/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/path","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/network","vs/nls","vs/nls!vs/server/entry","vs/base/common/errors","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/base/common/resources","fs","vs/base/common/buffer","vs/base/common/strings","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/common/arrays","vs/base/common/uuid","os","vs/base/common/process","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/product/common/product","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/parts/ipc/common/ipc","vs/base/common/extpath","path","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","@coder/logger","child_process","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/base/common/stream","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetryUtils","vs/base/node/zip","vs/base/common/uriIpc","util","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/node/diskFileSystemProvider","vs/platform/request/common/request","vs/server/node/nls","vs/base/common/functional","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/labels","vs/base/node/decoder","vs/base/parts/ipc/common/ipc.net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/instantiationService","vs/platform/localizations/node/localizations","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/files/common/fileService","vs/platform/configuration/common/configurationService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/server/node/logger","vs/server/node/util","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/editor/common/editorService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/languagePacks","vs/base/common/performance","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/proxy_agent","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/server/node/marketplace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/common/ipcFileSystemProvider","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/download/common/download","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/label/common/label","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","crypto","vs/platform/log/common/bufferLog","vs/platform/log/common/fileLog","vs/platform/log/node/loggerService","vs/platform/notification/common/notification","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/storage/common/storage","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/browser/errorTelemetry","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/telemetry","vs/platform/terminal/common/terminal","vs/platform/terminal/node/ptyHostService","vs/platform/workspace/common/workspace","vs/server/common/telemetry","vs/server/node/insights","vs/server/node/connection","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/services/extensions/node/extensionPoints","vs/server/node/channel","vs/workbench/services/remote/common/remoteAgentFileSystemChannel","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/server/node/marketplace","vs/base/parts/ipc/node/ipc.net","zlib","vs/code/node/cliProcessMain","vs/server/node/protocol","vs/server/node/server","string_decoder","proxy-agent","proxy-from-env","minimist","assert","https","http","yauzl","yazl","tar-stream","net","graceful-fs","vs/server/entry"],Z=function(q){for(var e=[],f=0,L=q.length;f<L;f++)e[f]=J[q[f]];return e};define(J[87],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function f(L,b){if(!L)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=f}),define(J[88],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function f(h){return(g,D,m)=>{let v=null,w=null;if(typeof m.value=="function"?(v="value",w=m.value):typeof m.get=="function"&&(v="get",w=m.get),!w)throw new Error("not supported");m[v]=h(w,D)}}e.createDecorator=f;let L=0;function b(){const h=`$memoize${L++}`;let g;const D=function(v,w,a){let c=null,p=null;if(typeof a.value=="function"?(c="value",p=a.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(c="get",p=a.get),!p)throw new Error("not supported");const O=`${h}:${w}`;a[c]=function(...T){return g=this,this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!0,enumerable:!1,writable:!0,value:p.apply(this,T)}),this[O]}};return D.clear=()=>{typeof g!="undefined"&&Object.getOwnPropertyNames(g).forEach(m=>{m.indexOf(h)===0&&delete g[m]})},D}e.createMemoizer=b;function _(h,g,D){return b()(h,g,D)}e.memoize=_;function A(h,g,D){return f((m,v)=>{const w=`$debounce$${v}`,a=`$debounce$result$${v}`;return function(...c){this[a]||(this[a]=D?D():void 0),clearTimeout(this[w]),g&&(this[a]=g(this[a],...c),c=[this[a]]),this[w]=setTimeout(()=>{m.apply(this,c),this[a]=D?D():void 0},h)}})}e.debounce=A;function C(h,g,D){return f((m,v)=>{const w=`$throttle$timer$${v}`,a=`$throttle$result$${v}`,c=`$throttle$lastRun$${v}`,p=`$throttle$pending$${v}`;return function(...O){if(this[a]||(this[a]=D?D():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),g&&(this[a]=g(this[a],...O)),!this[p]){const T=this[c]+h;T<=Date.now()?(this[c]=Date.now(),m.apply(this,[this[a]]),this[a]=D?D():void 0):(this[p]=!0,this[w]=setTimeout(()=>{this[p]=!1,this[c]=Date.now(),m.apply(this,[this[a]]),this[a]=D?D():void 0},T-Date.now()))}}})}e.throttle=C}),define(J[11],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class f{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=f,e.errorHandler=new f;function L(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=L;function b(s){h(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=b;function _(s){h(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=_;function A(s){if(s instanceof Error){let{name:t,message:i}=s;const n=s.stacktrace||s.stack;return{$isError:!0,name:t,message:i,stack:n}}return s}e.transformErrorForSerialization=A;const C="Canceled";function h(s){return s instanceof Error&&s.name===C&&s.message===C}e.isPromiseCanceledError=h;class g extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=g;function D(){const s=new Error(C);return s.name=s.message,s}e.canceled=D;function m(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=m;function v(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=v;function w(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function a(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function c(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=c;class p extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=p;class O extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=O;class T extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=T;function d(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function l(s,t=Object.create(null)){const i=new Error(s);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=l}),define(J[23],Z([0,1,11]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(B,x=0){return B[B.length-(1+x)]}e.tail=L;function b(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=b;function _(B,x,U=(S,I)=>S===I){if(B===x)return!0;if(!B||!x||B.length!==x.length)return!1;for(let S=0,I=B.length;S<I;S++)if(!U(B[S],x[S]))return!1;return!0}e.equals=_;function A(B,x,U){let S=0,I=B.length-1;for(;S<=I;){const N=(S+I)/2|0,M=U(B[N],x);if(M<0)S=N+1;else if(M>0)I=N-1;else return N}return-(S+1)}e.binarySearch=A;function C(B,x){let U=0,S=B.length;if(S===0)return 0;for(;U<S;){const I=Math.floor((U+S)/2);x(B[I])?S=I:U=I+1}return U}e.findFirstInSorted=C;function h(B,x,U){if(B=B|0,B>=x.length)throw new TypeError("invalid index");let S=x[Math.floor(x.length*Math.random())],I=[],N=[],M=[];for(let $ of x){const V=U($,S);V<0?I.push($):V>0?N.push($):M.push($)}return B<I.length?h(B,I,U):B<I.length+M.length?M[0]:h(B-(I.length+M.length),N,U)}e.quickSelect=h;function g(B,x){const U=[];let S;for(const I of B.slice(0).sort(x))!S||x(S[0],I)!==0?(S=[I],U.push(S)):S.push(I);return U}e.groupBy=g;function D(B,x,U){const S=[];function I($,V,G){if(!(V===0&&G.length===0)){const K=S[S.length-1];K&&K.start+K.deleteCount===$?(K.deleteCount+=V,K.toInsert.push(...G)):S.push({start:$,deleteCount:V,toInsert:G})}}let N=0,M=0;for(;;){if(N===B.length){I(N,0,x.slice(M));break}if(M===x.length){I(N,B.length-N,[]);break}const $=B[N],V=x[M],G=U($,V);G===0?(N+=1,M+=1):G<0?(I(N,1,[]),N+=1):G>0&&(I(N,0,[V]),M+=1)}return S}e.sortedDiff=D;function m(B,x,U){const S=D(B,x,U),I=[],N=[];for(const M of S)I.push(...B.slice(M.start,M.start+M.deleteCount)),N.push(...M.toInsert);return{removed:I,added:N}}e.delta=m;function v(B,x,U){if(U===0)return[];const S=B.slice(0,U).sort(x);return a(B,x,S,U,B.length),S}e.top=v;function w(B,x,U,S,I){return U===0?Promise.resolve([]):new Promise((N,M)=>{(async()=>{const $=B.length,V=B.slice(0,U).sort(x);for(let G=U,K=Math.min(U+S,$);G<$;G=K,K=Math.min(K+S,$)){if(G>U&&await new Promise(te=>setTimeout(te)),I&&I.isCancellationRequested)throw(0,f.canceled)();a(B,x,V,G,K)}return V})().then(N,M)})}e.topAsync=w;function a(B,x,U,S,I){for(const N=U.length;S<I;S++){const M=B[S];if(x(M,U[N-1])<0){U.pop();const $=C(U,V=>x(M,V)<0);U.splice($,0,M)}}}function c(B){return B.filter(x=>!!x)}e.coalesce=c;function p(B){let x=0;for(let U=0;U<B.length;U++)B[U]&&(B[x]=B[U],x+=1);B.length=x}e.coalesceInPlace=p;function O(B,x,U){B.splice(U,0,B.splice(x,1)[0])}e.move=O;function T(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=T;function d(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=d;function l(B,x){if(!x)return B.filter((S,I)=>B.indexOf(S)===I);const U=Object.create(null);return B.filter(S=>{const I=x(S);return U[I]?!1:(U[I]=!0,!0)})}e.distinct=l;function s(B){const x=new Set;return B.filter(U=>x.has(U)?!1:(x.add(U),!0))}e.distinctES6=s;function t(B){const x=Object.create(null);return U=>{const S=B(U);return x[S]?!1:(x[S]=!0,!0)}}e.uniqueFilter=t;function i(B,x){for(let U=B.length-1;U>=0;U--){const S=B[U];if(x(S))return U}return-1}e.lastIndex=i;function n(B,x){return B.length>0?B[0]:x}e.firstOrDefault=n;function r(B,x,U=(S,I)=>S===I){let S=0;for(let I=0,N=Math.min(B.length,x.length);I<N&&U(B[I],x[I]);I++)S++;return S}e.commonPrefixLength=r;function o(B){return[].concat(...B)}e.flatten=o;function y(B,x){let U=typeof x=="number"?B:0;typeof x=="number"?U=B:(U=0,x=B);const S=[];if(U<=x)for(let I=U;I<x;I++)S.push(I);else for(let I=U;I>x;I--)S.push(I);return S}e.range=y;function E(B,x,U){return B.reduce((S,I)=>(S[x(I)]=U?U(I):I,S),Object.create(null))}e.index=E;function F(B,x){return B.push(x),()=>R(B,x)}e.insert=F;function R(B,x){const U=B.indexOf(x);if(U>-1)return B.splice(U,1),x}e.remove=R;function u(B,x,U){const S=B.slice(0,x),I=B.slice(x);return S.concat(U,I)}e.arrayInsert=u;function P(B,x){let U;if(typeof x=="number"){let S=x;U=()=>{const I=Math.sin(S++)*179426549;return I-Math.floor(I)}}else U=Math.random;for(let S=B.length-1;S>0;S-=1){const I=Math.floor(U()*(S+1)),N=B[S];B[S]=B[I],B[I]=N}}e.shuffle=P;function k(B,x){const U=B.indexOf(x);U>-1&&(B.splice(U,1),B.unshift(x))}e.pushToStart=k;function W(B,x){const U=B.indexOf(x);U>-1&&(B.splice(U,1),B.push(x))}e.pushToEnd=W;function Q(B,x){return Array.isArray(B)?B.map(x):x(B)}e.mapArrayOrNot=Q;function z(B){return Array.isArray(B)?B:[B]}e.asArray=z;function H(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=H;function Y(B,x){for(const U of B){const S=x(U);if(S!==void 0)return S}}e.mapFind=Y}),define(J[59],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function f(L){const b=this;let _=!1,A;return function(){return _||(_=!0,A=L.apply(b,arguments)),A}}e.once=f}),define(J[60],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(L){function b(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}L.is=b;const _=Object.freeze([]);function A(){return _}L.empty=A;function*C(s){yield s}L.single=C;function h(s){return s||_}L.from=h;function g(s){return!s||s[Symbol.iterator]().next().done===!0}L.isEmpty=g;function D(s){return s[Symbol.iterator]().next().value}L.first=D;function m(s,t){for(const i of s)if(t(i))return!0;return!1}L.some=m;function v(s,t){for(const i of s)if(t(i))return i}L.find=v;function*w(s,t){for(const i of s)t(i)&&(yield i)}L.filter=w;function*a(s,t){for(const i of s)yield t(i)}L.map=a;function*c(...s){for(const t of s)for(const i of t)yield i}L.concat=c;function*p(s){for(const t of s)for(const i of t)yield i}L.concatNested=p;function O(s,t,i){let n=i;for(const r of s)n=t(n,r);return n}L.reduce=O;function*T(s,t,i=s.length){for(t<0&&(t+=s.length),i<0?i+=s.length:i>s.length&&(i=s.length);t<i;t++)yield s[t]}L.slice=T;function d(s,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,s];const n=s[Symbol.iterator]();for(let r=0;r<t;r++){const o=n.next();if(o.done)return[i,L.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return n}}]}L.consume=d;function l(s,t,i=(n,r)=>n===r){const n=s[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const o=n.next(),y=r.next();if(o.done!==y.done)return!1;if(o.done)return!0;if(!i(o.value,y.value))return!1}}L.equals=l})(f=e.Iterable||(e.Iterable={}))}),define(J[61],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var f;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(f=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(t){t.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function A(t,i=!1){let n=0,r=t.length,o="",y=0,E=16,F=0;function R(H){let Y=0,B=0;for(;Y<H;){const x=t.charCodeAt(n);if(x>=48&&x<=57)B=B*16+x-48;else if(x>=65&&x<=70)B=B*16+x-65+10;else if(x>=97&&x<=102)B=B*16+x-97+10;else break;n++,Y++}return Y<H&&(B=-1),B}function u(H){n=H,o="",y=0,E=16,F=0}function P(){const H=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&g(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&g(t.charCodeAt(n)))for(n++;n<t.length&&g(t.charCodeAt(n));)n++;else return F=3,t.substring(H,n);let Y=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&g(t.charCodeAt(n))){for(n++;n<t.length&&g(t.charCodeAt(n));)n++;Y=n}else F=3;return t.substring(H,Y)}function k(){let H="",Y=n;for(;;){if(n>=r){H+=t.substring(Y,n),F=2;break}const B=t.charCodeAt(n);if(B===34){H+=t.substring(Y,n),n++;break}if(B===92){if(H+=t.substring(Y,n),n++,n>=r){F=2;break}switch(t.charCodeAt(n++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:const U=R(4);U>=0?H+=String.fromCharCode(U):F=4;break;default:F=5}Y=n;continue}if(B>=0&&B<=31)if(h(B)){H+=t.substring(Y,n),F=2;break}else F=6;n++}return H}function W(){if(o="",F=0,y=n,n>=r)return y=r,E=17;let H=t.charCodeAt(n);if(C(H)){do n++,o+=String.fromCharCode(H),H=t.charCodeAt(n);while(C(H));return E=15}if(h(H))return n++,o+=String.fromCharCode(H),H===13&&t.charCodeAt(n)===10&&(n++,o+=`
`),E=14;switch(H){case 123:return n++,E=1;case 125:return n++,E=2;case 91:return n++,E=3;case 93:return n++,E=4;case 58:return n++,E=6;case 44:return n++,E=5;case 34:return n++,o=k(),E=10;case 47:const Y=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<r&&!h(t.charCodeAt(n));)n++;return o=t.substring(Y,n),E=12}if(t.charCodeAt(n+1)===42){n+=2;const B=r-1;let x=!1;for(;n<B;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,F=1),o=t.substring(Y,n),E=13}return o+=String.fromCharCode(H),n++,E=16;case 45:if(o+=String.fromCharCode(H),n++,n===r||!g(t.charCodeAt(n)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=P(),E=11;default:for(;n<r&&Q(H);)n++,H=t.charCodeAt(n);if(y!==n){switch(o=t.substring(y,n),o){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return o+=String.fromCharCode(H),n++,E=16}}function Q(H){if(C(H)||h(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let H;do H=W();while(H>=12&&H<=15);return H}return{setPosition:u,getPosition:()=>n,scan:i?z:W,getToken:()=>E,getTokenValue:()=>o,getTokenOffset:()=>y,getTokenLength:()=>n-y,getTokenError:()=>F}}e.createScanner=A;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var D;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(D||(D={}));function m(t,i){const n=[],r=new Object;let o;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function F(R,u,P,k){y.value=R,y.offset=u,y.length=P,y.type=k,y.colonOffset=void 0,o=y}try{d(t,{onObjectBegin:(R,u)=>{if(i<=R)throw r;o=void 0,E=i>R,n.push("")},onObjectProperty:(R,u,P)=>{if(i<u||(F(R,u,P,"property"),n[n.length-1]=R,i<=u+P))throw r},onObjectEnd:(R,u)=>{if(i<=R)throw r;o=void 0,n.pop()},onArrayBegin:(R,u)=>{if(i<=R)throw r;o=void 0,n.push(0)},onArrayEnd:(R,u)=>{if(i<=R)throw r;o=void 0,n.pop()},onLiteralValue:(R,u,P)=>{if(i<u||(F(R,u,P,s(R)),i<=u+P))throw r},onSeparator:(R,u,P)=>{if(i<=u)throw r;if(R===":"&&o&&o.type==="property")o.colonOffset=u,E=!1,o=void 0;else if(R===","){const k=n[n.length-1];typeof k=="number"?n[n.length-1]=k+1:(E=!0,n[n.length-1]=""),o=void 0}}})}catch(R){if(R!==r)throw R}return{path:n,previousNode:o,isAtPropertyKey:E,matches:R=>{let u=0;for(let P=0;u<R.length&&P<n.length;P++)if(R[u]===n[P]||R[u]==="*")u++;else if(R[u]!=="**")return!1;return u===R.length}}}e.getLocation=m;function v(t,i=[],n=_.DEFAULT){let r=null,o=[];const y=[];function E(R){Array.isArray(o)?o.push(R):r!==null&&(o[r]=R)}return d(t,{onObjectBegin:()=>{const R={};E(R),y.push(o),o=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{o=y.pop()},onArrayBegin:()=>{const R=[];E(R),y.push(o),o=R,r=null},onArrayEnd:()=>{o=y.pop()},onLiteralValue:E,onError:(R,u,P)=>{i.push({error:R,offset:u,length:P})}},n),o[0]}e.parse=v;function w(t,i=[],n=_.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function y(R){return r.children.push(R),R}d(t,{onObjectBegin:R=>{r=y({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,u,P)=>{r=y({type:"property",offset:u,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:u,length:P,parent:r})},onObjectEnd:(R,u)=>{r.length=R+u-r.offset,r=r.parent,o(R+u)},onArrayBegin:(R,u)=>{r=y({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,u)=>{r.length=R+u-r.offset,r=r.parent,o(R+u)},onLiteralValue:(R,u,P)=>{y({type:s(R),offset:u,length:P,parent:r,value:R}),o(u+P)},onSeparator:(R,u,P)=>{r.type==="property"&&(R===":"?r.colonOffset=u:R===","&&o(u))},onError:(R,u,P)=>{i.push({error:R,offset:u,length:P})}},n);const F=r.children[0];return F&&delete F.parent,F}e.parseTree=w;function a(t,i){if(!!t){let n=t;for(let r of i)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const y of n.children)if(Array.isArray(y.children)&&y.children[0].value===r){n=y.children[1],o=!0;break}if(!o)return}else{const o=r;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}}e.findNodeAtLocation=a;function c(t){if(!t.parent||!t.parent.children)return[];const i=c(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;i.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&i.push(n)}return i}e.getNodePath=c;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const i=Object.create(null);for(let n of t.children){const r=n.children[1];r&&(i[n.children[0].value]=p(r))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function O(t,i,n=!1){return i>=t.offset&&i<t.offset+t.length||n&&i===t.offset+t.length}e.contains=O;function T(t,i,n=!1){if(O(t,i,n)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=i;o++){const y=T(r[o],i,n);if(y)return y}return t}}e.findNodeAtOffset=T;function d(t,i,n=_.DEFAULT){const r=A(t,!1);function o(V){return V?()=>V(r.getTokenOffset(),r.getTokenLength()):()=>!0}function y(V){return V?G=>V(G,r.getTokenOffset(),r.getTokenLength()):()=>!0}const E=o(i.onObjectBegin),F=y(i.onObjectProperty),R=o(i.onObjectEnd),u=o(i.onArrayBegin),P=o(i.onArrayEnd),k=y(i.onLiteralValue),W=y(i.onSeparator),Q=o(i.onComment),z=y(i.onError),H=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function B(){for(;;){const V=r.scan();switch(r.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:H||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(V){case 12:case 13:H?x(10):Q();break;case 16:x(1);break;case 15:case 14:break;default:return V}}}function x(V,G=[],K=[]){if(z(V),G.length+K.length>0){let te=r.getToken();for(;te!==17;){if(G.indexOf(te)!==-1){B();break}else if(K.indexOf(te)!==-1)break;te=B()}}}function U(V){const G=r.getTokenValue();return V?k(G):F(G),B(),!0}function S(){switch(r.getToken()){case 11:let V=0;try{V=JSON.parse(r.getTokenValue()),typeof V!="number"&&(x(2),V=0)}catch(G){x(2)}k(V);break;case 7:k(null);break;case 8:k(!0);break;case 9:k(!1);break;default:return!1}return B(),!0}function I(){return r.getToken()!==10?(x(3,[],[2,5]),!1):(U(!1),r.getToken()===6?(W(":"),B(),$()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function N(){E(),B();let V=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(V||x(4,[],[]),W(","),B(),r.getToken()===2&&Y)break}else V&&x(6,[],[]);I()||x(4,[],[2,5]),V=!0}return R(),r.getToken()!==2?x(7,[2],[]):B(),!0}function M(){u(),B();let V=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(V||x(4,[],[]),W(","),B(),r.getToken()===4&&Y)break}else V&&x(6,[],[]);$()||x(4,[],[4,5]),V=!0}return P(),r.getToken()!==4?x(8,[4],[]):B(),!0}function $(){switch(r.getToken()){case 3:return M();case 1:return N();case 10:return U(!0);default:return S()}}return B(),r.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):$()?(r.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.visit=d;function l(t,i){let n=A(t),r=[],o,y=0,E;do switch(E=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:y!==E&&r.push(t.substring(y,E)),i!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,i)),y=n.getPosition();break}while(o!==17);return r.join("")}e.stripComments=l;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(J[2],Z([0,1,59,60]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const b=!1;let _=null;function A(d){_=d}if(e.setDisposableTracker=A,b){const d="__is_disposable_tracked__";_=new class{trackDisposable(l){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[d]||console.log(s)},3e3)}markTracked(l){if(l&&l!==c.None)try{l[d]=!0}catch(s){}}}}function C(d){!_||_.markTracked(d)}function h(d){return _&&_.trackDisposable(d),d}e.trackDisposable=h;class g extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=g;function D(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=D;function m(d){if(L.Iterable.is(d)){let l=[];for(const s of d)if(s){C(s);try{s.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new g(l);return Array.isArray(d)?[]:d}else if(d)return C(d),d.dispose(),d}e.dispose=m;function v(...d){return d.forEach(C),w(()=>m(d))}e.combinedDisposable=v;function w(d){const l=h({dispose:()=>{C(l),d()}});return l}e.toDisposable=w;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{m(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return C(l),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this._store=new a,h(this)}dispose(){C(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,h(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var s;this._isDisposed||l===this._value||((s=this._value)===null||s===void 0||s.dispose(),l&&C(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,C(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=p;class O{constructor(){this.references=new Map}acquire(l,...s){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...s)},this.references.set(l,t));const{object:i}=t,n=(0,f.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:i,dispose:n}}}e.ReferenceCollection=O;class T{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=T}),define(J[62],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class f{constructor(_){this.element=_,this.next=f.Undefined,this.prev=f.Undefined}}f.Undefined=new f(void 0);class L{constructor(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===f.Undefined}clear(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,A){const C=new f(_);if(this._first===f.Undefined)this._first=C,this._last=C;else if(A){const g=this._last;this._last=C,C.prev=g,g.next=C}else{const g=this._first;this._first=C,C.next=g,g.prev=C}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(C))}}shift(){if(this._first!==f.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==f.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==f.Undefined&&_.next!==f.Undefined){const A=_.prev;A.next=_.next,_.next.prev=A}else _.prev===f.Undefined&&_.next===f.Undefined?(this._first=f.Undefined,this._last=f.Undefined):_.next===f.Undefined?(this._last=this._last.prev,this._last.next=f.Undefined):_.prev===f.Undefined&&(this._first=this._first.next,this._first.prev=f.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==f.Undefined;)yield _.element,_=_.next}}e.LinkedList=L});"use strict";(function(){function q(b){const _=[];typeof b=="number"&&_.push("code/timeOrigin",b);function A(h){_.push(h,Date.now())}function C(){const h=[];for(let g=0;g<_.length;g+=2)h.push({name:_[g],startTime:_[g+1]});return h}return{mark:A,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const A of performance.getEntriesByType("mark"))_.push({name:A.name,startTime:Math.round(b+A.startTime)});return _}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function f(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return f(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=f(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=f(L))})(),define(J[3],Z([0,1]),function(q,e){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const L="en";let b=!1,_=!1,A=!1,C=!1,h=!1,g=!1,D=!1,m,v=L,w,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode!="undefined"?c=e.globals.vscode.process:typeof process!="undefined"&&(c=process);const p=typeof((f=c==null?void 0:c.versions)===null||f===void 0?void 0:f.electron)=="string"&&c.type==="renderer";if(e.isElectronSandboxed=p&&(c==null?void 0:c.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=c==null?void 0:c.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!p){a=navigator.userAgent,b=a.indexOf("Windows")>=0,_=a.indexOf("Macintosh")>=0,D=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=a.indexOf("Linux")>=0,g=!0,m=navigator.language,v=m;const r=typeof document!="undefined"&&document.getElementById("vscode-remote-nls-configuration"),o=r&&r.getAttribute("data-settings");if(o)try{const y=JSON.parse(o);m=y.locale,w=y._translationsConfigFile,v=y.availableLanguages["*"]||L}catch(y){}}else if(typeof c=="object"){b=c.platform==="win32",_=c.platform==="darwin",A=c.platform==="linux",C=A&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,m=L,v=L;const r=c.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),y=o.availableLanguages["*"];m=o.locale,v=y||L,w=o._translationsConfigFile}catch(o){}h=!0}else console.error("Unable to resolve platform.");var O;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(O=e.Platform||(e.Platform={}));function T(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=T;let d=0;_?d=1:b?d=3:A&&(d=2),e.isWindows=b,e.isMacintosh=_,e.isLinux=A,e.isLinuxSnap=C,e.isNative=h,e.isWeb=g,e.isIOS=D,e.platform=d,e.userAgent=a,e.language=v;var l;(function(r){function o(){return e.language}r.value=o;function y(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=y;function E(){return e.language==="en"}r.isDefault=E})(l=e.Language||(e.Language={})),e.locale=m,e.translationsConfigFile=w,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let y=[];e.globals.addEventListener("message",F=>{if(F.data&&F.data.vscodeSetImmediateId)for(let R=0,u=y.length;R<u;R++){const P=y[R];if(P.id===F.data.vscodeSetImmediateId){y.splice(R,1),P.callback();return}}});let E=0;return F=>{const R=++E;y.push({id:R,callback:F}),e.globals.postMessage({vscodeSetImmediateId:R},"*")}}if(typeof(c==null?void 0:c.nextTick)=="function")return c.nextTick.bind(c);const o=Promise.resolve();return y=>o.then(y)}();var s;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=_||D?2:b?1:3;let t=!0,i=!1;function n(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=n}),define(J[26],Z([0,1,3]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof f.globals.vscode!="undefined"){const b=f.globals.vscode.process;L={get platform(){return b.platform},get env(){return b.env},cwd(){return b.cwd()},nextTick(_){return(0,f.setImmediate)(_)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(b){return process.nextTick(b)}}:L={get platform(){return f.isWindows?"win32":f.isMacintosh?"darwin":"linux"},nextTick(b){return(0,f.setImmediate)(b)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(J[4],Z([0,1,26]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,b=97,_=90,A=122,C=46,h=47,g=92,D=58,m=63;class v extends Error{constructor(l,s,t){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const n=l.indexOf(".")!==-1?"property":"argument";let r=`The "${l}" ${n} ${i} of type ${s}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function w(d,l){if(typeof d!="string")throw new v(l,"string",d)}function a(d){return d===h||d===g}function c(d){return d===h}function p(d){return d>=L&&d<=_||d>=b&&d<=A}function O(d,l,s,t){let i="",n=0,r=-1,o=0,y=0;for(let E=0;E<=d.length;++E){if(E<d.length)y=d.charCodeAt(E);else{if(t(y))break;y=h}if(t(y)){if(!(r===E-1||o===1))if(o===2){if(i.length<2||n!==2||i.charCodeAt(i.length-1)!==C||i.charCodeAt(i.length-2)!==C){if(i.length>2){const F=i.lastIndexOf(s);F===-1?(i="",n=0):(i=i.slice(0,F),n=i.length-1-i.lastIndexOf(s)),r=E,o=0;continue}else if(i.length!==0){i="",n=0,r=E,o=0;continue}}l&&(i+=i.length>0?`${s}..`:"..",n=2)}else i.length>0?i+=`${s}${d.slice(r+1,E)}`:i=d.slice(r+1,E),n=E-r-1;r=E,o=0}else y===C&&o!==-1?++o:o=-1}return i}function T(d,l){if(l===null||typeof l!="object")throw new v("pathObject","Object",l);const s=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return s?s===l.root?`${s}${t}`:`${s}${d}${t}`:t}e.win32={resolve(...d){let l="",s="",t=!1;for(let i=d.length-1;i>=-1;i--){let n;if(i>=0){if(n=d[i],w(n,"path"),n.length===0)continue}else l.length===0?n=f.cwd():(n=f.env[`=${l}`]||f.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==l.toLowerCase()&&n.charCodeAt(2)===g)&&(n=`${l}\\`));const r=n.length;let o=0,y="",E=!1;const F=n.charCodeAt(0);if(r===1)a(F)&&(o=1,E=!0);else if(a(F))if(E=!0,a(n.charCodeAt(1))){let R=2,u=R;for(;R<r&&!a(n.charCodeAt(R));)R++;if(R<r&&R!==u){const P=n.slice(u,R);for(u=R;R<r&&a(n.charCodeAt(R));)R++;if(R<r&&R!==u){for(u=R;R<r&&!a(n.charCodeAt(R));)R++;(R===r||R!==u)&&(y=`\\\\${P}\\${n.slice(u,R)}`,o=R)}}}else o=1;else p(F)&&n.charCodeAt(1)===D&&(y=n.slice(0,2),o=2,r>2&&a(n.charCodeAt(2))&&(E=!0,o=3));if(y.length>0)if(l.length>0){if(y.toLowerCase()!==l.toLowerCase())continue}else l=y;if(t){if(l.length>0)break}else if(s=`${n.slice(o)}\\${s}`,t=E,E&&l.length>0)break}return s=O(s,!t,"\\",a),t?`${l}\\${s}`:`${l}${s}`||"."},normalize(d){w(d,"path");const l=d.length;if(l===0)return".";let s=0,t,i=!1;const n=d.charCodeAt(0);if(l===1)return c(n)?"\\":d;if(a(n))if(i=!0,a(d.charCodeAt(1))){let o=2,y=o;for(;o<l&&!a(d.charCodeAt(o));)o++;if(o<l&&o!==y){const E=d.slice(y,o);for(y=o;o<l&&a(d.charCodeAt(o));)o++;if(o<l&&o!==y){for(y=o;o<l&&!a(d.charCodeAt(o));)o++;if(o===l)return`\\\\${E}\\${d.slice(y)}\\`;o!==y&&(t=`\\\\${E}\\${d.slice(y,o)}`,s=o)}}}else s=1;else p(n)&&d.charCodeAt(1)===D&&(t=d.slice(0,2),s=2,l>2&&a(d.charCodeAt(2))&&(i=!0,s=3));let r=s<l?O(d.slice(s),!i,"\\",a):"";return r.length===0&&!i&&(r="."),r.length>0&&a(d.charCodeAt(l-1))&&(r+="\\"),t===void 0?i?`\\${r}`:r:i?`${t}\\${r}`:`${t}${r}`},isAbsolute(d){w(d,"path");const l=d.length;if(l===0)return!1;const s=d.charCodeAt(0);return a(s)||l>2&&p(s)&&d.charCodeAt(1)===D&&a(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let l,s;for(let n=0;n<d.length;++n){const r=d[n];w(r,"path"),r.length>0&&(l===void 0?l=s=r:l+=`\\${r}`)}if(l===void 0)return".";let t=!0,i=0;if(typeof s=="string"&&a(s.charCodeAt(0))){++i;const n=s.length;n>1&&a(s.charCodeAt(1))&&(++i,n>2&&(a(s.charCodeAt(2))?++i:t=!1))}if(t){for(;i<l.length&&a(l.charCodeAt(i));)i++;i>=2&&(l=`\\${l.slice(i)}`)}return e.win32.normalize(l)},relative(d,l){if(w(d,"from"),w(l,"to"),d===l)return"";const s=e.win32.resolve(d),t=e.win32.resolve(l);if(s===t||(d=s.toLowerCase(),l=t.toLowerCase(),d===l))return"";let i=0;for(;i<d.length&&d.charCodeAt(i)===g;)i++;let n=d.length;for(;n-1>i&&d.charCodeAt(n-1)===g;)n--;const r=n-i;let o=0;for(;o<l.length&&l.charCodeAt(o)===g;)o++;let y=l.length;for(;y-1>o&&l.charCodeAt(y-1)===g;)y--;const E=y-o,F=r<E?r:E;let R=-1,u=0;for(;u<F;u++){const k=d.charCodeAt(i+u);if(k!==l.charCodeAt(o+u))break;k===g&&(R=u)}if(u!==F){if(R===-1)return t}else{if(E>F){if(l.charCodeAt(o+u)===g)return t.slice(o+u+1);if(u===2)return t.slice(o+u)}r>F&&(d.charCodeAt(i+u)===g?R=u:u===2&&(R=3)),R===-1&&(R=0)}let P="";for(u=i+R+1;u<=n;++u)(u===n||d.charCodeAt(u)===g)&&(P+=P.length===0?"..":"\\..");return o+=R,P.length>0?`${P}${t.slice(o,y)}`:(t.charCodeAt(o)===g&&++o,t.slice(o,y))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const l=e.win32.resolve(d);if(l.length<=2)return d;if(l.charCodeAt(0)===g){if(l.charCodeAt(1)===g){const s=l.charCodeAt(2);if(s!==m&&s!==C)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(p(l.charCodeAt(0))&&l.charCodeAt(1)===D&&l.charCodeAt(2)===g)return`\\\\?\\${l}`;return d},dirname(d){w(d,"path");const l=d.length;if(l===0)return".";let s=-1,t=0;const i=d.charCodeAt(0);if(l===1)return a(i)?d:".";if(a(i)){if(s=t=1,a(d.charCodeAt(1))){let o=2,y=o;for(;o<l&&!a(d.charCodeAt(o));)o++;if(o<l&&o!==y){for(y=o;o<l&&a(d.charCodeAt(o));)o++;if(o<l&&o!==y){for(y=o;o<l&&!a(d.charCodeAt(o));)o++;if(o===l)return d;o!==y&&(s=t=o+1)}}}}else p(i)&&d.charCodeAt(1)===D&&(s=l>2&&a(d.charCodeAt(2))?3:2,t=s);let n=-1,r=!0;for(let o=l-1;o>=t;--o)if(a(d.charCodeAt(o))){if(!r){n=o;break}}else r=!1;if(n===-1){if(s===-1)return".";n=s}return d.slice(0,n)},basename(d,l){l!==void 0&&w(l,"ext"),w(d,"path");let s=0,t=-1,i=!0,n;if(d.length>=2&&p(d.charCodeAt(0))&&d.charCodeAt(1)===D&&(s=2),l!==void 0&&l.length>0&&l.length<=d.length){if(l===d)return"";let r=l.length-1,o=-1;for(n=d.length-1;n>=s;--n){const y=d.charCodeAt(n);if(a(y)){if(!i){s=n+1;break}}else o===-1&&(i=!1,o=n+1),r>=0&&(y===l.charCodeAt(r)?--r==-1&&(t=n):(r=-1,t=o))}return s===t?t=o:t===-1&&(t=d.length),d.slice(s,t)}for(n=d.length-1;n>=s;--n)if(a(d.charCodeAt(n))){if(!i){s=n+1;break}}else t===-1&&(i=!1,t=n+1);return t===-1?"":d.slice(s,t)},extname(d){w(d,"path");let l=0,s=-1,t=0,i=-1,n=!0,r=0;d.length>=2&&d.charCodeAt(1)===D&&p(d.charCodeAt(0))&&(l=t=2);for(let o=d.length-1;o>=l;--o){const y=d.charCodeAt(o);if(a(y)){if(!n){t=o+1;break}continue}i===-1&&(n=!1,i=o+1),y===C?s===-1?s=o:r!==1&&(r=1):s!==-1&&(r=-1)}return s===-1||i===-1||r===0||r===1&&s===i-1&&s===t+1?"":d.slice(s,i)},format:T.bind(null,"\\"),parse(d){w(d,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return l;const s=d.length;let t=0,i=d.charCodeAt(0);if(s===1)return a(i)?(l.root=l.dir=d,l):(l.base=l.name=d,l);if(a(i)){if(t=1,a(d.charCodeAt(1))){let R=2,u=R;for(;R<s&&!a(d.charCodeAt(R));)R++;if(R<s&&R!==u){for(u=R;R<s&&a(d.charCodeAt(R));)R++;if(R<s&&R!==u){for(u=R;R<s&&!a(d.charCodeAt(R));)R++;R===s?t=R:R!==u&&(t=R+1)}}}}else if(p(i)&&d.charCodeAt(1)===D){if(s<=2)return l.root=l.dir=d,l;if(t=2,a(d.charCodeAt(2))){if(s===3)return l.root=l.dir=d,l;t=3}}t>0&&(l.root=d.slice(0,t));let n=-1,r=t,o=-1,y=!0,E=d.length-1,F=0;for(;E>=t;--E){if(i=d.charCodeAt(E),a(i)){if(!y){r=E+1;break}continue}o===-1&&(y=!1,o=E+1),i===C?n===-1?n=E:F!==1&&(F=1):n!==-1&&(F=-1)}return o!==-1&&(n===-1||F===0||F===1&&n===o-1&&n===r+1?l.base=l.name=d.slice(r,o):(l.name=d.slice(r,n),l.base=d.slice(r,o),l.ext=d.slice(n,o))),r>0&&r!==t?l.dir=d.slice(0,r-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let l="",s=!1;for(let t=d.length-1;t>=-1&&!s;t--){const i=t>=0?d[t]:f.cwd();w(i,"path"),i.length!==0&&(l=`${i}/${l}`,s=i.charCodeAt(0)===h)}return l=O(l,!s,"/",c),s?`/${l}`:l.length>0?l:"."},normalize(d){if(w(d,"path"),d.length===0)return".";const l=d.charCodeAt(0)===h,s=d.charCodeAt(d.length-1)===h;return d=O(d,!l,"/",c),d.length===0?l?"/":s?"./":".":(s&&(d+="/"),l?`/${d}`:d)},isAbsolute(d){return w(d,"path"),d.length>0&&d.charCodeAt(0)===h},join(...d){if(d.length===0)return".";let l;for(let s=0;s<d.length;++s){const t=d[s];w(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(d,l){if(w(d,"from"),w(l,"to"),d===l||(d=e.posix.resolve(d),l=e.posix.resolve(l),d===l))return"";const s=1,t=d.length,i=t-s,n=1,r=l.length-n,o=i<r?i:r;let y=-1,E=0;for(;E<o;E++){const R=d.charCodeAt(s+E);if(R!==l.charCodeAt(n+E))break;R===h&&(y=E)}if(E===o)if(r>o){if(l.charCodeAt(n+E)===h)return l.slice(n+E+1);if(E===0)return l.slice(n+E)}else i>o&&(d.charCodeAt(s+E)===h?y=E:E===0&&(y=0));let F="";for(E=s+y+1;E<=t;++E)(E===t||d.charCodeAt(E)===h)&&(F+=F.length===0?"..":"/..");return`${F}${l.slice(n+y)}`},toNamespacedPath(d){return d},dirname(d){if(w(d,"path"),d.length===0)return".";const l=d.charCodeAt(0)===h;let s=-1,t=!0;for(let i=d.length-1;i>=1;--i)if(d.charCodeAt(i)===h){if(!t){s=i;break}}else t=!1;return s===-1?l?"/":".":l&&s===1?"//":d.slice(0,s)},basename(d,l){l!==void 0&&w(l,"ext"),w(d,"path");let s=0,t=-1,i=!0,n;if(l!==void 0&&l.length>0&&l.length<=d.length){if(l===d)return"";let r=l.length-1,o=-1;for(n=d.length-1;n>=0;--n){const y=d.charCodeAt(n);if(y===h){if(!i){s=n+1;break}}else o===-1&&(i=!1,o=n+1),r>=0&&(y===l.charCodeAt(r)?--r==-1&&(t=n):(r=-1,t=o))}return s===t?t=o:t===-1&&(t=d.length),d.slice(s,t)}for(n=d.length-1;n>=0;--n)if(d.charCodeAt(n)===h){if(!i){s=n+1;break}}else t===-1&&(i=!1,t=n+1);return t===-1?"":d.slice(s,t)},extname(d){w(d,"path");let l=-1,s=0,t=-1,i=!0,n=0;for(let r=d.length-1;r>=0;--r){const o=d.charCodeAt(r);if(o===h){if(!i){s=r+1;break}continue}t===-1&&(i=!1,t=r+1),o===C?l===-1?l=r:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||t===-1||n===0||n===1&&l===t-1&&l===s+1?"":d.slice(l,t)},format:T.bind(null,"/"),parse(d){w(d,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return l;const s=d.charCodeAt(0)===h;let t;s?(l.root="/",t=1):t=0;let i=-1,n=0,r=-1,o=!0,y=d.length-1,E=0;for(;y>=t;--y){const F=d.charCodeAt(y);if(F===h){if(!o){n=y+1;break}continue}r===-1&&(o=!1,r=y+1),F===C?i===-1?i=y:E!==1&&(E=1):i!==-1&&(E=-1)}if(r!==-1){const F=n===0&&s?1:n;i===-1||E===0||E===1&&i===r-1&&i===n+1?l.base=l.name=d.slice(F,r):(l.name=d.slice(F,i),l.base=d.slice(F,r),l.ext=d.slice(i,r))}return n>0?l.dir=d.slice(0,n-1):s&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=f.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f.platform==="win32"?e.win32.join:e.posix.join,e.resolve=f.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=f.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=f.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=f.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=f.platform==="win32"?e.win32.extname:e.posix.extname,e.format=f.platform==="win32"?e.win32.format:e.posix.format,e.parse=f.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=f.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=f.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[89],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var f;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(f=e.Source||(e.Source={}));var L;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function b(_,...A){const C=A.reduce((D,m)=>(D[m]=!0,D),{}),h=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/];Object.keys(_).filter(D=>!C[D]).forEach(D=>{for(let m=0;m<h.length;m++)if(D.search(h[m])!==-1){delete _[D];break}})}e.sanitizeProcessEnvironment=b}),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var f=e();for(var L in f)(typeof exports=="object"?exports:q)[L]=f[L]}}(typeof self!="undefined"?self:this,function(){return function(q){var e={};function f(L){if(e[L])return e[L].exports;var b=e[L]={i:L,l:!1,exports:{}};return q[L].call(b.exports,b,b.exports,f),b.l=!0,b.exports}return f.m=q,f.c=e,f.d=function(L,b,_){f.o(L,b)||Object.defineProperty(L,b,{enumerable:!0,get:_})},f.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},f.t=function(L,b){if(1&b&&(L=f(L)),8&b||4&b&&typeof L=="object"&&L&&L.__esModule)return L;var _=Object.create(null);if(f.r(_),Object.defineProperty(_,"default",{enumerable:!0,value:L}),2&b&&typeof L!="string")for(var A in L)f.d(_,A,function(C){return L[C]}.bind(null,A));return _},f.n=function(L){var b=L&&L.__esModule?function(){return L.default}:function(){return L};return f.d(b,"a",b),b},f.o=function(L,b){return Object.prototype.hasOwnProperty.call(L,b)},f.p="",f(f.s=0)}([function(q,e,f){(function(L){var b;e=q.exports=K,b=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var _=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],h=e.src=[],g=0,D=g++;h[D]="0|[1-9]\\d*";var m=g++;h[m]="[0-9]+";var v=g++;h[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=g++;h[w]="("+h[D]+")\\.("+h[D]+")\\.("+h[D]+")";var a=g++;h[a]="("+h[m]+")\\.("+h[m]+")\\.("+h[m]+")";var c=g++;h[c]="(?:"+h[D]+"|"+h[v]+")";var p=g++;h[p]="(?:"+h[m]+"|"+h[v]+")";var O=g++;h[O]="(?:-("+h[c]+"(?:\\."+h[c]+")*))";var T=g++;h[T]="(?:-?("+h[p]+"(?:\\."+h[p]+")*))";var d=g++;h[d]="[0-9A-Za-z-]+";var l=g++;h[l]="(?:\\+("+h[d]+"(?:\\."+h[d]+")*))";var s=g++,t="v?"+h[w]+h[O]+"?"+h[l]+"?";h[s]="^"+t+"$";var i="[v=\\s]*"+h[a]+h[T]+"?"+h[l]+"?",n=g++;h[n]="^"+i+"$";var r=g++;h[r]="((?:<|>)?=?)";var o=g++;h[o]=h[m]+"|x|X|\\*";var y=g++;h[y]=h[D]+"|x|X|\\*";var E=g++;h[E]="[v=\\s]*("+h[y]+")(?:\\.("+h[y]+")(?:\\.("+h[y]+")(?:"+h[O]+")?"+h[l]+"?)?)?";var F=g++;h[F]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[T]+")?"+h[l]+"?)?)?";var R=g++;h[R]="^"+h[r]+"\\s*"+h[E]+"$";var u=g++;h[u]="^"+h[r]+"\\s*"+h[F]+"$";var P=g++;h[P]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var k=g++;h[k]="(?:~>?)";var W=g++;h[W]="(\\s*)"+h[k]+"\\s+",C[W]=new RegExp(h[W],"g");var Q=g++;h[Q]="^"+h[k]+h[E]+"$";var z=g++;h[z]="^"+h[k]+h[F]+"$";var H=g++;h[H]="(?:\\^)";var Y=g++;h[Y]="(\\s*)"+h[H]+"\\s+",C[Y]=new RegExp(h[Y],"g");var B=g++;h[B]="^"+h[H]+h[E]+"$";var x=g++;h[x]="^"+h[H]+h[F]+"$";var U=g++;h[U]="^"+h[r]+"\\s*("+i+")$|^$";var S=g++;h[S]="^"+h[r]+"\\s*("+t+")$|^$";var I=g++;h[I]="(\\s*)"+h[r]+"\\s*("+i+"|"+h[E]+")",C[I]=new RegExp(h[I],"g");var N=g++;h[N]="^\\s*("+h[E]+")\\s+-\\s+("+h[E]+")\\s*$";var M=g++;h[M]="^\\s*("+h[F]+")\\s+-\\s+("+h[F]+")\\s*$";var $=g++;h[$]="(<|>)?=?\\s*\\*";for(var V=0;V<35;V++)b(V,h[V]),C[V]||(C[V]=new RegExp(h[V]));function G(X,ie){if(X instanceof K)return X;if(typeof X!="string"||X.length>_||!(ie?C[n]:C[s]).test(X))return null;try{return new K(X,ie)}catch(ne){return null}}function K(X,ie){if(X instanceof K){if(X.loose===ie)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>_)throw new TypeError("version is longer than "+_+" characters");if(!(this instanceof K))return new K(X,ie);b("SemVer",X,ie),this.loose=ie;var ne=X.trim().match(ie?C[n]:C[s]);if(!ne)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+ne[1],this.minor=+ne[2],this.patch=+ne[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ne[4]?this.prerelease=ne[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var j=+de;if(j>=0&&j<A)return j}return de}):this.prerelease=[],this.build=ne[5]?ne[5].split("."):[],this.format()}e.parse=G,e.valid=function(X,ie){var ne=G(X,ie);return ne?ne.version:null},e.clean=function(X,ie){var ne=G(X.trim().replace(/^[=v]+/,""),ie);return ne?ne.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(X){return b("SemVer.compare",this.version,this.loose,X),X instanceof K||(X=new K(X,this.loose)),this.compareMain(X)||this.comparePre(X)},K.prototype.compareMain=function(X){return X instanceof K||(X=new K(X,this.loose)),se(this.major,X.major)||se(this.minor,X.minor)||se(this.patch,X.patch)},K.prototype.comparePre=function(X){if(X instanceof K||(X=new K(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var ie=0;do{var ne=this.prerelease[ie],de=X.prerelease[ie];if(b("prerelease compare",ie,ne,de),ne===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(ne===void 0)return-1;if(ne!==de)return se(ne,de)}while(++ie)},K.prototype.inc=function(X,ie){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ie);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ie);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ie),this.inc("pre",ie);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ie),this.inc("pre",ie);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ne=this.prerelease.length;--ne>=0;)typeof this.prerelease[ne]=="number"&&(this.prerelease[ne]++,ne=-2);ne===-1&&this.prerelease.push(0)}ie&&(this.prerelease[0]===ie?isNaN(this.prerelease[1])&&(this.prerelease=[ie,0]):this.prerelease=[ie,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,ie,ne,de){typeof ne=="string"&&(de=ne,ne=void 0);try{return new K(X,ne).inc(ie,de).version}catch(j){return null}},e.diff=function(X,ie){if(Se(X,ie))return null;var ne=G(X),de=G(ie);if(ne.prerelease.length||de.prerelease.length){for(var j in ne)if((j==="major"||j==="minor"||j==="patch")&&ne[j]!==de[j])return"pre"+j;return"prerelease"}for(var j in ne)if((j==="major"||j==="minor"||j==="patch")&&ne[j]!==de[j])return j},e.compareIdentifiers=se;var te=/^[0-9]+$/;function se(X,ie){var ne=te.test(X),de=te.test(ie);return ne&&de&&(X=+X,ie=+ie),ne&&!de?-1:de&&!ne?1:X<ie?-1:X>ie?1:0}function oe(X,ie,ne){return new K(X,ne).compare(new K(ie,ne))}function ce(X,ie,ne){return oe(X,ie,ne)>0}function ue(X,ie,ne){return oe(X,ie,ne)<0}function Se(X,ie,ne){return oe(X,ie,ne)===0}function _e(X,ie,ne){return oe(X,ie,ne)!==0}function Oe(X,ie,ne){return oe(X,ie,ne)>=0}function Ae(X,ie,ne){return oe(X,ie,ne)<=0}function Ne(X,ie,ne,de){var j;switch(ie){case"===":typeof X=="object"&&(X=X.version),typeof ne=="object"&&(ne=ne.version),j=X===ne;break;case"!==":typeof X=="object"&&(X=X.version),typeof ne=="object"&&(ne=ne.version),j=X!==ne;break;case"":case"=":case"==":j=Se(X,ne,de);break;case"!=":j=_e(X,ne,de);break;case">":j=ce(X,ne,de);break;case">=":j=Oe(X,ne,de);break;case"<":j=ue(X,ne,de);break;case"<=":j=Ae(X,ne,de);break;default:throw new TypeError("Invalid operator: "+ie)}return j}function Ee(X,ie){if(X instanceof Ee){if(X.loose===ie)return X;X=X.value}if(!(this instanceof Ee))return new Ee(X,ie);b("comparator",X,ie),this.loose=ie,this.parse(X),this.semver===Ce?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}e.rcompareIdentifiers=function(X,ie){return se(ie,X)},e.major=function(X,ie){return new K(X,ie).major},e.minor=function(X,ie){return new K(X,ie).minor},e.patch=function(X,ie){return new K(X,ie).patch},e.compare=oe,e.compareLoose=function(X,ie){return oe(X,ie,!0)},e.rcompare=function(X,ie,ne){return oe(ie,X,ne)},e.sort=function(X,ie){return X.sort(function(ne,de){return e.compare(ne,de,ie)})},e.rsort=function(X,ie){return X.sort(function(ne,de){return e.rcompare(ne,de,ie)})},e.gt=ce,e.lt=ue,e.eq=Se,e.neq=_e,e.gte=Oe,e.lte=Ae,e.cmp=Ne,e.Comparator=Ee;var Ce={};function fe(X,ie){if(X instanceof fe)return X.loose===ie?X:new fe(X.raw,ie);if(X instanceof Ee)return new fe(X.value,ie);if(!(this instanceof fe))return new fe(X,ie);if(this.loose=ie,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(ne){return this.parseRange(ne.trim())},this).filter(function(ne){return ne.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function pe(X){return!X||X.toLowerCase()==="x"||X==="*"}function De(X,ie,ne,de,j,ee,re,ae,le,he,me,we,Ie){return((ie=pe(ne)?"":pe(de)?">="+ne+".0.0":pe(j)?">="+ne+"."+de+".0":">="+ie)+" "+(ae=pe(le)?"":pe(he)?"<"+(+le+1)+".0.0":pe(me)?"<"+le+"."+(+he+1)+".0":we?"<="+le+"."+he+"."+me+"-"+we:"<="+ae)).trim()}function je(X,ie){for(var ne=0;ne<X.length;ne++)if(!X[ne].test(ie))return!1;if(ie.prerelease.length){for(ne=0;ne<X.length;ne++)if(b(X[ne].semver),X[ne].semver!==Ce&&X[ne].semver.prerelease.length>0){var de=X[ne].semver;if(de.major===ie.major&&de.minor===ie.minor&&de.patch===ie.patch)return!0}return!1}return!0}function Me(X,ie,ne){try{ie=new fe(ie,ne)}catch(de){return!1}return ie.test(X)}function Ue(X,ie,ne,de){var j,ee,re,ae,le;switch(X=new K(X,de),ie=new fe(ie,de),ne){case">":j=ce,ee=Ae,re=ue,ae=">",le=">=";break;case"<":j=ue,ee=Oe,re=ce,ae="<",le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(X,ie,de))return!1;for(var he=0;he<ie.set.length;++he){var me=ie.set[he],we=null,Ie=null;if(me.forEach(function(Pe){Pe.semver===Ce&&(Pe=new Ee(">=0.0.0")),we=we||Pe,Ie=Ie||Pe,j(Pe.semver,we.semver,de)?we=Pe:re(Pe.semver,Ie.semver,de)&&(Ie=Pe)}),we.operator===ae||we.operator===le||(!Ie.operator||Ie.operator===ae)&&ee(X,Ie.semver)||Ie.operator===le&&re(X,Ie.semver))return!1}return!0}Ee.prototype.parse=function(X){var ie=this.loose?C[U]:C[S],ne=X.match(ie);if(!ne)throw new TypeError("Invalid comparator: "+X);this.operator=ne[1],this.operator==="="&&(this.operator=""),ne[2]?this.semver=new K(ne[2],this.loose):this.semver=Ce},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(X){return b("Comparator.test",X,this.loose),this.semver===Ce||(typeof X=="string"&&(X=new K(X,this.loose)),Ne(X,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(X,ie){if(!(X instanceof Ee))throw new TypeError("a Comparator is required");var ne;if(this.operator==="")return ne=new fe(X.value,ie),Me(this.value,ne,ie);if(X.operator==="")return ne=new fe(this.value,ie),Me(X.semver,ne,ie);var de=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),j=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),ee=this.semver.version===X.semver.version,re=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),ae=Ne(this.semver,"<",X.semver,ie)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),le=Ne(this.semver,">",X.semver,ie)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return de||j||ee&&re||ae||le},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(X){var ie=this.loose;X=X.trim(),b("range",X,ie);var ne=ie?C[M]:C[N];X=X.replace(ne,De),b("hyphen replace",X),X=X.replace(C[I],"$1$2$3"),b("comparator trim",X,C[I]),X=(X=(X=X.replace(C[W],"$1~")).replace(C[Y],"$1^")).split(/\s+/).join(" ");var de=ie?C[U]:C[S],j=X.split(" ").map(function(ee){return function(re,ae){return b("comp",re),re=function(le,he){return le.trim().split(/\s+/).map(function(me){return function(we,Ie){b("caret",we,Ie);var Pe=Ie?C[x]:C[B];return we.replace(Pe,function(ke,ye,be,Le,Re){var Fe;return b("caret",we,ke,ye,be,Le,Re),pe(ye)?Fe="":pe(be)?Fe=">="+ye+".0.0 <"+(+ye+1)+".0.0":pe(Le)?Fe=ye==="0"?">="+ye+"."+be+".0 <"+ye+"."+(+be+1)+".0":">="+ye+"."+be+".0 <"+(+ye+1)+".0.0":Re?(b("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Fe=ye==="0"?be==="0"?">="+ye+"."+be+"."+Le+Re+" <"+ye+"."+be+"."+(+Le+1):">="+ye+"."+be+"."+Le+Re+" <"+ye+"."+(+be+1)+".0":">="+ye+"."+be+"."+Le+Re+" <"+(+ye+1)+".0.0"):(b("no pr"),Fe=ye==="0"?be==="0"?">="+ye+"."+be+"."+Le+" <"+ye+"."+be+"."+(+Le+1):">="+ye+"."+be+"."+Le+" <"+ye+"."+(+be+1)+".0":">="+ye+"."+be+"."+Le+" <"+(+ye+1)+".0.0"),b("caret return",Fe),Fe})}(me,he)}).join(" ")}(re,ae),b("caret",re),re=function(le,he){return le.trim().split(/\s+/).map(function(me){return function(we,Ie){var Pe=Ie?C[z]:C[Q];return we.replace(Pe,function(ke,ye,be,Le,Re){var Fe;return b("tilde",we,ke,ye,be,Le,Re),pe(ye)?Fe="":pe(be)?Fe=">="+ye+".0.0 <"+(+ye+1)+".0.0":pe(Le)?Fe=">="+ye+"."+be+".0 <"+ye+"."+(+be+1)+".0":Re?(b("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Fe=">="+ye+"."+be+"."+Le+Re+" <"+ye+"."+(+be+1)+".0"):Fe=">="+ye+"."+be+"."+Le+" <"+ye+"."+(+be+1)+".0",b("tilde return",Fe),Fe})}(me,he)}).join(" ")}(re,ae),b("tildes",re),re=function(le,he){return b("replaceXRanges",le,he),le.split(/\s+/).map(function(me){return function(we,Ie){we=we.trim();var Pe=Ie?C[u]:C[R];return we.replace(Pe,function(ke,ye,be,Le,Re,Fe){b("xRange",we,ke,ye,be,Le,Re,Fe);var qe=pe(be),We=qe||pe(Le),Be=We||pe(Re);return ye==="="&&Be&&(ye=""),qe?ke=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Be?(We&&(Le=0),Be&&(Re=0),ye===">"?(ye=">=",We?(be=+be+1,Le=0,Re=0):Be&&(Le=+Le+1,Re=0)):ye==="<="&&(ye="<",We?be=+be+1:Le=+Le+1),ke=ye+be+"."+Le+"."+Re):We?ke=">="+be+".0.0 <"+(+be+1)+".0.0":Be&&(ke=">="+be+"."+Le+".0 <"+be+"."+(+Le+1)+".0"),b("xRange return",ke),ke})}(me,he)}).join(" ")}(re,ae),b("xrange",re),re=function(le,he){return b("replaceStars",le,he),le.trim().replace(C[$],"")}(re,ae),b("stars",re),re}(ee,ie)}).join(" ").split(/\s+/);return this.loose&&(j=j.filter(function(ee){return!!ee.match(de)})),j=j.map(function(ee){return new Ee(ee,ie)})},fe.prototype.intersects=function(X,ie){if(!(X instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ne){return ne.every(function(de){return X.set.some(function(j){return j.every(function(ee){return de.intersects(ee,ie)})})})})},e.toComparators=function(X,ie){return new fe(X,ie).set.map(function(ne){return ne.map(function(de){return de.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new K(X,this.loose));for(var ie=0;ie<this.set.length;ie++)if(je(this.set[ie],X))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(X,ie,ne){var de=null,j=null;try{var ee=new fe(ie,ne)}catch(re){return null}return X.forEach(function(re){ee.test(re)&&(de&&j.compare(re)!==-1||(j=new K(de=re,ne)))}),de},e.minSatisfying=function(X,ie,ne){var de=null,j=null;try{var ee=new fe(ie,ne)}catch(re){return null}return X.forEach(function(re){ee.test(re)&&(de&&j.compare(re)!==1||(j=new K(de=re,ne)))}),de},e.validRange=function(X,ie){try{return new fe(X,ie).range||"*"}catch(ne){return null}},e.ltr=function(X,ie,ne){return Ue(X,ie,"<",ne)},e.gtr=function(X,ie,ne){return Ue(X,ie,">",ne)},e.outside=Ue,e.prerelease=function(X,ie){var ne=G(X,ie);return ne&&ne.prerelease.length?ne.prerelease:null},e.intersects=function(X,ie,ne){return X=new fe(X,ne),ie=new fe(ie,ne),X.intersects(ie)},e.coerce=function(X){if(X instanceof K)return X;if(typeof X!="string")return null;var ie=X.match(C[P]);return ie==null?null:G((ie[1]||"0")+"."+(ie[2]||"0")+"."+(ie[3]||"0"))}}).call(this,f(1))},function(q,e){var f,L,b=q.exports={};function _(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function C(p){if(f===setTimeout)return setTimeout(p,0);if((f===_||!f)&&setTimeout)return f=setTimeout,setTimeout(p,0);try{return f(p,0)}catch(O){try{return f.call(null,p,0)}catch(T){return f.call(this,p,0)}}}(function(){try{f=typeof setTimeout=="function"?setTimeout:_}catch(p){f=_}try{L=typeof clearTimeout=="function"?clearTimeout:A}catch(p){L=A}})();var h,g=[],D=!1,m=-1;function v(){D&&h&&(D=!1,h.length?g=h.concat(g):m=-1,g.length&&w())}function w(){if(!D){var p=C(v);D=!0;for(var O=g.length;O;){for(h=g,g=[];++m<O;)h&&h[m].run();m=-1,O=g.length}h=null,D=!1,function(T){if(L===clearTimeout)return clearTimeout(T);if((L===A||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(T);try{L(T)}catch(d){try{return L.call(null,T)}catch(l){return L.call(this,T)}}}(p)}}function a(p,O){this.fun=p,this.array=O}function c(){}b.nextTick=function(p){var O=new Array(arguments.length-1);if(arguments.length>1)for(var T=1;T<arguments.length;T++)O[T-1]=arguments[T];g.push(new a(p,O)),g.length!==1||D||C(w)},a.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=c,b.addListener=c,b.once=c,b.off=c,b.removeListener=c,b.removeAllListeners=c,b.emit=c,b.prependListener=c,b.prependOnceListener=c,b.listeners=function(p){return[]},b.binding=function(p){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(p){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(J[90],Z([0,1,3]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=f.globals.performance&&typeof f.globals.performance.now=="function";class b{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new b(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?f.globals.performance.now():Date.now()}}e.StopWatch=b}),define(J[5],Z([0,1,11,59,2,62,90]),function(q,e,f,L,b,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(O){O.None=()=>b.Disposable.None;function T(z){return(H,Y=null,B)=>{let x=!1,U;return U=z(S=>{if(!x)return U?U.dispose():x=!0,H.call(Y,S)},null,B),x&&U.dispose(),U}}O.once=T;function d(z,H){return r((Y,B=null,x)=>z(U=>Y.call(B,H(U)),null,x))}O.map=d;function l(z,H){return r((Y,B=null,x)=>z(U=>{H(U),Y.call(B,U)},null,x))}O.forEach=l;function s(z,H){return r((Y,B=null,x)=>z(U=>H(U)&&Y.call(B,U),null,x))}O.filter=s;function t(z){return z}O.signal=t;function i(...z){return(H,Y=null,B)=>(0,b.combinedDisposable)(...z.map(x=>x(U=>H.call(Y,U),null,B)))}O.any=i;function n(z,H,Y){let B=Y;return d(z,x=>(B=H(B,x),B))}O.reduce=n;function r(z){let H;const Y=new v({onFirstListenerAdd(){H=z(Y.fire,Y)},onLastListenerRemove(){H.dispose()}});return Y.event}O.snapshot=r;function o(z,H,Y=100,B=!1,x){let U,S,I,N=0;const M=new v({leakWarningThreshold:x,onFirstListenerAdd(){U=z($=>{N++,S=H(S,$),B&&!I&&(M.fire(S),S=void 0),clearTimeout(I),I=setTimeout(()=>{const V=S;S=void 0,I=void 0,(!B||N>1)&&M.fire(V),N=0},Y)})},onLastListenerRemove(){U.dispose()}});return M.event}O.debounce=o;function y(z){const H=new Date().getTime();return d(T(z),Y=>new Date().getTime()-H)}O.stopwatch=y;function E(z){let H=!0,Y;return s(z,B=>{const x=H||B!==Y;return H=!1,Y=B,x})}O.latch=E;function F(z,H=!1,Y=[]){let B=Y.slice(),x=z(I=>{B?B.push(I):S.fire(I)});const U=()=>{B&&B.forEach(I=>S.fire(I)),B=null},S=new v({onFirstListenerAdd(){x||(x=z(I=>S.fire(I)))},onFirstListenerDidAdd(){B&&(H?setTimeout(U):U())},onLastListenerRemove(){x&&x.dispose(),x=null}});return S.event}O.buffer=F;class R{constructor(H){this.event=H}map(H){return new R(d(this.event,H))}forEach(H){return new R(l(this.event,H))}filter(H){return new R(s(this.event,H))}reduce(H,Y){return new R(n(this.event,H,Y))}latch(){return new R(E(this.event))}debounce(H,Y=100,B=!1,x){return new R(o(this.event,H,Y,B,x))}on(H,Y,B){return this.event(H,Y,B)}once(H,Y,B){return T(this.event)(H,Y,B)}}function u(z){return new R(z)}O.chain=u;function P(z,H,Y=B=>B){const B=(...I)=>S.fire(Y(...I)),x=()=>z.on(H,B),U=()=>z.removeListener(H,B),S=new v({onFirstListenerAdd:x,onLastListenerRemove:U});return S.event}O.fromNodeEventEmitter=P;function k(z,H,Y=B=>B){const B=(...I)=>S.fire(Y(...I)),x=()=>z.addEventListener(H,B),U=()=>z.removeEventListener(H,B),S=new v({onFirstListenerAdd:x,onLastListenerRemove:U});return S.event}O.fromDOMEventEmitter=k;function W(z){const H=new v;let Y=!1;return z.then(void 0,()=>null).then(()=>{Y?H.fire(void 0):setTimeout(()=>H.fire(void 0),0)}),Y=!0,H.event}O.fromPromise=W;function Q(z){return new Promise(H=>T(z)(H))}O.toPromise=Q})(C=e.Event||(e.Event={}));class h{constructor(T){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${T}_${h._idPool++}`}start(T){this._stopWatch=new A.StopWatch(!0),this._listenerCount=T}stop(){if(this._stopWatch){const T=this._stopWatch.elapsed();this._elapsedOverall+=T,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${T.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}h._idPool=0;let g=-1;function D(O){const T=g;return g=O,{dispose(){g=T}}}e.setGlobalLeakWarningThreshold=D;class m{constructor(T,d=Math.random().toString(18).slice(2,5)){this.customThreshold=T,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(T){let d=g;if(typeof this.customThreshold=="number"&&(d=this.customThreshold),!(d<=0||T<d)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(l)||0;if(this._stacks.set(l,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=d*.5;let t,i=0;for(const[n,r]of this._stacks)(!t||i<r)&&(t=n,i=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class v{constructor(T){var d;this._disposed=!1,this._options=T,this._leakageMon=g>0?new m(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((d=this._options)===null||d===void 0?void 0:d._profName)?new h(this._options._profName):void 0}get event(){return this._event||(this._event=(T,d,l)=>{var s;this._listeners||(this._listeners=new _.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(d?[T,d]:T);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,T,d);const n=(s=this._leakageMon)===null||s===void 0?void 0:s.check(this._listeners.size);let r;return r={dispose:()=>{n&&n(),r.dispose=v._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof b.DisposableStore?l.add(r):Array.isArray(l)&&l.push(r),r}),this._event}fire(T){var d,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,T]);for((d=this._perfMon)===null||d===void 0||d.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,t]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,t):s[0].call(s[1],t)}catch(i){(0,f.onUnexpectedError)(i)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var T,d,l;(T=this._listeners)===null||T===void 0||T.clear(),(d=this._deliveryQueue)===null||d===void 0||d.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=v,v._noop=function(){};class w extends v{constructor(T){super(T);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=T==null?void 0:T.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const T=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(T))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(T){this._listeners&&(this._isPaused!==0?this._eventQueue.push(T):super.fire(T))}}e.PauseableEmitter=w;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(T){const d={event:T,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const l=()=>{this.hasListeners&&this.unhook(d);const s=this.events.indexOf(d);this.events.splice(s,1)};return(0,b.toDisposable)((0,L.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(T=>this.hook(T))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(T=>this.unhook(T))}hook(T){T.listener=T.event(d=>this.emitter.fire(d))}unhook(T){T.listener&&T.listener.dispose(),T.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class c{constructor(){this.buffers=[]}wrapEvent(T){return(d,l,s)=>T(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>d.call(l,t)):d.call(l,t)},void 0,s)}bufferEvents(T){const d=[];this.buffers.push(d);const l=T();return this.buffers.pop(),d.forEach(s=>s()),l}}e.EventBufferer=c;class p{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=b.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(T){this.inputEvent=T,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=T(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(J[27],Z([0,1,5]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(C,h){const g=setTimeout(C.bind(h),0);return{dispose(){clearTimeout(g)}}});var b;(function(C){function h(g){return g===C.None||g===C.Cancelled||g instanceof _?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}C.isCancellationToken=h,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(b=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new f.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=b.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=b.None}}e.CancellationTokenSource=A}),define(J[43],Z([0,1,11,2]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function b(d){const l=d;return l?[l.on,l.pause,l.resume,l.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=b;function _(d){const l=d;return l?b(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=_;function A(d,l){return new C(d,l)}e.newWriteableStream=A;class C{constructor(l,s){this.reducer=l,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){var s;if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof((s=this.options)===null||s===void 0?void 0:s.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(s=>s(l))}emitError(l){this.listeners.error.length===0?(0,f.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(s=>s(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,s){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(l,s){if(!this.state.destroyed){let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(s);i>=0&&t.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(d,l){const s=[];let t;for(;(t=d.read())!==null;)s.push(t);return l(s)}e.consumeReadable=h;function g(d,l,s){const t=[];let i;for(;(i=d.read())!==null&&t.length<s;)t.push(i);return i===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return d.read()}}}e.peekReadable=g;function D(d,l){return new Promise((s,t)=>{const i=[];m(d,{onData:n=>{l&&i.push(n)},onError:n=>{l?t(n):s(void 0)},onEnd:()=>{s(l?l(i):void 0)}})})}e.consumeStream=D;function m(d,l){d.on("error",s=>l.onError(s)),d.on("end",()=>l.onEnd()),d.on("data",s=>l.onData(s))}e.listenStream=m;function v(d,l){return new Promise((s,t)=>{const i=new L.DisposableStore,n=[],r=E=>{if(n.push(E),n.length>l)return i.dispose(),d.pause(),s({stream:d,buffer:n,ended:!1})},o=E=>t(E),y=()=>s({stream:d,buffer:n,ended:!0});i.add((0,L.toDisposable)(()=>d.removeListener("error",o))),d.on("error",o),i.add((0,L.toDisposable)(()=>d.removeListener("end",y))),d.on("end",y),i.add((0,L.toDisposable)(()=>d.removeListener("data",r))),d.on("data",r)})}e.peekStream=v;function w(d,l){const s=A(l);return s.end(d),s}e.toStream=w;function a(){const d=A(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=a;function c(d){let l=!1;return{read:()=>l?null:(l=!0,d)}}e.toReadable=c;function p(d,l,s){const t=A(s);return m(d,{onData:i=>t.write(l.data(i)),onError:i=>t.error(l.error?l.error(i):i),onEnd:()=>t.end()}),t}e.transform=p;function O(d,l,s){let t=!1;return{read:()=>{const i=l.read();return t?i:(t=!0,i!==null?s([d,i]):d)}}}e.prefixedReadable=O;function T(d,l,s){let t=!1;const i=A(s);return m(l,{onData:n=>t?i.write(n):(t=!0,i.write(s([d,n]))),onError:n=>i.error(n),onEnd:()=>{t||(t=!0,i.write(d)),i.end()}}),i}e.prefixedStream=T}),define(J[18],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function f(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=f;const L=/{(\d+)}/g;function b(j,...ee){return ee.length===0?j:j.replace(L,function(re,ae){const le=parseInt(ae,10);return isNaN(le)||le<0||le>=ee.length?re:ee[le]})}e.format=b;function _(j){return j.replace(/[<>&]/g,function(ee){switch(ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ee}})}e.escape=_;function A(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=A;function C(j,ee){let re=0;const ae=ee.charCodeAt(0);for(let le=j.length-1;le>=0;le--)j.charCodeAt(le)===ae&&re++;return re}e.count=C;function h(j,ee,re="\u2026"){return j.length<=ee?j:`${j.substr(0,ee)}${re}`}e.truncate=h;function g(j,ee=" "){const re=D(j,ee);return m(re,ee)}e.trim=g;function D(j,ee){if(!j||!ee)return j;const re=ee.length;if(re===0||j.length===0)return j;let ae=0;for(;j.indexOf(ee,ae)===ae;)ae=ae+re;return j.substring(ae)}e.ltrim=D;function m(j,ee){if(!j||!ee)return j;const re=ee.length,ae=j.length;if(re===0||ae===0)return j;let le=ae,he=-1;for(;he=j.lastIndexOf(ee,le-1),!(he===-1||he+re!==le);){if(he===0)return"";le=he}return j.substring(0,le)}e.rtrim=m;function v(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function w(j){return j.replace(/\*/g,"")}e.stripWildcards=w;function a(j,ee,re={}){if(!j)throw new Error("Cannot create regex from empty string");ee||(j=A(j)),re.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let ae="";return re.global&&(ae+="g"),re.matchCase||(ae+="i"),re.multiline&&(ae+="m"),re.unicode&&(ae+="u"),new RegExp(j,ae)}e.createRegExp=a;function c(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function p(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function O(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=O;function T(j){return j.split(/\r\n|\r|\n/)}e.splitLines=T;function d(j){for(let ee=0,re=j.length;ee<re;ee++){const ae=j.charCodeAt(ee);if(ae!==32&&ae!==9)return ee}return-1}e.firstNonWhitespaceIndex=d;function l(j,ee=0,re=j.length){for(let ae=ee;ae<re;ae++){const le=j.charCodeAt(ae);if(le!==32&&le!==9)return j.substring(ee,ae)}return j.substring(ee,re)}e.getLeadingWhitespace=l;function s(j,ee=j.length-1){for(let re=ee;re>=0;re--){const ae=j.charCodeAt(re);if(ae!==32&&ae!==9)return re}return-1}e.lastNonWhitespaceIndex=s;function t(j,ee){return j<ee?-1:j>ee?1:0}e.compare=t;function i(j,ee,re=0,ae=j.length,le=0,he=ee.length){for(;re<ae&&le<he;re++,le++){let Ie=j.charCodeAt(re),Pe=ee.charCodeAt(le);if(Ie<Pe)return-1;if(Ie>Pe)return 1}const me=ae-re,we=he-le;return me<we?-1:me>we?1:0}e.compareSubstring=i;function n(j,ee){return r(j,ee,0,j.length,0,ee.length)}e.compareIgnoreCase=n;function r(j,ee,re=0,ae=j.length,le=0,he=ee.length){for(;re<ae&&le<he;re++,le++){let Ie=j.charCodeAt(re),Pe=ee.charCodeAt(le);if(Ie!==Pe){const ke=Ie-Pe;if(!(ke===32&&y(Pe))&&!(ke===-32&&y(Ie)))return o(Ie)&&o(Pe)?ke:i(j.toLowerCase(),ee.toLowerCase(),re,ae,le,he)}}const me=ae-re,we=he-le;return me<we?-1:me>we?1:0}e.compareSubstringIgnoreCase=r;function o(j){return j>=97&&j<=122}e.isLowerAsciiLetter=o;function y(j){return j>=65&&j<=90}e.isUpperAsciiLetter=y;function E(j){return o(j)||y(j)}function F(j,ee){return j.length===ee.length&&R(j,ee)}e.equalsIgnoreCase=F;function R(j,ee,re=j.length){for(let ae=0;ae<re;ae++){const le=j.charCodeAt(ae),he=ee.charCodeAt(ae);if(le!==he){if(E(le)&&E(he)){const me=Math.abs(le-he);if(me!==0&&me!==32)return!1}else if(String.fromCharCode(le).toLowerCase()!==String.fromCharCode(he).toLowerCase())return!1}}return!0}function u(j,ee){const re=ee.length;return ee.length>j.length?!1:R(j,ee,re)}e.startsWithIgnoreCase=u;function P(j,ee){let re,ae=Math.min(j.length,ee.length);for(re=0;re<ae;re++)if(j.charCodeAt(re)!==ee.charCodeAt(re))return re;return ae}e.commonPrefixLength=P;function k(j,ee){let re,ae=Math.min(j.length,ee.length);const le=j.length-1,he=ee.length-1;for(re=0;re<ae;re++)if(j.charCodeAt(le-re)!==ee.charCodeAt(he-re))return re;return ae}e.commonSuffixLength=k;function W(j){return 55296<=j&&j<=56319}e.isHighSurrogate=W;function Q(j){return 56320<=j&&j<=57343}e.isLowSurrogate=Q;function z(j,ee){return(j-55296<<10)+(ee-56320)+65536}e.computeCodePoint=z;function H(j,ee,re){const ae=j.charCodeAt(re);if(W(ae)&&re+1<ee){const le=j.charCodeAt(re+1);if(Q(le))return z(ae,le)}return ae}e.getNextCodePoint=H;function Y(j,ee){const re=j.charCodeAt(ee-1);if(Q(re)&&ee>1){const ae=j.charCodeAt(ee-2);if(W(ae))return z(ae,re)}return re}function B(j,ee){const re=ne.getInstance(),ae=ee,le=j.length,he=H(j,le,ee);ee+=he>=65536?2:1;let me=re.getGraphemeBreakType(he);for(;ee<le;){const we=H(j,le,ee),Ie=re.getGraphemeBreakType(we);if(X(me,Ie))break;ee+=we>=65536?2:1,me=Ie}return ee-ae}e.nextCharLength=B;function x(j,ee){const re=ne.getInstance(),ae=ee,le=Y(j,ee);ee-=le>=65536?2:1;let he=re.getGraphemeBreakType(le);for(;ee>0;){const me=Y(j,ee),we=re.getGraphemeBreakType(me);if(X(we,he))break;ee-=me>=65536?2:1,he=we}return ae-ee}e.prevCharLength=x;function U(j,ee){const re=ne.getInstance(),ae=j.length,le=ee,he=H(j,ae,ee),me=re.getGraphemeBreakType(he);ee+=he>=65536?2:1;let we=me;for(;ee<ae;){const Pe=H(j,ae,ee),ke=re.getGraphemeBreakType(Pe);if(X(we,ke))break;ee+=Pe>=65536?2:1,we=ke}const Ie=ee;for(ee=le,we=me;ee>0;){const Pe=Y(j,ee),ke=re.getGraphemeBreakType(Pe);if(X(ke,we))break;ee-=Pe>=65536?2:1,we=ke}return[ee,Ie]}function S(j,ee){return ee>0&&Q(j.charCodeAt(ee))?U(j,ee-1):U(j,ee)}e.getCharContainingOffset=S;function I(j){const ee=j.length;let re=0,ae=0;for(;ae<ee;){const me=H(j,ee,ae);ae+=me>=65536?2:1,me<128?re+=1:me<2048?re+=2:me<65536?re+=3:re+=4}const le=new Uint8Array(re);ae=0;let he=0;for(;ae<ee;){const me=H(j,ee,ae);ae+=me>=65536?2:1,me<128?le[he++]=me:me<2048?(le[he++]=192|(me&1984)>>>6,le[he++]=128|(me&63)>>>0):me<65536?(le[he++]=224|(me&61440)>>>12,le[he++]=128|(me&4032)>>>6,le[he++]=128|(me&63)>>>0):(le[he++]=240|(me&1835008)>>>18,le[he++]=128|(me&258048)>>>12,le[he++]=128|(me&4032)>>>6,le[he++]=128|(me&63)>>>0)}return le}e.encodeUTF8=I;function N(j){const ee=j.byteLength,re=[];let ae=0;for(;ae<ee;){const le=j[ae];let he;if(le>=240&&ae+3<ee?he=(j[ae++]&7)<<18>>>0|(j[ae++]&63)<<12>>>0|(j[ae++]&63)<<6>>>0|(j[ae++]&63)<<0>>>0:le>=224&&ae+2<ee?he=(j[ae++]&15)<<12>>>0|(j[ae++]&63)<<6>>>0|(j[ae++]&63)<<0>>>0:le>=192&&ae+1<ee?he=(j[ae++]&31)<<6>>>0|(j[ae++]&63)<<0>>>0:he=j[ae++],he>=0&&he<=55295||he>=57344&&he<=65535)re.push(String.fromCharCode(he));else if(he>=65536&&he<=1114111){const me=he-65536,we=55296+((me&1047552)>>>10),Ie=56320+((me&1023)>>>0);re.push(String.fromCharCode(we)),re.push(String.fromCharCode(Ie))}else re.push(String.fromCharCode(65533))}return re.join("")}e.decodeUTF8=N;const M=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function $(j){return M.test(j)}e.containsRTL=$;const V=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function G(j){return V.test(j)}e.containsEmoji=G;const K=/^[\t\n\r\x20-\x7E]*$/;function te(j){return K.test(j)}e.isBasicASCII=te,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=se;function oe(j){for(let ee=0,re=j.length;ee<re;ee++)if(ce(j.charCodeAt(ee)))return!0;return!1}e.containsFullWidthCharacter=oe;function ce(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=ce;function ue(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=ue;function Se(j,ee){if(j.length<ee)return j;const re=/\b/g;let ae=0;for(;re.test(j)&&!(j.length-re.lastIndex<ee);)ae=re.lastIndex,re.lastIndex+=1;return j.substring(ae).replace(/^\s/,"")}e.lcut=Se;const _e=/\x1B\x5B[12]?K/g,Oe=/\x1b\[\d+m/g,Ae=/\x1b\[0?m/g;function Ne(j){return j&&(j=j.replace(_e,""),j=j.replace(Oe,""),j=j.replace(Ae,"")),j}e.removeAnsiEscapeCodes=Ne,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Ce(j){return Ee(j)?j.substr(1):j}e.stripUTF8BOM=Ce;function fe(j,ee){if(!j||!ee||j.length<ee.length)return!1;const re=ee.length,ae=j.toLowerCase();let le=0,he=-1;for(;le<re;){const me=ae.indexOf(ee[le],he+1);if(me<0)return!1;he=me,le++}return!0}e.fuzzyContains=fe;function pe(j,ee=!1){return j?(ee&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=pe;function De(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=De;function je(j,ee=1){if(ee===0)return"";let re=-1;do re=j.indexOf(`
`,re+1),ee--;while(ee>0&&re>=0);return re===-1?j:(j[re-1]==="\r"&&re--,j.substr(0,re))}e.getNLines=je;function Me(j){const ee=90-65+1;return j=j%(2*ee),j<ee?String.fromCharCode(97+j):String.fromCharCode(65+j-ee)}e.singleLetterHash=Me;function Ue(j){return ne.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=Ue;function X(j,ee){return j===0?ee!==5&&ee!==7:j===2&&ee===3?!1:j===4||j===2||j===3||ee===4||ee===2||ee===3?!0:!(j===8&&(ee===8||ee===9||ee===11||ee===12)||(j===11||j===9)&&(ee===9||ee===10)||(j===12||j===10)&&ee===10||ee===5||ee===13||ee===7||j===1||j===13&&ee===14||j===6&&ee===6)}e.breakBetweenGraphemeBreakType=X;var ie;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ne{constructor(){this._data=de()}static getInstance(){return ne._INSTANCE||(ne._INSTANCE=new ne),ne._INSTANCE}getGraphemeBreakType(ee){if(ee<32)return ee===10?3:ee===13?2:4;if(ee<127)return 0;const re=this._data,ae=re.length/3;let le=1;for(;le<=ae;)if(ee<re[3*le])le=2*le;else if(ee>re[3*le+1])le=2*le+1;else return re[3*le+2];return 0}}ne._INSTANCE=null;function de(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(J[17],Z([0,1,18,43]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const b=typeof Buffer!="undefined",_=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let C,h;class g{constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}static alloc(E){return b?new g(Buffer.allocUnsafe(E)):new g(new Uint8Array(E))}static wrap(E){return b&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new g(E)}static fromString(E,F){return!((F==null?void 0:F.dontUseNodeBuffer)||!1)&&b?new g(Buffer.from(E)):_?(C||(C=new TextEncoder),new g(C.encode(E))):new g(f.encodeUTF8(E))}static concat(E,F){if(typeof F=="undefined"){F=0;for(let P=0,k=E.length;P<k;P++)F+=E[P].byteLength}const R=g.alloc(F);let u=0;for(let P=0,k=E.length;P<k;P++){const W=E[P];R.set(W,u),u+=W.byteLength}return R}toString(){return b?this.buffer.toString():A?(h||(h=new TextDecoder),h.decode(this.buffer)):f.decodeUTF8(this.buffer)}slice(E,F){return new g(this.buffer.subarray(E,F))}set(E,F){E instanceof g?this.buffer.set(E.buffer,F):this.buffer.set(E,F)}readUInt32BE(E){return v(this.buffer,E)}writeUInt32BE(E,F){w(this.buffer,E,F)}readUInt32LE(E){return a(this.buffer,E)}writeUInt32LE(E,F){c(this.buffer,E,F)}readUInt8(E){return p(this.buffer,E)}writeUInt8(E,F){O(this.buffer,E,F)}}e.VSBuffer=g;function D(y,E){return y[E+0]<<0>>>0|y[E+1]<<8>>>0}e.readUInt16LE=D;function m(y,E,F){y[F+0]=E&255,E=E>>>8,y[F+1]=E&255}e.writeUInt16LE=m;function v(y,E){return y[E]*2**24+y[E+1]*2**16+y[E+2]*2**8+y[E+3]}e.readUInt32BE=v;function w(y,E,F){y[F+3]=E,E=E>>>8,y[F+2]=E,E=E>>>8,y[F+1]=E,E=E>>>8,y[F]=E}e.writeUInt32BE=w;function a(y,E){return y[E+0]<<0>>>0|y[E+1]<<8>>>0|y[E+2]<<16>>>0|y[E+3]<<24>>>0}e.readUInt32LE=a;function c(y,E,F){y[F+0]=E&255,E=E>>>8,y[F+1]=E&255,E=E>>>8,y[F+2]=E&255,E=E>>>8,y[F+3]=E&255}e.writeUInt32LE=c;function p(y,E){return y[E]}e.readUInt8=p;function O(y,E,F){y[F]=E}e.writeUInt8=O;function T(y){return L.consumeReadable(y,E=>g.concat(E))}e.readableToBuffer=T;function d(y){return L.toReadable(y)}e.bufferToReadable=d;function l(y){return L.consumeStream(y,E=>g.concat(E))}e.streamToBuffer=l;async function s(y){return y.ended?g.concat(y.buffer):g.concat([...y.buffer,await l(y.stream)])}e.bufferedStreamToBuffer=s;function t(y){return L.toStream(y,E=>g.concat(E))}e.bufferToStream=t;function i(y){return L.transform(y,{data:E=>typeof E=="string"?g.fromString(E):g.wrap(E)},E=>g.concat(E))}e.streamToBufferReadableStream=i;function n(y){return L.newWriteableStream(E=>g.concat(E),y)}e.newWriteableBufferStream=n;function r(y,E){return L.prefixedReadable(y,E,F=>g.concat(F))}e.prefixedBufferReadable=r;function o(y,E){return L.prefixedStream(y,E,F=>g.concat(F))}e.prefixedBufferStream=o}),define(J[91],Z([0,1,18]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(L||(L={})),function(b){const _="error",A="warning",C="warn",h="info",g="ignore";function D(v){return v?f.equalsIgnoreCase(_,v)?b.Error:f.equalsIgnoreCase(A,v)||f.equalsIgnoreCase(C,v)?b.Warning:f.equalsIgnoreCase(h,v)?b.Info:b.Ignore:b.Ignore}b.fromValue=D;function m(v){switch(v){case b.Error:return _;case b.Warning:return A;case b.Info:return h;default:return g}}b.toString=m}(L||(L={})),e.default=L}),define(J[12],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function f(E){return Array.isArray(E)}e.isArray=f;function L(E){return typeof E=="string"}e.isString=L;function b(E){return Array.isArray(E)&&E.every(F=>L(F))}e.isStringArray=b;function _(E){return typeof E=="object"&&E!==null&&!Array.isArray(E)&&!(E instanceof RegExp)&&!(E instanceof Date)}e.isObject=_;function A(E){return typeof E=="number"&&!isNaN(E)}e.isNumber=A;function C(E){return!!E&&typeof E[Symbol.iterator]=="function"}e.isIterable=C;function h(E){return E===!0||E===!1}e.isBoolean=h;function g(E){return typeof E=="undefined"}e.isUndefined=g;function D(E){return!m(E)}e.isDefined=D;function m(E){return g(E)||E===null}e.isUndefinedOrNull=m;function v(E,F){if(!E)throw new Error(F?`Unexpected type, expected '${F}'`:"Unexpected type")}e.assertType=v;function w(E){if(m(E))throw new Error("Assertion Failed: argument is undefined or null");return E}e.assertIsDefined=w;function a(...E){const F=[];for(let R=0;R<E.length;R++){const u=E[R];if(m(u))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);F.push(u)}return F}e.assertAllDefined=a;const c=Object.prototype.hasOwnProperty;function p(E){if(!_(E))return!1;for(let F in E)if(c.call(E,F))return!1;return!0}e.isEmptyObject=p;function O(E){return typeof E=="function"}e.isFunction=O;function T(...E){return E.length>0&&E.every(O)}e.areFunctions=T;function d(E,F){const R=Math.min(E.length,F.length);for(let u=0;u<R;u++)l(E[u],F[u])}e.validateConstraints=d;function l(E,F){if(L(F)){if(typeof E!==F)throw new Error(`argument does not match constraint: typeof ${F}`)}else if(O(F)){try{if(E instanceof F)return}catch(R){}if(!m(E)&&E.constructor===F||F.length===1&&F.call(void 0,E)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function s(E){let F=[],R=Object.getPrototypeOf(E);for(;Object.prototype!==R;)F=F.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return F}e.getAllPropertyNames=s;function t(E){const F=[];for(const R of s(E))typeof E[R]=="function"&&F.push(R);return F}e.getAllMethodNames=t;function i(E,F){const R=P=>function(){const k=Array.prototype.slice.call(arguments,0);return F(P,k)};let u={};for(const P of E)u[P]=R(P);return u}e.createProxyObject=i;function n(E){return E===null?void 0:E}e.withNullAsUndefined=n;function r(E){return typeof E=="undefined"?null:E}e.withUndefinedAsNull=r;function o(E){return class{constructor(){return new Proxy({},{get(F,R){if(F[R])return F[R];throw new Error(`Not Implemented: ${E}->${String(R)}`)}})}}}e.NotImplementedProxy=o;function y(E){throw new Error("Unreachable")}e.assertNever=y}),define(J[35],Z([0,1,3,18,4,12]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function A(i){return i===47||i===92}e.isPathSeparator=A;function C(i){return i.replace(/[\\/]/g,b.posix.sep)}e.toSlashes=C;function h(i,n=b.posix.sep){if(!i)return"";const r=i.length,o=i.charCodeAt(0);if(A(o)){if(A(i.charCodeAt(1))&&!A(i.charCodeAt(2))){let E=3;const F=E;for(;E<r&&!A(i.charCodeAt(E));E++);if(F!==E&&!A(i.charCodeAt(E+1))){for(E+=1;E<r;E++)if(A(i.charCodeAt(E)))return i.slice(0,E+1).replace(/[\\/]/g,n)}}return n}else if(p(o)&&i.charCodeAt(1)===58)return A(i.charCodeAt(2))?i.slice(0,2)+n:i.slice(0,2);let y=i.indexOf("://");if(y!==-1){for(y+=3;y<r;y++)if(A(i.charCodeAt(y)))return i.slice(0,y+1)}return""}e.getRoot=h;function g(i){if(!f.isWindows||!i||i.length<5)return!1;let n=i.charCodeAt(0);if(n!==92||(n=i.charCodeAt(1),n!==92))return!1;let r=2;const o=r;for(;r<i.length&&(n=i.charCodeAt(r),n!==92);r++);return!(o===r||(n=i.charCodeAt(r+1),isNaN(n)||n===92))}e.isUNC=g;const D=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(i,n=f.isWindows){const r=n?D:m;return!(!i||i.length===0||/^\s+$/.test(i)||(r.lastIndex=0,r.test(i))||n&&v.test(i)||i==="."||i===".."||n&&i[i.length-1]==="."||n&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=w;function a(i,n,r){const o=i===n;return!r||o?o:!i||!n?!1:(0,L.equalsIgnoreCase)(i,n)}e.isEqual=a;function c(i,n,r,o=b.sep){if(i===n)return!0;if(!i||!n||n.length>i.length)return!1;if(r){if(!(0,L.startsWithIgnoreCase)(i,n))return!1;if(n.length===i.length)return!0;let E=n.length;return n.charAt(n.length-1)===o&&E--,i.charAt(E)===o}return n.charAt(n.length-1)!==o&&(n+=o),i.indexOf(n)===0}e.isEqualOrParent=c;function p(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=p;function O(i,n){return f.isWindows&&i.endsWith(":")&&(i+=b.sep),(0,b.isAbsolute)(i)||(i=(0,b.join)(n,i)),i=(0,b.normalize)(i),f.isWindows?(i=(0,L.rtrim)(i,b.sep),i.endsWith(":")&&(i+=b.sep)):(i=(0,L.rtrim)(i,b.sep),i||(i=b.sep)),i}e.sanitizeFilePath=O;function T(i){const n=(0,b.normalize)(i);return f.isWindows?i.length>3?!1:d(n)&&(i.length===2||n.charCodeAt(2)===92):n===b.posix.sep}e.isRootOrDriveLetter=T;function d(i){return f.isWindows?p(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function l(i){return d(i)?i[0]:void 0}e.getDriveLetter=l;function s(i,n,r){return n.length>i.length?-1:i===n?0:(r&&(i=i.toLowerCase(),n=n.toLowerCase()),i.indexOf(n))}e.indexOfPath=s;function t(i){const n=i.split(":");let r,o,y;if(n.forEach(E=>{const F=Number(E);(0,_.isNumber)(F)?o===void 0?o=F:y===void 0&&(y=F):r=r?[r,E].join(":"):E}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:o!==void 0?o:void 0,column:y!==void 0?y:o!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(J[22],Z([0,1,12]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const c=Array.isArray(a)?[]:{};return Object.keys(a).forEach(p=>{a[p]&&typeof a[p]=="object"?c[p]=L(a[p]):c[p]=a[p]}),c}e.deepClone=L;function b(a){if(!a||typeof a!="object")return a;const c=[a];for(;c.length>0;){const p=c.shift();Object.freeze(p);for(const O in p)if(_.call(p,O)){const T=p[O];typeof T=="object"&&!Object.isFrozen(T)&&c.push(T)}}return a}e.deepFreeze=b;const _=Object.prototype.hasOwnProperty;function A(a,c){return C(a,c,new Set)}e.cloneAndChange=A;function C(a,c,p){if((0,f.isUndefinedOrNull)(a))return a;const O=c(a);if(typeof O!="undefined")return O;if((0,f.isArray)(a)){const T=[];for(const d of a)T.push(C(d,c,p));return T}if((0,f.isObject)(a)){if(p.has(a))throw new Error("Cannot clone recursive data-structure");p.add(a);const T={};for(let d in a)_.call(a,d)&&(T[d]=C(a[d],c,p));return p.delete(a),T}return a}function h(a,c,p=!0){return(0,f.isObject)(a)?((0,f.isObject)(c)&&Object.keys(c).forEach(O=>{O in a?p&&((0,f.isObject)(a[O])&&(0,f.isObject)(c[O])?h(a[O],c[O],p):a[O]=c[O]):a[O]=c[O]}),a):c}e.mixin=h;function g(a,c){if(a===c)return!0;if(a==null||c===null||c===void 0||typeof a!=typeof c||typeof a!="object"||Array.isArray(a)!==Array.isArray(c))return!1;let p,O;if(Array.isArray(a)){if(a.length!==c.length)return!1;for(p=0;p<a.length;p++)if(!g(a[p],c[p]))return!1}else{const T=[];for(O in a)T.push(O);T.sort();const d=[];for(O in c)d.push(O);if(d.sort(),!g(T,d))return!1;for(p=0;p<T.length;p++)if(!g(a[T[p]],c[T[p]]))return!1}return!0}e.equals=g;function D(a){const c=new Set;return JSON.stringify(a,(p,O)=>{if((0,f.isObject)(O)||Array.isArray(O)){if(c.has(O))return"[Circular]";c.add(O)}return O})}e.safeStringify=D;function m(a,c,p){const O=c(a);return typeof O=="undefined"?p:O}e.getOrDefault=m;function v(a,c){const p=Object.create(null);return!a||!c||Object.keys(c).forEach(T=>{const d=a[T],l=c[T];g(d,l)||(p[T]=l)}),p}e.distinct=v;function w(a,c){const p=c.toLowerCase(),O=Object.keys(a).find(T=>T.toLowerCase()===p);return O?a[O]:a[c]}e.getCaseInsensitive=w}),define(J[7],Z([0,1,3,4]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const b=/^\w[\w\d+.-]*$/,_=/^\//,A=/^\/\//;function C(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!b.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!_.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(n,r){return!n&&!r?"file":n}function g(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==m&&(r=m+r):r=m;break}return r}const D="",m="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(r,o,y,E,F,R=!1){typeof r=="object"?(this.scheme=r.scheme||D,this.authority=r.authority||D,this.path=r.path||D,this.query=r.query||D,this.fragment=r.fragment||D):(this.scheme=h(r,R),this.authority=o||D,this.path=g(this.scheme,y||D),this.query=E||D,this.fragment=F||D,C(this,R))}static isUri(r){return r instanceof w?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return d(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:y,path:E,query:F,fragment:R}=r;return o===void 0?o=this.scheme:o===null&&(o=D),y===void 0?y=this.authority:y===null&&(y=D),E===void 0?E=this.path:E===null&&(E=D),F===void 0?F=this.query:F===null&&(F=D),R===void 0?R=this.fragment:R===null&&(R=D),o===this.scheme&&y===this.authority&&E===this.path&&F===this.query&&R===this.fragment?this:new c(o,y,E,F,R)}static parse(r,o=!1){const y=v.exec(r);return y?new c(y[2]||D,i(y[4]||D),i(y[5]||D),i(y[7]||D),i(y[9]||D),o):new c(D,D,D,D,D)}static file(r){let o=D;if(f.isWindows&&(r=r.replace(/\\/g,m)),r[0]===m&&r[1]===m){const y=r.indexOf(m,2);y===-1?(o=r.substring(2),r=m):(o=r.substring(2,y),r=r.substring(y)||m)}return new c("file",o,r,D,D)}static from(r){return new c(r.scheme,r.authority,r.path,r.query,r.fragment)}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return f.isWindows&&r.scheme==="file"?y=w.file(L.win32.join(d(r,!0),...o)).path:y=L.posix.join(r.path,...o),r.with({path:y})}toString(r=!1){return l(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof w)return r;{const o=new c(r);return o._formatted=r.external,o._fsPath=r._sep===a?r.fsPath:null,o}}else return r}}e.URI=w;const a=f.isWindows?1:void 0;class c extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(r=!1){return r?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=a),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function O(n,r){let o,y=-1;for(let E=0;E<n.length;E++){const F=n.charCodeAt(E);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||r&&F===47)y!==-1&&(o+=encodeURIComponent(n.substring(y,E)),y=-1),o!==void 0&&(o+=n.charAt(E));else{o===void 0&&(o=n.substr(0,E));const R=p[F];R!==void 0?(y!==-1&&(o+=encodeURIComponent(n.substring(y,E)),y=-1),o+=R):y===-1&&(y=E)}}return y!==-1&&(o+=encodeURIComponent(n.substring(y))),o!==void 0?o:n}function T(n){let r;for(let o=0;o<n.length;o++){const y=n.charCodeAt(o);y===35||y===63?(r===void 0&&(r=n.substr(0,o)),r+=p[y]):r!==void 0&&(r+=n[o])}return r!==void 0?r:n}function d(n,r){let o;return n.authority&&n.path.length>1&&n.scheme==="file"?o=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?o=n.path.substr(1):o=n.path[1].toLowerCase()+n.path.substr(2):o=n.path,f.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=d;function l(n,r){const o=r?T:O;let y="",{scheme:E,authority:F,path:R,query:u,fragment:P}=n;if(E&&(y+=E,y+=":"),(F||E==="file")&&(y+=m,y+=m),F){let k=F.indexOf("@");if(k!==-1){const W=F.substr(0,k);F=F.substr(k+1),k=W.indexOf(":"),k===-1?y+=o(W,!1):(y+=o(W.substr(0,k),!1),y+=":",y+=o(W.substr(k+1),!1)),y+="@"}F=F.toLowerCase(),k=F.indexOf(":"),k===-1?y+=o(F,!1):(y+=o(F.substr(0,k),!1),y+=F.substr(k))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const k=R.charCodeAt(1);k>=65&&k<=90&&(R=`/${String.fromCharCode(k+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const k=R.charCodeAt(0);k>=65&&k<=90&&(R=`${String.fromCharCode(k+32)}:${R.substr(2)}`)}y+=o(R,!0)}return u&&(y+="?",y+=o(u,!1)),P&&(y+="#",y+=r?P:O(P,!1)),y}function s(n){try{return decodeURIComponent(n)}catch(r){return n.length>3?n.substr(0,3)+s(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(n){return n.match(t)?n.replace(t,r=>s(r)):n}}),define(J[92],Z([0,1,7]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(g){const D=g;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=L;function b(g){const D=[];let m;try{const v=JSON.parse(g.arguments),w=v[v.length-1];w&&w.__$stack&&(v.pop(),m=w.__$stack),D.push(...v)}catch(v){D.push("Unable to log remote console arguments",g.arguments)}return{args:D,stack:m}}e.parse=b;function _(g){if(typeof g!="string")return _(b(g).stack);const D=g;if(D){const m=A(D),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(v&&v.length===4)return{uri:f.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=_;function A(g){if(!g)return g;const D=g.indexOf(`
`);return D===-1?g:g.substring(0,D)}function C(g,D){const{args:m,stack:v}=b(g),w=typeof m[0]=="string"&&m.length===1;let a=A(v);a&&(a=`(${a.trim()})`);let c=[];if(typeof m[0]=="string"?a&&w?c=[`%c[${D}] %c${m[0]} %c${a}`,h("blue"),h(""),h("grey")]:c=[`%c[${D}] %c${m[0]}`,h("blue"),h(""),...m.slice(1)]:c=[`%c[${D}]%`,h("blue"),...m],a&&!w&&c.push(a),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,c)}e.log=C;function h(g){return`color: ${g}`}});var Ge=this&&this.__classPrivateFieldSet||function(q,e,f,L,b){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?q!==e||!b:!e.has(q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?b.call(q,f):b?b.value=f:e.set(q,f),f},ze=this&&this.__classPrivateFieldGet||function(q,e,f,L){if(f==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?q!==e||!L:!e.has(q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?L:f==="a"?L.call(q):L?L.value:e.get(q)};define(J[33],Z([0,1,7,18]),function(q,e,f,L){"use strict";var b,_,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,i,n){let r=t.get(i);return r===void 0&&(r=n,t.set(i,r)),r}e.getOrSet=C;function h(t){const i=[];return t.forEach((n,r)=>{i.push(`${r} => ${n}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=h;function g(t){const i=[];return t.forEach(n=>{i.push(n)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=g;class D{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const n=i.charCodeAt(0),r=this._value.charCodeAt(this._pos);return n-r}value(){return this._value[this._pos]}}e.StringIterator=D;class m{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,L.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=m;class v{constructor(i=!0,n=!0){this._splitOnBackslash=i,this._caseSensitive=n}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,L.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var w;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(w||(w={}));class a{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,L.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class c{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class p{constructor(i){this._iter=i}static forUris(i=()=>!1){return new p(new a(i))}static forPaths(){return new p(new v)}static forStrings(){return new p(new D)}static forConfigKeys(){return new p(new m)}clear(){this._root=void 0}set(i,n){const r=this._iter.reset(i);let o;for(this._root||(this._root=new c,this._root.segment=r.value()),o=this._root;;){const E=r.cmp(o.segment);if(E>0)o.left||(o.left=new c,o.left.segment=r.value()),o=o.left;else if(E<0)o.right||(o.right=new c,o.right.segment=r.value()),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new c,o.mid.segment=r.value()),o=o.mid;else break}const y=o.value;return o.value=n,o.key=i,y}get(i){var n;return(n=this._getNode(i))===null||n===void 0?void 0:n.value}_getNode(i){const n=this._iter.reset(i);let r=this._root;for(;r;){const o=n.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(n.hasNext())n.next(),r=r.mid;else break}return r}has(i){const n=this._getNode(i);return!((n==null?void 0:n.value)===void 0&&(n==null?void 0:n.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,n){const r=this._iter.reset(i),o=[];let y=this._root;for(;y;){const E=r.cmp(y.segment);if(E>0)o.push([1,y]),y=y.left;else if(E<0)o.push([-1,y]),y=y.right;else if(r.hasNext())r.next(),o.push([0,y]),y=y.mid;else{for(n?(y.left=void 0,y.mid=void 0,y.right=void 0):y.value=void 0;o.length>0&&y.isEmpty();){let[F,R]=o.pop();switch(F){case 1:R.left=void 0;break;case 0:R.mid=void 0;break;case-1:R.right=void 0;break}y=R}break}}}findSubstr(i){const n=this._iter.reset(i);let r=this._root,o;for(;r;){const y=n.cmp(r.segment);if(y>0)r=r.left;else if(y<0)r=r.right;else if(n.hasNext())n.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(i){const n=this._iter.reset(i);let r=this._root;for(;r;){const o=n.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(n.hasNext())n.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(i){for(const[n,r]of this)i(r,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=p;class O{constructor(i,n){this[b]="ResourceMap",i instanceof O?(this.map=new Map(i.map),this.toKey=n!=null?n:O.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:O.defaultToKey)}set(i,n){return this.map.set(this.toKey(i),n),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,n){typeof n!="undefined"&&(i=i.bind(n));for(let[r,o]of this.map)i(o,f.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield f.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[f.URI.parse(i[0]),i[1]]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[f.URI.parse(i[0]),i[1]]}}e.ResourceMap=O,O.defaultToKey=t=>t.toString();var T;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(T=e.Touch||(e.Touch={}));class d{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,n=0){const r=this._map.get(i);if(!!r)return n!==0&&this.touch(r,n),r.value}set(i,n,r=0){let o=this._map.get(i);if(o)o.value=n,r!==0&&this.touch(o,r);else{switch(o={key:i,value:n,next:void 0,previous:void 0},r){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this._map.get(i);if(!!n)return this._map.delete(i),this.removeItem(n),this._size--,n.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,n){const r=this._state;let o=this._head;for(;o;){if(n?i.bind(n)(o.value,o.key,this):i(o.value,o.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,n=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(r){const y={value:r.key,done:!1};return r=r.next,y}else return{value:void 0,done:!0}}};return o}values(){const i=this,n=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(r){const y={value:r.value,done:!1};return r=r.next,y}else return{value:void 0,done:!0}}};return o}entries(){const i=this,n=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(r){const y={value:[r.key,r.value],done:!1};return r=r.next,y}else return{value:void 0,done:!0}}};return o}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let n=this._head,r=this.size;for(;n&&r>i;)this._map.delete(n.key),n=n.next,r--;this._head=n,this._size=r,n&&(n.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const n=i.next,r=i.previous;if(!n||!r)throw new Error("Invalid list");n.previous=r,r.next=n}i.next=void 0,i.previous=void 0,this._state++}touch(i,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(i===this._head)return;const r=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(r.previous=o,o.next=r),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(n===2){if(i===this._tail)return;const r=i.next,o=i.previous;i===this._head?(r.previous=void 0,this._head=r):(r.previous=o,o.next=r),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((n,r)=>{i.push([r,n])}),i}fromJSON(i){this.clear();for(const[n,r]of i)this.set(n,r)}}e.LinkedMap=d;class l extends d{constructor(i,n=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,n=2){return super.get(i,n)}peek(i){return super.get(i,0)}set(i,n){return super.set(i,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class s{constructor(i){A.set(this,void 0),Ge(this,A,i,"f")}get size(){return ze(this,A,"f").size}forEach(i,n){ze(this,A,"f").forEach(i,n)}get(i){return ze(this,A,"f").get(i)}has(i){return ze(this,A,"f").has(i)}entries(){return ze(this,A,"f").entries()}keys(){return ze(this,A,"f").keys()}values(){return ze(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return ze(this,A,"f").entries()}}e.ReadonlyMapView=s}),define(J[93],Z([0,1,17,18,7]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function _(g){return JSON.stringify(g,C)}e.stringify=_;function A(g){let D=JSON.parse(g);return D=h(D),D}e.parse=A;function C(g,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,L.regExpFlags)(D)}:D}function h(g,D=0){if(!g||D>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return b.URI.revive(g);case 2:return new RegExp(g.source,g.flags)}if(g instanceof f.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let m=0;m<g.length;++m)g[m]=h(g[m],D+1);else for(const m in g)Object.hasOwnProperty.call(g,m)&&(g[m]=h(g[m],D+1))}return g}e.revive=h}),define(J[8],Z([0,1,7,3]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var b;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(b=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}set(h,g,D){this._hosts[h]=g,this._ports[h]=D}setConnectionToken(h,g){this._connectionTokens[h]=g}rewrite(h){if(this._delegate)return this._delegate(h);const g=h.authority;let D=this._hosts[g];D&&D.indexOf(":")!==-1&&(D=`[${D}]`);const m=this._connectionTokens[g];let v=`path=${encodeURIComponent(h.path)}`;return typeof m=="string"&&(v+=`&tkn=${encodeURIComponent(m)}`),f.URI.from({scheme:L.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:window.location.host,path:`${window.location.pathname.replace(/\/+$/,"")}/vscode-remote-resource`,query:v})}}e.RemoteAuthorities=new _;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(h,g,D){const m=this.toUri(h,g);return m.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(m):L.isNative&&(D||L.isPreferringBrowserCodeLoad)&&m.scheme===b.file?m.with({scheme:b.vscodeFileResource,authority:m.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):m}asFileUri(h,g){const D=this.toUri(h,g);return D.scheme===b.vscodeFileResource?D.with({scheme:b.file,authority:D.authority!==this.FALLBACK_AUTHORITY?D.authority:null,query:null,fragment:null}):D}toUri(h,g){return f.URI.isUri(h)?h:f.URI.parse(g.toUrl(h))}}e.FileAccess=new A}),define(J[63],Z([0,1,33]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const L=new f.LRUCache(1e4);function b(g){return h(g,"NFC",L)}e.normalizeNFC=b;const _=new f.LRUCache(1e4);function A(g){return h(g,"NFD",_)}e.normalizeNFD=A;const C=/[^\u0000-\u0080]/;function h(g,D,m){if(!e.canNormalize||!g)return g;const v=m.get(g);if(v)return v;let w;return C.test(g)?w=g.normalize(D):w=g,m.set(g,w),w}e.removeAccents=function(){if(e.canNormalize){const g=/[\u0300-\u036f]/g;return function(D){return A(D).replace(g,"")}}else return function(g){return g}}()}),define(J[15],Z([0,1,35,4,7,18,8,3]),function(q,e,f,L,b,_,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(w){return(0,b.uriToFsPath)(w,!0)}e.originalFSPath=h;class g{constructor(a){this._ignorePathCasing=a}compare(a,c,p=!1){return a===c?0:(0,_.compare)(this.getComparisonKey(a,p),this.getComparisonKey(c,p))}isEqual(a,c,p=!1){return a===c?!0:!a||!c?!1:this.getComparisonKey(a,p)===this.getComparisonKey(c,p)}getComparisonKey(a,c=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,c,p=!1){if(a.scheme===c.scheme){if(a.scheme===A.Schemas.file)return f.isEqualOrParent(h(a),h(c),this._ignorePathCasing(a))&&a.query===c.query&&(p||a.fragment===c.fragment);if((0,e.isEqualAuthority)(a.authority,c.authority))return f.isEqualOrParent(a.path,c.path,this._ignorePathCasing(a),"/")&&a.query===c.query&&(p||a.fragment===c.fragment)}return!1}joinPath(a,...c){return b.URI.joinPath(a,...c)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return L.posix.basename(a.path)}extname(a){return L.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let c;return a.scheme===A.Schemas.file?c=b.URI.file(L.dirname(h(a))).path:(c=L.posix.dirname(a.path),a.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),c="/")),a.with({path:c})}normalizePath(a){if(!a.path.length)return a;let c;return a.scheme===A.Schemas.file?c=b.URI.file(L.normalize(h(a))).path:c=L.posix.normalize(a.path),a.with({path:c})}relativePath(a,c){if(!(a.scheme!==c.scheme||!(0,e.isEqualAuthority)(a.authority,c.authority))){if(a.scheme===A.Schemas.file){const T=L.relative(h(a),h(c));return C.isWindows?f.toSlashes(T):T}let p=a.path||"/",O=c.path||"/";if(this._ignorePathCasing(a)){let T=0;for(const d=Math.min(p.length,O.length);T<d&&!(p.charCodeAt(T)!==O.charCodeAt(T)&&p.charAt(T).toLowerCase()!==O.charAt(T).toLowerCase());T++);p=O.substr(0,T)+p.substr(T)}return L.posix.relative(p,O)}}resolvePath(a,c){if(a.scheme===A.Schemas.file){const p=b.URI.file(L.resolve(h(a),c));return a.with({authority:p.authority,path:p.path})}return c.indexOf("/")===-1&&(c=f.toSlashes(c),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c)),a.with({path:L.posix.resolve(a.path,c)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,c){return a===c||(0,_.equalsIgnoreCase)(a,c)}hasTrailingPathSeparator(a,c=L.sep){if(a.scheme===A.Schemas.file){const p=h(a);return p.length>f.getRoot(p).length&&p[p.length-1]===c}else{const p=a.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,c=L.sep){return(0,e.hasTrailingPathSeparator)(a,c)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,c=L.sep){let p=!1;if(a.scheme===A.Schemas.file){const O=h(a);p=O!==void 0&&O.length===f.getRoot(O).length&&O[O.length-1]===c}else{c="/";const O=a.path;p=O.length===1&&O.charCodeAt(O.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(a,c)?a.with({path:a.path+"/"}):a}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(w=>w.scheme===A.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new g(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function D(w,a){const c=[];for(let p=0;p<w.length;p++){const O=a(w[p]);w.some((T,d)=>d===p?!1:(0,e.isEqualOrParent)(O,a(T)))||c.push(w[p])}return c}e.distinctParents=D;var m;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function a(c){const p=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(d=>{const[l,s]=d.split(":");l&&s&&p.set(l,s)});const T=c.path.substring(0,c.path.indexOf(";"));return T&&p.set(w.META_DATA_MIME,T),p}w.parseMetaData=a})(m=e.DataUri||(e.DataUri={}));function v(w,a,c){if(a){let p=w.path;return p&&p[0]!==L.posix.sep&&(p=L.posix.sep+p),w.with({scheme:c,authority:a,path:p})}return w.with({scheme:c})}e.toLocalResource=v}),define(J[13],Z([0,1,27,11,5,2,62,15]),function(q,e,f,L,b,_,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(U){return!!U&&typeof U.then=="function"}e.isThenable=h;function g(U){const S=new f.CancellationTokenSource,I=U(S.token),N=new Promise((M,$)=>{S.token.onCancellationRequested(()=>{$((0,L.canceled)())}),Promise.resolve(I).then(V=>{S.dispose(),M(V)},V=>{S.dispose(),$(V)})});return new class{cancel(){S.cancel()}then(M,$){return N.then(M,$)}catch(M){return this.then(void 0,M)}finally(M){return N.finally(M)}}}e.createCancelablePromise=g;function D(U,S,I){return Promise.race([U,new Promise(N=>S.onCancellationRequested(()=>N(I)))])}e.raceCancellation=D;async function m(U){let S=-1;const I=U.map((M,$)=>M.then(V=>(S=$,V))),N=await Promise.race(I);return U.forEach((M,$)=>{$!==S&&M.cancel()}),N}e.raceCancellablePromises=m;function v(U,S,I){let N;const M=setTimeout(()=>{N==null||N(void 0),I==null||I()},S);return Promise.race([U.finally(()=>clearTimeout(M)),new Promise($=>N=$)])}e.raceTimeout=v;function w(U){return new Promise((S,I)=>{const N=U();h(N)?N.then(S,I):S(N)})}e.asPromise=w;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(S){if(this.activePromise){if(this.queuedPromiseFactory=S,!this.queuedPromise){const I=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(I,I).then(N)})}return new Promise((I,N)=>{this.queuedPromise.then(I,N)})}return this.activePromise=S(),new Promise((I,N)=>{this.activePromise.then(M=>{this.activePromise=null,I(M)},M=>{this.activePromise=null,N(M)})})}}e.Throttler=a;class c{constructor(){this.current=Promise.resolve(null)}queue(S){return this.current=this.current.then(()=>S(),()=>S())}}e.Sequencer=c;class p{constructor(){this.promiseMap=new Map}queue(S,I){var N;const $=((N=this.promiseMap.get(S))!==null&&N!==void 0?N:Promise.resolve()).catch(()=>{}).then(I).finally(()=>{this.promiseMap.get(S)===$&&this.promiseMap.delete(S)});return this.promiseMap.set(S,$),$}}e.SequencerByKey=p;class O{constructor(S){this.defaultDelay=S,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(S,I=this.defaultDelay){return this.task=S,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,M)=>{this.doResolve=N,this.doReject=M}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},I),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=O;class T{constructor(S){this.delayer=new O(S),this.throttler=new a}trigger(S,I){return this.delayer.trigger(()=>this.throttler.queue(S),I)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=T;class d{constructor(){this._isOpen=!1,this._promise=new Promise((S,I)=>{this._completePromise=S})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class l extends d{constructor(S){super();this._timeout=setTimeout(()=>this.open(),S)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function s(U,S){return S?new Promise((I,N)=>{const M=setTimeout(I,U);S.onCancellationRequested(()=>{clearTimeout(M),N((0,L.canceled)())})}):g(I=>s(U,I))}e.timeout=s;function t(U,S=0){const I=setTimeout(U,S);return(0,_.toDisposable)(()=>clearTimeout(I))}e.disposableTimeout=t;function i(U){return U.then(void 0,S=>{})}e.ignoreErrors=i;function n(U){const S=[];let I=0;const N=U.length;function M(){return I<N?U[I++]():null}function $(V){V!=null&&S.push(V);const G=M();return G?G.then($):Promise.resolve(S)}return Promise.resolve(null).then($)}e.sequence=n;function r(U,S=N=>!!N,I=null){let N=0;const M=U.length,$=()=>{if(N>=M)return Promise.resolve(I);const V=U[N++];return Promise.resolve(V()).then(K=>S(K)?Promise.resolve(K):$())};return $()}e.first=r;function o(U,S=N=>!!N,I=null){if(U.length===0)return Promise.resolve(I);let N=U.length;const M=()=>{var $,V;N=-1;for(const G of U)(V=($=G).cancel)===null||V===void 0||V.call($)};return new Promise(($,V)=>{for(const G of U)G.then(K=>{--N>=0&&S(K)?(M(),$(K)):N===0&&$(I)}).catch(K=>{--N>=0&&(M(),V(K))})})}e.firstParallel=o;class y{constructor(S){this._size=0,this.maxDegreeOfParalellism=S,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new b.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(S){return this._size++,new Promise((I,N)=>{this.outstandingPromises.push({factory:S,c:I,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const S=this.outstandingPromises.shift();this.runningPromises++;const I=S.factory();I.then(S.c,S.e),I.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=y;class E extends y{constructor(){super(1)}}e.Queue=E;class F{constructor(){this.queues=new Map}queueFor(S,I=C.extUri){const N=I.getComparisonKey(S);let M=this.queues.get(N);return M||(M=new E,b.Event.once(M.onFinished)(()=>{M==null||M.dispose(),this.queues.delete(N)}),this.queues.set(N,M)),M}dispose(){this.queues.forEach(S=>S.dispose()),this.queues.clear()}}e.ResourceQueue=F;class R{constructor(S,I){this._token=-1,typeof S=="function"&&typeof I=="number"&&this.setIfNotSet(S,I)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(S,I){this.cancel(),this._token=setTimeout(()=>{this._token=-1,S()},I)}setIfNotSet(S,I){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,S()},I))}}e.TimeoutTimer=R;class u{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(S,I){this.cancel(),this._token=setInterval(()=>{S()},I)}}e.IntervalTimer=u;class P{constructor(S,I){this.timeoutToken=-1,this.runner=S,this.timeout=I,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(S=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,S)}get delay(){return this.timeout}set delay(S){this.timeout=S}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class k extends P{constructor(S,I){super(S,I);this.units=[]}work(S){this.units.push(S),this.isScheduled()||this.schedule()}doRun(){const S=this.units;this.units=[],this.runner&&this.runner(S)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=k,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const U=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=S=>{const I=setTimeout(()=>S(U));let N=!1;return{dispose(){N||(N=!0,clearTimeout(I))}}}}else e.runWhenIdle=(U,S)=>{const I=requestIdleCallback(U,typeof S=="number"?{timeout:S}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(I))}}}}();class W{constructor(S){this._didRun=!1,this._executor=()=>{try{this._value=S()}catch(I){this._error=I}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=W;async function Q(U,S,I){let N;for(let M=0;M<I;M++)try{return await U()}catch($){N=$,await s(S)}throw N}e.retry=Q;class z{hasPending(S){return this._pending?typeof S=="number"?this._pending.taskId===S:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var S;(S=this._pending)===null||S===void 0||S.cancel()}setPending(S,I,N){return this._pending={taskId:S,cancel:()=>N==null?void 0:N(),promise:I},I.then(()=>this.donePending(S),()=>this.donePending(S)),I}donePending(S){this._pending&&S===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const S=this._next;this._next=void 0,S.run().then(S.promiseResolve,S.promiseReject)}}setNext(S){if(this._next)this._next.run=S;else{let I,N;const M=new Promise(($,V)=>{I=$,N=V});this._next={run:S,promise:M,promiseResolve:I,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=z;class H{constructor(S){this.interval=S,this.lastIncrementTime=0,this.value=0}increment(){const S=Date.now();return S-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=S,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class Y{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((S,I)=>{this.completeCallback=S,this.errorCallback=I})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(S){return new Promise(I=>{this.completeCallback(S),this.resolved=!0,I()})}error(S){return new Promise(I=>{this.errorCallback(S),this.rejected=!0,I()})}cancel(){new Promise(S=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,S()})}}e.DeferredPromise=Y;class B extends b.Emitter{async fireAsync(S,I,N){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const M of this._listeners)this._asyncDeliveryQueue.push([M,S]);for(;this._asyncDeliveryQueue.size>0&&!I.isCancellationRequested;){const[M,$]=this._asyncDeliveryQueue.shift(),V=[],G=Object.assign(Object.assign({},$),{waitUntil:K=>{if(Object.isFrozen(V))throw new Error("waitUntil can NOT be called asynchronous");N&&(K=N(K,typeof M=="function"?M:M[0])),V.push(K)}});try{typeof M=="function"?M.call(void 0,G):M[0].call(M[1],G)}catch(K){(0,L.onUnexpectedError)(K);continue}Object.freeze(V),await x.settled(V).catch(K=>(0,L.onUnexpectedError)(K))}}}}e.AsyncEmitter=B;var x;(function(U){async function S($){return typeof Promise.allSettled=="function"?I($):N($)}U.allSettled=S;async function I($){return Promise.allSettled($)}async function N($){return Promise.all($.map(V=>V.then(G=>({status:"fulfilled",value:G}),G=>({status:"rejected",reason:G}))))}async function M($){let V;const G=await Promise.all($.map(K=>K.then(te=>te,te=>{V||(V=te)})));if(typeof V!="undefined")throw V;return G}U.settled=M})(x=e.Promises||(e.Promises={}))}),define(J[94],Z([0,1,18,35,4,33,13]),function(q,e,f,L,b,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const h="**",g="/",D="[/\\\\]",m="[^/\\\\]",v=/\//g;function w(I){switch(I){case 0:return"";case 1:return`${m}*?`;default:return`(?:${D}|${m}+${D}|${D}${m}+)*?`}}function a(I,N){if(!I)return[];const M=[];let $=!1,V=!1,G="";for(const K of I){switch(K){case N:if(!$&&!V){M.push(G),G="";continue}break;case"{":$=!0;break;case"}":$=!1;break;case"[":V=!0;break;case"]":V=!1;break}G+=K}return G&&M.push(G),M}e.splitGlobAware=a;function c(I){if(!I)return"";let N="";const M=a(I,g);if(M.every($=>$===h))N=".*";else{let $=!1;M.forEach((V,G)=>{if(V===h){$||(N+=w(2),$=!0);return}let K=!1,te="",se=!1,oe="";for(const ce of V){if(ce!=="}"&&K){te+=ce;continue}if(se&&(ce!=="]"||!oe)){let ue;ce==="-"?ue=ce:(ce==="^"||ce==="!")&&!oe?ue="^":ce===g?ue="":ue=f.escapeRegExpCharacters(ce),oe+=ue;continue}switch(ce){case"{":K=!0;continue;case"[":se=!0;continue;case"}":N+=`(?:${a(te,",").map(_e=>c(_e)).join("|")})`,K=!1,te="";break;case"]":N+="["+oe+"]",se=!1,oe="";break;case"?":N+=m;continue;case"*":N+=w(1);continue;default:N+=f.escapeRegExpCharacters(ce)}}G<M.length-1&&(M[G+1]!==h||G+2<M.length)&&(N+=D),$=!1})}return N}const p=/^\*\*\/\*\.[\w\.-]+$/,O=/^\*\*\/([\w\.-]+)\/?$/,T=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new _.LRUCache(1e4),i=function(){return!1},n=function(){return null};function r(I,N){if(!I)return n;let M;typeof I!="string"?M=I.pattern:M=I,M=M.trim();const $=`${M}_${!!N.trimForExclusions}`;let V=t.get($);if(V)return o(V,I);let G;if(p.test(M)){const K=M.substr(4);V=function(te,se){return typeof te=="string"&&te.endsWith(K)?M:null}}else(G=O.exec(y(M,N)))?V=E(G[1],M):(N.trimForExclusions?d:T).test(M)?V=F(M,N):(G=l.exec(y(M,N)))?V=R(G[1].substr(1),M,!0):(G=s.exec(y(M,N)))?V=R(G[1],M,!1):V=u(M);return t.set($,V),o(V,I)}function o(I,N){return typeof N=="string"?I:function(M,$){return L.isEqualOrParent(M,N.base)?I(b.relative(N.base,M),$):null}}function y(I,N){return N.trimForExclusions&&I.endsWith("/**")?I.substr(0,I.length-2):I}function E(I,N){const M=`/${I}`,$=`\\${I}`,V=function(K,te){return typeof K!="string"?null:te?te===I?N:null:K===I||K.endsWith(M)||K.endsWith($)?N:null},G=[I];return V.basenames=G,V.patterns=[N],V.allBasenames=G,V}function F(I,N){const M=S(I.slice(1,-1).split(",").map(te=>r(te,N)).filter(te=>te!==n),I),$=M.length;if(!$)return n;if($===1)return M[0];const V=function(te,se){for(let oe=0,ce=M.length;oe<ce;oe++)if(M[oe](te,se))return I;return null},G=M.find(te=>!!te.allBasenames);G&&(V.allBasenames=G.allBasenames);const K=M.reduce((te,se)=>se.allPaths?te.concat(se.allPaths):te,[]);return K.length&&(V.allPaths=K),V}function R(I,N,M){const $=b.sep===b.posix.sep,V=$?I:I.replace(v,b.sep),G=b.sep+V,K=b.posix.sep+I,te=M?function(se,oe){return typeof se=="string"&&(se===V||se.endsWith(G)||!$&&(se===I||se.endsWith(K)))?N:null}:function(se,oe){return typeof se=="string"&&(se===V||!$&&se===I)?N:null};return te.allPaths=[(M?"*/":"./")+I],te}function u(I){try{const N=new RegExp(`^${c(I)}$`);return function(M){return N.lastIndex=0,typeof M=="string"&&N.test(M)?I:null}}catch(N){return n}}function P(I,N,M){return!I||typeof N!="string"?!1:k(I)(N,void 0,M)}e.match=P;function k(I,N={}){if(!I)return i;if(typeof I=="string"||H(I)){const M=r(I,N);if(M===n)return i;const $=function(V,G){return!!M(V,G)};return M.allBasenames&&($.allBasenames=M.allBasenames),M.allPaths&&($.allPaths=M.allPaths),$}return x(I,N)}e.parse=k;function W(I){if(!!I){let N;return M=>(N||(N=(I()||Promise.resolve([])).then($=>$?z($):{})),N.then($=>!!$[M]))}}e.hasSiblingPromiseFn=W;function Q(I){if(!!I){let N;return M=>{if(!N){const $=I();N=$?z($):{}}return!!N[M]}}}e.hasSiblingFn=Q;function z(I){const N={};for(const M of I)N[M]=!0;return N}function H(I){const N=I;return N&&typeof N.base=="string"&&typeof N.pattern=="string"}e.isRelativePattern=H;function Y(I){return I.allBasenames||[]}e.getBasenameTerms=Y;function B(I){return I.allPaths||[]}e.getPathTerms=B;function x(I,N){const M=S(Object.getOwnPropertyNames(I).map(te=>U(te,I[te],N)).filter(te=>te!==n)),$=M.length;if(!$)return n;if(!M.some(te=>!!te.requiresSiblings)){if($===1)return M[0];const te=function(ce,ue){for(let Se=0,_e=M.length;Se<_e;Se++){const Oe=M[Se](ce,ue);if(Oe)return Oe}return null},se=M.find(ce=>!!ce.allBasenames);se&&(te.allBasenames=se.allBasenames);const oe=M.reduce((ce,ue)=>ue.allPaths?ce.concat(ue.allPaths):ce,[]);return oe.length&&(te.allPaths=oe),te}const V=function(te,se,oe){let ce;for(let ue=0,Se=M.length;ue<Se;ue++){const _e=M[ue];_e.requiresSiblings&&oe&&(se||(se=b.basename(te)),ce||(ce=se.substr(0,se.length-b.extname(te).length)));const Oe=_e(te,se,ce,oe);if(Oe)return Oe}return null},G=M.find(te=>!!te.allBasenames);G&&(V.allBasenames=G.allBasenames);const K=M.reduce((te,se)=>se.allPaths?te.concat(se.allPaths):te,[]);return K.length&&(V.allPaths=K),V}function U(I,N,M){if(N===!1)return n;const $=r(I,M);if($===n)return n;if(typeof N=="boolean")return $;if(N){const V=N.when;if(typeof V=="string"){const G=(K,te,se,oe)=>{if(!oe||!$(K,te))return null;const ce=V.replace("$(basename)",se),ue=oe(ce);return(0,A.isThenable)(ue)?ue.then(Se=>Se?I:null):ue?I:null};return G.requiresSiblings=!0,G}}return $}function S(I,N){const M=I.filter(te=>!!te.basenames);if(M.length<2)return I;const $=M.reduce((te,se)=>{const oe=se.basenames;return oe?te.concat(oe):te},[]);let V;if(N){V=[];for(let te=0,se=$.length;te<se;te++)V.push(N)}else V=M.reduce((te,se)=>{const oe=se.patterns;return oe?te.concat(oe):te},[]);const G=function(te,se){if(typeof te!="string")return null;if(!se){let ce;for(ce=te.length;ce>0;ce--){const ue=te.charCodeAt(ce-1);if(ue===47||ue===92)break}se=te.substr(ce)}const oe=$.indexOf(se);return oe!==-1?V[oe]:null};G.basenames=$,G.patterns=V,G.allBasenames=$;const K=I.filter(te=>!te.basenames);return K.push(G),K}}),define(J[64],Z([0,1,7,4,18,8,3,15,35]),function(q,e,f,L,b,_,A,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function g(r,o,y){if(typeof r=="string"&&(r=f.URI.file(r)),y){const F=y.getWorkspaceFolder(r);if(F){const R=y.getWorkspace().folders.length>1;let u;if((0,C.isEqual)(F.uri,r)?u="":u=(0,C.relativePath)(F.uri,r),R){const P=F.name?F.name:(0,C.basename)(F.uri);u=u?P+" \u2022 "+u:P}return u}}if(r.scheme!==_.Schemas.file&&r.scheme!==_.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(r.fsPath))return(0,L.normalize)(m(r.fsPath));let E=(0,L.normalize)(r.fsPath);return!A.isWindows&&(o==null?void 0:o.userHome)&&(E=w(E,o.userHome.fsPath)),E}e.getPathLabel=g;function D(r){if(!!r){typeof r=="string"&&(r=f.URI.file(r));const o=(0,C.basename)(r)||(r.scheme===_.Schemas.file?r.fsPath:r.path);return A.isWindows&&(0,h.isRootOrDriveLetter)(o)?m(o):o}}e.getBaseLabel=D;function m(r){return(0,h.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=m;let v=Object.create(null);function w(r,o){if(A.isWindows||!r||!o)return r;let y=v.original===o?v.normalized:void 0;return y||(y=`${(0,b.rtrim)(o,L.posix.sep)}${L.posix.sep}`,v={original:o,normalized:y}),(A.isLinux?r.startsWith(y):(0,b.startsWithIgnoreCase)(r,y))&&(r=`~/${r.substr(y.length)}`),r}e.tildify=w;function a(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=a;const c="\u2026",p="\\\\",O="~";function T(r,o=L.sep){const y=new Array(r.length);let E=!1;for(let F=0;F<r.length;F++){let R=r[F];if(R===""){y[F]=`.${o}`;continue}if(!R){y[F]=R;continue}E=!0;let u="";R.indexOf(p)===0?(u=R.substr(0,R.indexOf(p)+p.length),R=R.substr(R.indexOf(p)+p.length)):R.indexOf(o)===0?(u=R.substr(0,R.indexOf(o)+o.length),R=R.substr(R.indexOf(o)+o.length)):R.indexOf(O)===0&&(u=R.substr(0,R.indexOf(O)+O.length),R=R.substr(R.indexOf(O)+O.length));const P=R.split(o);for(let k=1;E&&k<=P.length;k++)for(let W=P.length-k;E&&W>=0;W--){E=!1;let Q=P.slice(W,W+k).join(o);for(let z=0;!E&&z<r.length;z++)if(z!==F&&r[z]&&r[z].indexOf(Q)>-1){const H=W+k===P.length,Y=W>0&&r[z].indexOf(o)>-1?o+Q:Q,B=r[z].endsWith(Y);E=!H||B}if(!E){let z="";(P[0].endsWith(":")||u!=="")&&(W===1&&(W=0,k++,Q=P[0]+o+Q),W>0&&(z=P[0]+o),z=u+z),W>0&&(z=z+c+o),z=z+Q,W+k<P.length&&(z=z+o+c),y[F]=z}}E&&(y[F]=R)}return y}e.shorten=T;var d;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function l(r,o=Object.create(null)){const y=[];let E=!1,F="";for(const R of r)if(R==="$"||E&&R==="{")F&&y.push({value:F,type:d.TEXT}),F="",E=!0;else if(R==="}"&&E){const u=o[F];if(typeof u=="string")u.length&&y.push({value:u,type:d.VARIABLE});else if(u){const P=y[y.length-1];(!P||P.type!==d.SEPARATOR)&&y.push({value:u.label,type:d.SEPARATOR})}F="",E=!1}else F+=R;return F&&!E&&y.push({value:F,type:d.TEXT}),y.filter((R,u)=>{if(R.type===d.SEPARATOR){const P=y[u-1],k=y[u+1];return[P,k].every(W=>W&&(W.type===d.VARIABLE||W.type===d.TEXT)&&W.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=l;function s(r,o){return A.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):r.replace(/&&|&/g,y=>y==="&"?"&&":"&")}e.mnemonicMenuLabel=s;function t(r,o){return A.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):A.isWindows?r.replace(/&&|&/g,y=>y==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function n(r){const o=r.indexOf("/")!==-1?L.posix:L.win32,y=o.basename(r),E=o.dirname(r);return y.length?{name:y,parentPath:E}:{name:E,parentPath:""}}e.splitName=n}),define(J[48],Z([0,1,7,8]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function b(m){return m.toJSON()}class _{constructor(v){this.remoteAuthority=v}transformIncoming(v){return v.scheme===L.Schemas.vscodeRemote?b(f.URI.file(v.path)):v}transformOutgoing(v){return v.scheme===L.Schemas.file?b(f.URI.from({authority:this.remoteAuthority,scheme:L.Schemas.vscodeRemote,path:v.path})):v}transformOutgoingURI(v){return v.scheme===L.Schemas.file?f.URI.from({authority:this.remoteAuthority,scheme:L.Schemas.vscodeRemote,path:v.path}):v}transformOutgoingScheme(v){return v===L.Schemas.file?L.Schemas.vscodeRemote:v}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function A(m,v,w){if(!m||w>200)return null;if(typeof m=="object"){if(m instanceof f.URI)return v.transformOutgoing(m);for(let a in m)if(Object.hasOwnProperty.call(m,a)){const c=A(m[a],v,w+1);c!==null&&(m[a]=c)}}return null}function C(m,v){const w=A(m,v,0);return w===null?m:w}e.transformOutgoingURIs=C;function h(m,v,w,a){if(!m||a>200)return null;if(typeof m=="object"){if(m.$mid===1)return w?f.URI.revive(v.transformIncoming(m)):v.transformIncoming(m);for(let c in m)if(Object.hasOwnProperty.call(m,c)){const p=h(m[c],v,w,a+1);p!==null&&(m[c]=p)}}return null}function g(m,v){const w=h(m,v,!1,0);return w===null?m:w}e.transformIncomingURIs=g;function D(m,v){const w=h(m,v,!0,0);return w===null?m:w}e.transformAndReviveIncomingURIs=D}),define(J[24],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const f=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(h){return f.test(h)}e.isUUID=L;const b=new Uint8Array(16),_=[];for(let h=0;h<256;h++)_.push(h.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(h){for(let g=0;g<h.length;g++)h[g]=Math.floor(Math.random()*256);return h};function C(){A(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let h=0,g="";return g+=_[b[h++]],g+=_[b[h++]],g+=_[b[h++]],g+=_[b[h++]],g+="-",g+=_[b[h++]],g+=_[b[h++]],g+="-",g+=_[b[h++]],g+=_[b[h++]],g+="-",g+=_[b[h++]],g+=_[b[h++]],g+="-",g+=_[b[h++]],g+=_[b[h++]],g+=_[b[h++]],g+=_[b[h++]],g+=_[b[h++]],g+=_[b[h++]],g}e.generateUuid=C}),define(J[65],Z([0,1,203]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(_="utf8"){this.stringDecoder=new f.StringDecoder(_),this.remaining=null}write(_){const A=[],C=this.remaining?this.remaining+this.stringDecoder.write(_):this.stringDecoder.write(_);if(C.length<1)return A;let h=0,g,D=h;for(;D<C.length;)if(g=C.charCodeAt(D),g===13||g===10){if(A.push(C.substring(h,D)),D++,D<C.length){const m=g;g=C.charCodeAt(D),(m===13&&g===10||m===10&&g===13)&&D++}h=D}else D++;return this.remaining=h<C.length?C.substr(h):null,A}end(){return this.remaining}}e.LineDecoder=L}),function(){"use strict";function q(e,f,L,b){function _(a){return new Promise(c=>L.exists(a,c))}function A(a){return new Promise((c,p)=>{const O=new Date;L.utimes(a,O,O,T=>T?p(T):c())})}function C(a){return new Promise((c,p)=>L.mkdir(a,{recursive:!0},O=>O&&O.code!=="EEXIST"?p(O):c(a)))}function h(a){return new Promise((c,p)=>L.rmdir(a,{recursive:!0},O=>O&&O.code!=="ENOENT"?p(O):c()))}function g(a){return new Promise((c,p)=>L.readFile(a,"utf8",(O,T)=>O?p(O):c(T)))}function D(a,c){return new Promise((p,O)=>L.writeFile(a,c,"utf8",T=>T?O(T):p()))}function m(a){const c=f.join(a,"languagepacks.json");try{return JSON.parse(L.readFileSync(c,"utf8"))}catch(p){}}function v(a,c){try{for(;c;){if(a[c])return c;{const p=c.lastIndexOf("-");if(p>0)c=c.substring(0,p);else return}}}catch(p){console.error("Resolving language pack configuration failed.",p)}}function w(a,c,p,O){if(O==="pseudo")return Promise.resolve({locale:O,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:O,availableLanguages:{}});if(O&&(O==="en"||O==="en-us"))return Promise.resolve({locale:O,availableLanguages:{}});const T=O;b.mark("code/willGenerateNls");const d=function(l){return b.mark("code/didGenerateNls"),Promise.resolve({locale:l,availableLanguages:{}})};try{if(!a)return d(T);const l=m(c);if(!l||(O=v(l,O),!O))return d(T);const s=l[O];let t;return!s||typeof s.hash!="string"||!s.translations||typeof(t=s.translations.vscode)!="string"?d(T):_(t).then(i=>{if(!i)return d(T);const n=s.hash+"."+O,r=f.join(c,"clp",n),o=f.join(r,a),y=f.join(r,"tcf.json"),E=f.join(r,"corrupted.info"),F={locale:T,availableLanguages:{"*":O},_languagePackId:n,_translationsConfigFile:y,_cacheRoot:r,_resolvedLanguagePackCoreLocation:o,_corruptedFile:E};return _(E).then(R=>{let u;return R?u=h(r):u=Promise.resolve(void 0),u.then(()=>_(o).then(P=>P?(A(o).catch(()=>{}),b.mark("code/didGenerateNls"),F):C(o).then(()=>Promise.all([g(p),g(t)])).then(k=>{const W=JSON.parse(k[0]),Q=JSON.parse(k[1]).contents,z=Object.keys(W.bundles),H=[];for(const Y of z){const B=W.bundles[Y],x=Object.create(null);for(const U of B){const S=W.keys[U],I=W.messages[U],N=Q[U];let M;if(N){M=[];for(let $=0;$<S.length;$++){const V=S[$],G=typeof V=="string"?V:V.key;let K=N[G];K===void 0&&(K=I[$]),M.push(K)}}else M=I;x[U]=M}H.push(D(f.join(o,Y.replace(/\//g,"!")+".nls.json"),JSON.stringify(x)))}return H.push(D(y,JSON.stringify(s.translations))),Promise.all(H)}).then(()=>(b.mark("code/didGenerateNls"),F)).catch(k=>(console.error("Generating translation files failed.",k),d(O)))))})})}catch(l){return console.error("Generating translation files failed.",l),d(O)}}return{getNLSConfiguration:w}}if(typeof define=="function")define(J[95],Z([0,36,16,96]),function(e,f,L,b){return q(e.__$__nodeRequire,f,L,b)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),f=require("fs"),L=require("../common/performance");module.exports=q(require,e,f,L)}else throw new Error("Unknown context")}(),define(J[97],Z([0,1,25]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function b(C){const h=C.replace(/\-/g,":").toLowerCase();return!L.has(h)}function _(){return new Promise(async(C,h)=>{const g=setTimeout(()=>h("Unable to retrieve mac address (timeout after 10s)"),1e4);try{C(await A())}catch(D){h(D)}finally{clearTimeout(g)}})}e.getMac=_;function A(){return new Promise((C,h)=>{try{const g=(0,f.networkInterfaces)();for(let D in g){const m=g[D];if(m){for(const{mac:v}of m)if(b(v))return C(v)}}h("Unable to retrieve mac address (unexpected format)")}catch(g){h(g)}})}}),define(J[98],Z([0,1,11,24,25,33,97]),function(q,e,f,L,b,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(D){return this._virtualMachineOUIs||(this._virtualMachineOUIs=_.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(D)}value(){if(this._value===void 0){let D=0,m=0;const v=(0,b.networkInterfaces)();for(let w in v){const a=v[w];if(a)for(const{mac:c,internal:p}of a)p||(m+=1,this._isVirtualMachineMacAdress(c.toUpperCase())&&(D+=1))}this._value=m>0?D/m:0}return this._value}};let C;async function h(){return C||(C=(async()=>await g()||L.generateUuid())()),C}e.getMachineId=h;async function g(){try{const D=await new Promise((v,w)=>{q(["crypto"],v,w)}),m=await(0,A.getMac)();return D.createHash("sha256").update(m,"utf8").digest("hex")}catch(D){f.onUnexpectedError(D);return}}}),define(J[19],Z([0,1,16,25,4,13,3,35,24,63,15,7]),function(q,e,f,L,b,_,A,C,h,g,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var v;(function(Y){Y[Y.UNLINK=0]="UNLINK",Y[Y.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function w(Y,B=v.UNLINK){if((0,C.isRootOrDriveLetter)(Y))throw new Error("rimraf - will refuse to recursively delete root");return B===v.UNLINK?c(Y):a(Y)}e.rimraf=w;async function a(Y){try{const B=(0,b.join)((0,L.tmpdir)(),(0,h.generateUuid)());try{await f.promises.rename(Y,B)}catch(x){return c(Y)}c(B).catch(x=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function c(Y){return f.promises.rmdir(Y,{recursive:!0,maxRetries:3})}function p(Y){if((0,C.isRootOrDriveLetter)(Y))throw new Error("rimraf - will refuse to recursively delete root");f.rmdirSync(Y,{recursive:!0})}e.rimrafSync=p;async function O(Y,B){return l(await(B?T(Y):f.promises.readdir(Y)))}e.readdir=O;async function T(Y){try{return await f.promises.readdir(Y,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const B=[],x=await O(Y);for(const U of x){let S=!1,I=!1,N=!1;try{const M=await f.promises.lstat((0,b.join)(Y,U));S=M.isFile(),I=M.isDirectory(),N=M.isSymbolicLink()}catch(M){console.warn("[node.js fs] unexpected error from lstat after readdir: ",M)}B.push({name:U,isFile:()=>S,isDirectory:()=>I,isSymbolicLink:()=>N})}return B}function d(Y){return l(f.readdirSync(Y))}e.readdirSync=d;function l(Y){return Y.map(B=>typeof B=="string"?A.isMacintosh?(0,g.normalizeNFC)(B):B:(B.name=A.isMacintosh?(0,g.normalizeNFC)(B.name):B.name,B))}async function s(Y){const B=await O(Y),x=[];for(const U of B)await i.existsDirectory((0,b.join)(Y,U))&&x.push(U);return x}e.readDirsInDir=s;function t(Y,B=1e3){return new Promise(x=>{let U=!1;const S=setInterval(()=>{U||(U=!0,f.access(Y,I=>{U=!1,I&&(clearInterval(S),x(void 0))}))},B)})}e.whenDeleted=t;var i;(function(Y){async function B(S){let I;try{if(I=await f.promises.lstat(S),!I.isSymbolicLink())return{stat:I}}catch(N){}try{return{stat:await f.promises.stat(S),symbolicLink:(I==null?void 0:I.isSymbolicLink())?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&I)return{stat:I,symbolicLink:{dangling:!0}};if(A.isWindows&&N.code==="EACCES")try{return{stat:await f.promises.stat(await f.promises.readlink(S)),symbolicLink:{dangling:!1}}}catch(M){if(M.code==="ENOENT"&&I)return{stat:I,symbolicLink:{dangling:!0}};throw M}throw N}}Y.stat=B;async function x(S){try{const{stat:I,symbolicLink:N}=await Y.stat(S);return I.isFile()&&(N==null?void 0:N.dangling)!==!0}catch(I){}return!1}Y.existsFile=x;async function U(S){try{const{stat:I,symbolicLink:N}=await Y.stat(S);return I.isDirectory()&&(N==null?void 0:N.dangling)!==!0}catch(I){}return!1}Y.existsDirectory=U})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new _.ResourceQueue;function r(Y,B,x){return n.queueFor(m.URI.file(Y),D.extUriBiasedIgnorePathCase).queue(()=>{const U=F(x);return new Promise((S,I)=>y(Y,B,U,N=>N?I(N):S()))})}e.writeFile=r;let o=!0;function y(Y,B,x,U){if(!o)return f.writeFile(Y,B,{mode:x.mode,flag:x.flag},U);f.open(Y,x.flag,x.mode,(S,I)=>{if(S)return U(S);f.writeFile(I,B,N=>{if(N)return f.close(I,()=>U(N));f.fdatasync(I,M=>(M&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",M),o=!1),f.close(I,$=>U($))))})})}function E(Y,B,x){const U=F(x);if(!o)return f.writeFileSync(Y,B,{mode:U.mode,flag:U.flag});const S=f.openSync(Y,U.flag,U.mode);try{f.writeFileSync(S,B);try{f.fdatasyncSync(S)}catch(I){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",I),o=!1}}finally{f.closeSync(S)}}e.writeFileSync=E;function F(Y){return Y?{mode:typeof Y.mode=="number"?Y.mode:438,flag:typeof Y.flag=="string"?Y.flag:"w"}:{mode:438,flag:"w"}}async function R(Y,B){if(Y!==B){async function x(U){try{const S=await f.promises.lstat(U);if(S.isDirectory()||S.isSymbolicLink())return;const I=await f.promises.open(U,"a");try{await I.utimes(S.atime,new Date)}finally{await I.close()}}catch(S){}}try{await f.promises.rename(Y,B),await x(B)}catch(U){if(Y.toLowerCase()!==B.toLowerCase()&&U.code==="EXDEV"||Y.endsWith("."))await u(Y,B,{preserveSymlinks:!1}),await w(Y,v.MOVE),await x(B);else throw U}}}e.move=R;async function u(Y,B,x){return k(Y,B,{root:{source:Y,target:B},options:x,handledSourcePaths:new Set})}e.copy=u;const P=511;async function k(Y,B,x){if(!x.handledSourcePaths.has(Y)){x.handledSourcePaths.add(Y);const{stat:U,symbolicLink:S}=await i.stat(Y);if(S){if(x.options.preserveSymlinks)try{return await z(Y,B,x)}catch(I){console.warn("[node.js fs] copy of symlink failed: ",I)}if(S.dangling)return}return U.isDirectory()?W(Y,B,U.mode&P,x):Q(Y,B,U.mode&P)}}async function W(Y,B,x,U){await f.promises.mkdir(B,{recursive:!0,mode:x});const S=await O(Y);for(const I of S)await k((0,b.join)(Y,I),(0,b.join)(B,I),U)}async function Q(Y,B,x){await f.promises.copyFile(Y,B),await f.promises.chmod(B,x)}async function z(Y,B,x){let U=await f.promises.readlink(Y);(0,C.isEqualOrParent)(U,x.root.source,!A.isLinux)&&(U=(0,b.join)(x.root.target,U.substr(x.root.source.length+1))),await f.promises.symlink(U,B)}async function H(Y){try{return await f.promises.access(Y),!0}catch(B){return!1}}e.exists=H}),define(J[99],Z([0,1,16,49,18,4,19]),function(q,e,f,L,b,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function C(m){const v=(0,_.dirname)(m);if(m===v)return m;const w=((0,_.basename)(m)||m).toLowerCase();try{const c=(0,A.readdirSync)(v).filter(p=>p.toLowerCase()===w);if(c.length===1){const p=C(v);if(p)return(0,_.join)(p,c[0])}else if(c.length>1){const p=c.indexOf(w);if(p>=0){const O=C(v);if(O)return(0,_.join)(O,c[p])}}}catch(a){}return null}e.realcaseSync=C;async function h(m){try{return await(0,L.promisify)(f.realpath)(m)}catch(v){const w=D(m);return await f.promises.access(w,f.constants.R_OK),w}}e.realpath=h;function g(m){try{return f.realpathSync(m)}catch(v){const w=D(m);return f.accessSync(w,f.constants.R_OK),w}}e.realpathSync=g;function D(m){return(0,b.rtrim)((0,_.normalize)(m),_.sep)}});var Te=this&&this.__await||function(q){return this instanceof Te?(this.v=q,this):new Te(q)},$e=this&&this.__asyncGenerator||function(q,e,f){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var L=f.apply(q,e||[]),b,_=[];return b={},A("next"),A("throw"),A("return"),b[Symbol.asyncIterator]=function(){return this},b;function A(v){L[v]&&(b[v]=function(w){return new Promise(function(a,c){_.push([v,w,a,c])>1||C(v,w)})})}function C(v,w){try{h(L[v](w))}catch(a){m(_[0][3],a)}}function h(v){v.value instanceof Te?Promise.resolve(v.value.v).then(g,D):m(_[0][2],v)}function g(v){C("next",v)}function D(v){C("throw",v)}function m(v,w){v(w),_.shift(),_.length&&C(_[0][0],_[0][1])}},Ve=this&&this.__asyncValues||function(q){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=q[Symbol.asyncIterator],f;return e?e.call(q):(q=typeof __values=="function"?__values(q):q[Symbol.iterator](),f={},L("next"),L("throw"),L("return"),f[Symbol.asyncIterator]=function(){return this},f);function L(_){f[_]=q[_]&&function(A){return new Promise(function(C,h){A=q[_](A),b(C,h,A.done,A.value)})}}function b(_,A,C,h){Promise.resolve(h).then(function(g){_({value:g,done:C})},A)}};define(J[100],Z([0,1,19,25,4]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const _=/^\d+$/,A=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var h;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(h||(h={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class m{constructor(s,t,i){this.exePath=s,this.displayName=t,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await f.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:l=!1}={}){return l?g===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:l=!1,findPreview:s=!1}={}){const t=v({useAlternateBitness:l});if(!t)return null;const i=b.join(t,"PowerShell");if(!await f.SymlinkSupport.existsDirectory(i))return null;let n=-1,r=null;for(const E of await f.readdir(i)){let F=-1;if(s){const u=E.indexOf("-");if(u<0)continue;const P=E.substring(0,u);if(!_.test(P)||E.substring(u+1)!=="preview")continue;F=parseInt(P,10)}else{if(!_.test(E))continue;F=parseInt(E,10)}if(!(F<=n)){const R=b.join(i,E,"pwsh.exe");!await f.SymlinkSupport.existsFile(R)||(r=R,n=F)}}if(!r)return null;const o=t.includes("x86")?" (x86)":"",y=s?" Preview":"";return new m(r,`PowerShell${y}${o}`,!0)}async function a({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const s=b.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await f.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=l?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const n of await f.readdir(s))if(t.test(n)){const r=b.join(s,n,"pwsh.exe");return new m(r,i)}return null}function c(){const l=b.join(L.homedir(),".dotnet","tools","pwsh.exe");return new m(l,".NET Core PowerShell Global Tool")}function p(){const l=b.join(process.env.windir,g===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new m(l,"Windows PowerShell",!0)}function O(){return $e(this,arguments,function*(){let s=yield Te(w());s&&(yield yield Te(s)),s=yield Te(w({useAlternateBitness:!0})),s&&(yield yield Te(s)),s=yield Te(a()),s&&(yield yield Te(s)),s=c(),s&&(yield yield Te(s)),s=yield Te(w({findPreview:!0})),s&&(yield yield Te(s)),s=yield Te(a({findPreview:!0})),s&&(yield yield Te(s)),s=yield Te(w({useAlternateBitness:!0,findPreview:!0})),s&&(yield yield Te(s)),s=p(),s&&(yield yield Te(s))})}function T(){return $e(this,arguments,function*(){var s,t;try{for(var i=Ve(O()),n;n=yield Te(i.next()),!n.done;){const r=n.value;(yield Te(r.exists()))&&(yield yield Te(r))}}catch(r){s={error:r}}finally{try{n&&!n.done&&(t=i.return)&&(yield Te(t.call(i)))}finally{if(s)throw s.error}}})}e.enumeratePowerShellInstallations=T;async function d(){var l,s;try{for(var t=Ve(T()),i;i=await t.next(),!i.done;)return i.value}catch(n){l={error:n}}finally{try{i&&!i.done&&(s=t.return)&&await s.call(t)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=d}),define(J[101],Z([0,1,39,204,205]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.monkeyPatch=void 0;function _(h){if(C()){const g=q("http"),D=q("https"),m=A(h);g.globalAgent=m,D.globalAgent=m}}e.monkeyPatch=_;function A(h){return h?new L:new L.default}function C(){let h=!1;const g=b.getProxyForUrl("http://example.com");g&&(h=!0,f.logger.debug(`using $HTTP_PROXY ${g}`));const D=b.getProxyForUrl("https://example.com");return D&&(h=!0,f.logger.debug(`using $HTTPS_PROXY ${D}`)),h}}),define(J[102],Z([0,1,4,16,3,63,2,19]),function(q,e,f,L,b,_,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function h(m,v,w){return D({path:m,isDirectory:!1},v,w)}e.watchFile=h;function g(m,v,w){return D({path:m,isDirectory:!0},v,w)}e.watchFolder=g,e.CHANGE_BUFFER_DELAY=100;function D(m,v,w){const a=(0,f.basename)(m.path),c=new Map;let p=!1,O=[(0,A.toDisposable)(()=>{c.forEach(T=>(0,A.dispose)(T)),c.clear()})];try{const T=(0,L.watch)(m.path);O.push((0,A.toDisposable)(()=>{T.removeAllListeners(),T.close()}));const d=new Set;m.isDirectory&&(0,C.readdir)(m.path).then(l=>l.forEach(s=>d.add(s))),T.on("error",(l,s)=>{p||w(`Failed to watch ${m.path} for changes using fs.watch() (${l}, ${s})`)}),T.on("change",(l,s)=>{if(!p){let t="";if(s&&(t=s.toString(),b.isMacintosh&&(t=(0,_.normalizeNFC)(t))),!(!t||l!=="change"&&l!=="rename")){const i=m.isDirectory?(0,f.join)(m.path,t):m.path;if(m.isDirectory)if(l==="rename"){const n=c.get(i);n&&(0,A.dispose)(n);const r=setTimeout(async()=>{c.delete(i);const o=await(0,C.exists)(i);if(!p){let y;o?d.has(t)?y="changed":(y="added",d.add(t)):(d.delete(t),y="deleted"),v(y,i)}},e.CHANGE_BUFFER_DELAY);c.set(i,(0,A.toDisposable)(()=>clearTimeout(r)))}else{let n;d.has(t)?n="changed":(n="added",d.add(t)),v(n,i)}else if(l==="rename"||t!==a){const n=setTimeout(async()=>{const r=await(0,C.exists)(i);p||(r?(v("changed",i),O=[D(m,v,w)]):v("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,A.dispose)(O),O=[(0,A.toDisposable)(()=>clearTimeout(n))]}else v("changed",i)}}})}catch(T){(0,C.exists)(m.path).then(d=>{d&&!p&&w(`Failed to watch ${m.path} for changes using fs.watch() (${T.toString()})`)})}return(0,A.toDisposable)(()=>{p=!0,O=(0,A.dispose)(O)})}}),define(J[34],Z([0,1,5,2,13,27,11,17,23,12,93,18]),function(q,e,f,L,b,_,A,C,h,g,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function w(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(a=e.ResponseType||(e.ResponseType={}));function c(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(p||(p={}));class O{constructor(S){this.buffer=S,this.pos=0}read(S){const I=this.buffer.slice(this.pos,this.pos+S);return this.pos+=I.byteLength,I}}class T{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(S){this.buffers.push(S)}}var d;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(d||(d={}));function l(U){const S=C.VSBuffer.alloc(4);return S.writeUInt32BE(U,0),S}function s(U){return U.read(4).readUInt32BE(0)}function t(U){const S=C.VSBuffer.alloc(1);return S.writeUInt8(U,0),S}const i={Undefined:t(d.Undefined),String:t(d.String),Buffer:t(d.Buffer),VSBuffer:t(d.VSBuffer),Array:t(d.Array),Object:t(d.Object)},n=typeof Buffer!="undefined";function r(U,S){if(typeof S=="undefined")U.write(i.Undefined);else if(typeof S=="string"){const I=C.VSBuffer.fromString(S);U.write(i.String),U.write(l(I.byteLength)),U.write(I)}else if(n&&Buffer.isBuffer(S)){const I=C.VSBuffer.wrap(S);U.write(i.Buffer),U.write(l(I.byteLength)),U.write(I)}else if(S instanceof C.VSBuffer)U.write(i.VSBuffer),U.write(l(S.byteLength)),U.write(S);else if(Array.isArray(S)){U.write(i.Array),U.write(l(S.length));for(const I of S)r(U,I)}else{const I=C.VSBuffer.fromString(JSON.stringify(S));U.write(i.Object),U.write(l(I.byteLength)),U.write(I)}}function o(U){switch(U.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return U.read(s(U)).toString();case d.Buffer:return U.read(s(U)).buffer;case d.VSBuffer:return U.read(s(U));case d.Array:{const I=s(U),N=[];for(let M=0;M<I;M++)N.push(o(U));return N}case d.Object:return JSON.parse(U.read(s(U)).toString())}}class y{constructor(S,I,N=null,M=1e3){this.protocol=S,this.ctx=I,this.logger=N,this.timeoutDelay=M,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:200})}registerChannel(S,I){this.channels.set(S,I),setTimeout(()=>this.flushPendingRequests(S),0)}sendResponse(S){switch(S.type){case 200:{const I=this.send([S.type]);this.logger&&this.logger.logOutgoing(I,0,1,c(S.type));return}case 201:case 202:case 204:case 203:{const I=this.send([S.type,S.id],S.data);this.logger&&this.logger.logOutgoing(I,S.id,1,c(S.type),S.data);return}}}send(S,I=void 0){const N=new T;return r(N,S),r(N,I),this.sendBuffer(N.buffer)}sendBuffer(S){try{return this.protocol.send(S),S.byteLength}catch(I){return 0}}onRawMessage(S){const I=new O(S),N=o(I),M=o(I),$=N[0];switch($){case 100:return this.logger&&this.logger.logIncoming(S.byteLength,N[1],1,`${w($)}: ${N[2]}.${N[3]}`,M),this.onPromise({type:$,id:N[1],channelName:N[2],name:N[3],arg:M});case 102:return this.logger&&this.logger.logIncoming(S.byteLength,N[1],1,`${w($)}: ${N[2]}.${N[3]}`,M),this.onEventListen({type:$,id:N[1],channelName:N[2],name:N[3],arg:M});case 101:return this.logger&&this.logger.logIncoming(S.byteLength,N[1],1,`${w($)}`),this.disposeActiveRequest({type:$,id:N[1]});case 103:return this.logger&&this.logger.logIncoming(S.byteLength,N[1],1,`${w($)}`),this.disposeActiveRequest({type:$,id:N[1]})}}onPromise(S){const I=this.channels.get(S.channelName);if(!I){this.collectPendingRequest(S);return}const N=new _.CancellationTokenSource;let M;try{M=I.call(this.ctx,S.name,S.arg,N.token)}catch(G){M=Promise.reject(G)}const $=S.id;M.then(G=>{this.sendResponse({id:$,data:G,type:201}),this.activeRequests.delete(S.id)},G=>{G instanceof Error?this.sendResponse({id:$,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:$,data:G,type:203}),this.activeRequests.delete(S.id)});const V=(0,L.toDisposable)(()=>N.cancel());this.activeRequests.set(S.id,V)}onEventListen(S){const I=this.channels.get(S.channelName);if(!I){this.collectPendingRequest(S);return}const N=S.id,$=I.listen(this.ctx,S.name,S.arg)(V=>this.sendResponse({id:N,data:V,type:204}));this.activeRequests.set(S.id,$)}disposeActiveRequest(S){const I=this.activeRequests.get(S.id);I&&(I.dispose(),this.activeRequests.delete(S.id))}collectPendingRequest(S){let I=this.pendingRequests.get(S.channelName);I||(I=[],this.pendingRequests.set(S.channelName,I));const N=setTimeout(()=>{console.error(`Unknown channel: ${S.channelName}`),S.type===100&&this.sendResponse({id:S.id,data:{name:"Unknown channel",message:`Channel name '${S.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);I.push({request:S,timeoutTimer:N})}flushPendingRequests(S){const I=this.pendingRequests.get(S);if(I){for(const N of I)switch(clearTimeout(N.timeoutTimer),N.request.type){case 100:this.onPromise(N.request);break;case 102:this.onEventListen(N.request);break}this.pendingRequests.delete(S)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(S=>S.dispose()),this.activeRequests.clear()}}e.ChannelServer=y;var E;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));class F{constructor(S,I=null){this.protocol=S,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(N=>this.onBuffer(N)),this.logger=I}getChannel(S){const I=this;return{call(N,M,$){return I.isDisposed?Promise.reject(A.canceled()):I.requestPromise(S,N,M,$)},listen(N,M){return I.isDisposed?Promise.reject(A.canceled()):I.requestEvent(S,N,M)}}}requestPromise(S,I,N,M=_.CancellationToken.None){const $=this.lastRequestId++,G={id:$,type:100,channelName:S,name:I,arg:N};if(M.isCancellationRequested)return Promise.reject(A.canceled());let K;return new Promise((se,oe)=>{if(M.isCancellationRequested)return oe(A.canceled());const ce=()=>{const Oe=Ae=>{switch(Ae.type){case 201:this.handlers.delete($),se(Ae.data);break;case 202:this.handlers.delete($);const Ne=new Error(Ae.data.message);Ne.stack=Ae.data.stack,Ne.name=Ae.data.name,oe(Ne);break;case 203:this.handlers.delete($),oe(Ae.data);break}};this.handlers.set($,Oe),this.sendRequest(G)};let ue=null;this.state===p.Idle?ce():(ue=(0,b.createCancelablePromise)(Oe=>this.whenInitialized()),ue.then(()=>{ue=null,ce()}));const Se=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:$,type:101}),oe(A.canceled())},_e=M.onCancellationRequested(Se);K=(0,L.combinedDisposable)((0,L.toDisposable)(Se),_e),this.activeRequests.add(K)}).finally(()=>{this.activeRequests.delete(K)})}requestEvent(S,I,N){const M=this.lastRequestId++,V={id:M,type:102,channelName:S,name:I,arg:N};let G=null;const K=new f.Emitter({onFirstListenerAdd:()=>{G=(0,b.createCancelablePromise)(se=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(K),this.sendRequest(V)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(K),this.sendRequest({id:M,type:103}))}}),te=se=>K.fire(se.data);return this.handlers.set(M,te),K.event}sendRequest(S){switch(S.type){case 100:case 102:{const I=this.send([S.type,S.id,S.channelName,S.name],S.arg);this.logger&&this.logger.logOutgoing(I,S.id,0,`${w(S.type)}: ${S.channelName}.${S.name}`,S.arg);return}case 101:case 103:{const I=this.send([S.type,S.id]);this.logger&&this.logger.logOutgoing(I,S.id,0,w(S.type));return}}}send(S,I=void 0){const N=new T;return r(N,S),r(N,I),this.sendBuffer(N.buffer)}sendBuffer(S){try{return this.protocol.send(S),S.byteLength}catch(I){return 0}}onBuffer(S){const I=new O(S),N=o(I),M=o(I),$=N[0];switch($){case 200:return this.logger&&this.logger.logIncoming(S.byteLength,0,0,c($)),this.onResponse({type:N[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(S.byteLength,N[1],0,c($),M),this.onResponse({type:N[0],id:N[1],data:M})}}onResponse(S){if(S.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const I=this.handlers.get(S.id);I&&I(S)}whenInitialized(){return this.state===p.Idle?Promise.resolve():f.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(S=>S.dispose()),this.activeRequests.clear()}}e.ChannelClient=F;class R{constructor(S){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,S(({protocol:I,onDidClientDisconnect:N})=>{f.Event.once(I.onMessage)($=>{const V=new O($),G=o(V),K=new y(I,G),te=new F(I);this.channels.forEach((oe,ce)=>K.registerChannel(ce,oe));const se={channelServer:K,channelClient:te,ctx:G};this._connections.add(se),this._onDidAddConnection.fire(se),N(()=>{K.dispose(),te.dispose(),this._connections.delete(se),this._onDidRemoveConnection.fire(se)})})})}get connections(){const S=[];return this._connections.forEach(I=>S.push(I)),S}getChannel(S,I){const N=this;return{call(M,$,V){let G;if((0,g.isFunction)(I)){let te=(0,h.getRandomElement)(N.connections.filter(I));G=te?Promise.resolve(te):f.Event.toPromise(f.Event.filter(N.onDidAddConnection,I))}else G=I.routeCall(N,M,$);const K=G.then(te=>te.channelClient.getChannel(S));return P(K).call(M,$,V)},listen(M,$){if((0,g.isFunction)(I))return N.getMulticastEvent(S,I,M,$);const V=I.routeEvent(N,M,$).then(G=>G.channelClient.getChannel(S));return P(V).listen(M,$)}}}getMulticastEvent(S,I,N,M){const $=this;let V=new L.DisposableStore;const G=new f.Emitter({onFirstListenerAdd:()=>{V=new L.DisposableStore;const K=new f.EventMultiplexer,te=new Map,se=ce=>{const Se=ce.channelClient.getChannel(S).listen(N,M),_e=K.add(Se);te.set(ce,_e)},oe=ce=>{const ue=te.get(ce);!ue||(ue.dispose(),te.delete(ce))};$.connections.filter(I).forEach(se),f.Event.filter($.onDidAddConnection,I)(se,void 0,V),$.onDidRemoveConnection(oe,void 0,V),K.event(G.fire,G,V),V.add(K)},onLastListenerRemove:()=>{V.dispose()}});return G.event}registerChannel(S,I){this.channels.set(S,I),this._connections.forEach(N=>{N.channelServer.registerChannel(S,I)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class u{constructor(S,I,N=null){const M=new T;r(M,I),S.send(M.buffer),this.channelClient=new F(S,N),this.channelServer=new y(S,I,N)}getChannel(S){return this.channelClient.getChannel(S)}registerChannel(S,I){this.channelServer.registerChannel(S,I)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=u;function P(U){return{call(S,I,N){return U.then(M=>M.call(S,I,N))},listen(S,I){const N=new f.Relay;return U.then(M=>N.input=M.listen(S,I)),N.event}}}e.getDelayedChannel=P;function k(U){let S=!1;return{call(I,N,M){return S?U.call(I,N,M):(0,b.timeout)(0).then(()=>S=!0).then(()=>U.call(I,N,M))},listen(I,N){if(S)return U.listen(I,N);const M=new f.Relay;return(0,b.timeout)(0).then(()=>S=!0).then(()=>M.input=U.listen(I,N)),M.event}}}e.getNextTickChannel=k;class W{constructor(S){this.fn=S}routeCall(S){return this.route(S)}routeEvent(S){return this.route(S)}async route(S){for(const I of S.connections)if(await Promise.resolve(this.fn(I.ctx)))return Promise.resolve(I);return await f.Event.toPromise(S.onDidAddConnection),await this.route(S)}}e.StaticRouter=W;var Q;(function(U){function S(M,$){const V=M,G=$&&$.disableMarshalling,K=new Map;for(const te in V)N(te)&&K.set(te,f.Event.buffer(V[te],!0));return new class{listen(te,se){const oe=K.get(se);if(oe)return oe;throw new Error(`Event not found: ${se}`)}call(te,se,oe){const ce=V[se];if(typeof ce=="function"){if(!G&&Array.isArray(oe))for(let ue=0;ue<oe.length;ue++)oe[ue]=(0,D.revive)(oe[ue]);return ce.apply(V,oe)}throw new Error(`Method not found: ${se}`)}}}U.fromService=S;function I(M,$){const V=$&&$.disableMarshalling;return new Proxy({},{get(G,K){var te;if(typeof K=="string")return((te=$==null?void 0:$.properties)===null||te===void 0?void 0:te.has(K))?$.properties.get(K):N(K)?M.listen(K):async function(...se){let oe;$&&!(0,g.isUndefinedOrNull)($.context)?oe=[$.context,...se]:oe=se;const ce=await M.call(K,oe);return V?ce:(0,D.revive)(ce)};throw new Error(`Property not found: ${String(K)}`)}})}U.toService=I;function N(M){return M[0]==="o"&&M[1]==="n"&&m.isUpperAsciiLetter(M.charCodeAt(2))}})(Q=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let S=U.toString();if(S!=="[object Object]")return S}return U}function Y(U){return Array.isArray(U)?U.map(H):H(U)}function B(U,S,I,N,M,$,V){V=Y(V);const G=z[M],K=G[N%G.length];let te=[`%c[${U}]%c[${String(S).padStart(7," ")}]%c[len: ${String(I).padStart(5," ")}]%c${String(N).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${K}`];/\($/.test($)?(te=te.concat(V),te.push(")")):te.push(V),console.log.apply(console,te)}e.logWithColors=B;class x{constructor(S,I){this._outgoingPrefix=S,this._incomingPrefix=I,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(S,I,N,M,$){this._totalOutgoing+=S,B(this._outgoingPrefix,this._totalOutgoing,S,I,N,M,$)}logIncoming(S,I,N,M,$){this._totalIncoming+=S,B(this._incomingPrefix,this._totalIncoming,S,I,N,M,$)}}e.IPCLogger=x}),define(J[66],Z([0,1,5,34,2,17,3,26]),function(q,e,f,L,b,_,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let h=null;function g(){return h||(h=_.VSBuffer.alloc(0)),h}class D{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,r){if(n===0)return g();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const F=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=n),F}if(this._chunks[0].byteLength>n){const F=this._chunks[0].slice(0,n);return r&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),F}let o=_.VSBuffer.alloc(n),y=0,E=0;for(;n>0;){const F=this._chunks[E];if(F.byteLength>n){const R=F.slice(0,n);o.set(R,y),y+=n,r&&(this._chunks[E]=F.slice(n),this._totalLength-=n),n-=n}else o.set(F,y),y+=F.byteLength,r?(this._chunks.shift(),this._totalLength-=F.byteLength):E++,n-=F.byteLength}return o}}e.ChunkStream=D;var m;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(m||(m={}));var v;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class w{constructor(n,r,o,y){this.type=n,this.id=r,this.ack=o,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends b.Disposable{constructor(n){super();this._onMessage=this._register(new f.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new D,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const o=this._state.messageType,y=this._state.id,E=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new w(o,y,E,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class c{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(!this._isDisposed){n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=_.VSBuffer.alloc(13);r.writeUInt8(n.type,0),r.writeUInt32BE(n.id,1),r.writeUInt32BE(n.ack,5),r.writeUInt32BE(n.data.byteLength,9),this._writeSoon(r,n.data)}}_bufferAdd(n,r){const o=this._totalLength===0;return this._data.push(n,r),this._totalLength+=n.byteLength+r.byteLength,o}_bufferTake(){const n=_.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,r){this._bufferAdd(n,r)&&A.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class p extends b.Disposable{constructor(n){super();this._onMessage=new f.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new f.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new c(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new w(1,0,0,n))}}e.Protocol=p;class O extends L.IPCClient{constructor(n,r,o=null){super(n,r,o);this.protocol=n}static fromSocket(n,r){return new O(new p(n),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=O;class T{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new f.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,C.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=T;class d{constructor(n){this.data=n,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],r=0,o=this._first;for(;o;)n[r++]=o.data,o=o.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const r=new d(n);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class s{constructor(){this.lastRuns=[];const n=Date.now();for(let r=0;r<s._HISTORY_LENGTH;r++)this.lastRuns[r]=n-1e3*r;setInterval(()=>{for(let r=s._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const n=Date.now(),r=(1+s._HISTORY_LENGTH)*1e3;let o=0;for(let y=0;y<s._HISTORY_LENGTH;y++)n-this.lastRuns[y]<=r&&o++;return 1-o/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{constructor(n,r=null){this._loadEstimator=s.getInstance(),this._onControlMessage=new T,this.onControlMessage=this._onControlMessage.event,this._onMessage=new T,this.onMessage=this._onMessage.event,this._onDidDispose=new T,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new T,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new T,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new c(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,b.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new w(5,0,0,g());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const r=new w(4,0,0,g());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}}setSocket(n){this._socket=n}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,r){this._isReconnecting=!0,this._socketDisposables=(0,b.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new c(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let r=0,o=n.length;r<o;r++)this._socketWriter.write(n[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new w(6,0,0,g())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const r=this._outgoingUnackMsg.toArray();for(let o=0,y=r.length;o<y;o++)this._socketWriter.write(r[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new w(1,r,this._incomingAckId,n);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(n){const r=new w(2,0,0,n);this._socketWriter.write(r)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const n=this._outgoingUnackMsg.peek(),r=Date.now()-n.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const n=new w(3,0,this._incomingAckId,g());this._socketWriter.write(n)}}}e.PersistentProtocol=t}),define(J[103],Z([0,1,2,5,13,12]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var A;(function(D){D[D.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));var C;(function(D){D[D.None=0]="None",D[D.Initialized=1]="Initialized",D[D.Closed=2]="Closed"})(C||(C={}));class h extends f.Disposable{constructor(m,v=Object.create(null)){super();this.database=m,this.options=v,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new b.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){var v,w;(v=m.changed)===null||v===void 0||v.forEach((a,c)=>this.accept(c,a)),(w=m.deleted)===null||w===void 0||w.forEach(a=>this.accept(a,void 0))}accept(m,v){if(this.state!==C.Closed){let w=!1;(0,_.isUndefinedOrNull)(v)?w=this.cache.delete(m):this.cache.get(m)!==v&&(this.cache.set(m,v),w=!0),w&&this._onDidChangeStorage.fire(m)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,v){const w=this.cache.get(m);return(0,_.isUndefinedOrNull)(w)?v:w}getBoolean(m,v){const w=this.get(m);return(0,_.isUndefinedOrNull)(w)?v:w==="true"}getNumber(m,v){const w=this.get(m);return(0,_.isUndefinedOrNull)(w)?v:parseInt(w,10)}async set(m,v){if(this.state!==C.Closed){if((0,_.isUndefinedOrNull)(v))return this.delete(m);const w=String(v);if(this.cache.get(m)!==w)return this.cache.set(m,w),this.pendingInserts.set(m,w),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(m){if(this.state!==C.Closed&&!!this.cache.delete(m))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{var v;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(v=this.whenFlushedCallbacks.pop())===null||v===void 0||v()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=h,h.DEFAULT_FLUSH_DELAY=100;class g{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((v,w)=>this.items.set(w,v)),m.delete&&m.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=g}),define(J[104],Z([9,10]),function(q,e){return q.create("vs/base/common/actions",e)}),define(J[105],Z([0,1,104,2,5]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class _ extends L.Disposable{constructor(v,w="",a="",c=!0,p){super();this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._checked=!1,this._id=v,this._label=w,this._cssClass=a,this._enabled=c,this._actionCallback=p}get id(){return this._id}get label(){return this._label}set label(v){this._setLabel(v)}_setLabel(v){this._label!==v&&(this._label=v,this._onDidChange.fire({label:v}))}get tooltip(){return this._tooltip||""}set tooltip(v){this._setTooltip(v)}_setTooltip(v){this._tooltip!==v&&(this._tooltip=v,this._onDidChange.fire({tooltip:v}))}get class(){return this._cssClass}set class(v){this._setClass(v)}_setClass(v){this._cssClass!==v&&(this._cssClass=v,this._onDidChange.fire({class:v}))}get enabled(){return this._enabled}set enabled(v){this._setEnabled(v)}_setEnabled(v){this._enabled!==v&&(this._enabled=v,this._onDidChange.fire({enabled:v}))}get checked(){return this._checked}set checked(v){this._setChecked(v)}_setChecked(v){this._checked!==v&&(this._checked=v,this._onDidChange.fire({checked:v}))}async run(v,w){this._actionCallback&&await this._actionCallback(v)}}e.Action=_;class A extends L.Disposable{constructor(){super(...arguments);this._onBeforeRun=this._register(new b.Emitter),this.onBeforeRun=this._onBeforeRun.event,this._onDidRun=this._register(new b.Emitter),this.onDidRun=this._onDidRun.event}async run(v,w){if(!!v.enabled){this._onBeforeRun.fire({action:v});let a;try{await this.runAction(v,w)}catch(c){a=c}this._onDidRun.fire({action:v,error:a})}}async runAction(v,w){await v.run(w)}}e.ActionRunner=A;class C extends _{constructor(v){super(C.ID,v,v?"separator text":"separator");this.checked=!1,this.enabled=!1}}e.Separator=C,C.ID="vs.actions.separator";class h{constructor(v,w,a,c){this.tooltip="",this.enabled=!0,this.checked=!1,this.id=v,this.label=w,this.class=c,this._actions=a}get actions(){return this._actions}dispose(){}async run(){}}e.SubmenuAction=h;class g extends _{constructor(){super(g.ID,f.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=g,g.ID="vs.actions.empty";function D(m){var v,w;return{id:m.id,label:m.label,class:void 0,enabled:(v=m.enabled)!==null&&v!==void 0?v:!0,checked:(w=m.checked)!==null&&w!==void 0?w:!1,run:async()=>m.run(),tooltip:m.label,dispose:()=>{}}}e.toAction=D}),define(J[106],Z([9,10]),function(q,e){return q.create("vs/base/common/date",e)}),define(J[107],Z([0,1,106]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,b=L*60,_=b*24,A=_*7,C=_*30,h=_*365;function g(m,v){typeof m!="number"&&(m=m.getTime());const w=Math.round((new Date().getTime()-m)/1e3);if(w<-30)return(0,f.localize)(0,null,g(new Date().getTime()+w*1e3,!1));if(w<30)return(0,f.localize)(1,null);let a;return w<L?(a=w,v?a===1?(0,f.localize)(2,null,a):(0,f.localize)(3,null,a):a===1?(0,f.localize)(4,null,a):(0,f.localize)(5,null,a)):w<b?(a=Math.floor(w/L),v?a===1?(0,f.localize)(6,null,a):(0,f.localize)(7,null,a):a===1?(0,f.localize)(8,null,a):(0,f.localize)(9,null,a)):w<_?(a=Math.floor(w/b),v?a===1?(0,f.localize)(10,null,a):(0,f.localize)(11,null,a):a===1?(0,f.localize)(12,null,a):(0,f.localize)(13,null,a)):w<A?(a=Math.floor(w/_),v?a===1?(0,f.localize)(14,null,a):(0,f.localize)(15,null,a):a===1?(0,f.localize)(16,null,a):(0,f.localize)(17,null,a)):w<C?(a=Math.floor(w/A),v?a===1?(0,f.localize)(18,null,a):(0,f.localize)(19,null,a):a===1?(0,f.localize)(20,null,a):(0,f.localize)(21,null,a)):w<h?(a=Math.floor(w/C),v?a===1?(0,f.localize)(22,null,a):(0,f.localize)(23,null,a):a===1?(0,f.localize)(24,null,a):(0,f.localize)(25,null,a)):(a=Math.floor(w/h),v?a===1?(0,f.localize)(26,null,a):(0,f.localize)(27,null,a):a===1?(0,f.localize)(28,null,a):(0,f.localize)(29,null,a))}e.fromNow=g;function D(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(J[108],Z([9,10]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(J[37],Z([0,1,108,12,23]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(g,D){return D&&(g.stack||g.stacktrace)?f.localize(0,null,C(g),A(g.stack)||A(g.stacktrace)):C(g)}function A(g){return Array.isArray(g)?g.join(`
`):g}function C(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?f.localize(1,null,g.message):g.message||f.localize(2,null)}function h(g=null,D=!1){if(!g)return f.localize(3,null);if(Array.isArray(g)){const m=b.coalesce(g),v=h(m[0],D);return m.length>1?f.localize(4,null,v,m.length):v}if(L.isString(g))return g;if(g.detail){const m=g.detail;if(m.error)return _(m.error,D);if(m.exception)return _(m.exception,D)}return g.stack?_(g,D):g.message?g.message:f.localize(5,null)}e.toErrorMessage=h}),define(J[109],Z([9,10]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(J[110],Z([0,1,109]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(b){switch(b){case 1:return(0,f.localize)(0,null);case 2:return(0,f.localize)(1,null);case 3:return(0,f.localize)(2,null);case 4:return(0,f.localize)(3,null);case 5:return(0,f.localize)(4,null);case 6:return(0,f.localize)(5,null);case 7:return(0,f.localize)(6,null);case 8:return(0,f.localize)(7,null);case 9:return(0,f.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(J[111],Z([9,10]),function(q,e){return q.create("vs/base/node/processes",e)}),define(J[67],Z([0,1,4,16,19,40,111,26,12,22,35,3,65,8]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function a(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(s,t){if(m.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const n=_.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],i);return new Promise(r=>{n.once("error",o=>{r({success:!1,error:o})}),n.once("exit",(o,y)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?a(i.status):1})}else if(m.isLinux||m.isMacintosh)try{const i=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",q).fsPath;return new Promise(n=>{_.execFile(i,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,o,y)=>{n(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function p(s=C.env){return s.comspec||"cmd.exe"}e.getWindowsShell=p;class O{constructor(t,i,n,r){if(i!==void 0&&n!==void 0&&r!==void 0)this.cmd=t,this.args=i,this.shell=n,this.options=r;else{const o=t;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(C.env).forEach(y=>{o[y]=C.env[y]}),Object.keys(this.options.env).forEach(y=>{o[y]=this.options.env[y]}),this.options.env=o}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(f.sep);return i!==-1&&(t=t.substring(i+1)),O.WellKnowCommands[t]?t:"other"}start(t){return m.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(C.cwd()))?Promise.reject(new Error(A.localize(0,null))):this.useExec().then(i=>{let n,r;const o=new Promise((y,E)=>{n=y,r=E});if(i){let y=this.cmd;this.args&&(y=y+" "+this.args.join(" ")),this.childProcess=_.exec(y,this.options,(E,F,R)=>{this.childProcess=null;const u=E;u&&u.killed?r({killed:this.terminateRequested,stdout:F.toString(),stderr:R.toString()}):this.handleExec(n,t,E,F,R)})}else{let y=null;const E=F=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(F,n,t,r);const R={terminated:this.terminateRequested};h.isNumber(F)&&(R.cmdCode=F),n(R)};if(this.shell&&m.isWindows){const F=g.deepClone(this.options);F.windowsVerbatimArguments=!0,F.detached=!1;let R=!1,u=!1;const P=[];let k=this.ensureQuotes(this.cmd);P.push(k.value),R=k.quoted,this.args&&this.args.forEach(Q=>{k=this.ensureQuotes(Q),P.push(k.value),u=u&&k.quoted});const W=["/s","/c"];R?u?W.push('"'+P.join(" ")+'"'):P.length>1?W.push('"'+P[0]+'" '+P.slice(1).join(" ")):W.push('"'+P[0]+'"'):W.push(P.join(" ")),y=_.spawn(p(),W,F)}else this.cmd&&(y=_.spawn(this.cmd,this.args,this.options));y&&(this.childProcess=y,this.childProcessPromise=Promise.resolve(y),this.pidResolve&&(this.pidResolve(h.isNumber(y.pid)?y.pid:-1),this.pidResolve=void 0),y.on("error",F=>{this.childProcess=null,r({terminated:this.terminateRequested,error:F})}),y.pid&&(this.childProcess.on("close",E),this.handleSpawn(y,n,t,r,!0)))}return o})}handleClose(t,i,n,r){}ensureQuotes(t){return O.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,c(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!m.isWindows)return t(!1);const i=_.spawn(p(),["/s","/c"]);i.on("error",n=>t(!0)),i.on("exit",n=>t(!1))})}}e.AbstractProcess=O,O.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},O.regexp=/^[^"].* .*[^"]/;class T extends O{constructor(t,i,n,r){super(t,i,n,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,n,r,o){[r,o].forEach((y,E)=>{const F=new v.LineDecoder;F.write(y).forEach(P=>{i({line:P,source:E===0?0:1})});const u=F.end();u&&i({line:u,source:E===0?0:1})}),t({terminated:this.terminateRequested,error:n})}handleSpawn(t,i,n,r,o){const y=new v.LineDecoder,E=new v.LineDecoder;t.stdout.on("data",F=>{y.write(F).forEach(u=>n({line:u,source:0}))}),t.stderr.on("data",F=>{E.write(F).forEach(u=>n({line:u,source:1}))}),this.stdoutLineDecoder=y,this.stderrLineDecoder=E}handleClose(t,i,n,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&n({line:o,source:0});const y=this.stderrLineDecoder?this.stderrLineDecoder.end():null;y&&n({line:y,source:1})}}e.LineProcess=T;function d(s){let t=[],i=!1;const n=function(r){if(i){t.push(r);return}(!s.send(r,y=>{if(y&&console.error(y),i=!1,t.length>0){const E=t.slice(0);t=[],E.forEach(F=>n(F))}})||m.isWindows)&&(i=!0)};return{send:n}}e.createQueuedSender=d;var l;(function(s){async function t(i,n,r){if(f.isAbsolute(i))return i;if(n===void 0&&(n=C.cwd()),f.dirname(i)!=="."||(r===void 0&&h.isString(C.env.PATH)&&(r=C.env.PATH.split(f.delimiter)),r===void 0||r.length===0))return f.join(n,i);async function y(E){return await b.exists(E)?!(await L.promises.stat(E)).isDirectory():!1}for(let E of r){let F;if(f.isAbsolute(E)?F=f.join(E,i):F=f.join(n,E,i),await y(F))return F;let R=F+".com";if(await y(R)||(R=F+".exe",await y(R)))return R}return f.join(n,i)}s.findExecutable=t})(l=e.win32||(e.win32={}))}),define(J[112],Z([0,1,25,3,100,67]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(w,a){return w===1?L.isWindows?m():_.getWindowsShell(a):g(w,a)}e.getSystemShell=A;function C(w,a){return w===1?L.isWindows?v(a):_.getWindowsShell(a):g(w,a)}e.getSystemShellSync=C;let h=null;function g(w,a){if(L.isLinux&&w===2||L.isMacintosh&&w===3)return"/bin/bash";if(!h){let c;if(L.isWindows)c="/bin/bash";else{if(c=a.SHELL,!c)try{c=(0,f.userInfo)().shell}catch(p){}c||(c="sh"),c==="/bin/false"&&(c="/bin/bash")}h=c}return h}let D=null;async function m(){return D||(D=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),D}function v(w){if(D)return D;const a=L.isWindows&&parseFloat((0,f.release)())>=10,c=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${w.windir}\\${c?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?p:_.getWindowsShell(w)}}),define(J[50],Z([0,1,40,2,13,22,5,67,34,92,27,11,17,3]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class a extends h.ChannelServer{constructor(O){super({send:T=>{try{process.send&&process.send(T.buffer.toString("base64"))}catch(d){}},onMessage:A.Event.fromNodeEventEmitter(process,"message",T=>v.VSBuffer.wrap(Buffer.from(T,"base64")))},O);process.once("disconnect",()=>this.dispose())}}e.Server=a;class c{constructor(O,T){this.modulePath=O,this.options=T,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new A.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=T&&T.timeout?T.timeout:6e4;this.disposeDelayer=new b.Delayer(d),this.child=null,this._client=null}getChannel(O){const T=this;return{call(d,l,s){return T.requestPromise(O,d,l,s)},listen(d,l){return T.requestEvent(O,d,l)}}}requestPromise(O,T,d,l=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(m.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(O),t=(0,b.createCancelablePromise)(r=>s.call(T,d,r)),i=l.onCancellationRequested(()=>t.cancel()),n=(0,L.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(O,T,d){if(!this.disposeDelayer)return A.Event.None;this.disposeDelayer.cancel();let l;const s=new A.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(O).listen(T,d)(s.fire,s),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const O=this.options&&this.options.args?this.options.args:[],T=Object.create(null);T.env=Object.assign(Object.assign({},(0,_.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(T.env=Object.assign(Object.assign({},T.env),this.options.env)),this.options&&this.options.freshExecArgv&&(T.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(T.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(T.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),T.execArgv===void 0&&(T.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),w.isMacintosh&&T.env&&delete T.env.DYLD_LIBRARY_PATH,this.child=(0,f.fork)(this.modulePath,O,T);const d=new A.Emitter;A.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,g.isRemoteConsoleLog)(o)){(0,g.log)(o,`IPC Library: ${this.options.serverName}`);return}d.fire(v.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,t=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),i=d.event,n={send:t,onMessage:i};this._client=new h.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,y)=>{process.removeListener("exit",r),this.activeRequests.forEach(E=>(0,L.dispose)(E)),this.activeRequests.clear(),o!==0&&y!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+y),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:y})})}return this._client}getCachedChannel(O){let T=this.channels.get(O);return T||(T=this.client.getChannel(O),this.channels.set(O,T)),T}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=c}),define(J[113],Z([9,10]),function(q,e){return q.create("vs/base/node/zip",e)}),define(J[114],Z([9,10]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[115],Z([9,10]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(J[116],Z([9,10]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(J[117],Z([9,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[118],Z([9,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(J[119],Z([9,10]),function(q,e){return q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(J[120],Z([9,10]),function(q,e){return q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(J[121],Z([9,10]),function(q,e){return q.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(J[122],Z([9,10]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[123],Z([9,10]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(J[124],Z([9,10]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(J[125],Z([9,10]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(J[126],Z([9,10]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[127],Z([9,10]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(J[128],Z([9,10]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[129],Z([9,10]),function(q,e){return q.create("vs/server/node/marketplace",e)}),define(J[130],Z([9,10]),function(q,e){return q.create("vs/workbench/common/editor",e)}),define(J[131],Z([9,10]),function(q,e){return q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(J[132],Z([9,10]),function(q,e){return q.create("vs/workbench/services/extensions/node/extensionPoints",e)}),define(J[133],Z([0,1,5,2]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class b{constructor(){this._onCloseEmitter=new f.Emitter,this._onReloadEmitter=new f.Emitter,this._onTerminateEmitter=new f.Emitter,this._onAttachEmitter=new f.Emitter}call(C,h,g){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:g[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:g[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:g[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:g[0],port:g[1],subId:g[2]}))}throw new Error("Method not implemented.")}listen(C,h,g){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=b,b.ChannelName="extensionhostdebugservice";class _ extends L.Disposable{constructor(C){super();this.channel=C}reload(C){this.channel.call("reload",[C])}get onReload(){return this.channel.listen("reload")}close(C){this.channel.call("close",[C])}get onClose(){return this.channel.listen("close")}attachSession(C,h,g){this.channel.call("attach",[C,h,g])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(C,h){this.channel.call("terminate",[C,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(C,h,g){return this.channel.call("openExtensionDevelopmentHostWindow",[C,h||{},g])}}e.ExtensionHostDebugChannelClient=_});var ve=this&&this.__decorate||function(q,e,f,L){var b=arguments.length,_=b<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,f):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(q,e,f,L);else for(var C=q.length-1;C>=0;C--)(A=q[C])&&(_=(b<3?A(_):b>3?A(e,f,_):A(e,f))||_);return b>3&&_&&Object.defineProperty(e,f,_),_};define(J[134],Z([0,1,4,15,88,107,8,7,26]),function(q,e,f,L,b,_,A,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;function g(a,c){if(!!a){const p=(0,f.resolve)(a);return(0,f.normalize)(a)===p?p:(0,f.resolve)(c.env.VSCODE_CWD||c.cwd(),a)}}class D{constructor(c,p,O){this._args=c,this.paths=p,this.productService=O}get appRoot(){return(0,f.dirname)(A.FileAccess.asFileUri("",q).fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file((0,f.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,f.join)(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file((0,f.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(C.URI.file((0,f.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return C.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return C.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=h.env.VSCODE_PORTABLE;return c?C.URI.file((0,f.join)(c,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,f.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,f.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,f.resolve)(c):(0,f.normalize)((0,f.join)(A.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?(0,f.resolve)(c):(0,f.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,f.resolve)(c);const p=h.env.VSCODE_EXTENSIONS;if(p)return p;const O=h.env.VSCODE_PORTABLE;return O?(0,f.join)(O,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(p=>/^[^:/?#]+?:\/\//.test(p)?C.URI.parse(p):C.URI.file((0,f.normalize)(p)))}get extraExtensionPaths(){return(this._args["extra-extensions-dir"]||[]).map(c=>g(c,process))}get extraBuiltinExtensionPaths(){return(this._args["extra-builtin-extensions-dir"]||[]).map(c=>g(c,process))}get extensionDevelopmentKind(){var c;return(c=this.args.extensionDevelopmentKind)===null||c===void 0?void 0:c.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?C.URI.parse(c):C.URI.file((0,f.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!h.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,L.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return C.URI.file((0,f.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ve([b.memoize],D.prototype,"appRoot",null),ve([b.memoize],D.prototype,"userHome",null),ve([b.memoize],D.prototype,"userDataPath",null),ve([b.memoize],D.prototype,"appSettingsHome",null),ve([b.memoize],D.prototype,"tmpDir",null),ve([b.memoize],D.prototype,"userRoamingDataHome",null),ve([b.memoize],D.prototype,"settingsResource",null),ve([b.memoize],D.prototype,"userDataSyncHome",null),ve([b.memoize],D.prototype,"userDataSyncLogResource",null),ve([b.memoize],D.prototype,"sync",null),ve([b.memoize],D.prototype,"machineSettingsResource",null),ve([b.memoize],D.prototype,"globalStorageHome",null),ve([b.memoize],D.prototype,"workspaceStorageHome",null),ve([b.memoize],D.prototype,"keybindingsResource",null),ve([b.memoize],D.prototype,"keyboardLayoutResource",null),ve([b.memoize],D.prototype,"argvResource",null),ve([b.memoize],D.prototype,"snippetsHome",null),ve([b.memoize],D.prototype,"isExtensionDevelopment",null),ve([b.memoize],D.prototype,"untitledWorkspacesHome",null),ve([b.memoize],D.prototype,"installSourcePath",null),ve([b.memoize],D.prototype,"builtinExtensionsPath",null),ve([b.memoize],D.prototype,"extensionsPath",null),ve([b.memoize],D.prototype,"extensionDevelopmentLocationURI",null),ve([b.memoize],D.prototype,"extraExtensionPaths",null),ve([b.memoize],D.prototype,"extraBuiltinExtensionPaths",null),ve([b.memoize],D.prototype,"extensionDevelopmentKind",null),ve([b.memoize],D.prototype,"extensionTestsLocationURI",null),ve([b.memoize],D.prototype,"debugExtensionHost",null),ve([b.memoize],D.prototype,"serviceMachineIdResource",null),ve([b.memoize],D.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=D;function m(a,c){return w(a["inspect-extensions"],a["inspect-brk-extensions"],5870,c,a.debugId)}e.parseExtensionHostPort=m;function v(a,c){return w(a["inspect-search"],a["inspect-brk-search"],5876,c)}e.parseSearchPort=v;function w(a,c,p,O,T){const l=Number(c||a)||(O?null:p),s=l?Boolean(!!c):!1;return{port:l,break:s,debugId:T}}}),define(J[135],Z([0,1,206,115,3]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const _={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"extra-builtin-extensions-dir":{type:"string[]",cat:"o",description:"Path to an extra builtin extension directory."},"extra-extensions-dir":{type:"string[]",cat:"o",description:"Path to an extra user extension directory."},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,L.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,L.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,L.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,L.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,L.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(30,null)},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{}};function C(a,c,p=A){const O={},T=[],d=[];for(let i in c){const n=c[i];n.alias&&(O[i]=n.alias),n.type==="string"||n.type==="string[]"?(T.push(i),n.deprecates&&T.push(n.deprecates)):n.type==="boolean"&&(d.push(i),n.deprecates&&d.push(n.deprecates))}const l=f(a,{string:T,boolean:d,alias:O}),s={},t=l;s._=l._.map(i=>String(i)).filter(i=>i.length>0),delete t._;for(let i in c){const n=c[i];n.alias&&delete t[n.alias];let r=t[i];n.deprecates&&t.hasOwnProperty(n.deprecates)&&(r||(r=t[n.deprecates]),delete t[n.deprecates]),typeof r!="undefined"&&(n.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):n.type==="string"&&Array.isArray(r)&&(r=r.pop(),p.onMultipleValues(i,r)),s[i]=r),delete t[i]}for(let i in t)p.onUnknownOption(i);return s}e.parseArgs=C;function h(a,c){let p="";return c.args&&(Array.isArray(c.args)?p=` <${c.args.join("> <")}>`:p=` <${c.args}>`),c.alias?`-${c.alias} --${a}${p}`:`--${a}${p}`}function g(a,c){let p=0,O=[];for(const s in a){const t=a[s],i=h(s,t);p=Math.max(p,i.length),O.push([i,t.description])}let T=p+2+1;if(c-T<25)return O.reduce((s,t)=>s.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let d=c-T-1,l=[];for(const s of O){let t=s[0],i=m(s[1],d),n=D(T-t.length-2);l.push("  "+t+n+i[0]);for(let r=1;r<i.length;r++)l.push(D(T)+i[r])}return l}e.formatOptions=g;function D(a){return" ".repeat(a)}function m(a,c){let p=[];for(;a.length;){let O=a.length<c?a.length:a.lastIndexOf(" ",c),T=a.slice(0,O).trim();a=a.slice(O),p.push(T)}return p}function v(a,c,p,O,T=!0){const d=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${a} ${p}`];l.push(""),l.push(`${(0,L.localize)(32,null)}: ${c} [${(0,L.localize)(33,null)}][${(0,L.localize)(34,null)}...]`),l.push(""),T&&(b.isWindows?l.push((0,L.localize)(35,null,c)):l.push((0,L.localize)(36,null,c)),l.push(""));const s={};for(const t in O){const i=O[t];if(i.description&&i.cat){let n=s[i.cat];n||(s[i.cat]=n={}),n[t]=i}}for(let t in s){const i=t;let n=s[i];n&&(l.push(_[i]),l.push(...g(n,d)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=v;function w(a,c){return`${a||(0,L.localize)(37,null)}
${c||(0,L.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=w}),function(){"use strict";function q(e,f,L,b){function _(C){const h=A(C),g=[h];return e.isAbsolute(h)||g.unshift(b),e.resolve(...g)}function A(C){const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");const g=C["user-data-dir"];if(g)return g;let D=process.env.VSCODE_APPDATA;if(!D)switch(process.platform){case"win32":if(D=process.env.APPDATA,!D){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");D=e.join(m,"AppData","Roaming")}break;case"darwin":D=e.join(f.homedir(),"Library","Application Support");break;case"linux":D=process.env.XDG_CONFIG_HOME||e.join(f.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(D,L)}return{getUserDataPath:_}}if(typeof define=="function")define(J[136],Z([0,36,25,8,15,26]),function(e,f,L,b,_,A){const C=_.dirname(b.FileAccess.asFileUri("",e)),h=e.__$__nodeRequire(_.joinPath(C,"package.json").fsPath);return q(f,L,h.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),f=require("path"),L=require("os");module.exports=q(f,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[68],Z([0,1,25,136,134]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class _ extends b.AbstractNativeEnvironmentService{constructor(C,h){super(C,{homeDir:(0,f.homedir)(),tmpDir:(0,f.tmpdir)(),userDataDir:(0,L.getUserDataPath)(C)},h)}}e.NativeEnvironmentService=_}),define(J[137],Z([0,1,5,7,48,22,2]),function(q,e,f,L,b,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(a,c){return L.URI.revive(c?c.transformIncoming(a):a)}function h(a,c){return c?c.transformOutgoingURI(a):a}function g(a,c){c=c||b.DefaultURITransformer;const p=a.manifest,O=(0,b.transformAndReviveIncomingURIs)(Object.assign(Object.assign({},a),{manifest:void 0}),c);return Object.assign(Object.assign({},O),{manifest:p})}function D(a,c){return c?(0,_.cloneAndChange)(a,p=>p instanceof L.URI?c.transformOutgoingURI(p):void 0):a}class m{constructor(c,p){this.service=c,this.getUriTransformer=p,this.onInstallExtension=f.Event.buffer(c.onInstallExtension,!0),this.onDidInstallExtension=f.Event.buffer(c.onDidInstallExtension,!0),this.onUninstallExtension=f.Event.buffer(c.onUninstallExtension,!0),this.onDidUninstallExtension=f.Event.buffer(c.onDidUninstallExtension,!0)}listen(c,p){const O=this.getUriTransformer(c);switch(p){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return f.Event.map(this.onDidInstallExtension,T=>Object.assign(Object.assign({},T),{local:T.local?D(T.local,O):T.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(c,p,O){const T=this.getUriTransformer(c);switch(p){case"zip":return this.service.zip(g(O[0],T)).then(d=>h(d,T));case"unzip":return this.service.unzip(C(O[0],T));case"install":return this.service.install(C(O[0],T));case"getManifest":return this.service.getManifest(C(O[0],T));case"canInstall":return this.service.canInstall(O[0]);case"installFromGallery":return this.service.installFromGallery(O[0],O[1]);case"uninstall":return this.service.uninstall(g(O[0],T),O[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(g(O[0],T));case"getInstalled":return this.service.getInstalled(O[0]).then(d=>d.map(l=>D(l,T)));case"updateMetadata":return this.service.updateMetadata(g(O[0],T),O[1]).then(d=>D(d,T));case"updateExtensionScope":return this.service.updateExtensionScope(g(O[0],T),O[1]).then(d=>D(d,T));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class v extends A.Disposable{constructor(c){super();this.channel=c,this._onInstallExtension=this._register(new f.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new f.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new f.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new f.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(p=>this._onInstallExtension.fire(p))),this._register(this.channel.listen("onDidInstallExtension")(p=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},p),{local:p.local?g(p.local,null):p.local})))),this._register(this.channel.listen("onUninstallExtension")(p=>this._onUninstallExtension.fire(p))),this._register(this.channel.listen("onDidUninstallExtension")(p=>this._onDidUninstallExtension.fire(p)))}zip(c){return Promise.resolve(this.channel.call("zip",[c]).then(p=>L.URI.revive(p)))}unzip(c){return Promise.resolve(this.channel.call("unzip",[c]))}install(c){return Promise.resolve(this.channel.call("install",[c])).then(p=>g(p,null))}getManifest(c){return Promise.resolve(this.channel.call("getManifest",[c]))}async canInstall(c){return!0}installFromGallery(c,p){return Promise.resolve(this.channel.call("installFromGallery",[c,p])).then(O=>g(O,null))}uninstall(c,p){return Promise.resolve(this.channel.call("uninstall",[c,p]))}reinstallFromGallery(c){return Promise.resolve(this.channel.call("reinstallFromGallery",[c]))}getInstalled(c=null){return Promise.resolve(this.channel.call("getInstalled",[c])).then(p=>p.map(O=>g(O,null)))}updateMetadata(c,p){return Promise.resolve(this.channel.call("updateMetadata",[c,p])).then(O=>g(O,null))}updateExtensionScope(c,p){return Promise.resolve(this.channel.call("updateExtensionScope",[c,p])).then(O=>g(O,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=v;class w{constructor(c){this.service=c}listen(c,p){throw new Error("Invalid listen")}call(c,p,O){switch(p){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(O[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=w}),define(J[138],Z([0,1,22]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function b(_,A){const C=h=>{if(typeof h=="string"){const g=L.exec(h);if(!!g)return A[g[1]]||h}};return(0,f.cloneAndChange)(_,C)}e.localizeManifest=b}),define(J[51],Z([0,1,122]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function b(m){return m=m.trim(),m==="*"||L.test(m)}e.isValidVersionStr=b;function _(m){if(!b(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=m.match(L);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=_;function A(m){if(!m)return null;let v=m.majorBase,w=m.majorMustEqual,a=m.minorBase,c=m.minorMustEqual,p=m.patchBase,O=m.patchMustEqual;return m.hasCaret&&(v===0||(c=!1),O=!1),{majorBase:v,majorMustEqual:w,minorBase:a,minorMustEqual:c,patchBase:p,patchMustEqual:O,isMinimum:m.hasGreaterEquals}}e.normalizeVersion=A;function C(m,v){let w;typeof m=="string"?w=A(_(m)):w=m;let a;if(typeof v=="string"?a=A(_(v)):a=v,!w||!a)return!1;let c=w.majorBase,p=w.minorBase,O=w.patchBase,T=a.majorBase,d=a.minorBase,l=a.patchBase,s=a.majorMustEqual,t=a.minorMustEqual,i=a.patchMustEqual;return a.isMinimum?c>T?!0:c<T?!1:p>d?!0:p<d?!1:O>=l:(c===1&&T===0&&(!s||!t||!i)&&(T=1,d=0,l=0,s=!0,t=!1,i=!1),c<T?!1:c>T?!s:p<d?!1:p>d?!t:O<l?!1:O>l?!i:!0)}e.isValidVersion=C;function h(m,v,w){return v.isBuiltin||typeof v.main=="undefined"?!0:D(m,v.engines.vscode,w)}e.isValidExtensionVersion=h;function g(m,v){return m==="*"||D(v,m)}e.isEngineValid=g;function D(m,v,w=[]){let a=A(_(v));if(!a)return w.push(f.localize(0,null,v)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return w.push(f.localize(1,null,v)),!1}else if(!a.majorMustEqual)return w.push(f.localize(2,null,v)),!1;return C(m,a)?!0:(w.push(f.localize(3,null,m,v)),!1)}e.isVersionValid=D}),define(J[139],Z([0,1,5,2,7,24,17,43,11,37]),function(q,e,f,L,b,_,A,C,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCFileSystemProvider=void 0;class D extends L.Disposable{constructor(v){super();this.channel=v,this.session=(0,_.generateUuid)(),this._onDidChange=this._register(new f.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchErrorOccur=this._register(new f.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeCapabilities=this._register(new f.Emitter),this.onDidChangeCapabilities=this._onDidChangeCapabilities.event,this._capabilities=2|4|16|8|8192,this.registerListeners()}get capabilities(){return this._capabilities}registerListeners(){this._register(this.channel.listen("filechange",[this.session])(v=>{if(Array.isArray(v)){const w=v;this._onDidChange.fire(w.map(a=>({resource:b.URI.revive(a.resource),type:a.type})))}else{const w=v;this._onDidWatchErrorOccur.fire(w)}}))}setCaseSensitive(v){v?this._capabilities|=1024:this._capabilities&=~1024,this._onDidChangeCapabilities.fire(void 0)}stat(v){return this.channel.call("stat",[v])}open(v,w){return this.channel.call("open",[v,w])}close(v){return this.channel.call("close",[v])}async read(v,w,a,c,p){const[O,T]=await this.channel.call("read",[v,w,p]);return a.set(O.buffer.slice(0,T),c),T}async readFile(v){return(await this.channel.call("readFile",[v])).buffer}readFileStream(v,w,a){const c=(0,C.newWriteableStream)(O=>A.VSBuffer.concat(O.map(T=>A.VSBuffer.wrap(T))).buffer),p=this.channel.listen("readFileStream",[v,w])(O=>{if(O instanceof A.VSBuffer)c.write(O.buffer);else{if(O==="end")c.end();else{let T=O;T instanceof Error||(T=new Error((0,g.toErrorMessage)(T))),c.error(T),c.end()}p.dispose()}});return a.onCancellationRequested(()=>{c.error((0,h.canceled)()),c.end(),p.dispose()}),c}write(v,w,a,c,p){return this.channel.call("write",[v,w,A.VSBuffer.wrap(a),c,p])}writeFile(v,w,a){return this.channel.call("writeFile",[v,A.VSBuffer.wrap(w),a])}delete(v,w){return this.channel.call("delete",[v,w])}mkdir(v){return this.channel.call("mkdir",[v])}readdir(v){return this.channel.call("readdir",[v])}rename(v,w,a){return this.channel.call("rename",[v,w,a])}copy(v,w,a){return this.channel.call("copy",[v,w,a])}watch(v,w){const a=Math.random();return this.channel.call("watch",[this.session,a,v,w]),(0,L.toDisposable)(()=>this.channel.call("unwatch",[this.session,a]))}}e.IPCFileSystemProvider=D}),define(J[140],Z([0,1,34,50,2,8]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends b.Disposable{constructor(h,g,D,m){super();this.folders=h,this.onDidFilesChange=g,this.onLogMessage=D,this.verboseLogging=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const h=this._register(new L.Client(_.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=f.ProxyChannel.toService((0,f.getNextTickChannel)(h.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(h){this.verboseLogging=h,!this.isDisposed&&this.service&&this.service.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${h}`})}setFolders(h){this.folders=h,this.service&&this.service.setRoots(h)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(J[141],Z([0,1,34,50,2,8]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends b.Disposable{constructor(h,g,D,m,v={}){super();this.folders=h,this.onDidFilesChange=g,this.onLogMessage=D,this.verboseLogging=m,this.watcherOptions=v,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const h=this._register(new L.Client(_.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=f.ProxyChannel.toService((0,f.getNextTickChannel)(h.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${h}`})}setVerboseLogging(h){this.verboseLogging=h,this.service&&this.service.setVerboseLogging(h)}setFolders(h){this.folders=h,this.service&&this.service.setRoots(h)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(J[142],Z([0,1,40,65,94,8]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class A{constructor(h,g,D,m,v){this.watchedFolder=h,this.eventCallback=D,this.logCallback=m,this.verboseLogging=v,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(w=>b.parse(w)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${h}`),this.startWatcher()}startWatcher(){const h=[this.watchedFolder];this.verboseLogging&&h.push("-verbose"),this.handle=f.spawn(_.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",q).fsPath,h);const g=new L.LineDecoder;this.handle.stdout.on("data",D=>{const m=[];g.write(D).forEach(v=>{const w=v.split("|");if(w.length===2){const a=Number(w[0]),c=w[1];if(a>=0&&a<3){if(this.ignored&&this.ignored.some(p=>p(c))){this.verboseLogging&&this.log(c);return}m.push({type:A.changeTypeMap[a],path:c})}else this.log(w[1])}}),m.length>0&&this.eventCallback(m)}),this.handle.on("error",D=>this.onError(D)),this.handle.stderr.on("data",D=>this.onError(D)),this.handle.on("exit",(D,m)=>this.onExit(D,m))}onError(h){this.error("process error: "+h.toString())}onExit(h,g){this.handle&&(this.error(`terminated unexpectedly (code: ${h}, signal: ${g})`),this.restartCounter<=A.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(h){this.logCallback({type:"error",message:`[File Watcher (C#)] ${h}`})}log(h){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${h}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=A,A.MAX_RESTARTS=5,A.changeTypeMap=[0,1,2]}),define(J[143],Z([0,1,142,4,18]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class _{constructor(C,h,g,D){this.onDidFilesChange=h,this.onLogMessage=g,this.verboseLogging=D,this.service=void 0,this.folder=C[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=(0,b.rtrim)(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new f.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,C=>this.onFileEvents(C),C=>this.onLogMessage(C),this.verboseLogging)}setVerboseLogging(C){this.verboseLogging=C,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(C){this.isDisposed||C.length>0&&this.onDidFilesChange(C)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=_}),define(J[52],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class f{constructor(_,A=[],C=!1){this.ctor=_,this.staticArguments=A,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=f;const L=(b,..._)=>new f(b,_);e.createSyncDescriptor=L}),define(J[144],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class f{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=f;class L{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let A of this._nodes.values())A.outgoing.size===0&&_.push(A);return _}insertEdge(_,A){const C=this.lookupOrInsertNode(_),h=this.lookupOrInsertNode(A);C.outgoing.set(this._hashFn(A),h),h.incoming.set(this._hashFn(_),C)}removeNode(_){const A=this._hashFn(_);this._nodes.delete(A);for(let C of this._nodes.values())C.outgoing.delete(A),C.incoming.delete(A)}lookupOrInsertNode(_){const A=this._hashFn(_);let C=this._nodes.get(A);return C||(C=new f(_),this._nodes.set(A,C)),C}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[A,C]of this._nodes)_.push(`${A}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return _.join(`
`)}findCycleSlow(){for(let[_,A]of this._nodes){const C=new Set([_]),h=this._findCycle(A,C);if(h)return h}}_findCycle(_,A){for(let[C,h]of _.outgoing){if(A.has(C))return[...A,C].join(" -> ");A.add(C);const g=this._findCycle(h,A);if(g)return g;A.delete(C)}}}e.Graph=L}),define(J[6],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var f;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function h(g){return g[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=h})(f=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function L(C,h,g,D){h[f.DI_TARGET]===h?h[f.DI_DEPENDENCIES].push({id:C,index:g,optional:D}):(h[f.DI_DEPENDENCIES]=[{id:C,index:g,optional:D}],h[f.DI_TARGET]=h)}function b(C){if(f.serviceIds.has(C))return f.serviceIds.get(C);const h=function(g,D,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(h,g,m,!1)};return h.toString=()=>C,f.serviceIds.set(C,h),h}e.createDecorator=b;function _(C){return C}e.refineServiceDecorator=_;function A(C){return function(h,g,D){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(C,h,D,!0)}}e.optional=A}),define(J[145],Z([0,1,18,6,3]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let _=b.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",b.isMacintosh),A.set("isLinux",b.isLinux),A.set("isWindows",b.isWindows),A.set("isWeb",b.isWeb),A.set("isMacNative",b.isMacintosh&&!b.isWeb),A.set("isEdge",_.indexOf("Edg/")>=0),A.set("isFirefox",_.indexOf("Firefox")>=0),A.set("isChrome",_.indexOf("Chrome")>=0),A.set("isSafari",_.indexOf("Safari")>=0),A.set("isIPad",_.indexOf("iPad")>=0);const C=Object.prototype.hasOwnProperty;var h;(function(R){R[R.False=0]="False",R[R.True=1]="True",R[R.Defined=2]="Defined",R[R.Not=3]="Not",R[R.Equals=4]="Equals",R[R.NotEquals=5]="NotEquals",R[R.And=6]="And",R[R.Regex=7]="Regex",R[R.NotRegex=8]="NotRegex",R[R.Or=9]="Or",R[R.In=10]="In",R[R.NotIn=11]="NotIn",R[R.Greater=12]="Greater",R[R.GreaterEquals=13]="GreaterEquals",R[R.Smaller=14]="Smaller",R[R.SmallerEquals=15]="SmallerEquals"})(h=e.ContextKeyExprType||(e.ContextKeyExprType={}));class g{static false(){return m.INSTANCE}static true(){return v.INSTANCE}static has(u){return w.create(u)}static equals(u,P){return a.create(u,P)}static notEquals(u,P){return O.create(u,P)}static regex(u,P){return i.create(u,P)}static in(u,P){return c.create(u,P)}static not(u){return T.create(u)}static and(...u){return r.create(u)}static or(...u){return o.create(u)}static greater(u,P){return d.create(u,P)}static less(u,P){return s.create(u,P)}static deserialize(u,P=!1){if(!!u)return this._deserializeOrExpression(u,P)}static _deserializeOrExpression(u,P){let k=u.split("||");return o.create(k.map(W=>this._deserializeAndExpression(W,P)))}static _deserializeAndExpression(u,P){let k=u.split("&&");return r.create(k.map(W=>this._deserializeOne(W,P)))}static _deserializeOne(u,P){if(u=u.trim(),u.indexOf("!=")>=0){let k=u.split("!=");return O.create(k[0].trim(),this._deserializeValue(k[1],P))}if(u.indexOf("==")>=0){let k=u.split("==");return a.create(k[0].trim(),this._deserializeValue(k[1],P))}if(u.indexOf("=~")>=0){let k=u.split("=~");return i.create(k[0].trim(),this._deserializeRegexValue(k[1],P))}if(u.indexOf(" in ")>=0){let k=u.split(" in ");return c.create(k[0].trim(),k[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(u)){const k=u.split(">=");return l.create(k[0].trim(),k[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(u)){const k=u.split(">");return d.create(k[0].trim(),k[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(u)){const k=u.split("<=");return t.create(k[0].trim(),k[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(u)){const k=u.split("<");return s.create(k[0].trim(),k[1].trim())}return/^\!\s*/.test(u)?T.create(u.substr(1).trim()):w.create(u)}static _deserializeValue(u,P){if(u=u.trim(),u==="true")return!0;if(u==="false")return!1;let k=/^'([^']*)'$/.exec(u);return k?k[1].trim():u}static _deserializeRegexValue(u,P){if((0,f.isFalsyOrWhitespace)(u)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let k=u.indexOf("/"),W=u.lastIndexOf("/");if(k===W||k<0){if(P)throw new Error(`bad regexp-value '${u}', missing /-enclosure`);return console.warn(`bad regexp-value '${u}', missing /-enclosure`),null}let Q=u.slice(k+1,W),z=u[W+1]==="i"?"i":"";try{return new RegExp(Q,z)}catch(H){if(P)throw new Error(`bad regexp-value '${u}', parse error: ${H}`);return console.warn(`bad regexp-value '${u}', parse error: ${H}`),null}}}e.ContextKeyExpr=g;function D(R,u){return R.cmp(u)}class m{constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=m,m.INSTANCE=new m;class v{constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return m.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class w{constructor(u){this.key=u,this.type=2}static create(u){const P=A.get(u);return typeof P=="boolean"?P?v.INSTANCE:m.INSTANCE:new w(u)}cmp(u){return u.type!==this.type?this.type-u.type:E(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return T.create(this.key)}}e.ContextKeyDefinedExpr=w;class a{constructor(u,P){this.key=u,this.value=P,this.type=4}static create(u,P){if(typeof P=="boolean")return P?w.create(u):T.create(u);const k=A.get(u);return typeof k=="boolean"?P===(k?"true":"false")?v.INSTANCE:m.INSTANCE:new a(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:F(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(u){return u.mapEquals(this.key,this.value)}negate(){return O.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class c{constructor(u,P){this.key=u,this.valueKey=P,this.type=10}static create(u,P){return new c(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:F(this.key,this.valueKey,u.key,u.valueKey)}equals(u){return u.type===this.type?this.key===u.key&&this.valueKey===u.valueKey:!1}evaluate(u){const P=u.getValue(this.valueKey),k=u.getValue(this.key);return Array.isArray(P)?P.indexOf(k)>=0:typeof k=="string"&&typeof P=="object"&&P!==null?C.call(P,k):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(u){return u.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}e.ContextKeyInExpr=c;class p{constructor(u){this._actual=u,this.type=11}static create(u){return new p(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new p(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class O{constructor(u,P){this.key=u,this.value=P,this.type=5}static create(u,P){if(typeof P=="boolean")return P?T.create(u):w.create(u);const k=A.get(u);return typeof k=="boolean"?P===(k?"true":"false")?m.INSTANCE:v.INSTANCE:new O(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:F(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(u){return u.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=O;class T{constructor(u){this.key=u,this.type=3}static create(u){const P=A.get(u);return typeof P=="boolean"?P?m.INSTANCE:v.INSTANCE:new T(u)}cmp(u){return u.type!==this.type?this.type-u.type:E(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!u.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(u){return u.mapNot(this.key)}negate(){return w.create(this.key)}}e.ContextKeyNotExpr=T;class d{constructor(u,P){this.key=u,this.value=P,this.type=12}static create(u,P){return new d(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:F(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class l{constructor(u,P){this.key=u,this.value=P,this.type=13}static create(u,P){return new l(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:F(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreaterEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class s{constructor(u,P){this.key=u,this.value=P,this.type=14}static create(u,P){return new s(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:F(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=s;class t{constructor(u,P){this.key=u,this.value=P,this.type=15}static create(u,P){return new t(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:F(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(u,P){this.key=u,this.regexp=P,this.type=7}static create(u,P){return new i(u,P)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.key<u.key)return-1;if(this.key>u.key)return 1;const P=this.regexp?this.regexp.source:"",k=u.regexp?u.regexp.source:"";return P<k?-1:P>k?1:0}equals(u){if(u.type===this.type){const P=this.regexp?this.regexp.source:"",k=u.regexp?u.regexp.source:"";return this.key===u.key&&P===k}return!1}evaluate(u){let P=u.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const u=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${u}`}keys(){return[this.key]}map(u){return u.mapRegex(this.key,this.regexp)}negate(){return n.create(this)}}e.ContextKeyRegexExpr=i;class n{constructor(u){this._actual=u,this.type=8}static create(u){return new n(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new n(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class r{constructor(u){this.expr=u,this.type=6}static create(u){return r._normalizeArr(u)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let P=0,k=this.expr.length;P<k;P++){const W=D(this.expr[P],u.expr[P]);if(W!==0)return W}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let P=0,k=this.expr.length;P<k;P++)if(!this.expr[P].equals(u.expr[P]))return!1;return!0}return!1}evaluate(u){for(let P=0,k=this.expr.length;P<k;P++)if(!this.expr[P].evaluate(u))return!1;return!0}static _normalizeArr(u){const P=[];let k=!1;for(const W of u)if(!!W){if(W.type===1){k=!0;continue}if(W.type===0)return m.INSTANCE;if(W.type===6){P.push(...W.expr);continue}P.push(W)}if(P.length===0&&k)return v.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(D);P.length>1;){const W=P[P.length-1];if(W.type!==9)break;P.pop();const Q=P.pop(),z=o.create(W.expr.map(H=>r.create([H,Q])));z&&(P.push(z),P.sort(D))}return P.length===1?P[0]:new r(P)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(let P of this.expr)u.push(...P.keys());return u}map(u){return new r(this.expr.map(P=>P.map(u)))}negate(){let u=[];for(let P of this.expr)u.push(P.negate());return o.create(u)}}e.ContextKeyAndExpr=r;class o{constructor(u){this.expr=u,this.type=9}static create(u){const P=o._normalizeArr(u);if(P.length!==0)return P.length===1?P[0]:new o(P)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let P=0,k=this.expr.length;P<k;P++){const W=D(this.expr[P],u.expr[P]);if(W!==0)return W}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let P=0,k=this.expr.length;P<k;P++)if(!this.expr[P].equals(u.expr[P]))return!1;return!0}return!1}evaluate(u){for(let P=0,k=this.expr.length;P<k;P++)if(this.expr[P].evaluate(u))return!0;return!1}static _normalizeArr(u){let P=[],k=!1;if(u){for(let W=0,Q=u.length;W<Q;W++){const z=u[W];if(!!z){if(z.type===0){k=!0;continue}if(z.type===1)return[v.INSTANCE];if(z.type===9){P=P.concat(z.expr);continue}P.push(z)}}if(P.length===0&&k)return[m.INSTANCE];P.sort(D)}return P}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(let P of this.expr)u.push(...P.keys());return u}map(u){return new o(this.expr.map(P=>P.map(u)))}negate(){let u=[];for(let k of this.expr)u.push(k.negate());const P=k=>k.type===9?k.expr:[k];for(;u.length>1;){const k=u.shift(),W=u.shift(),Q=[];for(const z of P(k))for(const H of P(W))Q.push(g.and(z,H));u.unshift(g.or(...Q))}return u[0]}}e.ContextKeyOrExpr=o;class y extends w{constructor(u,P,k){super(u);this._defaultValue=P,typeof k=="object"?y._info.push(Object.assign(Object.assign({},k),{key:u})):k!==!0&&y._info.push({key:u,description:k,type:P!=null?typeof P:void 0})}static all(){return y._info.values()}bindTo(u){return u.createKey(this.key,this._defaultValue)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return g.not(this.key)}isEqualTo(u){return g.equals(this.key,u)}notEqualsTo(u){return g.notEquals(this.key,u)}}e.RawContextKey=y,y._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(R,u){return R<u?-1:R>u?1:0}function F(R,u,P,k){return R<P?-1:R>P?1:u<k?-1:u>k?1:0}}),define(J[146],Z([0,1,6]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,f.createDecorator)("downloadService")}),define(J[21],Z([0,1,6]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,f.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,f.refineServiceDecorator)(e.IEnvironmentService)});var ge=this&&this.__param||function(q,e){return function(f,L){e(f,L,q)}};define(J[147],Z([0,1,21,4,19,11,2,13]),function(q,e,f,L,b,_,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let h=class extends A.Disposable{constructor(D){super();this.environmentService=D,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let D=setTimeout(()=>{D=void 0;const m=(0,L.basename)(this.environmentService.logsPath),v=(0,L.dirname)(this.environmentService.logsPath);(0,b.readdir)(v).then(w=>{const c=w.filter(O=>/^\d{8}T\d{6}$/.test(O)).sort().filter((O,T)=>O!==m),p=c.slice(0,Math.max(0,c.length-9));return C.Promises.settled(p.map(O=>(0,b.rimraf)((0,L.join)(v,O))))}).then(null,_.onUnexpectedError)},10*1e3);this._register((0,A.toDisposable)(()=>{D&&(clearTimeout(D),D=void 0)}))}};h=ve([ge(0,f.IEnvironmentService)],h),e.LogsDataCleaner=h}),define(J[29],Z([0,1,117,6,8]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function _(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=_;var A;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=5]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var C;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var h;(function(m){m.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var g;(function(m){m[m.None=0]="None",m[m.Install=1]="Install",m[m.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class D extends Error{constructor(v,w){super(v);this.code=w}}e.ExtensionManagementError=D,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=b.FileAccess.asBrowserUri("./media/defaultIcon.png",q).toString(!0),e.ExtensionsLabel=(0,f.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,f.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")}),define(J[41],Z([0,1,18,6]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function b(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=b,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(_=e.ExtensionType||(e.ExtensionType={}));class A{constructor(D){this.value=D,this._lower=D.toLowerCase()}static equals(D,m){if(typeof D=="undefined"||D===null)return typeof m=="undefined"||m===null;if(typeof m=="undefined"||m===null)return!1;if(typeof D=="string"||typeof m=="string"){let v=typeof D=="string"?D:D.value,w=typeof m=="string"?m:m.value;return f.equalsIgnoreCase(v,w)}return D._lower===m._lower}static toKey(D){return typeof D=="string"?D.toLowerCase():D._lower}}e.ExtensionIdentifier=A;function C(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function h(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=h,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[30],Z([0,1,18,41]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function b(w,a){return w.uuid&&a.uuid?w.uuid===a.uuid:w.id===a.id?!0:(0,f.compareIgnoreCase)(w.id,a.id)===0}e.areSameExtensions=b;class _{constructor(a,c){this.version=c,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof _?b(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=_;function A(w,a){return`${w}.${a}`}e.getExtensionId=A;function C(w){return w.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function h(w,a){return C(A(w,a))}e.getGalleryExtensionId=h;function g(w,a){const c=[],p=O=>{for(const T of c)if(T.some(d=>b(a(d),a(O))))return T;return null};for(const O of w){const T=p(O);T?T.push(O):c.push([O])}return c}e.groupByExtension=g;function D(w){return{id:w.identifier.id,name:w.manifest.name,galleryId:null,publisherId:w.publisherId,publisherName:w.manifest.publisher,publisherDisplayName:w.publisherDisplayName,dependencies:w.manifest.extensionDependencies&&w.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=D;function m(w){return Object.assign({id:w.identifier.id,name:w.name,galleryId:w.identifier.uuid,publisherId:w.publisherId,publisherName:w.publisher,publisherDisplayName:w.publisherDisplayName,dependencies:!!(w.properties.dependencies&&w.properties.dependencies.length>0)},w.telemetryData)}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function v(w){const a=new Set;for(const c of w)c.malicious&&a.add(c.id.id);return a}e.getMaliciousExtensionsSet=v}),define(J[148],Z([0,1,118,11,7,44,29,30,41,64,27,8]),function(q,e,f,L,b,_,A,C,h,g,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=e.getIdAndVersion=void 0;const v=T=>(0,f.localize)(0,null,T),w=(0,f.localize)(1,null,"ms-dotnettools.csharp");function a(T,d){return d?`${T.publisher}.${T.name}@${T.version}`:`${T.publisher}.${T.name}`}const c=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function p(T){const d=c.exec(T);return d&&d[1]?[(0,C.adoptToGalleryExtensionId)(d[1]),d[2]]:[(0,C.adoptToGalleryExtensionId)(T),void 0]}e.getIdAndVersion=p;let O=class{constructor(d,l){this.extensionManagementService=d,this.extensionGalleryService=l}get location(){}async listExtensions(d,l,s=console){let t=await this.extensionManagementService.getInstalled(1);const i=h.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(l&&l!==""){if(i.indexOf(l.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}t=t.filter(r=>r.manifest.categories?r.manifest.categories.map(y=>y.toLowerCase()).indexOf(l.toLowerCase())>-1:!1)}else if(l===""){s.log("Possible Categories: "),i.forEach(r=>{s.log(r)});return}this.location&&s.log((0,f.localize)(2,null,this.location)),t=t.sort((r,o)=>r.identifier.id.localeCompare(o.identifier.id));let n;for(let r of t)n!==r.identifier.id&&(n=r.identifier.id,s.log(a(r.manifest,d)))}async installExtensions(d,l,s,t,i=console){const n=[],r=[];d.length&&i.log(this.location?(0,f.localize)(3,null,this.location):(0,f.localize)(4,null));const o=await this.extensionManagementService.getInstalled(1),y=(R,u)=>{const P=o.find(k=>(0,C.areSameExtensions)(k.identifier,{id:R}));if(P){if(!u&&!t)return i.log((0,f.localize)(5,null,R,P.manifest.version,R)),!1;if(u&&P.manifest.version===u)return i.log((0,f.localize)(6,null,`${R}@${u}`)),!1}return!0},E=[],F=[];for(const R of d)if(R instanceof b.URI)E.push(R);else{const[u,P]=p(R);y(u,P)&&F.push({id:u,version:P,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const R of l){const[u,P]=p(R);y(u,P)&&F.push({id:u,version:P,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(E.length&&await Promise.all(E.map(async R=>{try{const u=await this.installVSIX(R,{isBuiltin:!1,isMachineScoped:s},t,i);u&&r.push(u)}catch(u){i.error(u.message||u.stack||u),n.push(R.toString())}})),F.length){const R=await this.getGalleryExtensions(F);await Promise.all(F.map(async u=>{const P=R.get(u.id.toLowerCase());if(P)try{const k=await this.installFromGallery(u,P,o,t,i);k&&r.push(k)}catch(k){i.error(k.message||k.stack||k),n.push(u.id)}else i.error(`${v(u.version?`${u.id}@${u.version}`:u.id)}
${w}`),n.push(u.id)}))}if(n.length)throw new Error((0,f.localize)(7,null,n.join(", ")))}async installVSIX(d,l,s,t){const i=await this.extensionManagementService.getManifest(d);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,t))try{return await this.extensionManagementService.install(d,l),t.log((0,f.localize)(8,null,(0,g.getBaseLabel)(d))),i}catch(r){if((0,L.isPromiseCanceledError)(r))return t.log((0,f.localize)(9,null,(0,g.getBaseLabel)(d))),null;throw r}return null}async getGalleryExtensions(d){const l=d.filter(({version:i})=>i===void 0).map(({id:i})=>i),s=d.filter(({version:i})=>i!==void 0),t=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(l,D.CancellationToken.None)).forEach(n=>t.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(s.map(async({id:i,version:n})=>{const r=await this.extensionGalleryService.getCompatibleExtension({id:i},n);r&&t.set(r.identifier.id.toLowerCase(),r)}))]),t}async installFromGallery({id:d,version:l,installOptions:s},t,i,n,r){const o=await this.extensionGalleryService.getManifest(t,D.CancellationToken.None);if(o&&!this.validateExtensionKind(o,r))return null;const y=i.find(E=>(0,C.areSameExtensions)(E.identifier,t.identifier));if(y){if(t.version===y.manifest.version)return r.log((0,f.localize)(10,null,l?`${d}@${l}`:d)),null;r.log((0,f.localize)(11,null,d,t.version))}try{return s.isBuiltin?r.log((0,f.localize)(12,null,d,t.version)):r.log((0,f.localize)(13,null,d,t.version)),await this.extensionManagementService.installFromGallery(t,s),r.log((0,f.localize)(14,null,d,t.version)),o}catch(E){if((0,L.isPromiseCanceledError)(E))return r.log((0,f.localize)(15,null,d)),null;throw E}}validateExtensionKind(d,l){return!0}async validateVSIX(d,l,s){const t={id:(0,C.getGalleryExtensionId)(d.publisher,d.name)},n=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,C.areSameExtensions)(t,r.identifier)&&(0,_.gt)(r.manifest.version,d.version));return n&&!l?(s.log((0,f.localize)(16,null,n.identifier.id,n.manifest.version,d.version)),!1):this.validateExtensionKind(d,s)}async uninstallExtensions(d,l,s=console){const t=async n=>{if(n instanceof b.URI){const r=await this.extensionManagementService.getManifest(n);return a(r)}return n},i=[];for(const n of d){const r=await t(n),y=(await this.extensionManagementService.getInstalled()).filter(E=>(0,C.areSameExtensions)(E.identifier,{id:r}));if(!y.length)throw new Error(`${this.notInstalled(r)}
${w}`);if(y.some(E=>E.type===0)){s.log((0,f.localize)(17,null,r));return}if(!l&&y.some(E=>E.isBuiltin)){s.log((0,f.localize)(18,null,r));return}s.log((0,f.localize)(19,null,r));for(const E of y)await this.extensionManagementService.uninstall(E),i.push(E);this.location?s.log((0,f.localize)(20,null,r,this.location)):s.log((0,f.localize)(21,null,r))}}async locateExtension(d,l=console){const s=await this.extensionManagementService.getInstalled();d.forEach(t=>{s.forEach(i=>{if(i.identifier.id===t&&i.location.scheme===m.Schemas.file){l.log(i.location.fsPath);return}})})}notInstalled(d){return this.location?(0,f.localize)(22,null,d,this.location):(0,f.localize)(23,null,d)}};O=ve([ge(0,A.IExtensionManagementService),ge(1,A.IExtensionGalleryService)],O),e.ExtensionManagementCLIService=O}),define(J[149],Z([0,1,2,4,41,19]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends f.Disposable{constructor(h,g){super();this.environmentService=h,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,b.MANIFEST_CACHE_FOLDER,b.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtension(D=>this.onDidInstallExtension(D))),this._register(g.onDidUninstallExtension(D=>this.onDidUnInstallExtension(D)))}onDidInstallExtension(h){h.error||this.invalidate()}onDidUnInstallExtension(h){h.error||this.invalidate()}invalidate(){_.rimraf(this.extensionsManifestCache,_.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(J[20],Z([0,1,124,4,7,6,18,12,33]),function(q,e,f,L,b,_,A,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function g(z){return z.create===!0}e.isFileOpenForWriteOptions=g;var D;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(D=e.FileType||(e.FileType={}));var m;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=v;function w(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=w;function a(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function c(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=c;var p;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class O extends Error{constructor(H,Y){super(H);this.code=Y}}e.FileSystemProviderError=O;function T(z,H){const Y=new O(z.toString(),H);return l(Y,H),Y}e.createFileSystemProviderError=T;function d(z){return z||T((0,f.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=d;function l(z,H){return z.name=H?`${H} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=l;function s(z){if(!z)return p.Unknown;if(z instanceof O)return z.code;const H=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!H)return p.Unknown;switch(H[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=s;function t(z){if(z instanceof E)return z.fileOperationResult;switch(s(z)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor(H,Y,B){this.resource=H,this.operation=Y,this.target=B}isOperation(H){return this.operation===H}}e.FileOperationEvent=n;var r;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class o{constructor(H,Y){this.ignorePathCasing=Y,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=H;for(const B of H)switch(B.type){case 1:this.added||(this.added=h.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=h.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=h.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(B.resource,B);break}}contains(H,...Y){return this.doContains(H,{includeChildren:!1},...Y)}affects(H,...Y){return this.doContains(H,{includeChildren:!0},...Y)}doContains(H,Y,...B){var x,U,S,I,N,M;if(!H)return!1;const $=B.length>0;return!!((!$||B.includes(1))&&(((x=this.added)===null||x===void 0?void 0:x.get(H))||Y.includeChildren&&((U=this.added)===null||U===void 0?void 0:U.findSuperstr(H)))||(!$||B.includes(0))&&(((S=this.updated)===null||S===void 0?void 0:S.get(H))||Y.includeChildren&&((I=this.updated)===null||I===void 0?void 0:I.findSuperstr(H)))||(!$||B.includes(2))&&(((N=this.deleted)===null||N===void 0?void 0:N.findSubstr(H))||Y.includeChildren&&((M=this.deleted)===null||M===void 0?void 0:M.findSuperstr(H))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(H){const Y=[],B=H===1?this.added:H===0?this.updated:this.deleted;if(B)for(const[,x]of B)Y.push(x);return Y}filter(H){return new o(this.changes.filter(Y=>H(Y)),this.ignorePathCasing)}}e.FileChangesEvent=o;function y(z,H,Y){return!z||!H||z===H||H.length>z.length?!1:(H.charAt(H.length-1)!==L.sep&&(H+=L.sep),Y?(0,A.startsWithIgnoreCase)(z,H):z.indexOf(H)===0)}e.isParent=y;class E extends Error{constructor(H,Y,B){super(H);this.fileOperationResult=Y,this.options=B}static isFileOperationError(H){return H instanceof Error&&!(0,C.isUndefinedOrNull)(H.fileOperationResult)}}e.FileOperationError=E;var F;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function u(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=u;async function P(z,H){if(!H.canHandleResource(b.URI.from({scheme:z.scheme})))return new Promise(Y=>{const B=H.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===z.scheme&&x.added&&(B.dispose(),Y())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class k{static formatSize(H){return(0,C.isNumber)(H)||(H=0),H<k.KB?(0,f.localize)(1,null,H.toFixed(0)):H<k.MB?(0,f.localize)(2,null,(H/k.KB).toFixed(2)):H<k.GB?(0,f.localize)(3,null,(H/k.MB).toFixed(2)):H<k.TB?(0,f.localize)(4,null,(H/k.GB).toFixed(2)):(0,f.localize)(5,null,(H/k.TB).toFixed(2))}}e.ByteSize=k,k.KB=1024,k.MB=k.KB*k.KB,k.GB=k.MB*k.KB,k.TB=k.GB*k.KB;var W;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(W=e.Arch||(e.Arch={}));function Q(z){return{maxFileSize:z===0?300*k.MB:16*k.GB,maxHeapSize:z===0?700*k.MB:2*700*k.MB}}e.getPlatformLimits=Q}),define(J[150],Z([0,1,207,116,20,135]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(v,w){const a={onUnknownOption:p=>{console.warn((0,L.localize)(0,null,p))},onMultipleValues:(p,O)=>{console.warn((0,L.localize)(1,null,p,O))}},c=(0,_.parseArgs)(v,_.OPTIONS,w?a:void 0);return c.goto&&c._.forEach(p=>f(/^(\w:)?[^:]+(:\d*){0,2}$/.test(p),(0,L.localize)(2,null))),c["max-memory"]&&f(parseInt(c["max-memory"])>=b.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${b.MIN_MAX_MEMORY_SIZE_MB} MB.`),c}function C(v){const w=v.findIndex(a=>!/^-/.test(a));if(w>-1)return[...v.slice(0,w),...v.slice(w+1)]}function h(v){let[,...w]=v;process.env.VSCODE_DEV&&(w=C(w)||[]);const a=!m(process.env);return A(w,a)}e.parseMainProcessArgv=h;function g(v){const[,,...w]=v;return A(w,!0)}e.parseCLIProcessArgv=g;function D(v,...w){const a=v.indexOf("--");return a===-1?v.push(...w):v.splice(a,0,...w),v}e.addArg=D;function m(v){return v.VSCODE_CLI==="1"}e.isLaunchedFromCli=m}),define(J[151],Z([0,1,36,40,24,3,150,37,112]),function(q,e,f,L,b,_,A,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function g(v,w,a){return w["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):_.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,A.isLaunchedFromCli)(a)&&!w["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,A.isLaunchedFromCli)(a)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),D||(D=m(v)),D)}e.resolveShellEnv=g;let D;async function m(v){const w=new Promise(async(a,c)=>{const p=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",p);const O=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",O);const T=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),d=new RegExp(T+"(.*)"+T),l=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});v.trace("getUnixShellEnvironment#env",l);const s=await(0,h.getSystemShell)(_.OS,l);v.trace("getUnixShellEnvironment#shell",s);const t=f.basename(s);let i,n;/^pwsh(-preview)?$/.test(t)?(i=`& '${process.execPath}' -p '''${T}'' + JSON.stringify(process.env) + ''${T}'''`,n=["-Login","-Command"]):(i=`'${process.execPath}' -p '"${T}" + JSON.stringify(process.env) + "${T}"'`,n=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(n),i);const r=(0,L.spawn)(s,[...n,i],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});r.on("error",E=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(E)),a({})});const o=[];r.stdout.on("data",E=>o.push(E));const y=[];r.stderr.on("data",E=>y.push(E)),r.on("close",(E,F)=>{const R=Buffer.concat(o).toString("utf8");v.trace("getUnixShellEnvironment#raw",R);const u=Buffer.concat(y).toString("utf8");if(u.trim()&&v.trace("getUnixShellEnvironment#stderr",u),E||F)return c(new Error(`Failed to get environment (code ${E}, signal ${F})`));const P=d.exec(R),k=P?P[1]:"{}";try{const W=JSON.parse(k);p?W.ELECTRON_RUN_AS_NODE=p:delete W.ELECTRON_RUN_AS_NODE,O?W.ELECTRON_NO_ATTACH_CONSOLE=O:delete W.ELECTRON_NO_ATTACH_CONSOLE,delete W.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",W),a(W)}catch(W){v.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(W)),c(W)}})});try{return await w}catch(a){return v.error("getUnixShellEnvironment#error",(0,C.toErrorMessage)(a)),{}}}}),define(J[69],Z([0,1,7,20,3]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function _(h){return h.map(g=>({type:g.type,resource:f.URI.file(g.path)}))}e.toFileChanges=_;function A(h){const g=new C;for(const D of h)g.processEvent(D);return g.normalize()}e.normalizeFileChanges=A;class C{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const D=this.mapPathToChange.get(g.path);if(D){const m=D.type,v=g.type;m===1&&v===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(D),1)):m===2&&v===1?D.type=0:m===1&&v===0||(D.type=v)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],D=[];return this.normalized.filter(m=>m.type!==2?(g.push(m),!1):!0).sort((m,v)=>m.path.length-v.path.length).filter(m=>D.some(v=>(0,L.isParent)(m.path,v,!b.isLinux))?!1:(D.push(m.path),!0)).concat(g)}}}),define(J[152],Z([0,1,69,2,19,99,102,13,4]),function(q,e,f,L,b,_,A,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class g extends L.Disposable{constructor(m,v,w,a){super();this.path=m,this.onDidFilesChange=v,this.onLogMessage=w,this.verboseLogging=a,this.fileChangesDelayer=this._register(new C.ThrottledDelayer(A.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(m){this.verboseLogging=m}async startWatching(){try{const{stat:m,symbolicLink:v}=await b.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let w=this.path;if(v)try{w=await(0,_.realpath)(w)}catch(a){if(this.onError(a),v.dangling)return}m.isDirectory()?this._register((0,A.watchFolder)(w,(a,c)=>{this.onFileChange({type:a==="changed"?0:a==="added"?1:2,path:(0,h.join)(this.path,(0,h.basename)(c))})},a=>this.onError(a))):this._register((0,A.watchFile)(w,a=>{this.onFileChange({type:a==="changed"?0:2,path:this.path})},a=>this.onError(a)))}catch(m){m.code!=="ENOENT"&&this.onError(m)}}onFileChange(m){this.fileChangesBuffer.push(m),this.verboseLogging&&this.onVerbose(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,f.normalizeFileChanges)(v);this.verboseLogging&&w.forEach(a=>{this.onVerbose(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`)}),w.length>0&&this.onDidFilesChange(w)})}onError(m){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${m}`})}onVerbose(m){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=g}),define(J[53],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class f{constructor(...b){this._entries=new Map;for(let[_,A]of b)this.set(_,A)}set(b,_){const A=this._entries.get(b);return this._entries.set(b,_),A}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=f}),define(J[70],Z([0,1,11,144,52,6,53,13]),function(q,e,f,L,b,_,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const h=!1;class g extends Error{constructor(a){var c;super("cyclic dependency between services");this.message=(c=a.findCycleSlow())!==null&&c!==void 0?c:`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class D{constructor(a=new A.ServiceCollection,c=!1,p){this._activeInstantiations=new Set,this._services=a,this._strict=c,this._parent=p,this._services.set(_.IInstantiationService,this)}createChild(a){return new D(a,this._strict,this)}invokeFunction(a,...c){let p=v.traceInvocation(a),O=!1;try{return a({get:(d,l)=>{if(O)throw(0,f.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(d,p);if(!s&&l!==_.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return s}},...c)}finally{O=!0,p.stop()}}createInstance(a,...c){let p,O;return a instanceof b.SyncDescriptor?(p=v.traceCreation(a.ctor),O=this._createInstance(a.ctor,a.staticArguments.concat(c),p)):(p=v.traceCreation(a),O=this._createInstance(a,c,p)),p.stop(),O}_createInstance(a,c=[],p){let O=_._util.getServiceDependencies(a).sort((l,s)=>l.index-s.index),T=[];for(const l of O){let s=this._getOrCreateServiceInstance(l.id,p);if(!s&&this._strict&&!l.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${l.id}.`);T.push(s)}let d=O.length>0?O[0].index:c.length;if(c.length!==d){console.warn(`[createInstance] First service dependency of ${a.name} at position ${d+1} conflicts with ${c.length} static arguments`);let l=d-c.length;l>0?c=c.concat(new Array(l)):c=c.slice(0,d)}return new a(...[...c,...T])}_setServiceInstance(a,c){if(this._services.get(a)instanceof b.SyncDescriptor)this._services.set(a,c);else if(this._parent)this._parent._setServiceInstance(a,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let c=this._services.get(a);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):c}_getOrCreateServiceInstance(a,c){let p=this._getServiceInstanceOrDescriptor(a);return p instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,p,c.branch(a,!0)):(c.branch(a,!1),p)}_safeCreateAndCacheServiceInstance(a,c,p){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,c,p)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,c,p){const O=new L.Graph(l=>l.id.toString());let T=0;const d=[{id:a,desc:c,_trace:p}];for(;d.length;){const l=d.pop();if(O.lookupOrInsertNode(l),T++>1e3)throw new g(O);for(let s of _._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${a} depends on ${s.id} which is NOT registered.`),t instanceof b.SyncDescriptor){const i={id:s.id,desc:t,_trace:l._trace.branch(s.id,!0)};O.insertEdge(l,i),d.push(i)}}}for(;;){const l=O.roots();if(l.length===0){if(!O.isEmpty())throw new g(O);break}for(const{data:s}of l){if(this._getServiceInstanceOrDescriptor(s.id)instanceof b.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}O.removeNode(s)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,c,p=[],O,T){if(this._services.get(a)instanceof b.SyncDescriptor)return this._createServiceInstance(c,p,O,T);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,c,p,O,T);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(a,c=[],p,O){if(p){const T=new C.IdleValue(()=>this._createInstance(a,c,O));return new Proxy(Object.create(null),{get(d,l){if(l in d)return d[l];let s=T.value,t=s[l];return typeof t!="function"||(t=t.bind(s),d[l]=t),t},set(d,l,s){return T.value[l]=s,!0}})}else return this._createInstance(a,c,O)}}e.InstantiationService=D;var m;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(m||(m={}));class v{constructor(a,c){this.type=a,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return h?new v(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(a){return h?new v(0,a.name):v._None}branch(a,c){let p=new v(2,a.toString());return this._dep.push([a,c,p]),p}stop(){let a=Date.now()-this._start;v._totals+=a;let c=!1;function p(T,d){let l=[],s=new Array(T+1).join("	");for(const[t,i,n]of d._dep)if(i&&n){c=!0,l.push(`${s}CREATES -> ${t}`);let r=p(T+1,n);r&&l.push(r)}else l.push(`${s}uses -> ${t}`);return l.join(`
`)}let O=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(a>2||c)&&console.log(O.join(`
`))}}v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(J[153],Z([0,1,6]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,f.createDecorator)("labelService")}),define(J[54],Z([0,1,6]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,f.createDecorator)("localizationsService");function L(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const _ of b.translations)if(typeof _.id!="string"||typeof _.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}e.isValidLocalization=L}),define(J[14],Z([0,1,6,2,3,5,37]),function(q,e,f,L,b,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,f.createDecorator)("logService"),e.ILoggerService=(0,f.createDecorator)("loggerService");function C(){return new Date().toISOString()}var h;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;class g extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=g;class D extends g{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(h.Trace)&&this.log(h.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(h.Debug)&&this.log(h.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(h.Info)&&this.log(h.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(h.Warning)&&this.log(h.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(h.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(h.Error,this.format(n))}else this.log(h.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(h.Critical)&&this.log(h.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let n=0;n<t.length;n++){let r=t[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(o){}i+=(n>0?" ":"")+r}return i}}e.AbstractMessageLogger=D;class m extends g{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!b.isWindows}trace(t,...i){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...i):console.log(`[main ${C()}]`,t,...i))}debug(t,...i){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...i):console.log(`[main ${C()}]`,t,...i))}info(t,...i){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...i):console.log(`[main ${C()}]`,t,...i))}warn(t,...i){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...i):console.warn(`[main ${C()}]`,t,...i))}error(t,...i){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...i):console.error(`[main ${C()}]`,t,...i))}critical(t,...i){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...i):console.error(`[main ${C()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class v extends g{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=v;class w extends g{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,A.toErrorMessage)(t,this.getLevel()<=h.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class a extends g{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const n of this.logServices)n.trace(t,...i)}debug(t,...i){for(const n of this.logServices)n.debug(t,...i)}info(t,...i){for(const n of this.logServices)n.info(t,...i)}warn(t,...i){for(const n of this.logServices)n.warn(t,...i)}error(t,...i){for(const n of this.logServices)n.error(t,...i)}critical(t,...i){for(const n of this.logServices)n.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class c extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=c;class p extends L.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}createLogger(t,i){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,(i==null?void 0:i.always)?h.Trace:this.logLevel,i),this.loggers.set(t.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class O{constructor(){this.onDidChangeLogLevel=new _.Emitter().event}setLevel(t){}getLevel(){return h.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=O;function T(s){if(s.verbose)return h.Trace;if(typeof s.logLevel=="string"){const t=d(s.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=T;function d(s){switch(s){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}e.parseLogLevel=d;function l(s){switch(s){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}e.LogLevelToString=l}),define(J[154],Z([0,1,16,2,20,29,21,7,15,30,14,24,44,3,13,11]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let O=class extends L.Disposable{constructor(d,l,s,t){super();this.fileService=l,this.extensionGalleryService=s,this.logService=t,this.extensionsDownloadDir=C.URI.file(d.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(d,l){await this.cleanUpPromise;const s=this.getName(d),t=(0,h.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(t)){const i=(0,h.joinPath)(this.extensionsDownloadDir,`.${(0,m.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(d,i,l);try{await this.rename(i,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",d.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,c.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return t}async delete(d){}async rename(d,l,s){try{await f.promises.rename(d.fsPath,l.fsPath)}catch(t){if(w.isWindows&&t&&t.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${d} to ${l} with 'EPERM' error. Trying again...`),this.rename(d,l,s);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const d=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(d.children){const l=[],s=[];for(const n of d.children){const r=this.parse(n.name);r&&s.push([r,n])}const t=(0,g.groupByExtension)(s,([n])=>n),i=[];for(const n of t)n.sort((r,o)=>v.rcompare(r[0].version,o[0].version)),l.push(...n.slice(1).map(r=>r[1].resource)),i.push(n[0][1]);i.sort((n,r)=>n.mtime-r.mtime),l.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await a.Promises.settled(l.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(d){this.logService.error(d)}}getName(d){return this.cache?new g.ExtensionIdentifierWithVersion(d.identifier,d.version).key().toLowerCase():(0,m.generateUuid)()}parse(d){const l=p.exec(d);return l&&l[1]&&l[2]?new g.ExtensionIdentifierWithVersion({id:l[1]},l[2]):null}};O=ve([ge(0,A.INativeEnvironmentService),ge(1,b.IFileService),ge(2,_.IExtensionGalleryService),ge(3,D.ILogService)],O),e.ExtensionsDownloader=O}),define(J[155],Z([0,1,2,14,40,37,4,13,5,8,19,21]),function(q,e,f,L,b,_,A,C,h,g,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends f.Disposable{constructor(a,c){super();this.environmentService=a,this.logService=c,this.processesLimiter=new C.Limiter(5)}async postUninstall(a){const c=this.parseScript(a,"uninstall");return c&&(this.logService.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(c.script,"uninstall",c.args,!0,a).then(()=>this.logService.info(a.identifier.id,a.manifest.version,"Finished running post uninstall script"),p=>this.logService.error(a.identifier.id,a.manifest.version,`Failed to run post uninstall script: ${p}`)))),(0,D.rimraf)(this.getExtensionStoragePath(a)).then(void 0,p=>this.logService.error("Error while removing extension storage path",p))}parseScript(a,c){const p=`vscode:${c}`;if(a.location.scheme===g.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[p]=="string"){const O=a.manifest.scripts[p].split(" ");return O.length<2||O[0]!=="node"||!O[1]?(this.logService.warn(a.identifier.id,a.manifest.version,`${p} should be a node script`),null):{script:(0,A.join)(a.location.fsPath,O[1]),args:O.slice(2)||[]}}return null}runLifecycleHook(a,c,p,O,T){return new Promise((d,l)=>{const s=this.start(a,c,p,T);let t;const i=n=>{t&&(clearTimeout(t),t=null),n?l(n):d(void 0)};s.on("error",n=>{i((0,_.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,r)=>{i(n?`post-${c} process exited with code ${n}`:void 0)}),O&&(t=setTimeout(()=>{t=null,s.kill(),l("timed out")},5e3))})}start(a,c,p,O){const T={silent:!0,execArgv:void 0},d=(0,b.fork)(a,[`--type=extension-post-${c}`,...p],T);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const l=h.Event.fromNodeEventEmitter(d.stdout,"data"),s=h.Event.fromNodeEventEmitter(d.stderr,"data");l(n=>this.logService.info(O.identifier.id,O.manifest.version,`post-${c}`,n)),s(n=>this.logService.error(O.identifier.id,O.manifest.version,`post-${c}`,n));const t=h.Event.any(h.Event.map(l,n=>({data:`%c${n}`,format:[""]})),h.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return h.Event.debounce(t,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(O.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),d}getExtensionStoragePath(a){return(0,A.join)(this.environmentService.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};v=ve([ge(0,m.IEnvironmentService),ge(1,L.ILogService)],v),e.ExtensionsLifecycle=v}),define(J[156],Z([0,1,2,21,5,20,7,30,15,14]),function(q,e,f,L,b,_,A,C,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let D=class extends f.Disposable{constructor(v,w,a,c){super();this.extensionsManagementService=v,this.logService=c,this._onDidChangeExtensionsByAnotherSource=this._register(new b.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(T=>{this.installedExtensions=T.map(d=>d.identifier),this.startTimestamp=Date.now()}),this._register(v.onInstallExtension(T=>this.onInstallExtension(T))),this._register(v.onDidInstallExtension(T=>this.onDidInstallExtension(T))),this._register(v.onDidUninstallExtension(T=>this.onDidUninstallExtension(T)));const p=A.URI.file(a.extensionsPath),O=new h.ExtUri(T=>!w.hasCapability(T,1024));this._register(w.watch(p)),this._register(b.Event.filter(w.onDidFilesChange,T=>T.changes.some(d=>this.doesChangeAffects(d,p,O)))(()=>this.onDidChange()))}doesChangeAffects(v,w,a){return a.isEqual(a.dirname(v.resource),w)?a.isEqual(v.resource,a.joinPath(w,".obsolete"))?!0:!(v.type!==1&&v.type!==2||a.basename(v.resource).startsWith(".")):!1}onInstallExtension(v){this.addInstallingExtension(v.identifier)}onDidInstallExtension(v){this.removeInstallingExtension(v.identifier),v.error||this.addInstalledExtension(v.identifier)}onDidUninstallExtension(v){v.error||this.removeInstalledExtension(v.identifier)}addInstallingExtension(v){this.removeInstallingExtension(v),this.installingExtensions.push(v)}removeInstallingExtension(v){this.installingExtensions=this.installingExtensions.filter(w=>!(0,C.areSameExtensions)(w,v))}addInstalledExtension(v){this.installedExtensions&&(this.removeInstalledExtension(v),this.installedExtensions.push(v))}removeInstalledExtension(v){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(w=>!(0,C.areSameExtensions)(w,v)))}async onDidChange(){if(this.installedExtensions){const v=await this.extensionsManagementService.getInstalled(1),w=v.filter(c=>[...this.installingExtensions,...this.installedExtensions].some(p=>(0,C.areSameExtensions)(p,c.identifier))?!1:c.installedTimestamp&&c.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",c.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",c.identifier.id),!1)),a=this.installedExtensions.filter(c=>this.installingExtensions.some(p=>(0,C.areSameExtensions)(p,c))?!1:v.every(p=>!(0,C.areSameExtensions)(p.identifier,c))?(this.logService.info("Detected extension removed from another source",c.id),!0):!1);this.installedExtensions=v.map(c=>c.identifier),(w.length||a.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:w,removed:a})}}};D=ve([ge(1,_.IFileService),ge(2,L.INativeEnvironmentService),ge(3,g.ILogService)],D),e.ExtensionsWatcher=D}),define(J[71],Z([0,1,19,16,157,29,2,21,13,30,14,54,23,5,8,4]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let p=class extends A.Disposable{constructor(d,l,s){super();this.extensionManagementService=d,this.logService=s,this._onDidLanguagesChange=this._register(new w.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new O(l,s)),this._register(d.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(d.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(d=>{const l=["en",...Object.keys(d)];return(0,v.distinct)(l)})}onDidInstallExtension(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",d.identifier.id),this.update().then(l=>{l&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(d){this.cache.getLanguagePacks().then(l=>{Object.keys(l).some(s=>l[s]&&l[s].extensions.some(t=>(0,g.areSameExtensions)(t.extensionIdentifier,d)))&&(this.logService.debug("Removing language packs from the extension",d.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))})}async update(){const[d,l]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),s=await this.cache.update(l);return!(0,v.equals)(Object.keys(d),Object.keys(s))}};p=ve([ge(0,_.IExtensionManagementService),ge(1,C.INativeEnvironmentService),ge(2,D.ILogService)],p),e.LocalizationsService=p;let O=class extends A.Disposable{constructor(d,l){super();this.logService=l,this.languagePacks={},this.languagePacksFilePath=(0,c.join)(d.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new h.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(d){return this.withLanguagePacks(l=>{Object.keys(l).forEach(s=>delete l[s]),this.createLanguagePacksFromExtensions(l,...d)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(d,...l){for(const s of l)s&&s.manifest&&s.manifest.contributes&&s.manifest.contributes.localizations&&s.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(d,s);Object.keys(d).forEach(s=>this.updateHash(d[s]))}createLanguagePacksFromExtension(d,l){const s=l.identifier,t=l.manifest.contributes&&l.manifest.contributes.localizations?l.manifest.contributes.localizations:[];for(const i of t)if(l.location.scheme===a.Schemas.file&&(0,m.isValidLocalization)(i)){let n=d[i.languageId];n||(n={hash:"",extensions:[],translations:{}},d[i.languageId]=n);let r=n.extensions.filter(o=>(0,g.areSameExtensions)(o.extensionIdentifier,s))[0];r?r.version=l.manifest.version:n.extensions.push({extensionIdentifier:s,version:l.manifest.version});for(const o of i.translations)n.translations[o.id]=(0,c.join)(l.location.fsPath,o.path)}}updateHash(d){if(d){const l=(0,b.createHash)("md5");for(const s of d.extensions)l.update(s.extensionIdentifier.uuid||s.extensionIdentifier.id).update(s.version);d.hash=l.digest("hex")}}withLanguagePacks(d=()=>null){return this.languagePacksFileLimiter.queue(()=>{let l=null;return L.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,s=>s.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(s)).then(s=>{try{return JSON.parse(s)}catch(t){return{}}}).then(s=>(l=d(s),s)).then(s=>{for(const i of Object.keys(s))s[i]||delete s[i];this.languagePacks=s,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),(0,f.writeFile)(this.languagePacksFilePath,t)}).then(()=>l,s=>this.logService.error(s))})}};O=ve([ge(0,C.INativeEnvironmentService),ge(1,D.ILogService)],O)}),define(J[158],Z([0,1,14]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(_,A){switch(A){case f.LogLevel.Trace:return _.trace;case f.LogLevel.Debug:return _.debug;case f.LogLevel.Info:return _.info;case f.LogLevel.Warning:return _.warn;case f.LogLevel.Error:return _.error;case f.LogLevel.Critical:return _.critical;default:throw new Error("Invalid log level")}}class b extends f.AbstractLogger{constructor(A=f.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(A),this._register(this.onDidChangeLogLevel(C=>{this._logger&&this._logger.setLevel(C)}))}set logger(A){this._logger=A;for(const{level:C,args:h}of this.buffer)L(A,C).apply(A,h);this.buffer=[]}_log(A,...C){this._logger?L(this._logger,A).apply(this._logger,C):this.getLevel()<=A&&this.buffer.push({level:A,args:C})}trace(A,...C){this._log(f.LogLevel.Trace,A,...C)}debug(A,...C){this._log(f.LogLevel.Debug,A,...C)}info(A,...C){this._log(f.LogLevel.Info,A,...C)}warn(A,...C){this._log(f.LogLevel.Warning,A,...C)}error(A,...C){this._log(f.LogLevel.Error,A,...C)}critical(A,...C){this._log(f.LogLevel.Critical,A,...C)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=b}),define(J[159],Z([0,1,14,20,13,17,15,6,158]),function(q,e,f,L,b,_,A,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const g=5*L.ByteSize.MB;let D=class extends f.AbstractLogger{constructor(w,a,c,p){super();this.name=w,this.resource=a,this.fileService=p,this.backupIndex=1,this.setLevel(c),this.queue=this._register(new b.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const w=arguments[0];if(w instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=w.stack,this._log(f.LogLevel.Error,this.format(a))}else this._log(f.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,this.format(arguments))}flush(){}log(w,a){this._log(w,this.format(a))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(w){if(w.fileOperationResult!==3)throw w}}_log(w,a){this.queue.queue(async()=>{await this.initializePromise;let c=await this.loadContent();c.length>g&&(await this.fileService.writeFile(this.getBackupResource(),_.VSBuffer.fromString(c)),c=""),c+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(w)}] ${a}
`,await this.fileService.writeFile(this.resource,_.VSBuffer.fromString(c))})}getCurrentTimestamp(){const w=p=>p<10?`0${p}`:p,a=p=>p<10?`00${p}`:p<100?`0${p}`:p,c=new Date;return`${c.getFullYear()}-${w(c.getMonth()+1)}-${w(c.getDate())} ${w(c.getHours())}:${w(c.getMinutes())}:${w(c.getSeconds())}.${a(c.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,A.joinPath)((0,A.dirname)(this.resource),`${(0,A.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(w){return""}}stringifyLogLevel(w){switch(w){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}format(w){let a="";for(let c=0;c<w.length;c++){let p=w[c];if(typeof p=="object")try{p=JSON.stringify(p)}catch(O){}a+=(c>0?" ":"")+p}return a}};D=ve([ge(3,L.IFileService)],D),e.FileLogger=D;let m=class extends f.AbstractLoggerService{constructor(w,a,c){super(w.getLevel(),w.onDidChangeLogLevel);this.instantiationService=a,this.fileService=c}doCreateLogger(w,a){const c=new h.BufferLogService(a);return(0,L.whenProviderRegistered)(w,this.fileService).then(()=>c.logger=this.instantiationService.createInstance(D,(0,A.basename)(w),w,c.getLevel())),c}};m=ve([ge(0,f.ILogService),ge(1,C.IInstantiationService),ge(2,L.IFileService)],m),e.FileLoggerService=m}),define(J[72],Z([0,1,14,5,7]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class _{constructor(v){this.service=v,this.onDidChangeLogLevel=L.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(v,w,a){switch(w){case"setLevel":return this.service.setLevel(a)}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=_;class A{constructor(v){this.channel=v}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(v){A.setLevel(this.channel,v)}static setLevel(v,w){return v.call("setLevel",w)}}e.LogLevelChannelClient=A;class C{constructor(v){this.loggerService=v,this.loggers=new Map}listen(v,w){throw new Error(`Event not found: ${w}`)}async call(v,w,a){switch(w){case"createLogger":this.createLogger(b.URI.revive(a[0]),a[1]);return;case"log":return this.log(b.URI.revive(a[0]),a[1]);case"consoleLog":return this.consoleLog(a[0],a[1])}throw new Error(`Call not found: ${w}`)}createLogger(v,w){this.loggers.set(v.toString(),this.loggerService.createLogger(v,w))}consoleLog(v,w){let a=console.log;switch(v){case f.LogLevel.Error:a=console.error;break;case f.LogLevel.Warning:a=console.warn;break;case f.LogLevel.Info:a=console.info;break}a.call(console,...w)}log(v,w){const a=this.loggers.get(v.toString());if(!a)throw new Error("Create the logger before logging");for(const[c,p]of w)switch(c){case f.LogLevel.Trace:a.trace(p);break;case f.LogLevel.Debug:a.debug(p);break;case f.LogLevel.Info:a.info(p);break;case f.LogLevel.Warning:a.warn(p);break;case f.LogLevel.Error:a.error(p);break;case f.LogLevel.Critical:a.critical(p);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=C;class h extends f.AbstractLoggerService{constructor(v,w,a){super(v,w);this.channel=a}createConsoleMainLogger(){return new f.AdapterLogger({log:(v,w)=>{this.channel.call("consoleLog",[v,w])}})}doCreateLogger(v,w,a){return new g(this.channel,v,w,a)}}e.LoggerChannelClient=h;class g extends f.AbstractMessageLogger{constructor(v,w,a,c){super(c==null?void 0:c.always);this.channel=v,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(a),this.channel.call("createLogger",[w,c]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(v,w){const a=[[v,w]];this.isLoggerCreated?this.doLog(a):this.buffer.push(...a)}doLog(v){this.channel.call("log",[this.file,v])}}class D extends f.LogService{constructor(v,w){super(w);this.parent=v,this._register(v.onDidChangeLogLevel(a=>w.setLevel(a)))}setLevel(v){super.setLevel(v),this.parent.setLevel(v)}}e.FollowerLogService=D}),define(J[55],Z([0,1,14,20]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function b(h,g,D,m){try{const v=await new Promise((w,a)=>{q(["spdlog"],w,a)});return v.setAsyncMode(8192,500),v.createRotatingLoggerAsync(h,g,D,m)}catch(v){console.error(v)}return null}function _(h,g,D,m){return q.__$__nodeRequire("spdlog").createRotatingLogger(h,g,D,m)}e.createRotatingLogger=_;function A(h,g,D){switch(g){case f.LogLevel.Trace:h.trace(D);break;case f.LogLevel.Debug:h.debug(D);break;case f.LogLevel.Info:h.info(D);break;case f.LogLevel.Warning:h.warn(D);break;case f.LogLevel.Error:h.error(D);break;case f.LogLevel.Critical:h.critical(D);break;default:throw new Error("Invalid log level")}}class C extends f.AbstractMessageLogger{constructor(g,D,m,v){super();this.name=g,this.filepath=D,this.rotating=m,this.buffer=[],this.setLevel(v),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}_createSpdLogLogger(){const g=this.rotating?6:1,D=30/g*L.ByteSize.MB;return b(this.name,this.filepath,D,g).then(m=>{if(m){this._logger=m,this._logger.setLevel(this.getLevel());for(const{level:v,message:w}of this.buffer)A(this._logger,v,w);this.buffer=[]}})}log(g,D){this._logger?A(this._logger,g,D):this.getLevel()<=g&&this.buffer.push({level:g,message:D})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(J[160],Z([0,1,14,15,8,159,55,20,24]),function(q,e,f,L,b,_,A,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let g=class extends f.AbstractLoggerService{constructor(m,v){super(m.getLevel(),m.onDidChangeLogLevel);this.fileService=v}doCreateLogger(m,v,w){var a;if(m.scheme===b.Schemas.file){const c=new A.SpdLogLogger((w==null?void 0:w.name)||(0,h.generateUuid)(),m.fsPath,!(w==null?void 0:w.donotRotate),v);return(w==null?void 0:w.donotUseFormatters)&&c.clearFormatters(),c}else return new _.FileLogger((a=w==null?void 0:w.name)!==null&&a!==void 0?a:(0,L.basename)(m),m,v,this.fileService)}};g=ve([ge(0,f.ILogService),ge(1,C.IFileService)],g),e.LoggerService=g}),define(J[161],Z([0,1,91,6,5]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=f.default,e.INotificationService=(0,L.createDecorator)("notificationService");var _;(function(g){g[g.WORKSPACE=0]="WORKSPACE",g[g.GLOBAL=1]="GLOBAL"})(_=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(g){g[g.OFF=0]="OFF",g[g.SILENT=1]="SILENT",g[g.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new h,this.onDidClose=b.Event.None,this.onDidChangeVisibility=b.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.NoOpNotification=C;class h{infinite(){}done(){}total(D){}worked(D){}}e.NoOpProgress=h}),define(J[31],Z([0,1,8,3,26,15]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"){const C=L.globals.vscode.context.configuration();if(C)A=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(q==null?void 0:q.__$__nodeRequire)=="function"){const C=(0,_.dirname)(f.FileAccess.asFileUri("",q));A=q.__$__nodeRequire((0,_.joinPath)(C,"product.json").fsPath);const h=q.__$__nodeRequire((0,_.joinPath)(C,"package.json").fsPath);b.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:h.version})}else{A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.56.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});const C=document.getElementById("vscode-remote-product-configuration"),h=C&&C.getAttribute("data-settings");h&&Object.assign(A,JSON.parse(h))}e.default=A}),define(J[73],Z([0,1,125,17,20,11,31]),function(q,e,f,L,b,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(m,v,w,a,c,p){let O;try{await h(m,v,w,a,c,p)}catch(T){O=T}finally{O&&c.errorTransformer&&(O=c.errorTransformer(O)),typeof O!="undefined"&&w.error(O),w.end()}}e.readFileIntoStream=C;async function h(m,v,w,a,c,p){g(p);const O=await m.open(v,{create:!1});try{g(p);let T=0,d=0,l=c&&typeof c.length=="number"?c.length:void 0,s=L.VSBuffer.alloc(Math.min(c.bufferSize,typeof l=="number"?l:c.bufferSize)),t=c&&typeof c.position=="number"?c.position:0,i=0;do d=await m.read(O,t,s.buffer,i,s.byteLength-i),t+=d,i+=d,T+=d,typeof l=="number"&&(l-=d),i===s.byteLength&&(await w.write(a(s)),s=L.VSBuffer.alloc(Math.min(c.bufferSize,typeof l=="number"?l:c.bufferSize)),i=0);while(d>0&&(typeof l!="number"||l>0)&&g(p)&&D(T,c));if(i>0){let n=i;typeof l=="number"&&(n=Math.min(i,l)),w.write(a(s.slice(0,n)))}}catch(T){throw(0,b.ensureFileSystemProviderError)(T)}finally{await m.close(O)}}function g(m){if(m.isCancellationRequested)throw(0,_.canceled)();return!0}function D(m,v){if(v==null?void 0:v.limits){if(typeof v.limits.memory=="number"&&m>v.limits.memory)throw(0,b.createFileSystemProviderError)((0,f.localize)(0,null,A.default.nameShort),b.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&m>v.limits.size)throw(0,b.createFileSystemProviderError)((0,f.localize)(1,null),b.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[74],Z([0,1,123,96,2,20,5,15,33,23,14,17,43,13,27,8,73,60]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w,a,c,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let T=class extends b.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new w.ResourceQueue)}registerProvider(l,s){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,L.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:s});const t=new b.DisposableStore;return t.add(s.onDidChangeFile(i=>this._onDidFilesChange.fire(new _.FileChangesEvent(i,!this.isPathCaseSensitive(s))))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:l}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:s}),this.provider.delete(l),(0,b.dispose)(t)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(t){s.push(t)}}),!this.provider.has(l)&&await w.Promises.settled(s)}canHandleResource(l){return this.provider.has(l.scheme)}hasCapability(l,s){const t=this.provider.get(l.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return O.Iterable.map(this.provider,([l,s])=>({scheme:l,capabilities:s.capabilities}))}async withProvider(l){if(!(0,C.isAbsolutePath)(l))throw new _.FileOperationError((0,f.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const s=this.provider.get(l.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=(0,f.localize)(1,null,l.toString()),t}return s}async withReadProvider(l){const s=await this.withProvider(l);if((0,_.hasOpenReadWriteCloseCapability)(s)||(0,_.hasReadWriteCapability)(s)||(0,_.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const s=await this.withProvider(l);if((0,_.hasOpenReadWriteCloseCapability)(s)||(0,_.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,s){try{return await this.doResolveFile(l,s)}catch(t){throw(0,_.toFileSystemProviderErrorCode)(t)===_.FileSystemProviderErrorCode.FileNotFound?new _.FileOperationError((0,f.localize)(2,null,this.resourceForError(l)),1):(0,_.ensureFileSystemProviderError)(t)}}async doResolveFile(l,s){const t=await this.withProvider(l),i=this.isPathCaseSensitive(t),n=s==null?void 0:s.resolveTo,r=s==null?void 0:s.resolveSingleChildDescendants,o=s==null?void 0:s.resolveMetadata,y=await t.stat(l);let E;return this.toFileStat(t,l,y,void 0,!!o,(F,R)=>(E||(E=h.TernarySearchTree.forUris(()=>!i),E.set(l,!0),(0,g.isNonEmptyArray)(n)&&n.forEach(u=>E.set(u,!0))),Boolean(E.findSuperstr(F.resource)||E.get(F.resource))?!0:F.isDirectory&&r?R===1:!1))}async toFileStat(l,s,t,i,n,r){const{providerExtUri:o}=this.getExtUri(l),y={resource:s,name:o.basename(s),isFile:(t.type&_.FileType.File)!=0,isDirectory:(t.type&_.FileType.Directory)!=0,isSymbolicLink:(t.type&_.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,_.etag)({mtime:t.mtime,size:t.size})};if(y.isDirectory&&r(y,i)){try{const E=await l.readdir(s),F=await w.Promises.settled(E.map(async([R,u])=>{try{const P=o.joinPath(s,R),k=n?await l.stat(P):{type:u};return await this.toFileStat(l,P,k,E.length,n,r)}catch(P){return this.logService.trace(P),null}}));y.children=(0,g.coalesce)(F)}catch(E){this.logService.trace(E),y.children=[]}return y}return y}async resolveAll(l){return w.Promises.settled(l.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(l){const s=await this.withProvider(l);try{return!!await s.stat(l)}catch(t){return!1}}async canCreateFile(l,s){try{await this.doValidateCreateFile(l,s)}catch(t){return t}return!0}async doValidateCreateFile(l,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(l))throw new _.FileOperationError((0,f.localize)(3,null,this.resourceForError(l)),3,s)}async createFile(l,s=m.VSBuffer.fromString(""),t){await this.doValidateCreateFile(l,t);const i=await this.writeFile(l,s);return this._onDidRunOperation.fire(new _.FileOperationEvent(l,0,i)),i}async writeFile(l,s,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,l,t)||await this.mkdirp(i,n.dirname(l));let o;if((0,_.hasReadWriteCapability)(i)&&!(s instanceof m.VSBuffer))if((0,v.isReadableStream)(s)){const y=await(0,v.peekStream)(s,3);y.ended?o=m.VSBuffer.concat(y.buffer):o=y}else o=(0,v.peekReadable)(s,y=>m.VSBuffer.concat(y),3);else o=s;!(0,_.hasOpenReadWriteCloseCapability)(i)||(0,_.hasReadWriteCapability)(i)&&o instanceof m.VSBuffer?await this.doWriteUnbuffered(i,l,t,o):await this.doWriteBuffered(i,l,t,o instanceof m.VSBuffer?(0,m.bufferToReadable)(o):o)}catch(r){throw new _.FileOperationError((0,f.localize)(4,null,this.resourceForError(l),(0,_.ensureFileSystemProviderError)(r).toString()),(0,_.toFileOperationResult)(r),t)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,s,t){if(!!(t==null?void 0:t.unlock)&&!(l.capabilities&8192))throw new Error((0,f.localize)(5,null,this.resourceForError(s)));let n;try{n=await l.stat(s)}catch(r){return}if((n.type&_.FileType.Directory)!=0)throw new _.FileOperationError((0,f.localize)(6,null,this.resourceForError(s)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==_.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,_.etag)({mtime:t.mtime,size:n.size}))throw new _.FileOperationError((0,f.localize)(7,null),3,t);return n}async readFile(l,s){const t=await this.withReadProvider(l);return(s==null?void 0:s.atomic)?this.doReadFileAtomic(t,l,s):this.doReadFile(t,l,s)}async doReadFileAtomic(l,s,t){return new Promise((i,n)=>{this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(l,s,t);i(r)}catch(r){n(r)}})})}async doReadFile(l,s,t){const i=await this.doReadFileStream(l,s,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,m.streamToBuffer)(i.value)})}async readFileStream(l,s){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,s)}async doReadFileStream(l,s,t){const i=new a.CancellationTokenSource,n=this.validateReadFile(s,t).then(o=>o,o=>{throw i.cancel(),o});let r;try{t&&typeof t.etag=="string"&&t.etag!==_.ETAG_DISABLED&&await n,!((0,_.hasOpenReadWriteCloseCapability)(l)||(0,_.hasFileReadStreamCapability)(l))||(0,_.hasReadWriteCapability)(l)&&(t==null?void 0:t.preferUnbuffered)?r=this.readFileUnbuffered(l,s,t):(0,_.hasFileReadStreamCapability)(l)?r=this.readFileStreamed(l,s,i.token,t):r=this.readFileBuffered(l,s,i.token,t);const o=await n;return Object.assign(Object.assign({},o),{value:r})}catch(o){throw r&&await(0,v.consumeStream)(r),new _.FileOperationError((0,f.localize)(8,null,this.resourceForError(s),(0,_.ensureFileSystemProviderError)(o).toString()),(0,_.toFileOperationResult)(o),t)}}readFileStreamed(l,s,t,i=Object.create(null)){const n=l.readFileStream(s,i,t);return(0,v.transform)(n,{data:r=>r instanceof m.VSBuffer?r:m.VSBuffer.wrap(r),error:r=>new _.FileOperationError((0,f.localize)(9,null,this.resourceForError(s),(0,_.ensureFileSystemProviderError)(r).toString()),(0,_.toFileOperationResult)(r),i)},r=>m.VSBuffer.concat(r))}readFileBuffered(l,s,t,i=Object.create(null)){const n=(0,m.newWriteableBufferStream)();return(0,p.readFileIntoStream)(l,s,n,r=>r,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new _.FileOperationError((0,f.localize)(10,null,this.resourceForError(s),(0,_.ensureFileSystemProviderError)(r).toString()),(0,_.toFileOperationResult)(r),i)}),t),n}readFileUnbuffered(l,s,t){const i=(0,v.newWriteableStream)(n=>m.VSBuffer.concat(n));return(async()=>{try{let n=await l.readFile(s);t&&typeof t.position=="number"&&(n=n.slice(t.position)),t&&typeof t.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(s,n.byteLength,t),i.end(m.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(l,s){const t=await this.resolve(l,{resolveMetadata:!0});if(t.isDirectory)throw new _.FileOperationError((0,f.localize)(11,null,this.resourceForError(l)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==_.ETAG_DISABLED&&s.etag===t.etag)throw new _.FileOperationError((0,f.localize)(12,null),2,s);return this.validateReadFileLimits(l,t.size,s),t}validateReadFileLimits(l,s,t){if(t==null?void 0:t.limits){let i;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&s>t.limits.size&&(i=7),typeof i=="number")throw new _.FileOperationError((0,f.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,s,t){return this.doCanMoveCopy(l,s,"move",t)}async canCopy(l,s,t){return this.doCanMoveCopy(l,s,"copy",t)}async doCanMoveCopy(l,s,t,i){if(l.toString()!==s.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,l,r,s,t,i)}catch(n){return n}return!0}async move(l,s,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,l,n,s,"move",!!t),o=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new _.FileOperationEvent(l,r==="move"?2:3,o)),o}async copy(l,s,t){const i=await this.withReadProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,l,n,s,"copy",!!t),o=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new _.FileOperationEvent(l,r==="copy"?3:2,o)),o}async doMoveCopy(l,s,t,i,n,r){if(s.toString()===i.toString())return n;const{exists:o,isSameResourceWithDifferentPathCase:y}=await this.doValidateMoveCopy(l,s,t,i,n,r);if(o&&!y&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),n==="copy"){if(l===t&&(0,_.hasFileFolderCopyCapability)(l))await l.copy(s,i,{overwrite:r});else{const E=await this.resolve(s);E.isDirectory?await this.doCopyFolder(l,E,t,i):await this.doCopyFile(l,s,t,i)}return n}else return l===t?(await l.rename(s,i,{overwrite:r}),n):(await this.doMoveCopy(l,s,t,i,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(l,s,t,i){if((0,_.hasOpenReadWriteCloseCapability)(l)&&(0,_.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(l,s,t,i);if((0,_.hasOpenReadWriteCloseCapability)(l)&&(0,_.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(l,s,t,i);if((0,_.hasReadWriteCapability)(l)&&(0,_.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(l,s,t,i);if((0,_.hasReadWriteCapability)(l)&&(0,_.hasReadWriteCapability)(t))return this.doPipeUnbuffered(l,s,t,i)}async doCopyFolder(l,s,t,i){await t.mkdir(i),Array.isArray(s.children)&&await w.Promises.settled(s.children.map(async n=>{const r=this.getExtUri(t).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(l,await this.resolve(n.resource),t,r):this.doCopyFile(l,n.resource,t,r)}))}async doValidateMoveCopy(l,s,t,i,n,r){let o=!1;if(l===t){const{providerExtUri:E,isPathCaseSensitive:F}=this.getExtUri(l);if(F||(o=E.isEqual(s,i)),o&&n==="copy")throw new Error((0,f.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!o&&E.isEqualOrParent(i,s))throw new Error((0,f.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const y=await this.exists(i);if(y&&!o){if(!r)throw new _.FileOperationError((0,f.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(l===t){const{providerExtUri:E}=this.getExtUri(l);if(E.isEqualOrParent(s,i))throw new Error((0,f.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:y,isSameResourceWithDifferentPathCase:o}}getExtUri(l){const s=this.isPathCaseSensitive(l);return{providerExtUri:s?C.extUri:C.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(s,l);const t=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new _.FileOperationEvent(l,0,t)),t}async mkdirp(l,s){const t=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(s,i.dirname(s));)try{if(((await l.stat(s)).type&_.FileType.Directory)==0)throw new Error((0,f.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,_.toFileSystemProviderErrorCode)(n)!==_.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(i.basename(s)),s=i.dirname(s)}for(let n=t.length-1;n>=0;n--){s=i.joinPath(s,t[n]);try{await l.mkdir(s)}catch(r){if((0,_.toFileSystemProviderErrorCode)(r)!==_.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(l,s){try{await this.doValidateDelete(l,s)}catch(t){return t}return!0}async doValidateDelete(l,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!(s==null?void 0:s.useTrash)&&!(t.capabilities&4096))throw new Error((0,f.localize)(19,null,this.resourceForError(l)));const n=await this.exists(l);if(!n)throw new _.FileOperationError((0,f.localize)(20,null,this.resourceForError(l)),1);if(!!!(s==null?void 0:s.recursive)&&n){const o=await this.resolve(l);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,f.localize)(21,null,this.resourceForError(l)))}return t}async del(l,s){const t=await this.doValidateDelete(l,s),i=!!(s==null?void 0:s.useTrash),n=!!(s==null?void 0:s.recursive);await t.delete(l,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new _.FileOperationEvent(l,1))}watch(l,s={recursive:!1,excludes:[]}){let t=!1,i=()=>{t=!0};return this.doWatch(l,s).then(n=>{t?(0,b.dispose)(n):i=()=>(0,b.dispose)(n)},n=>this.logService.error(n)),(0,b.toDisposable)(()=>i())}async doWatch(l,s){const t=await this.withProvider(l),i=this.toWatchKey(t,l,s),n=this.activeWatchers.get(i)||{count:0,disposable:t.watch(l,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,b.toDisposable)(()=>{n.count--,n.count===0&&((0,b.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(l,s,t){const{providerExtUri:i}=this.getExtUri(l);return[i.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(l=>(0,b.dispose)(l.disposable)),this.activeWatchers.clear()}async doWriteBuffered(l,s,t,i){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(async()=>{var n;const r=await l.open(s,{create:!0,unlock:(n=t==null?void 0:t.unlock)!==null&&n!==void 0?n:!1});try{(0,v.isReadableStream)(i)||(0,v.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,r,i):await this.doWriteReadableBufferedQueued(l,r,i)}catch(o){throw(0,_.ensureFileSystemProviderError)(o)}finally{await l.close(r)}})}async doWriteStreamBufferedQueued(l,s,t){let i=0,n;if((0,v.isReadableBufferedStream)(t)){if(t.buffer.length>0){const r=m.VSBuffer.concat(t.buffer);await this.doWriteBuffer(l,s,r,r.byteLength,i,0),i+=r.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(r,o)=>{(0,v.listenStream)(n,{onData:async y=>{n.pause();try{await this.doWriteBuffer(l,s,y,y.byteLength,i,0)}catch(E){return o(E)}i+=y.byteLength,setTimeout(()=>n.resume())},onError:y=>o(y),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(l,s,t){let i=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(l,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(l,s,t,i,n,r){let o=0;for(;o<i;)o+=await l.write(s,n+o,t.buffer,r+o,i-o)}async doWriteUnbuffered(l,s,t,i){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,s,t,i))}async doWriteUnbufferedQueued(l,s,t,i){var n;let r;i instanceof m.VSBuffer?r=i:(0,v.isReadableStream)(i)?r=await(0,m.streamToBuffer)(i):(0,v.isReadableBufferedStream)(i)?r=await(0,m.bufferedStreamToBuffer)(i):r=(0,m.readableToBuffer)(i),await l.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:(n=t==null?void 0:t.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(l,s,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,s,t,i))}async doPipeBufferedQueued(l,s,t,i){let n,r;try{n=await l.open(s,{create:!1}),r=await t.open(i,{create:!0,unlock:!1});const o=m.VSBuffer.alloc(this.BUFFER_SIZE);let y=0,E=0,F=0;do F=await l.read(n,y,o.buffer,E,o.byteLength-E),await this.doWriteBuffer(t,r,o,F,y,E),y+=F,E+=F,E===o.byteLength&&(E=0);while(F>0)}catch(o){throw(0,_.ensureFileSystemProviderError)(o)}finally{await w.Promises.settled([typeof n=="number"?l.close(n):Promise.resolve(),typeof r=="number"?t.close(r):Promise.resolve()])}}async doPipeUnbuffered(l,s,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,s,t,i))}async doPipeUnbufferedQueued(l,s,t,i){return t.writeFile(i,await l.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,s,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,s,t,i))}async doPipeUnbufferedToBufferedQueued(l,s,t,i){const n=await t.open(i,{create:!0,unlock:!1});try{const r=await l.readFile(s);await this.doWriteBuffer(t,n,m.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,_.ensureFileSystemProviderError)(r)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(l,s,t,i){const n=await(0,m.streamToBuffer)(this.readFileBuffered(l,s,a.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,n)}throwIfFileSystemIsReadonly(l,s){if(l.capabilities&2048)throw new _.FileOperationError((0,f.localize)(22,null,this.resourceForError(s)),6);return l}resourceForError(l){return l.scheme===c.Schemas.file?l.fsPath:l.toString(!0)}};T=ve([ge(0,D.ILogService)],T),e.FileService=T}),define(J[56],Z([0,1,16,49,2,20,5,3,19,4,15,35,13,14,126,69,141,143,140,152,43,73,23,17]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w,a,c,p,O,T,d,l,s,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class n extends b.Disposable{constructor(o,y){var E;super();this.logService=o,this.options=y,this.BUFFER_SIZE=((E=this.options)===null||E===void 0?void 0:E.bufferSize)||64*1024,this.onDidChangeCapabilities=A.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new A.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new v.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(o){try{const{stat:y,symbolicLink:E}=await h.SymlinkSupport.stat(this.toFilePath(o));return{type:this.toType(y,E),ctime:y.birthtime.getTime(),mtime:y.mtime.getTime(),size:y.size}}catch(y){throw this.toFileSystemProviderError(y)}}async readdir(o){try{const y=await(0,h.readdir)(this.toFilePath(o),{withFileTypes:!0}),E=[];return await Promise.all(y.map(async F=>{try{let R;F.isSymbolicLink()?R=(await this.stat((0,D.joinPath)(o,F.name))).type:R=this.toType(F),E.push([F.name,R])}catch(R){this.logService.trace(R)}})),E}catch(y){throw this.toFileSystemProviderError(y)}}toType(o,y){let E;return(y==null?void 0:y.dangling)?E=_.FileType.Unknown:o.isFile()?E=_.FileType.File:o.isDirectory()?E=_.FileType.Directory:E=_.FileType.Unknown,y&&(E|=_.FileType.SymbolicLink),E}async readFile(o){try{const y=this.toFilePath(o);return await f.promises.readFile(y)}catch(y){throw this.toFileSystemProviderError(y)}}readFileStream(o,y,E){const F=(0,l.newWriteableStream)(R=>i.VSBuffer.concat(R.map(u=>i.VSBuffer.wrap(u))).buffer);return(0,s.readFileIntoStream)(this,o,F,R=>R.buffer,Object.assign(Object.assign({},y),{bufferSize:this.BUFFER_SIZE}),E),F}async writeFile(o,y,E){let F;try{const R=this.toFilePath(o);if(!E.create||!E.overwrite){if(await(0,h.exists)(R)){if(!E.overwrite)throw(0,_.createFileSystemProviderError)((0,a.localize)(0,null),_.FileSystemProviderErrorCode.FileExists)}else if(!E.create)throw(0,_.createFileSystemProviderError)((0,a.localize)(1,null),_.FileSystemProviderErrorCode.FileNotFound)}F=await this.open(o,{create:!0,unlock:E.unlock}),await this.write(F,0,y,0,y.byteLength)}catch(R){throw await this.toFileSystemProviderWriteError(o,R)}finally{typeof F=="number"&&await this.close(F)}}async open(o,y){try{const E=this.toFilePath(o);if((0,_.isFileOpenForWriteOptions)(y)&&y.unlock)try{const{stat:u}=await h.SymlinkSupport.stat(E);u.mode&128||await f.promises.chmod(E,u.mode|128)}catch(u){this.logService.trace(u)}let F;if((0,_.isFileOpenForWriteOptions)(y)){if(C.isWindows)try{await f.promises.truncate(E,0),F="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}F||(F="w")}else F="r";const R=await(0,L.promisify)(f.open)(E,F);return this.mapHandleToPos.set(R,0),(0,_.isFileOpenForWriteOptions)(y)&&this.writeHandles.set(R,o),R}catch(E){throw(0,_.isFileOpenForWriteOptions)(y)?await this.toFileSystemProviderWriteError(o,E):this.toFileSystemProviderError(E)}}async close(o){try{if(this.mapHandleToPos.delete(o),this.writeHandles.delete(o)&&this.canFlush)try{await(0,L.promisify)(f.fdatasync)(o)}catch(y){this.canFlush=!1,this.logService.error(y)}return await(0,L.promisify)(f.close)(o)}catch(y){throw this.toFileSystemProviderError(y)}}async read(o,y,E,F,R){const u=this.normalizePos(o,y);let P=null;try{const k=await(0,L.promisify)(f.read)(o,E,F,R,u);return typeof k=="number"?P=k:P=k.bytesRead,P}catch(k){throw this.toFileSystemProviderError(k)}finally{this.updatePos(o,u,P)}}normalizePos(o,y){return y===this.mapHandleToPos.get(o)?null:y}updatePos(o,y,E){const F=this.mapHandleToPos.get(o);typeof F=="number"&&(typeof y=="number"||(typeof E=="number"?this.mapHandleToPos.set(o,F+E):this.mapHandleToPos.delete(o)))}async write(o,y,E,F,R){return(0,v.retry)(()=>this.doWrite(o,y,E,F,R),100,3)}async doWrite(o,y,E,F,R){const u=this.normalizePos(o,y);let P=null;try{const k=await(0,L.promisify)(f.write)(o,E,F,R,u);return typeof k=="number"?P=k:P=k.bytesWritten,P}catch(k){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(o),k)}finally{this.updatePos(o,u,P)}}async mkdir(o){try{await f.promises.mkdir(this.toFilePath(o))}catch(y){throw this.toFileSystemProviderError(y)}}async delete(o,y){try{const E=this.toFilePath(o);await this.doDelete(E,y)}catch(E){throw this.toFileSystemProviderError(E)}}async doDelete(o,y){y.recursive?await(0,h.rimraf)(o,h.RimRafMode.MOVE):await f.promises.unlink(o)}async rename(o,y,E){const F=this.toFilePath(o),R=this.toFilePath(y);if(F!==R)try{await this.validateTargetDeleted(o,y,"move",E.overwrite),await(0,h.move)(F,R)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,a.localize)(2,null,(0,g.basename)(F),(0,g.basename)((0,g.dirname)(R)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(o,y,E){const F=this.toFilePath(o),R=this.toFilePath(y);if(F!==R)try{await this.validateTargetDeleted(o,y,"copy",E.overwrite),await(0,h.copy)(F,R,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,a.localize)(3,null,(0,g.basename)(F),(0,g.basename)((0,g.dirname)(R)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(o,y,E,F){const R=this.toFilePath(o),u=this.toFilePath(y);let P=!1;if(!!(this.capabilities&1024)||(P=(0,m.isEqual)(R,u,!0)),P&&E==="copy")throw(0,_.createFileSystemProviderError)((0,a.localize)(4,null),_.FileSystemProviderErrorCode.FileExists);if(!P&&await(0,h.exists)(u)){if(!F)throw(0,_.createFileSystemProviderError)((0,a.localize)(5,null),_.FileSystemProviderErrorCode.FileExists);await this.delete(y,{recursive:!0,useTrash:!1})}}watch(o,y){return y.recursive?this.watchRecursive(o,y.excludes):this.watchNonRecursive(o)}watchRecursive(o,y){const E={path:this.toFilePath(o),excludes:y},F=(0,t.insert)(this.recursiveFoldersToWatch,E);return this.refreshRecursiveWatchers(),(0,b.toDisposable)(()=>{F(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var o,y,E;if(this.recursiveWatcher instanceof T.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,b.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let F,R;((y=(o=this.options)===null||o===void 0?void 0:o.watcher)===null||y===void 0?void 0:y.usePolling)?(F=p.FileWatcher,R=(E=this.options)===null||E===void 0?void 0:E.watcher):this.recursiveFoldersToWatch.length===1?C.isWindows?F=O.FileWatcher:F=p.FileWatcher:F=T.FileWatcher,this.recursiveWatcher=new F(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,c.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===w.LogLevel.Trace,R),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))}}watchNonRecursive(o){const y=new d.FileWatcher(this.toFilePath(o),F=>this._onDidChangeFile.fire((0,c.toFileChanges)(F)),F=>{F.type==="error"&&this._onDidWatchErrorOccur.fire(F.message),this.logService[F.type](F.message)},this.logService.getLevel()===w.LogLevel.Trace),E=this.logService.onDidChangeLogLevel(()=>{y.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)});return(0,b.combinedDisposable)(y,E)}toFilePath(o){return(0,g.normalize)(o.fsPath)}toFileSystemProviderError(o){if(o instanceof _.FileSystemProviderError)return o;let y;switch(o.code){case"ENOENT":y=_.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":y=_.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":y=_.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":y=_.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":y=_.FileSystemProviderErrorCode.NoPermissions;break;default:y=_.FileSystemProviderErrorCode.Unknown}return(0,_.createFileSystemProviderError)(o,y)}async toFileSystemProviderWriteError(o,y){let E=this.toFileSystemProviderError(y);if(o&&E.code===_.FileSystemProviderErrorCode.NoPermissions)try{const{stat:F}=await h.SymlinkSupport.stat(this.toFilePath(o));F.mode&128||(E=(0,_.createFileSystemProviderError)(y,_.FileSystemProviderErrorCode.FileWriteLocked))}catch(F){this.logService.trace(F)}return E}dispose(){super.dispose(),(0,b.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,b.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=n}),define(J[45],Z([0,1,6]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,f.createDecorator)("productService")}),define(J[28],Z([0,1,12,87]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(A,C){L.ok(f.isString(A)),L.ok(f.isObject(C)),L.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,C)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new b}),define(J[162],Z([0,1,28,5]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class _{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,g){this.schemasById[b(h)]=g,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new _;f.Registry.add(e.Extensions.JSONContribution,A)}),define(J[38],Z([0,1,114,5,28,12,162]),function(q,e,f,L,b,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const h=b.Registry.as(A.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:f.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},h.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(O,T=!0){this.registerConfigurations([O],T)}registerConfigurations(O,T=!0){const d=[];O.forEach(l=>{d.push(...this.validateAndRegisterProperties(l,T,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),h.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(O){const T=[],d=l=>{if(l.properties)for(const s in l.properties)T.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,l.properties[s]);l.allOf&&l.allOf.forEach(s=>d(s))};for(const l of O){d(l);const s=this.configurationContributors.indexOf(l);s!==-1&&this.configurationContributors.splice(s,1)}h.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(T)}registerDefaultConfigurations(O){const T=[],d=[];for(const l of O)for(const s in l)if(T.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),l[s]);const t={type:"object",default:this.defaultValues[s],description:f.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};d.push(m(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=l[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(T)}deregisterDefaultConfigurations(O){const T=[];for(const d of O)for(const l in d)if(T.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const s=this.configurationProperties[l];s&&(this.updatePropertyDefaultValue(l,s),this.updateSchema(l,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(T)}notifyConfigurationSchemaUpdated(...O){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(O){for(const T of O)this.overrideIdentifiers.add(T);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(O,T=!0,d,l=3){var s;l=_.isUndefinedOrNull(O.scope)?l:O.scope;let t=[],i=O.properties;if(i)for(let r in i){if(T&&a(r)){delete i[r];continue}const o=i[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:(o.scope=_.isUndefinedOrNull(o.scope)?l:o.scope,o.restricted=_.isUndefinedOrNull(o.restricted)?!!((s=d==null?void 0:d.restrictedConfigurations)===null||s===void 0?void 0:s.includes(r)):o.restricted),i[r].hasOwnProperty("included")&&!i[r].included){this.excludedConfigurationProperties[r]=i[r],delete i[r];continue}else this.configurationProperties[r]=i[r];!i[r].deprecationMessage&&i[r].markdownDeprecationMessage&&(i[r].deprecationMessage=i[r].markdownDeprecationMessage),t.push(r)}let n=O.allOf;if(n)for(let r of n)t.push(...this.validateAndRegisterProperties(r,T,d,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(O){const T=d=>{let l=d.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let s=d.allOf;s&&s.forEach(T)};T(O)}updateSchema(O,T){switch(e.allSettings.properties[O]=T,T.scope){case 1:e.applicationSettings.properties[O]=T;break;case 2:e.machineSettings.properties[O]=T;break;case 6:e.machineOverridableSettings.properties[O]=T;break;case 3:e.windowSettings.properties[O]=T;break;case 4:e.resourceSettings.properties[O]=T;break;case 5:e.resourceSettings.properties[O]=T,this.resourceLanguageSettingsSchema.properties[O]=T;break}}removeFromSchema(O,T){switch(delete e.allSettings.properties[O],T.scope){case 1:delete e.applicationSettings.properties[O];break;case 2:delete e.machineSettings.properties[O];break;case 6:delete e.machineOverridableSettings.properties[O];break;case 3:delete e.windowSettings.properties[O];break;case 4:case 5:delete e.resourceSettings.properties[O];break}}updateOverridePropertyPatternKey(){for(const O of this.overrideIdentifiers.values()){const T=`[${O}]`,d={type:"object",description:f.localize(2,null),errorMessage:f.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(T,d),e.allSettings.properties[T]=d,e.applicationSettings.properties[T]=d,e.machineSettings.properties[T]=d,e.machineOverridableSettings.properties[T]=d,e.windowSettings.properties[T]=d,e.resourceSettings.properties[T]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(O,T){let d=this.defaultValues[O];_.isUndefined(d)&&(d=T.default),_.isUndefined(d)&&(d=v(T.type)),T.default=d}}const D="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(D);function m(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=m;function v(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const w=new g;b.Registry.add(e.Extensions.Configuration,w);function a(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?f.localize(5,null,p):w.getConfigurationProperties()[p]!==void 0?f.localize(6,null,p):null:f.localize(4,null)}e.validateProperty=a;function c(){const p=[],O=w.getConfigurationProperties();for(const T of Object.keys(O))p.push([T,O[T].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=c}),define(J[32],Z([0,1,22,12,7,28,6,38]),function(q,e,f,L,b,_,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function h(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof b.URI)}e.isConfigurationOverrides=h;var g;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(g=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=D;function m(i,n){const r=n?i?n.keys.filter(P=>i.keys.indexOf(P)===-1):[...n.keys]:[],o=i?n?i.keys.filter(P=>n.keys.indexOf(P)===-1):[...i.keys]:[],y=[];if(n&&i){for(const P of i.keys)if(n.keys.indexOf(P)!==-1){const k=O(i.contents,P),W=O(n.contents,P);f.equals(k,W)||y.push(P)}}const E=[],F=P=>{const k={};for(const W of P)for(const Q of W.identifiers)k[s(Q)]=W;return k},R=n?F(n.overrides):{},u=i?F(i.overrides):{};if(Object.keys(R).length)for(const P of r){const k=R[P];k&&E.push([(0,C.overrideIdentifierFromKey)(P),k.keys])}if(Object.keys(u).length)for(const P of o){const k=u[P];k&&E.push([(0,C.overrideIdentifierFromKey)(P),k.keys])}if(Object.keys(R).length&&Object.keys(u).length)for(const P of y){const k=u[P],W=R[P];if(k&&W){const Q=m({contents:k.contents,keys:k.keys,overrides:[]},{contents:W.contents,keys:W.keys,overrides:[]});E.push([(0,C.overrideIdentifierFromKey)(P),[...Q.added,...Q.removed,...Q.updated]])}}return{added:r,removed:o,updated:y,overrides:E}}e.compare=m;function v(i,n){const r=[];for(const o of Object.keys(i))if(C.OVERRIDE_PROPERTY_PATTERN.test(o)){const y={};for(const E in i[o])y[E]=i[o][E];r.push({identifiers:[(0,C.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(y),contents:w(y,n)})}return r}e.toOverrides=v;function w(i,n){const r=Object.create(null);for(let o in i)a(r,o,i[o],n);return r}e.toValuesTree=w;function a(i,n,r,o){const y=n.split("."),E=y.pop();let F=i;for(let R=0;R<y.length;R++){let u=y[R],P=F[u];switch(typeof P){case"undefined":P=F[u]=Object.create(null);break;case"object":break;default:o(`Ignoring ${n} as ${y.slice(0,R+1).join(".")} is ${JSON.stringify(P)}`);return}F=P}if(typeof F=="object"&&F!==null)try{F[E]=r}catch(R){o(`Ignoring ${n} as ${y.join(".")} is ${JSON.stringify(F)}`)}else o(`Ignoring ${n} as ${y.join(".")} is ${JSON.stringify(F)}`)}e.addToValueTree=a;function c(i,n){const r=n.split(".");p(i,r)}e.removeFromValueTree=c;function p(i,n){const r=n.shift();if(n.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const o=i[r];typeof o=="object"&&!Array.isArray(o)&&(p(o,n),Object.keys(o).length===0&&delete i[r])}}function O(i,n,r){function o(F,R){let u=F;for(const P of R){if(typeof u!="object"||u===null)return;u=u[P]}return u}const y=n.split("."),E=o(i,y);return typeof E=="undefined"?r:E}e.getConfigurationValue=O;function T(i,n,r){Object.keys(n).forEach(o=>{o!=="__proto__"&&(o in i?L.isObject(i[o])&&L.isObject(n[o])?T(i[o],n[o],r):r&&(i[o]=n[o]):i[o]=n[o])})}e.merge=T;function d(){const i=_.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=d;function l(){const i=Object.create(null),n=_.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let r in n){let o=n[r].default;a(i,r,o,y=>console.error(`Conflict in default settings: ${y}`))}return i}e.getDefaultValues=l;function s(i){return`[${i}]`}e.keyFromOverrideIdentifier=s;function t(i,n,r){const o=i.inspect(n),y=i.inspect(r);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:o.defaultValue}e.getMigratedSettingValue=t}),define(J[163],Z([0,1,61,33,23,12,22,7,38,32,28,2,5]),function(q,e,f,L,b,_,A,C,h,g,D,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class w{constructor(t={},i=[],n=[]){this._contents=t,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,g.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const n=this.getContentsForOverrideIdentifer(i);return n?t?(0,g.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const r of b.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[r],y=i[r];y&&(typeof o=="object"&&typeof y=="object"?(o=A.deepClone(o),this.mergeContents(o,y)):o=y),n[r]=o}return new w(n,this.keys,this.overrides)}merge(...t){const i=A.deepClone(this.contents),n=A.deepClone(this.overrides),r=[...this.keys];for(const o of t){this.mergeContents(i,o.contents);for(const y of o.overrides){const[E]=n.filter(F=>b.equals(F.identifiers,y.identifiers));E?this.mergeContents(E.contents,y.contents):n.push(A.deepClone(y))}for(const y of o.keys)r.indexOf(y)===-1&&r.push(y)}return new w(i,r,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const n of Object.keys(i)){if(n in t&&_.isObject(t[n])&&_.isObject(i[n])){this.mergeContents(t[n],i[n]);continue}t[n]=A.deepClone(i[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,g.addToValueTree)(this.contents,t,i,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,g.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let n=0;n<i;n++)t.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=w;class a extends w{constructor(){const t=(0,g.getDefaultValues)(),i=(0,g.getConfigurationKeys)(),n=[];for(const r of Object.keys(t))h.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,h.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,g.toValuesTree)(t[r],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,i,n)}}e.DefaultConfigurationModel=a;class c{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!_.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:n,keys:r,overrides:o,restricted:y}=this.doParseRaw(t,i);this._configurationModel=new w(n,r,o),this._restrictedConfigurations=y||[]}doParseContent(t){let i={},n=null,r=[],o=[],y=[];function E(R){Array.isArray(r)?r.push(R):n&&(r[n]=R)}let F={onObjectBegin:()=>{let R={};E(R),o.push(r),r=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{let R=[];E(R),o.push(r),r=R,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:E,onError:(R,u,P)=>{y.push({error:R,offset:u,length:P})}};if(t)try{f.visit(t,F),i=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return i}doParseRaw(t,i){const n=D.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,n,!0,i);t=r.raw;const o=(0,g.toValuesTree)(t,F=>console.error(`Conflict in settings file ${this._name}: ${F}`)),y=Object.keys(t),E=(0,g.toOverrides)(t,F=>console.error(`Conflict in settings file ${this._name}: ${F}`));return{contents:o,keys:y,overrides:E,restricted:r.restricted}}filter(t,i,n,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.skipRestricted))return{raw:t,restricted:[]};const o={},y=[];for(let E in t)if(h.OVERRIDE_PROPERTY_PATTERN.test(E)&&n){const F=this.filter(t[E],i,!1,r);o[E]=F.raw,y.push(...F.restricted)}else{const F=i[E],R=F?typeof F.scope!="undefined"?F.scope:3:void 0;(F==null?void 0:F.restricted)&&y.push(E),(R===void 0||r.scopes===void 0||r.scopes.includes(R))&&(r.skipRestricted&&(F==null?void 0:F.restricted)||(o[E]=t[E]))}return{raw:o,restricted:y}}}e.ConfigurationModelParser=c;class p extends m.Disposable{constructor(t,i,n,r){super();this.userSettingsResource=t,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(v.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class O{constructor(t,i,n=new w,r=new w,o=new L.ResourceMap,y=new w,E=new L.ResourceMap,F=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=o,this._memoryConfiguration=y,this._memoryConfigurationByResource=E,this._freeze=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(t)}updateValue(t,i,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new w,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(t):r.setValue(t,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,n){const r=this.getConsolidateConfigurationModel(i,n),o=this.getFolderConfigurationModelForResource(i.resource,n),y=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,E=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),F=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),R=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),u=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,k=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,W=i.overrideIdentifier?y.override(i.overrideIdentifier).getValue(t):y.getValue(t),Q=r.getValue(t),z=b.distinct(b.flatten(r.overrides.map(H=>H.identifiers))).filter(H=>r.getOverrideValue(t,H)!==void 0);return{defaultValue:E,userValue:F,userLocalValue:R,userRemoteValue:u,workspaceValue:P,workspaceFolderValue:k,memoryValue:W,value:Q,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:F!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:u!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:k!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:i.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:y.getValue(t),override:i.overrideIdentifier?y.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=i.filter(r=>h.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const o=(0,h.overrideIdentifierFromKey)(r),y=this._defaultConfiguration.getKeysForOverrideIdentifier(o),E=t.getKeysForOverrideIdentifier(o),F=[...E.filter(R=>y.indexOf(R)===-1),...y.filter(R=>E.indexOf(R)===-1),...y.filter(R=>!A.equals(this._defaultConfiguration.override(o).getValue(R),t.override(o).getValue(R)))];return[o,F]});return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:o}=(0,g.compare)(this.localUserConfiguration,t),y=[...i,...n,...r];return y.length&&this.updateLocalUserConfiguration(t),{keys:y,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:o}=(0,g.compare)(this.remoteUserConfiguration,t);let y=[...i,...n,...r];return y.length&&this.updateRemoteUserConfiguration(t),{keys:y,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:r,overrides:o}=(0,g.compare)(this.workspaceConfiguration,t);let y=[...i,...n,...r];return y.length&&this.updateWorkspaceConfiguration(t),{keys:y,overrides:o}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:r,updated:o,removed:y,overrides:E}=(0,g.compare)(n,i);let F=[...r,...o,...y];return(F.length||!n)&&this.updateFolderConfiguration(t,i),{keys:F,overrides:E}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:o,overrides:y}=(0,g.compare)(i,void 0);return{keys:[...n,...r,...o],overrides:y}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let n=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const r=i.getFolder(t);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const o=this._memoryConfigurationByResource.get(t);o&&(n=n.merge(o))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(i=n.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=n}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:n,overrides:r,keys:o}=this._folderConfigurations.get(i);return t.push([i,{contents:n,overrides:r,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((y,E)=>(y.set(C.URI.revive(E[0]),this.parseConfigurationModel(E[1])),y),new L.ResourceMap);return new O(i,n,new w,r,o,new w,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new w(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=O;function T(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,i=new Map;for(const r of s)r.keys.forEach(o=>t.add(o)),r.overrides.forEach(([o,y])=>{const E=(0,L.getOrSet)(i,o,new Set);y.forEach(F=>E.add(F))});const n=[];return i.forEach((r,o)=>n.push([o,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=T;class d{constructor(t,i,n,r){this.change=t,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(E=>o.add(E)),t.overrides.forEach(([,E])=>E.forEach(F=>o.add(F))),this.affectedKeys=[...o.values()];const y=new w;this.affectedKeys.forEach(E=>y.setValue(E,{})),this.affectedKeysTree=y.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=O.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,o=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!A.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let n=(0,g.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(t=t[r],!t)return!1;n=n[r]}return!0}}e.ConfigurationChangeEvent=d;class l extends d{constructor(t,i,n,r){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=n,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=l}),define(J[75],Z([0,1,28,38,2,32,163,5,13,15]),function(q,e,f,L,b,_,A,C,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends b.Disposable{constructor(v,w){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new A.UserSettings(this.settingsResource,void 0,g.extUriBiasedIgnorePathCase,w)),this.configuration=new A.Configuration(new A.DefaultConfigurationModel,new A.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new h.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(f.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(a=>this.onDidDefaultConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const v=await this.userConfiguration.loadConfiguration();this.configuration=new A.Configuration(new A.DefaultConfigurationModel,v)}getConfigurationData(){return this.configuration.toData()}getValue(v,w){const a=typeof v=="string"?v:void 0,c=(0,_.isConfigurationOverrides)(v)?v:(0,_.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(a,c,void 0)}updateValue(v,w,a,c){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const w=this.configuration.toData(),a=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(a,w,1)}onDidDefaultConfigurationChange(v){const w=this.configuration.toData(),a=this.configuration.compareAndUpdateDefaultConfiguration(new A.DefaultConfigurationModel,v);this.trigger(a,w,6)}trigger(v,w,a){const c=new A.ConfigurationChangeEvent(v,{data:w},this.configuration);c.source=a,c.sourceConfig=this.getTargetConfiguration(a),this._onDidChangeConfiguration.fire(c)}getTargetConfiguration(v){switch(v){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(J[164],Z([0,1,6]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,f.createDecorator)("remoteAuthorityResolverService");var L;(function(A){A[A.Unknown=0]="Unknown",A[A.DisableTrust=1]="DisableTrust",A[A.MachineTrusted=2]="MachineTrusted"})(L=e.RemoteTrustOption||(e.RemoteTrustOption={}));var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(b=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class _ extends Error{constructor(C,h=b.Unknown,g){super(C);this._message=C,this._code=h,this._detail=g,this.isHandled=h===b.NotAvailable&&g===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype)}static isTemporarilyNotAvailable(C){return C instanceof _&&C._code===b.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof _&&C._code===b.NoResolverFound}static isHandled(C){return C instanceof _&&C.isHandled}}e.RemoteAuthorityResolverError=_}),define(J[57],Z([0,1,127,6,38,28,17]),function(q,e,f,L,b,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function C(a){return a.res.statusCode&&a.res.statusCode>=200&&a.res.statusCode<300||a.res.statusCode===1223}e.isSuccess=C;function h(a){return a.res.statusCode===204}async function g(a){if(!C(a))throw new Error("Server returned "+a.res.statusCode);return h(a)?null:(await(0,A.streamToBuffer)(a.stream)).toString()}e.asText=g;async function D(a){if(!C(a))throw new Error("Server returned "+a.res.statusCode);if(h(a))return null;const p=(await(0,A.streamToBuffer)(a.stream)).toString();try{return JSON.parse(p)}catch(O){throw O.message+=`:
`+p,O}}e.asJson=D;function m(a){w(a)}e.updateProxyConfigurationsScope=m;let v;function w(a){const c=_.Registry.as(b.Extensions.Configuration);v&&c.deregisterConfigurations([v]),v={id:"http",order:15,title:(0,f.localize)(0,null),type:"object",scope:a,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,f.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,f.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,f.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,f.localize)(4,null),(0,f.localize)(5,null),(0,f.localize)(6,null),(0,f.localize)(7,null)],default:"override",description:(0,f.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,f.localize)(9,null),restricted:!0}}},c.registerConfiguration(v)}w(2)}),define(J[165],Z([0,1,27,17]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class b{constructor(C){this.service=C}listen(C,h){throw new Error("Invalid listen")}call(C,h,g){switch(h){case"request":return this.service.request(g[0],f.CancellationToken.None).then(async({res:D,stream:m})=>{const v=await(0,L.streamToBuffer)(m);return[{statusCode:D.statusCode,headers:D.headers},v]})}throw new Error("Invalid call")}}e.RequestChannel=b;class _{constructor(C){this.channel=C}async request(C,h){return _.request(this.channel,C,h)}static async request(C,h,g){const[D,m]=await C.call("request",[h]);return{res:D,stream:(0,L.bufferToStream)(m)}}}e.RequestChannelClient=_}),define(J[166],Z([0,1,167,12]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function b(A,C){return A.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:A.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function _(A,C,h={}){const g=(0,f.parse)(A),D=h.proxyUrl||b(g,C);if(!D)return null;const m=(0,f.parse)(D);if(!/^https?:$/.test(m.protocol||""))return null;const v={host:m.hostname||"",port:m.port||(m.protocol==="https"?"443":"80"),auth:m.auth,rejectUnauthorized:(0,L.isBoolean)(h.strictSSL)?h.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((w,a)=>{q(["http-proxy-agent"],w,a)}))(v):new(await new Promise((w,a)=>{q(["https-proxy-agent"],w,a)}))(v)}e.getProxyAgent=_}),define(J[168],Z([0,1,24,17]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function b(_,A,C){let h=C&&C.get("storage.serviceMachineId",0)||null;if(h)return h;try{const D=(await A.readFile(_.serviceMachineIdResource)).value.toString();h=(0,f.isUUID)(D)?D:null}catch(g){h=null}if(!h){h=(0,f.generateUuid)();try{await A.writeFile(_.serviceMachineIdResource,L.VSBuffer.fromString(h))}catch(g){}}return C&&C.store("storage.serviceMachineId",h,0,1),h}e.getServiceMachineId=b}),define(J[169],Z([0,1,6]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,f.createDecorator)("stateService")}),define(J[170],Z([0,1,4,16,21,19,12,14]),function(q,e,f,L,b,_,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class h{constructor(m,v){this.dbPath=m,this.onError=v,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const m=await this.loadAsync();this._database||(this._database=m)}}loadSync(){try{return this.lastFlushedSerializedDatabase=L.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(m){return m.code!=="ENOENT"&&this.onError(m),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await L.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(m){return m.code!=="ENOENT"&&this.onError(m),{}}}getItem(m,v){const w=this.database[m];return(0,A.isUndefinedOrNull)(w)?v:w}setItem(m,v){if((0,A.isUndefinedOrNull)(v))return this.removeItem(m);(typeof v=="string"||typeof v=="number"||typeof v=="boolean")&&this.database[m]===v||(this.database[m]=v,this.saveSync())}removeItem(m){(0,A.isUndefined)(this.database[m])||(this.database[m]=void 0,this.saveSync())}saveSync(){const m=JSON.stringify(this.database,null,4);if(m!==this.lastFlushedSerializedDatabase)try{(0,_.writeFileSync)(this.dbPath,m),this.lastFlushedSerializedDatabase=m}catch(v){this.onError(v)}}}e.FileStorage=h;let g=class He{constructor(m,v){this.fileStorage=new h(f.join(m.userDataPath,He.STATE_FILE),w=>v.error(w))}init(){return this.fileStorage.init()}getItem(m,v){return this.fileStorage.getItem(m,v)}setItem(m,v){this.fileStorage.setItem(m,v)}removeItem(m){this.fileStorage.removeItem(m)}};g.STATE_FILE="storage.json",g=ve([ge(0,b.INativeEnvironmentService),ge(1,C.ILogService)],g),e.StateService=g}),define(J[171],Z([0,1,6,5,2,12,103,13]),function(q,e,f,L,b,_,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const h="__$__targetStorageMarker";e.IStorageService=(0,f.createDecorator)("storageService");var g;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(g=e.WillSaveStateReason||(e.WillSaveStateReason={}));var D;(function(c){c[c.GLOBAL=0]="GLOBAL",c[c.WORKSPACE=1]="WORKSPACE"})(D=e.StorageScope||(e.StorageScope={}));var m;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class v extends b.Disposable{constructor(p={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=p,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(p,O){O===h?(p===0?this._globalKeyTargets=void 0:p===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:p})):this._onDidChangeValue.fire({scope:p,key:O,target:this.getKeyTargets(p)[O]})}emitWillSaveState(p){this._onWillSaveState.fire({reason:p})}get(p,O,T){var d;return(d=this.getStorage(O))===null||d===void 0?void 0:d.get(p,T)}getBoolean(p,O,T){var d;return(d=this.getStorage(O))===null||d===void 0?void 0:d.getBoolean(p,T)}getNumber(p,O,T){var d;return(d=this.getStorage(O))===null||d===void 0?void 0:d.getNumber(p,T)}store(p,O,T,d){if((0,_.isUndefinedOrNull)(O)){this.remove(p,T);return}this.withPausedEmitters(()=>{var l;this.updateKeyTarget(p,T,d),(l=this.getStorage(T))===null||l===void 0||l.set(p,O)})}remove(p,O){this.withPausedEmitters(()=>{var T;this.updateKeyTarget(p,O,void 0),(T=this.getStorage(O))===null||T===void 0||T.delete(p)})}withPausedEmitters(p){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{p()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(p,O){const T=[],d=this.getKeyTargets(p);for(const l of Object.keys(d))d[l]===O&&T.push(l);return T}updateKeyTarget(p,O,T){var d,l;const s=this.getKeyTargets(O);typeof T=="number"?s[p]!==T&&(s[p]=T,(d=this.getStorage(O))===null||d===void 0||d.set(h,JSON.stringify(s))):typeof s[p]=="number"&&(delete s[p],(l=this.getStorage(O))===null||l===void 0||l.set(h,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(p){return p===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(p){const O=this.get(h,p);if(O)try{return JSON.parse(O)}catch(T){}return Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(){var p,O,T,d;this._onWillSaveState.fire({reason:g.NONE}),await C.Promises.settled([(O=(p=this.getStorage(0))===null||p===void 0?void 0:p.whenFlushed())!==null&&O!==void 0?O:Promise.resolve(),(d=(T=this.getStorage(1))===null||T===void 0?void 0:T.whenFlushed())!==null&&d!==void 0?d:Promise.resolve()])}async logStorage(){var p,O,T,d,l,s;const t=(O=(p=this.getStorage(0))===null||p===void 0?void 0:p.items)!==null&&O!==void 0?O:new Map,i=(d=(T=this.getStorage(1))===null||T===void 0?void 0:T.items)!==null&&d!==void 0?d:new Map;return a(t,i,(l=this.getLogDetails(0))!==null&&l!==void 0?l:"",(s=this.getLogDetails(1))!==null&&s!==void 0?s:"")}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class w extends v{constructor(){super();this.globalStorage=new A.Storage(new A.InMemoryStorageDatabase),this.workspaceStorage=new A.Storage(new A.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(p=>this.emitDidChangeValue(1,p))),this._register(this.globalStorage.onDidChangeStorage(p=>this.emitDidChangeValue(0,p)))}getStorage(p){return p===0?this.globalStorage:this.workspaceStorage}getLogDetails(p){return p===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(p){}}e.InMemoryStorageService=w;async function a(c,p,O,T){const d=o=>{try{return JSON.parse(o)}catch(y){return o}},l=new Map,s=new Map;c.forEach((o,y)=>{l.set(y,o),s.set(y,d(o))});const t=new Map,i=new Map;p.forEach((o,y)=>{t.set(y,o),i.set(y,d(o))}),console.group(`Storage: Global (path: ${O})`);let n=[];l.forEach((o,y)=>{n.push({key:y,value:o})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${T})`);let r=[];t.forEach((o,y)=>{r.push({key:y,value:o})}),console.table(r),console.groupEnd(),console.log(i)}e.logStorage=a}),define(J[76],Z([0,1,3,26,24,7]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;function A(g){if(f.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function C(g,D,m,v,w,a,c,p,O,T){const d=Object.create(null);d["common.machineId"]=c,d.sessionID=(0,b.generateUuid)()+Date.now(),d.commitHash=w,d.version=a,d["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,f.PlatformToString)(f.platform),d["common.nodePlatform"]=L.platform,d["common.nodeArch"]=v,d["common.product"]=T||"desktop";const l=h(p||[]);l&&(d["common.msftInternal"]=l);let s=0;const t=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),f.isLinuxSnap&&(d["common.snap"]="true");const i=A(m);i&&(d["common.platformDetail"]=i);try{const n=await g.readFile(_.URI.file(O));d["common.source"]=n.value.toString().slice(0,30)}catch(n){}return d}e.resolveCommonProperties=C;function h(g){const D=L.env.USERDNSDOMAIN;if(!D)return!1;const m=D.toLowerCase();return g.some(v=>m===v)}}),define(J[172],Z([0,1,23,11,2,22]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var A;(function(h){function g(D,m){return D.callstack<m.callstack?-1:D.callstack>m.callstack?1:0}h.compare=g})(A=e.ErrorEvent||(e.ErrorEvent={}));class C{constructor(g,D=C.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new b.DisposableStore,this._telemetryService=g,this._flushDelay=D;const m=L.errorHandler.addListener(v=>this._onErrorEvent(v));this._disposables.add((0,b.toDisposable)(m)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(g){if(!!g){g.detail&&g.detail.stack&&(g=g.detail);let D=Array.isArray(g.stack)?g.stack.join(`
`):g.stack,m=g.message?g.message:(0,_.safeStringify)(g);!D||this._enqueue({msg:m,callstack:D})}}_enqueue(g){const D=(0,f.binarySearch)(this._buffer,g,A.compare);D<0?(g.count=1,this._buffer.splice(~D,0,g)):(this._buffer[D].count||(this._buffer[D].count=0),this._buffer[D].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let g of this._buffer)this._telemetryService.publicLogError2("UnhandledError",g);this._buffer.length=0}}e.default=C,C.ERROR_FLUSH_TIMEOUT=5*1e3}),define(J[173],Z([0,1,2,3,172]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class _ extends b.default{installErrorListeners(){let C,h=this;typeof L.globals.onerror=="function"&&(C=L.globals.onerror),L.globals.onerror=function(g,D,m,v,w){h._onUncaughtError(g,D,m,v,w),C&&C.apply(this,arguments)},this._disposables.add((0,f.toDisposable)(()=>{C&&(L.globals.onerror=C)}))}_onUncaughtError(C,h,g,D,m){let v={callstack:C,msg:C,file:h,line:g,column:D};if(m){let{name:w,message:a,stack:c}=m;v.uncaught_error_name=w,a&&(v.uncaught_error_msg=a),c&&(v.callstack=Array.isArray(m.stack)?m.stack=m.stack.join(`
`):m.stack)}this._enqueue(v)}}e.default=_}),define(J[42],Z([0,1,6]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,f.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,f.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[77],Z([0,1,11,29,30,22,42,57,51,21,27,14,20,7,45,171,168,6,15]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w,a,c,p,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var d;(function(S){S[S.None=0]="None",S[S.IncludeVersions=1]="IncludeVersions",S[S.IncludeFiles=2]="IncludeFiles",S[S.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",S[S.IncludeSharedAccounts=8]="IncludeSharedAccounts",S[S.IncludeVersionProperties=16]="IncludeVersionProperties",S[S.ExcludeNonValidated=32]="ExcludeNonValidated",S[S.IncludeInstallationTargets=64]="IncludeInstallationTargets",S[S.IncludeAssetUri=128]="IncludeAssetUri",S[S.IncludeStatistics=256]="IncludeStatistics",S[S.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",S[S.Unpublished=4096]="Unpublished"})(d||(d={}));function l(...S){return String(S.reduce((I,N)=>I|N,0))}var s;(function(S){S[S.Tag=1]="Tag",S[S.ExtensionId=4]="ExtensionId",S[S.Category=5]="Category",S[S.ExtensionName=7]="ExtensionName",S[S.Target=8]="Target",S[S.Featured=9]="Featured",S[S.SearchText=10]="SearchText",S[S.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},r={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:d.None,criteria:[],assetTypes:[]};class o{constructor(I=r){this.state=I}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(I,N=this.state.pageSize){return new o(Object.assign(Object.assign({},this.state),{pageNumber:I,pageSize:N}))}withFilter(I,...N){const M=[...this.state.criteria,...N.length?N.map($=>({filterType:I,value:$})):[{filterType:I}]];return new o(Object.assign(Object.assign({},this.state),{criteria:M}))}withSortBy(I){return new o(Object.assign(Object.assign({},this.state),{sortBy:I}))}withSortOrder(I){return new o(Object.assign(Object.assign({},this.state),{sortOrder:I}))}withFlags(...I){return new o(Object.assign(Object.assign({},this.state),{flags:I.reduce((N,M)=>N|M,0)}))}withAssetTypes(...I){return new o(Object.assign(Object.assign({},this.state),{assetTypes:I}))}get raw(){const{criteria:I,pageNumber:N,pageSize:M,sortBy:$,sortOrder:V,flags:G,assetTypes:K}=this.state;return{filters:[{criteria:I,pageNumber:N,pageSize:M,sortBy:$,sortOrder:V}],assetTypes:K,flags:G}}get searchText(){const I=this.state.criteria.filter(N=>N.filterType===s.SearchText)[0];return I&&I.value?I.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(I=>String(I.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function y(S,I){const N=(S||[]).filter(M=>M.statisticName===I)[0];return N?N.value:0}function E(S){const I="Microsoft.VisualStudio.Code.Translation.";return S.files.filter(M=>M.assetType.indexOf(I)===0).reduce((M,$)=>{const V=P(S,$.assetType);return V&&M.push([$.assetType.substring(I.length),V]),M},[])}function F(S){if(S.properties){const I=S.properties.filter($=>$.key===t.Repository),N=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),M=I.filter($=>N.test($.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return P(S,t.Repository)}function R(S){return{uri:`${S.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${S.fallbackAssetUri}/${t.VSIX}`}}function u(S){const I=P(S,t.Icon);if(I)return I;const N=L.DefaultIconPath;return{uri:N,fallbackUri:N}}function P(S,I){return S.files.filter(M=>M.assetType===I)[0]?{uri:`${S.assetUri}/${I}`,fallbackUri:`${S.fallbackAssetUri}/${I}`}:null}function k(S,I){const N=S.properties?S.properties.filter($=>$.key===I):[],M=N.length>0&&N[0].value;return M?M.split(",").map($=>(0,b.adoptToGalleryExtensionId)($)):[]}function W(S){const I=S.properties?S.properties.filter(N=>N.key===i.Engine):[];return I.length>0&&I[0].value||""}function Q(S){const I=S.properties?S.properties.filter(M=>M.key===i.LocalizedLanguages):[],N=I.length>0&&I[0].value||"";return N?N.split(","):[]}function z(S){return S.indexOf("preview")!==-1}function H(S){const I=S.properties?S.properties.find(N=>N.key===i.WebExtension):void 0;return!!I&&I.value==="true"}function Y(S){return S.files.some(I=>I.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,T.joinPath)(w.URI.parse(S.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function B(S,I,N,M,$){const V={manifest:P(I,t.Manifest),readme:P(I,t.Details),changelog:P(I,t.Changelog),license:P(I,t.License),repository:F(I),download:R(I),icon:u(I),coreTranslations:E(I)};return{identifier:{id:(0,b.getGalleryExtensionId)(S.publisher.publisherName,S.extensionName),uuid:S.extensionId},name:S.extensionName,version:I.version,date:I.lastUpdated,displayName:S.displayName,publisherId:S.publisher.publisherId,publisher:S.publisher.publisherName,publisherDisplayName:S.publisher.displayName,description:S.shortDescription||"",installCount:y(S.statistics,"install"),rating:y(S.statistics,"averagerating"),ratingCount:y(S.statistics,"ratingcount"),assetUri:w.URI.parse(I.assetUri),webResource:Y(I),assetTypes:I.files.map(({assetType:G})=>G),assets:V,properties:{dependencies:k(I,i.Dependency),extensionPack:k(I,i.ExtensionPack),engine:W(I),localizedLanguages:Q(I),webExtension:H(I)},telemetryData:{index:(M.pageNumber-1)*M.pageSize+N,searchText:M.searchText,querySource:$},preview:z(S.flags)}}let x=class{constructor(I,N,M,$,V,G,K){this.requestService=I,this.logService=N,this.environmentService=M,this.telemetryService=$,this.fileService=V,this.productService=G;const te=G.extensionsGallery;this.extensionsGalleryUrl=te&&te.serviceUrl,this.extensionsControlUrl=te&&te.controlUrl,this.commonHeadersPromise=U(G.version,this.environmentService,this.fileService,K)}api(I=""){return`${this.extensionsGalleryUrl}${I}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(I,N){const M=[];let{total:$,firstPage:V,getPage:G}=await this.query({names:I,pageSize:I.length},N);M.push(...V);for(let K=1;M.length<$&&(V=await G(K,N),V.length);K++)M.push(...V);return M}async getCompatibleExtension(I,N){const M=await this.getCompatibleExtensionByEngine(I,N);return(M==null?void 0:M.properties.webExtension)?M.webResource?M:null:M}async getCompatibleExtensionByEngine(I,N){const M=(0,L.isIExtensionIdentifier)(I)?null:I;if(M&&M.properties.engine&&(0,h.isEngineValid)(M.properties.engine,this.productService.version))return M;const{id:$,uuid:V}=M?M.identifier:I;let G=new o().withFlags(d.IncludeAssetUri,d.IncludeStatistics,d.IncludeFiles,d.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");V?G=G.withFilter(s.ExtensionId,V):G=G.withFilter(s.ExtensionName,$);const{galleryExtensions:K}=await this.queryGallery(G,D.CancellationToken.None),[te]=K;if(!te||!te.versions.length)return null;if(N){const oe=te.versions.filter(ce=>ce.version===N)[0];if(oe){const ce=B(te,oe,0,G);if(ce.properties.engine&&(0,h.isEngineValid)(ce.properties.engine,this.productService.version))return ce}return null}const se=await this.getLastValidExtensionVersion(te,te.versions);return se?B(te,se,0,G):null}async query(I,N){const M=D.CancellationToken.isCancellationToken(I)?{}:I,$=D.CancellationToken.isCancellationToken(I)?I:N;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let V=M.text||"";const G=(0,_.getOrDefault)(M,ue=>ue.pageSize,50);let K=new o().withFlags(d.IncludeLatestVersionOnly,d.IncludeAssetUri,d.IncludeStatistics,d.IncludeFiles,d.IncludeVersionProperties).withPage(1,G).withFilter(s.Target,"Microsoft.VisualStudio.Code");V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,Se,_e)=>(K=K.withFilter(s.Category,_e||Se),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,Se,_e)=>(K=K.withFilter(s.Tag,_e||Se),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(s.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),K=K.withFilter(s.SearchText,V)),K=K.withSortBy(0)):M.ids?K=K.withFilter(s.ExtensionId,...M.ids):M.names?K=K.withFilter(s.ExtensionName,...M.names):K=K.withSortBy(4),typeof M.sortBy=="number"&&(K=K.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(K=K.withSortOrder(M.sortOrder));const{galleryExtensions:te,total:se}=await this.queryGallery(K,$),oe=te.map((ue,Se)=>B(ue,ue.versions[0],Se,K,M.source)),ce=async(ue,Se)=>{if(Se.isCancellationRequested)throw(0,f.canceled)();const _e=K.withPage(ue+1),{galleryExtensions:Oe}=await this.queryGallery(_e,Se);return Oe.map((Ae,Ne)=>B(Ae,Ae.versions[0],Ne,_e,M.source))};return{firstPage:oe,total:se,pageSize:K.pageSize,getPage:ce}}async queryGallery(I,N){if(!this.isEnabled())throw new Error("No extension gallery service configured.");I=I.withFlags(I.flags,d.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,l(d.Unpublished));const M=await this.commonHeadersPromise,$=JSON.stringify(I.raw),V=Object.assign(Object.assign({},M),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String($.length)}),G=new Date().getTime();let K,te,se=0;try{if(K=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:$,headers:V},N),K.res.statusCode&&K.res.statusCode>=400&&K.res.statusCode<500)return{galleryExtensions:[],total:se};const oe=await(0,C.asJson)(K);if(oe){const ce=oe.results[0],ue=ce.extensions,Se=ce.resultMetadata&&ce.resultMetadata.filter(_e=>_e.metadataType==="ResultCount")[0];return se=Se&&Se.metadataItems.filter(_e=>_e.name==="TotalCount")[0].count||0,{galleryExtensions:ue,total:se}}return{galleryExtensions:[],total:se}}catch(oe){throw te=oe,oe}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},I.telemetryData),{requestBodySize:String($.length),duration:new Date().getTime()-G,success:!!K&&(0,C.isSuccess)(K),responseBodySize:K==null?void 0:K.res.headers["Content-Length"],statusCode:K?String(K.res.statusCode):void 0,errorCode:te?(0,f.isPromiseCanceledError)(te)?"canceled":(0,f.getErrorMessage)(te).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(se)}))}}async reportStatistic(I,N,M,$){if(!!this.isEnabled()){const V=await this.commonHeadersPromise,G=Object.assign(Object.assign({},V),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${I}/extensions/${N}/${M}/stats?statType=${$}`),headers:G},D.CancellationToken.None)}catch(K){}}}async download(I,N,M){this.logService.trace("ExtensionGalleryService#download",I.identifier.id);const $=(0,b.getGalleryExtensionTelemetryData)(I),V=new Date().getTime(),G=oe=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},$),{duration:oe})),K=M===1?"install":M===2?"update":"",te=K?{uri:`${I.assets.download.uri}&${K}=true`,fallbackUri:`${I.assets.download.fallbackUri}?${K}=true`}:I.assets.download,se=await this.getAsset(te);await this.fileService.writeFile(N,se.stream),G(new Date().getTime()-V)}async getReadme(I,N){if(I.assets.readme){const M=await this.getAsset(I.assets.readme,{},N);return await(0,C.asText)(M)||""}return""}async getManifest(I,N){if(I.assets.manifest){const M=await this.getAsset(I.assets.manifest,{},N),$=await(0,C.asText)(M);return $?JSON.parse($):null}return null}async getCoreTranslation(I,N){const M=I.assets.coreTranslations.filter($=>$[0]===N.toUpperCase())[0];if(M){const $=await this.getAsset(M[1]),V=await(0,C.asText)($);return V?JSON.parse(V):null}return null}async getChangelog(I,N){if(I.assets.changelog){const M=await this.getAsset(I.assets.changelog,{},N);return await(0,C.asText)(M)||""}return""}async getAllVersions(I,N){let M=new o().withFlags(d.IncludeVersions,d.IncludeFiles,d.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");I.identifier.uuid?M=M.withFilter(s.ExtensionId,I.identifier.uuid):M=M.withFilter(s.ExtensionName,I.identifier.id);const $=[],{galleryExtensions:V}=await this.queryGallery(M,D.CancellationToken.None);return V.length&&(N?await Promise.all(V[0].versions.map(async G=>{let K;try{K=await this.getEngine(G)}catch(te){}K&&(0,h.isEngineValid)(K,this.productService.version)&&$.push({version:G.version,date:G.lastUpdated})})):$.push(...V[0].versions.map(G=>({version:G.version,date:G.lastUpdated})))),$}async getAsset(I,N={},M=D.CancellationToken.None){const $=await this.commonHeadersPromise,V={type:"GET"},G=Object.assign(Object.assign({},$),N.headers||{});N=Object.assign(Object.assign(Object.assign({},N),V),{headers:G});const K=I.uri,te=I.fallbackUri,se=Object.assign(Object.assign({},N),{url:K});try{const oe=await this.requestService.request(se,M);if(oe.res.statusCode===200)return oe;const ce=await(0,C.asText)(oe);throw new Error(`Expected 200, got back ${oe.res.statusCode} instead.

${ce}`)}catch(oe){if((0,f.isPromiseCanceledError)(oe))throw oe;const ce=(0,f.getErrorMessage)(oe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:K,message:ce});const ue=Object.assign(Object.assign({},N),{url:te});return this.requestService.request(ue,M)}}async getLastValidExtensionVersion(I,N){const M=this.getLastValidExtensionVersionFromProperties(I,N);return M||this.getLastValidExtensionVersionRecursively(I,N)}getLastValidExtensionVersionFromProperties(I,N){for(const M of N){const $=W(M);if(!$)return null;if((0,h.isEngineValid)($,this.productService.version))return M}return null}async getEngine(I){const N=W(I);if(N)return N;const M=P(I,t.Manifest);if(!M)throw new Error("Manifest was not found");const $={"Accept-Encoding":"gzip"},V=await this.getAsset(M,{headers:$}),G=await(0,C.asJson)(V);if(G)return G.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(I,N){if(!N.length)return null;const M=N[0],$=await this.getEngine(M);return(0,h.isEngineValid)($,this.productService.version)?(M.properties=M.properties||[],M.properties.push({key:i.Engine,value:$}),M):this.getLastValidExtensionVersionRecursively(I,N.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const I=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(I.res.statusCode!==200)throw new Error("Could not get extensions report.");const N=await(0,C.asJson)(I),M=new Map;if(N)for(const $ of N.malicious){const V=M.get($)||{id:{id:$},malicious:!0,slow:!1};V.malicious=!0,M.set($,V)}return[...M.values()]}};x=ve([ge(0,C.IRequestService),ge(1,m.ILogService),ge(2,g.IEnvironmentService),ge(3,A.ITelemetryService),ge(4,v.IFileService),ge(5,a.IProductService),ge(6,(0,O.optional)(c.IStorageService))],x),e.ExtensionGalleryService=x;async function U(S,I,N,M){const $={"X-Market-Client-Id":`VSCode ${S}`,"User-Agent":`VSCode ${S}`},V=await(0,p.getServiceMachineId)(I,N,M);return $["X-Market-User-Id"]=V,$}e.resolveMarketplaceHeaders=U}),define(J[78],Z([0,1,31,128,18,6,32,38,2,22,28]),function(q,e,f,L,b,_,A,C,h,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(a,c){this._configurationService=c,this._experimentProperties={},this._disposables=new h.DisposableStore,this._cleanupPatterns=[],this._appender=a.appender,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,b.escapeRegExpCharacters)(p),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(p=>{const O=/^[a-f0-9]+$/i.test(p["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!O})}))}setExperimentProperty(a,c){this._experimentProperties[a]=c}setEnabled(a){this._enabled=a}_updateUserOptIn(){var a;const c=(a=this._configurationService)===null||a===void 0?void 0:a.getValue(v);this._userOptIn=c?c.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const a=await this._commonProperties;let c=a.sessionID,p=a["common.instanceId"],O=a["common.machineId"],T=a["common.firstSessionDate"],d=a["common.msftInternal"];return{sessionId:c,instanceId:p,machineId:O,firstSessionDate:T,msftInternal:d}}dispose(){this._disposables.dispose()}publicLog(a,c,p){return this.isOptedIn?this._commonProperties.then(O=>{c=(0,g.mixin)(c,O),c=(0,g.mixin)(c,this._experimentProperties),c=(0,g.cloneAndChange)(c,T=>{if(typeof T=="string")return this._cleanupInfo(T,p)}),this._appender.log(a,c)},O=>{console.error(O)}):Promise.resolve(void 0)}publicLog2(a,c,p){return this.publicLog(a,c,p)}publicLogError(a,c){return this.sendErrorTelemetry?this.publicLog(a,c,!0):Promise.resolve(void 0)}publicLogError2(a,c){return this.publicLogError(a,c)}_cleanupInfo(a,c){let p=a;if(c){const O=[];for(let s of this._cleanupPatterns)for(;;){const t=s.exec(a);if(!t)break;O.push([t.index,s.lastIndex])}const T=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(p="";;){const s=d.exec(a);if(!s)break;!T.test(s[0])&&O.every(([t,i])=>s.index<t||s.index>=i)&&(p+=a.substring(l,s.index)+"<REDACTED: user-file-path>",l=d.lastIndex)}l<a.length&&(p+=a.substr(l))}for(let O of this._cleanupPatterns)p=p.replace(O,"");return p}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=ve([ge(1,(0,_.optional)(A.IConfigurationService))],m),e.TelemetryService=m;const v="telemetry";D.Registry.as(C.Extensions.Configuration).registerConfiguration({id:v,order:110,type:"object",title:(0,L.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,L.localize)(2,null,f.default.privacyStatementUrl):(0,L.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(J[46],Z([0,1,32,22,12,13]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(a,c){return Promise.resolve(void 0)}publicLog2(a,c){return this.publicLog(a,c)}publicLogError(a,c){return Promise.resolve(void 0)}publicLogError2(a,c){return this.publicLogError(a,c)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class A{async publicLog(c,p,O){}async publicLogError(c,p,O){}}e.NullEndpointTelemetryService=A;function C(...a){return{log:(c,p)=>a.forEach(O=>O.log(c,p)),flush:()=>_.Promises.settled(a.map(c=>c.flush()))}}e.combinedAppender=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(a,c){return c.onDidChangeConfiguration(p=>{p.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,f.ConfigurationTargetToString)(p.source),configurationKeys:v(p.sourceConfig)})})}e.configurationTelemetry=h;function g(a){const c=Object.create(null),p=Object.create(null),O=Object.create(null);m(a,O);for(let T in O){T=T.length>150?T.substr(T.length-149):T;const d=O[T];typeof d=="number"?p[T]=d:typeof d=="boolean"?p[T]=d?1:0:typeof d=="string"?c[T]=d.substring(0,1023):typeof d!="undefined"&&d!==null&&(c[T]=d)}return{properties:c,measurements:p}}e.validateTelemetryData=g;function D(a){if(!a)return"none";let c="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(O=>{a.indexOf(`${O}+`)===0&&(c=O)}),c}e.cleanRemoteAuthority=D;function m(a,c,p=0,O){if(!!a)for(let T of Object.getOwnPropertyNames(a)){const d=a[T],l=O?O+T:T;Array.isArray(d)?c[l]=(0,L.safeStringify)(d):d instanceof Date?c[l]=d.toISOString():(0,b.isObject)(d)?p<2?m(d,c,p+1,l+"."):c[l]=(0,L.safeStringify)(d):c[l]=d}}function v(a){if(!a)return[];const c=[];return w(c,"",a),c}function w(a,c,p){p&&typeof p=="object"&&!Array.isArray(p)?Object.keys(p).forEach(O=>w(a,c?`${c}.${O}`:O,p[O])):a.push(c)}}),define(J[174],Z([0,1,2,21,14,46]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends f.Disposable{constructor(h,g){super();this.logger=this._register(h.createLogger(g.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(h,g){this.logger.trace(`telemetry/${h}`,(0,_.validateTelemetryData)(g))}};A=ve([ge(0,b.ILoggerService),ge(1,L.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(J[79],Z([0,1,11,22,46]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function _(C){const h=await new Promise((D,m)=>{q(["applicationinsights"],D,m)});let g;return h.defaultClient?(g=new h.TelemetryClient(C),g.channel.setUseDiskRetryCaching(!0)):(h.setup(C).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=h.defaultClient),C.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class A{constructor(h,g,D){this._eventPrefix=h,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof D=="function"?this._aiClient=D():this._aiClient=D,this._asyncAIClient=null}_withAIClient(h){if(!!this._aiClient){if(typeof this._aiClient!="string"){h(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=_(this._aiClient)),this._asyncAIClient.then(g=>{h(g)},g=>{(0,f.onUnexpectedError)(g),console.error(g)})}}log(h,g){!this._aiClient||(g=(0,L.mixin)(g,this._defaultData),g=(0,b.validateTelemetryData)(g),this._withAIClient(D=>D.trackEvent({name:this._eventPrefix+"/"+h,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(h=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,h(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(J[175],Z([0,1,19,16,4]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;function _(A,C){const h=Object.create(null),g=(m,v)=>{const w=JSON.parse(m);h[v]=w};if(C){const m=(0,f.readdirSync)(C).filter(w=>{try{return(0,L.statSync)((0,b.join)(C,w)).isDirectory()}catch(a){return!1}}),v=[];m.forEach(w=>{(0,f.readdirSync)((0,b.join)(C,w)).filter(c=>c==="telemetry.json").length===1&&v.push(w)}),v.forEach(w=>{const a=(0,L.readFileSync)((0,b.join)(C,w,"telemetry.json")).toString();g(a,w)})}let D=(0,L.readFileSync)((0,b.join)(A,"telemetry-core.json")).toString();return g(D,"vscode-core"),D=(0,L.readFileSync)((0,b.join)(A,"telemetry-extensions.json")).toString(),g(D,"vscode-extensions"),JSON.stringify(h,null,4)}e.buildTelemetryMessage=_}),define(J[176],Z([0,1,6]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.WindowsShellType=void 0;var L;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(L=e.WindowsShellType||(e.WindowsShellType={}));var b;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.Log="log",h.Heartbeat="heartbeat"})(b=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=(0,f.createDecorator)("localTerminalService"),e.IPtyService=(0,f.createDecorator)("ptyService");var _;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(_=e.HeartbeatConstants||(e.HeartbeatConstants={}));var A;(function(h){h[h.ReconnectionGraceTime=6e4]="ReconnectionGraceTime",h[h.ReconnectionShortGraceTime=6e3]="ReconnectionShortGraceTime"})(A=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var C;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(C=e.FlowControlConstants||(e.FlowControlConstants={}))}),define(J[177],Z([0,1,2,14,176,50,8,34,5,72,42]),function(q,e,f,L,b,_,A,C,h,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(a){a[a.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let v=0,w=class extends f.Disposable{constructor(c,p){super();this._logService=c,this._telemetryService=p,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new h.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new h.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new h.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new h.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onProcessData=this._register(new h.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new h.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new h.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new h.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new h.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new h.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new h.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new h.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new h.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._register((0,f.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const c=new _.Client(A.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:v,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}});this._onPtyHostStart.fire(),C.ProxyChannel.toService(c.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(c.onDidProcessExit(d=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(d.code),this._isDisposed||(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}, giving up`))}));const O=c.getChannel(b.TerminalIpcChannels.Log);this._register(this._logService.onDidChangeLogLevel(()=>{g.LogLevelChannelClient.setLevel(O,this._logService.getLevel())}));const T=C.ProxyChannel.toService(c.getChannel(b.TerminalIpcChannels.PtyHost));return this._register(T.onProcessData(d=>this._onProcessData.fire(d))),this._register(T.onProcessExit(d=>this._onProcessExit.fire(d))),this._register(T.onProcessReady(d=>this._onProcessReady.fire(d))),this._register(T.onProcessTitleChanged(d=>this._onProcessTitleChanged.fire(d))),this._register(T.onProcessShellTypeChanged(d=>this._onProcessShellTypeChanged.fire(d))),this._register(T.onProcessOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d))),this._register(T.onProcessResolvedShellLaunchConfig(d=>this._onProcessResolvedShellLaunchConfig.fire(d))),this._register(T.onProcessReplay(d=>this._onProcessReplay.fire(d))),this._register(T.onProcessOrphanQuestion(d=>this._onProcessOrphanQuestion.fire(d))),[c,T]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(c,p,O,T,d,l,s,t,i,n){const r=setTimeout(()=>this._handleUnresponsiveCreateProcess(),b.HeartbeatConstants.CreateProcessTimeout),o=await this._proxy.createProcess(c,p,O,T,d,l,s,t,i,n);return clearTimeout(r),v=Math.max(v,o),o}attachToProcess(c){return this._proxy.attachToProcess(c)}detachFromProcess(c){return this._proxy.detachFromProcess(c)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(c){return this._proxy.start(c)}shutdown(c,p){return this._proxy.shutdown(c,p)}input(c,p){return this._proxy.input(c,p)}processBinary(c,p){return this._proxy.processBinary(c,p)}resize(c,p,O){return this._proxy.resize(c,p,O)}acknowledgeDataEvent(c,p){return this._proxy.acknowledgeDataEvent(c,p)}getInitialCwd(c){return this._proxy.getInitialCwd(c)}getCwd(c){return this._proxy.getCwd(c)}getLatency(c){return this._proxy.getLatency(c)}orphanQuestionReply(c){return this._proxy.orphanQuestionReply(c)}getDefaultSystemShell(c){return this._proxy.getDefaultSystemShell(c)}getShellEnvironment(){return this._proxy.getShellEnvironment()}setTerminalLayoutInfo(c){return this._proxy.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return await this._proxy.getTerminalLayoutInfo(c)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}};w=ve([ge(0,L.ILogService),ge(1,D.ITelemetryService)],w),e.PtyHostService=w}),define(J[178],Z([0,1,7,15,6,33]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");var A;(function(v){v[v.EMPTY=1]="EMPTY",v[v.FOLDER=2]="FOLDER",v[v.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function C(v){const w=v;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.isWorkspace=C;function h(v){const w=v;return!!(w&&typeof w=="object"&&f.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.isWorkspaceFolder=h;class g{constructor(w,a,c,p){this._id=w,this._configuration=c,this._ignorePathCasing=p,this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(w){this._id=w.id,this._configuration=w.configuration,this._ignorePathCasing=w._ignorePathCasing,this.folders=w.folders}get folders(){return this._folders}set folders(w){this._folders=w,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(w){this._configuration=w}getFolder(w){return w&&this._foldersMap.findSubstr(w.with({scheme:w.scheme,authority:w.authority,path:w.path}))||null}updateFoldersMap(){this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing);for(const w of this.folders)this._foldersMap.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=g;class D{constructor(w,a){this.raw=a,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,L.joinPath)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=D;function m(v){return new D({uri:v,index:0,name:(0,L.basenameOrAuthority)(v)},{uri:v.toString()})}e.toWorkspaceFolder=m}),define(J[179],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryChannelClient=e.TelemetryChannel=void 0;class f{constructor(_){this.service=_}listen(_,A){throw new Error(`Invalid listen ${A}`)}call(_,A,C){switch(A){case"publicLog":return this.service.publicLog(C[0],C[1],C[2]);case"publicLog2":return this.service.publicLog2(C[0],C[1],C[2]);case"publicLogError":return this.service.publicLogError(C[0],C[1]);case"publicLogError2":return this.service.publicLogError2(C[0],C[1]);case"setEnabled":return Promise.resolve(this.service.setEnabled(C[0]));case"getTelemetryInfo":return this.service.getTelemetryInfo();case"setExperimentProperty":return Promise.resolve(this.service.setExperimentProperty(C[0],C[1]))}throw new Error(`Invalid call ${A}`)}}e.TelemetryChannel=f;class L{constructor(_){this.channel=_,this.isOptedIn=!0,this.sendErrorTelemetry=!0}publicLog(_,A,C){return this.channel.call("publicLog",[_,A,C])}publicLog2(_,A,C){return this.channel.call("publicLog2",[_,A,C])}publicLogError(_,A){return this.channel.call("publicLogError",[_,A])}publicLogError2(_,A){return this.channel.call("publicLogError2",[_,A])}setEnabled(_){this.channel.call("setEnable",[_])}getTelemetryInfo(){return this.channel.call("getTelemetryInfo")}setExperimentProperty(_,A){this.channel.call("setExperimentProperty",[_,A])}}e.TelemetryChannelClient=L}),define(J[180],Z([0,1,208,209,25]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryClient=void 0;class _{get _sender(){throw new Error("unimplemented")}get _buffer(){throw new Error("unimplemented")}setUseDiskRetryCaching(){throw new Error("unimplemented")}send(){throw new Error("unimplemented")}triggerSend(){throw new Error("unimplemented")}}class A{constructor(){this.context=void 0,this.commonProperties=void 0,this.config={},this.channel=new _}addTelemetryProcessor(){throw new Error("unimplemented")}clearTelemetryProcessors(){throw new Error("unimplemented")}runTelemetryProcessors(){throw new Error("unimplemented")}trackTrace(){throw new Error("unimplemented")}trackMetric(){throw new Error("unimplemented")}trackException(){throw new Error("unimplemented")}trackRequest(){throw new Error("unimplemented")}trackDependency(){throw new Error("unimplemented")}track(){throw new Error("unimplemented")}trackNodeHttpRequestSync(){throw new Error("unimplemented")}trackNodeHttpRequest(){throw new Error("unimplemented")}trackNodeHttpDependency(){throw new Error("unimplemented")}trackEvent(h){h.properties||(h.properties={}),h.measurements||(h.measurements={});try{const g=b.cpus();h.measurements.cores=g.length,h.properties["common.cpuModel"]=g[0].model}catch(g){}try{h.measurements.memoryFree=b.freemem(),h.measurements.memoryTotal=b.totalmem()}catch(g){}try{h.properties["common.shell"]=b.userInfo().shell,h.properties["common.release"]=b.release(),h.properties["common.arch"]=b.arch()}catch(g){}try{const g=process.env.TELEMETRY_URL||"https://v1.telemetry.coder.com/track",D=(/^http:/.test(g)?L:f).request(g,{method:"POST",headers:{"Content-Type":"application/json"}});D.on("error",()=>{}),D.write(JSON.stringify(h)),D.end()}catch(g){}}flush(h){h.callback&&h.callback("")}}e.TelemetryClient=A}),define(J[80],Z([0,1,39]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logger=void 0,e.logger=f.logger.named("vscode")}),define(J[58],Z([0,1,16,36,49,8,95,31]),function(q,e,f,L,b,_,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.getTranslations=e.getNlsConfiguration=e.isInternalConfiguration=void 0;const h=new Map,g=L.join(_.FileAccess.asFileUri("",q).fsPath,"nls.metadata.json"),D=p=>p&&!!p._languagePackId;e.isInternalConfiguration=D;const m={locale:"en",availableLanguages:{}},v=async(p,O)=>{const T=`${p}: ${O}`;return h.has(T)||h.set(T,new Promise(async d=>{const l=C.default.commit&&await b.promisify(f.exists)(g)?await A.getNLSConfiguration(C.default.commit,O,g,p):m;(0,e.isInternalConfiguration)(l)&&(l._languagePackSupport=!0),l.locale!=="en"&&l.locale!=="en-us"&&Object.keys(l.availableLanguages).length===0&&h.delete(T),d(l)})),h.get(T)};e.getNlsConfiguration=v;const w=async(p,O)=>{const T=await(0,e.getNlsConfiguration)(p,O);if((0,e.isInternalConfiguration)(T))try{return JSON.parse(await b.promisify(f.readFile)(T._translationsConfigFile,"utf8"))}catch(d){}return{}};e.getTranslations=w;const a=async p=>{const O=["locale.json","argv.json"];for(let T=0;T<O.length;++T)try{const d=L.join(p,"User",O[T]),l=c(await b.promisify(f.readFile)(d,"utf8"));return JSON.parse(l).locale}catch(d){}return"en"};e.getLocaleFromConfig=a;const c=p=>{const O=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return p.replace(O,(T,d,l,s,t)=>{if(s)return"";if(t){const i=t.length;return i>2&&t[i-1]===`
`?t[i-2]==="\r"?`\r
`:`
`:""}else return T})}}),define(J[181],Z([0,1,39,40,5,8,58]),function(q,e,f,L,b,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.ManagementConnection=e.Connection=void 0;class C{constructor(m,v){this.protocol=m,this.name=v,this._onClose=new b.Emitter,this.onClose=this._onClose.event,this.disposed=!1,this.logger=f.logger.named(this.name,(0,f.field)("token",this.protocol.options.reconnectionToken)),this.logger.debug("Connecting..."),this.onClose(()=>this.logger.debug("Closed"))}get offline(){return this._offline}reconnect(m){this.logger.debug("Reconnecting..."),this._offline=void 0,this.doReconnect(m)}dispose(m){this.logger.debug("Disposing...",(0,f.field)("reason",m)),this.disposed||(this.disposed=!0,this.doDispose(),this._onClose.fire())}setOffline(){this.logger.debug("Disconnected"),this._offline||(this._offline=Date.now())}}e.Connection=C;class h extends C{constructor(m){super(m,"management");m.onDidDispose(()=>this.dispose()),m.onSocketClose(()=>this.setOffline()),m.sendMessage({type:"ok"})}doDispose(){this.protocol.destroy()}doReconnect(m){m.sendMessage({type:"ok"}),this.protocol.beginAcceptReconnection(m.getSocket(),m.readEntireBuffer()),this.protocol.endAcceptReconnection(),m.dispose()}}e.ManagementConnection=h;class g extends C{constructor(m,v,w){super(m,"exthost");this.params=v,this.environment=w,m.sendMessage({debugPort:this.params.port});const a=m.readEntireBuffer(),c=m.inflateBytes;m.dispose(),m.getUnderlyingSocket().pause(),this.spawn(a,c).then(p=>this.process=p)}doDispose(){this.protocol.destroy(),this.process&&this.process.kill()}doReconnect(m){m.sendMessage({debugPort:this.params.port});const v=m.readEntireBuffer(),w=m.inflateBytes;m.dispose(),m.getUnderlyingSocket().pause(),this.protocol.setSocket(m.getSocket()),this.sendInitMessage(v,w)}sendInitMessage(m,v){if(!this.process)throw new Error("Tried to initialize VS Code before spawning");this.logger.debug("Sending socket"),this.process.send({type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:Buffer.from(m.buffer).toString("base64"),skipWebSocketFrames:this.protocol.options.skipWebSocketFrames,permessageDeflate:this.protocol.options.permessageDeflate,inflateBytes:v?Buffer.from(v).toString("base64"):void 0},this.protocol.getUnderlyingSocket())}async spawn(m,v){this.logger.debug("Getting NLS configuration...");const w=await(0,A.getNlsConfiguration)(this.params.language,this.environment.userDataPath);this.logger.debug("Spawning extension host...");const a=L.fork(_.FileAccess.asFileUri("bootstrap-fork",q).fsPath,["--type=extensionHost"],{env:Object.assign(Object.assign({},process.env),{VSCODE_AMD_ENTRYPOINT:"vs/workbench/services/extensions/node/extensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_LOG_LEVEL:process.env.LOG_LEVEL,VSCODE_NLS_CONFIG:JSON.stringify(w),VSCODE_PARENT_PID:String(process.pid)}),silent:!0});return a.on("error",c=>{this.logger.error("Exited unexpectedly",(0,f.field)("error",c)),this.dispose()}),a.on("exit",c=>{this.logger.debug("Exited",(0,f.field)("code",c)),this.dispose()}),a.stdout&&a.stderr&&(a.stdout.setEncoding("utf8").on("data",c=>this.logger.info(c)),a.stderr.setEncoding("utf8").on("data",c=>this.logger.error(c))),a.on("message",c=>{switch(c.type){case"__$console":const p=this.logger[c.severity==="log"?"info":c.severity];p?p.bind(this.logger)("console",(0,f.field)("arguments",c.arguments)):this.logger.error("Unexpected severity",(0,f.field)("event",c));break;case"VSCODE_EXTHOST_DISCONNECTED":this.logger.debug("Got disconnected message"),this.setOffline();break;case"VSCODE_EXTHOST_IPC_READY":this.logger.debug("Handshake completed"),this.sendInitMessage(m,v);break;default:this.logger.error("Unexpected message",(0,f.field)("event",c));break}}),this.logger.debug("Waiting for handshake..."),a}}e.ExtensionHostConnection=g}),define(J[81],Z([0,1,48]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodePath=e.getUriTransformer=void 0;const L=_=>new f.URITransformer(_);e.getUriTransformer=L;const b=_=>_.split("/").map(A=>encodeURIComponent(A)).join("/");e.encodePath=b}),define(J[82],Z([0,1,6]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,f.createDecorator)("environmentVariableService");var L;(function(b){b[b.Replace=1]="Replace",b[b.Append=2]="Append",b[b.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(J[182],Z([0,1,3,82]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class b{constructor(h){this.map=new Map,h.forEach((g,D)=>{const m=g.map.entries();let v=m.next();for(;!v.done;){const w=v.value[0];let a=this.map.get(w);if(a||(a=[],this.map.set(w,a)),a.length>0&&a[0].type===L.EnvironmentVariableMutatorType.Replace){v=m.next();continue}const c=v.value[1];a.unshift({extensionIdentifier:D,value:c.value,type:c.type}),v=m.next()}})}applyToProcessEnvironment(h,g){let D;f.isWindows&&(D={},Object.keys(h).forEach(m=>D[m.toLowerCase()]=m)),this.map.forEach((m,v)=>{const w=f.isWindows&&D[v.toLowerCase()]||v;m.forEach(a=>{const c=g?g(a.value):a.value;switch(a.type){case L.EnvironmentVariableMutatorType.Append:h[w]=(h[w]||"")+c;break;case L.EnvironmentVariableMutatorType.Prepend:h[w]=c+(h[w]||"");break;case L.EnvironmentVariableMutatorType.Replace:h[w]=c;break}})})}diff(h){const g=new Map,D=new Map,m=new Map;if(h.map.forEach((v,w)=>{const a=this.map.get(w),c=_(v,a);c&&g.set(w,c)}),this.map.forEach((v,w)=>{const a=h.map.get(w),c=_(v,a);c&&m.set(w,c)}),this.map.forEach((v,w)=>{const a=h.map.get(w),c=A(v,a);c&&D.set(w,c)}),!(g.size===0&&D.size===0&&m.size===0))return{added:g,changed:D,removed:m}}}e.MergedEnvironmentVariableCollection=b;function _(C,h){if(!h)return C;const g=new Set;h.forEach(m=>g.add(m.extensionIdentifier));const D=[];return C.forEach(m=>{g.has(m.extensionIdentifier)||D.push(m)}),D.length===0?void 0:D}function A(C,h){if(!!h){const g=new Map;h.forEach(m=>g.set(m.extensionIdentifier,m));const D=[];return C.forEach(m=>{const v=g.get(m.extensionIdentifier);v&&(m.type!==v.type||m.value!==v.value)&&D.push(v)}),D.length===0?void 0:D}}}),define(J[83],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function f(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=f;function L(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=L}),define(J[183],Z([0,1,4,89,3]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function _(s,t){if(!!t)if(b.isWindows)for(const i in t){let n=i;for(const o in s)if(i.toLowerCase()===o.toLowerCase()){n=o;break}const r=t[i];r!==void 0&&A(s,n,r)}else Object.keys(t).forEach(i=>{const n=t[i];n!==void 0&&A(s,i,n)})}e.mergeEnvironments=_;function A(s,t,i){typeof i=="string"?s[t]=i:delete s[t]}function C(s,t,i,n){s.TERM_PROGRAM="vscode",t&&(s.TERM_PROGRAM_VERSION=t),D(s,n)&&(s.LANG=m(i)),s.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=C;function h(s,t){if(!!t)for(const i of Object.keys(t)){const n=t[i];n&&(s[i]=n)}}function g(s,t){return Object.keys(t).forEach(i=>{const n=t[i];if(typeof n=="string")try{t[i]=s(n)}catch(r){t[i]=n}}),t}function D(s,t){if(t==="on")return!0;if(t==="auto"){const i=s.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=D;function m(s){const t=s?s.split("-"):[],i=t.length;if(i===0)return"en_US.UTF-8";if(i===1){const n={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in n&&t.push(n[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=m;function v(s,t,i,n,r,o){if(s.cwd){const E=typeof s.cwd=="object"?s.cwd.fsPath:s.cwd,F=w(E,i);return a(F||E)}let y;return!s.ignoreConfigurationCwd&&r&&(i&&(r=w(r,i,o)),r&&(f.isAbsolute(r)?y=r:n&&(y=f.join(n.fsPath,r)))),y||(y=n?n.fsPath:t||""),a(y)}e.getCwd=v;function w(s,t,i){if(t)try{return t(s)}catch(n){i==null||i.error("Could not resolve terminal cwd",n);return}return s}function a(s){return b.OS===1&&s&&s[1]===":"?s[0].toUpperCase()+s.substr(1):s}function c(s){let t=s;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const i=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(i,""),`'${t}'`}e.escapeNonWindowsPath=c;function p(s,t,i){if(!!i)return n=>i.resolveWithEnvironment(t,s,n)}e.createVariableResolver=p;function O(s,t,i,n,r,o,y,E=b.platform){let F;y&&(F=d(s,"automationShell",E)),F||(F=d(s,"shell",E));let R=F||t;if(E===3&&!i&&n){const u=f.join(n,"Sysnative").replace(/\//g,"\\").toLowerCase();R&&R.toLowerCase().indexOf(u)===0&&(R=f.join(n,"System32",R.substr(u.length+1)))}if(R&&E===3&&(R=R.replace(/\//g,"\\")),r)try{R=r(R)}catch(u){o.error("Could not resolve shell",u)}return R}e.getDefaultShell=O;function T(s,t,i,n,r=b.platform){if(t&&d(s,"automationShell",r))return[];const o=r===3?"windows":r===1?"osx":"linux";let y=s(`terminal.integrated.shellArgs.${o}`);if(!y)return[];if(typeof y=="string"&&r===3)return i?i(y):y;if(i){const E=[];for(const F of y)try{E.push(i(F))}catch(R){n.error(`Could not resolve terminal.integrated.shellArgs.${o}`,R),E.push(F)}y=E}return y}e.getDefaultShellArgs=T;function d(s,t,i=b.platform){return s(`terminal.integrated.${t}.${i===3?"windows":i===1?"osx":"linux"}`)}function l(s,t,i,n,r,o){let y={};if(s.strictEnv)h(y,s.env);else{h(y,o);const E=Object.assign({},t);i&&(E&&g(i,E),s.env&&g(i,s.env)),(0,L.sanitizeProcessEnvironment)(y,"VSCODE_IPC_HOOK_CLI"),_(y,E),_(y,s.env),C(y,n,b.locale,r)}return y}e.createTerminalEnvironment=l}),define(J[184],Z([0,1,16,4,3]),function(q,e,f,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMainProcessParentEnv=void 0;let _;async function A(C){if(_)return _;if(b.isLinux){const h=process.ppid,g=L.basename(process.argv[0]);let D=0,m=h,v=g;do D=m,(await f.promises.readFile(`/proc/${D}/status`,"utf8")).split(`
`).forEach(O=>{O.indexOf("Name:")===0&&(v=O.replace(/^Name:\s+/,"")),O.indexOf("PPid:")===0&&(m=parseInt(O.replace(/^PPid:\s+/,"")))});while(v===g);const w=await f.promises.readFile(`/proc/${D}/environ`,"utf8"),a={};w.split("\0").forEach(c=>{const p=c.indexOf("=");a[c.substr(0,p)]=c.substr(p+1)}),_=a}return b.isMacintosh&&(_={},["SHELL","SSH_AUTH_SOCK","Apple_PubSub_Socket_Render","XPC_FLAGS","XPC_SERVICE_NAME","HOME","LOGNAME","TMPDIR"].forEach(g=>{C[g]&&(_[g]=C[g])})),b.isWindows&&(_=C),_}e.getMainProcessParentEnv=A}),define(J[185],Z([0,1,38,32,6,28]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.filterSettingsRequireWorkspaceTrust=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`;function A(C){const h=_.Registry.as(f.Extensions.Configuration);return C.filter(g=>{const D=h.getConfigurationProperties()[g];return D.restricted&&D.scope!==1&&D.scope!==2})}e.filterSettingsRequireWorkspaceTrust=A,e.IWorkbenchConfigurationService=(0,b.refineServiceDecorator)(L.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(J[186],Z([0,1,6]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,f.createDecorator)("configurationResolverService")}),define(J[187],Z([0,1,4,26,12,22,3,64,131]),function(q,e,f,L,b,_,A,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class g{constructor(m,v,w){this._contributedVariables=new Map,this._context=m,this._labelService=v,w&&(this._envVariablesPromise=w.then(a=>this.prepareEnv(a)))}prepareEnv(m){if(A.isWindows){const v=Object.create(null);return Object.keys(m).forEach(w=>{v[w.toLowerCase()]=m[w]}),v}return m}resolveWithEnvironment(m,v,w){return this.recursiveResolve(this.prepareEnv(m),v?v.uri:void 0,w)}async resolveAsync(m,v){return this.recursiveResolve(await this._envVariablesPromise,m?m.uri:void 0,v)}async resolveAnyBase(m,v,w,a){const c=_.deepClone(v);return A.isWindows&&c.windows?Object.keys(c.windows).forEach(p=>c[p]=c.windows[p]):A.isMacintosh&&c.osx?Object.keys(c.osx).forEach(p=>c[p]=c.osx[p]):A.isLinux&&c.linux&&Object.keys(c.linux).forEach(p=>c[p]=c.linux[p]),delete c.windows,delete c.osx,delete c.linux,this.recursiveResolve(await this._envVariablesPromise,m?m.uri:void 0,c,w,a)}async resolveAnyAsync(m,v,w){return this.resolveAnyBase(m,v,w)}async resolveAnyMap(m,v,w){const a=new Map;return{newConfig:await this.resolveAnyBase(m,v,w,a),resolvedVariables:a}}resolveWithInteractionReplace(m,v,w,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,v,w,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,v){if(this._contributedVariables.has(m))throw new Error("Variable "+m+" is contributed twice.");this._contributedVariables.set(m,v)}recursiveResolve(m,v,w,a,c){if(b.isString(w))return this.resolveString(m,v,w,a,c);if(b.isArray(w))return w.map(p=>this.recursiveResolve(m,v,p,a,c));if(b.isObject(w)){let p=Object.create(null);return Object.keys(w).forEach(O=>{const T=this.resolveString(m,v,O,a,c);p[T]=this.recursiveResolve(m,v,w[O],a,c)}),p}return w}resolveString(m,v,w,a,c){return w.replace(g.VARIABLE_REGEXP,(O,T)=>{if(T.includes(g.VARIABLE_LHS))return O;let d=this.evaluateSingleVariable(m,O,T,v,a);return c&&c.set(T,d),d})}fsPath(m){return this._labelService?this._labelService.getUriLabel(m,{noPrefix:!0}):m.fsPath}evaluateSingleVariable(m,v,w,a,c){let p;const O=w.split(":");O.length>1&&(w=O[0],p=O[1]);const T=()=>{const s=this._context.getFilePath();if(s)return s;throw new Error((0,h.localize)(0,null,v))},d=()=>{const s=T();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,h.localize)(1,null,v,f.basename(s)))},l=()=>{if(p){const s=this._context.getFolderUri(p);if(s)return s;throw new Error((0,h.localize)(2,null,v,p))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,h.localize)(3,null,v)):new Error((0,h.localize)(4,null,v))};switch(w){case"env":if(p){if(m){const s=m[A.isWindows?p.toLowerCase():p];if(b.isString(s))return s}return""}throw new Error((0,h.localize)(5,null,v));case"config":if(p){const s=this._context.getConfigurationValue(a,p);if(b.isUndefinedOrNull(s))throw new Error((0,h.localize)(6,null,v,p));if(b.isObject(s))throw new Error((0,h.localize)(7,null,v,p));return s}throw new Error((0,h.localize)(8,null,v));case"command":return this.resolveFromMap(v,p,c,"command");case"input":return this.resolveFromMap(v,p,c,"input");default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return a||p?(0,C.normalizeDriveLetter)(this.fsPath(l())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return f.basename(this.fsPath(l()));case"lineNumber":const s=this._context.getLineNumber();if(s)return s;throw new Error((0,h.localize)(9,null,v));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,h.localize)(10,null,v));case"file":return T();case"fileWorkspaceFolder":return d();case"relativeFile":return a||p?f.relative(this.fsPath(l()),T()):T();case"relativeFileDirname":const i=f.dirname(T());if(a||p){const y=f.relative(this.fsPath(l()),i);return y.length===0?".":y}return i;case"fileDirname":return f.dirname(T());case"fileExtname":return f.extname(T());case"fileBasename":return f.basename(T());case"fileBasenameNoExtension":const n=f.basename(T());return n.slice(0,n.length-f.extname(n).length);case"fileDirnameBasename":return f.basename(f.dirname(T()));case"execPath":const r=this._context.getExecPath();return r||v;case"execInstallFolder":const o=this._context.getAppRoot();return o||v;case"pathSeparator":return f.sep;default:try{const y=p?`${w}:${p}`:w;return this.resolveFromMap(v,y,c,void 0)}catch(y){return v}}}}resolveFromMap(m,v,w,a){if(v&&w){const c=a===void 0?w[v]:w[a+":"+v];if(typeof c=="string")return c;throw new Error((0,h.localize)(11,null,m))}return m}}e.AbstractVariableResolverService=g,g.VARIABLE_LHS="${",g.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(J[84],Z([0,1,6]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,f.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(J[188],Z([0,1,130,5,12,7,2,6,145,28,105,23,84]),function(q,e,f,L,b,_,A,C,h,g,D,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.editorGroupToViewColumn=e.viewColumnToEditorGroup=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCommandsContextActionRunner=e.TextEditorOptions=e.EditorOptions=e.isEditorInputWithOptions=e.EditorModel=e.SideBySideEditorInput=e.isEditorInputWithPreferredResource=e.EditorInput=e.SaveReason=e.Verbosity=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.EditorExtensions=void 0,e.EditorExtensions={Editors:"workbench.contributions.editors",Associations:"workbench.editors.associations",EditorInputFactories:"workbench.contributions.editor.inputFactories"},e.ActiveEditorDirtyContext=new h.RawContextKey("activeEditorIsDirty",!1,(0,f.localize)(0,null)),e.ActiveEditorPinnedContext=new h.RawContextKey("activeEditorIsNotPreview",!1,(0,f.localize)(1,null)),e.ActiveEditorStickyContext=new h.RawContextKey("activeEditorIsPinned",!1,(0,f.localize)(2,null)),e.ActiveEditorReadonlyContext=new h.RawContextKey("activeEditorIsReadonly",!1,(0,f.localize)(3,null)),e.ActiveEditorContext=new h.RawContextKey("activeEditor",null,{type:"string",description:(0,f.localize)(4,null)}),e.ActiveEditorAvailableEditorIdsContext=new h.RawContextKey("activeEditorAvailableEditorIds","",(0,f.localize)(5,null)),e.TextCompareEditorVisibleContext=new h.RawContextKey("textCompareEditorVisible",!1,(0,f.localize)(6,null)),e.TextCompareEditorActiveContext=new h.RawContextKey("textCompareEditorActive",!1,(0,f.localize)(7,null)),e.EditorGroupEditorsCountContext=new h.RawContextKey("groupEditorsCount",0,(0,f.localize)(8,null)),e.ActiveEditorGroupEmptyContext=new h.RawContextKey("activeEditorGroupEmpty",!1,(0,f.localize)(9,null)),e.ActiveEditorGroupIndexContext=new h.RawContextKey("activeEditorGroupIndex",0,(0,f.localize)(10,null)),e.ActiveEditorGroupLastContext=new h.RawContextKey("activeEditorGroupLast",!1,(0,f.localize)(11,null)),e.MultipleEditorGroupsContext=new h.RawContextKey("multipleEditorGroups",!1,(0,f.localize)(12,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new h.RawContextKey("editorIsOpen",!1,(0,f.localize)(13,null)),e.InEditorZenModeContext=new h.RawContextKey("inZenMode",!1,(0,f.localize)(14,null)),e.IsCenteredLayoutContext=new h.RawContextKey("isCenteredLayout",!1,(0,f.localize)(15,null)),e.SplitEditorsVertically=new h.RawContextKey("splitEditorsVertically",!1,(0,f.localize)(16,null)),e.EditorAreaVisibleContext=new h.RawContextKey("editorAreaVisible",!0,(0,f.localize)(17,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function w(P){const k=P;return typeof(k==null?void 0:k.getViewState)=="function"}e.isTextEditorPane=w;var a;(function(P){P[P.SHORT=0]="SHORT",P[P.MEDIUM=1]="MEDIUM",P[P.LONG=2]="LONG"})(a=e.Verbosity||(e.Verbosity={}));var c;(function(P){P[P.EXPLICIT=1]="EXPLICIT",P[P.AUTO=2]="AUTO",P[P.FOCUS_CHANGE=3]="FOCUS_CHANGE",P[P.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));class p extends A.Disposable{constructor(){super(...arguments);this._onDidChangeDirty=this._register(new L.Emitter),this.onDidChangeDirty=this._onDidChangeDirty.event,this._onDidChangeLabel=this._register(new L.Emitter),this.onDidChangeLabel=this._onDidChangeLabel.event,this._onWillDispose=this._register(new L.Emitter),this.onWillDispose=this._onWillDispose.event,this.disposed=!1}getName(){return`Editor ${this.typeId}`}getDescription(k){}getTitle(k){return this.getName()}getAriaLabel(){return this.getTitle(0)}getPreferredEditorId(k){return(0,m.firstOrDefault)(k)}getTelemetryDescriptor(){return{typeId:this.typeId}}isReadonly(){return!0}isUntitled(){return!1}isDirty(){return!1}isSaving(){return!1}async resolve(){return null}async save(k,W){return this}async saveAs(k,W){return this}async revert(k,W){}rename(k,W){}canSplit(){return!0}matches(k){return this===k}copy(){return this}isDisposed(){return this.disposed}dispose(){this.disposed||(this.disposed=!0,this._onWillDispose.fire()),super.dispose()}}e.EditorInput=p;function O(P){const k=P;return k&&!!k.preferredResource}e.isEditorInputWithPreferredResource=O;class T extends p{constructor(k,W,Q,z){super();this.name=k,this.description=W,this._secondary=Q,this._primary=z,this.registerListeners()}get typeId(){return T.ID}registerListeners(){const k=L.Event.once(this.secondary.onWillDispose);this._register(k(()=>{this.isDisposed()||this.dispose()}));const W=L.Event.once(this.primary.onWillDispose);this._register(W(()=>{this.isDisposed()||this.dispose()})),this._register(this.primary.onDidChangeDirty(()=>this._onDidChangeDirty.fire())),this._register(this.primary.onDidChangeLabel(()=>this._onDidChangeLabel.fire()))}get resource(){}get primary(){return this._primary}get secondary(){return this._secondary}getName(){return this.name?this.name:(0,f.localize)(18,null,this._secondary.getName(),this._primary.getName())}getDescription(){return this.description}isReadonly(){return this.primary.isReadonly()}isUntitled(){return this.primary.isUntitled()}isDirty(){return this.primary.isDirty()}isSaving(){return this.primary.isSaving()}save(k,W){return this.primary.save(k,W)}saveAs(k,W){return this.primary.saveAs(k,W)}revert(k,W){return this.primary.revert(k,W)}getTelemetryDescriptor(){const k=this.primary.getTelemetryDescriptor();return Object.assign(k,super.getTelemetryDescriptor())}matches(k){return k===this?!0:k instanceof T?this.primary.matches(k.primary)&&this.secondary.matches(k.secondary):!1}}e.SideBySideEditorInput=T,T.ID="workbench.editorinputs.sidebysideEditorInput";class d extends A.Disposable{constructor(){super(...arguments);this._onWillDispose=this._register(new L.Emitter),this.onWillDispose=this._onWillDispose.event,this.disposed=!1,this.resolved=!1}async resolve(){this.resolved=!0}isResolved(){return this.resolved}isDisposed(){return this.disposed}dispose(){this.disposed=!0,this._onWillDispose.fire(),super.dispose()}}e.EditorModel=d;function l(P){const k=P;return!!k&&!!k.editor}e.isEditorInputWithOptions=l;class s{static create(k){const W=new s;return W.overwrite(k),W}overwrite(k){return typeof k.forceReload=="boolean"&&(this.forceReload=k.forceReload),typeof k.revealIfVisible=="boolean"&&(this.revealIfVisible=k.revealIfVisible),typeof k.revealIfOpened=="boolean"&&(this.revealIfOpened=k.revealIfOpened),typeof k.preserveFocus=="boolean"&&(this.preserveFocus=k.preserveFocus),typeof k.activation=="number"&&(this.activation=k.activation),typeof k.pinned=="boolean"&&(this.pinned=k.pinned),typeof k.sticky=="boolean"&&(this.sticky=k.sticky),typeof k.inactive=="boolean"&&(this.inactive=k.inactive),typeof k.ignoreError=="boolean"&&(this.ignoreError=k.ignoreError),typeof k.index=="number"&&(this.index=k.index),k.override!==void 0&&(this.override=k.override),typeof k.context=="number"&&(this.context=k.context),this}}e.EditorOptions=s;class t extends s{static from(k){if(!!(k==null?void 0:k.options))return t.create(k.options)}static create(k=Object.create(null)){const W=new t;return W.overwrite(k),W}overwrite(k){var W,Q;return super.overwrite(k),k.selection&&(this.selection={startLineNumber:k.selection.startLineNumber,startColumn:k.selection.startColumn,endLineNumber:(W=k.selection.endLineNumber)!==null&&W!==void 0?W:k.selection.startLineNumber,endColumn:(Q=k.selection.endColumn)!==null&&Q!==void 0?Q:k.selection.startColumn}),k.viewState&&(this.editorViewState=k.viewState),typeof k.selectionRevealType!="undefined"&&(this.selectionRevealType=k.selectionRevealType),this}hasOptionsDefined(){return!!this.editorViewState||!!this.selectionRevealType||!!this.selection}static fromEditor(k,W){const Q=t.create(W);return Q.editorViewState=(0,b.withNullAsUndefined)(k.saveViewState()),Q}apply(k,W){var Q,z;let H=!1;if(this.editorViewState)k.restoreViewState(this.editorViewState),H=!0;else if(this.selection){const Y={startLineNumber:this.selection.startLineNumber,startColumn:this.selection.startColumn,endLineNumber:(Q=this.selection.endLineNumber)!==null&&Q!==void 0?Q:this.selection.startLineNumber,endColumn:(z=this.selection.endColumn)!==null&&z!==void 0?z:this.selection.startColumn};k.setSelection(Y),this.selectionRevealType===2?k.revealRangeNearTop(Y,W):this.selectionRevealType===3?k.revealRangeNearTopIfOutsideViewport(Y,W):this.selectionRevealType===1?k.revealRangeInCenterIfOutsideViewport(Y,W):k.revealRangeInCenter(Y,W),H=!0}return H}}e.TextEditorOptions=t;class i extends D.ActionRunner{constructor(k){super();this.context=k}run(k){return super.run(k,this.context)}}e.EditorCommandsContextActionRunner=i;var n;(function(P){P[P.PRIMARY=1]="PRIMARY",P[P.SECONDARY=2]="SECONDARY",P[P.BOTH=3]="BOTH"})(n=e.SideBySideEditor||(e.SideBySideEditor={}));class r{getOriginalUri(k,W){if(!!k){if((W==null?void 0:W.supportSideBySide)&&k instanceof T){if((W==null?void 0:W.supportSideBySide)===n.BOTH)return{primary:this.getOriginalUri(k.primary,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(k.secondary,{filterByScheme:W.filterByScheme})};k=W.supportSideBySide===n.PRIMARY?k.primary:k.secondary}const Q=O(k)?k.preferredResource:k.resource;return!Q||!W||!W.filterByScheme?Q:this.filterUri(Q,W.filterByScheme)}}getCanonicalUri(k,W){if(!!k){if((W==null?void 0:W.supportSideBySide)&&k instanceof T){if((W==null?void 0:W.supportSideBySide)===n.BOTH)return{primary:this.getCanonicalUri(k.primary,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(k.secondary,{filterByScheme:W.filterByScheme})};k=W.supportSideBySide===n.PRIMARY?k.primary:k.secondary}const Q=k.resource;return!Q||!W||!W.filterByScheme?Q:this.filterUri(Q,W.filterByScheme)}}filterUri(k,W){if(Array.isArray(W)){if(W.some(Q=>k.scheme===Q))return k}else if(W===k.scheme)return k}}e.EditorResourceAccessor=new r;var o;(function(P){P[P.LEFT=0]="LEFT",P[P.RIGHT=1]="RIGHT"})(o=e.CloseDirection||(e.CloseDirection={}));class y{constructor(){this.customEditorInputFactoryInstances=new Map,this.editorInputSerializerConstructors=new Map,this.editorInputSerializerInstances=new Map}start(k){const W=this.instantiationService=k.get(C.IInstantiationService);for(const[Q,z]of this.editorInputSerializerConstructors)this.createEditorInputSerializer(Q,z,W);this.editorInputSerializerConstructors.clear()}createEditorInputSerializer(k,W,Q){const z=Q.createInstance(W);this.editorInputSerializerInstances.set(k,z)}registerFileEditorInputFactory(k){if(this.fileEditorInputFactory)throw new Error("Can only register one file editor input factory.");this.fileEditorInputFactory=k}getFileEditorInputFactory(){return(0,b.assertIsDefined)(this.fileEditorInputFactory)}registerEditorInputSerializer(k,W){if(this.editorInputSerializerConstructors.has(k)||this.editorInputSerializerInstances.has(k))throw new Error(`A editor input serializer with type ID '${k}' was already registered.`);return this.instantiationService?this.createEditorInputSerializer(k,W,this.instantiationService):this.editorInputSerializerConstructors.set(k,W),(0,A.toDisposable)(()=>{this.editorInputSerializerConstructors.delete(k),this.editorInputSerializerInstances.delete(k)})}getEditorInputSerializer(k){return this.editorInputSerializerInstances.get(typeof k=="string"?k:k.typeId)}registerCustomEditorInputFactory(k,W){this.customEditorInputFactoryInstances.set(k,W)}getCustomEditorInputFactory(k){return this.customEditorInputFactoryInstances.get(k)}}g.Registry.add(e.EditorExtensions.EditorInputFactories,new y);async function E(P,k){if(!P||!P.length)return[];const W=await Promise.all(P.map(async Q=>{const z=_.URI.revive(Q.fileUri);if(!(!z||!k.canHandleResource(z))){const H=typeof Q.exists=="boolean"?Q.exists:await k.exists(z);if(!(!H&&Q.openOnlyIfExists)){const Y=H&&typeof Q.lineNumber=="number"?{selection:{startLineNumber:Q.lineNumber,startColumn:Q.columnNumber||1},pinned:!0,override:Q.editorOverrideId}:{pinned:!0,override:Q.editorOverrideId};let B;return H?B={resource:z,options:Y,forceFile:!0}:B={resource:z,options:Y,forceUntitled:!0},B}}}));return(0,m.coalesce)(W)}e.pathsToEditors=E;var F;(function(P){P[P.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",P[P.SEQUENTIAL=1]="SEQUENTIAL"})(F=e.EditorsOrder||(e.EditorsOrder={}));function R(P,k){if(typeof k!="number"||k===v.ACTIVE_GROUP)return v.ACTIVE_GROUP;const W=P.getGroups(2);let Q=W[k];if(Q)return Q.id;let z=W[0];return W.length===1&&z.count===0?z.id:v.SIDE_GROUP}e.viewColumnToEditorGroup=R;function u(P,k){let W=typeof k=="number"?P.getGroup(k):k;return W=W!=null?W:P.activeGroup,P.getGroups(2).indexOf(W)}e.editorGroupToViewColumn=u}),define(J[189],Z([0,1,12,185,14,164,178,83,186,188,84,8,153,82]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let a=class{constructor(p,O,T,d,l,s,t,i,n,r){this._remoteAuthority=p,this._channel=O,this._configurationService=T,this._workspaceContextService=d,this._resolverService=l,this._environmentVariableService=s,this._remoteAuthorityResolverService=t,this._logService=i,this._editorService=n,this._labelService=r}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessTitleChanged(){return this._channel.listen("$onProcessTitleChangedEvent")}get onProcessShellTypeChanged(){return this._channel.listen("$onProcessShellTypeChangedEvent")}get onProcessOverrideDimensions(){return this._channel.listen("$onProcessOverrideDimensionsEvent")}get onProcessResolvedShellLaunchConfig(){return this._channel.listen("$onProcessResolvedShellLaunchConfigEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(p,O,T,d,l,s){await this._configurationService.whenRemoteConfigurationLoaded();const t=Object.create(null),i=T?(0,f.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(T)):void 0;let n;try{n=await this._resolverService.resolveWithInteraction(i,{shellLaunchConfig:p,configuration:O})}catch(k){this._logService.error(k)}if(n)for(const[k,W]of n.entries())(/^config:/.test(k)||k==="selectedText"||k==="lineNumber")&&(t[k]=W);const r=[];for(const[k,W]of this._environmentVariableService.collections.entries())r.push([k,(0,C.serializeEnvironmentVariableCollection)(W.map)]);const o=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),y=o.options&&o.options.extensionHostEnv,E=this._workspaceContextService.getWorkspace(),F=E.folders,R=T?this._workspaceContextService.getWorkspaceFolder(T):null,u=g.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:g.SideBySideEditor.PRIMARY,filterByScheme:[m.Schemas.file,m.Schemas.userData,m.Schemas.vscodeRemote]}),P={configuration:O,resolvedVariables:t,envVariableCollections:r,shellLaunchConfig:p,workspaceId:E.id,workspaceName:this._labelService.getWorkspaceLabel(E),workspaceFolders:F,activeWorkspaceFolder:R,activeFileResource:u,shouldPersistTerminal:d,cols:l,rows:s,resolverEnv:y};return await this._channel.call("$createProcess",P)}attachToProcess(p){return this._channel.call("$attachToProcess",[p])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(p,O){return this._channel.call("$processBinary",[p,O])}start(p){return this._channel.call("$start",[p])}input(p,O){return this._channel.call("$input",[p,O])}acknowledgeDataEvent(p,O){return this._channel.call("$acknowledgeDataEvent",[p,O])}shutdown(p,O){return this._channel.call("$shutdown",[p,O])}resize(p,O,T){return this._channel.call("$resize",[p,O,T])}getInitialCwd(p){return this._channel.call("$getInitialCwd",[p])}getCwd(p){return this._channel.call("$getCwd",[p])}orphanQuestionReply(p){return this._channel.call("$orphanQuestionReply",[p])}sendCommandResult(p,O,T){return this._channel.call("$sendCommandResult",[p,O,T])}getDefaultSystemShell(p){return this._channel.call("$getDefaultSystemShell",[p])}getShellEnvironment(){return this._channel.call("$getShellEnvironment")}setTerminalLayoutInfo(p){const T={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:p.tabs};return this._channel.call("$setTerminalLayoutInfo",T)}getTerminalLayoutInfo(){const O={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",O)}};a=ve([ge(2,L.IWorkbenchConfigurationService),ge(3,A.IWorkspaceContextService),ge(4,h.IConfigurationResolverService),ge(5,w.IEnvironmentVariableService),ge(6,_.IRemoteAuthorityResolverService),ge(7,b.ILogService),ge(8,D.IEditorService),ge(9,v.ILabelService)],a),e.RemoteTerminalChannelClient=a}),define(J[190],Z([0,1,161]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Logger=e.Translations=void 0;var L;(function(_){function A(C,h){if(C===h)return!0;let g=Object.keys(C),D=new Set;for(let m of Object.keys(h))D.add(m);if(g.length!==D.size)return!1;for(let m of g){if(C[m]!==h[m])return!1;D.delete(m)}return D.size===0}_.equals=A})(L=e.Translations||(e.Translations={}));class b{constructor(A){this._messageHandler=A}error(A,C){this._messageHandler(f.Severity.Error,A,C)}warn(A,C){this._messageHandler(f.Severity.Warning,A,C)}info(A,C){this._messageHandler(f.Severity.Info,A,C)}}e.Logger=b}),define(J[191],Z([0,1,16,132,4,44,61,23,110,12,7,19,30,51,41,190]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=void 0;const p="package.json";class O{constructor(r,o,y,E,F){this._ourVersion=r,this._log=o,this._absoluteFolderPath=y,this._isBuiltin=E,this._isUnderDevelopment=F,this._absoluteManifestPath=b.join(y,p)}}class T extends O{static _fastParseJSON(r,o){try{return JSON.parse(r)}catch(y){return A.parse(r,o)}}parse(){return f.promises.readFile(this._absoluteManifestPath).then(r=>{var o;const y=[],E=T._fastParseJSON(r.toString(),y);if(A.getNodeType(E)!=="object")this._log.error(this._absoluteFolderPath,L.localize(0,null,this._absoluteManifestPath));else{if(y.length===0)return E.__metadata&&(E.uuid=E.__metadata.id),E.isUserBuiltin=!!((o=E.__metadata)===null||o===void 0?void 0:o.isBuiltin),delete E.__metadata,E;y.forEach(F=>{this._log.error(this._absoluteFolderPath,L.localize(1,null,this._absoluteManifestPath,F.offset,F.length,(0,h.getParseErrorMessage)(F.error)))})}return null},r=>(r.code==="ENOENT"||this._log.error(this._absoluteFolderPath,L.localize(2,null,this._absoluteManifestPath,r.message)),null))}}class d extends O{constructor(r,o,y,E,F,R){super(r,o,y,E,F);this._nlsConfig=R}replaceNLS(r){const o=(k,W)=>{W.forEach(Q=>{this._log.error(this._absoluteFolderPath,L.localize(3,null,k,(0,h.getParseErrorMessage)(Q.error)))})},y=k=>{this._log.error(this._absoluteFolderPath,L.localize(4,null,k))};let E=b.extname(this._absoluteManifestPath),F=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-E.length);const R=`${r.publisher}.${r.name}`;let u=this._nlsConfig.translations[R],P;return u?P=f.promises.readFile(u,"utf8").then(k=>{let W=[],Q=A.parse(k,W);return W.length>0?(o(u,W),{values:void 0,default:`${F}.nls.json`}):A.getNodeType(Q)!=="object"?(y(u),{values:void 0,default:`${F}.nls.json`}):{values:Q.contents?Q.contents.package:void 0,default:`${F}.nls.json`}},k=>({values:void 0,default:`${F}.nls.json`})):P=m.SymlinkSupport.existsFile(F+".nls"+E).then(k=>{if(!!k)return d.findMessageBundles(this._nlsConfig,F).then(W=>W.localized?f.promises.readFile(W.localized,"utf8").then(Q=>{let z=[],H=A.parse(Q,z);return z.length>0?(o(W.localized,z),{values:void 0,default:W.original}):A.getNodeType(H)!=="object"?(y(W.localized),{values:void 0,default:W.original}):{values:H,default:W.original}},Q=>({values:void 0,default:W.original})):{values:void 0,default:W.original},W=>{})}),P.then(k=>{if(k===void 0)return r;let W=[];return d.resolveOriginalMessageBundle(k.default,W).then(Q=>{if(W.length>0)return o(k.default,W),r;if(A.getNodeType(k)!=="object")return y(k.default),r;const z=k.values||Object.create(null);return d._replaceNLStrings(this._nlsConfig,r,z,Q,this._log,this._absoluteFolderPath),r})},k=>r)}static resolveOriginalMessageBundle(r,o){return new Promise((y,E)=>{r?f.promises.readFile(r).then(F=>{y(A.parse(F.toString(),o))},F=>{y(null)}):y(null)})}static findMessageBundles(r,o){return new Promise((y,E)=>{function F(R,u){let P=`${R}.nls.${u}.json`;m.SymlinkSupport.existsFile(P).then(k=>{k&&y({localized:P,original:`${R}.nls.json`});let W=u.lastIndexOf("-");W===-1?y({localized:`${R}.nls.json`,original:null}):(u=u.substring(0,W),F(R,u))})}if(r.devMode||r.pseudo||!r.locale)return y({localized:o+".nls.json",original:null});F(o,r.locale)})}static _replaceNLStrings(r,o,y,E,F,R){function u(P,k,W){let Q=P[k];if(g.isString(Q)){let z=Q,H=z.length;if(H>1&&z[0]==="%"&&z[H-1]==="%"){let Y=z.substr(1,H-2),B=y[Y];B===void 0&&E&&(B=E[Y]),B?(r.pseudo&&(B="\uFF3B"+B.replace(/[aouei]/g,"$&$&")+"\uFF3D"),P[k]=W&&(k==="title"||k==="category")&&E?{value:B,original:E[Y]}:B):F.warn(R,L.localize(5,null,Y))}}else if(g.isObject(Q))for(let z in Q)Q.hasOwnProperty(z)&&(z==="commands"?u(Q,z,!0):u(Q,z,W));else if(g.isArray(Q))for(let z=0;z<Q.length;z++)u(Q,z,W)}for(let P in o)o.hasOwnProperty(P)&&u(o,P)}}class l extends O{validate(r){let o=r;o.isBuiltin=this._isBuiltin,o.isUserBuiltin=!this._isBuiltin&&!!o.isUserBuiltin,o.isUnderDevelopment=this._isUnderDevelopment;let y=[];return l.isValidExtensionDescription(this._ourVersion,this._absoluteFolderPath,o,y)?(y.forEach(E=>{this._log.warn(this._absoluteFolderPath,E)}),o.publisher||(o.publisher="undefined_publisher"),o.id=(0,v.getExtensionId)(o.publisher,o.name),o.identifier=new a.ExtensionIdentifier(o.id),o.extensionLocation=D.URI.file(this._absoluteFolderPath),o):(y.forEach(E=>{this._log.error(this._absoluteFolderPath,E)}),null)}static isValidExtensionDescription(r,o,y,E){return l.baseIsValidExtensionDescription(o,y,E)?_.valid(y.version)?(0,w.isValidExtensionVersion)(r,y,E):(E.push(L.localize(6,null)),!1):!1}static baseIsValidExtensionDescription(r,o,y){if(!o)return y.push(L.localize(7,null)),!1;if(typeof o.publisher!="undefined"&&typeof o.publisher!="string")return y.push(L.localize(8,null)),!1;if(typeof o.name!="string")return y.push(L.localize(9,null,"name")),!1;if(typeof o.version!="string")return y.push(L.localize(10,null,"version")),!1;if(!o.engines)return y.push(L.localize(11,null,"engines")),!1;if(typeof o.engines.vscode!="string")return y.push(L.localize(12,null,"engines.vscode")),!1;if(typeof o.extensionDependencies!="undefined"&&!l._isStringArray(o.extensionDependencies))return y.push(L.localize(13,null,"extensionDependencies")),!1;if(typeof o.activationEvents!="undefined"){if(!l._isStringArray(o.activationEvents))return y.push(L.localize(14,null,"activationEvents")),!1;if(typeof o.main=="undefined"&&typeof o.browser=="undefined")return y.push(L.localize(15,null,"activationEvents","main")),!1}if(typeof o.main!="undefined"){if(typeof o.main!="string")return y.push(L.localize(16,null,"main")),!1;{const E=b.join(r,o.main);E.startsWith(r)||y.push(L.localize(17,null,E,r))}if(typeof o.activationEvents=="undefined")return y.push(L.localize(18,null,"activationEvents","main")),!1}if(typeof o.browser!="undefined"){if(typeof o.browser!="string")return y.push(L.localize(19,null,"browser")),!1;{const E=b.join(r,o.browser);E.startsWith(r)||y.push(L.localize(20,null,E,r))}if(typeof o.activationEvents=="undefined")return y.push(L.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(r){if(!Array.isArray(r))return!1;for(let o=0,y=r.length;o<y;o++)if(typeof r[o]!="string")return!1;return!0}}class s{constructor(r,o,y,E,F,R,u,P){this.ourVersion=r,this.commit=o,this.locale=y,this.devMode=E,this.absoluteFolderPath=F,this.isBuiltin=R,this.isUnderDevelopment=u,this.translations=P}static createNLSConfig(r){return{devMode:r.devMode,locale:r.locale,pseudo:r.locale==="pseudo",translations:r.translations}}static equals(r,o){return r.ourVersion===o.ourVersion&&r.commit===o.commit&&r.locale===o.locale&&r.devMode===o.devMode&&r.absoluteFolderPath===o.absoluteFolderPath&&r.isBuiltin===o.isBuiltin&&r.isUnderDevelopment===o.isUnderDevelopment&&r.mtime===o.mtime&&c.Translations.equals(r.translations,o.translations)}}e.ExtensionScannerInput=s;class t{constructor(r){this.root=r}resolveExtensions(){return m.readDirsInDir(this.root).then(r=>r.map(o=>({name:o,path:b.join(this.root,o)})))}}class i{static scanExtension(r,o,y,E,F,R){return y=b.normalize(y),new T(r,o,y,E,F).parse().then(P=>P===null?null:new d(r,o,y,E,F,R).replaceNLS(P)).then(P=>P===null?null:new l(r,o,y,E,F).validate(P))}static async scanExtensions(r,o,y=null){const E=r.absoluteFolderPath,F=r.isBuiltin,R=r.isUnderDevelopment;y||(y=new t(E));try{let u={};if(!F)try{const z=await f.promises.readFile(b.join(E,".obsolete"),"utf8");u=JSON.parse(z)}catch(z){}let P=await y.resolveExtensions();P.sort((z,H)=>z.name<H.name?-1:1),F||(P=P.filter(z=>z.name.indexOf(".")!==0));const k=s.createNLSConfig(r);let W=await Promise.all(P.map(z=>this.scanExtension(r.ourVersion,o,z.path,F,R,k))),Q=C.coalesce(W);return Q=Q.filter(z=>z!==null&&!u[new v.ExtensionIdentifierWithVersion({id:(0,v.getGalleryExtensionId)(z.publisher,z.name)},z.version).key()]),F||(Q=(0,v.groupByExtension)(Q,H=>({id:H.identifier.value,uuid:H.uuid})).map(H=>H.sort((Y,B)=>_.rcompare(Y.version,B.version))[0])),Q.sort((z,H)=>z.extensionLocation.fsPath<H.extensionLocation.fsPath?-1:1),Q}catch(u){return o.error(E,u),[]}}static scanOneOrMultipleExtensions(r,o){const y=r.absoluteFolderPath,E=r.isBuiltin,F=r.isUnderDevelopment;return m.SymlinkSupport.existsFile(b.join(y,p)).then(R=>{if(R){const u=s.createNLSConfig(r);return this.scanExtension(r.ourVersion,o,y,E,F,u).then(P=>P===null?[]:[P])}return this.scanExtensions(r,o)},R=>(o.error(y,R),[]))}static scanSingleExtension(r,o){const y=r.absoluteFolderPath,E=r.isBuiltin,F=r.isUnderDevelopment,R=s.createNLSConfig(r);return this.scanExtension(r.ourVersion,o,y,E,F,R)}static mergeBuiltinExtensions(r,o){return Promise.all([r,o]).then(([y,E])=>{let F=Object.create(null);for(let u=0,P=y.length;u<P;u++)F[a.ExtensionIdentifier.toKey(y[u].identifier)]=y[u];for(let u=0,P=E.length;u<P;u++)F[a.ExtensionIdentifier.toKey(E[u].identifier)]=E[u];let R=Object.keys(F).map(u=>F[u]);return R.sort((u,P)=>{const k=b.basename(u.extensionLocation.fsPath),W=b.basename(P.extensionLocation.fsPath);return k<W?-1:k>W?1:0}),R})}}e.ExtensionScanner=i}),define(J[192],Z([0,1,39,25,36,17,27,5,3,15,7,48,41,56,31,58,81,182,83,183,184,187,191]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w,a,c,p,O,T,d,l,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProviderChannel=e.ExtensionEnvironmentChannel=e.FileProviderChannel=void 0;class i extends w.DiskFileSystemProvider{constructor(){super(...arguments);this.watches=new Map}dispose(){this.watches.forEach(R=>R.dispose()),this.watches.clear(),super.dispose()}_watch(R,u,P){this.watches.set(R,this.watch(u,P))}unwatch(R){this.watches.get(R).dispose(),this.watches.delete(R)}}class n{constructor(R,u){this.environmentService=R,this.logService=u,this.watchers=new Map,this.provider=new w.DiskFileSystemProvider(this.logService)}listen(R,u,P){switch(u){case"filechange":return this.filechange(R,P[0]);case"readFileStream":return this.readFileStream(P[0],P[1])}throw new Error(`Invalid listen '${u}'`)}filechange(R,u){const P=new C.Emitter({onFirstListenerAdd:()=>{const k=new i(this.logService);this.watchers.set(u,k);const W=(0,p.getUriTransformer)(R.remoteAuthority);k.onDidChangeFile(Q=>{P.fire(Q.map(z=>Object.assign(Object.assign({},z),{resource:W.transformOutgoing(z.resource)})))}),k.onDidErrorOccur(Q=>this.logService.error(Q))},onLastListenerRemove:()=>{this.watchers.get(u).dispose(),this.watchers.delete(u)}});return P.event}readFileStream(R,u){const P=new A.CancellationTokenSource,k=this.provider.readFileStream(this.transform(R),u,P.token),W=new C.Emitter({onFirstListenerAdd:()=>{k.on("data",Q=>W.fire(_.VSBuffer.wrap(Q))),k.on("error",Q=>W.fire(Q)),k.on("end",()=>W.fire("end"))},onLastListenerRemove:()=>P.cancel()});return W.event}call(R,u,P){switch(u){case"stat":return this.stat(P[0]);case"open":return this.open(P[0],P[1]);case"close":return this.close(P[0]);case"read":return this.read(P[0],P[1],P[2]);case"readFile":return this.readFile(P[0]);case"write":return this.write(P[0],P[1],P[2],P[3],P[4]);case"writeFile":return this.writeFile(P[0],P[1],P[2]);case"delete":return this.delete(P[0],P[1]);case"mkdir":return this.mkdir(P[0]);case"readdir":return this.readdir(P[0]);case"rename":return this.rename(P[0],P[1],P[2]);case"copy":return this.copy(P[0],P[1],P[2]);case"watch":return this.watch(P[0],P[1],P[2],P[3]);case"unwatch":return this.unwatch(P[0],P[1])}throw new Error(`Invalid call '${u}'`)}dispose(){this.watchers.forEach(R=>R.dispose()),this.watchers.clear()}async stat(R){return this.provider.stat(this.transform(R))}async open(R,u){return this.provider.open(this.transform(R),u)}async close(R){return this.provider.close(R)}async read(R,u,P){const k=_.VSBuffer.alloc(P),W=await this.provider.read(R,u,k.buffer,0,P);return[k,W]}async readFile(R){return _.VSBuffer.wrap(await this.provider.readFile(this.transform(R)))}write(R,u,P,k,W){return this.provider.write(R,u,P.buffer,k,W)}writeFile(R,u,P){return this.provider.writeFile(this.transform(R),u.buffer,P)}async delete(R,u){return this.provider.delete(this.transform(R),u)}async mkdir(R){return this.provider.mkdir(this.transform(R))}async readdir(R){return this.provider.readdir(this.transform(R))}async rename(R,u,P){return this.provider.rename(this.transform(R),D.URI.from(u),P)}copy(R,u,P){return this.provider.copy(this.transform(R),D.URI.from(u),P)}async watch(R,u,P,k){this.watchers.get(R)._watch(u,this.transform(P),k)}async unwatch(R,u){this.watchers.get(R).unwatch(u)}transform(R){if(/^\/static[^/]*\//.test(R.path))return D.URI.file(this.environmentService.appRoot+R.path.replace(/^\/static[^/]*\//,"/"));if(R.path==="/vscode-resource"&&R.query)try{const u=JSON.parse(R.query);if(u.requestResourcePath)return D.URI.file(u.requestResourcePath)}catch(u){}return D.URI.from(R)}}e.FileProviderChannel=n;class r{constructor(R,u,P,k){this.environment=R,this.log=u,this.telemetry=P,this.connectionToken=k}listen(R,u){throw new Error(`Invalid listen '${u}'`)}async call(R,u,P){switch(u){case"getEnvironmentData":return(0,m.transformOutgoingURIs)(await this.getEnvironmentData(),(0,p.getUriTransformer)(R.remoteAuthority));case"scanExtensions":return(0,m.transformOutgoingURIs)(await this.scanExtensions(P.language),(0,p.getUriTransformer)(R.remoteAuthority));case"getDiagnosticInfo":return this.getDiagnosticInfo();case"disableTelemetry":return this.disableTelemetry();case"logTelemetry":return this.logTelemetry(P[0],P[1]);case"flushTelemetry":return this.flushTelemetry()}throw new Error(`Invalid call '${u}'`)}async getEnvironmentData(){return{pid:process.pid,connectionToken:this.connectionToken,appRoot:D.URI.file(this.environment.appRoot),settingsPath:this.environment.settingsResource,logsPath:D.URI.file(this.environment.logsPath),extensionsPath:D.URI.file(this.environment.extensionsPath),extensionHostLogsPath:D.URI.file(b.join(this.environment.logsPath,"extension-host")),globalStorageHome:this.environment.globalStorageHome,workspaceStorageHome:this.environment.workspaceStorageHome,userHome:this.environment.userHome,useHostProxy:!1,os:h.OS,marks:[]}}async scanExtensions(R){const u=await(0,c.getTranslations)(R,this.environment.userDataPath),P=(Q,z,H)=>Promise.all(H.map(Y=>t.ExtensionScanner.scanExtensions(new t.ExtensionScannerInput(a.default.version,a.default.commit,R,!!process.env.VSCODE_DEV,Y,Q,z,u),this.log))),k=async()=>P(!0,!1,[this.environment.builtinExtensionsPath,...this.environment.extraBuiltinExtensionPaths]),W=async()=>P(!1,!0,[this.environment.extensionsPath,...this.environment.extraExtensionPaths]);return Promise.all([k(),W()]).then(Q=>{const z=new Map;return Q.forEach(H=>{H.forEach(Y=>{Y.forEach(B=>{const x=v.ExtensionIdentifier.toKey(B.identifier);if(z.has(x)){const U=z.get(x).extensionLocation.fsPath,S=B.extensionLocation.fsPath;this.log.warn(`${U} has been overridden ${S}`)}z.set(x,B)})})}),Array.from(z.values())})}getDiagnosticInfo(){throw new Error("not implemented")}async disableTelemetry(){this.telemetry.setEnabled(!1)}async logTelemetry(R,u){this.telemetry.publicLog(R,u)}async flushTelemetry(){}}e.ExtensionEnvironmentChannel=r;class o extends s.AbstractVariableResolverService{constructor(R,u,P){super({getFolderUri:k=>{const W=u.workspaceFolders.find(Q=>Q.name===k);return W&&D.URI.revive(W.uri)},getWorkspaceFolderCount:()=>u.workspaceFolders.length,getConfigurationValue:(k,W)=>u.resolvedVariables[`config:${W}`],getAppRoot:()=>u.resolverEnv&&u.resolverEnv.VSCODE_CWD||P.VSCODE_CWD||process.cwd(),getExecPath:()=>u.resolverEnv&&u.resolverEnv.VSCODE_EXEC_PATH||P.VSCODE_EXEC_PATH,getFilePath:()=>{const k=E(R,u.activeFileResource);if(!!k)return k.scheme==="file"?k.fsPath:k.path},getSelectedText:()=>u.resolvedVariables.selectedText,getLineNumber:()=>u.resolvedVariables.selectedText},void 0,Promise.resolve(P))}}class y{constructor(R,u){this.logService=R,this.ptyService=u}listen(R,u,P){switch(f.logger.trace("TerminalProviderChannel:listen",(0,f.field)("event",u),(0,f.field)("args",P)),u){case"$onPtyHostExitEvent":return this.ptyService.onPtyHostExit||C.Event.None;case"$onPtyHostStartEvent":return this.ptyService.onPtyHostStart||C.Event.None;case"$onPtyHostUnresponsiveEvent":return this.ptyService.onPtyHostUnresponsive||C.Event.None;case"$onPtyHostResponsiveEvent":return this.ptyService.onPtyHostResponsive||C.Event.None;case"$onProcessDataEvent":return this.ptyService.onProcessData;case"$onProcessExitEvent":return this.ptyService.onProcessExit;case"$onProcessReadyEvent":return this.ptyService.onProcessReady;case"$onProcessReplayEvent":return this.ptyService.onProcessReplay;case"$onProcessTitleChangedEvent":return this.ptyService.onProcessTitleChanged;case"$onProcessShellTypeChangedEvent":return this.ptyService.onProcessShellTypeChanged;case"$onProcessOverrideDimensionsEvent":return this.ptyService.onProcessOverrideDimensions;case"$onProcessResolvedShellLaunchConfigEvent":return this.ptyService.onProcessResolvedShellLaunchConfig;case"$onProcessOrphanQuestion":return this.ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return C.Event.None}throw new Error(`Invalid listen '${u}'`)}call(R,u,P){switch(f.logger.trace("TerminalProviderChannel:call",(0,f.field)("command",u),(0,f.field)("args",P)),u){case"$restartPtyHost":return this.restartPtyHost();case"$createProcess":return this.createProcess(R.remoteAuthority,P);case"$attachToProcess":return this.ptyService.attachToProcess(P[0]);case"$start":return this.ptyService.start(P[0]);case"$input":return this.ptyService.input(P[0],P[1]);case"$acknowledgeDataEvent":return this.ptyService.acknowledgeDataEvent(P[0],P[1]);case"$shutdown":return this.ptyService.shutdown(P[0],P[1]);case"$resize":return this.ptyService.resize(P[0],P[1],P[2]);case"$getInitialCwd":return this.ptyService.getInitialCwd(P[0]);case"$getCwd":return this.ptyService.getCwd(P[0]);case"$sendCommandResult":return this.sendCommandResult(P[0],P[1],P[2],P[3]);case"$orphanQuestionReply":return this.ptyService.orphanQuestionReply(P[0]);case"$listProcesses":return this.ptyService.listProcesses();case"$setTerminalLayoutInfo":return this.ptyService.setTerminalLayoutInfo(P);case"$getTerminalLayoutInfo":return this.ptyService.getTerminalLayoutInfo(P);case"$getShellEnvironment":return this.ptyService.getShellEnvironment();case"$getDefaultSystemShell":return this.ptyService.getDefaultSystemShell(P[0]);case"$reduceConnectionGraceTime":return this.ptyService.reduceConnectionGraceTime()}throw new Error(`Invalid call '${u}'`)}async dispose(){}async restartPtyHost(){if(this.ptyService.restartPtyHost)return this.ptyService.restartPtyHost()}async createProcess(R,u){var P;const k={name:u.shellLaunchConfig.name,executable:u.shellLaunchConfig.executable,args:u.shellLaunchConfig.args,cwd:typeof u.shellLaunchConfig.cwd!="string"?E(R,u.shellLaunchConfig.cwd):u.shellLaunchConfig.cwd,env:u.shellLaunchConfig.env},W=E(R,(P=u.activeWorkspaceFolder)===null||P===void 0?void 0:P.uri),Q=W&&u.activeWorkspaceFolder?Object.assign(Object.assign({},u.activeWorkspaceFolder),{uri:W,toResource:S=>g.joinPath(W,S)}):void 0,z=new o(R,u,process.env),H=d.createVariableResolver(Q,process.env,z);k.cwd=d.getCwd(k,L.homedir(),H,W,u.configuration["terminal.integrated.cwd"],this.logService);const Y=()=>h.isWindows?u.configuration["terminal.integrated.env.windows"]:h.isMacintosh?u.configuration["terminal.integrated.env.osx"]:u.configuration["terminal.integrated.env.linux"],B=async()=>{const S=await(0,l.getMainProcessParentEnv)(process.env);return S.VSCODE_IPC_HOOK_CLI=process.env.VSCODE_IPC_HOOK_CLI,S},x=d.createTerminalEnvironment(k,Y(),H,a.default.version,u.configuration["terminal.integrated.detectLocale"],u.configuration["terminal.integrated.inheritEnv"]!==!1?process.env:await B());if(!k.strictEnv){const S=new Map;for(const[N,M]of u.envVariableCollections)S.set(N,{map:(0,T.deserializeEnvironmentVariableCollection)(M)});new O.MergedEnvironmentVariableCollection(S).applyToProcessEnvironment(x)}return{persistentTerminalId:await this.ptyService.createProcess(k,k.cwd,u.cols,u.rows,x,process.env,!1,u.shouldPersistTerminal,u.workspaceId,u.workspaceName),resolvedShellLaunchConfig:k}}async sendCommandResult(R,u,P,k){throw new Error("not implemented")}}e.TerminalProviderChannel=y;function E(F,R){const u=(0,p.getUriTransformer)(F);return R&&D.URI.revive(u.transformIncoming(R))}}),define(J[193],Z([0,1,139]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProvider=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remotefilesystem";class L extends f.IPCFileSystemProvider{constructor(_){super(_.getConnection().getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME));this.setCaseSensitive(!0),(async()=>{const A=await _.getEnvironment();this.setCaseSensitive((A==null?void 0:A.os)===3)})()}}e.RemoteFileSystemProvider=L}),define(J[194],Z([0,1,6]),function(q,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,f.createDecorator)("remoteAgentService")}),define(J[47],Z([0,1,113,4,16,13,19,210,211,12]),function(q,e,f,L,b,_,A,C,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class D extends Error{constructor(t,i){let n=i.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=i}}e.ExtractError=D;function m(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>t&i).reduce((i,n)=>i+n,t&61440)}function v(s){if(s instanceof D)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new D(t,s)}function w(s,t,i,n,r,o){const y=L.dirname(t),E=L.join(n,y);if(!E.startsWith(n))return Promise.reject(new Error(f.localize(0,null,t)));const F=L.join(n,t);let R;return o.onCancellationRequested(()=>{R&&R.destroy()}),Promise.resolve(b.promises.mkdir(E,{recursive:!0})).then(()=>new Promise((u,P)=>{if(!o.isCancellationRequested)try{R=(0,b.createWriteStream)(F,{mode:i}),R.once("close",()=>u()),R.once("error",P),s.once("error",P),s.pipe(R)}catch(k){P(k)}}))}function a(s,t,i,n){let r=(0,_.createCancelablePromise)(()=>Promise.resolve()),o=0;return n.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((y,E)=>{const F=new _.Sequencer,R=u=>{u.isCancellationRequested||(o++,s.readEntry())};s.once("error",E),s.once("close",()=>r.then(()=>{n.isCancellationRequested||s.entryCount===o?y():E(new D("Incomplete",new Error(f.localize(1,null,o,s.entryCount))))},E)),s.readEntry(),s.on("entry",u=>{if(!n.isCancellationRequested){if(!i.sourcePathRegex.test(u.fileName)){R(n);return}const P=u.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(P)){const Q=L.join(t,P);r=(0,_.createCancelablePromise)(z=>b.promises.mkdir(Q,{recursive:!0}).then(()=>R(z)).then(void 0,E));return}const k=p(s,u),W=m(u);r=(0,_.createCancelablePromise)(Q=>F.queue(()=>k.then(z=>w(z,P,W,t,i,Q).then(()=>R(Q)))).then(null,E))}})})}function c(s,t=!1){return new Promise((i,n)=>{(0,C.open)(s,t?{lazyEntries:!0}:void 0,(r,o)=>{r?n(v(r)):i((0,g.assertIsDefined)(o))})})}function p(s,t){return new Promise((i,n)=>{s.openReadStream(t,(r,o)=>{r?n(v(r)):i((0,g.assertIsDefined)(o))})})}function O(s,t){return new Promise((i,n)=>{const r=new h.ZipFile;t.forEach(y=>{y.contents?r.addBuffer(typeof y.contents=="string"?Buffer.from(y.contents,"utf8"):y.contents,y.path):y.localPath&&r.addFile(y.localPath,y.path)}),r.end();const o=(0,b.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",n),o.once("error",n),o.once("finish",()=>i(s))})}e.zip=O;function T(s,t,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let o=c(s,!0);return i.overwrite&&(o=o.then(y=>(0,A.rimraf)(t).then(()=>y))),o.then(y=>a(y,t,{sourcePathRegex:r},n))}e.extract=T;function d(s,t){return c(s).then(i=>new Promise((n,r)=>{i.on("entry",o=>{o.fileName===t&&p(i,o).then(y=>n(y),y=>r(y))}),i.once("close",()=>r(new Error(f.localize(2,null,t))))}))}function l(s,t){return d(s,t).then(i=>new Promise((n,r)=>{const o=[];i.once("error",r),i.on("data",y=>o.push(y)),i.on("end",()=>n(Buffer.concat(o)))}))}e.buffer=l}),define(J[195],Z([0,1,47,120]),function(q,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function b(_){return(0,f.buffer)(_,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(C){throw new Error((0,L.localize)(0,null))}})}e.getManifest=b}),define(J[196],Z([0,1,16,44,2,19,4,14,29,30,13,7,21,138,121,45,47,3,23,8,20,15,24,11]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w,a,c,p,O,T,d,l,s,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const n="scanningSystem",r="scanningUser",o="extracting",y="deleting",E="renaming";let F=class extends b.Disposable{constructor(u,P,k,W,Q){super();this.beforeRemovingExtension=u,this.fileService=P,this.logService=k,this.environmentService=W,this.productService=Q,this._devSystemExtensionsPath=null,this.systemExtensionsPath=W.builtinExtensionsPath,this.extensionsPath=W.extensionsPath,this.uninstalledPath=A.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(u){const P=[];(u===null||u===0)&&P.push(this.scanSystemExtensions().then(null,k=>Promise.reject(new h.ExtensionManagementError(this.joinErrors(k).message,n)))),(u===null||u===1)&&P.push(this.scanUserExtensions(!0).then(null,k=>Promise.reject(new h.ExtensionManagementError(this.joinErrors(k).message,r))));try{const k=await Promise.all(P);return(0,T.flatten)(k)}catch(k){throw this.joinErrors(k)}}async scanUserExtensions(u){this.logService.trace("Started scanning user extensions");let[P,k]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return k=k.filter(W=>!P[new g.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version).key()]),u&&(k=(0,g.groupByExtension)(k,Q=>Q.identifier).map(Q=>Q.sort((z,H)=>L.rcompare(z.manifest.version,H.manifest.version))[0])),this.logService.trace("Scanned user extensions:",k.length),k}async scanAllUserExtensions(){return this.scanExtensionsInDirs(this.extensionsPath,this.environmentService.extraExtensionPaths,1)}async extractUserExtension(u,P,k){const W=u.key(),Q=A.join(this.extensionsPath,`.${(0,t.generateUuid)()}`),z=A.join(this.extensionsPath,W);try{await _.rimraf(z)}catch(Y){try{await _.rimraf(z)}catch(B){}throw new h.ExtensionManagementError((0,a.localize)(0,null,z,u.id),y)}await this.extractAtLocation(u,P,Q,k);let H=await this.scanExtension(m.URI.file(Q),1);if(!H)throw new Error((0,a.localize)(1,null,Q));await this.storeMetadata(H,{installedTimestamp:Date.now()});try{await this.rename(u,Q,z,Date.now()+2*60*1e3),this.logService.info("Renamed to",z)}catch(Y){try{await _.rimraf(Q)}catch(B){}if(Y.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",u.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(Y)}. Deleted from extracted location`,Q),Y}try{H=await this.scanExtension(m.URI.file(z),1)}catch(Y){}if(H)return H;throw new Error((0,a.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(u,P){return this.setMetadata(u,P),await this.storeMetadata(u,Object.assign(Object.assign({},P),{installedTimestamp:u.installedTimestamp})),u}async storeMetadata(u,P){P.isMachineScoped=P.isMachineScoped||void 0,P.isBuiltin=P.isBuiltin||void 0,P.installedTimestamp=P.installedTimestamp||void 0;const k=A.join(u.location.fsPath,"package.json"),W=await f.promises.readFile(k,"utf8"),{manifest:Q}=await this.parseManifest(W);return Q.__metadata=P,await _.writeFile(k,JSON.stringify(Q,null,"	")),u}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...u){const P=u.map(k=>new g.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version));await this.withUninstalledExtensions(k=>{P.forEach(W=>k[W.key()]=!0)})}async setInstalled(u){await this.withUninstalledExtensions(W=>delete W[u.key()]);const k=(await this.scanExtensions(1)).find(W=>new g.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version).equals(u))||null;return k?(await this.storeMetadata(k,{installedTimestamp:Date.now()}),this.scanExtension(k.location,1)):null}async withUninstalledExtensions(u){return this.uninstalledFileLimiter.queue(async()=>{let P;try{P=await f.promises.readFile(this.uninstalledPath,"utf8")}catch(W){if(W.code!=="ENOENT")throw W}let k={};if(P)try{k=JSON.parse(P)}catch(W){}return u&&(u(k),Object.keys(k).length?await _.writeFile(this.uninstalledPath,JSON.stringify(k)):await _.rimraf(this.uninstalledPath)),k})}async removeExtension(u,P){this.logService.trace(`Deleting ${P} extension from disk`,u.identifier.id,u.location.fsPath),await _.rimraf(u.location.fsPath),this.logService.info("Deleted from disk",u.identifier.id,u.location.fsPath)}async removeUninstalledExtension(u){await this.removeExtension(u,"uninstalled"),await this.withUninstalledExtensions(P=>delete P[new g.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()])}async extractAtLocation(u,P,k,W){this.logService.trace(`Started extracting the extension from ${P} to ${k}`);try{await _.rimraf(k)}catch(Q){throw new h.ExtensionManagementError(this.joinErrors(Q).message,y)}try{await(0,p.extract)(P,k,{sourcePath:"extension",overwrite:!0},W),this.logService.info(`Extracted extension to ${k}:`,u.id)}catch(Q){try{await _.rimraf(k)}catch(z){}throw new h.ExtensionManagementError(Q.message,Q instanceof p.ExtractError&&Q.type?Q.type:o)}}async rename(u,P,k,W){try{await f.promises.rename(P,k)}catch(Q){if(O.isWindows&&Q&&Q.code==="EPERM"&&Date.now()<W)return this.logService.info(`Failed renaming ${P} to ${k} with 'EPERM' error. Trying again...`,u.id),this.rename(u,P,k,W);throw new h.ExtensionManagementError(Q.message||(0,a.localize)(3,null,P,k),Q.code||E)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const u=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return u;const P=this.scanDevSystemExtensions(),[k,W]=await Promise.all([u,P]);return[...k,...W]}async scanExtensionsInDir(u,P){const k=new D.Limiter(10),W=await this.fileService.resolve(m.URI.file(u));return W.children?(await Promise.all(W.children.filter(z=>z.isDirectory).map(z=>k.queue(async()=>P===1&&(0,s.basename)(z.resource).indexOf(".")===0?null:this.scanExtension(z.resource,P))))).filter(z=>z&&z.identifier):[]}async scanExtension(u,P){var k,W;try{const Q=await this.fileService.resolve(u);if(Q.children){const{manifest:z,metadata:H}=await this.readManifest(u.fsPath),Y=(k=Q.children.find(({name:S})=>/^readme(\.txt|\.md|)$/i.test(S)))===null||k===void 0?void 0:k.resource,B=(W=Q.children.find(({name:S})=>/^changelog(\.txt|\.md|)$/i.test(S)))===null||W===void 0?void 0:W.resource,x={id:(0,g.getGalleryExtensionId)(z.publisher,z.name)},U={type:P,identifier:x,manifest:z,location:u,readmeUrl:Y,changelogUrl:B,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:P===0};return H&&(this.setMetadata(U,H),U.installedTimestamp=H.installedTimestamp),U}}catch(Q){P!==0&&this.logService.trace(Q)}return null}async scanDefaultSystemExtensions(){const u=await this.scanExtensionsInDirs(this.systemExtensionsPath,this.environmentService.extraBuiltinExtensionPaths,0);return this.logService.trace("Scanned system extensions:",u.length),u}async scanDevSystemExtensions(){const u=this.getDevSystemExtensionsList();if(u.length){const P=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",P.length),P.filter(k=>u.some(W=>(0,g.areSameExtensions)(k.identifier,{id:W})))}else return[]}setMetadata(u,P){u.publisherDisplayName=P.publisherDisplayName||null,u.publisherId=P.publisherId||null,u.identifier.uuid=P.id,u.isMachineScoped=!!P.isMachineScoped,u.isBuiltin=u.type===0||!!P.isBuiltin}async removeUninstalledExtensions(){const u=await this.getUninstalledExtensions(),P=await this.scanAllUserExtensions(),k=new Set;for(const z of P)u[new g.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]||k.add(z.identifier.id.toLowerCase());const W=(0,g.groupByExtension)(P,z=>z.identifier);await D.Promises.settled(W.map(async z=>{const H=z.sort((Y,B)=>L.rcompare(Y.manifest.version,B.manifest.version))[0];k.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(H)}));const Q=P.filter(z=>u[new g.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]);await D.Promises.settled(Q.map(z=>this.removeUninstalledExtension(z)))}async removeOutdatedExtensions(){const u=await this.scanAllUserExtensions(),P=[],k=(0,g.groupByExtension)(u,W=>W.identifier);P.push(...(0,T.flatten)(k.map(W=>W.sort((Q,z)=>L.rcompare(Q.manifest.version,z.manifest.version)).slice(1)))),await D.Promises.settled(P.map(W=>this.removeExtension(W,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(u=>u.name)}joinErrors(u){const P=Array.isArray(u)?u:[u];return P.length===1?P[0]instanceof Error?P[0]:new Error(P[0]):P.reduce((k,W)=>new Error(`${k.message}${k.message?",":""}${W instanceof Error?W.message:W}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=A.normalize(A.join(d.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(u){const P=[f.promises.readFile(A.join(u,"package.json"),"utf8").then(z=>this.parseManifest(z)),f.promises.readFile(A.join(u,"package.nls.json"),"utf8").then(void 0,z=>z.code!=="ENOENT"?Promise.reject(z):"{}").then(z=>JSON.parse(z))],[{manifest:k,metadata:W},Q]=await Promise.all(P);return{manifest:(0,w.localizeManifest)(k,Q),metadata:W}}parseManifest(u){return new Promise((P,k)=>{try{const W=JSON.parse(u),Q=W.__metadata||null;P({manifest:W,metadata:Q})}catch(W){k(new Error((0,a.localize)(4,null)))}})}async scanExtensionsInDirs(u,P,k){return(await Promise.all([u,...P].map(Q=>this.scanExtensionsInDir(Q,k)))).reduce((Q,z)=>Q.concat(z),[])}};F=ve([ge(1,l.IFileService),ge(2,C.ILogService),ge(3,v.INativeEnvironmentService),ge(4,c.IProductService)],F),e.ExtensionsScanner=F}),define(J[85],Z([0,1,16,119,4,19,2,23,47,29,30,21,13,5,44,7,31,3,14,149,37,42,51,15,24,146,6,8,27,195,154,196,155,156,20]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w,a,c,p,O,T,d,l,s,t,i,n,r,o,y,E,F,R,u,P,k,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const Q="unsetUninstalled",z="downloading",H="validating",Y="local",B="unknown";let x=class extends A.Disposable{constructor(S,I,N,M,$,V,G){super();this.environmentService=S,this.galleryService=I,this.logService=N,this.downloadService=M,this.telemetryService=$,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new w.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new w.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new w.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new w.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const K=this._register(V.createInstance(P.ExtensionsLifecycle));this.extensionsScanner=this._register(V.createInstance(u.ExtensionsScanner,se=>K.postUninstall(se))),this.manifestCache=this._register(new d.ExtensionsManifestCache(S,this)),this.extensionsDownloader=this._register(V.createInstance(R.ExtensionsDownloader));const te=this._register(new k.ExtensionsWatcher(this,G,S,N));this._register(te.onDidChangeExtensionsByAnotherSource(({added:se,removed:oe})=>{se.forEach(ce=>this._onDidInstallExtension.fire({identifier:ce.identifier,operation:0,local:ce})),oe.forEach(ce=>this._onDidUninstallExtension.fire({identifier:ce}))})),this._register((0,A.toDisposable)(()=>{this.installingExtensions.forEach(se=>se.cancel()),this.uninstallingExtensions.forEach(se=>se.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(S){this.logService.trace("ExtensionManagementService#zip",S.identifier.id);const I=await this.collectFiles(S),N=await(0,h.zip)((0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)()).fsPath,I);return c.URI.file(N)}async unzip(S){return this.logService.trace("ExtensionManagementService#unzip",S.toString()),(await this.install(S)).identifier}async getManifest(S){const I=await this.downloadVsix(S),N=b.resolve(I.fsPath);return(0,F.getManifest)(N)}async collectFiles(S){const I=async M=>{let $=await _.readdir(M);$=$.map(K=>b.join(M,K));const V=await Promise.all($.map(K=>f.promises.stat(K)));let G=Promise.resolve([]);return V.forEach((K,te)=>{const se=$[te];K.isFile()&&(G=G.then(oe=>[...oe,se])),K.isDirectory()&&(G=G.then(oe=>I(se).then(ce=>[...oe,...ce])))}),G};return(await I(S.location.fsPath)).map(M=>({path:`extension/${b.relative(S.location.fsPath,M)}`,localPath:M}))}async install(S,I={}){return this.logService.trace("ExtensionManagementService#install",S.toString()),(0,v.createCancelablePromise)(async N=>{const M=await this.downloadVsix(S),$=b.resolve(M.fsPath),V=await(0,F.getManifest)($),G={id:(0,D.getGalleryExtensionId)(V.publisher,V.name)};let K=1;if(V.engines&&V.engines.vscode&&!(0,t.isEngineValid)(V.engines.vscode,p.default.version))throw new Error(L.localize(0,null,G.id,p.default.version));const te=new D.ExtensionIdentifierWithVersion(G,V.version),oe=(await this.getInstalled(1)).find(ue=>(0,D.areSameExtensions)(G,ue.identifier));if(oe)if(I.isMachineScoped=I.isMachineScoped||oe.isMachineScoped,I.isBuiltin=I.isBuiltin||oe.isBuiltin,K=2,te.equals(new D.ExtensionIdentifierWithVersion(oe.identifier,oe.manifest.version)))try{await this.extensionsScanner.removeExtension(oe,"existing")}catch(ue){throw new Error(L.localize(1,null,V.displayName||V.name))}else a.gt(oe.manifest.version,V.version)&&await this.uninstallExtension(oe);else{const ue=await this.unsetUninstalledAndGetLocal(te);if(ue)try{await this.extensionsScanner.removeExtension(ue,"existing")}catch(Se){throw new Error(L.localize(2,null,V.displayName||V.name))}}this.logService.info("Installing the extension:",G.id),this._onInstallExtension.fire({identifier:G,zipPath:$});let ce;try{ce=await this.getGalleryMetadata((0,D.getGalleryExtensionId)(V.publisher,V.name))}catch(ue){}try{const ue=await this.installFromZipPath(te,$,Object.assign(Object.assign({},ce||{}),I),I,K,N);return this.logService.info("Successfully installed the extension:",G.id),ue}catch(ue){throw this.logService.error("Failed to install the extension:",G.id,ue.message),ue}})}async downloadVsix(S){if(S.scheme===y.Schemas.file)return S;if(!this.downloadService)throw new Error("Download service is not available");const I=(0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)());return await this.downloadService.download(S,I),I}async installFromZipPath(S,I,N,M,$,V){try{const G=await this.installExtension({zipPath:I,identifierWithVersion:S,metadata:N},V);try{await this.installDependenciesAndPackExtensions(G,void 0,M)}catch(K){(0,C.isNonEmptyArray)(G.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",G.identifier.id,K.message),(0,C.isNonEmptyArray)(G.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",G.identifier.id,K.message)}return this._onDidInstallExtension.fire({identifier:S,zipPath:I,local:G,operation:$}),G}catch(G){throw this._onDidInstallExtension.fire({identifier:S,zipPath:I,operation:$,error:G}),G}}async canInstall(S){return!0}async installFromGallery(S,I={}){if(!this.galleryService.isEnabled())throw new Error(L.localize(3,null));try{S=await this.checkAndGetCompatibleVersion(S)}catch($){const V=$&&$.code?$.code:B;throw this.logService.error("Failed to install extension:",S.identifier.id,$?$.message:V),this.reportTelemetry(this.getTelemetryEvent(1),(0,D.getGalleryExtensionTelemetryData)(S),void 0,$),$ instanceof Error&&($.name=V),$}const N=new D.ExtensionIdentifierWithVersion(S.identifier,S.version).key();let M=this.installingExtensions.get(N);return M||(M=(0,v.createCancelablePromise)($=>this.doInstallFromGallery(S,I,$)),this.installingExtensions.set(N,M),M.finally(()=>this.installingExtensions.delete(N))),M}async doInstallFromGallery(S,I,N){const M=new Date().getTime();let $=1;this.logService.info("Installing extension:",S.identifier.id),this._onInstallExtension.fire({identifier:S.identifier,gallery:S});try{const G=(await this.getInstalled(1)).find(se=>(0,D.areSameExtensions)(se.identifier,S.identifier));G&&($=2);const K=await this.downloadInstallableExtension(S,$);K.metadata.isMachineScoped=I.isMachineScoped||(G==null?void 0:G.isMachineScoped),K.metadata.isBuiltin=I.isBuiltin||(G==null?void 0:G.isBuiltin);const te=await this.installExtension(K,N);try{await this.extensionsDownloader.delete(c.URI.file(K.zipPath))}catch(se){}if(!I.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(te,G,I)}catch(se){try{await this.uninstall(te)}catch(oe){}throw se}return G&&a.neq(G.manifest.version,S.version)&&await this.extensionsScanner.setUninstalled(G),this.logService.info("Extensions installed successfully:",S.identifier.id),this._onDidInstallExtension.fire({identifier:S.identifier,gallery:S,local:te,operation:$}),this.reportTelemetry(this.getTelemetryEvent($),(0,D.getGalleryExtensionTelemetryData)(S),new Date().getTime()-M,void 0),te}catch(V){const G=V&&V.code?V.code:B;throw this.logService.error("Failed to install extension:",S.identifier.id,V?V.message:G),this._onDidInstallExtension.fire({identifier:S.identifier,gallery:S,operation:$,error:G}),this.reportTelemetry(this.getTelemetryEvent($),(0,D.getGalleryExtensionTelemetryData)(S),new Date().getTime()-M,V),V instanceof Error&&(V.name=G),V}}async checkAndGetCompatibleVersion(S){if(await this.isMalicious(S))throw new g.ExtensionManagementError(L.localize(4,null),g.INSTALL_ERROR_MALICIOUS);const I=await this.galleryService.getCompatibleExtension(S);if(!I)throw new g.ExtensionManagementError(L.localize(5,null,S.identifier.id,p.default.version),g.INSTALL_ERROR_INCOMPATIBLE);return I}async reinstallFromGallery(S){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",S.identifier.id),!this.galleryService.isEnabled())throw new Error(L.localize(6,null));const I=await this.findGalleryExtension(S);if(!I)throw new Error(L.localize(7,null));await this.extensionsScanner.setUninstalled(S);try{await this.extensionsScanner.removeUninstalledExtension(S)}catch(N){throw new Error(L.localize(8,null,(0,l.toErrorMessage)(N)))}await this.installFromGallery(I)}getTelemetryEvent(S){return S===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(S){const I=await this.getExtensionsReport();return(0,D.getMaliciousExtensionsSet)(I).has(S.identifier.id)}async downloadInstallableExtension(S,I){const N={id:S.identifier.uuid,publisherId:S.publisherId,publisherDisplayName:S.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",S.identifier.id),M=(await this.extensionsDownloader.downloadExtension(S,I)).fsPath,this.logService.info("Downloaded extension:",S.identifier.id,M)}catch($){throw new g.ExtensionManagementError(this.joinErrors($).message,z)}try{const $=await(0,F.getManifest)(M);return{zipPath:M,identifierWithVersion:new D.ExtensionIdentifierWithVersion(S.identifier,$.version),metadata:N}}catch($){throw new g.ExtensionManagementError(this.joinErrors($).message,H)}}async installExtension(S,I){try{const N=await this.unsetUninstalledAndGetLocal(S.identifierWithVersion);if(N)return S.metadata?this.extensionsScanner.saveMetadataForLocalExtension(N,S.metadata):N}catch(N){throw O.isMacintosh?new g.ExtensionManagementError(L.localize(9,null),Q):new g.ExtensionManagementError(L.localize(10,null),Q)}return this.extractAndInstall(S,I)}async unsetUninstalledAndGetLocal(S){if(!await this.isUninstalled(S))return null;this.logService.trace("Removing the extension from uninstalled list:",S.id);const N=await this.extensionsScanner.setInstalled(S);return this.logService.info("Removed the extension from uninstalled list:",S.id),N}async extractAndInstall({zipPath:S,identifierWithVersion:I,metadata:N},M){let $=await this.extensionsScanner.extractUserExtension(I,S,M);return this.logService.info("Installation completed.",I.id),N&&($=await this.extensionsScanner.saveMetadataForLocalExtension($,N)),$}async installDependenciesAndPackExtensions(S,I,N){if(!!this.galleryService.isEnabled()){const M=S.manifest.extensionDependencies||[];if(S.manifest.extensionPack)for(const $ of S.manifest.extensionPack)I&&I.manifest.extensionPack&&I.manifest.extensionPack.some(V=>(0,D.areSameExtensions)({id:V},{id:$}))||M.every(V=>!(0,D.areSameExtensions)({id:V},{id:$}))&&M.push($);if(M.length){const $=await this.getInstalled(),V=M.filter(G=>$.every(({identifier:K})=>!(0,D.areSameExtensions)(K,{id:G})));if(V.length){const K=(await this.galleryService.query({names:V,pageSize:M.length},E.CancellationToken.None)).firstPage;try{await v.Promises.settled(K.map(te=>this.installFromGallery(te,N)))}catch(te){try{await this.rollback(K)}catch(se){}throw te}}}}}async rollback(S){const N=(await this.getInstalled(1)).filter(M=>S.some($=>new D.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).equals(new D.ExtensionIdentifierWithVersion($.identifier,$.version))));await v.Promises.settled(N.map(M=>this.uninstall(M)))}async uninstall(S,I={}){this.logService.trace("ExtensionManagementService#uninstall",S.identifier.id);const N=await this.getInstalled(1),M=N.find($=>(0,D.areSameExtensions)($.identifier,S.identifier));if(!M)throw new Error(L.localize(11,null,S.manifest.displayName||S.manifest.name));try{await this.checkForDependenciesAndUninstall(M,N,I)}catch($){throw this.joinErrors($)}}async updateMetadata(S,I){return this.logService.trace("ExtensionManagementService#updateMetadata",S.identifier.id),S=await this.extensionsScanner.saveMetadataForLocalExtension(S,Object.assign(Object.assign({},S.manifest.__metadata||{}),I)),this.manifestCache.invalidate(),S}async updateExtensionScope(S,I){return this.logService.trace("ExtensionManagementService#updateExtensionScope",S.identifier.id),S=await this.extensionsScanner.saveMetadataForLocalExtension(S,Object.assign(Object.assign({},S.manifest.__metadata||{}),{isMachineScoped:I})),this.manifestCache.invalidate(),S}async getGalleryMetadata(S){const I=await this.findGalleryExtensionByName(S);return I?{id:I.identifier.uuid,publisherDisplayName:I.publisherDisplayName,publisherId:I.publisherId}:void 0}async findGalleryExtension(S){if(S.identifier.uuid){const I=await this.findGalleryExtensionById(S.identifier.uuid);return I||this.findGalleryExtensionByName(S.identifier.id)}return this.findGalleryExtensionByName(S.identifier.id)}async findGalleryExtensionById(S){return(await this.galleryService.query({ids:[S],pageSize:1},E.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(S){return(await this.galleryService.query({names:[S],pageSize:1},E.CancellationToken.None)).firstPage[0]}joinErrors(S){const I=Array.isArray(S)?S:[S];return I.length===1?I[0]instanceof Error?I[0]:new Error(I[0]):I.reduce((N,M)=>new Error(`${N.message}${N.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}async checkForDependenciesAndUninstall(S,I,N){try{await this.preUninstallExtension(S);const M=N.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(S,I);await this.uninstallExtensions(S,M,I,N)}catch(M){throw await this.postUninstallExtension(S,new g.ExtensionManagementError(M instanceof Error?M.message:M,Y)),M}await this.postUninstallExtension(S)}async uninstallExtensions(S,I,N,M){const $=[S,...I];if(!M.donotCheckDependents)for(const V of $)this.checkForDependents(V,$,N,S);await v.Promises.settled([this.uninstallExtension(S),...I.map(V=>this.doUninstall(V))])}checkForDependents(S,I,N,M){const $=this.getDependents(S,N);if($.length){const V=$.filter(G=>I.indexOf(G)===-1);if(V.length)throw new Error(this.getDependentsErrorMessage(S,V,M))}}getDependentsErrorMessage(S,I,N){return N===S?I.length===1?L.localize(12,null,N.manifest.displayName||N.manifest.name,I[0].manifest.displayName||I[0].manifest.name):I.length===2?L.localize(13,null,N.manifest.displayName||N.manifest.name,I[0].manifest.displayName||I[0].manifest.name,I[1].manifest.displayName||I[1].manifest.name):L.localize(14,null,N.manifest.displayName||N.manifest.name,I[0].manifest.displayName||I[0].manifest.name,I[1].manifest.displayName||I[1].manifest.name):I.length===1?L.localize(15,null,N.manifest.displayName||N.manifest.name,S.manifest.displayName||S.manifest.name,I[0].manifest.displayName||I[0].manifest.name):I.length===2?L.localize(16,null,N.manifest.displayName||N.manifest.name,S.manifest.displayName||S.manifest.name,I[0].manifest.displayName||I[0].manifest.name,I[1].manifest.displayName||I[1].manifest.name):L.localize(17,null,N.manifest.displayName||N.manifest.name,S.manifest.displayName||S.manifest.name,I[0].manifest.displayName||I[0].manifest.name,I[1].manifest.displayName||I[1].manifest.name)}getAllPackExtensionsToUninstall(S,I,N=[]){if(N.indexOf(S)!==-1)return[];N.push(S);const M=S.manifest.extensionPack?S.manifest.extensionPack:[];if(M.length){const $=I.filter(G=>!G.isBuiltin&&M.some(K=>(0,D.areSameExtensions)({id:K},G.identifier))),V=[];for(const G of $)V.push(...this.getAllPackExtensionsToUninstall(G,I,N));return[...$,...V]}return[]}getDependents(S,I){return I.filter(N=>N.manifest.extensionDependencies&&N.manifest.extensionDependencies.some(M=>(0,D.areSameExtensions)({id:M},S.identifier)))}async doUninstall(S){try{await this.preUninstallExtension(S),await this.uninstallExtension(S)}catch(I){throw await this.postUninstallExtension(S,new g.ExtensionManagementError(I instanceof Error?I.message:I,Y)),I}await this.postUninstallExtension(S)}async preUninstallExtension(S){if(!await _.exists(S.location.fsPath))throw new Error(L.localize(18,null));this.logService.info("Uninstalling extension:",S.identifier.id),this._onUninstallExtension.fire(S.identifier)}async uninstallExtension(S){let I=this.uninstallingExtensions.get(S.identifier.id);return I||(I=(0,v.createCancelablePromise)(async()=>{const N=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...N.filter(M=>(0,D.areSameExtensions)(M.identifier,S.identifier)))}),this.uninstallingExtensions.set(S.identifier.id,I),I.finally(()=>this.uninstallingExtensions.delete(S.identifier.id))),I}async postUninstallExtension(S,I){if(I)this.logService.error("Failed to uninstall extension:",S.identifier.id,I.message);else if(this.logService.info("Successfully uninstalled extension:",S.identifier.id),S.identifier.uuid)try{await this.galleryService.reportStatistic(S.manifest.publisher,S.manifest.name,S.manifest.version,"uninstall")}catch(M){}this.reportTelemetry("extensionGallery:uninstall",(0,D.getLocalExtensionTelemetryData)(S),void 0,I);const N=I?I instanceof g.ExtensionManagementError?I.code:B:void 0;this._onDidUninstallExtension.fire({identifier:S.identifier,error:N})}getInstalled(S=null){return this.extensionsScanner.scanExtensions(S)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(S){return(await this.filterUninstalled(S)).length===1}async filterUninstalled(...S){const I=[],N=await this.extensionsScanner.getUninstalledExtensions();for(const M of S)N[M.key()]&&I.push(M.key());return I}getExtensionsReport(){const S=new Date().getTime();return(!this.reportedExtensions||S-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=S),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const S=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${S.length} reported extensions from service`),S}catch(S){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(S,I,N,M){const $=M?M instanceof g.ExtensionManagementError?M.code:B:void 0;this.telemetryService.publicLogError(S,Object.assign(Object.assign({},I),{success:!M,duration:N,errorcode:$}))}};x=ve([ge(0,m.INativeEnvironmentService),ge(1,g.IExtensionGalleryService),ge(2,T.ILogService),ge(3,(0,o.optional)(r.IDownloadService)),ge(4,s.ITelemetryService),ge(5,o.IInstantiationService),ge(6,W.IFileService)],x),e.ExtensionManagementService=x}),define(J[197],Z([0,1,16,36,212,49,47,129,31]),function(q,e,f,L,b,_,A,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enableCustomMarketplace=e.buffer=e.extract=e.tar=void 0;const g=A.extract,D=A.buffer,m=async(T,d)=>{const l=b.pack(),s=[],t=new Promise(i=>{l.on("end",()=>i(Buffer.concat(s)))});l.on("data",i=>s.push(i));for(let i=0;i<d.length;i++){const n=d[i];l.entry({name:n.path},n.contents)}return l.finalize(),await _.promisify(f.writeFile)(T,await t),T};e.tar=m;const v=async(T,d,l={},s)=>{try{await p(T,d,l,s)}catch(t){t.toString().includes("Invalid tar header")&&await g(T,d,l,s)}};e.extract=v;const w=(T,d)=>new Promise(async(l,s)=>{try{let t=!1;if(await a(T,new RegExp(d),(i,n)=>{L.normalize(i)===L.normalize(d)&&(t=!0,l(n))}),!t)throw new Error("couldn't find asset "+d)}catch(t){t.toString().includes("Invalid tar header")?D(T,d).then(l).catch(s):s(t)}});e.buffer=w;const a=async(T,d,l)=>new Promise((s,t)=>{const i=b.extract(),n=r=>{i.destroy(),t(r)};i.once("error",n),i.on("entry",async(r,o,y)=>{const E=r.name;d.test(E)?c(o).then(F=>{l(E,F),y()}).catch(n):(o.on("end",()=>y()),o.resume())}),i.on("finish",s),f.createReadStream(T).pipe(i)}),c=T=>new Promise((d,l)=>{const s=[];T.on("error",l),T.on("end",()=>d(Buffer.concat(s))),T.on("data",t=>s.push(t))}),p=async(T,d,l={},s)=>new Promise((t,i)=>{const n=new RegExp(l.sourcePath?`^${l.sourcePath}`:""),r=b.extract(),o=y=>{r.destroy(),i(y)};r.once("error",o),r.on("entry",async(y,E,F)=>{const R=()=>{E.on("end",()=>F()),E.resume()},u=L.normalize(y.name);if(s.isCancellationRequested||!n.test(u))return R();const P=u.replace(n,""),k=L.join(d,P);if(/\/$/.test(P))return f.promises.mkdir(k,{recursive:!0}).then(R);const W=L.dirname(P),Q=L.join(d,W);if(Q.indexOf(d)!==0)return o(new Error(C.localize(0,null,P)));await f.promises.mkdir(Q,{recursive:!0});const z=f.createWriteStream(k,{mode:y.mode});z.once("close",()=>F()),z.once("error",o),E.pipe(z)}),r.once("finish",t),f.createReadStream(T).pipe(r)}),O=()=>{h.default.extensionsGallery=Object.assign({serviceUrl:process.env.SERVICE_URL||"https://extensions.coder.com/api",itemUrl:process.env.ITEM_URL||"",controlUrl:"",recommendationsUrl:""},h.default.extensionsGallery||{});const T=A;T.zip=e.tar,T.extract=e.extract,T.buffer=e.buffer};e.enableCustomMarketplace=O}),define(J[198],Z([0,1,157,213,199,5,34,4,25,24,2,17,66,11,3]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class c{constructor(E){this.socket=E,this._errorListener=F=>{if(F){if(F.code==="EPIPE")return;(0,w.onUnexpectedError)(F)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(E){const F=R=>E(m.VSBuffer.wrap(R));return this.socket.on("data",F),{dispose:()=>this.socket.off("data",F)}}onClose(E){return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(E){return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(E){if(!this.socket.destroyed)try{this.socket.write(E.buffer,F=>{if(F){if(F.code==="EPIPE")return;(0,w.onUnexpectedError)(F)}})}catch(F){if(F.code==="EPIPE")return;(0,w.onUnexpectedError)(F)}}end(){this.socket.end()}drain(){return new Promise((E,F)=>{if(this.socket.bufferSize===0){E();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),E()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=c;var p;(function(y){y[y.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var O;(function(y){y[y.PeekHeader=1]="PeekHeader",y[y.ReadHeader=2]="ReadHeader",y[y.ReadBody=3]="ReadBody",y[y.Fin=4]="Fin"})(O||(O={}));class T extends D.Disposable{constructor(E,F,R,u){super();this._onDidZlibFlush=this._register(new _.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new _.Emitter),this._onClose=this._register(new _.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=E,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=F,this._recordInflateBytes=u,F?(this._zlibInflate=b.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",P=>{console.error(P),(0,w.onUnexpectedError)(P),this._onClose.fire()}),this._zlibInflate.on("data",P=>{this._pendingInflateData.push(P)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=b.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",P=>{console.error(P),(0,w.onUnexpectedError)(P),this._onClose.fire()}),this._zlibDeflate.on("data",P=>{this._pendingDeflateData.push(P)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new v.ChunkStream,this._register(this.socket.onData(P=>this._acceptChunk(P))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?m.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):m.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this._onData.event(E)}onClose(E){return this._onClose.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){this._totalOutgoingDataBytes+=E.byteLength,this._zlibDeflate?(this._zlibDeflate.write(E.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let F=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,F=F.slice(0,F.length-4),this._isEnded||this._write(m.VSBuffer.wrap(F),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(E,!1)}_write(E,F){let R=2;E.byteLength<126?R+=0:E.byteLength<2**16?R+=2:R+=8;const u=m.VSBuffer.alloc(R);if(F?u.writeUInt8(194,0):u.writeUInt8(130,0),E.byteLength<126)u.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){u.writeUInt8(126,1);let P=1;u.writeUInt8(E.byteLength>>>8&255,++P),u.writeUInt8(E.byteLength>>>0&255,++P)}else{u.writeUInt8(127,1);let P=1;u.writeUInt8(0,++P),u.writeUInt8(0,++P),u.writeUInt8(0,++P),u.writeUInt8(0,++P),u.writeUInt8(E.byteLength>>>24&255,++P),u.writeUInt8(E.byteLength>>>16&255,++P),u.writeUInt8(E.byteLength>>>8&255,++P),u.writeUInt8(E.byteLength>>>0&255,++P)}this._totalOutgoingWireBytes+=u.byteLength+E.byteLength,this.socket.write(m.VSBuffer.concat([u,E]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(E){if(E.byteLength!==0){for(this._totalIncomingWireBytes+=E.byteLength,this._incomingData.acceptChunk(E);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const F=this._incomingData.peek(this._state.readLen),u=(F.readUInt8(0)&128)>>>7,P=F.readUInt8(1),k=(P&128)>>>7,W=P&127;this._state.state=2,this._state.readLen=2+(k?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=u,this._state.mask=0}else if(this._state.state===2){const F=this._incomingData.read(this._state.readLen),R=F.readUInt8(1),u=(R&128)>>>7;let P=R&127,k=1;P===126?P=F.readUInt8(++k)*2**8+F.readUInt8(++k):P===127&&(P=F.readUInt8(++k)*0+F.readUInt8(++k)*0+F.readUInt8(++k)*0+F.readUInt8(++k)*0+F.readUInt8(++k)*2**24+F.readUInt8(++k)*2**16+F.readUInt8(++k)*2**8+F.readUInt8(++k));let W=0;u&&(W=F.readUInt8(++k)*2**24+F.readUInt8(++k)*2**16+F.readUInt8(++k)*2**8+F.readUInt8(++k)),this._state.state=3,this._state.readLen=P,this._state.mask=W}else if(this._state.state===3){const F=this._incomingData.read(this._state.readLen);d(F,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(F.buffer)),this._zlibInflate.write(F.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(m.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=F.byteLength,this._onData.fire(F))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await _.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=T;function d(y,E){if(E!==0){let F=y.byteLength>>>2;for(let Q=0;Q<F;Q++){const z=y.readUInt32BE(Q*4);y.writeUInt32BE(z^E,Q*4)}let R=F*4,u=y.byteLength-R;const P=E>>>24&255,k=E>>>16&255,W=E>>>8&255;u>=1&&y.writeUInt8(y.readUInt8(R)^P,R),u>=2&&y.writeUInt8(y.readUInt8(R+1)^k,R+1),u>=3&&y.writeUInt8(y.readUInt8(R+2)^W,R+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function s(){const y=(0,g.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${y}-sock`;let E;return e.XDG_RUNTIME_DIR?E=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${y}.sock`):E=(0,C.join)((0,h.tmpdir)(),`vscode-ipc-${y}.sock`),i(E),E}e.createRandomIPCHandle=s;function t(y,E,F){const R=(0,f.createHash)("md5").update(y).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${F}-${E}-sock`;let u;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?u=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${F}-${E}.sock`):u=(0,C.join)(y,`${F}-${E}.sock`),i(u),u}e.createStaticIPCHandle=t;function i(y){const E=l[a.platform];typeof E=="number"&&y.length>=E&&console.warn(`WARNING: IPC handle "${y}" is longer than ${E} chars, try a shorter --user-data-dir`)}class n extends A.IPCServer{constructor(E){super(n.toClientConnectionEvent(E));this.server=E}static toClientConnectionEvent(E){const F=_.Event.fromNodeEventEmitter(E,"connection");return _.Event.map(F,R=>({protocol:new v.Protocol(new c(R)),onDidClientDisconnect:_.Event.once(_.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function r(y){return new Promise((E,F)=>{const R=(0,L.createServer)();R.on("error",F),R.listen(y,()=>{R.removeListener("error",F),E(new n(R))})})}e.serve=r;function o(y,E){return new Promise((F,R)=>{const u=(0,L.createConnection)(y,()=>{u.removeListener("error",R),F(v.Client.fromSocket(new c(u),E))});u.once("error",R)})}e.connect=o}),define(J[86],Z([0,1,199,167,2,12,11,166,32,14,17,21,151]),function(q,e,f,L,b,_,A,C,h,g,D,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let w=class extends b.Disposable{constructor(c,p,O){super();this.environmentService=p,this.logService=O,this.configure(c.getValue()),this._register(c.onDidChangeConfiguration(()=>this.configure(c.getValue()),this))}configure(c){this.proxyUrl=c.http&&c.http.proxy,this.strictSSL=!!(c.http&&c.http.proxyStrictSSL),this.authorization=c.http&&c.http.proxyAuthorization}async request(c,p){this.logService.trace("RequestService#request",c.url);const{proxyUrl:O,strictSSL:T}=this,d=Object.assign(Object.assign({},process.env),await(0,v.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),l=c.agent?c.agent:await(0,C.getProxyAgent)(c.url||"",d,{proxyUrl:O,strictSSL:T});return c.agent=l,c.strictSSL=T,this.authorization&&(c.headers=Object.assign(Object.assign({},c.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(c,p)}async getNodeRequest(c){return((0,L.parse)(c.url).protocol==="https:"?await new Promise((T,d)=>{q(["https"],T,d)}):await new Promise((T,d)=>{q(["http"],T,d)})).request}_request(c,p){return new Promise(async(O,T)=>{let d;const l=(0,L.parse)(c.url),s=c.getRawRequest?c.getRawRequest(c):await this.getNodeRequest(c),t={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,_.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(t.auth=c.user+":"+c.password),d=s(t,i=>{const n=(0,_.isNumber)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request(Object.assign(Object.assign({},c),{url:i.headers.location,followRedirects:n-1}),p).then(O,T);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,f.createGunzip)())),O({res:i,stream:(0,D.streamToBufferReadableStream)(r)})}}),d.on("error",T),c.timeout&&d.setTimeout(c.timeout),c.data&&typeof c.data=="string"&&d.write(c.data),d.end(),p.onCancellationRequested(()=>{d.abort(),T((0,A.canceled)())})})}async resolveProxy(c){}};w=ve([ge(0,h.IConfigurationService),ge(1,m.INativeEnvironmentService),ge(2,g.ILogService)],w),e.RequestService=w}),define(J[200],Z([0,1,25,16,214,4,13,31,53,52,70,21,68,29,85,77,42,46,78,76,57,86,32,75,79,169,170,14,8,55,175,74,20,56,2,45,148,7,71,54,11,37,17,26]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w,a,c,p,O,T,d,l,s,t,i,n,r,o,y,E,F,R,u,P,k,W,Q,z,H,Y,B,x,U,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class N extends W.Disposable{constructor(V){super();this.argv=V,(0,b.gracefulify)(L),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[V,G]=await this.initServices();return V.invokeFunction(async K=>{const te=K.get(y.ILogService),se=K.get(P.IFileService),oe=K.get(m.INativeEnvironmentService),ce=K.get(w.IExtensionManagementCLIService);return te.info("CLI main",this.argv),this.registerErrorHandler(te),await this.doRun(oe,ce,se),(0,A.raceTimeout)((0,O.combinedAppender)(...G).flush(),1e3)})}async initServices(){const V=new h.ServiceCollection,G=Object.assign({_serviceBrand:void 0},C.default);V.set(Q.IProductService,G);const K=new v.NativeEnvironmentService(this.argv,G);V.set(m.INativeEnvironmentService,K),await Promise.all([K.appSettingsHome.fsPath,K.extensionsPath].map(Ae=>Ae?L.promises.mkdir(Ae,{recursive:!0}):void 0));const te=(0,y.getLogLevel)(K),se=[];se.push(new F.SpdLogLogger("cli",(0,_.join)(K.logsPath,"cli.log"),!0,te)),te===y.LogLevel.Trace&&se.push(new y.ConsoleLogger(te));const oe=this._register(new y.MultiplexLogService(se));V.set(y.ILogService,oe);const ce=this._register(new u.FileService(oe));V.set(P.IFileService,ce);const ue=this._register(new k.DiskFileSystemProvider(oe));ce.registerProvider(E.Schemas.file,ue);const Se=this._register(new i.ConfigurationService(K.settingsResource,ce));V.set(t.IConfigurationService,Se),await Se.initialize();const _e=new o.StateService(K,oe);V.set(r.IStateService,_e),V.set(l.IRequestService,new g.SyncDescriptor(s.RequestService)),V.set(w.IExtensionManagementService,new g.SyncDescriptor(a.ExtensionManagementService)),V.set(w.IExtensionGalleryService,new g.SyncDescriptor(c.ExtensionGalleryService)),V.set(w.IExtensionManagementCLIService,new g.SyncDescriptor(z.ExtensionManagementCLIService)),V.set(B.ILocalizationsService,new g.SyncDescriptor(Y.LocalizationsService));const Oe=[];if(K.isBuilt&&!K.isExtensionDevelopment&&!K.disableTelemetry&&G.enableTelemetry){G.aiConfig&&G.aiConfig.asimovKey&&Oe.push(new n.AppInsightsAppender("monacoworkbench",null,G.aiConfig.asimovKey));const{appRoot:Ae,extensionsPath:Ne,installSourcePath:Ee}=K,Ce={appender:(0,O.combinedAppender)(...Oe),sendErrorTelemetry:!1,commonProperties:(0,d.resolveCommonProperties)(ce,(0,f.release)(),(0,f.hostname)(),process.arch,G.commit,G.version,_e.getItem("telemetry.machineId"),G.msftInternalDomains,Ee),piiPaths:[Ae,Ne]};V.set(p.ITelemetryService,new g.SyncDescriptor(T.TelemetryService,[Ce]))}else V.set(p.ITelemetryService,O.NullTelemetryService);return[new D.InstantiationService(V),Oe]}registerErrorHandler(V){(0,x.setUnexpectedErrorHandler)(G=>{const K=(0,U.toErrorMessage)(G,!0);!K||V.error(`[uncaught exception in CLI]: ${K}`)})}async doRun(V,G,K){if(this.argv["install-source"])return this.setInstallSource(V,K,this.argv["install-source"]);if(this.argv["list-extensions"])return G.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return G.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return G.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return G.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log((0,R.buildTelemetryMessage)(V.appRoot,V.extensionsPath))}asExtensionIdOrVSIX(V){return V.map(G=>/\.vsix$/i.test(G)?H.URI.file((0,_.isAbsolute)(G)?G:(0,_.join)((0,I.cwd)(),G)):G)}async setInstallSource(V,G,K){await G.writeFile(H.URI.file(V.installSourcePath),S.VSBuffer.fromString(K.slice(0,30)))}}async function M($){const V=new N($);try{await V.run()}finally{V.dispose()}}e.main=M}),define(J[201],Z([0,1,39,17,66,198]),function(q,e,f,L,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class A extends b.PersistentProtocol{constructor(h,g){super(g.skipWebSocketFrames?new _.NodeSocket(h):new _.WebSocketNodeSocket(new _.NodeSocket(h),g.permessageDeflate||!1,g.inflateBytes||null,g.permessageDeflate||!1));this.options=g,this.logger=f.logger.named("protocol",(0,f.field)("token",this.options.reconnectionToken))}getUnderlyingSocket(){const h=this.getSocket();return h instanceof _.NodeSocket?h.socket:h.socket.socket}handshake(){return this.logger.debug("Initiating handshake..."),new Promise((h,g)=>{const D=()=>{w.dispose(),m.dispose(),clearTimeout(v)},m=this.onSocketClose(()=>{D(),this.logger.debug("Handshake failed"),g(new Error("Protocol socket closed unexpectedly"))}),v=setTimeout(()=>{D(),this.logger.debug("Handshake timed out"),g(new Error("Protocol handshake timed out"))},1e4),w=this.onControlMessage(a=>{try{const c=a.toString();this.logger.trace("Got message",(0,f.field)("message",c));const p=JSON.parse(c);switch(p.type){case"auth":return this.authenticate(p);case"connectionType":return D(),this.logger.debug("Handshake completed"),h(p);default:throw new Error("Unrecognized message type")}}catch(c){D(),g(c)}});this.authenticate()})}authenticate(h){this.sendMessage({type:"sign",data:""})}tunnel(){throw new Error("Tunnel is not implemented yet")}sendMessage(h){this.sendControl(L.VSBuffer.fromString(JSON.stringify(h)))}destroy(h){try{h&&this.sendMessage({type:"error",reason:h}),this.sendDisconnect()}catch(g){this.logger.warn(g.message||g)}this.dispose(),this.getSocket().dispose()}get inflateBytes(){const h=this.getSocket();return h instanceof _.WebSocketNodeSocket?h.recordedInflateBytes.buffer:void 0}}e.Protocol=A}),define(J[202],Z([0,1,16,25,36,5,8,7,98,34,147,200,32,75,133,21,68,77,29,137,85,20,74,56,52,70,53,54,71,14,72,160,55,31,45,57,165,86,173,76,42,174,78,46,79,179,192,181,180,80,58,201,81,189,193,194,177]),function(q,e,f,L,b,_,A,C,h,g,D,m,v,w,a,c,p,O,T,d,l,s,t,i,n,r,o,y,E,F,R,u,P,k,W,Q,z,H,Y,B,x,U,S,I,N,M,$,V,G,K,te,se,oe,ce,ue,Se,_e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Vscode=void 0;const Oe=k.default.commit||"development";class Ae{constructor(){this._onDidClientConnect=new _.Emitter,this.onDidClientConnect=this._onDidClientConnect.event,this.ipc=new g.IPCServer(this.onDidClientConnect),this.maxExtraOfflineConnections=0,this.connections=new Map,this.services=new o.ServiceCollection}async cli(Ee){return(0,m.main)(Ee)}async initialize(Ee){const Ce=(0,oe.getUriTransformer)(Ee.remoteAuthority);this.servicesPromise||(this.servicesPromise=this.initializeServices(Ee.args)),await this.servicesPromise;const fe=this.services.get(c.IEnvironmentService),pe=Ee.startPath,De=je=>{try{return C.URI.parse(je,!0)}catch(Me){return C.URI.from({scheme:A.Schemas.vscodeRemote,authority:Ee.remoteAuthority,path:je})}};return{workbenchWebConfiguration:{workspaceUri:pe&&pe.workspace?De(pe.url):void 0,folderUri:pe&&!pe.workspace?De(pe.url):void 0,remoteAuthority:Ee.remoteAuthority,logLevel:(0,F.getLogLevel)(fe),workspaceProvider:{payload:[["userDataPath",fe.userDataPath],["enableProposedApi",JSON.stringify(Ee.args["enable-proposed-api"]||[])]]}},remoteUserDataUri:Ce.transformOutgoing(C.URI.file(fe.userDataPath)),productConfiguration:k.default,nlsConfiguration:await(0,te.getNlsConfiguration)(fe.args.locale||await(0,te.getLocaleFromConfig)(fe.userDataPath),fe.userDataPath),commit:Oe}}async handleWebSocket(Ee,Ce,fe){if(!Ce.reconnectionToken)throw new Error("Reconnection token is missing from query parameters");const pe=new se.Protocol(Ee,{reconnectionToken:Ce.reconnectionToken,reconnection:Ce.reconnection==="true",skipWebSocketFrames:Ce.skipWebSocketFrames==="true",permessageDeflate:fe});try{await this.connect(await pe.handshake(),pe)}catch(De){pe.destroy(De.message)}return!0}async connect(Ee,Ce){switch(k.default.commit&&Ee.commit!==k.default.commit&&K.logger.warn(`Version mismatch (${Ee.commit} instead of ${k.default.commit})`),Ee.desiredConnectionType){case 2:case 1:this.connections.has(Ee.desiredConnectionType)||this.connections.set(Ee.desiredConnectionType,new Map);const fe=this.connections.get(Ee.desiredConnectionType),pe=Ce.options.reconnectionToken;let De=fe.get(pe);if(Ce.options.reconnection&&De)return De.reconnect(Ce);if(Ce.options.reconnection)throw new Error(`Unable to reconnect; session no longer exists (${pe})`);if(De)throw new Error("Unable to connect; token is already in use");Ee.desiredConnectionType===1?(De=new V.ManagementConnection(Ce),this._onDidClientConnect.fire({protocol:Ce,onDidClientDisconnect:De.onClose})):De=new V.ExtensionHostConnection(Ce,Object.assign({language:"en"},Ee.args),this.services.get(c.IEnvironmentService)),fe.set(pe,De),De.onClose(()=>fe.delete(pe)),this.disposeOldOfflineConnections(fe),K.logger.debug(`${fe.size} active ${De.name} connection(s)`);break;case 3:return Ce.tunnel();default:throw new Error(`Unrecognized connection type ${Ee.desiredConnectionType}`)}}disposeOldOfflineConnections(Ee){const Ce=Array.from(Ee.values()).filter(fe=>typeof fe.offline!="undefined");for(let fe=0,pe=Ce.length-this.maxExtraOfflineConnections;fe<pe;++fe)Ce[fe].dispose("old")}async initializeServices(Ee){const Ce=Object.assign({_serviceBrand:void 0},k.default),fe=new p.NativeEnvironmentService(Ee,Ce);await Promise.all([fe.extensionsPath,fe.logsPath,fe.globalStorageHome.fsPath,fe.workspaceStorageHome.fsPath,...fe.extraExtensionPaths,...fe.extraBuiltinExtensionPaths].map(ie=>f.promises.mkdir(ie,{recursive:!0}).catch(ne=>{K.logger.warn(ne.message||ne)})));const pe=new F.MultiplexLogService([new F.ConsoleLogger((0,F.getLogLevel)(fe)),new P.SpdLogLogger(Se.RemoteExtensionLogFileName,b.join(fe.logsPath,`${Se.RemoteExtensionLogFileName}.log`),!1,(0,F.getLogLevel)(fe))]),De=new t.FileService(pe);De.registerProvider(A.Schemas.file,new i.DiskFileSystemProvider(pe));const je=new u.LoggerService(pe,De),Me=[b.join(fe.userDataPath,"clp"),fe.appRoot,fe.extensionsPath,fe.builtinExtensionsPath,...fe.extraExtensionPaths,...fe.extraBuiltinExtensionPaths];this.ipc.registerChannel("logger",new R.LogLevelChannel(pe)),this.ipc.registerChannel(a.ExtensionHostDebugBroadcastChannel.ChannelName,new a.ExtensionHostDebugBroadcastChannel),this.services.set(F.ILogService,pe),this.services.set(c.IEnvironmentService,fe),this.services.set(c.INativeEnvironmentService,fe),this.services.set(F.ILoggerService,je);const Ue=new w.ConfigurationService(fe.settingsResource,De);await Ue.initialize(),this.services.set(v.IConfigurationService,Ue),this.services.set(Q.IRequestService,new n.SyncDescriptor(H.RequestService)),this.services.set(s.IFileService,De),this.services.set(W.IProductService,Ce);const X=await(0,h.getMachineId)();await new Promise(ie=>{const ne=new r.InstantiationService(this.services);ne.invokeFunction(de=>{ne.createInstance(D.LogsDataCleaner);let j;fe.disableTelemetry?j=I.NullTelemetryService:j=new S.TelemetryService({appender:(0,I.combinedAppender)(new N.AppInsightsAppender("code-server",null,()=>new G.TelemetryClient),new U.TelemetryLogAppender(de.get(F.ILoggerService),fe)),sendErrorTelemetry:!0,commonProperties:(0,B.resolveCommonProperties)(De,(0,L.release)(),(0,L.hostname)(),process.arch,Oe,k.default.version,X,void 0,fe.installSourcePath,"code-server"),piiPaths:Me},Ue),this.services.set(x.ITelemetryService,j),this.services.set(T.IExtensionManagementService,new n.SyncDescriptor(l.ExtensionManagementService)),this.services.set(T.IExtensionGalleryService,new n.SyncDescriptor(O.ExtensionGalleryService)),this.services.set(y.ILocalizationsService,new n.SyncDescriptor(E.LocalizationsService)),this.ipc.registerChannel("extensions",new d.ExtensionManagementChannel(de.get(T.IExtensionManagementService),re=>(0,oe.getUriTransformer)(re.remoteAuthority))),this.ipc.registerChannel("remoteextensionsenvironment",new $.ExtensionEnvironmentChannel(fe,pe,j,"")),this.ipc.registerChannel("request",new z.RequestChannel(de.get(Q.IRequestService))),this.ipc.registerChannel("telemetry",new M.TelemetryChannel(j)),this.ipc.registerChannel("localizations",g.ProxyChannel.fromService(de.get(y.ILocalizationsService))),this.ipc.registerChannel(ue.REMOTE_FILE_SYSTEM_CHANNEL_NAME,new $.FileProviderChannel(fe,pe));const ee=new _e.PtyHostService(pe,j);this.ipc.registerChannel(ce.REMOTE_TERMINAL_CHANNEL_NAME,new $.TerminalProviderChannel(pe,ee)),ie(new Y.default(j))})})}}e.Vscode=Ae}),define(J[215],Z([0,1,39,11,101,80,197,202]),function(q,e,f,L,b,_,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,L.setUnexpectedErrorHandler)(m=>{_.logger.warn("Uncaught error",(0,f.field)("error",m instanceof Error?m.message:m))}),(0,A.enableCustomMarketplace)(),b.monkeyPatch(!0);const h=process.exit;if(process.exit=function(m){_.logger.warn(`process.exit() was prevented: ${m||"unknown code"}.`)},typeof process.env.CODE_SERVER_PARENT_PID!="undefined"){const m=parseInt(process.env.CODE_SERVER_PARENT_PID,10);setInterval(()=>{try{process.kill(m,0)}catch(v){h()}},5e3)}else _.logger.error("no parent process"),h(1);const g=new C.Vscode,D=m=>{if(!process.send)throw new Error("not spawned with IPC");process.send(m)};process.on("message",async(m,v)=>{switch(_.logger.debug("got message from code-server",(0,f.field)("type",m.type)),_.logger.trace("code-server message content",(0,f.field)("message",m)),m.type){case"init":try{const w=await g.initialize(m.options);D({type:"options",id:m.id,options:w})}catch(w){_.logger.error(w.message),_.logger.error(w.stack),h(1)}break;case"cli":try{await g.cli(m.args),h(0)}catch(w){_.logger.error(w.message),_.logger.error(w.stack),h(1)}break;case"socket":g.handleWebSocket(v,m.query,m.permessageDeflate);break}}),process.send?D({type:"ready"}):(_.logger.error("not spawned with IPC"),h(1))})}).call(this);

//# sourceMappingURL=entry.js.map
