/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/platform","vs/base/common/types","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/node/pfs","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/extpath","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","os","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/base/node/proxy_agent","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","@coder/logger","proxy-agent","proxy-from-env","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(G){for(var e=[],_=0,I=G.length;_<I;_++)e[_]=ge[G[_]];return e};define(ge[52],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(I,A){if(!I)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=_}),define(ge[53],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const _=Object.prototype.hasOwnProperty;function I(C){const f=[];for(let p in C)_.call(C,p)&&f.push(C[p]);return f}e.values=I;function A(C,f){for(let p in C)if(_.call(C,p)&&f({key:p,value:C[p]},function(){delete C[p]})===!1)return}e.forEach=A;function T(C,f){const p=Object.create(null);for(const a of C){const u=f(a);let E=p[u];E||(E=p[u]=[]),E.push(a)}return p}e.groupBy=T;function y(C,f){const p=new Map;for(const a of C){const u=f(a);let E=p.get(u);E||(E=[],p.set(u,E)),E.push(a)}return p}e.groupByNumber=y;function P(C){const f=Object.create(null);return C&&C.forEach((p,a)=>{f[a]=p}),f}e.fromMap=P;function D(C,f){const p=[],a=[];for(let u of C)f.has(u)||p.push(u);for(let u of f)C.has(u)||a.push(u);return{removed:p,added:a}}e.diffSets=D;function k(C,f){const p=[],a=[];for(let[u,E]of C)f.has(u)||p.push(E);for(let[u,E]of f)C.has(u)||a.push(E);return{removed:p,added:a}}e.diffMaps=k;class r{constructor(){this.map=new Map}add(f,p){let a=this.map.get(f);a||(a=new Set,this.map.set(f,a)),a.add(p)}delete(f,p){const a=this.map.get(f);!a||(a.delete(p),a.size===0&&this.map.delete(f))}forEach(f,p){const a=this.map.get(f);!a||a.forEach(p)}}e.SetMap=r}),define(ge[70],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function _(D){return(k,r,C)=>{let f=null,p=null;if(typeof C.value=="function"?(f="value",p=C.value):typeof C.get=="function"&&(f="get",p=C.get),!p)throw new Error("not supported");C[f]=D(p,r)}}e.createDecorator=_;let I=0;function A(){const D=`$memoize${I++}`;let k;const r=function(f,p,a){let u=null,E=null;if(typeof a.value=="function"?(u="value",E=a.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(u="get",E=a.get),!E)throw new Error("not supported");const w=`${D}:${p}`;a[u]=function(...S){return k=this,this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!0,enumerable:!1,writable:!0,value:E.apply(this,S)}),this[w]}};return r.clear=()=>{typeof k!="undefined"&&Object.getOwnPropertyNames(k).forEach(C=>{C.indexOf(D)===0&&delete k[C]})},r}e.createMemoizer=A;function T(D,k,r){return A()(D,k,r)}e.memoize=T;function y(D,k,r){return _((C,f)=>{const p=`$debounce$${f}`,a=`$debounce$result$${f}`;return function(...u){this[a]||(this[a]=r?r():void 0),clearTimeout(this[p]),k&&(this[a]=k(this[a],...u),u=[this[a]]),this[p]=setTimeout(()=>{C.apply(this,u),this[a]=r?r():void 0},D)}})}e.debounce=y;function P(D,k,r){return _((C,f)=>{const p=`$throttle$timer$${f}`,a=`$throttle$result$${f}`,u=`$throttle$lastRun$${f}`,E=`$throttle$pending$${f}`;return function(...w){if(this[a]||(this[a]=r?r():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),k&&(this[a]=k(this[a],...w)),!this[E]){const S=this[u]+D;S<=Date.now()?(this[u]=Date.now(),C.apply(this,[this[a]]),this[a]=r?r():void 0):(this[E]=!0,this[p]=setTimeout(()=>{this[E]=!1,this[u]=Date.now(),C.apply(this,[this[a]]),this[a]=r?r():void 0},S-Date.now()))}}})}e.throttle=P}),define(ge[16],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=_,e.errorHandler=new _;function I(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=I;function A(m){D(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=A;function T(m){D(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=T;function y(m){if(m instanceof Error){let{name:t,message:n}=m;const o=m.stacktrace||m.stack;return{$isError:!0,name:t,message:n,stack:o}}return m}e.transformErrorForSerialization=y;const P="Canceled";function D(m){return m instanceof Error&&m.name===P&&m.message===P}e.isPromiseCanceledError=D;class k extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=k;function r(){const m=new Error(P);return m.name=m.message,m}e.canceled=r;function C(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=C;function f(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=f;function p(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function a(m){const t=new Error(`${m} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function u(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=u;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function h(m){const t=m;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=h;function c(m,t=Object.create(null)){const n=new Error(m);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=c}),define(ge[17],pe([0,1,16]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I(U,F=0){return U[U.length-(1+F)]}e.tail=I;function A(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=A;function T(U,F,M=(L,O)=>L===O){if(U===F)return!0;if(!U||!F||U.length!==F.length)return!1;for(let L=0,O=U.length;L<O;L++)if(!M(U[L],F[L]))return!1;return!0}e.equals=T;function y(U,F,M){let L=0,O=U.length-1;for(;L<=O;){const B=(L+O)/2|0,j=M(U[B],F);if(j<0)L=B+1;else if(j>0)O=B-1;else return B}return-(L+1)}e.binarySearch=y;function P(U,F){let M=0,L=U.length;if(L===0)return 0;for(;M<L;){const O=Math.floor((M+L)/2);F(U[O])?L=O:M=O+1}return M}e.findFirstInSorted=P;function D(U,F,M){if(U=U|0,U>=F.length)throw new TypeError("invalid index");let L=F[Math.floor(F.length*Math.random())],O=[],B=[],j=[];for(let Q of F){const de=M(Q,L);de<0?O.push(Q):de>0?B.push(Q):j.push(Q)}return U<O.length?D(U,O,M):U<O.length+j.length?j[0]:D(U-(O.length+j.length),B,M)}e.quickSelect=D;function k(U,F){const M=[];let L;for(const O of U.slice(0).sort(F))!L||F(L[0],O)!==0?(L=[O],M.push(L)):L.push(O);return M}e.groupBy=k;function r(U,F,M){const L=[];function O(Q,de,be){if(!(de===0&&be.length===0)){const Ae=L[L.length-1];Ae&&Ae.start+Ae.deleteCount===Q?(Ae.deleteCount+=de,Ae.toInsert.push(...be)):L.push({start:Q,deleteCount:de,toInsert:be})}}let B=0,j=0;for(;;){if(B===U.length){O(B,0,F.slice(j));break}if(j===F.length){O(B,U.length-B,[]);break}const Q=U[B],de=F[j],be=M(Q,de);be===0?(B+=1,j+=1):be<0?(O(B,1,[]),B+=1):be>0&&(O(B,0,[de]),j+=1)}return L}e.sortedDiff=r;function C(U,F,M){const L=r(U,F,M),O=[],B=[];for(const j of L)O.push(...U.slice(j.start,j.start+j.deleteCount)),B.push(...j.toInsert);return{removed:O,added:B}}e.delta=C;function f(U,F,M){if(M===0)return[];const L=U.slice(0,M).sort(F);return a(U,F,L,M,U.length),L}e.top=f;function p(U,F,M,L,O){return M===0?Promise.resolve([]):new Promise((B,j)=>{(async()=>{const Q=U.length,de=U.slice(0,M).sort(F);for(let be=M,Ae=Math.min(M+L,Q);be<Q;be=Ae,Ae=Math.min(Ae+L,Q)){if(be>M&&await new Promise(Ce=>setTimeout(Ce)),O&&O.isCancellationRequested)throw(0,_.canceled)();a(U,F,de,be,Ae)}return de})().then(B,j)})}e.topAsync=p;function a(U,F,M,L,O){for(const B=M.length;L<O;L++){const j=U[L];if(F(j,M[B-1])<0){M.pop();const Q=P(M,de=>F(j,de)<0);M.splice(Q,0,j)}}}function u(U){return U.filter(F=>!!F)}e.coalesce=u;function E(U){let F=0;for(let M=0;M<U.length;M++)U[M]&&(U[F]=U[M],F+=1);U.length=F}e.coalesceInPlace=E;function w(U,F,M){U.splice(M,0,U.splice(F,1)[0])}e.move=w;function S(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=S;function h(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=h;function c(U,F){if(!F)return U.filter((L,O)=>U.indexOf(L)===O);const M=Object.create(null);return U.filter(L=>{const O=F(L);return M[O]?!1:(M[O]=!0,!0)})}e.distinct=c;function m(U){const F=new Set;return U.filter(M=>F.has(M)?!1:(F.add(M),!0))}e.distinctES6=m;function t(U){const F=Object.create(null);return M=>{const L=U(M);return F[L]?!1:(F[L]=!0,!0)}}e.uniqueFilter=t;function n(U,F){for(let M=U.length-1;M>=0;M--){const L=U[M];if(F(L))return M}return-1}e.lastIndex=n;function o(U,F){return U.length>0?U[0]:F}e.firstOrDefault=o;function i(U,F,M=(L,O)=>L===O){let L=0;for(let O=0,B=Math.min(U.length,F.length);O<B&&M(U[O],F[O]);O++)L++;return L}e.commonPrefixLength=i;function s(U){return[].concat(...U)}e.flatten=s;function l(U,F){let M=typeof F=="number"?U:0;typeof F=="number"?M=U:(M=0,F=U);const L=[];if(M<=F)for(let O=M;O<F;O++)L.push(O);else for(let O=M;O>F;O--)L.push(O);return L}e.range=l;function g(U,F,M){return U.reduce((L,O)=>(L[F(O)]=M?M(O):O,L),Object.create(null))}e.index=g;function v(U,F){return U.push(F),()=>d(U,F)}e.insert=v;function d(U,F){const M=U.indexOf(F);if(M>-1)return U.splice(M,1),F}e.remove=d;function b(U,F,M){const L=U.slice(0,F),O=U.slice(F);return L.concat(M,O)}e.arrayInsert=b;function R(U,F){let M;if(typeof F=="number"){let L=F;M=()=>{const O=Math.sin(L++)*179426549;return O-Math.floor(O)}}else M=Math.random;for(let L=U.length-1;L>0;L-=1){const O=Math.floor(M()*(L+1)),B=U[L];U[L]=U[O],U[O]=B}}e.shuffle=R;function N(U,F){const M=U.indexOf(F);M>-1&&(U.splice(M,1),U.unshift(F))}e.pushToStart=N;function q(U,F){const M=U.indexOf(F);M>-1&&(U.splice(M,1),U.push(F))}e.pushToEnd=q;function re(U,F){return Array.isArray(U)?U.map(F):F(U)}e.mapArrayOrNot=re;function V(U){return Array.isArray(U)?U:[U]}e.asArray=V;function W(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=W;function $(U,F){for(const M of U){const L=F(M);if(L!==void 0)return L}}e.mapFind=$}),define(ge[71],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(I){const A=this;let T=!1,y;return function(){return T||(T=!0,y=I.apply(A,arguments)),y}}e.once=_}),define(ge[72],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(A){this._prefix=A,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(ge[54],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(I){function A(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}I.is=A;const T=Object.freeze([]);function y(){return T}I.empty=y;function*P(m){yield m}I.single=P;function D(m){return m||T}I.from=D;function k(m){return!m||m[Symbol.iterator]().next().done===!0}I.isEmpty=k;function r(m){return m[Symbol.iterator]().next().value}I.first=r;function C(m,t){for(const n of m)if(t(n))return!0;return!1}I.some=C;function f(m,t){for(const n of m)if(t(n))return n}I.find=f;function*p(m,t){for(const n of m)t(n)&&(yield n)}I.filter=p;function*a(m,t){for(const n of m)yield t(n)}I.map=a;function*u(...m){for(const t of m)for(const n of t)yield n}I.concat=u;function*E(m){for(const t of m)for(const n of t)yield n}I.concatNested=E;function w(m,t,n){let o=n;for(const i of m)o=t(o,i);return o}I.reduce=w;function*S(m,t,n=m.length){for(t<0&&(t+=m.length),n<0?n+=m.length:n>m.length&&(n=m.length);t<n;t++)yield m[t]}I.slice=S;function h(m,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,m];const o=m[Symbol.iterator]();for(let i=0;i<t;i++){const s=o.next();if(s.done)return[n,I.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return o}}]}I.consume=h;function c(m,t,n=(o,i)=>o===i){const o=m[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const s=o.next(),l=i.next();if(s.done!==l.done)return!1;if(s.done)return!0;if(!n(s.value,l.value))return!1}}I.equals=c})(_=e.Iterable||(e.Iterable={}))}),define(ge[55],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let o=0,i=t.length,s="",l=0,g=16,v=0;function d(W){let $=0,U=0;for(;$<W;){const F=t.charCodeAt(o);if(F>=48&&F<=57)U=U*16+F-48;else if(F>=65&&F<=70)U=U*16+F-65+10;else if(F>=97&&F<=102)U=U*16+F-97+10;else break;o++,$++}return $<W&&(U=-1),U}function b(W){o=W,s="",l=0,g=16,v=0}function R(){const W=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&k(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&k(t.charCodeAt(o)))for(o++;o<t.length&&k(t.charCodeAt(o));)o++;else return v=3,t.substring(W,o);let $=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&k(t.charCodeAt(o))){for(o++;o<t.length&&k(t.charCodeAt(o));)o++;$=o}else v=3;return t.substring(W,$)}function N(){let W="",$=o;for(;;){if(o>=i){W+=t.substring($,o),v=2;break}const U=t.charCodeAt(o);if(U===34){W+=t.substring($,o),o++;break}if(U===92){if(W+=t.substring($,o),o++,o>=i){v=2;break}switch(t.charCodeAt(o++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const M=d(4);M>=0?W+=String.fromCharCode(M):v=4;break;default:v=5}$=o;continue}if(U>=0&&U<=31)if(D(U)){W+=t.substring($,o),v=2;break}else v=6;o++}return W}function q(){if(s="",v=0,l=o,o>=i)return l=i,g=17;let W=t.charCodeAt(o);if(P(W)){do o++,s+=String.fromCharCode(W),W=t.charCodeAt(o);while(P(W));return g=15}if(D(W))return o++,s+=String.fromCharCode(W),W===13&&t.charCodeAt(o)===10&&(o++,s+=`
`),g=14;switch(W){case 123:return o++,g=1;case 125:return o++,g=2;case 91:return o++,g=3;case 93:return o++,g=4;case 58:return o++,g=6;case 44:return o++,g=5;case 34:return o++,s=N(),g=10;case 47:const $=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<i&&!D(t.charCodeAt(o));)o++;return s=t.substring($,o),g=12}if(t.charCodeAt(o+1)===42){o+=2;const U=i-1;let F=!1;for(;o<U;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,F=!0;break}o++}return F||(o++,v=1),s=t.substring($,o),g=13}return s+=String.fromCharCode(W),o++,g=16;case 45:if(s+=String.fromCharCode(W),o++,o===i||!k(t.charCodeAt(o)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=R(),g=11;default:for(;o<i&&re(W);)o++,W=t.charCodeAt(o);if(l!==o){switch(s=t.substring(l,o),s){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return s+=String.fromCharCode(W),o++,g=16}}function re(W){if(P(W)||D(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let W;do W=q();while(W>=12&&W<=15);return W}return{setPosition:b,getPosition:()=>o,scan:n?V:q,getToken:()=>g,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>o-l,getTokenError:()=>v}}e.createScanner=y;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var r;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(r||(r={}));function C(t,n){const o=[],i=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function v(d,b,R,N){l.value=d,l.offset=b,l.length=R,l.type=N,l.colonOffset=void 0,s=l}try{h(t,{onObjectBegin:(d,b)=>{if(n<=d)throw i;s=void 0,g=n>d,o.push("")},onObjectProperty:(d,b,R)=>{if(n<b||(v(d,b,R,"property"),o[o.length-1]=d,n<=b+R))throw i},onObjectEnd:(d,b)=>{if(n<=d)throw i;s=void 0,o.pop()},onArrayBegin:(d,b)=>{if(n<=d)throw i;s=void 0,o.push(0)},onArrayEnd:(d,b)=>{if(n<=d)throw i;s=void 0,o.pop()},onLiteralValue:(d,b,R)=>{if(n<b||(v(d,b,R,m(d)),n<=b+R))throw i},onSeparator:(d,b,R)=>{if(n<=b)throw i;if(d===":"&&s&&s.type==="property")s.colonOffset=b,g=!1,s=void 0;else if(d===","){const N=o[o.length-1];typeof N=="number"?o[o.length-1]=N+1:(g=!0,o[o.length-1]=""),s=void 0}}})}catch(d){if(d!==i)throw d}return{path:o,previousNode:s,isAtPropertyKey:g,matches:d=>{let b=0;for(let R=0;b<d.length&&R<o.length;R++)if(d[b]===o[R]||d[b]==="*")b++;else if(d[b]!=="**")return!1;return b===d.length}}}e.getLocation=C;function f(t,n=[],o=T.DEFAULT){let i=null,s=[];const l=[];function g(d){Array.isArray(s)?s.push(d):i!==null&&(s[i]=d)}return h(t,{onObjectBegin:()=>{const d={};g(d),l.push(s),s=d,i=null},onObjectProperty:d=>{i=d},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const d=[];g(d),l.push(s),s=d,i=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:g,onError:(d,b,R)=>{n.push({error:d,offset:b,length:R})}},o),s[0]}e.parse=f;function p(t,n=[],o=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(d){i.type==="property"&&(i.length=d-i.offset,i=i.parent)}function l(d){return i.children.push(d),d}h(t,{onObjectBegin:d=>{i=l({type:"object",offset:d,length:-1,parent:i,children:[]})},onObjectProperty:(d,b,R)=>{i=l({type:"property",offset:b,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:d,offset:b,length:R,parent:i})},onObjectEnd:(d,b)=>{i.length=d+b-i.offset,i=i.parent,s(d+b)},onArrayBegin:(d,b)=>{i=l({type:"array",offset:d,length:-1,parent:i,children:[]})},onArrayEnd:(d,b)=>{i.length=d+b-i.offset,i=i.parent,s(d+b)},onLiteralValue:(d,b,R)=>{l({type:m(d),offset:b,length:R,parent:i,value:d}),s(b+R)},onSeparator:(d,b,R)=>{i.type==="property"&&(d===":"?i.colonOffset=b:d===","&&s(b))},onError:(d,b,R)=>{n.push({error:d,offset:b,length:R})}},o);const v=i.children[0];return v&&delete v.parent,v}e.parseTree=p;function a(t,n){if(!!t){let o=t;for(let i of n)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let s=!1;for(const l of o.children)if(Array.isArray(l.children)&&l.children[0].value===i){o=l.children[1],s=!0;break}if(!s)return}else{const s=i;if(o.type!=="array"||s<0||!Array.isArray(o.children)||s>=o.children.length)return;o=o.children[s]}return o}}e.findNodeAtLocation=a;function u(t){if(!t.parent||!t.parent.children)return[];const n=u(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;n.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&n.push(o)}return n}e.getNodePath=u;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const n=Object.create(null);for(let o of t.children){const i=o.children[1];i&&(n[o.children[0].value]=E(i))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function w(t,n,o=!1){return n>=t.offset&&n<t.offset+t.length||o&&n===t.offset+t.length}e.contains=w;function S(t,n,o=!1){if(w(t,n,o)){const i=t.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=n;s++){const l=S(i[s],n,o);if(l)return l}return t}}e.findNodeAtOffset=S;function h(t,n,o=T.DEFAULT){const i=y(t,!1);function s(de){return de?()=>de(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(de){return de?be=>de(be,i.getTokenOffset(),i.getTokenLength()):()=>!0}const g=s(n.onObjectBegin),v=l(n.onObjectProperty),d=s(n.onObjectEnd),b=s(n.onArrayBegin),R=s(n.onArrayEnd),N=l(n.onLiteralValue),q=l(n.onSeparator),re=s(n.onComment),V=l(n.onError),W=o&&o.disallowComments,$=o&&o.allowTrailingComma;function U(){for(;;){const de=i.scan();switch(i.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:W||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(de){case 12:case 13:W?F(10):re();break;case 16:F(1);break;case 15:case 14:break;default:return de}}}function F(de,be=[],Ae=[]){if(V(de),be.length+Ae.length>0){let Ce=i.getToken();for(;Ce!==17;){if(be.indexOf(Ce)!==-1){U();break}else if(Ae.indexOf(Ce)!==-1)break;Ce=U()}}}function M(de){const be=i.getTokenValue();return de?N(be):v(be),U(),!0}function L(){switch(i.getToken()){case 11:let de=0;try{de=JSON.parse(i.getTokenValue()),typeof de!="number"&&(F(2),de=0)}catch(be){F(2)}N(de);break;case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return U(),!0}function O(){return i.getToken()!==10?(F(3,[],[2,5]),!1):(M(!1),i.getToken()===6?(q(":"),U(),Q()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function B(){g(),U();let de=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(de||F(4,[],[]),q(","),U(),i.getToken()===2&&$)break}else de&&F(6,[],[]);O()||F(4,[],[2,5]),de=!0}return d(),i.getToken()!==2?F(7,[2],[]):U(),!0}function j(){b(),U();let de=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(de||F(4,[],[]),q(","),U(),i.getToken()===4&&$)break}else de&&F(6,[],[]);Q()||F(4,[],[4,5]),de=!0}return R(),i.getToken()!==4?F(8,[4],[]):U(),!0}function Q(){switch(i.getToken()){case 3:return j();case 1:return B();case 10:return M(!0);default:return L()}}return U(),i.getToken()===17?o.allowEmptyContent?!0:(F(4,[],[]),!1):Q()?(i.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=h;function c(t,n){let o=y(t),i=[],s,l=0,g;do switch(g=o.getPosition(),s=o.scan(),s){case 12:case 13:case 17:l!==g&&i.push(t.substring(l,g)),n!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,n)),l=o.getPosition();break}while(s!==17);return i.join("")}e.stripComments=c;function m(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(ge[132],pe([0,1,55]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(D,k,r){let C,f,p,a,u;if(k){for(a=k.offset,u=a+k.length,p=a;p>0&&!P(D,p-1);)p--;let l=u;for(;l<D.length&&!P(D,l);)l++;f=D.substring(p,l),C=T(f,r)}else f=D,C=0,p=0,a=0,u=D.length;const E=y(r,D);let w=!1,S=0,h;r.insertSpaces?h=A(" ",r.tabSize||4):h="	";const c=(0,_.createScanner)(f,!1);let m=!1;function t(){return E+A(h,C+S)}function n(){let l=c.scan();for(w=!1;l===15||l===14;)w=w||l===14,l=c.scan();return m=l===16||c.getTokenError()!==0,l}const o=[];function i(l,g,v){!m&&g<u&&v>a&&D.substring(g,v)!==l&&o.push({offset:g,length:v-g,content:l})}let s=n();if(s!==17){const l=c.getTokenOffset()+p,g=A(h,C);i(g,p,l)}for(;s!==17;){let l=c.getTokenOffset()+c.getTokenLength()+p,g=n(),v="";for(;!w&&(g===12||g===13);){const b=c.getTokenOffset()+p;i(" ",l,b),l=c.getTokenOffset()+c.getTokenLength()+p,v=g===12?t():"",g=n()}if(g===2)s!==1&&(S--,v=t());else if(g===4)s!==3&&(S--,v=t());else{switch(s){case 3:case 1:S++,v=t();break;case 5:case 12:v=t();break;case 13:w?v=t():v=" ";break;case 6:v=" ";break;case 10:if(g===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?v=" ":g!==5&&g!==17&&(m=!0);break;case 16:m=!0;break}w&&(g===12||g===13)&&(v=t())}const d=c.getTokenOffset()+p;i(v,l,d),s=g}return o}e.format=I;function A(D,k){let r="";for(let C=0;C<k;C++)r+=D;return r}function T(D,k){let r=0,C=0;const f=k.tabSize||4;for(;r<D.length;){const p=D.charAt(r);if(p===" ")C++;else if(p==="	")C+=f;else break;r++}return Math.floor(C/f)}function y(D,k){for(let r=0;r<k.length;r++){const C=k.charAt(r);if(C==="\r")return r+1<k.length&&k.charAt(r+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function P(D,k){return`\r
`.indexOf(D.charAt(k))!==-1}e.isEOL=P}),define(ge[133],pe([0,1,55,132]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(k,r,C){return T(k,r,void 0,C)}e.removeProperty=A;function T(k,r,C,f,p){const a=r.slice(),u=[],E=(0,_.parseTree)(k,u);let w,S;for(;a.length>0&&(S=a.pop(),w=(0,_.findNodeAtLocation)(E,a),w===void 0&&C!==void 0);)typeof S=="string"?C={[S]:C}:C=[C];if(w)if(w.type==="object"&&typeof S=="string"&&Array.isArray(w.children)){const h=(0,_.findNodeAtLocation)(w,[S]);if(h!==void 0)if(C===void 0){if(!h.parent)throw new Error("Malformed AST");const c=w.children.indexOf(h.parent);let m,t=h.parent.offset+h.parent.length;if(c>0){const n=w.children[c-1];m=n.offset+n.length}else m=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return y(k,{offset:m,length:t-m,content:""},f)}else return y(k,{offset:h.offset,length:h.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const c=`${JSON.stringify(S)}: ${JSON.stringify(C)}`,m=p?p(w.children.map(n=>n.children[0].value)):w.children.length;let t;if(m>0){const n=w.children[m-1];t={offset:n.offset+n.length,length:0,content:","+c}}else w.children.length===0?t={offset:w.offset+1,length:0,content:c}:t={offset:w.offset+1,length:0,content:c+","};return y(k,t,f)}}else if(w.type==="array"&&typeof S=="number"&&Array.isArray(w.children))if(C!==void 0){const h=`${JSON.stringify(C)}`;let c;if(w.children.length===0||S===0)c={offset:w.offset+1,length:0,content:w.children.length===0?h:h+","};else{const m=S===-1||S>w.children.length?w.children.length:S,t=w.children[m-1];c={offset:t.offset+t.length,length:0,content:","+h}}return y(k,c,f)}else{const h=S,c=w.children[h];let m;if(w.children.length===1)m={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===h){const t=w.children[h-1],n=t.offset+t.length,o=w.offset+w.length;m={offset:n,length:o-2-n,content:""}}else m={offset:c.offset,length:w.children[h+1].offset-c.offset,content:""};return y(k,m,f)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${w.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return y(k,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(C)},f)}}e.setProperty=T;function y(k,r,C){let f=P(k,r),p=r.offset,a=r.offset+r.content.length;if(r.length===0||r.content.length===0){for(;p>0&&!(0,I.isEOL)(f,p-1);)p--;for(;a<f.length&&!(0,I.isEOL)(f,a);)a++}const u=(0,I.format)(f,{offset:p,length:a-p},C);for(let w=u.length-1;w>=0;w--){const S=u[w];f=P(f,S),p=Math.min(p,S.offset),a=Math.max(a,S.offset+S.length),a+=S.content.length-S.length}const E=k.length-(f.length-a)-p;return[{offset:p,length:E,content:f.substring(p,a)}]}e.withFormatting=y;function P(k,r){return k.substring(0,r.offset)+r.content+k.substring(r.offset+r.length)}e.applyEdit=P;function D(k,r){let C=r.slice(0).sort((p,a)=>{const u=p.offset-a.offset;return u===0?p.length-a.length:u}),f=k.length;for(let p=C.length-1;p>=0;p--){let a=C[p];if(a.offset+a.length<=f)k=P(k,a);else throw new Error("Overlapping edit");f=a.offset}return k}e.applyEdits=D}),define(ge[134],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(A){this.executor=A,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(A){return new _(()=>A(this.getValue()))}}e.Lazy=_}),define(ge[6],pe([0,1,71,54]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let T=null;function y(h){T=h}if(e.setDisposableTracker=y,A){const h="__is_disposable_tracked__";T=new class{trackDisposable(c){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[h]||console.log(m)},3e3)}markTracked(c){if(c&&c!==u.None)try{c[h]=!0}catch(m){}}}}function P(h){!T||T.markTracked(h)}function D(h){return T&&T.trackDisposable(h),h}e.trackDisposable=D;class k extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=k;function r(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.isDisposable=r;function C(h){if(I.Iterable.is(h)){let c=[];for(const m of h)if(m){P(m);try{m.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new k(c);return Array.isArray(h)?[]:h}else if(h)return P(h),h.dispose(),h}e.dispose=C;function f(...h){return h.forEach(P),p(()=>C(h))}e.combinedDisposable=f;function p(h){const c=D({dispose:()=>{P(c),h()}});return c}e.toDisposable=p;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return P(c),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new a,D(this)}dispose(){P(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var m;this._isDisposed||c===this._value||((m=this._value)===null||m===void 0||m.dispose(),c&&P(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,P(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=E;class w{constructor(){this.references=new Map}acquire(c,...m){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...m)},this.references.set(c,t));const{object:n}=t,o=(0,_.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:n,dispose:o}}}e.ReferenceCollection=w;class S{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=S}),define(ge[56],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(T){this.element=T,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class I{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,y){const P=new _(T);if(this._first===_.Undefined)this._first=P,this._last=P;else if(y){const k=this._last;this._last=P,P.prev=k,k.next=P}else{const k=this._first;this._first=P,P.next=k,k.prev=P}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(P))}}shift(){if(this._first!==_.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==_.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==_.Undefined&&T.next!==_.Undefined){const y=T.prev;y.next=T.next,T.next.prev=y}else T.prev===_.Undefined&&T.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):T.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):T.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==_.Undefined;)yield T.element,T=T.next}}e.LinkedList=I}),function(G,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(G=typeof globalThis!="undefined"?globalThis:G||self,G.marked=e())}(this,function(){"use strict";function G(K,se){for(var he=0;he<se.length;he++){var J=se[he];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(K,J.key,J)}}function e(K,se,he){return se&&G(K.prototype,se),he&&G(K,he),K}function _(K,se){if(!!K){if(typeof K=="string")return I(K,se);var he=Object.prototype.toString.call(K).slice(8,-1);if(he==="Object"&&K.constructor&&(he=K.constructor.name),he==="Map"||he==="Set")return Array.from(K);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return I(K,se)}}function I(K,se){(se==null||se>K.length)&&(se=K.length);for(var he=0,J=new Array(se);he<se;he++)J[he]=K[he];return J}function A(K,se){var he;if(typeof Symbol=="undefined"||K[Symbol.iterator]==null){if(Array.isArray(K)||(he=_(K))||se&&K&&typeof K.length=="number"){he&&(K=he);var J=0;return function(){return J>=K.length?{done:!0}:{done:!1,value:K[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return he=K[Symbol.iterator](),he.next.bind(he)}function T(K){var se={exports:{}};return K(se,se.exports),se.exports}var y=T(function(K){function se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function he(J){K.exports.defaults=J}K.exports={defaults:se(),getDefaults:se,changeDefaults:he}}),P=/[&<>"']/,D=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,r=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(se){return C[se]};function p(K,se){if(se){if(P.test(K))return K.replace(D,f)}else if(k.test(K))return K.replace(r,f);return K}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(K){return K.replace(a,function(se,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var E=/(^|[^\[])\^/g;function w(K,se){K=K.source||K,se=se||"";var he={replace:function(ne,ce){return ce=ce.source||ce,ce=ce.replace(E,"$1"),K=K.replace(ne,ce),he},getRegex:function(){return new RegExp(K,se)}};return he}var S=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(K,se,he){if(K){var J;try{J=decodeURIComponent(u(he)).replace(S,"").toLowerCase()}catch(ne){return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}se&&!h.test(he)&&(he=i(se,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch(ne){return null}return he}var m={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(K,se){m[" "+K]||(t.test(K)?m[" "+K]=K+"/":m[" "+K]=v(K,"/",!0)),K=m[" "+K];var he=K.indexOf(":")===-1;return se.substring(0,2)==="//"?he?se:K.replace(n,"$1")+se:se.charAt(0)==="/"?he?se:K.replace(o,"$1")+se:K+se}var s={exec:function(){}};function l(K){for(var se=1,he,J;se<arguments.length;se++){he=arguments[se];for(J in he)Object.prototype.hasOwnProperty.call(he,J)&&(K[J]=he[J])}return K}function g(K,se){var he=K.replace(/\|/g,function(ce,ve,ye){for(var je=!1,He=ve;--He>=0&&ye[He]==="\\";)je=!je;return je?"|":" |"}),J=he.split(/ \|/),ne=0;if(J.length>se)J.splice(se);else for(;J.length<se;)J.push("");for(;ne<J.length;ne++)J[ne]=J[ne].trim().replace(/\\\|/g,"|");return J}function v(K,se,he){var J=K.length;if(J===0)return"";for(var ne=0;ne<J;){var ce=K.charAt(J-ne-1);if(ce===se&&!he)ne++;else if(ce!==se&&he)ne++;else break}return K.substr(0,J-ne)}function d(K,se){if(K.indexOf(se[1])===-1)return-1;for(var he=K.length,J=0,ne=0;ne<he;ne++)if(K[ne]==="\\")ne++;else if(K[ne]===se[0])J++;else if(K[ne]===se[1]&&(J--,J<0))return ne;return-1}function b(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(K,se){if(se<1)return"";for(var he="";se>1;)se&1&&(he+=K),se>>=1,K+=K;return he+K}var N={escape:p,unescape:u,edit:w,cleanUrl:c,resolveUrl:i,noopTest:s,merge:l,splitCells:g,rtrim:v,findClosingBracket:d,checkSanitizeDeprecation:b,repeatString:R},q=y.defaults,re=N.rtrim,V=N.splitCells,W=N.escape,$=N.findClosingBracket;function U(K,se,he){var J=se.href,ne=se.title?W(se.title):null,ce=K[1].replace(/\\([\[\]])/g,"$1");return K[0].charAt(0)!=="!"?{type:"link",raw:he,href:J,title:ne,text:ce}:{type:"image",raw:he,href:J,title:ne,text:W(ce)}}function F(K,se){var he=K.match(/^(\s+)(?:```)/);if(he===null)return se;var J=he[1];return se.split(`
`).map(function(ne){var ce=ne.match(/^\s+/);if(ce===null)return ne;var ve=ce[0];return ve.length>=J.length?ne.slice(J.length):ne}).join(`
`)}var M=function(){function K(he){this.options=he||q}var se=K.prototype;return se.space=function(J){var ne=this.rules.block.newline.exec(J);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},se.code=function(J){var ne=this.rules.block.code.exec(J);if(ne){var ce=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?ce:re(ce,`
`)}}},se.fences=function(J){var ne=this.rules.block.fences.exec(J);if(ne){var ce=ne[0],ve=F(ce,ne[3]||"");return{type:"code",raw:ce,lang:ne[2]?ne[2].trim():ne[2],text:ve}}},se.heading=function(J){var ne=this.rules.block.heading.exec(J);if(ne){var ce=ne[2].trim();if(/#$/.test(ce)){var ve=re(ce,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(ce=ve.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:ce}}},se.nptable=function(J){var ne=this.rules.block.nptable.exec(J);if(ne){var ce={type:"table",header:V(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[],raw:ne[0]};if(ce.header.length===ce.align.length){var ve=ce.align.length,ye;for(ye=0;ye<ve;ye++)/^ *-+: *$/.test(ce.align[ye])?ce.align[ye]="right":/^ *:-+: *$/.test(ce.align[ye])?ce.align[ye]="center":/^ *:-+ *$/.test(ce.align[ye])?ce.align[ye]="left":ce.align[ye]=null;for(ve=ce.cells.length,ye=0;ye<ve;ye++)ce.cells[ye]=V(ce.cells[ye],ce.header.length);return ce}}},se.hr=function(J){var ne=this.rules.block.hr.exec(J);if(ne)return{type:"hr",raw:ne[0]}},se.blockquote=function(J){var ne=this.rules.block.blockquote.exec(J);if(ne){var ce=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],text:ce}}},se.list=function(J){var ne=this.rules.block.list.exec(J);if(ne){var ce=ne[0],ve=ne[2],ye=ve.length>1,je={type:"list",raw:ce,ordered:ye,start:ye?+ve.slice(0,-1):"",loose:!1,items:[]},He=ne[0].match(this.rules.block.item),We=!1,Ge,nt,dt,it,Ye,mt,wt,Ee,fe=He.length;dt=this.rules.block.listItemStart.exec(He[0]);for(var le=0;le<fe;le++){if(Ge=He[le],ce=Ge,le!==fe-1){if(it=this.rules.block.listItemStart.exec(He[le+1]),this.options.pedantic?it[1].length>dt[1].length:it[1].length>dt[0].length||it[1].length>3){He.splice(le,2,He[le]+`
`+He[le+1]),le--,fe--;continue}else(!this.options.pedantic||this.options.smartLists?it[2][it[2].length-1]!==ve[ve.length-1]:ye===(it[2].length===1))&&(Ye=He.slice(le+1).join(`
`),je.raw=je.raw.substring(0,je.raw.length-Ye.length),le=fe-1);dt=it}nt=Ge.length,Ge=Ge.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ge.indexOf(`
 `)&&(nt-=Ge.length,Ge=this.options.pedantic?Ge.replace(/^ {1,4}/gm,""):Ge.replace(new RegExp("^ {1,"+nt+"}","gm"),"")),mt=We||/\n\n(?!\s*$)/.test(Ge),le!==fe-1&&(We=Ge.charAt(Ge.length-1)===`
`,mt||(mt=We)),mt&&(je.loose=!0),this.options.gfm&&(wt=/^\[[ xX]\] /.test(Ge),Ee=void 0,wt&&(Ee=Ge[1]!==" ",Ge=Ge.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:ce,task:wt,checked:Ee,loose:mt,text:Ge})}return je}},se.html=function(J){var ne=this.rules.block.html.exec(J);if(ne)return{type:this.options.sanitize?"paragraph":"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):W(ne[0]):ne[0]}},se.def=function(J){var ne=this.rules.block.def.exec(J);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var ce=ne[1].toLowerCase().replace(/\s+/g," ");return{tag:ce,raw:ne[0],href:ne[2],title:ne[3]}}},se.table=function(J){var ne=this.rules.block.table.exec(J);if(ne){var ce={type:"table",header:V(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(ce.header.length===ce.align.length){ce.raw=ne[0];var ve=ce.align.length,ye;for(ye=0;ye<ve;ye++)/^ *-+: *$/.test(ce.align[ye])?ce.align[ye]="right":/^ *:-+: *$/.test(ce.align[ye])?ce.align[ye]="center":/^ *:-+ *$/.test(ce.align[ye])?ce.align[ye]="left":ce.align[ye]=null;for(ve=ce.cells.length,ye=0;ye<ve;ye++)ce.cells[ye]=V(ce.cells[ye].replace(/^ *\| *| *\| *$/g,""),ce.header.length);return ce}}},se.lheading=function(J){var ne=this.rules.block.lheading.exec(J);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1]}},se.paragraph=function(J){var ne=this.rules.block.paragraph.exec(J);if(ne)return{type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1]}},se.text=function(J){var ne=this.rules.block.text.exec(J);if(ne)return{type:"text",raw:ne[0],text:ne[0]}},se.escape=function(J){var ne=this.rules.inline.escape.exec(J);if(ne)return{type:"escape",raw:ne[0],text:W(ne[1])}},se.tag=function(J,ne,ce){var ve=this.rules.inline.tag.exec(J);if(ve)return!ne&&/^<a /i.test(ve[0])?ne=!0:ne&&/^<\/a>/i.test(ve[0])&&(ne=!1),!ce&&/^<(pre|code|kbd|script)(\s|>)/i.test(ve[0])?ce=!0:ce&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ve[0])&&(ce=!1),{type:this.options.sanitize?"text":"html",raw:ve[0],inLink:ne,inRawBlock:ce,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):W(ve[0]):ve[0]}},se.link=function(J){var ne=this.rules.inline.link.exec(J);if(ne){var ce=ne[2].trim();if(!this.options.pedantic&&/^</.test(ce)){if(!/>$/.test(ce))return;var ve=re(ce.slice(0,-1),"\\");if((ce.length-ve.length)%2==0)return}else{var ye=$(ne[2],"()");if(ye>-1){var je=ne[0].indexOf("!")===0?5:4,He=je+ne[1].length+ye;ne[2]=ne[2].substring(0,ye),ne[0]=ne[0].substring(0,He).trim(),ne[3]=""}}var We=ne[2],Ge="";if(this.options.pedantic){var nt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(We);nt&&(We=nt[1],Ge=nt[3])}else Ge=ne[3]?ne[3].slice(1,-1):"";return We=We.trim(),/^</.test(We)&&(this.options.pedantic&&!/>$/.test(ce)?We=We.slice(1):We=We.slice(1,-1)),U(ne,{href:We&&We.replace(this.rules.inline._escapes,"$1"),title:Ge&&Ge.replace(this.rules.inline._escapes,"$1")},ne[0])}},se.reflink=function(J,ne){var ce;if((ce=this.rules.inline.reflink.exec(J))||(ce=this.rules.inline.nolink.exec(J))){var ve=(ce[2]||ce[1]).replace(/\s+/g," ");if(ve=ne[ve.toLowerCase()],!ve||!ve.href){var ye=ce[0].charAt(0);return{type:"text",raw:ye,text:ye}}return U(ce,ve,ce[0])}},se.emStrong=function(J,ne,ce){ce===void 0&&(ce="");var ve=this.rules.inline.emStrong.lDelim.exec(J);if(!!ve&&!(ve[3]&&ce.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ye=ve[1]||ve[2]||"";if(!ye||ye&&(ce===""||this.rules.inline.punctuation.exec(ce))){var je=ve[0].length-1,He,We,Ge=je,nt=0,dt=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(dt.lastIndex=0,ne=ne.slice(-1*J.length+je);(ve=dt.exec(ne))!=null;)if(He=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!He){if(We=He.length,ve[3]||ve[4]){Ge+=We;continue}else if((ve[5]||ve[6])&&je%3&&!((je+We)%3)){nt+=We;continue}if(Ge-=We,!(Ge>0)){if(Ge+nt-We<=0&&!ne.slice(dt.lastIndex).match(dt)&&(We=Math.min(We,We+Ge+nt)),Math.min(je,We)%2)return{type:"em",raw:J.slice(0,je+ve.index+We+1),text:J.slice(1,je+ve.index+We)};if(Math.min(je,We)%2==0)return{type:"strong",raw:J.slice(0,je+ve.index+We+1),text:J.slice(2,je+ve.index+We-1)}}}}}},se.codespan=function(J){var ne=this.rules.inline.code.exec(J);if(ne){var ce=ne[2].replace(/\n/g," "),ve=/[^ ]/.test(ce),ye=/^ /.test(ce)&&/ $/.test(ce);return ve&&ye&&(ce=ce.substring(1,ce.length-1)),ce=W(ce,!0),{type:"codespan",raw:ne[0],text:ce}}},se.br=function(J){var ne=this.rules.inline.br.exec(J);if(ne)return{type:"br",raw:ne[0]}},se.del=function(J){var ne=this.rules.inline.del.exec(J);if(ne)return{type:"del",raw:ne[0],text:ne[2]}},se.autolink=function(J,ne){var ce=this.rules.inline.autolink.exec(J);if(ce){var ve,ye;return ce[2]==="@"?(ve=W(this.options.mangle?ne(ce[1]):ce[1]),ye="mailto:"+ve):(ve=W(ce[1]),ye=ve),{type:"link",raw:ce[0],text:ve,href:ye,tokens:[{type:"text",raw:ve,text:ve}]}}},se.url=function(J,ne){var ce;if(ce=this.rules.inline.url.exec(J)){var ve,ye;if(ce[2]==="@")ve=W(this.options.mangle?ne(ce[0]):ce[0]),ye="mailto:"+ve;else{var je;do je=ce[0],ce[0]=this.rules.inline._backpedal.exec(ce[0])[0];while(je!==ce[0]);ve=W(ce[0]),ce[1]==="www."?ye="http://"+ve:ye=ve}return{type:"link",raw:ce[0],text:ve,href:ye,tokens:[{type:"text",raw:ve,text:ve}]}}},se.inlineText=function(J,ne,ce){var ve=this.rules.inline.text.exec(J);if(ve){var ye;return ne?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):W(ve[0]):ve[0]:ye=W(this.options.smartypants?ce(ve[0]):ve[0]),{type:"text",raw:ve[0],text:ye}}},K}(),L=N.noopTest,O=N.edit,B=N.merge,j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:L,table:L,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=O(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,j.item=O(j.item,"gm").replace(/bull/g,j.bullet).getRegex(),j.listItemStart=O(/^( *)(bull)/).replace("bull",j.bullet).getRegex(),j.list=O(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=O(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=O(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",j._tag).getRegex(),j.blockquote=O(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=B({},j),j.gfm=B({},j.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.nptable=O(j.gfm.nptable).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",j._tag).getRegex(),j.gfm.table=O(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",j._tag).getRegex(),j.pedantic=B({},j.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:L,paragraph:O(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:L,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:L,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=O(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=O(j._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=O(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=O(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=O(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=O(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=O(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=O(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=O(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=O(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=B({},Q),Q.pedantic=B({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=B({},Q.normal,{escape:O(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Q.gfm.url=O(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=B({},Q.gfm,{br:O(Q.br).replace("{2,}","*").getRegex(),text:O(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:j,inline:Q},be=y.defaults,Ae=de.block,Ce=de.inline,Le=N.repeatString;function z(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(K){var se="",he,J,ne=K.length;for(he=0;he<ne;he++)J=K.charCodeAt(he),Math.random()>.5&&(J="x"+J.toString(16)),se+="&#"+J+";";return se}var ee=function(){function K(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||be,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var J={block:Ae.normal,inline:Ce.normal};this.options.pedantic?(J.block=Ae.pedantic,J.inline=Ce.pedantic):this.options.gfm&&(J.block=Ae.gfm,this.options.breaks?J.inline=Ce.breaks:J.inline=Ce.gfm),this.tokenizer.rules=J}K.lex=function(J,ne){var ce=new K(ne);return ce.lex(J)},K.lexInline=function(J,ne){var ce=new K(ne);return ce.inlineTokens(J)};var se=K.prototype;return se.lex=function(J){return J=J.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(J,this.tokens,!0),this.inline(this.tokens),this.tokens},se.blockTokens=function(J,ne,ce){ne===void 0&&(ne=[]),ce===void 0&&(ce=!0),this.options.pedantic&&(J=J.replace(/^ +$/gm,""));for(var ve,ye,je,He;J;){if(ve=this.tokenizer.space(J)){J=J.substring(ve.raw.length),ve.type&&ne.push(ve);continue}if(ve=this.tokenizer.code(J)){J=J.substring(ve.raw.length),He=ne[ne.length-1],He&&He.type==="paragraph"?(He.raw+=`
`+ve.raw,He.text+=`
`+ve.text):ne.push(ve);continue}if(ve=this.tokenizer.fences(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.heading(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.nptable(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.hr(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.blockquote(J)){J=J.substring(ve.raw.length),ve.tokens=this.blockTokens(ve.text,[],ce),ne.push(ve);continue}if(ve=this.tokenizer.list(J)){for(J=J.substring(ve.raw.length),je=ve.items.length,ye=0;ye<je;ye++)ve.items[ye].tokens=this.blockTokens(ve.items[ye].text,[],!1);ne.push(ve);continue}if(ve=this.tokenizer.html(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ce&&(ve=this.tokenizer.def(J))){J=J.substring(ve.raw.length),this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.lheading(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ce&&(ve=this.tokenizer.paragraph(J))){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.text(J)){J=J.substring(ve.raw.length),He=ne[ne.length-1],He&&He.type==="text"?(He.raw+=`
`+ve.raw,He.text+=`
`+ve.text):ne.push(ve);continue}if(J){var We="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(We);break}else throw new Error(We)}}return ne},se.inline=function(J){var ne,ce,ve,ye,je,He,We=J.length;for(ne=0;ne<We;ne++)switch(He=J[ne],He.type){case"paragraph":case"text":case"heading":{He.tokens=[],this.inlineTokens(He.text,He.tokens);break}case"table":{for(He.tokens={header:[],cells:[]},ye=He.header.length,ce=0;ce<ye;ce++)He.tokens.header[ce]=[],this.inlineTokens(He.header[ce],He.tokens.header[ce]);for(ye=He.cells.length,ce=0;ce<ye;ce++)for(je=He.cells[ce],He.tokens.cells[ce]=[],ve=0;ve<je.length;ve++)He.tokens.cells[ce][ve]=[],this.inlineTokens(je[ve],He.tokens.cells[ce][ve]);break}case"blockquote":{this.inline(He.tokens);break}case"list":{for(ye=He.items.length,ce=0;ce<ye;ce++)this.inline(He.items[ce].tokens);break}}return J},se.inlineTokens=function(J,ne,ce,ve){ne===void 0&&(ne=[]),ce===void 0&&(ce=!1),ve===void 0&&(ve=!1);var ye,je,He=J,We,Ge,nt;if(this.tokens.links){var dt=Object.keys(this.tokens.links);if(dt.length>0)for(;(We=this.tokenizer.rules.inline.reflinkSearch.exec(He))!=null;)dt.includes(We[0].slice(We[0].lastIndexOf("[")+1,-1))&&(He=He.slice(0,We.index)+"["+Le("a",We[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(We=this.tokenizer.rules.inline.blockSkip.exec(He))!=null;)He=He.slice(0,We.index)+"["+Le("a",We[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(We=this.tokenizer.rules.inline.escapedEmSt.exec(He))!=null;)He=He.slice(0,We.index)+"++"+He.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;){if(Ge||(nt=""),Ge=!1,ye=this.tokenizer.escape(J)){J=J.substring(ye.raw.length),ne.push(ye);continue}if(ye=this.tokenizer.tag(J,ce,ve)){J=J.substring(ye.raw.length),ce=ye.inLink,ve=ye.inRawBlock;var it=ne[ne.length-1];it&&ye.type==="text"&&it.type==="text"?(it.raw+=ye.raw,it.text+=ye.text):ne.push(ye);continue}if(ye=this.tokenizer.link(J)){J=J.substring(ye.raw.length),ye.type==="link"&&(ye.tokens=this.inlineTokens(ye.text,[],!0,ve)),ne.push(ye);continue}if(ye=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(ye.raw.length);var Ye=ne[ne.length-1];ye.type==="link"?(ye.tokens=this.inlineTokens(ye.text,[],!0,ve),ne.push(ye)):Ye&&ye.type==="text"&&Ye.type==="text"?(Ye.raw+=ye.raw,Ye.text+=ye.text):ne.push(ye);continue}if(ye=this.tokenizer.emStrong(J,He,nt)){J=J.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ce,ve),ne.push(ye);continue}if(ye=this.tokenizer.codespan(J)){J=J.substring(ye.raw.length),ne.push(ye);continue}if(ye=this.tokenizer.br(J)){J=J.substring(ye.raw.length),ne.push(ye);continue}if(ye=this.tokenizer.del(J)){J=J.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ce,ve),ne.push(ye);continue}if(ye=this.tokenizer.autolink(J,Y)){J=J.substring(ye.raw.length),ne.push(ye);continue}if(!ce&&(ye=this.tokenizer.url(J,Y))){J=J.substring(ye.raw.length),ne.push(ye);continue}if(ye=this.tokenizer.inlineText(J,ve,z)){J=J.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(nt=ye.raw.slice(-1)),Ge=!0,je=ne[ne.length-1],je&&je.type==="text"?(je.raw+=ye.raw,je.text+=ye.text):ne.push(ye);continue}if(J){var mt="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return ne},e(K,null,[{key:"rules",get:function(){return{block:Ae,inline:Ce}}}]),K}(),ae=y.defaults,me=N.cleanUrl,De=N.escape,Oe=function(){function K(he){this.options=he||ae}var se=K.prototype;return se.code=function(J,ne,ce){var ve=(ne||"").match(/\S*/)[0];if(this.options.highlight){var ye=this.options.highlight(J,ve);ye!=null&&ye!==J&&(ce=!0,J=ye)}return J=J.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+De(ve,!0)+'">'+(ce?J:De(J,!0))+`</code></pre>
`:"<pre><code>"+(ce?J:De(J,!0))+`</code></pre>
`},se.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},se.html=function(J){return J},se.heading=function(J,ne,ce,ve){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+ve.slug(ce)+'">'+J+"</h"+ne+`>
`:"<h"+ne+">"+J+"</h"+ne+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(J,ne,ce){var ve=ne?"ol":"ul",ye=ne&&ce!==1?' start="'+ce+'"':"";return"<"+ve+ye+`>
`+J+"</"+ve+`>
`},se.listitem=function(J){return"<li>"+J+`</li>
`},se.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(J){return"<p>"+J+`</p>
`},se.table=function(J,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+ne+`</table>
`},se.tablerow=function(J){return`<tr>
`+J+`</tr>
`},se.tablecell=function(J,ne){var ce=ne.header?"th":"td",ve=ne.align?"<"+ce+' align="'+ne.align+'">':"<"+ce+">";return ve+J+"</"+ce+`>
`},se.strong=function(J){return"<strong>"+J+"</strong>"},se.em=function(J){return"<em>"+J+"</em>"},se.codespan=function(J){return"<code>"+J+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(J){return"<del>"+J+"</del>"},se.link=function(J,ne,ce){if(J=me(this.options.sanitize,this.options.baseUrl,J),J===null)return ce;var ve='<a href="'+De(J)+'"';return ne&&(ve+=' title="'+ne+'"'),ve+=">"+ce+"</a>",ve},se.image=function(J,ne,ce){if(J=me(this.options.sanitize,this.options.baseUrl,J),J===null)return ce;var ve='<img src="'+J+'" alt="'+ce+'"';return ne&&(ve+=' title="'+ne+'"'),ve+=this.options.xhtml?"/>":">",ve},se.text=function(J){return J},K}(),we=function(){function K(){}var se=K.prototype;return se.strong=function(J){return J},se.em=function(J){return J},se.codespan=function(J){return J},se.del=function(J){return J},se.html=function(J){return J},se.text=function(J){return J},se.link=function(J,ne,ce){return""+ce},se.image=function(J,ne,ce){return""+ce},se.br=function(){return""},K}(),Pe=function(){function K(){this.seen={}}var se=K.prototype;return se.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(J,ne){var ce=J,ve=0;if(this.seen.hasOwnProperty(ce)){ve=this.seen[J];do ve++,ce=J+"-"+ve;while(this.seen.hasOwnProperty(ce))}return ne||(this.seen[J]=ve,this.seen[ce]=0),ce},se.slug=function(J,ne){ne===void 0&&(ne={});var ce=this.serialize(J);return this.getNextSafeSlug(ce,ne.dryrun)},K}(),Re=y.defaults,Be=N.unescape,Se=function(){function K(he){this.options=he||Re,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new Pe}K.parse=function(J,ne){var ce=new K(ne);return ce.parse(J)},K.parseInline=function(J,ne){var ce=new K(ne);return ce.parseInline(J)};var se=K.prototype;return se.parse=function(J,ne){ne===void 0&&(ne=!0);var ce="",ve,ye,je,He,We,Ge,nt,dt,it,Ye,mt,wt,Ee,fe,le,Z,Fe,Te,Qe=J.length;for(ve=0;ve<Qe;ve++)switch(Ye=J[ve],Ye.type){case"space":continue;case"hr":{ce+=this.renderer.hr();continue}case"heading":{ce+=this.renderer.heading(this.parseInline(Ye.tokens),Ye.depth,Be(this.parseInline(Ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ce+=this.renderer.code(Ye.text,Ye.lang,Ye.escaped);continue}case"table":{for(dt="",nt="",He=Ye.header.length,ye=0;ye<He;ye++)nt+=this.renderer.tablecell(this.parseInline(Ye.tokens.header[ye]),{header:!0,align:Ye.align[ye]});for(dt+=this.renderer.tablerow(nt),it="",He=Ye.cells.length,ye=0;ye<He;ye++){for(Ge=Ye.tokens.cells[ye],nt="",We=Ge.length,je=0;je<We;je++)nt+=this.renderer.tablecell(this.parseInline(Ge[je]),{header:!1,align:Ye.align[je]});it+=this.renderer.tablerow(nt)}ce+=this.renderer.table(dt,it);continue}case"blockquote":{it=this.parse(Ye.tokens),ce+=this.renderer.blockquote(it);continue}case"list":{for(mt=Ye.ordered,wt=Ye.start,Ee=Ye.loose,He=Ye.items.length,it="",ye=0;ye<He;ye++)le=Ye.items[ye],Z=le.checked,Fe=le.task,fe="",le.task&&(Te=this.renderer.checkbox(Z),Ee?le.tokens.length>0&&le.tokens[0].type==="text"?(le.tokens[0].text=Te+" "+le.tokens[0].text,le.tokens[0].tokens&&le.tokens[0].tokens.length>0&&le.tokens[0].tokens[0].type==="text"&&(le.tokens[0].tokens[0].text=Te+" "+le.tokens[0].tokens[0].text)):le.tokens.unshift({type:"text",text:Te}):fe+=Te),fe+=this.parse(le.tokens,Ee),it+=this.renderer.listitem(fe,Fe,Z);ce+=this.renderer.list(it,mt,wt);continue}case"html":{ce+=this.renderer.html(Ye.text);continue}case"paragraph":{ce+=this.renderer.paragraph(this.parseInline(Ye.tokens));continue}case"text":{for(it=Ye.tokens?this.parseInline(Ye.tokens):Ye.text;ve+1<Qe&&J[ve+1].type==="text";)Ye=J[++ve],it+=`
`+(Ye.tokens?this.parseInline(Ye.tokens):Ye.text);ce+=ne?this.renderer.paragraph(it):it;continue}default:{var Ze='Token with "'+Ye.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}return ce},se.parseInline=function(J,ne){ne=ne||this.renderer;var ce="",ve,ye,je=J.length;for(ve=0;ve<je;ve++)switch(ye=J[ve],ye.type){case"escape":{ce+=ne.text(ye.text);break}case"html":{ce+=ne.html(ye.text);break}case"link":{ce+=ne.link(ye.href,ye.title,this.parseInline(ye.tokens,ne));break}case"image":{ce+=ne.image(ye.href,ye.title,ye.text);break}case"strong":{ce+=ne.strong(this.parseInline(ye.tokens,ne));break}case"em":{ce+=ne.em(this.parseInline(ye.tokens,ne));break}case"codespan":{ce+=ne.codespan(ye.text);break}case"br":{ce+=ne.br();break}case"del":{ce+=ne.del(this.parseInline(ye.tokens,ne));break}case"text":{ce+=ne.text(ye.text);break}default:{var He='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}return ce},K}(),qe=N.merge,X=N.checkSanitizeDeprecation,ie=N.escape,_e=y.getDefaults,Ne=y.changeDefaults,ze=y.defaults;function $e(K,se,he){if(typeof K=="undefined"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof se=="function"&&(he=se,se=null),se=qe({},$e.defaults,se||{}),X(se),he){var J=se.highlight,ne;try{ne=ee.lex(K,se)}catch(je){return he(je)}var ce=function(He){var We;if(!He)try{We=Se.parse(ne,se)}catch(Ge){He=Ge}return se.highlight=J,He?he(He):he(null,We)};if(!J||J.length<3||(delete se.highlight,!ne.length))return ce();var ve=0;$e.walkTokens(ne,function(je){je.type==="code"&&(ve++,setTimeout(function(){J(je.text,je.lang,function(He,We){if(He)return ce(He);We!=null&&We!==je.text&&(je.text=We,je.escaped=!0),ve--,ve===0&&ce()})},0))}),ve===0&&ce();return}try{var ye=ee.lex(K,se);return se.walkTokens&&$e.walkTokens(ye,se.walkTokens),Se.parse(ye,se)}catch(je){if(je.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+ie(je.message+"",!0)+"</pre>";throw je}}$e.options=$e.setOptions=function(K){return qe($e.defaults,K),Ne($e.defaults),$e},$e.getDefaults=_e,$e.defaults=ze,$e.use=function(K){var se=qe({},K);if(K.renderer&&function(){var J=$e.defaults.renderer||new Oe,ne=function(ye){var je=J[ye];J[ye]=function(){for(var He=arguments.length,We=new Array(He),Ge=0;Ge<He;Ge++)We[Ge]=arguments[Ge];var nt=K.renderer[ye].apply(J,We);return nt===!1&&(nt=je.apply(J,We)),nt}};for(var ce in K.renderer)ne(ce);se.renderer=J}(),K.tokenizer&&function(){var J=$e.defaults.tokenizer||new M,ne=function(ye){var je=J[ye];J[ye]=function(){for(var He=arguments.length,We=new Array(He),Ge=0;Ge<He;Ge++)We[Ge]=arguments[Ge];var nt=K.tokenizer[ye].apply(J,We);return nt===!1&&(nt=je.apply(J,We)),nt}};for(var ce in K.tokenizer)ne(ce);se.tokenizer=J}(),K.walkTokens){var he=$e.defaults.walkTokens;se.walkTokens=function(J){K.walkTokens(J),he&&he(J)}}$e.setOptions(se)},$e.walkTokens=function(K,se){for(var he=A(K),J;!(J=he()).done;){var ne=J.value;switch(se(ne),ne.type){case"table":{for(var ce=A(ne.tokens.header),ve;!(ve=ce()).done;){var ye=ve.value;$e.walkTokens(ye,se)}for(var je=A(ne.tokens.cells),He;!(He=je()).done;)for(var We=He.value,Ge=A(We),nt;!(nt=Ge()).done;){var dt=nt.value;$e.walkTokens(dt,se)}break}case"list":{$e.walkTokens(ne.items,se);break}default:ne.tokens&&$e.walkTokens(ne.tokens,se)}}},$e.parseInline=function(K,se){if(typeof K=="undefined"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");se=qe({},$e.defaults,se||{}),X(se);try{var he=ee.lexInline(K,se);return se.walkTokens&&$e.walkTokens(he,se.walkTokens),Se.parseInline(he,se)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+ie(J.message+"",!0)+"</pre>";throw J}},$e.Parser=Se,$e.parser=Se.parse,$e.Renderer=Oe,$e.TextRenderer=we,$e.Lexer=ee,$e.lexer=ee.lex,$e.Tokenizer=M,$e.Slugger=Pe,$e.parse=$e;var Je=$e;return Je}),define(ge[73],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(y,P,D){return Math.min(Math.max(y,P),D)}e.clamp=_;function I(y,P){return(P+y%P)%P}e.rot=I;class A{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=A;class T{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";(function(){function G(A){const T=[];typeof A=="number"&&T.push("code/timeOrigin",A);function y(D){T.push(D,Date.now())}function P(){const D=[];for(let k=0;k<T.length;k+=2)D.push({name:T[k],startTime:T[k+1]});return D}return{mark:y,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const y of performance.getEntriesByType("mark"))T.push({name:y.name,startTime:Math.round(A+y.startTime)});return T}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function _(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=_(I))})(),define(ge[10],pe([0,1]),function(G,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let A=!1,T=!1,y=!1,P=!1,D=!1,k=!1,r=!1,C,f=I,p,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const E=typeof((_=u==null?void 0:u.versions)===null||_===void 0?void 0:_.electron)=="string"&&u.type==="renderer";if(e.isElectronSandboxed=E&&(u==null?void 0:u.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=u==null?void 0:u.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E){a=navigator.userAgent,A=a.indexOf("Windows")>=0,T=a.indexOf("Macintosh")>=0,r=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=a.indexOf("Linux")>=0,k=!0,C=navigator.language,f=C;const i=typeof document!="undefined"&&document.getElementById("vscode-remote-nls-configuration"),s=i&&i.getAttribute("data-settings");if(s)try{const l=JSON.parse(s);C=l.locale,p=l._translationsConfigFile,f=l.availableLanguages["*"]||I}catch(l){}}else if(typeof u=="object"){A=u.platform==="win32",T=u.platform==="darwin",y=u.platform==="linux",P=y&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,C=I,f=I;const i=u.env.VSCODE_NLS_CONFIG;if(i)try{const s=JSON.parse(i),l=s.availableLanguages["*"];C=s.locale,f=l||I,p=s._translationsConfigFile}catch(s){}D=!0}else console.error("Unable to resolve platform.");var w;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function S(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let h=0;T?h=1:A?h=3:y&&(h=2),e.isWindows=A,e.isMacintosh=T,e.isLinux=y,e.isLinuxSnap=P,e.isNative=D,e.isWeb=k,e.isIOS=r,e.platform=h,e.userAgent=a,e.language=f;var c;(function(i){function s(){return e.language}i.value=s;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=l;function g(){return e.language==="en"}i.isDefault=g})(c=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=p,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeSetImmediateId)for(let d=0,b=l.length;d<b;d++){const R=l[d];if(R.id===v.data.vscodeSetImmediateId){l.splice(d,1),R.callback();return}}});let g=0;return v=>{const d=++g;l.push({id:d,callback:v}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof(u==null?void 0:u.nextTick)=="function")return u.nextTick.bind(u);const s=Promise.resolve();return l=>s.then(l)}();var m;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(m=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||r?2:A?1:3;let t=!0,n=!1;function o(){if(!n){n=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,t=new Uint16Array(i.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=o}),define(ge[36],pe([0,1,10]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof _.globals.vscode!="undefined"){const A=_.globals.vscode.process;I={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(T){return(0,_.setImmediate)(T)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:I={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},nextTick(A){return(0,_.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(ge[8],pe([0,1,36]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,A=97,T=90,y=122,P=46,D=47,k=92,r=58,C=63;class f extends Error{constructor(c,m,t){let n;typeof m=="string"&&m.indexOf("not ")===0?(n="must not be",m=m.replace(/^not /,"")):n="must be";const o=c.indexOf(".")!==-1?"property":"argument";let i=`The "${c}" ${o} ${n} of type ${m}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function p(h,c){if(typeof h!="string")throw new f(c,"string",h)}function a(h){return h===D||h===k}function u(h){return h===D}function E(h){return h>=I&&h<=T||h>=A&&h<=y}function w(h,c,m,t){let n="",o=0,i=-1,s=0,l=0;for(let g=0;g<=h.length;++g){if(g<h.length)l=h.charCodeAt(g);else{if(t(l))break;l=D}if(t(l)){if(!(i===g-1||s===1))if(s===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const v=n.lastIndexOf(m);v===-1?(n="",o=0):(n=n.slice(0,v),o=n.length-1-n.lastIndexOf(m)),i=g,s=0;continue}else if(n.length!==0){n="",o=0,i=g,s=0;continue}}c&&(n+=n.length>0?`${m}..`:"..",o=2)}else n.length>0?n+=`${m}${h.slice(i+1,g)}`:n=h.slice(i+1,g),o=g-i-1;i=g,s=0}else l===P&&s!==-1?++s:s=-1}return n}function S(h,c){if(c===null||typeof c!="object")throw new f("pathObject","Object",c);const m=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return m?m===c.root?`${m}${t}`:`${m}${h}${t}`:t}e.win32={resolve(...h){let c="",m="",t=!1;for(let n=h.length-1;n>=-1;n--){let o;if(n>=0){if(o=h[n],p(o,"path"),o.length===0)continue}else c.length===0?o=_.cwd():(o=_.env[`=${c}`]||_.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==c.toLowerCase()&&o.charCodeAt(2)===k)&&(o=`${c}\\`));const i=o.length;let s=0,l="",g=!1;const v=o.charCodeAt(0);if(i===1)a(v)&&(s=1,g=!0);else if(a(v))if(g=!0,a(o.charCodeAt(1))){let d=2,b=d;for(;d<i&&!a(o.charCodeAt(d));)d++;if(d<i&&d!==b){const R=o.slice(b,d);for(b=d;d<i&&a(o.charCodeAt(d));)d++;if(d<i&&d!==b){for(b=d;d<i&&!a(o.charCodeAt(d));)d++;(d===i||d!==b)&&(l=`\\\\${R}\\${o.slice(b,d)}`,s=d)}}}else s=1;else E(v)&&o.charCodeAt(1)===r&&(l=o.slice(0,2),s=2,i>2&&a(o.charCodeAt(2))&&(g=!0,s=3));if(l.length>0)if(c.length>0){if(l.toLowerCase()!==c.toLowerCase())continue}else c=l;if(t){if(c.length>0)break}else if(m=`${o.slice(s)}\\${m}`,t=g,g&&c.length>0)break}return m=w(m,!t,"\\",a),t?`${c}\\${m}`:`${c}${m}`||"."},normalize(h){p(h,"path");const c=h.length;if(c===0)return".";let m=0,t,n=!1;const o=h.charCodeAt(0);if(c===1)return u(o)?"\\":h;if(a(o))if(n=!0,a(h.charCodeAt(1))){let s=2,l=s;for(;s<c&&!a(h.charCodeAt(s));)s++;if(s<c&&s!==l){const g=h.slice(l,s);for(l=s;s<c&&a(h.charCodeAt(s));)s++;if(s<c&&s!==l){for(l=s;s<c&&!a(h.charCodeAt(s));)s++;if(s===c)return`\\\\${g}\\${h.slice(l)}\\`;s!==l&&(t=`\\\\${g}\\${h.slice(l,s)}`,m=s)}}}else m=1;else E(o)&&h.charCodeAt(1)===r&&(t=h.slice(0,2),m=2,c>2&&a(h.charCodeAt(2))&&(n=!0,m=3));let i=m<c?w(h.slice(m),!n,"\\",a):"";return i.length===0&&!n&&(i="."),i.length>0&&a(h.charCodeAt(c-1))&&(i+="\\"),t===void 0?n?`\\${i}`:i:n?`${t}\\${i}`:`${t}${i}`},isAbsolute(h){p(h,"path");const c=h.length;if(c===0)return!1;const m=h.charCodeAt(0);return a(m)||c>2&&E(m)&&h.charCodeAt(1)===r&&a(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let c,m;for(let o=0;o<h.length;++o){const i=h[o];p(i,"path"),i.length>0&&(c===void 0?c=m=i:c+=`\\${i}`)}if(c===void 0)return".";let t=!0,n=0;if(typeof m=="string"&&a(m.charCodeAt(0))){++n;const o=m.length;o>1&&a(m.charCodeAt(1))&&(++n,o>2&&(a(m.charCodeAt(2))?++n:t=!1))}if(t){for(;n<c.length&&a(c.charCodeAt(n));)n++;n>=2&&(c=`\\${c.slice(n)}`)}return e.win32.normalize(c)},relative(h,c){if(p(h,"from"),p(c,"to"),h===c)return"";const m=e.win32.resolve(h),t=e.win32.resolve(c);if(m===t||(h=m.toLowerCase(),c=t.toLowerCase(),h===c))return"";let n=0;for(;n<h.length&&h.charCodeAt(n)===k;)n++;let o=h.length;for(;o-1>n&&h.charCodeAt(o-1)===k;)o--;const i=o-n;let s=0;for(;s<c.length&&c.charCodeAt(s)===k;)s++;let l=c.length;for(;l-1>s&&c.charCodeAt(l-1)===k;)l--;const g=l-s,v=i<g?i:g;let d=-1,b=0;for(;b<v;b++){const N=h.charCodeAt(n+b);if(N!==c.charCodeAt(s+b))break;N===k&&(d=b)}if(b!==v){if(d===-1)return t}else{if(g>v){if(c.charCodeAt(s+b)===k)return t.slice(s+b+1);if(b===2)return t.slice(s+b)}i>v&&(h.charCodeAt(n+b)===k?d=b:b===2&&(d=3)),d===-1&&(d=0)}let R="";for(b=n+d+1;b<=o;++b)(b===o||h.charCodeAt(b)===k)&&(R+=R.length===0?"..":"\\..");return s+=d,R.length>0?`${R}${t.slice(s,l)}`:(t.charCodeAt(s)===k&&++s,t.slice(s,l))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const c=e.win32.resolve(h);if(c.length<=2)return h;if(c.charCodeAt(0)===k){if(c.charCodeAt(1)===k){const m=c.charCodeAt(2);if(m!==C&&m!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(E(c.charCodeAt(0))&&c.charCodeAt(1)===r&&c.charCodeAt(2)===k)return`\\\\?\\${c}`;return h},dirname(h){p(h,"path");const c=h.length;if(c===0)return".";let m=-1,t=0;const n=h.charCodeAt(0);if(c===1)return a(n)?h:".";if(a(n)){if(m=t=1,a(h.charCodeAt(1))){let s=2,l=s;for(;s<c&&!a(h.charCodeAt(s));)s++;if(s<c&&s!==l){for(l=s;s<c&&a(h.charCodeAt(s));)s++;if(s<c&&s!==l){for(l=s;s<c&&!a(h.charCodeAt(s));)s++;if(s===c)return h;s!==l&&(m=t=s+1)}}}}else E(n)&&h.charCodeAt(1)===r&&(m=c>2&&a(h.charCodeAt(2))?3:2,t=m);let o=-1,i=!0;for(let s=c-1;s>=t;--s)if(a(h.charCodeAt(s))){if(!i){o=s;break}}else i=!1;if(o===-1){if(m===-1)return".";o=m}return h.slice(0,o)},basename(h,c){c!==void 0&&p(c,"ext"),p(h,"path");let m=0,t=-1,n=!0,o;if(h.length>=2&&E(h.charCodeAt(0))&&h.charCodeAt(1)===r&&(m=2),c!==void 0&&c.length>0&&c.length<=h.length){if(c===h)return"";let i=c.length-1,s=-1;for(o=h.length-1;o>=m;--o){const l=h.charCodeAt(o);if(a(l)){if(!n){m=o+1;break}}else s===-1&&(n=!1,s=o+1),i>=0&&(l===c.charCodeAt(i)?--i==-1&&(t=o):(i=-1,t=s))}return m===t?t=s:t===-1&&(t=h.length),h.slice(m,t)}for(o=h.length-1;o>=m;--o)if(a(h.charCodeAt(o))){if(!n){m=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":h.slice(m,t)},extname(h){p(h,"path");let c=0,m=-1,t=0,n=-1,o=!0,i=0;h.length>=2&&h.charCodeAt(1)===r&&E(h.charCodeAt(0))&&(c=t=2);for(let s=h.length-1;s>=c;--s){const l=h.charCodeAt(s);if(a(l)){if(!o){t=s+1;break}continue}n===-1&&(o=!1,n=s+1),l===P?m===-1?m=s:i!==1&&(i=1):m!==-1&&(i=-1)}return m===-1||n===-1||i===0||i===1&&m===n-1&&m===t+1?"":h.slice(m,n)},format:S.bind(null,"\\"),parse(h){p(h,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return c;const m=h.length;let t=0,n=h.charCodeAt(0);if(m===1)return a(n)?(c.root=c.dir=h,c):(c.base=c.name=h,c);if(a(n)){if(t=1,a(h.charCodeAt(1))){let d=2,b=d;for(;d<m&&!a(h.charCodeAt(d));)d++;if(d<m&&d!==b){for(b=d;d<m&&a(h.charCodeAt(d));)d++;if(d<m&&d!==b){for(b=d;d<m&&!a(h.charCodeAt(d));)d++;d===m?t=d:d!==b&&(t=d+1)}}}}else if(E(n)&&h.charCodeAt(1)===r){if(m<=2)return c.root=c.dir=h,c;if(t=2,a(h.charCodeAt(2))){if(m===3)return c.root=c.dir=h,c;t=3}}t>0&&(c.root=h.slice(0,t));let o=-1,i=t,s=-1,l=!0,g=h.length-1,v=0;for(;g>=t;--g){if(n=h.charCodeAt(g),a(n)){if(!l){i=g+1;break}continue}s===-1&&(l=!1,s=g+1),n===P?o===-1?o=g:v!==1&&(v=1):o!==-1&&(v=-1)}return s!==-1&&(o===-1||v===0||v===1&&o===s-1&&o===i+1?c.base=c.name=h.slice(i,s):(c.name=h.slice(i,o),c.base=h.slice(i,s),c.ext=h.slice(o,s))),i>0&&i!==t?c.dir=h.slice(0,i-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let c="",m=!1;for(let t=h.length-1;t>=-1&&!m;t--){const n=t>=0?h[t]:_.cwd();p(n,"path"),n.length!==0&&(c=`${n}/${c}`,m=n.charCodeAt(0)===D)}return c=w(c,!m,"/",u),m?`/${c}`:c.length>0?c:"."},normalize(h){if(p(h,"path"),h.length===0)return".";const c=h.charCodeAt(0)===D,m=h.charCodeAt(h.length-1)===D;return h=w(h,!c,"/",u),h.length===0?c?"/":m?"./":".":(m&&(h+="/"),c?`/${h}`:h)},isAbsolute(h){return p(h,"path"),h.length>0&&h.charCodeAt(0)===D},join(...h){if(h.length===0)return".";let c;for(let m=0;m<h.length;++m){const t=h[m];p(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(h,c){if(p(h,"from"),p(c,"to"),h===c||(h=e.posix.resolve(h),c=e.posix.resolve(c),h===c))return"";const m=1,t=h.length,n=t-m,o=1,i=c.length-o,s=n<i?n:i;let l=-1,g=0;for(;g<s;g++){const d=h.charCodeAt(m+g);if(d!==c.charCodeAt(o+g))break;d===D&&(l=g)}if(g===s)if(i>s){if(c.charCodeAt(o+g)===D)return c.slice(o+g+1);if(g===0)return c.slice(o+g)}else n>s&&(h.charCodeAt(m+g)===D?l=g:g===0&&(l=0));let v="";for(g=m+l+1;g<=t;++g)(g===t||h.charCodeAt(g)===D)&&(v+=v.length===0?"..":"/..");return`${v}${c.slice(o+l)}`},toNamespacedPath(h){return h},dirname(h){if(p(h,"path"),h.length===0)return".";const c=h.charCodeAt(0)===D;let m=-1,t=!0;for(let n=h.length-1;n>=1;--n)if(h.charCodeAt(n)===D){if(!t){m=n;break}}else t=!1;return m===-1?c?"/":".":c&&m===1?"//":h.slice(0,m)},basename(h,c){c!==void 0&&p(c,"ext"),p(h,"path");let m=0,t=-1,n=!0,o;if(c!==void 0&&c.length>0&&c.length<=h.length){if(c===h)return"";let i=c.length-1,s=-1;for(o=h.length-1;o>=0;--o){const l=h.charCodeAt(o);if(l===D){if(!n){m=o+1;break}}else s===-1&&(n=!1,s=o+1),i>=0&&(l===c.charCodeAt(i)?--i==-1&&(t=o):(i=-1,t=s))}return m===t?t=s:t===-1&&(t=h.length),h.slice(m,t)}for(o=h.length-1;o>=0;--o)if(h.charCodeAt(o)===D){if(!n){m=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":h.slice(m,t)},extname(h){p(h,"path");let c=-1,m=0,t=-1,n=!0,o=0;for(let i=h.length-1;i>=0;--i){const s=h.charCodeAt(i);if(s===D){if(!n){m=i+1;break}continue}t===-1&&(n=!1,t=i+1),s===P?c===-1?c=i:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||t===-1||o===0||o===1&&c===t-1&&c===m+1?"":h.slice(c,t)},format:S.bind(null,"/"),parse(h){p(h,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return c;const m=h.charCodeAt(0)===D;let t;m?(c.root="/",t=1):t=0;let n=-1,o=0,i=-1,s=!0,l=h.length-1,g=0;for(;l>=t;--l){const v=h.charCodeAt(l);if(v===D){if(!s){o=l+1;break}continue}i===-1&&(s=!1,i=l+1),v===P?n===-1?n=l:g!==1&&(g=1):n!==-1&&(g=-1)}if(i!==-1){const v=o===0&&m?1:o;n===-1||g===0||g===1&&n===i-1&&n===o+1?c.base=c.name=h.slice(v,i):(c.name=h.slice(v,n),c.base=h.slice(v,i),c.ext=h.slice(n,i))}return o>0?c.dir=h.slice(0,o-1):m&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[135],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var I;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(T,...y){const P=y.reduce((r,C)=>(r[C]=!0,r),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/];Object.keys(T).filter(r=>!P[r]).forEach(r=>{for(let C=0;C<D.length;C++)if(r.search(D[C])!==-1){delete T[r];break}})}e.sanitizeProcessEnvironment=A}),define(ge[48],pe([0,1,10]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=_.globals.performance&&typeof _.globals.performance.now=="function";class A{constructor(y){this._highResolution=I&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new A(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=A}),define(ge[3],pe([0,1,16,71,6,56,48]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(w){w.None=()=>A.Disposable.None;function S(V){return(W,$=null,U)=>{let F=!1,M;return M=V(L=>{if(!F)return M?M.dispose():F=!0,W.call($,L)},null,U),F&&M.dispose(),M}}w.once=S;function h(V,W){return i(($,U=null,F)=>V(M=>$.call(U,W(M)),null,F))}w.map=h;function c(V,W){return i(($,U=null,F)=>V(M=>{W(M),$.call(U,M)},null,F))}w.forEach=c;function m(V,W){return i(($,U=null,F)=>V(M=>W(M)&&$.call(U,M),null,F))}w.filter=m;function t(V){return V}w.signal=t;function n(...V){return(W,$=null,U)=>(0,A.combinedDisposable)(...V.map(F=>F(M=>W.call($,M),null,U)))}w.any=n;function o(V,W,$){let U=$;return h(V,F=>(U=W(U,F),U))}w.reduce=o;function i(V){let W;const $=new f({onFirstListenerAdd(){W=V($.fire,$)},onLastListenerRemove(){W.dispose()}});return $.event}w.snapshot=i;function s(V,W,$=100,U=!1,F){let M,L,O,B=0;const j=new f({leakWarningThreshold:F,onFirstListenerAdd(){M=V(Q=>{B++,L=W(L,Q),U&&!O&&(j.fire(L),L=void 0),clearTimeout(O),O=setTimeout(()=>{const de=L;L=void 0,O=void 0,(!U||B>1)&&j.fire(de),B=0},$)})},onLastListenerRemove(){M.dispose()}});return j.event}w.debounce=s;function l(V){const W=new Date().getTime();return h(S(V),$=>new Date().getTime()-W)}w.stopwatch=l;function g(V){let W=!0,$;return m(V,U=>{const F=W||U!==$;return W=!1,$=U,F})}w.latch=g;function v(V,W=!1,$=[]){let U=$.slice(),F=V(O=>{U?U.push(O):L.fire(O)});const M=()=>{U&&U.forEach(O=>L.fire(O)),U=null},L=new f({onFirstListenerAdd(){F||(F=V(O=>L.fire(O)))},onFirstListenerDidAdd(){U&&(W?setTimeout(M):M())},onLastListenerRemove(){F&&F.dispose(),F=null}});return L.event}w.buffer=v;class d{constructor(W){this.event=W}map(W){return new d(h(this.event,W))}forEach(W){return new d(c(this.event,W))}filter(W){return new d(m(this.event,W))}reduce(W,$){return new d(o(this.event,W,$))}latch(){return new d(g(this.event))}debounce(W,$=100,U=!1,F){return new d(s(this.event,W,$,U,F))}on(W,$,U){return this.event(W,$,U)}once(W,$,U){return S(this.event)(W,$,U)}}function b(V){return new d(V)}w.chain=b;function R(V,W,$=U=>U){const U=(...O)=>L.fire($(...O)),F=()=>V.on(W,U),M=()=>V.removeListener(W,U),L=new f({onFirstListenerAdd:F,onLastListenerRemove:M});return L.event}w.fromNodeEventEmitter=R;function N(V,W,$=U=>U){const U=(...O)=>L.fire($(...O)),F=()=>V.addEventListener(W,U),M=()=>V.removeEventListener(W,U),L=new f({onFirstListenerAdd:F,onLastListenerRemove:M});return L.event}w.fromDOMEventEmitter=N;function q(V){const W=new f;let $=!1;return V.then(void 0,()=>null).then(()=>{$?W.fire(void 0):setTimeout(()=>W.fire(void 0),0)}),$=!0,W.event}w.fromPromise=q;function re(V){return new Promise(W=>S(V)(W))}w.toPromise=re})(P=e.Event||(e.Event={}));class D{constructor(S){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${S}_${D._idPool++}`}start(S){this._stopWatch=new y.StopWatch(!0),this._listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this._elapsedOverall+=S,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${S.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let k=-1;function r(w){const S=k;return k=w,{dispose(){k=S}}}e.setGlobalLeakWarningThreshold=r;class C{constructor(S,h=Math.random().toString(18).slice(2,5)){this.customThreshold=S,this.name=h,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(S){let h=k;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),!(h<=0||S<h)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),m=this._stacks.get(c)||0;if(this._stacks.set(c,m+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let t,n=0;for(const[o,i]of this._stacks)(!t||n<i)&&(t=o,n=i);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class f{constructor(S){var h;this._disposed=!1,this._options=S,this._leakageMon=k>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((h=this._options)===null||h===void 0?void 0:h._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(S,h,c)=>{var m;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(h?[S,h]:S);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,S,h);const o=(m=this._leakageMon)===null||m===void 0?void 0:m.check(this._listeners.size);let i;return i={dispose:()=>{o&&o(),i.dispose=f._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof A.DisposableStore?c.add(i):Array.isArray(c)&&c.push(i),i}),this._event}fire(S){var h,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let m of this._listeners)this._deliveryQueue.push([m,S]);for((h=this._perfMon)===null||h===void 0||h.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[m,t]=this._deliveryQueue.shift();try{typeof m=="function"?m.call(void 0,t):m[0].call(m[1],t)}catch(n){(0,_.onUnexpectedError)(n)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var S,h,c;(S=this._listeners)===null||S===void 0||S.clear(),(h=this._deliveryQueue)===null||h===void 0||h.clear(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=f,f._noop=function(){};class p extends f{constructor(S){super(S);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=S==null?void 0:S.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._listeners&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=p;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const h={event:S,listener:null};this.events.push(h),this.hasListeners&&this.hook(h);const c=()=>{this.hasListeners&&this.unhook(h);const m=this.events.indexOf(h);this.events.splice(m,1)};return(0,A.toDisposable)((0,I.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(h=>this.emitter.fire(h))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class u{constructor(){this.buffers=[]}wrapEvent(S){return(h,c,m)=>S(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>h.call(c,t)):h.call(c,t)},void 0,m)}bufferEvents(S){const h=[];this.buffers.push(h);const c=S();return this.buffers.pop(),h.forEach(m=>m()),c}}e.EventBufferer=u;class E{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=A.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(ge[21],pe([0,1,3]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(P,D){const k=setTimeout(P.bind(D),0);return{dispose(){clearTimeout(k)}}});var A;(function(P){function D(k){return k===P.None||k===P.Cancelled||k instanceof T?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}P.isCancellationToken=D,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(A=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=A.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=y}),define(ge[43],pe([0,1,3]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new _.Emitter}add(C){const f=this._icons.get(C.id);f?C.description?f.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new I;e.iconRegistry=A;function T(r,C){return new P(r,C)}e.registerCodicon=T;function y(r){return r?r.replace(/\$\((.*?)\)/g,(C,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=y;class P{constructor(C,f,p){this.id=C,this.definition=f,this.description=p,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function D(r,C){const f=["codicon","codicon-"+r];return C&&f.push("codicon-modifier-"+C),f}e.getClassNamesArray=D;var k;(function(r){r.iconNameSegment="[A-Za-z0-9]+",r.iconNameExpression="[A-Za-z0-9\\-]+",r.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${r.iconNameExpression})(${r.iconModifierExpression})?$`);function f(u){if(u instanceof P)return["codicon","codicon-"+u.id];const E=C.exec(u.id);if(!E)return f(P.error);let[,w,S]=E;const h=["codicon","codicon-"+w];return S&&h.push("codicon-modifier-"+S.substr(1)),h}r.asClassNameArray=f;function p(u){return f(u).join(" ")}r.asClassName=p;function a(u){return"."+f(u).join(".")}r.asCSSSelector=a})(k=e.CSSIcon||(e.CSSIcon={})),function(r){r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",{fontCharacter:"\\ea60"}),r.gistNew=new r("gist-new",{fontCharacter:"\\ea60"}),r.repoCreate=new r("repo-create",{fontCharacter:"\\ea60"}),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eb0a"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(ge[95],pe([0,1,16,6]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(h){const c=h;return c?[c.on,c.pause,c.resume,c.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=A;function T(h){const c=h;return c?A(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=T;function y(h,c){return new P(h,c)}e.newWriteableStream=y;class P{constructor(c,m){this.reducer=c,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){var m;if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof((m=this.options)===null||m===void 0?void 0:m.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(m=>m(c))}emitError(c){this.listeners.error.length===0?(0,_.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(m=>m(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,m){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(c,m){if(!this.state.destroyed){let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(m);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(h,c){const m=[];let t;for(;(t=h.read())!==null;)m.push(t);return c(m)}e.consumeReadable=D;function k(h,c,m){const t=[];let n;for(;(n=h.read())!==null&&t.length<m;)t.push(n);return n===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const o=n;return n=void 0,o}return h.read()}}}e.peekReadable=k;function r(h,c){return new Promise((m,t)=>{const n=[];C(h,{onData:o=>{c&&n.push(o)},onError:o=>{c?t(o):m(void 0)},onEnd:()=>{m(c?c(n):void 0)}})})}e.consumeStream=r;function C(h,c){h.on("error",m=>c.onError(m)),h.on("end",()=>c.onEnd()),h.on("data",m=>c.onData(m))}e.listenStream=C;function f(h,c){return new Promise((m,t)=>{const n=new I.DisposableStore,o=[],i=g=>{if(o.push(g),o.length>c)return n.dispose(),h.pause(),m({stream:h,buffer:o,ended:!1})},s=g=>t(g),l=()=>m({stream:h,buffer:o,ended:!0});n.add((0,I.toDisposable)(()=>h.removeListener("error",s))),h.on("error",s),n.add((0,I.toDisposable)(()=>h.removeListener("end",l))),h.on("end",l),n.add((0,I.toDisposable)(()=>h.removeListener("data",i))),h.on("data",i)})}e.peekStream=f;function p(h,c){const m=y(c);return m.end(h),m}e.toStream=p;function a(){const h=y(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=a;function u(h){let c=!1;return{read:()=>c?null:(c=!0,h)}}e.toReadable=u;function E(h,c,m){const t=y(m);return C(h,{onData:n=>t.write(c.data(n)),onError:n=>t.error(c.error?c.error(n):n),onEnd:()=>t.end()}),t}e.transform=E;function w(h,c,m){let t=!1;return{read:()=>{const n=c.read();return t?n:(t=!0,n!==null?m([h,n]):h)}}}e.prefixedReadable=w;function S(h,c,m){let t=!1;const n=y(m);return C(c,{onData:o=>t?n.write(o):(t=!0,n.write(m([h,o]))),onError:o=>n.error(o),onEnd:()=>{t||(t=!0,n.write(h)),n.end()}}),n}e.prefixedStream=S}),define(ge[9],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function _(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=_;const I=/{(\d+)}/g;function A(K,...se){return se.length===0?K:K.replace(I,function(he,J){const ne=parseInt(J,10);return isNaN(ne)||ne<0||ne>=se.length?he:se[ne]})}e.format=A;function T(K){return K.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=T;function y(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function P(K,se){let he=0;const J=se.charCodeAt(0);for(let ne=K.length-1;ne>=0;ne--)K.charCodeAt(ne)===J&&he++;return he}e.count=P;function D(K,se,he="\u2026"){return K.length<=se?K:`${K.substr(0,se)}${he}`}e.truncate=D;function k(K,se=" "){const he=r(K,se);return C(he,se)}e.trim=k;function r(K,se){if(!K||!se)return K;const he=se.length;if(he===0||K.length===0)return K;let J=0;for(;K.indexOf(se,J)===J;)J=J+he;return K.substring(J)}e.ltrim=r;function C(K,se){if(!K||!se)return K;const he=se.length,J=K.length;if(he===0||J===0)return K;let ne=J,ce=-1;for(;ce=K.lastIndexOf(se,ne-1),!(ce===-1||ce+he!==ne);){if(ce===0)return"";ne=ce}return K.substring(0,ne)}e.rtrim=C;function f(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function p(K){return K.replace(/\*/g,"")}e.stripWildcards=p;function a(K,se,he={}){if(!K)throw new Error("Cannot create regex from empty string");se||(K=y(K)),he.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let J="";return he.global&&(J+="g"),he.matchCase||(J+="i"),he.multiline&&(J+="m"),he.unicode&&(J+="u"),new RegExp(K,J)}e.createRegExp=a;function u(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function E(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function w(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=w;function S(K){return K.split(/\r\n|\r|\n/)}e.splitLines=S;function h(K){for(let se=0,he=K.length;se<he;se++){const J=K.charCodeAt(se);if(J!==32&&J!==9)return se}return-1}e.firstNonWhitespaceIndex=h;function c(K,se=0,he=K.length){for(let J=se;J<he;J++){const ne=K.charCodeAt(J);if(ne!==32&&ne!==9)return K.substring(se,J)}return K.substring(se,he)}e.getLeadingWhitespace=c;function m(K,se=K.length-1){for(let he=se;he>=0;he--){const J=K.charCodeAt(he);if(J!==32&&J!==9)return he}return-1}e.lastNonWhitespaceIndex=m;function t(K,se){return K<se?-1:K>se?1:0}e.compare=t;function n(K,se,he=0,J=K.length,ne=0,ce=se.length){for(;he<J&&ne<ce;he++,ne++){let je=K.charCodeAt(he),He=se.charCodeAt(ne);if(je<He)return-1;if(je>He)return 1}const ve=J-he,ye=ce-ne;return ve<ye?-1:ve>ye?1:0}e.compareSubstring=n;function o(K,se){return i(K,se,0,K.length,0,se.length)}e.compareIgnoreCase=o;function i(K,se,he=0,J=K.length,ne=0,ce=se.length){for(;he<J&&ne<ce;he++,ne++){let je=K.charCodeAt(he),He=se.charCodeAt(ne);if(je!==He){const We=je-He;if(!(We===32&&l(He))&&!(We===-32&&l(je)))return s(je)&&s(He)?We:n(K.toLowerCase(),se.toLowerCase(),he,J,ne,ce)}}const ve=J-he,ye=ce-ne;return ve<ye?-1:ve>ye?1:0}e.compareSubstringIgnoreCase=i;function s(K){return K>=97&&K<=122}e.isLowerAsciiLetter=s;function l(K){return K>=65&&K<=90}e.isUpperAsciiLetter=l;function g(K){return s(K)||l(K)}function v(K,se){return K.length===se.length&&d(K,se)}e.equalsIgnoreCase=v;function d(K,se,he=K.length){for(let J=0;J<he;J++){const ne=K.charCodeAt(J),ce=se.charCodeAt(J);if(ne!==ce){if(g(ne)&&g(ce)){const ve=Math.abs(ne-ce);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(ne).toLowerCase()!==String.fromCharCode(ce).toLowerCase())return!1}}return!0}function b(K,se){const he=se.length;return se.length>K.length?!1:d(K,se,he)}e.startsWithIgnoreCase=b;function R(K,se){let he,J=Math.min(K.length,se.length);for(he=0;he<J;he++)if(K.charCodeAt(he)!==se.charCodeAt(he))return he;return J}e.commonPrefixLength=R;function N(K,se){let he,J=Math.min(K.length,se.length);const ne=K.length-1,ce=se.length-1;for(he=0;he<J;he++)if(K.charCodeAt(ne-he)!==se.charCodeAt(ce-he))return he;return J}e.commonSuffixLength=N;function q(K){return 55296<=K&&K<=56319}e.isHighSurrogate=q;function re(K){return 56320<=K&&K<=57343}e.isLowSurrogate=re;function V(K,se){return(K-55296<<10)+(se-56320)+65536}e.computeCodePoint=V;function W(K,se,he){const J=K.charCodeAt(he);if(q(J)&&he+1<se){const ne=K.charCodeAt(he+1);if(re(ne))return V(J,ne)}return J}e.getNextCodePoint=W;function $(K,se){const he=K.charCodeAt(se-1);if(re(he)&&se>1){const J=K.charCodeAt(se-2);if(q(J))return V(J,he)}return he}function U(K,se){const he=$e.getInstance(),J=se,ne=K.length,ce=W(K,ne,se);se+=ce>=65536?2:1;let ve=he.getGraphemeBreakType(ce);for(;se<ne;){const ye=W(K,ne,se),je=he.getGraphemeBreakType(ye);if(Ne(ve,je))break;se+=ye>=65536?2:1,ve=je}return se-J}e.nextCharLength=U;function F(K,se){const he=$e.getInstance(),J=se,ne=$(K,se);se-=ne>=65536?2:1;let ce=he.getGraphemeBreakType(ne);for(;se>0;){const ve=$(K,se),ye=he.getGraphemeBreakType(ve);if(Ne(ye,ce))break;se-=ve>=65536?2:1,ce=ye}return J-se}e.prevCharLength=F;function M(K,se){const he=$e.getInstance(),J=K.length,ne=se,ce=W(K,J,se),ve=he.getGraphemeBreakType(ce);se+=ce>=65536?2:1;let ye=ve;for(;se<J;){const He=W(K,J,se),We=he.getGraphemeBreakType(He);if(Ne(ye,We))break;se+=He>=65536?2:1,ye=We}const je=se;for(se=ne,ye=ve;se>0;){const He=$(K,se),We=he.getGraphemeBreakType(He);if(Ne(We,ye))break;se-=He>=65536?2:1,ye=We}return[se,je]}function L(K,se){return se>0&&re(K.charCodeAt(se))?M(K,se-1):M(K,se)}e.getCharContainingOffset=L;function O(K){const se=K.length;let he=0,J=0;for(;J<se;){const ve=W(K,se,J);J+=ve>=65536?2:1,ve<128?he+=1:ve<2048?he+=2:ve<65536?he+=3:he+=4}const ne=new Uint8Array(he);J=0;let ce=0;for(;J<se;){const ve=W(K,se,J);J+=ve>=65536?2:1,ve<128?ne[ce++]=ve:ve<2048?(ne[ce++]=192|(ve&1984)>>>6,ne[ce++]=128|(ve&63)>>>0):ve<65536?(ne[ce++]=224|(ve&61440)>>>12,ne[ce++]=128|(ve&4032)>>>6,ne[ce++]=128|(ve&63)>>>0):(ne[ce++]=240|(ve&1835008)>>>18,ne[ce++]=128|(ve&258048)>>>12,ne[ce++]=128|(ve&4032)>>>6,ne[ce++]=128|(ve&63)>>>0)}return ne}e.encodeUTF8=O;function B(K){const se=K.byteLength,he=[];let J=0;for(;J<se;){const ne=K[J];let ce;if(ne>=240&&J+3<se?ce=(K[J++]&7)<<18>>>0|(K[J++]&63)<<12>>>0|(K[J++]&63)<<6>>>0|(K[J++]&63)<<0>>>0:ne>=224&&J+2<se?ce=(K[J++]&15)<<12>>>0|(K[J++]&63)<<6>>>0|(K[J++]&63)<<0>>>0:ne>=192&&J+1<se?ce=(K[J++]&31)<<6>>>0|(K[J++]&63)<<0>>>0:ce=K[J++],ce>=0&&ce<=55295||ce>=57344&&ce<=65535)he.push(String.fromCharCode(ce));else if(ce>=65536&&ce<=1114111){const ve=ce-65536,ye=55296+((ve&1047552)>>>10),je=56320+((ve&1023)>>>0);he.push(String.fromCharCode(ye)),he.push(String.fromCharCode(je))}else he.push(String.fromCharCode(65533))}return he.join("")}e.decodeUTF8=B;const j=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(K){return j.test(K)}e.containsRTL=Q;const de=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function be(K){return de.test(K)}e.containsEmoji=be;const Ae=/^[\t\n\r\x20-\x7E]*$/;function Ce(K){return Ae.test(K)}e.isBasicASCII=Ce,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Le;function z(K){for(let se=0,he=K.length;se<he;se++)if(Y(K.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=z;function Y(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=Y;function ee(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=ee;function ae(K,se){if(K.length<se)return K;const he=/\b/g;let J=0;for(;he.test(K)&&!(K.length-he.lastIndex<se);)J=he.lastIndex,he.lastIndex+=1;return K.substring(J).replace(/^\s/,"")}e.lcut=ae;const me=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function we(K){return K&&(K=K.replace(me,""),K=K.replace(De,""),K=K.replace(Oe,"")),K}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Pe(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Pe;function Re(K){return Pe(K)?K.substr(1):K}e.stripUTF8BOM=Re;function Be(K,se){if(!K||!se||K.length<se.length)return!1;const he=se.length,J=K.toLowerCase();let ne=0,ce=-1;for(;ne<he;){const ve=J.indexOf(se[ne],ce+1);if(ve<0)return!1;ce=ve,ne++}return!0}e.fuzzyContains=Be;function Se(K,se=!1){return K?(se&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Se;function qe(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=qe;function X(K,se=1){if(se===0)return"";let he=-1;do he=K.indexOf(`
`,he+1),se--;while(se>0&&he>=0);return he===-1?K:(K[he-1]==="\r"&&he--,K.substr(0,he))}e.getNLines=X;function ie(K){const se=90-65+1;return K=K%(2*se),K<se?String.fromCharCode(97+K):String.fromCharCode(65+K-se)}e.singleLetterHash=ie;function _e(K){return $e.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=_e;function Ne(K,se){return K===0?se!==5&&se!==7:K===2&&se===3?!1:K===4||K===2||K===3||se===4||se===2||se===3?!0:!(K===8&&(se===8||se===9||se===11||se===12)||(K===11||K===9)&&(se===9||se===10)||(K===12||K===10)&&se===10||se===5||se===13||se===7||K===1||K===13&&se===14||K===6&&se===6)}e.breakBetweenGraphemeBreakType=Ne;var ze;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Je()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const he=this._data,J=he.length/3;let ne=1;for(;ne<=J;)if(se<he[3*ne])ne=2*ne;else if(se>he[3*ne+1])ne=2*ne+1;else return he[3*ne+2];return 0}}$e._INSTANCE=null;function Je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ge[22],pe([0,1,9,95]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let P,D;class k{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return A?new k(Buffer.allocUnsafe(g)):new k(new Uint8Array(g))}static wrap(g){return A&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new k(g)}static fromString(g,v){return!((v==null?void 0:v.dontUseNodeBuffer)||!1)&&A?new k(Buffer.from(g)):T?(P||(P=new TextEncoder),new k(P.encode(g))):new k(_.encodeUTF8(g))}static concat(g,v){if(typeof v=="undefined"){v=0;for(let R=0,N=g.length;R<N;R++)v+=g[R].byteLength}const d=k.alloc(v);let b=0;for(let R=0,N=g.length;R<N;R++){const q=g[R];d.set(q,b),b+=q.byteLength}return d}toString(){return A?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):_.decodeUTF8(this.buffer)}slice(g,v){return new k(this.buffer.subarray(g,v))}set(g,v){g instanceof k?this.buffer.set(g.buffer,v):this.buffer.set(g,v)}readUInt32BE(g){return f(this.buffer,g)}writeUInt32BE(g,v){p(this.buffer,g,v)}readUInt32LE(g){return a(this.buffer,g)}writeUInt32LE(g,v){u(this.buffer,g,v)}readUInt8(g){return E(this.buffer,g)}writeUInt8(g,v){w(this.buffer,g,v)}}e.VSBuffer=k;function r(l,g){return l[g+0]<<0>>>0|l[g+1]<<8>>>0}e.readUInt16LE=r;function C(l,g,v){l[v+0]=g&255,g=g>>>8,l[v+1]=g&255}e.writeUInt16LE=C;function f(l,g){return l[g]*2**24+l[g+1]*2**16+l[g+2]*2**8+l[g+3]}e.readUInt32BE=f;function p(l,g,v){l[v+3]=g,g=g>>>8,l[v+2]=g,g=g>>>8,l[v+1]=g,g=g>>>8,l[v]=g}e.writeUInt32BE=p;function a(l,g){return l[g+0]<<0>>>0|l[g+1]<<8>>>0|l[g+2]<<16>>>0|l[g+3]<<24>>>0}e.readUInt32LE=a;function u(l,g,v){l[v+0]=g&255,g=g>>>8,l[v+1]=g&255,g=g>>>8,l[v+2]=g&255,g=g>>>8,l[v+3]=g&255}e.writeUInt32LE=u;function E(l,g){return l[g]}e.readUInt8=E;function w(l,g,v){l[v]=g}e.writeUInt8=w;function S(l){return I.consumeReadable(l,g=>k.concat(g))}e.readableToBuffer=S;function h(l){return I.toReadable(l)}e.bufferToReadable=h;function c(l){return I.consumeStream(l,g=>k.concat(g))}e.streamToBuffer=c;async function m(l){return l.ended?k.concat(l.buffer):k.concat([...l.buffer,await c(l.stream)])}e.bufferedStreamToBuffer=m;function t(l){return I.toStream(l,g=>k.concat(g))}e.bufferToStream=t;function n(l){return I.transform(l,{data:g=>typeof g=="string"?k.fromString(g):k.wrap(g)},g=>k.concat(g))}e.streamToBufferReadableStream=n;function o(l){return I.newWriteableStream(g=>k.concat(g),l)}e.newWriteableBufferStream=o;function i(l,g){return I.prefixedReadable(l,g,v=>k.concat(v))}e.prefixedBufferReadable=i;function s(l,g){return I.prefixedStream(l,g,v=>k.concat(v))}e.prefixedBufferStream=s}),define(ge[74],pe([0,1,9]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(w){return A(w,0)}e.hash=I;function A(w,S){switch(typeof w){case"object":return w===null?T(349,S):Array.isArray(w)?D(w,S):k(w,S);case"string":return P(w,S);case"boolean":return y(w,S);case"number":return T(w,S);case"undefined":return T(937,S);default:return T(617,S)}}e.doHash=A;function T(w,S){return(S<<5)-S+w|0}function y(w,S){return T(w?433:863,S)}function P(w,S){S=T(149417,S);for(let h=0,c=w.length;h<c;h++)S=T(w.charCodeAt(h),S);return S}e.stringHash=P;function D(w,S){return S=T(104579,S),w.reduce((h,c)=>A(c,h),S)}function k(w,S){return S=T(181387,S),Object.keys(w).sort().reduce((h,c)=>(h=P(c,h),A(w[c],h)),S)}class r{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=A(S,this._value),this._value}}e.Hasher=r;var C;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function f(w,S,h=32){const c=h-S,m=~((1<<c)-1);return(w<<S|(m&w)>>>c)>>>0}function p(w,S=0,h=w.byteLength,c=0){for(let m=0;m<h;m++)w[S+m]=c}function a(w,S,h="0"){for(;w.length<S;)w=h+w;return w}function u(w,S=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(h=>h.toString(16).padStart(2,"0")).join(""):a((w>>>0).toString(16),S/4)}e.toHexString=u;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const h=S.length;if(h!==0){const c=this._buff;let m=this._buffLen,t=this._leftoverHighSurrogate,n,o;for(t!==0?(n=t,o=-1,t=0):(n=S.charCodeAt(0),o=0);;){let i=n;if(_.isHighSurrogate(n))if(o+1<h){const s=S.charCodeAt(o+1);_.isLowSurrogate(s)?(o++,i=_.computeCodePoint(n,s)):i=65533}else{t=n;break}else _.isLowSurrogate(n)&&(i=65533);if(m=this._push(c,m,i),o++,o<h)n=S.charCodeAt(o);else break}this._buffLen=m,this._leftoverHighSurrogate=t}}_push(S,h,c){return c<128?S[h++]=c:c<2048?(S[h++]=192|(c&1984)>>>6,S[h++]=128|(c&63)>>>0):c<65536?(S[h++]=224|(c&61440)>>>12,S[h++]=128|(c&4032)>>>6,S[h++]=128|(c&63)>>>0):(S[h++]=240|(c&1835008)>>>18,S[h++]=128|(c&258048)>>>12,S[h++]=128|(c&4032)>>>6,S[h++]=128|(c&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=E._bigBlock32,h=this._buffDV;for(let g=0;g<64;g+=4)S.setUint32(g,h.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)S.setUint32(g,f(S.getUint32(g-12,!1)^S.getUint32(g-32,!1)^S.getUint32(g-56,!1)^S.getUint32(g-64,!1),1),!1);let c=this._h0,m=this._h1,t=this._h2,n=this._h3,o=this._h4,i,s,l;for(let g=0;g<80;g++)g<20?(i=m&t|~m&n,s=1518500249):g<40?(i=m^t^n,s=1859775393):g<60?(i=m&t|m&n|t&n,s=2400959708):(i=m^t^n,s=3395469782),l=f(c,5)+i+o+s+S.getUint32(g*4,!1)&4294967295,o=n,n=t,t=f(m,30),m=c,c=l;this._h0=this._h0+c&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[57],pe([0,1,9]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(I||(I={})),function(A){const T="error",y="warning",P="warn",D="info",k="ignore";function r(f){return f?_.equalsIgnoreCase(T,f)?A.Error:_.equalsIgnoreCase(y,f)||_.equalsIgnoreCase(P,f)?A.Warning:_.equalsIgnoreCase(D,f)?A.Info:A.Ignore:A.Ignore}A.fromValue=r;function C(f){switch(f){case A.Error:return T;case A.Warning:return y;case A.Info:return D;default:return k}}A.toString=C}(I||(I={})),e.default=I}),define(ge[11],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(g){return Array.isArray(g)}e.isArray=_;function I(g){return typeof g=="string"}e.isString=I;function A(g){return Array.isArray(g)&&g.every(v=>I(v))}e.isStringArray=A;function T(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.isObject=T;function y(g){return typeof g=="number"&&!isNaN(g)}e.isNumber=y;function P(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.isIterable=P;function D(g){return g===!0||g===!1}e.isBoolean=D;function k(g){return typeof g=="undefined"}e.isUndefined=k;function r(g){return!C(g)}e.isDefined=r;function C(g){return k(g)||g===null}e.isUndefinedOrNull=C;function f(g,v){if(!g)throw new Error(v?`Unexpected type, expected '${v}'`:"Unexpected type")}e.assertType=f;function p(g){if(C(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.assertIsDefined=p;function a(...g){const v=[];for(let d=0;d<g.length;d++){const b=g[d];if(C(b))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);v.push(b)}return v}e.assertAllDefined=a;const u=Object.prototype.hasOwnProperty;function E(g){if(!T(g))return!1;for(let v in g)if(u.call(g,v))return!1;return!0}e.isEmptyObject=E;function w(g){return typeof g=="function"}e.isFunction=w;function S(...g){return g.length>0&&g.every(w)}e.areFunctions=S;function h(g,v){const d=Math.min(g.length,v.length);for(let b=0;b<d;b++)c(g[b],v[b])}e.validateConstraints=h;function c(g,v){if(I(v)){if(typeof g!==v)throw new Error(`argument does not match constraint: typeof ${v}`)}else if(w(v)){try{if(g instanceof v)return}catch(d){}if(!C(g)&&g.constructor===v||v.length===1&&v.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function m(g){let v=[],d=Object.getPrototypeOf(g);for(;Object.prototype!==d;)v=v.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return v}e.getAllPropertyNames=m;function t(g){const v=[];for(const d of m(g))typeof g[d]=="function"&&v.push(d);return v}e.getAllMethodNames=t;function n(g,v){const d=R=>function(){const N=Array.prototype.slice.call(arguments,0);return v(R,N)};let b={};for(const R of g)b[R]=d(R);return b}e.createProxyObject=n;function o(g){return g===null?void 0:g}e.withNullAsUndefined=o;function i(g){return typeof g=="undefined"?null:g}e.withUndefinedAsNull=i;function s(g){return class{constructor(){return new Proxy({},{get(v,d){if(v[d])return v[d];throw new Error(`Not Implemented: ${g}->${String(d)}`)}})}}}e.NotImplementedProxy=s;function l(g){throw new Error("Unreachable")}e.assertNever=l}),define(ge[29],pe([0,1,10,9,8,11]),function(G,e,_,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function P(n){return n.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=P;function D(n,o=A.posix.sep){if(!n)return"";const i=n.length,s=n.charCodeAt(0);if(y(s)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let g=3;const v=g;for(;g<i&&!y(n.charCodeAt(g));g++);if(v!==g&&!y(n.charCodeAt(g+1))){for(g+=1;g<i;g++)if(y(n.charCodeAt(g)))return n.slice(0,g+1).replace(/[\\/]/g,o)}}return o}else if(E(s)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+o:n.slice(0,2);let l=n.indexOf("://");if(l!==-1){for(l+=3;l<i;l++)if(y(n.charCodeAt(l)))return n.slice(0,l+1)}return""}e.getRoot=D;function k(n){if(!_.isWindows||!n||n.length<5)return!1;let o=n.charCodeAt(0);if(o!==92||(o=n.charCodeAt(1),o!==92))return!1;let i=2;const s=i;for(;i<n.length&&(o=n.charCodeAt(i),o!==92);i++);return!(s===i||(o=n.charCodeAt(i+1),isNaN(o)||o===92))}e.isUNC=k;const r=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(n,o=_.isWindows){const i=o?r:C;return!(!n||n.length===0||/^\s+$/.test(n)||(i.lastIndex=0,i.test(n))||o&&f.test(n)||n==="."||n===".."||o&&n[n.length-1]==="."||o&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=p;function a(n,o,i){const s=n===o;return!i||s?s:!n||!o?!1:(0,I.equalsIgnoreCase)(n,o)}e.isEqual=a;function u(n,o,i,s=A.sep){if(n===o)return!0;if(!n||!o||o.length>n.length)return!1;if(i){if(!(0,I.startsWithIgnoreCase)(n,o))return!1;if(o.length===n.length)return!0;let g=o.length;return o.charAt(o.length-1)===s&&g--,n.charAt(g)===s}return o.charAt(o.length-1)!==s&&(o+=s),n.indexOf(o)===0}e.isEqualOrParent=u;function E(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=E;function w(n,o){return _.isWindows&&n.endsWith(":")&&(n+=A.sep),(0,A.isAbsolute)(n)||(n=(0,A.join)(o,n)),n=(0,A.normalize)(n),_.isWindows?(n=(0,I.rtrim)(n,A.sep),n.endsWith(":")&&(n+=A.sep)):(n=(0,I.rtrim)(n,A.sep),n||(n=A.sep)),n}e.sanitizeFilePath=w;function S(n){const o=(0,A.normalize)(n);return _.isWindows?n.length>3?!1:h(o)&&(n.length===2||o.charCodeAt(2)===92):o===A.posix.sep}e.isRootOrDriveLetter=S;function h(n){return _.isWindows?E(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function c(n){return h(n)?n[0]:void 0}e.getDriveLetter=c;function m(n,o,i){return o.length>n.length?-1:n===o?0:(i&&(n=n.toLowerCase(),o=o.toLowerCase()),n.indexOf(o))}e.indexOfPath=m;function t(n){const o=n.split(":");let i,s,l;if(o.forEach(g=>{const v=Number(g);(0,T.isNumber)(v)?s===void 0?s=v:l===void 0&&(l=v):i=i?[i,g].join(":"):g}),!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:s!==void 0?s:void 0,column:l!==void 0?l:s!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ge[23],pe([0,1,11]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const u=Array.isArray(a)?[]:{};return Object.keys(a).forEach(E=>{a[E]&&typeof a[E]=="object"?u[E]=I(a[E]):u[E]=a[E]}),u}e.deepClone=I;function A(a){if(!a||typeof a!="object")return a;const u=[a];for(;u.length>0;){const E=u.shift();Object.freeze(E);for(const w in E)if(T.call(E,w)){const S=E[w];typeof S=="object"&&!Object.isFrozen(S)&&u.push(S)}}return a}e.deepFreeze=A;const T=Object.prototype.hasOwnProperty;function y(a,u){return P(a,u,new Set)}e.cloneAndChange=y;function P(a,u,E){if((0,_.isUndefinedOrNull)(a))return a;const w=u(a);if(typeof w!="undefined")return w;if((0,_.isArray)(a)){const S=[];for(const h of a)S.push(P(h,u,E));return S}if((0,_.isObject)(a)){if(E.has(a))throw new Error("Cannot clone recursive data-structure");E.add(a);const S={};for(let h in a)T.call(a,h)&&(S[h]=P(a[h],u,E));return E.delete(a),S}return a}function D(a,u,E=!0){return(0,_.isObject)(a)?((0,_.isObject)(u)&&Object.keys(u).forEach(w=>{w in a?E&&((0,_.isObject)(a[w])&&(0,_.isObject)(u[w])?D(a[w],u[w],E):a[w]=u[w]):a[w]=u[w]}),a):u}e.mixin=D;function k(a,u){if(a===u)return!0;if(a==null||u===null||u===void 0||typeof a!=typeof u||typeof a!="object"||Array.isArray(a)!==Array.isArray(u))return!1;let E,w;if(Array.isArray(a)){if(a.length!==u.length)return!1;for(E=0;E<a.length;E++)if(!k(a[E],u[E]))return!1}else{const S=[];for(w in a)S.push(w);S.sort();const h=[];for(w in u)h.push(w);if(h.sort(),!k(S,h))return!1;for(E=0;E<S.length;E++)if(!k(a[S[E]],u[S[E]]))return!1}return!0}e.equals=k;function r(a){const u=new Set;return JSON.stringify(a,(E,w)=>{if((0,_.isObject)(w)||Array.isArray(w)){if(u.has(w))return"[Circular]";u.add(w)}return w})}e.safeStringify=r;function C(a,u,E){const w=u(a);return typeof w=="undefined"?E:w}e.getOrDefault=C;function f(a,u){const E=Object.create(null);return!a||!u||Object.keys(u).forEach(S=>{const h=a[S],c=u[S];k(h,c)||(E[S]=c)}),E}e.distinct=f;function p(a,u){const E=u.toLowerCase(),w=Object.keys(a).find(S=>S.toLowerCase()===E);return w?a[w]:a[u]}e.getCaseInsensitive=p}),define(ge[96],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_=e.Constants||(e.Constants={}));function I(T){return T<0?0:T>255?255:T|0}e.toUint8=I;function A(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=A}),define(ge[2],pe([0,1,10,8]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,T=/^\//,y=/^\/\//;function P(o,i){if(!o.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!A.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!T.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(o,i){return!o&&!i?"file":o}function k(o,i){switch(o){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const r="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(i,s,l,g,v,d=!1){typeof i=="object"?(this.scheme=i.scheme||r,this.authority=i.authority||r,this.path=i.path||r,this.query=i.query||r,this.fragment=i.fragment||r):(this.scheme=D(i,d),this.authority=s||r,this.path=k(this.scheme,l||r),this.query=g||r,this.fragment=v||r,P(this,d))}static isUri(i){return i instanceof p?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return h(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:l,path:g,query:v,fragment:d}=i;return s===void 0?s=this.scheme:s===null&&(s=r),l===void 0?l=this.authority:l===null&&(l=r),g===void 0?g=this.path:g===null&&(g=r),v===void 0?v=this.query:v===null&&(v=r),d===void 0?d=this.fragment:d===null&&(d=r),s===this.scheme&&l===this.authority&&g===this.path&&v===this.query&&d===this.fragment?this:new u(s,l,g,v,d)}static parse(i,s=!1){const l=f.exec(i);return l?new u(l[2]||r,n(l[4]||r),n(l[5]||r),n(l[7]||r),n(l[9]||r),s):new u(r,r,r,r,r)}static file(i){let s=r;if(_.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const l=i.indexOf(C,2);l===-1?(s=i.substring(2),i=C):(s=i.substring(2,l),i=i.substring(l)||C)}return new u("file",s,i,r,r)}static from(i){return new u(i.scheme,i.authority,i.path,i.query,i.fragment)}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return _.isWindows&&i.scheme==="file"?l=p.file(I.win32.join(h(i,!0),...s)).path:l=I.posix.join(i.path,...s),i.with({path:l})}toString(i=!1){return c(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof p)return i;{const s=new u(i);return s._formatted=i.external,s._fsPath=i._sep===a?i.fsPath:null,s}}else return i}}e.URI=p;const a=_.isWindows?1:void 0;class u extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(i=!1){return i?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=a),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(o,i){let s,l=-1;for(let g=0;g<o.length;g++){const v=o.charCodeAt(g);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||i&&v===47)l!==-1&&(s+=encodeURIComponent(o.substring(l,g)),l=-1),s!==void 0&&(s+=o.charAt(g));else{s===void 0&&(s=o.substr(0,g));const d=E[v];d!==void 0?(l!==-1&&(s+=encodeURIComponent(o.substring(l,g)),l=-1),s+=d):l===-1&&(l=g)}}return l!==-1&&(s+=encodeURIComponent(o.substring(l))),s!==void 0?s:o}function S(o){let i;for(let s=0;s<o.length;s++){const l=o.charCodeAt(s);l===35||l===63?(i===void 0&&(i=o.substr(0,s)),i+=E[l]):i!==void 0&&(i+=o[s])}return i!==void 0?i:o}function h(o,i){let s;return o.authority&&o.path.length>1&&o.scheme==="file"?s=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?i?s=o.path.substr(1):s=o.path[1].toLowerCase()+o.path.substr(2):s=o.path,_.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=h;function c(o,i){const s=i?S:w;let l="",{scheme:g,authority:v,path:d,query:b,fragment:R}=o;if(g&&(l+=g,l+=":"),(v||g==="file")&&(l+=C,l+=C),v){let N=v.indexOf("@");if(N!==-1){const q=v.substr(0,N);v=v.substr(N+1),N=q.indexOf(":"),N===-1?l+=s(q,!1):(l+=s(q.substr(0,N),!1),l+=":",l+=s(q.substr(N+1),!1)),l+="@"}v=v.toLowerCase(),N=v.indexOf(":"),N===-1?l+=s(v,!1):(l+=s(v.substr(0,N),!1),l+=v.substr(N))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const N=d.charCodeAt(1);N>=65&&N<=90&&(d=`/${String.fromCharCode(N+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const N=d.charCodeAt(0);N>=65&&N<=90&&(d=`${String.fromCharCode(N+32)}:${d.substr(2)}`)}l+=s(d,!0)}return b&&(l+="?",l+=s(b,!1)),R&&(l+="#",l+=i?R:w(R,!1)),l}function m(o){try{return decodeURIComponent(o)}catch(i){return o.length>3?o.substr(0,3)+m(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(o){return o.match(t)?o.replace(t,i=>m(i)):o}});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[24],pe([0,1,2,9]),function(G,e,_,I){"use strict";var A,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,n,o){let i=t.get(n);return i===void 0&&(i=o,t.set(n,i)),i}e.getOrSet=P;function D(t){const n=[];return t.forEach((o,i)=>{n.push(`${i} => ${o}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function k(t){const n=[];return t.forEach(o=>{n.push(o)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=k;class r{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),i=this._value.charCodeAt(this._pos);return o-i}value(){return this._value[this._pos]}}e.StringIterator=r;class C{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class f{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var p;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(p||(p={}));class a{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,I.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class u{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(n){this._iter=n}static forUris(n=()=>!1){return new E(new a(n))}static forPaths(){return new E(new f)}static forStrings(){return new E(new r)}static forConfigKeys(){return new E(new C)}clear(){this._root=void 0}set(n,o){const i=this._iter.reset(n);let s;for(this._root||(this._root=new u,this._root.segment=i.value()),s=this._root;;){const g=i.cmp(s.segment);if(g>0)s.left||(s.left=new u,s.left.segment=i.value()),s=s.left;else if(g<0)s.right||(s.right=new u,s.right.segment=i.value()),s=s.right;else if(i.hasNext())i.next(),s.mid||(s.mid=new u,s.mid.segment=i.value()),s=s.mid;else break}const l=s.value;return s.value=o,s.key=n,l}get(n){var o;return(o=this._getNode(n))===null||o===void 0?void 0:o.value}_getNode(n){const o=this._iter.reset(n);let i=this._root;for(;i;){const s=o.cmp(i.segment);if(s>0)i=i.left;else if(s<0)i=i.right;else if(o.hasNext())o.next(),i=i.mid;else break}return i}has(n){const o=this._getNode(n);return!((o==null?void 0:o.value)===void 0&&(o==null?void 0:o.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const i=this._iter.reset(n),s=[];let l=this._root;for(;l;){const g=i.cmp(l.segment);if(g>0)s.push([1,l]),l=l.left;else if(g<0)s.push([-1,l]),l=l.right;else if(i.hasNext())i.next(),s.push([0,l]),l=l.mid;else{for(o?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;s.length>0&&l.isEmpty();){let[v,d]=s.pop();switch(v){case 1:d.left=void 0;break;case 0:d.mid=void 0;break;case-1:d.right=void 0;break}l=d}break}}}findSubstr(n){const o=this._iter.reset(n);let i=this._root,s;for(;i;){const l=o.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(o.hasNext())o.next(),s=i.value||s,i=i.mid;else break}return i&&i.value||s}findSuperstr(n){const o=this._iter.reset(n);let i=this._root;for(;i;){const s=o.cmp(i.segment);if(s>0)i=i.left;else if(s<0)i=i.right;else if(o.hasNext())o.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(n){for(const[o,i]of this)n(i,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=E;class w{constructor(n,o){this[A]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=o!=null?o:w.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:w.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),o),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(let[i,s]of this.map)n(s,_.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield _.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[_.URI.parse(n[0]),n[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[_.URI.parse(n[0]),n[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var S;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class h{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,o=0){const i=this._map.get(n);if(!!i)return o!==0&&this.touch(i,o),i.value}set(n,o,i=0){let s=this._map.get(n);if(s)s.value=o,i!==0&&this.touch(s,i);else{switch(s={key:n,value:o,next:void 0,previous:void 0},i){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(n,s),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,o){const i=this._state;let s=this._head;for(;s;){if(o?n.bind(o)(s.value,s.key,this):n(s.value,s.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const n=this,o=this._state;let i=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const l={value:i.key,done:!1};return i=i.next,l}else return{value:void 0,done:!0}}};return s}values(){const n=this,o=this._state;let i=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const l={value:i.value,done:!1};return i=i.next,l}else return{value:void 0,done:!0}}};return s}entries(){const n=this,o=this._state;let i=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const l={value:[i.key,i.value],done:!1};return i=i.next,l}else return{value:void 0,done:!0}}};return s}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let o=this._head,i=this.size;for(;o&&i>n;)this._map.delete(o.key),o=o.next,i--;this._head=o,this._size=i,o&&(o.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,i=n.previous;if(!o||!i)throw new Error("Invalid list");o.previous=i,i.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const i=n.next,s=n.previous;n===this._tail?(s.next=void 0,this._tail=s):(i.previous=s,s.next=i),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const i=n.next,s=n.previous;n===this._head?(i.previous=void 0,this._head=i):(i.previous=s,s.next=i),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,i)=>{n.push([i,o])}),n}fromJSON(n){this.clear();for(const[o,i]of n)this.set(o,i)}}e.LinkedMap=h;class c extends h{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class m{constructor(n){y.set(this,void 0),tt(this,y,n,"f")}get size(){return Ue(this,y,"f").size}forEach(n,o){Ue(this,y,"f").forEach(n,o)}get(n){return Ue(this,y,"f").get(n)}has(n){return Ue(this,y,"f").has(n)}entries(){return Ue(this,y,"f").entries()}keys(){return Ue(this,y,"f").keys()}values(){return Ue(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Ue(this,y,"f").entries()}}e.ReadonlyMapView=m}),define(ge[97],pe([0,1,24,9]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...we){return function(Pe,Re){for(let Be=0,Se=we.length;Be<Se;Be++){const qe=we[Be](Pe,Re);if(qe)return qe}return null}}e.or=A,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(we,Pe,Re){if(!Re||Re.length<Pe.length)return null;let Be;return we?Be=I.startsWithIgnoreCase(Re,Pe):Be=Re.indexOf(Pe)===0,Be?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function y(we,Pe){const Re=Pe.toLowerCase().indexOf(we.toLowerCase());return Re===-1?null:[{start:Re,end:Re+we.length}]}e.matchesContiguousSubString=y;function P(we,Pe){return D(we.toLowerCase(),Pe.toLowerCase(),0,0)}e.matchesSubString=P;function D(we,Pe,Re,Be){if(Re===we.length)return[];if(Be===Pe.length)return null;if(we[Re]===Pe[Be]){let Se=null;return(Se=D(we,Pe,Re+1,Be+1))?w({start:Be,end:Be+1},Se):null}return D(we,Pe,Re,Be+1)}function k(we){return 97<=we&&we<=122}function r(we){return 65<=we&&we<=90}e.isUpper=r;function C(we){return 48<=we&&we<=57}function f(we){return we===32||we===9||we===10||we===13}const p=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(we=>p.add(we.charCodeAt(0)));function a(we){return f(we)||p.has(we)}function u(we,Pe){return we===Pe||a(we)&&a(Pe)}function E(we){return k(we)||r(we)||C(we)}function w(we,Pe){return Pe.length===0?Pe=[we]:we.end===Pe[0].start?Pe[0].start=we.start:Pe.unshift(we),Pe}function S(we,Pe){for(let Re=Pe;Re<we.length;Re++){const Be=we.charCodeAt(Re);if(r(Be)||C(Be)||Re>0&&!E(we.charCodeAt(Re-1)))return Re}return we.length}function h(we,Pe,Re,Be){if(Re===we.length)return[];if(Be===Pe.length)return null;if(we[Re]!==Pe[Be].toLowerCase())return null;{let Se=null,qe=Be+1;for(Se=h(we,Pe,Re+1,Be+1);!Se&&(qe=S(Pe,qe))<Pe.length;)Se=h(we,Pe,Re+1,qe),qe++;return Se===null?null:w({start:Be,end:Be+1},Se)}}function c(we){let Pe=0,Re=0,Be=0,Se=0,qe=0;for(let ze=0;ze<we.length;ze++)qe=we.charCodeAt(ze),r(qe)&&Pe++,k(qe)&&Re++,E(qe)&&Be++,C(qe)&&Se++;const X=Pe/we.length,ie=Re/we.length,_e=Be/we.length,Ne=Se/we.length;return{upperPercent:X,lowerPercent:ie,alphaPercent:_e,numericPercent:Ne}}function m(we){const{upperPercent:Pe,lowerPercent:Re}=we;return Re===0&&Pe>.6}function t(we){const{upperPercent:Pe,lowerPercent:Re,alphaPercent:Be,numericPercent:Se}=we;return Re>.2&&Pe<.8&&Be>.6&&Se<.2}function n(we){let Pe=0,Re=0,Be=0,Se=0;for(let qe=0;qe<we.length;qe++)Be=we.charCodeAt(qe),r(Be)&&Pe++,k(Be)&&Re++,f(Be)&&Se++;return(Pe===0||Re===0)&&Se===0?we.length<=30:Pe<=5}function o(we,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!n(we)||Pe.length>60)return null;const Re=c(Pe);if(!t(Re)){if(!m(Re))return null;Pe=Pe.toLowerCase()}let Be=null,Se=0;for(we=we.toLowerCase();Se<Pe.length&&(Be=h(we,Pe,0,Se))===null;)Se=S(Pe,Se+1);return Be}e.matchesCamelCase=o;function i(we,Pe,Re=!1){if(!Pe||Pe.length===0)return null;let Be=null,Se=0;for(we=we.toLowerCase(),Pe=Pe.toLowerCase();Se<Pe.length&&(Be=s(we,Pe,0,Se,Re))===null;)Se=l(Pe,Se+1);return Be}e.matchesWords=i;function s(we,Pe,Re,Be,Se){if(Re===we.length)return[];if(Be===Pe.length)return null;if(u(we.charCodeAt(Re),Pe.charCodeAt(Be))){let qe=null,X=Be+1;if(qe=s(we,Pe,Re+1,Be+1,Se),!Se)for(;!qe&&(X=l(Pe,X))<Pe.length;)qe=s(we,Pe,Re+1,X,Se),X++;return qe===null?null:w({start:Be,end:Be+1},qe)}else return null}function l(we,Pe){for(let Re=Pe;Re<we.length;Re++)if(a(we.charCodeAt(Re))||Re>0&&a(we.charCodeAt(Re-1)))return Re;return we.length}const g=A(e.matchesPrefix,o,y),v=A(e.matchesPrefix,o,P),d=new _.LRUCache(1e4);function b(we,Pe,Re=!1){if(typeof we!="string"||typeof Pe!="string")return null;let Be=d.get(we);Be||(Be=new RegExp(I.convertSimple2RegExpPattern(we),"i"),d.set(we,Be));const Se=Be.exec(Pe);return Se?[{start:Se.index,end:Se.index+Se[0].length}]:Re?v(we,Pe):g(we,Pe)}e.matchesFuzzy=b;function R(we,Pe){const Re=z(we,we.toLowerCase(),0,Pe,Pe.toLowerCase(),0,!0);return Re?q(Re):null}e.matchesFuzzy2=R;function N(we,Pe,Re,Be,Se,qe){const X=Math.min(13,we.length);for(;Re<X;Re++){const ie=z(we,Pe,Re,Be,Se,qe,!1);if(ie)return ie}return[0,qe]}e.anyScore=N;function q(we){if(typeof we=="undefined")return[];const Pe=[],Re=we[1];for(let Be=we.length-1;Be>1;Be--){const Se=we[Be]+Re,qe=Pe[Pe.length-1];qe&&qe.end===Se?qe.end=Se+1:Pe.push({start:Se,end:Se+1})}return Pe}e.createMatches=q;const re=128;function V(){const we=[],Pe=[];for(let Re=0;Re<=re;Re++)Pe[Re]=0;for(let Re=0;Re<=re;Re++)we.push(Pe.slice(0));return we}function W(we){const Pe=[];for(let Re=0;Re<=we;Re++)Pe[Re]=0;return Pe}const $=W(2*re),U=W(2*re),F=V(),M=V(),L=V(),O=!1;function B(we,Pe,Re,Be,Se){function qe(ie,_e,Ne=" "){for(;ie.length<_e;)ie=Ne+ie;return ie}let X=` |   |${Be.split("").map(ie=>qe(ie,3)).join("|")}
`;for(let ie=0;ie<=Re;ie++)ie===0?X+=" |":X+=`${Pe[ie-1]}|`,X+=we[ie].slice(0,Se+1).map(_e=>qe(_e.toString(),3)).join("|")+`
`;return X}function j(we,Pe,Re,Be){we=we.substr(Pe),Re=Re.substr(Be),console.log(B(M,we,we.length,Re,Re.length)),console.log(B(L,we,we.length,Re,Re.length)),console.log(B(F,we,we.length,Re,Re.length))}function Q(we,Pe){if(Pe<0||Pe>=we.length)return!1;const Re=we.codePointAt(Pe);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Re)}}function de(we,Pe){if(Pe<0||Pe>=we.length)return!1;switch(we.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function be(we,Pe,Re){return Pe[we]!==Re[we]}function Ae(we,Pe,Re,Be,Se,qe,X=!1){for(;Pe<Re&&Se<qe;)we[Pe]===Be[Se]&&(X&&($[Pe]=Se),Pe+=1),Se+=1;return Pe===Re}e.isPatternInWord=Ae;var Ce;(function(we){we[we.Diag=1]="Diag",we[we.Left=2]="Left",we[we.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Le;(function(we){we.Default=[-100,0];function Pe(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}we.isDefault=Pe})(Le=e.FuzzyScore||(e.FuzzyScore={}));function z(we,Pe,Re,Be,Se,qe,X){const ie=we.length>re?re:we.length,_e=Be.length>re?re:Be.length;if(!(Re>=ie||qe>=_e||ie-Re>_e-qe)&&!!Ae(Pe,Re,ie,Se,qe,_e,!0)){Y(ie,_e,Re,qe,Pe,Se);let Ne=1,ze=1,$e=Re,Je=qe;const K=[!1];for(Ne=1,$e=Re;$e<ie;Ne++,$e++){const ce=$[$e],ve=U[$e],ye=$e+1<ie?U[$e+1]:_e;for(ze=ce-qe+1,Je=ce;Je<ye;ze++,Je++){let je=Number.MIN_SAFE_INTEGER,He=!1;Je<=ve&&(je=ee(we,Pe,$e,Re,Be,Se,Je,_e,qe,F[Ne-1][ze-1]===0,K));let We=0;je!==Number.MAX_SAFE_INTEGER&&(He=!0,We=je+M[Ne-1][ze-1]);const Ge=Je>ce,nt=Ge?M[Ne][ze-1]+(F[Ne][ze-1]>0?-5:0):0,dt=Je>ce+1&&F[Ne][ze-1]>0,it=dt?M[Ne][ze-2]+(F[Ne][ze-2]>0?-5:0):0;if(dt&&(!Ge||it>=nt)&&(!He||it>=We))M[Ne][ze]=it,L[Ne][ze]=3,F[Ne][ze]=0;else if(Ge&&(!He||nt>=We))M[Ne][ze]=nt,L[Ne][ze]=2,F[Ne][ze]=0;else if(He)M[Ne][ze]=We,L[Ne][ze]=1,F[Ne][ze]=F[Ne-1][ze-1]+1;else throw new Error("not possible")}}if(O&&j(we,Re,Be,qe),!(!K[0]&&!X)){Ne--,ze--;const se=[M[Ne][ze],qe];let he=0,J=0;for(;Ne>=1;){let ce=ze;do{const ve=L[Ne][ce];if(ve===3)ce=ce-2;else if(ve===2)ce=ce-1;else break}while(ce>=1);he>1&&Pe[Re+Ne-1]===Se[qe+ze-1]&&!be(ce+qe-1,Be,Se)&&he+1>F[Ne][ce]&&(ce=ze),ce===ze?he++:he=1,J||(J=ce),Ne--,ze=ce-1,se.push(ze)}_e===ie&&(se[0]+=2);const ne=J-ie;return se[0]-=ne,se}}}e.fuzzyScore=z;function Y(we,Pe,Re,Be,Se,qe){let X=we-1,ie=Pe-1;for(;X>=Re&&ie>=Be;)Se[X]===qe[ie]&&(U[X]=ie,X--),ie--}function ee(we,Pe,Re,Be,Se,qe,X,ie,_e,Ne,ze){if(Pe[Re]!==qe[X])return Number.MIN_SAFE_INTEGER;let $e=1,Je=!1;return X===Re-Be?$e=we[Re]===Se[X]?7:5:be(X,Se,qe)&&(X===0||!be(X-1,Se,qe))?($e=we[Re]===Se[X]?7:5,Je=!0):Q(qe,X)&&(X===0||!Q(qe,X-1))?$e=5:(Q(qe,X-1)||de(qe,X-1))&&($e=5,Je=!0),$e>1&&Re===Be&&(ze[0]=!0),Je||(Je=be(X,Se,qe)||Q(qe,X-1)||de(qe,X-1)),Re===Be?X>_e&&($e-=Je?3:5):Ne?$e+=Je?2:0:$e+=Je?0:1,X+1===ie&&($e-=Je?3:5),$e}function ae(we,Pe,Re,Be,Se,qe,X){return De(we,Pe,Re,Be,Se,qe,!0,X)}e.fuzzyScoreGracefulAggressive=ae;function me(we,Pe,Re,Be,Se,qe,X){return De(we,Pe,Re,Be,Se,qe,!1,X)}e.fuzzyScoreGraceful=me;function De(we,Pe,Re,Be,Se,qe,X,ie){let _e=z(we,Pe,Re,Be,Se,qe,ie);if(_e&&!X)return _e;if(we.length>=3){const Ne=Math.min(7,we.length-1);for(let ze=Re+1;ze<Ne;ze++){const $e=Oe(we,ze);if($e){const Je=z($e,$e.toLowerCase(),Re,Be,Se,qe,ie);Je&&(Je[0]-=3,(!_e||Je[0]>_e[0])&&(_e=Je))}}}return _e}function Oe(we,Pe){if(!(Pe+1>=we.length)){const Re=we[Pe],Be=we[Pe+1];if(Re!==Be)return we.slice(0,Pe)+Be+Re+we.slice(Pe+2)}}}),define(ge[136],pe([0,1,43,97,9]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${T.source}`,"g");function P(u){return u.replace(y,(E,w)=>w?E:`\\${E}`)}e.escapeIcons=P;const D=new RegExp(`\\\\${T.source}`,"g");function k(u){return u.replace(D,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=k;const r=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function C(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(r,(E,w,S,h)=>S?E:w||h||"")}e.stripIcons=C;function f(u){const E=u.indexOf(e.iconStartMarker);return E===-1?{text:u}:p(u,E)}e.parseLabelWithIcons=f;function p(u,E){const w=[];let S="";function h(l){if(l){S+=l;for(const g of l)w.push(t)}}let c=-1,m="",t=0,n,o,i=E;const s=u.length;for(h(u.substr(0,E));i<s;)n=u[i],o=u[i+1],n===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(c=i,h(m),m=e.iconStartMarker,i++):n===")"&&c!==-1?(t+=i-c+1,c=-1,m=""):c!==-1?/^[a-z0-9\-]$/i.test(n)?m+=n:(h(m),c=-1,m=""):h(n),i++;return h(m),{text:S,iconOffsets:w}}function a(u,E,w=!1){const{text:S,iconOffsets:h}=E;if(!h||h.length===0)return(0,I.matchesFuzzy)(u,S,w);const c=(0,A.ltrim)(S," "),m=S.length-c.length,t=(0,I.matchesFuzzy)(u,c,w);if(t)for(const n of t){const o=h[n.start+m]+m;n.start+=o,n.end+=o}return t}e.matchesFuzzyIconAware=a}),define(ge[98],pe([0,1,17,136,16]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(u="",E=!1){var w,S;if(this.value=u,typeof this.value!="string")throw(0,A.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1):(this.isTrusted=(w=E.isTrusted)!==null&&w!==void 0?w:void 0,this.supportThemeIcons=(S=E.supportThemeIcons)!==null&&S!==void 0?S:!1)}appendText(u,E=0){return this.value+=C(this.supportThemeIcons?(0,I.escapeIcons)(u):u).replace(/([ \t]+)/g,(w,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,E){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}}e.MarkdownString=y;function P(a){return D(a)?!a.value:Array.isArray(a)?a.every(P):!0}e.isEmptyMarkdownString=P;function D(a){return a instanceof y?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function k(a,u){return!a&&!u?!0:!a||!u?!1:Array.isArray(a)&&Array.isArray(u)?(0,_.equals)(a,u,r):D(a)&&D(u)?r(a,u):!1}e.markedStringsEquals=k;function r(a,u){return a===u?!0:!a||!u?!1:a.value===u.value&&a.isTrusted===u.isTrusted&&a.supportThemeIcons===u.supportThemeIcons}function C(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function f(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function p(a){const u=[],E=a.split("|").map(S=>S.trim());a=E[0];const w=E[1];if(w){const S=/height=(\d+)/.exec(w),h=/width=(\d+)/.exec(w),c=S?S[1]:"",m=h?h[1]:"",t=isFinite(parseInt(m)),n=isFinite(parseInt(c));t&&u.push(`width="${m}"`),n&&u.push(`height="${c}"`)}return{href:a,dimensions:u}}e.parseHrefAndDimensions=p}),define(ge[58],pe([0,1,22,9,2]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(k){return JSON.stringify(k,P)}e.stringify=T;function y(k){let r=JSON.parse(k);return r=D(r),r}e.parse=y;function P(k,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:(0,I.regExpFlags)(r)}:r}function D(k,r=0){if(!k||r>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return A.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof _.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=D(k[C],r+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=D(k[C],r+1))}return k}e.revive=D}),define(ge[12],pe([0,1,2,10]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(A=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,k,r){this._hosts[D]=k,this._ports[D]=r}setConnectionToken(D,k){this._connectionTokens[D]=k}rewrite(D){if(this._delegate)return this._delegate(D);const k=D.authority;let r=this._hosts[k];r&&r.indexOf(":")!==-1&&(r=`[${r}]`);const C=this._connectionTokens[k];let f=`path=${encodeURIComponent(D.path)}`;return typeof C=="string"&&(f+=`&tkn=${encodeURIComponent(C)}`),_.URI.from({scheme:I.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:window.location.host,path:`${window.location.pathname.replace(/\/+$/,"")}/vscode-remote-resource`,query:f})}}e.RemoteAuthorities=new T;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,k,r){const C=this.toUri(D,k);return C.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(C):I.isNative&&(r||I.isPreferringBrowserCodeLoad)&&C.scheme===A.file?C.with({scheme:A.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(D,k){const r=this.toUri(D,k);return r.scheme===A.vscodeFileResource?r.with({scheme:A.file,authority:r.authority!==this.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(D,k){return _.URI.isUri(D)?D:_.URI.parse(k.toUrl(D))}}e.FileAccess=new y}),define(ge[75],pe([0,1,24]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const I=new _.LRUCache(1e4);function A(k){return D(k,"NFC",I)}e.normalizeNFC=A;const T=new _.LRUCache(1e4);function y(k){return D(k,"NFD",T)}e.normalizeNFD=y;const P=/[^\u0000-\u0080]/;function D(k,r,C){if(!e.canNormalize||!k)return k;const f=C.get(k);if(f)return f;let p;return P.test(k)?p=k.normalize(r):p=k,C.set(k,p),p}e.removeAccents=function(){if(e.canNormalize){const k=/[\u0300-\u036f]/g;return function(r){return y(r).replace(k,"")}}else return function(k){return k}}()}),define(ge[25],pe([0,1,29,8,2,9,12,10]),function(G,e,_,I,A,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(p){return(0,A.uriToFsPath)(p,!0)}e.originalFSPath=D;class k{constructor(a){this._ignorePathCasing=a}compare(a,u,E=!1){return a===u?0:(0,T.compare)(this.getComparisonKey(a,E),this.getComparisonKey(u,E))}isEqual(a,u,E=!1){return a===u?!0:!a||!u?!1:this.getComparisonKey(a,E)===this.getComparisonKey(u,E)}getComparisonKey(a,u=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,u,E=!1){if(a.scheme===u.scheme){if(a.scheme===y.Schemas.file)return _.isEqualOrParent(D(a),D(u),this._ignorePathCasing(a))&&a.query===u.query&&(E||a.fragment===u.fragment);if((0,e.isEqualAuthority)(a.authority,u.authority))return _.isEqualOrParent(a.path,u.path,this._ignorePathCasing(a),"/")&&a.query===u.query&&(E||a.fragment===u.fragment)}return!1}joinPath(a,...u){return A.URI.joinPath(a,...u)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return I.posix.basename(a.path)}extname(a){return I.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let u;return a.scheme===y.Schemas.file?u=A.URI.file(I.dirname(D(a))).path:(u=I.posix.dirname(a.path),a.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),u="/")),a.with({path:u})}normalizePath(a){if(!a.path.length)return a;let u;return a.scheme===y.Schemas.file?u=A.URI.file(I.normalize(D(a))).path:u=I.posix.normalize(a.path),a.with({path:u})}relativePath(a,u){if(!(a.scheme!==u.scheme||!(0,e.isEqualAuthority)(a.authority,u.authority))){if(a.scheme===y.Schemas.file){const S=I.relative(D(a),D(u));return P.isWindows?_.toSlashes(S):S}let E=a.path||"/",w=u.path||"/";if(this._ignorePathCasing(a)){let S=0;for(const h=Math.min(E.length,w.length);S<h&&!(E.charCodeAt(S)!==w.charCodeAt(S)&&E.charAt(S).toLowerCase()!==w.charAt(S).toLowerCase());S++);E=w.substr(0,S)+E.substr(S)}return I.posix.relative(E,w)}}resolvePath(a,u){if(a.scheme===y.Schemas.file){const E=A.URI.file(I.resolve(D(a),u));return a.with({authority:E.authority,path:E.path})}return u.indexOf("/")===-1&&(u=_.toSlashes(u),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u)),a.with({path:I.posix.resolve(a.path,u)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,u){return a===u||(0,T.equalsIgnoreCase)(a,u)}hasTrailingPathSeparator(a,u=I.sep){if(a.scheme===y.Schemas.file){const E=D(a);return E.length>_.getRoot(E).length&&E[E.length-1]===u}else{const E=a.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,u=I.sep){return(0,e.hasTrailingPathSeparator)(a,u)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,u=I.sep){let E=!1;if(a.scheme===y.Schemas.file){const w=D(a);E=w!==void 0&&w.length===_.getRoot(w).length&&w[w.length-1]===u}else{u="/";const w=a.path;E=w.length===1&&w.charCodeAt(w.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(a,u)?a.with({path:a.path+"/"}):a}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(p=>p.scheme===y.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new k(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(p,a){const u=[];for(let E=0;E<p.length;E++){const w=a(p[E]);p.some((S,h)=>h===E?!1:(0,e.isEqualOrParent)(w,a(S)))||u.push(p[E])}return u}e.distinctParents=r;var C;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function a(u){const E=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(h=>{const[c,m]=h.split(":");c&&m&&E.set(c,m)});const S=u.path.substring(0,u.path.indexOf(";"));return S&&E.set(p.META_DATA_MIME,S),E}p.parseMetaData=a})(C=e.DataUri||(e.DataUri={}));function f(p,a,u){if(a){let E=p.path;return E&&E[0]!==I.posix.sep&&(E=I.posix.sep+E),p.with({scheme:u,authority:a,path:E})}return p.with({scheme:u})}e.toLocalResource=f}),define(ge[13],pe([0,1,21,16,3,6,56,25]),function(G,e,_,I,A,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(M){return!!M&&typeof M.then=="function"}e.isThenable=D;function k(M){const L=new _.CancellationTokenSource,O=M(L.token),B=new Promise((j,Q)=>{L.token.onCancellationRequested(()=>{Q((0,I.canceled)())}),Promise.resolve(O).then(de=>{L.dispose(),j(de)},de=>{L.dispose(),Q(de)})});return new class{cancel(){L.cancel()}then(j,Q){return B.then(j,Q)}catch(j){return this.then(void 0,j)}finally(j){return B.finally(j)}}}e.createCancelablePromise=k;function r(M,L,O){return Promise.race([M,new Promise(B=>L.onCancellationRequested(()=>B(O)))])}e.raceCancellation=r;async function C(M){let L=-1;const O=M.map((j,Q)=>j.then(de=>(L=Q,de))),B=await Promise.race(O);return M.forEach((j,Q)=>{Q!==L&&j.cancel()}),B}e.raceCancellablePromises=C;function f(M,L,O){let B;const j=setTimeout(()=>{B==null||B(void 0),O==null||O()},L);return Promise.race([M.finally(()=>clearTimeout(j)),new Promise(Q=>B=Q)])}e.raceTimeout=f;function p(M){return new Promise((L,O)=>{const B=M();D(B)?B.then(L,O):L(B)})}e.asPromise=p;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(O,O).then(B)})}return new Promise((O,B)=>{this.queuedPromise.then(O,B)})}return this.activePromise=L(),new Promise((O,B)=>{this.activePromise.then(j=>{this.activePromise=null,O(j)},j=>{this.activePromise=null,B(j)})})}}e.Throttler=a;class u{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=u;class E{constructor(){this.promiseMap=new Map}queue(L,O){var B;const Q=((B=this.promiseMap.get(L))!==null&&B!==void 0?B:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===Q&&this.promiseMap.delete(L)});return this.promiseMap.set(L,Q),Q}}e.SequencerByKey=E;class w{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,j)=>{this.doResolve=B,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class S{constructor(L){this.delayer=new w(L),this.throttler=new a}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class h{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=h;class c extends h{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function m(M,L){return L?new Promise((O,B)=>{const j=setTimeout(O,M);L.onCancellationRequested(()=>{clearTimeout(j),B((0,I.canceled)())})}):k(O=>m(M,O))}e.timeout=m;function t(M,L=0){const O=setTimeout(M,L);return(0,T.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function n(M){return M.then(void 0,L=>{})}e.ignoreErrors=n;function o(M){const L=[];let O=0;const B=M.length;function j(){return O<B?M[O++]():null}function Q(de){de!=null&&L.push(de);const be=j();return be?be.then(Q):Promise.resolve(L)}return Promise.resolve(null).then(Q)}e.sequence=o;function i(M,L=B=>!!B,O=null){let B=0;const j=M.length,Q=()=>{if(B>=j)return Promise.resolve(O);const de=M[B++];return Promise.resolve(de()).then(Ae=>L(Ae)?Promise.resolve(Ae):Q())};return Q()}e.first=i;function s(M,L=B=>!!B,O=null){if(M.length===0)return Promise.resolve(O);let B=M.length;const j=()=>{var Q,de;B=-1;for(const be of M)(de=(Q=be).cancel)===null||de===void 0||de.call(Q)};return new Promise((Q,de)=>{for(const be of M)be.then(Ae=>{--B>=0&&L(Ae)?(j(),Q(Ae)):B===0&&Q(O)}).catch(Ae=>{--B>=0&&(j(),de(Ae))})})}e.firstParallel=s;class l{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,B)=>{this.outstandingPromises.push({factory:L,c:O,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class g extends l{constructor(){super(1)}}e.Queue=g;class v{constructor(){this.queues=new Map}queueFor(L,O=P.extUri){const B=O.getComparisonKey(L);let j=this.queues.get(B);return j||(j=new g,A.Event.once(j.onFinished)(()=>{j==null||j.dispose(),this.queues.delete(B)}),this.queues.set(B,j)),j}dispose(){this.queues.forEach(L=>L.dispose()),this.queues.clear()}}e.ResourceQueue=v;class d{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=d;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=b;class R{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class N extends R{constructor(L,O){super(L,O);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=L=>{const O=setTimeout(()=>L(M));let B=!1;return{dispose(){B||(B=!0,clearTimeout(O))}}}}else e.runWhenIdle=(M,L)=>{const O=requestIdleCallback(M,typeof L=="number"?{timeout:L}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(O))}}}}();class q{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=q;async function re(M,L,O){let B;for(let j=0;j<O;j++)try{return await M()}catch(Q){B=Q,await m(L)}throw B}e.retry=re;class V{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var L;(L=this._pending)===null||L===void 0||L.cancel()}setPending(L,O,B){return this._pending={taskId:L,cancel:()=>B==null?void 0:B(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,B;const j=new Promise((Q,de)=>{O=Q,B=de});this._next={run:L,promise:j,promiseResolve:O,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=V;class W{constructor(L){this.interval=L,this.lastIncrementTime=0,this.value=0}increment(){const L=Date.now();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,L()})}}e.DeferredPromise=$;class U extends A.Emitter{async fireAsync(L,O,B){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const j of this._listeners)this._asyncDeliveryQueue.push([j,L]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[j,Q]=this._asyncDeliveryQueue.shift(),de=[],be=Object.assign(Object.assign({},Q),{waitUntil:Ae=>{if(Object.isFrozen(de))throw new Error("waitUntil can NOT be called asynchronous");B&&(Ae=B(Ae,typeof j=="function"?j:j[0])),de.push(Ae)}});try{typeof j=="function"?j.call(void 0,be):j[0].call(j[1],be)}catch(Ae){(0,I.onUnexpectedError)(Ae);continue}Object.freeze(de),await F.settled(de).catch(Ae=>(0,I.onUnexpectedError)(Ae))}}}}e.AsyncEmitter=U;var F;(function(M){async function L(Q){return typeof Promise.allSettled=="function"?O(Q):B(Q)}M.allSettled=L;async function O(Q){return Promise.allSettled(Q)}async function B(Q){return Promise.all(Q.map(de=>de.then(be=>({status:"fulfilled",value:be}),be=>({status:"rejected",reason:be}))))}async function j(Q){let de;const be=await Promise.all(Q.map(Ae=>Ae.then(Ce=>Ce,Ce=>{de||(de=Ce)})));if(typeof de!="undefined")throw de;return be}M.settled=j})(F=e.Promises||(e.Promises={}))}),define(ge[99],pe([0,1,8,13]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const A=new I.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),T=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(c,m,t=!1){const n=c||"",o=m||"",i=A.value.collator.compare(n,o);return A.value.collatorIsNumeric&&i===0&&n!==o?n<o?-1:1:i}e.compareFileNames=P;function D(c,m){const t=T.value.collator;return c=c||"",m=m||"",u(t,c,m)}e.compareFileNamesDefault=D;function k(c,m,t=!1){t||(c=c&&c.toLowerCase(),m=m&&m.toLowerCase());const[n,o]=p(c),[i,s]=p(m);return n!==i?n<i?-1:1:o===s?0:o<s?-1:1}e.noIntlCompareFileNames=k;function r(c,m){const[t,n]=p(c),[o,i]=p(m);let s=A.value.collator.compare(n,i);if(s===0){if(A.value.collatorIsNumeric&&n!==i)return n<i?-1:1;if(s=A.value.collator.compare(t,o),A.value.collatorIsNumeric&&s===0&&t!==o)return t<o?-1:1}return s}e.compareFileExtensions=r;function C(c,m){c=c||"",m=m||"";const t=a(c),n=a(m),o=T.value.collator,i=y.value.collator;let s;return s=u(i,t,n),s!==0?s:u(o,c,m)}e.compareFileExtensionsDefault=C;const f=/^(.*?)(\.([^.]*))?$/;function p(c,m=!1){const t=c?f.exec(c):[];let n=[t&&t[1]||"",t&&t[3]||""];return m&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function a(c){const m=c?f.exec(c):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function u(c,m,t){let n=c.compare(m,t);return n!==0?n:m.length!==t.length?m.length<t.length?-1:1:0}function E(c,m,t=!1){return t||(c=c&&c.toLowerCase(),m=m&&m.toLowerCase()),c===m?0:c<m?-1:1}function w(c,m,t=!1){const n=c.split(_.sep),o=m.split(_.sep),i=n.length-1,s=o.length-1;let l,g;for(let v=0;;v++){if(l=i===v,g=s===v,l&&g)return P(n[v],o[v],t);if(l)return-1;if(g)return 1;const d=E(n[v],o[v],t);if(d!==0)return d}}e.comparePaths=w;function S(c,m,t){const n=c.toLowerCase(),o=m.toLowerCase(),i=h(c,m,t);if(i)return i;const s=n.endsWith(t),l=o.endsWith(t);if(s!==l)return s?-1:1;const g=P(n,o);return g!==0?g:n.localeCompare(o)}e.compareAnything=S;function h(c,m,t){const n=c.toLowerCase(),o=m.toLowerCase(),i=n.startsWith(t),s=o.startsWith(t);if(i!==s)return i?-1:1;if(i&&s){if(n.length<o.length)return-1;if(n.length>o.length)return 1}return 0}e.compareByPrefix=h}),define(ge[100],pe([0,1,99,97,8,10,9]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const P=0,D=[P,[]];function k(W,$,U,F){if(!W||!$)return D;const M=W.length,L=$.length;if(M<L)return D;const O=W.toLowerCase();return!F&&!O.includes(U)?D:r($,U,L,W,O,M)}e.scoreFuzzy=k;function r(W,$,U,F,M,L){const O=[],B=[];for(let be=0;be<U;be++){const Ae=be*L,Ce=Ae-L,Le=be>0,z=W[be],Y=$[be];for(let ee=0;ee<L;ee++){const ae=ee>0,me=Ae+ee,De=me-1,Oe=Ce+ee-1,we=ae?O[De]:0,Pe=Le&&ae?O[Oe]:0,Re=Le&&ae?B[Oe]:0;let Be;!Pe&&Le?Be=0:Be=C(z,Y,F,M,ee,Re),Be&&Pe+Be>=we?(B[me]=Re+1,O[me]=Pe+Be):(B[me]=P,O[me]=we)}}const j=[];let Q=U-1,de=L-1;for(;Q>=0&&de>=0;){const be=Q*L+de;B[be]===P||(j.push(de),Q--),de--}return[O[U*L-1],j.reverse()]}function C(W,$,U,F,M,L){let O=0;if(!f($,F[M]))return O;if(O+=1,L>0&&(O+=L*5),W===U[M]&&(O+=1),M===0)O+=8;else{const B=p(U.charCodeAt(M-1));B?O+=B:(0,I.isUpper)(U.charCodeAt(M))&&(O+=2)}return O}function f(W,$){return W===$?!0:W==="/"||W==="\\"?$==="/"||$==="\\":!1}function p(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function u(W,$,U=0,F=0){const M=$;return M.values&&M.values.length>1?E(W,M.values,U,F):w(W,$,U,F)}e.scoreFuzzy2=u;function E(W,$,U,F){let M=0;const L=[];for(const O of $){const[B,j]=w(W,O,U,F);if(typeof B!="number")return a;M+=B,L.push(...j)}return[M,l(L)]}function w(W,$,U,F){const M=(0,I.fuzzyScore)($.original,$.originalLowercase,U,W,W.toLowerCase(),F,!0);return M?[M[0],(0,I.createMatches)(M)]:a}const S=Object.freeze({score:0}),h=1<<18,c=1<<17,m=1<<16;function t(W,$,U,F,M){if(!W||!$.normalized)return S;const L=F.getItemLabel(W);if(!L)return S;const O=F.getItemDescription(W);let B;O?B=`${L}${O}${$.normalized}${Array.isArray($.values)?$.values.length:""}${U}`:B=`${L}${$.normalized}${Array.isArray($.values)?$.values.length:""}${U}`;const j=M[B];if(j)return j;const Q=n(L,O,F.getItemPath(W),$,U);return M[B]=Q,Q}e.scoreItemFuzzy=t;function n(W,$,U,F,M){const L=!U||!F.containsPathSeparator;return U&&(T.isLinux?F.pathNormalized===U:(0,y.equalsIgnoreCase)(F.pathNormalized,U))?{score:h,labelMatch:[{start:0,end:W.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:F.values&&F.values.length>1?o(W,$,U,F.values,L,M):i(W,$,U,F,L,M)}function o(W,$,U,F,M,L){let O=0;const B=[],j=[];for(const Q of F){const{score:de,labelMatch:be,descriptionMatch:Ae}=i(W,$,U,Q,M,L);if(de===P)return S;O+=de,be&&B.push(...be),Ae&&j.push(...Ae)}return{score:O,labelMatch:l(B),descriptionMatch:l(j)}}function i(W,$,U,F,M,L){if(M||!$){const[O,B]=k(W,F.normalized,F.normalizedLowercase,L);if(O){const j=(0,I.matchesPrefix)(F.normalized,W);let Q;return j?(Q=c,Q+=Math.round(F.normalized.length/W.length*100)):Q=m,{score:Q+O,labelMatch:j||s(B)}}}if($){let O=$;U&&(O=`${$}${A.sep}`);const B=O.length,j=`${O}${W}`,[Q,de]=k(j,F.normalized,F.normalizedLowercase,L);if(Q){const be=s(de),Ae=[],Ce=[];return be.forEach(Le=>{Le.start<B&&Le.end>B?(Ae.push({start:0,end:Le.end-B}),Ce.push({start:Le.start,end:B})):Le.start>=B?Ae.push({start:Le.start-B,end:Le.end-B}):Ce.push(Le)}),{score:Q,labelMatch:Ae,descriptionMatch:Ce}}}return S}function s(W){const $=[];if(!W)return $;let U;for(const F of W)U&&U.end===F?U.end+=1:(U={start:F,end:F+1},$.push(U));return $}function l(W){const $=W.sort((M,L)=>M.start-L.start),U=[];let F;for(const M of $)!F||!g(F,M)?(F=M,U.push(M)):(F.start=Math.min(F.start,M.start),F.end=Math.max(F.end,M.end));return U}function g(W,$){return!(W.end<$.start||$.end<W.start)}function v(W,$,U,F,M,L){const O=t(W,U,F,M,L),B=t($,U,F,M,L),j=O.score,Q=B.score;if((j===h||Q===h)&&j!==Q)return j===h?-1:1;if(j>m||Q>m){if(j!==Q)return j>Q?-1:1;if(j<c&&Q<c){const Y=b(O.labelMatch,B.labelMatch);if(Y!==0)return Y}const Le=M.getItemLabel(W)||"",z=M.getItemLabel($)||"";if(Le.length!==z.length)return Le.length-z.length}if(j!==Q)return j>Q?-1:1;const de=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,be=Array.isArray(B.labelMatch)&&B.labelMatch.length>0;if(de&&!be)return-1;if(be&&!de)return 1;const Ae=d(W,O,M),Ce=d($,B,M);return Ae&&Ce&&Ae!==Ce?Ce>Ae?-1:1:R(W,$,U,M)}e.compareItemsByFuzzyScore=v;function d(W,$,U){let F=-1,M=-1;if($.descriptionMatch&&$.descriptionMatch.length?F=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(F=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(M=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const L=U.getItemDescription(W);L&&(M+=L.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(M=$.descriptionMatch[$.descriptionMatch.length-1].end);return M-F}function b(W,$){if(!W&&!$||(!W||!W.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!W||!W.length)return 1;const U=W[0].start,M=W[W.length-1].end-U,L=$[0].start,B=$[$.length-1].end-L;return M===B?0:B<M?1:-1}function R(W,$,U,F){const M=F.getItemLabel(W)||"",L=F.getItemLabel($)||"",O=F.getItemDescription(W),B=F.getItemDescription($),j=M.length+(O?O.length:0),Q=L.length+(B?B.length:0);if(j!==Q)return j-Q;const de=F.getItemPath(W),be=F.getItemPath($);return de&&be&&de.length!==be.length?de.length-be.length:M!==L?(0,_.compareAnything)(M,L,U.normalized):O&&B&&O!==B?(0,_.compareAnything)(O,B,U.normalized):de&&be&&de!==be?(0,_.compareAnything)(de,be,U.normalized):0}const N=" ";function q(W){typeof W!="string"&&(W="");const $=W.toLowerCase(),{pathNormalized:U,normalized:F,normalizedLowercase:M}=re(W),L=U.indexOf(A.sep)>=0;let O;const B=W.split(N);if(B.length>1)for(const j of B){const{pathNormalized:Q,normalized:de,normalizedLowercase:be}=re(j);de&&(O||(O=[]),O.push({original:j,originalLowercase:j.toLowerCase(),pathNormalized:Q,normalized:de,normalizedLowercase:be}))}return{original:W,originalLowercase:$,pathNormalized:U,normalized:F,normalizedLowercase:M,values:O,containsPathSeparator:L}}e.prepareQuery=q;function re(W){let $;T.isWindows?$=W.replace(/\//g,A.sep):$=W.replace(/\\/g,A.sep);const U=(0,y.stripWildcards)($).replace(/\s/g,"");return{pathNormalized:$,normalized:U,normalizedLowercase:U.toLowerCase()}}function V(W){return Array.isArray(W)?q(W.map($=>$.original).join(N)):q(W.original)}e.pieceToQuery=V}),define(ge[33],pe([0,1,9,29,8,24,13]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const D="**",k="/",r="[/\\\\]",C="[^/\\\\]",f=/\//g;function p(O){switch(O){case 0:return"";case 1:return`${C}*?`;default:return`(?:${r}|${C}+${r}|${r}${C}+)*?`}}function a(O,B){if(!O)return[];const j=[];let Q=!1,de=!1,be="";for(const Ae of O){switch(Ae){case B:if(!Q&&!de){j.push(be),be="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":de=!0;break;case"]":de=!1;break}be+=Ae}return be&&j.push(be),j}e.splitGlobAware=a;function u(O){if(!O)return"";let B="";const j=a(O,k);if(j.every(Q=>Q===D))B=".*";else{let Q=!1;j.forEach((de,be)=>{if(de===D){Q||(B+=p(2),Q=!0);return}let Ae=!1,Ce="",Le=!1,z="";for(const Y of de){if(Y!=="}"&&Ae){Ce+=Y;continue}if(Le&&(Y!=="]"||!z)){let ee;Y==="-"?ee=Y:(Y==="^"||Y==="!")&&!z?ee="^":Y===k?ee="":ee=_.escapeRegExpCharacters(Y),z+=ee;continue}switch(Y){case"{":Ae=!0;continue;case"[":Le=!0;continue;case"}":B+=`(?:${a(Ce,",").map(me=>u(me)).join("|")})`,Ae=!1,Ce="";break;case"]":B+="["+z+"]",Le=!1,z="";break;case"?":B+=C;continue;case"*":B+=p(1);continue;default:B+=_.escapeRegExpCharacters(Y)}}be<j.length-1&&(j[be+1]!==D||be+2<j.length)&&(B+=r),Q=!1})}return B}const E=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},o=function(){return null};function i(O,B){if(!O)return o;let j;typeof O!="string"?j=O.pattern:j=O,j=j.trim();const Q=`${j}_${!!B.trimForExclusions}`;let de=t.get(Q);if(de)return s(de,O);let be;if(E.test(j)){const Ae=j.substr(4);de=function(Ce,Le){return typeof Ce=="string"&&Ce.endsWith(Ae)?j:null}}else(be=w.exec(l(j,B)))?de=g(be[1],j):(B.trimForExclusions?h:S).test(j)?de=v(j,B):(be=c.exec(l(j,B)))?de=d(be[1].substr(1),j,!0):(be=m.exec(l(j,B)))?de=d(be[1],j,!1):de=b(j);return t.set(Q,de),s(de,O)}function s(O,B){return typeof B=="string"?O:function(j,Q){return I.isEqualOrParent(j,B.base)?O(A.relative(B.base,j),Q):null}}function l(O,B){return B.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function g(O,B){const j=`/${O}`,Q=`\\${O}`,de=function(Ae,Ce){return typeof Ae!="string"?null:Ce?Ce===O?B:null:Ae===O||Ae.endsWith(j)||Ae.endsWith(Q)?B:null},be=[O];return de.basenames=be,de.patterns=[B],de.allBasenames=be,de}function v(O,B){const j=L(O.slice(1,-1).split(",").map(Ce=>i(Ce,B)).filter(Ce=>Ce!==o),O),Q=j.length;if(!Q)return o;if(Q===1)return j[0];const de=function(Ce,Le){for(let z=0,Y=j.length;z<Y;z++)if(j[z](Ce,Le))return O;return null},be=j.find(Ce=>!!Ce.allBasenames);be&&(de.allBasenames=be.allBasenames);const Ae=j.reduce((Ce,Le)=>Le.allPaths?Ce.concat(Le.allPaths):Ce,[]);return Ae.length&&(de.allPaths=Ae),de}function d(O,B,j){const Q=A.sep===A.posix.sep,de=Q?O:O.replace(f,A.sep),be=A.sep+de,Ae=A.posix.sep+O,Ce=j?function(Le,z){return typeof Le=="string"&&(Le===de||Le.endsWith(be)||!Q&&(Le===O||Le.endsWith(Ae)))?B:null}:function(Le,z){return typeof Le=="string"&&(Le===de||!Q&&Le===O)?B:null};return Ce.allPaths=[(j?"*/":"./")+O],Ce}function b(O){try{const B=new RegExp(`^${u(O)}$`);return function(j){return B.lastIndex=0,typeof j=="string"&&B.test(j)?O:null}}catch(B){return o}}function R(O,B,j){return!O||typeof B!="string"?!1:N(O)(B,void 0,j)}e.match=R;function N(O,B={}){if(!O)return n;if(typeof O=="string"||W(O)){const j=i(O,B);if(j===o)return n;const Q=function(de,be){return!!j(de,be)};return j.allBasenames&&(Q.allBasenames=j.allBasenames),j.allPaths&&(Q.allPaths=j.allPaths),Q}return F(O,B)}e.parse=N;function q(O){if(!!O){let B;return j=>(B||(B=(O()||Promise.resolve([])).then(Q=>Q?V(Q):{})),B.then(Q=>!!Q[j]))}}e.hasSiblingPromiseFn=q;function re(O){if(!!O){let B;return j=>{if(!B){const Q=O();B=Q?V(Q):{}}return!!B[j]}}}e.hasSiblingFn=re;function V(O){const B={};for(const j of O)B[j]=!0;return B}function W(O){const B=O;return B&&typeof B.base=="string"&&typeof B.pattern=="string"}e.isRelativePattern=W;function $(O){return O.allBasenames||[]}e.getBasenameTerms=$;function U(O){return O.allPaths||[]}e.getPathTerms=U;function F(O,B){const j=L(Object.getOwnPropertyNames(O).map(Ce=>M(Ce,O[Ce],B)).filter(Ce=>Ce!==o)),Q=j.length;if(!Q)return o;if(!j.some(Ce=>!!Ce.requiresSiblings)){if(Q===1)return j[0];const Ce=function(Y,ee){for(let ae=0,me=j.length;ae<me;ae++){const De=j[ae](Y,ee);if(De)return De}return null},Le=j.find(Y=>!!Y.allBasenames);Le&&(Ce.allBasenames=Le.allBasenames);const z=j.reduce((Y,ee)=>ee.allPaths?Y.concat(ee.allPaths):Y,[]);return z.length&&(Ce.allPaths=z),Ce}const de=function(Ce,Le,z){let Y;for(let ee=0,ae=j.length;ee<ae;ee++){const me=j[ee];me.requiresSiblings&&z&&(Le||(Le=A.basename(Ce)),Y||(Y=Le.substr(0,Le.length-A.extname(Ce).length)));const De=me(Ce,Le,Y,z);if(De)return De}return null},be=j.find(Ce=>!!Ce.allBasenames);be&&(de.allBasenames=be.allBasenames);const Ae=j.reduce((Ce,Le)=>Le.allPaths?Ce.concat(Le.allPaths):Ce,[]);return Ae.length&&(de.allPaths=Ae),de}function M(O,B,j){if(B===!1)return o;const Q=i(O,j);if(Q===o)return o;if(typeof B=="boolean")return Q;if(B){const de=B.when;if(typeof de=="string"){const be=(Ae,Ce,Le,z)=>{if(!z||!Q(Ae,Ce))return null;const Y=de.replace("$(basename)",Le),ee=z(Y);return(0,y.isThenable)(ee)?ee.then(ae=>ae?O:null):ee?O:null};return be.requiresSiblings=!0,be}}return Q}function L(O,B){const j=O.filter(Ce=>!!Ce.basenames);if(j.length<2)return O;const Q=j.reduce((Ce,Le)=>{const z=Le.basenames;return z?Ce.concat(z):Ce},[]);let de;if(B){de=[];for(let Ce=0,Le=Q.length;Ce<Le;Ce++)de.push(B)}else de=j.reduce((Ce,Le)=>{const z=Le.patterns;return z?Ce.concat(z):Ce},[]);const be=function(Ce,Le){if(typeof Ce!="string")return null;if(!Le){let Y;for(Y=Ce.length;Y>0;Y--){const ee=Ce.charCodeAt(Y-1);if(ee===47||ee===92)break}Le=Ce.substr(Y)}const z=Q.indexOf(Le);return z!==-1?de[z]:null};be.basenames=Q,be.patterns=de,be.allBasenames=Q;const Ae=O.filter(Ce=>!Ce.basenames);return Ae.push(be),Ae}}),define(ge[76],pe([0,1,2,8,9,12,10,25,29]),function(G,e,_,I,A,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(i,s,l){if(typeof i=="string"&&(i=_.URI.file(i)),l){const v=l.getWorkspaceFolder(i);if(v){const d=l.getWorkspace().folders.length>1;let b;if((0,P.isEqual)(v.uri,i)?b="":b=(0,P.relativePath)(v.uri,i),d){const R=v.name?v.name:(0,P.basename)(v.uri);b=b?R+" \u2022 "+b:R}return b}}if(i.scheme!==T.Schemas.file&&i.scheme!==T.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(i.fsPath))return(0,I.normalize)(C(i.fsPath));let g=(0,I.normalize)(i.fsPath);return!y.isWindows&&(s==null?void 0:s.userHome)&&(g=p(g,s.userHome.fsPath)),g}e.getPathLabel=k;function r(i){if(!!i){typeof i=="string"&&(i=_.URI.file(i));const s=(0,P.basename)(i)||(i.scheme===T.Schemas.file?i.fsPath:i.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(s)?C(s):s}}e.getBaseLabel=r;function C(i){return(0,D.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let f=Object.create(null);function p(i,s){if(y.isWindows||!i||!s)return i;let l=f.original===s?f.normalized:void 0;return l||(l=`${(0,A.rtrim)(s,I.posix.sep)}${I.posix.sep}`,f={original:s,normalized:l}),(y.isLinux?i.startsWith(l):(0,A.startsWithIgnoreCase)(i,l))&&(i=`~/${i.substr(l.length)}`),i}e.tildify=p;function a(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=a;const u="\u2026",E="\\\\",w="~";function S(i,s=I.sep){const l=new Array(i.length);let g=!1;for(let v=0;v<i.length;v++){let d=i[v];if(d===""){l[v]=`.${s}`;continue}if(!d){l[v]=d;continue}g=!0;let b="";d.indexOf(E)===0?(b=d.substr(0,d.indexOf(E)+E.length),d=d.substr(d.indexOf(E)+E.length)):d.indexOf(s)===0?(b=d.substr(0,d.indexOf(s)+s.length),d=d.substr(d.indexOf(s)+s.length)):d.indexOf(w)===0&&(b=d.substr(0,d.indexOf(w)+w.length),d=d.substr(d.indexOf(w)+w.length));const R=d.split(s);for(let N=1;g&&N<=R.length;N++)for(let q=R.length-N;g&&q>=0;q--){g=!1;let re=R.slice(q,q+N).join(s);for(let V=0;!g&&V<i.length;V++)if(V!==v&&i[V]&&i[V].indexOf(re)>-1){const W=q+N===R.length,$=q>0&&i[V].indexOf(s)>-1?s+re:re,U=i[V].endsWith($);g=!W||U}if(!g){let V="";(R[0].endsWith(":")||b!=="")&&(q===1&&(q=0,N++,re=R[0]+s+re),q>0&&(V=R[0]+s),V=b+V),q>0&&(V=V+u+s),V=V+re,q+N<R.length&&(V=V+s+u),l[v]=V}}g&&(l[v]=d)}return l}e.shorten=S;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function c(i,s=Object.create(null)){const l=[];let g=!1,v="";for(const d of i)if(d==="$"||g&&d==="{")v&&l.push({value:v,type:h.TEXT}),v="",g=!0;else if(d==="}"&&g){const b=s[v];if(typeof b=="string")b.length&&l.push({value:b,type:h.VARIABLE});else if(b){const R=l[l.length-1];(!R||R.type!==h.SEPARATOR)&&l.push({value:b.label,type:h.SEPARATOR})}v="",g=!1}else v+=d;return v&&!g&&l.push({value:v,type:h.TEXT}),l.filter((d,b)=>{if(d.type===h.SEPARATOR){const R=l[b-1],N=l[b+1];return[R,N].every(q=>q&&(q.type===h.VARIABLE||q.type===h.TEXT)&&q.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=c;function m(i,s){return y.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function t(i,s){return y.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):y.isWindows?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function o(i){const s=i.indexOf("/")!==-1?I.posix:I.win32,l=s.basename(i),g=s.dirname(i);return l.length?{name:l,parentPath:g}:{name:g,parentPath:""}}e.splitName=o}),define(ge[101],pe([0,1,2,12]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function A(C){return C.toJSON()}class T{constructor(f){this.remoteAuthority=f}transformIncoming(f){return f.scheme===I.Schemas.vscodeRemote?A(_.URI.file(f.path)):f}transformOutgoing(f){return f.scheme===I.Schemas.file?A(_.URI.from({authority:this.remoteAuthority,scheme:I.Schemas.vscodeRemote,path:f.path})):f}transformOutgoingURI(f){return f.scheme===I.Schemas.file?_.URI.from({authority:this.remoteAuthority,scheme:I.Schemas.vscodeRemote,path:f.path}):f}transformOutgoingScheme(f){return f===I.Schemas.file?I.Schemas.vscodeRemote:f}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function y(C,f,p){if(!C||p>200)return null;if(typeof C=="object"){if(C instanceof _.URI)return f.transformOutgoing(C);for(let a in C)if(Object.hasOwnProperty.call(C,a)){const u=y(C[a],f,p+1);u!==null&&(C[a]=u)}}return null}function P(C,f){const p=y(C,f,0);return p===null?C:p}e.transformOutgoingURIs=P;function D(C,f,p,a){if(!C||a>200)return null;if(typeof C=="object"){if(C.$mid===1)return p?_.URI.revive(f.transformIncoming(C)):f.transformIncoming(C);for(let u in C)if(Object.hasOwnProperty.call(C,u)){const E=D(C[u],f,p,a+1);E!==null&&(C[u]=E)}}return null}function k(C,f){const p=D(C,f,!1,0);return p===null?C:p}e.transformIncomingURIs=k;function r(C,f){const p=D(C,f,!0,0);return p===null?C:p}e.transformAndReviveIncomingURIs=r}),define(ge[30],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(D){return _.test(D)}e.isUUID=I;const A=new Uint8Array(16),T=[];for(let D=0;D<256;D++)T.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let k=0;k<D.length;k++)D[k]=Math.floor(Math.random()*256);return D};function P(){y(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let D=0,k="";return k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k}e.generateUuid=P}),define(ge[137],pe([0,1,102]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class I{constructor(T="utf8"){this.stringDecoder=new _.StringDecoder(T),this.remaining=null}write(T){const y=[],P=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(P.length<1)return y;let D=0,k,r=D;for(;r<P.length;)if(k=P.charCodeAt(r),k===13||k===10){if(y.push(P.substring(D,r)),r++,r<P.length){const C=k;k=P.charCodeAt(r),(C===13&&k===10||C===10&&k===13)&&r++}D=r}else r++;return this.remaining=D<P.length?P.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=I}),define(ge[26],pe([0,1,37,44,8,13,10,29,30,75,25,2]),function(G,e,_,I,A,T,y,P,D,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var f;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function p($,U=f.UNLINK){if((0,P.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return U===f.UNLINK?u($):a($)}e.rimraf=p;async function a($){try{const U=(0,A.join)((0,I.tmpdir)(),(0,D.generateUuid)());try{await _.promises.rename($,U)}catch(F){return u($)}u(U).catch(F=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function u($){return _.promises.rmdir($,{recursive:!0,maxRetries:3})}function E($){if((0,P.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");_.rmdirSync($,{recursive:!0})}e.rimrafSync=E;async function w($,U){return c(await(U?S($):_.promises.readdir($)))}e.readdir=w;async function S($){try{return await _.promises.readdir($,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const U=[],F=await w($);for(const M of F){let L=!1,O=!1,B=!1;try{const j=await _.promises.lstat((0,A.join)($,M));L=j.isFile(),O=j.isDirectory(),B=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}U.push({name:M,isFile:()=>L,isDirectory:()=>O,isSymbolicLink:()=>B})}return U}function h($){return c(_.readdirSync($))}e.readdirSync=h;function c($){return $.map(U=>typeof U=="string"?y.isMacintosh?(0,k.normalizeNFC)(U):U:(U.name=y.isMacintosh?(0,k.normalizeNFC)(U.name):U.name,U))}async function m($){const U=await w($),F=[];for(const M of U)await n.existsDirectory((0,A.join)($,M))&&F.push(M);return F}e.readDirsInDir=m;function t($,U=1e3){return new Promise(F=>{let M=!1;const L=setInterval(()=>{M||(M=!0,_.access($,O=>{M=!1,O&&(clearInterval(L),F(void 0))}))},U)})}e.whenDeleted=t;var n;(function($){async function U(L){let O;try{if(O=await _.promises.lstat(L),!O.isSymbolicLink())return{stat:O}}catch(B){}try{return{stat:await _.promises.stat(L),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(y.isWindows&&B.code==="EACCES")try{return{stat:await _.promises.stat(await _.promises.readlink(L)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw j}throw B}}$.stat=U;async function F(L){try{const{stat:O,symbolicLink:B}=await $.stat(L);return O.isFile()&&(B==null?void 0:B.dangling)!==!0}catch(O){}return!1}$.existsFile=F;async function M(L){try{const{stat:O,symbolicLink:B}=await $.stat(L);return O.isDirectory()&&(B==null?void 0:B.dangling)!==!0}catch(O){}return!1}$.existsDirectory=M})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new T.ResourceQueue;function i($,U,F){return o.queueFor(C.URI.file($),r.extUriBiasedIgnorePathCase).queue(()=>{const M=v(F);return new Promise((L,O)=>l($,U,M,B=>B?O(B):L()))})}e.writeFile=i;let s=!0;function l($,U,F,M){if(!s)return _.writeFile($,U,{mode:F.mode,flag:F.flag},M);_.open($,F.flag,F.mode,(L,O)=>{if(L)return M(L);_.writeFile(O,U,B=>{if(B)return _.close(O,()=>M(B));_.fdatasync(O,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),s=!1),_.close(O,Q=>M(Q))))})})}function g($,U,F){const M=v(F);if(!s)return _.writeFileSync($,U,{mode:M.mode,flag:M.flag});const L=_.openSync($,M.flag,M.mode);try{_.writeFileSync(L,U);try{_.fdatasyncSync(L)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),s=!1}}finally{_.closeSync(L)}}e.writeFileSync=g;function v($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function d($,U){if($!==U){async function F(M){try{const L=await _.promises.lstat(M);if(L.isDirectory()||L.isSymbolicLink())return;const O=await _.promises.open(M,"a");try{await O.utimes(L.atime,new Date)}finally{await O.close()}}catch(L){}}try{await _.promises.rename($,U),await F(U)}catch(M){if($.toLowerCase()!==U.toLowerCase()&&M.code==="EXDEV"||$.endsWith("."))await b($,U,{preserveSymlinks:!1}),await p($,f.MOVE),await F(U);else throw M}}}e.move=d;async function b($,U,F){return N($,U,{root:{source:$,target:U},options:F,handledSourcePaths:new Set})}e.copy=b;const R=511;async function N($,U,F){if(!F.handledSourcePaths.has($)){F.handledSourcePaths.add($);const{stat:M,symbolicLink:L}=await n.stat($);if(L){if(F.options.preserveSymlinks)try{return await V($,U,F)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(L.dangling)return}return M.isDirectory()?q($,U,M.mode&R,F):re($,U,M.mode&R)}}async function q($,U,F,M){await _.promises.mkdir(U,{recursive:!0,mode:F});const L=await w($);for(const O of L)await N((0,A.join)($,O),(0,A.join)(U,O),M)}async function re($,U,F){await _.promises.copyFile($,U),await _.promises.chmod(U,F)}async function V($,U,F){let M=await _.promises.readlink($);(0,P.isEqualOrParent)(M,F.root.source,!y.isLinux)&&(M=(0,A.join)(F.root.target,M.substr(F.root.source.length+1))),await _.promises.symlink(M,U)}async function W($){try{return await _.promises.access($),!0}catch(U){return!1}}e.exists=W}),define(ge[103],pe([0,1,37,285,9,8,26]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(C){const f=(0,T.dirname)(C);if(C===f)return C;const p=((0,T.basename)(C)||C).toLowerCase();try{const u=(0,y.readdirSync)(f).filter(E=>E.toLowerCase()===p);if(u.length===1){const E=P(f);if(E)return(0,T.join)(E,u[0])}else if(u.length>1){const E=u.indexOf(p);if(E>=0){const w=P(f);if(w)return(0,T.join)(w,u[E])}}}catch(a){}return null}e.realcaseSync=P;async function D(C){try{return await(0,I.promisify)(_.realpath)(C)}catch(f){const p=r(C);return await _.promises.access(p,_.constants.R_OK),p}}e.realpath=D;function k(C){try{return _.realpathSync(C)}catch(f){const p=r(C);return _.accessSync(p,_.constants.R_OK),p}}e.realpathSync=k;function r(C){return(0,A.rtrim)((0,T.normalize)(C),T.sep)}});var Et=this&&this.__await||function(G){return this instanceof Et?(this.v=G,this):new Et(G)},Fn=this&&this.__asyncGenerator||function(G,e,_){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var I=_.apply(G,e||[]),A,T=[];return A={},y("next"),y("throw"),y("return"),A[Symbol.asyncIterator]=function(){return this},A;function y(f){I[f]&&(A[f]=function(p){return new Promise(function(a,u){T.push([f,p,a,u])>1||P(f,p)})})}function P(f,p){try{D(I[f](p))}catch(a){C(T[0][3],a)}}function D(f){f.value instanceof Et?Promise.resolve(f.value.v).then(k,r):C(T[0][2],f)}function k(f){P("next",f)}function r(f){P("throw",f)}function C(f,p){f(p),T.shift(),T.length&&P(T[0][0],T[0][1])}},mn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],_;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),_={},I("next"),I("throw"),I("return"),_[Symbol.asyncIterator]=function(){return this},_);function I(T){_[T]=G[T]&&function(y){return new Promise(function(P,D){y=G[T](y),A(P,D,y.done,y.value)})}}function A(T,y,P,D){Promise.resolve(D).then(function(k){T({value:k,done:P})},y)}};define(ge[104],pe([0,1,26,44,8]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,y=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var D;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(D||(D={}));let k;switch(process.arch){case"ia32":case"x32":k=1;break;case"arm":case"arm64":k=2;break;default:k=0;break}let r;process.env.PROCESSOR_ARCHITEW6432?r=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?r=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?r=1:r=0;class C{constructor(m,t,n){this.exePath=m,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await _.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:c=!1}={}){return c?k===0?process.env["ProgramFiles(x86)"]||null:r===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:c=!1,findPreview:m=!1}={}){const t=f({useAlternateBitness:c});if(!t)return null;const n=A.join(t,"PowerShell");if(!await _.SymlinkSupport.existsDirectory(n))return null;let o=-1,i=null;for(const g of await _.readdir(n)){let v=-1;if(m){const b=g.indexOf("-");if(b<0)continue;const R=g.substring(0,b);if(!T.test(R)||g.substring(b+1)!=="preview")continue;v=parseInt(R,10)}else{if(!T.test(g))continue;v=parseInt(g,10)}if(!(v<=o)){const d=A.join(n,g,"pwsh.exe");!await _.SymlinkSupport.existsFile(d)||(i=d,o=v)}}if(!i)return null;const s=t.includes("x86")?" (x86)":"",l=m?" Preview":"";return new C(i,`PowerShell${l}${s}`,!0)}async function a({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const m=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await _.SymlinkSupport.existsDirectory(m))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=c?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:y,pwshMsixName:"PowerShell (Store)"};for(const o of await _.readdir(m))if(t.test(o)){const i=A.join(m,o,"pwsh.exe");return new C(i,n)}return null}function u(){const c=A.join(I.homedir(),".dotnet","tools","pwsh.exe");return new C(c,".NET Core PowerShell Global Tool")}function E(){const c=A.join(process.env.windir,k===1&&r!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(c,"Windows PowerShell",!0)}function w(){return Fn(this,arguments,function*(){let m=yield Et(p());m&&(yield yield Et(m)),m=yield Et(p({useAlternateBitness:!0})),m&&(yield yield Et(m)),m=yield Et(a()),m&&(yield yield Et(m)),m=u(),m&&(yield yield Et(m)),m=yield Et(p({findPreview:!0})),m&&(yield yield Et(m)),m=yield Et(a({findPreview:!0})),m&&(yield yield Et(m)),m=yield Et(p({useAlternateBitness:!0,findPreview:!0})),m&&(yield yield Et(m)),m=E(),m&&(yield yield Et(m))})}function S(){return Fn(this,arguments,function*(){var m,t;try{for(var n=mn(w()),o;o=yield Et(n.next()),!o.done;){const i=o.value;(yield Et(i.exists()))&&(yield yield Et(i))}}catch(i){m={error:i}}finally{try{o&&!o.done&&(t=n.return)&&(yield Et(t.call(n)))}finally{if(m)throw m.error}}})}e.enumeratePowerShellInstallations=S;async function h(){var c,m;try{for(var t=mn(S()),n;n=await t.next(),!n.done;)return n.value}catch(o){c={error:o}}finally{try{n&&!n.done&&(m=t.return)&&await m.call(t)}finally{if(c)throw c.error}}return null}e.getFirstAvailablePowerShellInstallation=h}),define(ge[138],pe([0,1,286,287,288]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.monkeyPatch=void 0;function T(D){if(P()){const k=G("http"),r=G("https"),C=y(D);k.globalAgent=C,r.globalAgent=C}}e.monkeyPatch=T;function y(D){return D?new I:new I.default}function P(){let D=!1;const k=A.getProxyForUrl("http://example.com");k&&(D=!0,_.logger.debug(`using $HTTP_PROXY ${k}`));const r=A.getProxyForUrl("https://example.com");return r&&(D=!0,_.logger.debug(`using $HTTPS_PROXY ${r}`)),D}}),define(ge[105],pe([0,1,3,6,13,21,16,22,17,11,58,9]),function(G,e,_,I,A,T,y,P,D,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function p(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(a=e.ResponseType||(e.ResponseType={}));function u(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(E||(E={}));class w{constructor(L){this.buffer=L,this.pos=0}read(L){const O=this.buffer.slice(this.pos,this.pos+L);return this.pos+=O.byteLength,O}}class S{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(L){this.buffers.push(L)}}var h;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(h||(h={}));function c(M){const L=P.VSBuffer.alloc(4);return L.writeUInt32BE(M,0),L}function m(M){return M.read(4).readUInt32BE(0)}function t(M){const L=P.VSBuffer.alloc(1);return L.writeUInt8(M,0),L}const n={Undefined:t(h.Undefined),String:t(h.String),Buffer:t(h.Buffer),VSBuffer:t(h.VSBuffer),Array:t(h.Array),Object:t(h.Object)},o=typeof Buffer!="undefined";function i(M,L){if(typeof L=="undefined")M.write(n.Undefined);else if(typeof L=="string"){const O=P.VSBuffer.fromString(L);M.write(n.String),M.write(c(O.byteLength)),M.write(O)}else if(o&&Buffer.isBuffer(L)){const O=P.VSBuffer.wrap(L);M.write(n.Buffer),M.write(c(O.byteLength)),M.write(O)}else if(L instanceof P.VSBuffer)M.write(n.VSBuffer),M.write(c(L.byteLength)),M.write(L);else if(Array.isArray(L)){M.write(n.Array),M.write(c(L.length));for(const O of L)i(M,O)}else{const O=P.VSBuffer.fromString(JSON.stringify(L));M.write(n.Object),M.write(c(O.byteLength)),M.write(O)}}function s(M){switch(M.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return M.read(m(M)).toString();case h.Buffer:return M.read(m(M)).buffer;case h.VSBuffer:return M.read(m(M));case h.Array:{const O=m(M),B=[];for(let j=0;j<O;j++)B.push(s(M));return B}case h.Object:return JSON.parse(M.read(m(M)).toString())}}class l{constructor(L,O,B=null,j=1e3){this.protocol=L,this.ctx=O,this.logger=B,this.timeoutDelay=j,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(L,O){this.channels.set(L,O),setTimeout(()=>this.flushPendingRequests(L),0)}sendResponse(L){switch(L.type){case 200:{const O=this.send([L.type]);this.logger&&this.logger.logOutgoing(O,0,1,u(L.type));return}case 201:case 202:case 204:case 203:{const O=this.send([L.type,L.id],L.data);this.logger&&this.logger.logOutgoing(O,L.id,1,u(L.type),L.data);return}}}send(L,O=void 0){const B=new S;return i(B,L),i(B,O),this.sendBuffer(B.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(O){return 0}}onRawMessage(L){const O=new w(L),B=s(O),j=s(O),Q=B[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(L.byteLength,B[1],1,`${p(Q)}: ${B[2]}.${B[3]}`,j),this.onPromise({type:Q,id:B[1],channelName:B[2],name:B[3],arg:j});case 102:return this.logger&&this.logger.logIncoming(L.byteLength,B[1],1,`${p(Q)}: ${B[2]}.${B[3]}`,j),this.onEventListen({type:Q,id:B[1],channelName:B[2],name:B[3],arg:j});case 101:return this.logger&&this.logger.logIncoming(L.byteLength,B[1],1,`${p(Q)}`),this.disposeActiveRequest({type:Q,id:B[1]});case 103:return this.logger&&this.logger.logIncoming(L.byteLength,B[1],1,`${p(Q)}`),this.disposeActiveRequest({type:Q,id:B[1]})}}onPromise(L){const O=this.channels.get(L.channelName);if(!O){this.collectPendingRequest(L);return}const B=new T.CancellationTokenSource;let j;try{j=O.call(this.ctx,L.name,L.arg,B.token)}catch(be){j=Promise.reject(be)}const Q=L.id;j.then(be=>{this.sendResponse({id:Q,data:be,type:201}),this.activeRequests.delete(L.id)},be=>{be instanceof Error?this.sendResponse({id:Q,data:{message:be.message,name:be.name,stack:be.stack?be.stack.split?be.stack.split(`
`):be.stack:void 0},type:202}):this.sendResponse({id:Q,data:be,type:203}),this.activeRequests.delete(L.id)});const de=(0,I.toDisposable)(()=>B.cancel());this.activeRequests.set(L.id,de)}onEventListen(L){const O=this.channels.get(L.channelName);if(!O){this.collectPendingRequest(L);return}const B=L.id,Q=O.listen(this.ctx,L.name,L.arg)(de=>this.sendResponse({id:B,data:de,type:204}));this.activeRequests.set(L.id,Q)}disposeActiveRequest(L){const O=this.activeRequests.get(L.id);O&&(O.dispose(),this.activeRequests.delete(L.id))}collectPendingRequest(L){let O=this.pendingRequests.get(L.channelName);O||(O=[],this.pendingRequests.set(L.channelName,O));const B=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.sendResponse({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:L,timeoutTimer:B})}flushPendingRequests(L){const O=this.pendingRequests.get(L);if(O){for(const B of O)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(L)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var g;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(L,O=null){this.protocol=L,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=O}getChannel(L){const O=this;return{call(B,j,Q){return O.isDisposed?Promise.reject(y.canceled()):O.requestPromise(L,B,j,Q)},listen(B,j){return O.isDisposed?Promise.reject(y.canceled()):O.requestEvent(L,B,j)}}}requestPromise(L,O,B,j=T.CancellationToken.None){const Q=this.lastRequestId++,be={id:Q,type:100,channelName:L,name:O,arg:B};if(j.isCancellationRequested)return Promise.reject(y.canceled());let Ae;return new Promise((Le,z)=>{if(j.isCancellationRequested)return z(y.canceled());const Y=()=>{const De=Oe=>{switch(Oe.type){case 201:this.handlers.delete(Q),Le(Oe.data);break;case 202:this.handlers.delete(Q);const we=new Error(Oe.data.message);we.stack=Oe.data.stack,we.name=Oe.data.name,z(we);break;case 203:this.handlers.delete(Q),z(Oe.data);break}};this.handlers.set(Q,De),this.sendRequest(be)};let ee=null;this.state===E.Idle?Y():(ee=(0,A.createCancelablePromise)(De=>this.whenInitialized()),ee.then(()=>{ee=null,Y()}));const ae=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:Q,type:101}),z(y.canceled())},me=j.onCancellationRequested(ae);Ae=(0,I.combinedDisposable)((0,I.toDisposable)(ae),me),this.activeRequests.add(Ae)}).finally(()=>{this.activeRequests.delete(Ae)})}requestEvent(L,O,B){const j=this.lastRequestId++,de={id:j,type:102,channelName:L,name:O,arg:B};let be=null;const Ae=new _.Emitter({onFirstListenerAdd:()=>{be=(0,A.createCancelablePromise)(Le=>this.whenInitialized()),be.then(()=>{be=null,this.activeRequests.add(Ae),this.sendRequest(de)})},onLastListenerRemove:()=>{be?(be.cancel(),be=null):(this.activeRequests.delete(Ae),this.sendRequest({id:j,type:103}))}}),Ce=Le=>Ae.fire(Le.data);return this.handlers.set(j,Ce),Ae.event}sendRequest(L){switch(L.type){case 100:case 102:{const O=this.send([L.type,L.id,L.channelName,L.name],L.arg);this.logger&&this.logger.logOutgoing(O,L.id,0,`${p(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const O=this.send([L.type,L.id]);this.logger&&this.logger.logOutgoing(O,L.id,0,p(L.type));return}}}send(L,O=void 0){const B=new S;return i(B,L),i(B,O),this.sendBuffer(B.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(O){return 0}}onBuffer(L){const O=new w(L),B=s(O),j=s(O),Q=B[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(L.byteLength,0,0,u(Q)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(L.byteLength,B[1],0,u(Q),j),this.onResponse({type:B[0],id:B[1],data:j})}}onResponse(L){if(L.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(L.id);O&&O(L)}whenInitialized(){return this.state===E.Idle?Promise.resolve():_.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}e.ChannelClient=v;class d{constructor(L){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,L(({protocol:O,onDidClientDisconnect:B})=>{_.Event.once(O.onMessage)(Q=>{const de=new w(Q),be=s(de),Ae=new l(O,be),Ce=new v(O);this.channels.forEach((z,Y)=>Ae.registerChannel(Y,z));const Le={channelServer:Ae,channelClient:Ce,ctx:be};this._connections.add(Le),this._onDidAddConnection.fire(Le),B(()=>{Ae.dispose(),Ce.dispose(),this._connections.delete(Le),this._onDidRemoveConnection.fire(Le)})})})}get connections(){const L=[];return this._connections.forEach(O=>L.push(O)),L}getChannel(L,O){const B=this;return{call(j,Q,de){let be;if((0,k.isFunction)(O)){let Ce=(0,D.getRandomElement)(B.connections.filter(O));be=Ce?Promise.resolve(Ce):_.Event.toPromise(_.Event.filter(B.onDidAddConnection,O))}else be=O.routeCall(B,j,Q);const Ae=be.then(Ce=>Ce.channelClient.getChannel(L));return R(Ae).call(j,Q,de)},listen(j,Q){if((0,k.isFunction)(O))return B.getMulticastEvent(L,O,j,Q);const de=O.routeEvent(B,j,Q).then(be=>be.channelClient.getChannel(L));return R(de).listen(j,Q)}}}getMulticastEvent(L,O,B,j){const Q=this;let de=new I.DisposableStore;const be=new _.Emitter({onFirstListenerAdd:()=>{de=new I.DisposableStore;const Ae=new _.EventMultiplexer,Ce=new Map,Le=Y=>{const ae=Y.channelClient.getChannel(L).listen(B,j),me=Ae.add(ae);Ce.set(Y,me)},z=Y=>{const ee=Ce.get(Y);!ee||(ee.dispose(),Ce.delete(Y))};Q.connections.filter(O).forEach(Le),_.Event.filter(Q.onDidAddConnection,O)(Le,void 0,de),Q.onDidRemoveConnection(z,void 0,de),Ae.event(be.fire,be,de),de.add(Ae)},onLastListenerRemove:()=>{de.dispose()}});return be.event}registerChannel(L,O){this.channels.set(L,O),this._connections.forEach(B=>{B.channelServer.registerChannel(L,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=d;class b{constructor(L,O,B=null){const j=new S;i(j,O),L.send(j.buffer),this.channelClient=new v(L,B),this.channelServer=new l(L,O,B)}getChannel(L){return this.channelClient.getChannel(L)}registerChannel(L,O){this.channelServer.registerChannel(L,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=b;function R(M){return{call(L,O,B){return M.then(j=>j.call(L,O,B))},listen(L,O){const B=new _.Relay;return M.then(j=>B.input=j.listen(L,O)),B.event}}}e.getDelayedChannel=R;function N(M){let L=!1;return{call(O,B,j){return L?M.call(O,B,j):(0,A.timeout)(0).then(()=>L=!0).then(()=>M.call(O,B,j))},listen(O,B){if(L)return M.listen(O,B);const j=new _.Relay;return(0,A.timeout)(0).then(()=>L=!0).then(()=>j.input=M.listen(O,B)),j.event}}}e.getNextTickChannel=N;class q{constructor(L){this.fn=L}routeCall(L){return this.route(L)}routeEvent(L){return this.route(L)}async route(L){for(const O of L.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await _.Event.toPromise(L.onDidAddConnection),await this.route(L)}}e.StaticRouter=q;var re;(function(M){function L(j,Q){const de=j,be=Q&&Q.disableMarshalling,Ae=new Map;for(const Ce in de)B(Ce)&&Ae.set(Ce,_.Event.buffer(de[Ce],!0));return new class{listen(Ce,Le){const z=Ae.get(Le);if(z)return z;throw new Error(`Event not found: ${Le}`)}call(Ce,Le,z){const Y=de[Le];if(typeof Y=="function"){if(!be&&Array.isArray(z))for(let ee=0;ee<z.length;ee++)z[ee]=(0,r.revive)(z[ee]);return Y.apply(de,z)}throw new Error(`Method not found: ${Le}`)}}}M.fromService=L;function O(j,Q){const de=Q&&Q.disableMarshalling;return new Proxy({},{get(be,Ae){var Ce;if(typeof Ae=="string")return((Ce=Q==null?void 0:Q.properties)===null||Ce===void 0?void 0:Ce.has(Ae))?Q.properties.get(Ae):B(Ae)?j.listen(Ae):async function(...Le){let z;Q&&!(0,k.isUndefinedOrNull)(Q.context)?z=[Q.context,...Le]:z=Le;const Y=await j.call(Ae,z);return de?Y:(0,r.revive)(Y)};throw new Error(`Property not found: ${String(Ae)}`)}})}M.toService=O;function B(j){return j[0]==="o"&&j[1]==="n"&&C.isUpperAsciiLetter(j.charCodeAt(2))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let L=M.toString();if(L!=="[object Object]")return L}return M}function $(M){return Array.isArray(M)?M.map(W):W(M)}function U(M,L,O,B,j,Q,de){de=$(de);const be=V[j],Ae=be[B%be.length];let Ce=[`%c[${M}]%c[${String(L).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${Ae}`];/\($/.test(Q)?(Ce=Ce.concat(de),Ce.push(")")):Ce.push(de),console.log.apply(console,Ce)}e.logWithColors=U;class F{constructor(L,O){this._outgoingPrefix=L,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(L,O,B,j,Q){this._totalOutgoing+=L,U(this._outgoingPrefix,this._totalOutgoing,L,O,B,j,Q)}logIncoming(L,O,B,j,Q){this._totalIncoming+=L,U(this._incomingPrefix,this._totalIncoming,L,O,B,j,Q)}}e.IPCLogger=F}),define(ge[106],pe([0,1,3,105,6,22,10,36]),function(G,e,_,I,A,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function k(){return D||(D=T.VSBuffer.alloc(0)),D}class r{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,i){if(o===0)return k();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const v=this._chunks[0];return i&&(this._chunks.shift(),this._totalLength-=o),v}if(this._chunks[0].byteLength>o){const v=this._chunks[0].slice(0,o);return i&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),v}let s=T.VSBuffer.alloc(o),l=0,g=0;for(;o>0;){const v=this._chunks[g];if(v.byteLength>o){const d=v.slice(0,o);s.set(d,l),l+=o,i&&(this._chunks[g]=v.slice(o),this._totalLength-=o),o-=o}else s.set(v,l),l+=v.byteLength,i?(this._chunks.shift(),this._totalLength-=v.byteLength):g++,o-=v.byteLength}return s}}e.ChunkStream=r;var C;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(C||(C={}));var f;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(o,i,s,l){this.type=o,this.id=i,this.ack=s,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends A.Disposable{constructor(o){super();this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new r,this._register(this._socket.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const i=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=i.readUInt32BE(9),this._state.messageType=i.readUInt8(0),this._state.id=i.readUInt32BE(1),this._state.ack=i.readUInt32BE(5);else{const s=this._state.messageType,l=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new p(s,l,g,i)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=T.VSBuffer.alloc(13);i.writeUInt8(o.type,0),i.writeUInt32BE(o.id,1),i.writeUInt32BE(o.ack,5),i.writeUInt32BE(o.data.byteLength,9),this._writeSoon(i,o.data)}}_bufferAdd(o,i){const s=this._totalLength===0;return this._data.push(o,i),this._totalLength+=o.byteLength+i.byteLength,s}_bufferTake(){const o=T.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,i){this._bufferAdd(o,i)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends A.Disposable{constructor(o){super();this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(i=>{i.type===1&&this._onMessage.fire(i.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new p(1,0,0,o))}}e.Protocol=E;class w extends I.IPCClient{constructor(o,i,s=null){super(o,i,s);this.protocol=o}static fromSocket(o,i){return new w(new E(o),i)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=w;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class h{constructor(o){this.data=o,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],i=0,s=this._first;for(;s;)o[i++]=s.data,s=s.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const i=new h(o);if(!this._first){this._first=i,this._last=i;return}this._last.next=i,this._last=i}}class m{constructor(){this.lastRuns=[];const o=Date.now();for(let i=0;i<m._HISTORY_LENGTH;i++)this.lastRuns[i]=o-1e3*i;setInterval(()=>{for(let i=m._HISTORY_LENGTH;i>=1;i--)this.lastRuns[i]=this.lastRuns[i-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return m._INSTANCE||(m._INSTANCE=new m),m._INSTANCE}load(){const o=Date.now(),i=(1+m._HISTORY_LENGTH)*1e3;let s=0;for(let l=0;l<m._HISTORY_LENGTH;l++)o-this.lastRuns[l]<=i&&s++;return 1-s/m._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}m._HISTORY_LENGTH=10,m._INSTANCE=null;class t{constructor(o,i=null){this._loadEstimator=m.getInstance(),this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),i&&this._socketReader.acceptChunk(i),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,A.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new p(5,0,0,k());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const i=new p(4,0,0,k());this._socketWriter.write(i),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}setSocket(o){this._socket=o}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,i){this._isReconnecting=!0,this._socketDisposables=(0,A.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(i)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let i=0,s=o.length;i<s;i++)this._socketWriter.write(o[i]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const i=this._outgoingUnackMsg.peek();if(i&&i.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const i=Date.now();i-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=i,this._socketWriter.write(new p(6,0,0,k())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const i=this._outgoingUnackMsg.toArray();for(let s=0,l=i.length;s<l;s++)this._socketWriter.write(i[s]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const i=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const s=new p(1,i,this._incomingAckId,o);this._outgoingUnackMsg.push(s),this._isReconnecting||(this._socketWriter.write(s),this._recvAckCheck())}sendControl(o){const i=new p(2,0,0,o);this._socketWriter.write(i)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),i=Date.now()-o.writtenTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-i,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new p(3,0,this._incomingAckId,k());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(ge[107],pe([0,1,96]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(P){let D=(0,_.toUint8)(P);this._defaultValue=D,this._asciiMap=I._createAsciiMap(D),this._map=new Map}static _createAsciiMap(P){let D=new Uint8Array(256);for(let k=0;k<256;k++)D[k]=P;return D}set(P,D){let k=(0,_.toUint8)(D);P>=0&&P<256?this._asciiMap[P]=k:this._map.set(P,k)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=I;var A;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(A||(A={}));class T{constructor(){this._actual=new I(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=T}),define(ge[139],pe([0,1,107]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class A extends _.CharacterClassifier{constructor(P){super(0);for(let D=0,k=P.length;D<k;D++)this.set(P.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=A;function T(y){let P={};return D=>(P.hasOwnProperty(D)||(P[D]=y(D)),P[D])}e.getMapForWordSeparators=T(y=>new A(y))}),define(ge[49],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(A,T){this.lineNumber=A,this.column=T}with(A=this.lineNumber,T=this.column){return A===this.lineNumber&&T===this.column?this:new _(A,T)}delta(A=0,T=0){return this.with(this.lineNumber+A,this.column+T)}equals(A){return _.equals(this,A)}static equals(A,T){return!A&&!T?!0:!!A&&!!T&&A.lineNumber===T.lineNumber&&A.column===T.column}isBefore(A){return _.isBefore(this,A)}static isBefore(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<T.column}isBeforeOrEqual(A){return _.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<=T.column}static compare(A,T){let y=A.lineNumber|0,P=T.lineNumber|0;if(y===P){let D=A.column|0,k=T.column|0;return D-k}return y-P}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new _(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}e.Position=_}),define(ge[45],pe([0,1,49]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(T,y,P,D){T>P||T===P&&y>D?(this.startLineNumber=P,this.startColumn=D,this.endLineNumber=T,this.endColumn=y):(this.startLineNumber=T,this.startColumn=y,this.endLineNumber=P,this.endColumn=D)}isEmpty(){return I.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return I.containsPosition(this,T)}static containsPosition(T,y){return!(y.lineNumber<T.startLineNumber||y.lineNumber>T.endLineNumber||y.lineNumber===T.startLineNumber&&y.column<T.startColumn||y.lineNumber===T.endLineNumber&&y.column>T.endColumn)}containsRange(T){return I.containsRange(this,T)}static containsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>T.endColumn)}strictContainsRange(T){return I.strictContainsRange(this,T)}static strictContainsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<=T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>=T.endColumn)}plusRange(T){return I.plusRange(this,T)}static plusRange(T,y){let P,D,k,r;return y.startLineNumber<T.startLineNumber?(P=y.startLineNumber,D=y.startColumn):y.startLineNumber===T.startLineNumber?(P=y.startLineNumber,D=Math.min(y.startColumn,T.startColumn)):(P=T.startLineNumber,D=T.startColumn),y.endLineNumber>T.endLineNumber?(k=y.endLineNumber,r=y.endColumn):y.endLineNumber===T.endLineNumber?(k=y.endLineNumber,r=Math.max(y.endColumn,T.endColumn)):(k=T.endLineNumber,r=T.endColumn),new I(P,D,k,r)}intersectRanges(T){return I.intersectRanges(this,T)}static intersectRanges(T,y){let P=T.startLineNumber,D=T.startColumn,k=T.endLineNumber,r=T.endColumn,C=y.startLineNumber,f=y.startColumn,p=y.endLineNumber,a=y.endColumn;return P<C?(P=C,D=f):P===C&&(D=Math.max(D,f)),k>p?(k=p,r=a):k===p&&(r=Math.min(r,a)),P>k||P===k&&D>r?null:new I(P,D,k,r)}equalsRange(T){return I.equalsRange(this,T)}static equalsRange(T,y){return!!T&&!!y&&T.startLineNumber===y.startLineNumber&&T.startColumn===y.startColumn&&T.endLineNumber===y.endLineNumber&&T.endColumn===y.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(T){return new _.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(T){return new _.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,y){return new I(this.startLineNumber,this.startColumn,T,y)}setStartPosition(T,y){return new I(T,y,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(T){return new I(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,y=T){return new I(T.lineNumber,T.column,y.lineNumber,y.column)}static lift(T){return T?new I(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn)}static areIntersecting(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,y){if(T&&y){const k=T.startLineNumber|0,r=y.startLineNumber|0;if(k===r){const C=T.startColumn|0,f=y.startColumn|0;if(C===f){const p=T.endLineNumber|0,a=y.endLineNumber|0;if(p===a){const u=T.endColumn|0,E=y.endColumn|0;return u-E}return p-a}return C-f}return k-r}return(T?1:0)-(y?1:0)}static compareRangesUsingEnds(T,y){return T.endLineNumber===y.endLineNumber?T.endColumn===y.endColumn?T.startLineNumber===y.startLineNumber?T.startColumn-y.startColumn:T.startLineNumber-y.startLineNumber:T.endColumn-y.endColumn:T.endLineNumber-y.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=I}),define(ge[140],pe([0,1,49,45]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var A;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(A=e.SelectionDirection||(e.SelectionDirection={}));class T extends I.Range{constructor(P,D,k,r){super(P,D,k,r);this.selectionStartLineNumber=P,this.selectionStartColumn=D,this.positionLineNumber=k,this.positionColumn=r}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return T.selectionsEqual(this,P)}static selectionsEqual(P,D){return P.selectionStartLineNumber===D.selectionStartLineNumber&&P.selectionStartColumn===D.selectionStartColumn&&P.positionLineNumber===D.positionLineNumber&&P.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,D){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,P,D):new T(P,D,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(P,D){return this.getDirection()===0?new T(P,D,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,P,D)}static fromPositions(P,D=P){return new T(P.lineNumber,P.column,D.lineNumber,D.column)}static liftSelection(P){return new T(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,D){if(P&&!D||!P&&D)return!1;if(!P&&!D)return!0;if(P.length!==D.length)return!1;for(let k=0,r=P.length;k<r;k++)if(!this.selectionsEqual(P[k],D[k]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,D,k,r,C){return C===0?new T(P,D,k,r):new T(k,r,P,D)}}e.Selection=T}),define(ge[108],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var _;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(_=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(a){this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace)}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class D{constructor(a,u){this.range=a,this.matches=u}}e.FindMatch=D;var k;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var r;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(r=e.ModelConstants||(e.ModelConstants={}));class C{constructor(a,u,E,w,S,h){this.identifier=a,this.range=u,this.text=E,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=S,this._isTracked=h}}e.ValidAnnotatedEditOperation=C;class f{constructor(a,u,E){this.reverseEdits=a,this.changes=u,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=f}),define(ge[141],pe([0,1,9,139,49,45,108]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class D{constructor(h,c,m,t){this.searchString=h,this.isRegex=c,this.matchCase=m,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let h;this.isRegex?h=k(this.searchString):h=this.searchString.indexOf(`
`)>=0;let c=null;try{c=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:h,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let m=!this.isRegex&&!h;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new r(c,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,m?this.searchString:null)}}e.SearchParams=D;function k(S){if(!S||S.length===0)return!1;for(let h=0,c=S.length;h<c;h++)if(S.charCodeAt(h)===92){if(h++,h>=c)break;const t=S.charCodeAt(h);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class r{constructor(h,c,m){this.regex=h,this.wordSeparators=c,this.simpleSearch=m}}e.SearchData=r;function C(S,h,c){if(!c)return new y.FindMatch(S,null);let m=[];for(let t=0,n=h.length;t<n;t++)m[t]=h[t];return new y.FindMatch(S,m)}e.createFindMatch=C;class f{constructor(h){let c=[],m=0;for(let t=0,n=h.length;t<n;t++)h.charCodeAt(t)===10&&(c[m++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(h){const c=this._lineFeedsOffsets;let m=0,t=c.length-1;if(t===-1||h<=c[0])return 0;for(;m<t;){const n=m+((t-m)/2>>0);c[n]>=h?t=n-1:c[n+1]>=h?(m=n,t=n):m=n+1}return m+1}}class p{static findMatches(h,c,m,t,n){const o=c.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(h,m,new w(o.wordSeparators,o.regex),t,n):this._doFindMatchesLineByLine(h,m,o,t,n):[]}static _getMultilineMatchRange(h,c,m,t,n,o){let i,s=0;t?(s=t.findLineFeedCountBeforeOffset(n),i=c+n+s):i=c+n;let l;if(t){let b=t.findLineFeedCountBeforeOffset(n+o.length)-s;l=i+o.length+b}else l=i+o.length;const g=h.getPositionAt(i),v=h.getPositionAt(l);return new T.Range(g.lineNumber,g.column,v.lineNumber,v.column)}static _doFindMatchesMultiline(h,c,m,t,n){const o=h.getOffsetAt(c.getStartPosition()),i=h.getValueInRange(c,1),s=h.getEOL()===`\r
`?new f(i):null,l=[];let g=0,v;for(m.reset(0);v=m.next(i);)if(l[g++]=C(this._getMultilineMatchRange(h,o,i,s,v.index,v[0]),v,t),g>=n)return l;return l}static _doFindMatchesLineByLine(h,c,m,t,n){const o=[];let i=0;if(c.startLineNumber===c.endLineNumber){const l=h.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return i=this._findMatchesInLine(m,l,c.startLineNumber,c.startColumn-1,i,o,t,n),o}const s=h.getLineContent(c.startLineNumber).substring(c.startColumn-1);i=this._findMatchesInLine(m,s,c.startLineNumber,c.startColumn-1,i,o,t,n);for(let l=c.startLineNumber+1;l<c.endLineNumber&&i<n;l++)i=this._findMatchesInLine(m,h.getLineContent(l),l,0,i,o,t,n);if(i<n){const l=h.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);i=this._findMatchesInLine(m,l,c.endLineNumber,0,i,o,t,n)}return o}static _findMatchesInLine(h,c,m,t,n,o,i,s){const l=h.wordSeparators;if(!i&&h.simpleSearch){const d=h.simpleSearch,b=d.length,R=c.length;let N=-b;for(;(N=c.indexOf(d,N+b))!==-1;)if((!l||E(l,c,R,N,b))&&(o[n++]=new y.FindMatch(new T.Range(m,N+1+t,m,N+1+b+t),null),n>=s))return n;return n}const g=new w(h.wordSeparators,h.regex);let v;g.reset(0);do if(v=g.next(c),v&&(o[n++]=C(new T.Range(m,v.index+1+t,m,v.index+1+v[0].length+t),v,i),n>=s))return n;while(v);return n}static findNextMatch(h,c,m,t){const n=c.parseSearchRequest();if(!n)return null;const o=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(h,m,o,t):this._doFindNextMatchLineByLine(h,m,o,t)}static _doFindNextMatchMultiline(h,c,m,t){const n=new A.Position(c.lineNumber,1),o=h.getOffsetAt(n),i=h.getLineCount(),s=h.getValueInRange(new T.Range(n.lineNumber,n.column,i,h.getLineMaxColumn(i)),1),l=h.getEOL()===`\r
`?new f(s):null;m.reset(c.column-1);let g=m.next(s);return g?C(this._getMultilineMatchRange(h,o,s,l,g.index,g[0]),g,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(h,new A.Position(1,1),m,t):null}static _doFindNextMatchLineByLine(h,c,m,t){const n=h.getLineCount(),o=c.lineNumber,i=h.getLineContent(o),s=this._findFirstMatchInLine(m,i,o,c.column,t);if(s)return s;for(let l=1;l<=n;l++){const g=(o+l-1)%n,v=h.getLineContent(g+1),d=this._findFirstMatchInLine(m,v,g+1,1,t);if(d)return d}return null}static _findFirstMatchInLine(h,c,m,t,n){h.reset(t-1);const o=h.next(c);return o?C(new T.Range(m,o.index+1,m,o.index+1+o[0].length),o,n):null}static findPreviousMatch(h,c,m,t){const n=c.parseSearchRequest();if(!n)return null;const o=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(h,m,o,t):this._doFindPreviousMatchLineByLine(h,m,o,t)}static _doFindPreviousMatchMultiline(h,c,m,t){const n=this._doFindMatchesMultiline(h,new T.Range(1,1,c.lineNumber,c.column),m,t,10*P);if(n.length>0)return n[n.length-1];const o=h.getLineCount();return c.lineNumber!==o||c.column!==h.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(h,new A.Position(o,h.getLineMaxColumn(o)),m,t):null}static _doFindPreviousMatchLineByLine(h,c,m,t){const n=h.getLineCount(),o=c.lineNumber,i=h.getLineContent(o).substring(0,c.column-1),s=this._findLastMatchInLine(m,i,o,t);if(s)return s;for(let l=1;l<=n;l++){const g=(n+o-l-1)%n,v=h.getLineContent(g+1),d=this._findLastMatchInLine(m,v,g+1,t);if(d)return d}return null}static _findLastMatchInLine(h,c,m,t){let n=null,o;for(h.reset(0);o=h.next(c);)n=C(new T.Range(m,o.index+1,m,o.index+1+o[0].length),o,t);return n}}e.TextModelSearch=p;function a(S,h,c,m,t){if(m===0)return!0;const n=h.charCodeAt(m-1);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const o=h.charCodeAt(m);if(S.get(o)!==0)return!0}return!1}function u(S,h,c,m,t){if(m+t===c)return!0;const n=h.charCodeAt(m+t);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const o=h.charCodeAt(m+t-1);if(S.get(o)!==0)return!0}return!1}function E(S,h,c,m,t){return a(S,h,c,m,t)&&u(S,h,c,m,t)}e.isValidMatch=E;class w{constructor(h,c){this._wordSeparators=h,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(h){this._searchRegex.lastIndex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(h){const c=h.length;let m;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(m=this._searchRegex.exec(h),!m))return null;const t=m.index,n=m[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){_.getNextCodePoint(h,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||E(this._wordSeparators,h,c,t,n))return m}while(m);return null}}e.Searcher=w}),define(ge[109],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function _(P=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)P.indexOf(k)>=0||(D+="\\"+k);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=_();function I(P){let D=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)D=P;else{let k="g";P.ignoreCase&&(k+="i"),P.multiline&&(k+="m"),P.unicode&&(k+="u"),D=new RegExp(P.source,k)}return D.lastIndex=0,D}e.ensureValidWordDefinition=I;const A={maxLen:1e3,windowSize:15,timeBudget:150};function T(P,D,k,r,C=A){if(k.length>C.maxLen){let E=P-C.maxLen/2;return E<0?E=0:r+=E,k=k.substring(E,P+C.maxLen/2),T(P,D,k,r,C)}const f=Date.now(),p=P-1-r;let a=-1,u=null;for(let E=1;!(Date.now()-f>=C.timeBudget);E++){const w=p-C.windowSize*E;D.lastIndex=Math.max(0,w);const S=y(D,k,p,a);if(!S&&u||(u=S,w<=0))break;a=w}if(u){let E={word:u[0],startColumn:r+1+u.index,endColumn:r+1+u.index+u[0].length};return D.lastIndex=0,E}return null}e.getWordAtText=T;function y(P,D,k,r){let C;for(;C=P.exec(D);){const f=C.index||0;if(f<=k&&P.lastIndex>=k)return C;if(r>0&&f>r)return null}return null}}),define(ge[142],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(_=e.IndentAction||(e.IndentAction={}));class I{constructor(P){if(this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let D=0,k=P.notIn.length;D<k;D++)switch(P.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=I;class A{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of P)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=A;function T(y,P,D){y.has(P)?y.get(P).push(D):y.set(P,[D])}}),define(ge[77],pe([0,1,33,8]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function A(T,y,P,D){if(Array.isArray(T)){let k=0;for(const r of T){const C=A(r,y,P,D);if(C===10)return C;C>k&&(k=C)}return k}else{if(typeof T=="string")return D?T==="*"?5:T===P?10:0:0;if(T){const{language:k,pattern:r,scheme:C,hasAccessToAllModels:f}=T;if(!D&&!f)return 0;let p=0;if(C)if(C===y.scheme)p=10;else if(C==="*")p=5;else return 0;if(k)if(k===P)p=10;else if(k==="*")p=Math.max(p,5);else return 0;if(r){let a;if(typeof r=="string"?a=r:a=Object.assign(Object.assign({},r),{base:(0,I.normalize)(r.base)}),a===y.fsPath||(0,_.match)(a,y.fsPath))p=10;else return 0}return p}else return 0}}e.score=A}),define(ge[143],pe([0,1,107]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class A{constructor(a,u,E){const w=new Uint8Array(a*u);for(let S=0,h=a*u;S<h;S++)w[S]=E;this._data=w,this.rows=a,this.cols=u}get(a,u){return this._data[a*this.cols+u]}set(a,u,E){this._data[a*this.cols+u]=E}}e.Uint8Matrix=A;class T{constructor(a){let u=0,E=0;for(let S=0,h=a.length;S<h;S++){let[c,m,t]=a[S];m>u&&(u=m),c>E&&(E=c),t>E&&(E=t)}u++,E++;let w=new A(E,u,0);for(let S=0,h=a.length;S<h;S++){let[c,m,t]=a[S];w.set(c,m,t)}this._states=w,this._maxCharCode=u}nextState(a,u){return u<0||u>=this._maxCharCode?0:this._states.get(a,u)}}e.StateMachine=T;let y=null;function P(){return y===null&&(y=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let k=null;function r(){if(k===null){k=new _.CharacterClassifier(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<p.length;u++)k.set(p.charCodeAt(u),1);const a=".,;";for(let u=0;u<a.length;u++)k.set(a.charCodeAt(u),2)}return k}class C{static _createLink(a,u,E,w,S){let h=S-1;do{const c=u.charCodeAt(h);if(a.get(c)!==2)break;h--}while(h>w);if(w>0){const c=u.charCodeAt(w-1),m=u.charCodeAt(h);(c===40&&m===41||c===91&&m===93||c===123&&m===125)&&h--}return{range:{startLineNumber:E,startColumn:w+1,endLineNumber:E,endColumn:h+2},url:u.substring(w,h+1)}}static computeLinks(a,u=P()){const E=r();let w=[];for(let S=1,h=a.getLineCount();S<=h;S++){const c=a.getLineContent(S),m=c.length;let t=0,n=0,o=0,i=1,s=!1,l=!1,g=!1,v=!1;for(;t<m;){let d=!1;const b=c.charCodeAt(t);if(i===13){let R;switch(b){case 40:s=!0,R=0;break;case 41:R=s?0:1;break;case 91:g=!0,l=!0,R=0;break;case 93:g=!1,R=l?0:1;break;case 123:v=!0,R=0;break;case 125:R=v?0:1;break;case 39:R=o===34||o===96?0:1;break;case 34:R=o===39||o===96?0:1;break;case 96:R=o===39||o===34?0:1;break;case 42:R=o===42?1:0;break;case 124:R=o===124?1:0;break;case 32:R=g?0:1;break;default:R=E.get(b)}R===1&&(w.push(C._createLink(E,c,S,n,t)),d=!0)}else if(i===12){let R;b===91?(l=!0,R=0):R=E.get(b),R===1?d=!0:i=13}else i=u.nextState(i,b),i===0&&(d=!0);d&&(i=1,s=!1,l=!1,v=!1,n=t+1,o=b),t++}i===13&&w.push(C._createLink(E,c,S,n,m))}return w}}e.LinkComputer=C;function f(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:C.computeLinks(p)}e.computeLinks=f}),define(ge[144],pe([0,1,3,6]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class A{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,P){return this._map.set(y,P),this.fire([y]),(0,I.toDisposable)(()=>{this._map.get(y)===P&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,P){let D=null,k=!1;return this._promises.set(y,P.then(r=>{this._promises.delete(y),!(k||!r)&&(D=this.register(y,r))})),(0,I.toDisposable)(()=>{k=!0,D&&D.dispose()})}getPromise(y){const P=this.get(y);if(P)return Promise.resolve(P);const D=this._promises.get(y);return D?D.then(k=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=A}),define(ge[110],pe([0,1,22,10]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var A;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(A||(A={}));function T(C){for(let f=0,p=C.length;f<p;f+=4){const a=C[f+0],u=C[f+1],E=C[f+2],w=C[f+3];C[f+0]=w,C[f+1]=E,C[f+2]=u,C[f+3]=a}}function y(C){const f=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return I.isLittleEndian()||T(f),_.VSBuffer.wrap(f)}function P(C){const f=C.buffer;if(I.isLittleEndian()||T(f),f.byteOffset%4==0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const p=new Uint8Array(f.byteLength);return p.set(f),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function D(C){const f=new Uint32Array(k(C));let p=0;if(f[p++]=C.id,C.type==="full")f[p++]=1,f[p++]=C.data.length,f.set(C.data,p),p+=C.data.length;else{f[p++]=2,f[p++]=C.deltas.length;for(const a of C.deltas)f[p++]=a.start,f[p++]=a.deleteCount,a.data?(f[p++]=a.data.length,f.set(a.data,p),p+=a.data.length):f[p++]=0}return y(f)}e.encodeSemanticTokensDto=D;function k(C){let f=0;if(f+=1+1,C.type==="full")f+=1+C.data.length;else{f+=1,f+=(1+1+1)*C.deltas.length;for(const p of C.deltas)p.data&&(f+=p.data.length)}return f}function r(C){const f=P(C);let p=0;const a=f[p++];if(f[p++]===1){const S=f[p++],h=f.subarray(p,p+S);return p+=S,{id:a,type:"full",data:h}}const E=f[p++];let w=[];for(let S=0;S<E;S++){const h=f[p++],c=f[p++],m=f[p++];let t;m>0&&(t=f.subarray(p,p+m),p+=m),w[S]={start:h,deleteCount:c,data:t}}return{id:a,type:"delta",deltas:w}}e.decodeSemanticTokensDto=r}),define(ge[111],pe([0,1,96]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(y,P){this.index=y,this.remainder=P}}e.PrefixSumIndexOfResult=I;class A{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,P){y=(0,_.toUint32)(y);const D=this.values,k=this.prefixSum,r=P.length;return r===0?!1:(this.values=new Uint32Array(D.length+r),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+r),this.values.set(P,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,P){return y=(0,_.toUint32)(y),P=(0,_.toUint32)(P),this.values[y]===P?!1:(this.values[y]=P,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,P){y=(0,_.toUint32)(y),P=(0,_.toUint32)(P);const D=this.values,k=this.prefixSum;if(y>=D.length)return!1;let r=D.length-y;return P>=r&&(P=r),P===0?!1:(this.values=new Uint32Array(D.length-P),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+P),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,_.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),y>=this.values.length&&(y=this.values.length-1);for(let D=P;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let P=0,D=this.values.length-1,k=0,r=0,C=0;for(;P<=D;)if(k=P+(D-P)/2|0,r=this.prefixSum[k],C=r-this.values[k],y<C)D=k-1;else if(y>=r)P=k+1;else break;return new I(k,y-C)}}e.PrefixSumComputer=A}),define(ge[145],pe([0,1,9,49,111]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(P,D,k,r){this._uri=P,this._lines=D,this._eol=k,this._versionId=r,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const D=P.changes;for(const k of D)this._acceptDeleteRange(k.range),this._acceptInsertText(new I.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,D=this._lines.length,k=new Uint32Array(D);for(let r=0;r<D;r++)k[r]=this._lines[r].length+P;this._lineStarts=new A.PrefixSumComputer(k)}}_setLineText(P,D){this._lines[P]=D,this._lineStarts&&this._lineStarts.changeValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,D){if(D.length!==0){let k=(0,_.splitLines)(D);if(k.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+k[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}k[k.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+k[0]);let r=new Uint32Array(k.length-1);for(let C=1;C<k.length;C++)this._lines.splice(P.lineNumber+C-1,0,k[C]),r[C-1]=k[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,r)}}}e.MirrorTextModel=T}),define(ge[146],pe([18,19]),function(G,e){return G.create("vs/base/common/date",e)}),define(ge[147],pe([0,1,146]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,A=I*60,T=A*24,y=T*7,P=T*30,D=T*365;function k(C,f){typeof C!="number"&&(C=C.getTime());const p=Math.round((new Date().getTime()-C)/1e3);if(p<-30)return(0,_.localize)(0,null,k(new Date().getTime()+p*1e3,!1));if(p<30)return(0,_.localize)(1,null);let a;return p<I?(a=p,f?a===1?(0,_.localize)(2,null,a):(0,_.localize)(3,null,a):a===1?(0,_.localize)(4,null,a):(0,_.localize)(5,null,a)):p<A?(a=Math.floor(p/I),f?a===1?(0,_.localize)(6,null,a):(0,_.localize)(7,null,a):a===1?(0,_.localize)(8,null,a):(0,_.localize)(9,null,a)):p<T?(a=Math.floor(p/A),f?a===1?(0,_.localize)(10,null,a):(0,_.localize)(11,null,a):a===1?(0,_.localize)(12,null,a):(0,_.localize)(13,null,a)):p<y?(a=Math.floor(p/T),f?a===1?(0,_.localize)(14,null,a):(0,_.localize)(15,null,a):a===1?(0,_.localize)(16,null,a):(0,_.localize)(17,null,a)):p<P?(a=Math.floor(p/y),f?a===1?(0,_.localize)(18,null,a):(0,_.localize)(19,null,a):a===1?(0,_.localize)(20,null,a):(0,_.localize)(21,null,a)):p<D?(a=Math.floor(p/P),f?a===1?(0,_.localize)(22,null,a):(0,_.localize)(23,null,a):a===1?(0,_.localize)(24,null,a):(0,_.localize)(25,null,a)):(a=Math.floor(p/D),f?a===1?(0,_.localize)(26,null,a):(0,_.localize)(27,null,a):a===1?(0,_.localize)(28,null,a):(0,_.localize)(29,null,a))}e.fromNow=k;function r(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=r}),define(ge[148],pe([18,19]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ge[59],pe([0,1,148,11,17]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(k,r){return r&&(k.stack||k.stacktrace)?_.localize(0,null,P(k),y(k.stack)||y(k.stacktrace)):P(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?_.localize(1,null,k.message):k.message||_.localize(2,null)}function D(k=null,r=!1){if(!k)return _.localize(3,null);if(Array.isArray(k)){const C=A.coalesce(k),f=D(C[0],r);return C.length>1?_.localize(4,null,f,C.length):f}if(I.isString(k))return k;if(k.detail){const C=k.detail;if(C.error)return T(C.error,r);if(C.exception)return T(C.exception,r)}return k.stack?T(k,r):k.message?k.message:_.localize(5,null)}e.toErrorMessage=D}),define(ge[149],pe([18,19]),function(G,e){return G.create("vs/base/node/processes",e)}),define(ge[78],pe([0,1,8,37,26,38,149,36,11,23,29,10,137,12]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function a(m){switch(m){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(m,t){if(C.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const o=T.execFile("taskkill",["/T","/F","/PID",m.pid.toString()],n);return new Promise(i=>{o.once("error",s=>{i({success:!1,error:s})}),o.once("exit",(s,l)=>{i(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?a(n.status):1})}else if(C.isLinux||C.isMacintosh)try{const n=p.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(o=>{T.execFile(n,[m.pid.toString()],{encoding:"utf8",shell:!0},(i,s,l)=>{o(i?{success:!1,error:i}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else m.kill("SIGKILL");return Promise.resolve({success:!0})}function E(m=P.env){return m.comspec||"cmd.exe"}e.getWindowsShell=E;class w{constructor(t,n,o,i){if(n!==void 0&&o!==void 0&&i!==void 0)this.cmd=t,this.args=n,this.shell=o,this.options=i;else{const s=t;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(P.env).forEach(l=>{s[l]=P.env[l]}),Object.keys(this.options.env).forEach(l=>{s[l]=this.options.env[l]}),this.options.env=s}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(_.sep);return n!==-1&&(t=t.substring(n+1)),w.WellKnowCommands[t]?t:"other"}start(t){return C.isWindows&&(this.options&&this.options.cwd&&r.isUNC(this.options.cwd)||!this.options&&r.isUNC(P.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(n=>{let o,i;const s=new Promise((l,g)=>{o=l,i=g});if(n){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=T.exec(l,this.options,(g,v,d)=>{this.childProcess=null;const b=g;b&&b.killed?i({killed:this.terminateRequested,stdout:v.toString(),stderr:d.toString()}):this.handleExec(o,t,g,v,d)})}else{let l=null;const g=v=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(v,o,t,i);const d={terminated:this.terminateRequested};D.isNumber(v)&&(d.cmdCode=v),o(d)};if(this.shell&&C.isWindows){const v=k.deepClone(this.options);v.windowsVerbatimArguments=!0,v.detached=!1;let d=!1,b=!1;const R=[];let N=this.ensureQuotes(this.cmd);R.push(N.value),d=N.quoted,this.args&&this.args.forEach(re=>{N=this.ensureQuotes(re),R.push(N.value),b=b&&N.quoted});const q=["/s","/c"];d?b?q.push('"'+R.join(" ")+'"'):R.length>1?q.push('"'+R[0]+'" '+R.slice(1).join(" ")):q.push('"'+R[0]+'"'):q.push(R.join(" ")),l=T.spawn(E(),q,v)}else this.cmd&&(l=T.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(D.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",v=>{this.childProcess=null,i({terminated:this.terminateRequested,error:v})}),l.pid&&(this.childProcess.on("close",g),this.handleSpawn(l,o,t,i,!0)))}return s})}handleClose(t,n,o,i){}ensureQuotes(t){return w.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,u(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!C.isWindows)return t(!1);const n=T.spawn(E(),["/s","/c"]);n.on("error",o=>t(!0)),n.on("exit",o=>t(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class S extends w{constructor(t,n,o,i){super(t,n,o,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,o,i,s){[i,s].forEach((l,g)=>{const v=new f.LineDecoder;v.write(l).forEach(R=>{n({line:R,source:g===0?0:1})});const b=v.end();b&&n({line:b,source:g===0?0:1})}),t({terminated:this.terminateRequested,error:o})}handleSpawn(t,n,o,i,s){const l=new f.LineDecoder,g=new f.LineDecoder;t.stdout.on("data",v=>{l.write(v).forEach(b=>o({line:b,source:0}))}),t.stderr.on("data",v=>{g.write(v).forEach(b=>o({line:b,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=g}handleClose(t,n,o,i){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&o({line:s,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&o({line:l,source:1})}}e.LineProcess=S;function h(m){let t=[],n=!1;const o=function(i){if(n){t.push(i);return}(!m.send(i,l=>{if(l&&console.error(l),n=!1,t.length>0){const g=t.slice(0);t=[],g.forEach(v=>o(v))}})||C.isWindows)&&(n=!0)};return{send:o}}e.createQueuedSender=h;var c;(function(m){async function t(n,o,i){if(_.isAbsolute(n))return n;if(o===void 0&&(o=P.cwd()),_.dirname(n)!=="."||(i===void 0&&D.isString(P.env.PATH)&&(i=P.env.PATH.split(_.delimiter)),i===void 0||i.length===0))return _.join(o,n);async function l(g){return await A.exists(g)?!(await I.promises.stat(g)).isDirectory():!1}for(let g of i){let v;if(_.isAbsolute(g)?v=_.join(g,n):v=_.join(o,g,n),await l(v))return v;let d=v+".com";if(await l(d)||(d=v+".exe",await l(d)))return d}return _.join(o,n)}m.findExecutable=t})(c=e.win32||(e.win32={}))}),define(ge[150],pe([0,1,44,10,104,78]),function(G,e,_,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function y(p,a){return p===1?I.isWindows?C():T.getWindowsShell(a):k(p,a)}e.getSystemShell=y;function P(p,a){return p===1?I.isWindows?f(a):T.getWindowsShell(a):k(p,a)}e.getSystemShellSync=P;let D=null;function k(p,a){if(I.isLinux&&p===2||I.isMacintosh&&p===3)return"/bin/bash";if(!D){let u;if(I.isWindows)u="/bin/bash";else{if(u=a.SHELL,!u)try{u=(0,_.userInfo)().shell}catch(E){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}D=u}return D}let r=null;async function C(){return r||(r=(await(0,A.getFirstAvailablePowerShellInstallation)()).exePath),r}function f(p){if(r)return r;const a=I.isWindows&&parseFloat((0,_.release)())>=10,u=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${p.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?E:T.getWindowsShell(p)}}),define(ge[151],pe([18,19]),function(G,e){return G.create("vs/editor/common/config/editorOptions",e)}),define(ge[152],pe([0,1,151,10,109]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=y;class P{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,_e){this._values[ie]=_e}}e.ValidatedEditorOptions=P;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class k{constructor(ie,_e,Ne,ze){this.id=ie,this.name=_e,this.defaultValue=Ne,this.schema=ze}compute(ie,_e,Ne){return Ne}}class r{constructor(ie,_e=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(ie){return this.defaultValue}}class C{constructor(ie,_e,Ne,ze){this.id=ie,this.name=_e,this.defaultValue=Ne,this.schema=ze}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,_e,Ne){return Ne}}function f(X,ie){return typeof X=="undefined"?ie:X==="false"?!1:Boolean(X)}e.boolean=f;class p extends C{constructor(ie,_e,Ne,ze=void 0){typeof ze!="undefined"&&(ze.type="boolean",ze.default=Ne),super(ie,_e,Ne,ze)}validate(ie){return f(ie,this.defaultValue)}}class a extends C{constructor(ie,_e,Ne,ze,$e,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=Ne,Je.minimum=ze,Je.maximum=$e),super(ie,_e,Ne,Je),this.minimum=ze,this.maximum=$e}static clampedInt(ie,_e,Ne,ze){if(typeof ie=="undefined")return _e;let $e=parseInt(ie,10);return isNaN($e)?_e:($e=Math.max(Ne,$e),$e=Math.min(ze,$e),$e|0)}validate(ie){return a.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class u extends C{constructor(ie,_e,Ne,ze,$e){typeof $e!="undefined"&&($e.type="number",$e.default=Ne),super(ie,_e,Ne,$e),this.validationFn=ze}static clamp(ie,_e,Ne){return ie<_e?_e:ie>Ne?Ne:ie}static float(ie,_e){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return _e;const Ne=parseFloat(ie);return isNaN(Ne)?_e:Ne}validate(ie){return this.validationFn(u.float(ie,this.defaultValue))}}class E extends C{static string(ie,_e){return typeof ie!="string"?_e:ie}constructor(ie,_e,Ne,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.default=Ne),super(ie,_e,Ne,ze)}validate(ie){return E.string(ie,this.defaultValue)}}function w(X,ie,_e){return typeof X!="string"||_e.indexOf(X)===-1?ie:X}e.stringSet=w;class S extends C{constructor(ie,_e,Ne,ze,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=ze,$e.default=Ne),super(ie,_e,Ne,$e),this._allowedValues=ze}validate(ie){return w(ie,this.defaultValue,this._allowedValues)}}class h extends k{constructor(ie,_e,Ne,ze,$e,Je,K=void 0){typeof K!="undefined"&&(K.type="string",K.enum=$e,K.default=ze),super(ie,_e,Ne,K),this._allowedValues=$e,this._convert=Je}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function c(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[_.localize(0,null),_.localize(1,null),_.localize(2,null)],default:"auto",description:_.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,_e,Ne){return Ne===0?ie.accessibilitySupport:Ne}}class t extends k{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:_.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:_.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{insertSpace:f(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function s(X){switch(X){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=s;function l(X){switch(X){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class g extends r{constructor(){super(123,[62,31])}compute(ie,_e,Ne){const ze=["monaco-editor"];return _e.get(31)&&ze.push(_e.get(31)),ie.extraEditorClassName&&ze.push(ie.extraEditorClassName),_e.get(62)==="default"?ze.push("mouse-default"):_e.get(62)==="copy"&&ze.push("mouse-copy"),_e.get(97)&&ze.push("showUnused"),_e.get(121)&&ze.push("showDeprecated"),ze.join(" ")}}class v extends p{constructor(){super(30,"emptySelectionClipboard",!0,{description:_.localize(6,null)})}compute(ie,_e,Ne){return Ne&&ie.emptySelectionClipboard}}class d extends k{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:_.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:_.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[_.localize(9,null),_.localize(10,null),_.localize(11,null)],description:_.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:_.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:_.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:_.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{cursorMoveOnType:f(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:f(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":w(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(_e.loop,this.defaultValue.loop)}}}class b extends k{constructor(){super(41,"fontLigatures",b.OFF,{anyOf:[{type:"boolean",description:_.localize(16,null)},{type:"string",description:_.localize(17,null)}],description:_.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?b.OFF:ie==="true"?b.ON:ie:Boolean(ie)?b.ON:b.OFF}}e.EditorFontLigatures=b,b.OFF='"liga" off, "calt" off',b.ON='"liga" on, "calt" on';class R extends r{constructor(){super(40)}compute(ie,_e,Ne){return ie.fontInfo}}class N extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:_.localize(19,null)})}validate(ie){let _e=u.float(ie,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(_e,6,100)}compute(ie,_e,Ne){return ie.fontInfo.fontSize}}class q extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.MINIMUM_VALUE,maximum:q.MAXIMUM_VALUE,errorMessage:_.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:_.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(a.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,q.MINIMUM_VALUE,q.MAXIMUM_VALUE))}}q.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],q.MINIMUM_VALUE=1,q.MAXIMUM_VALUE=1e3;class re extends k{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[_.localize(22,null),_.localize(23,null),_.localize(24,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:_.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:_.localize(26,null)},_e),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:_.localize(27,null)},_e),"editor.gotoLocation.multipleDeclarations":Object.assign({description:_.localize(28,null)},_e),"editor.gotoLocation.multipleImplementations":Object.assign({description:_.localize(29,null)},_e),"editor.gotoLocation.multipleReferences":Object.assign({description:_.localize(30,null)},_e),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Ne,description:_.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Ne,description:_.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Ne,description:_.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Ne,description:_.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Ne,description:_.localize(35,null)}})}validate(ie){var _e,Ne,ze,$e,Je;if(!ie||typeof ie!="object")return this.defaultValue;const K=ie;return{multiple:w(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(_e=K.multipleDefinitions)!==null&&_e!==void 0?_e:w(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=K.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:w(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(ze=K.multipleDeclarations)!==null&&ze!==void 0?ze:w(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=K.multipleImplementations)!==null&&$e!==void 0?$e:w(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Je=K.multipleReferences)!==null&&Je!==void 0?Je:w(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class V extends k{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:_.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:_.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:_.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),delay:a.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:f(_e.sticky,this.defaultValue.sticky)}}}var W;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(W=e.RenderMinimap||(e.RenderMinimap={}));class $ extends r{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(ie,_e,Ne){return $.computeLayout(_e,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const _e=ie.height/ie.lineHeight,Ne=ie.scrollBeyondLastLine?_e-1:0,ze=(ie.viewLineCount+Ne)/(ie.pixelRatio*ie.height),$e=Math.floor(ie.viewLineCount/ze);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:Ne,desiredRatio:ze,minimapLineCount:$e}}static _computeMinimapLayout(ie,_e){const Ne=ie.outerWidth,ze=ie.outerHeight,$e=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Je=_e.stableMinimapLayoutInput,K=Je&&ie.outerHeight===Je.outerHeight&&ie.lineHeight===Je.lineHeight&&ie.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Je.pixelRatio&&ie.scrollBeyondLastLine===Je.scrollBeyondLastLine&&ie.minimap.enabled===Je.minimap.enabled&&ie.minimap.side===Je.minimap.side&&ie.minimap.size===Je.minimap.size&&ie.minimap.showSlider===Je.minimap.showSlider&&ie.minimap.renderCharacters===Je.minimap.renderCharacters&&ie.minimap.maxColumn===Je.minimap.maxColumn&&ie.minimap.scale===Je.minimap.scale&&ie.verticalScrollbarWidth===Je.verticalScrollbarWidth&&ie.isViewportWrapping===Je.isViewportWrapping,se=ie.lineHeight,he=ie.typicalHalfwidthCharacterWidth,J=ie.scrollBeyondLastLine,ne=ie.minimap.renderCharacters;let ce=$e>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const ve=ie.minimap.maxColumn,ye=ie.minimap.size,je=ie.minimap.side,He=ie.verticalScrollbarWidth,We=ie.viewLineCount,Ge=ie.remainingWidth,nt=ie.isViewportWrapping,dt=ne?2:3;let it=Math.floor($e*ze);const Ye=it/$e;let mt=!1,wt=!1,Ee=dt*ce,fe=ce/$e,le=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:Xe,desiredRatio:ot,minimapLineCount:ft}=$.computeContainedMinimapLineCount({viewLineCount:We,scrollBeyondLastLine:J,height:ze,lineHeight:se,pixelRatio:$e});if(We/ft>1)mt=!0,wt=!0,ce=1,Ee=1,fe=ce/$e;else{let St=!1,vt=ce+1;if(ye==="fit"){const kt=Math.ceil((We+Xe)*Ee);nt&&K&&Ge<=_e.stableFitRemainingWidth?(St=!0,vt=_e.stableFitMaxMinimapScale):(St=kt>it,nt&&St?(_e.stableMinimapLayoutInput=ie,_e.stableFitRemainingWidth=Ge):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0))}if(ye==="fill"||St){mt=!0;const kt=ce;Ee=Math.min(se*$e,Math.max(1,Math.floor(1/ot))),ce=Math.min(vt,Math.max(1,Math.floor(Ee/dt))),ce>kt&&(le=Math.min(2,ce/kt)),fe=ce/$e/le,it=Math.ceil(Math.max(ht,We+Xe)*Ee),nt&&St&&(_e.stableFitMaxMinimapScale=ce)}}}const Z=Math.floor(ve*fe),Fe=Math.min(Z,Math.max(0,Math.floor((Ge-He-2)*fe/(he+fe)))+e.MINIMAP_GUTTER_WIDTH);let Te=Math.floor($e*Fe);const Qe=Te/$e;Te=Math.floor(Te*le);const Ze=ne?1:2,ct=je==="left"?0:Ne-Fe-He;return{renderMinimap:Ze,minimapLeft:ct,minimapWidth:Fe,minimapHeightIsEditorHeight:mt,minimapIsSampling:wt,minimapScale:ce,minimapLineHeight:Ee,minimapCanvasInnerWidth:Te,minimapCanvasInnerHeight:it,minimapCanvasOuterWidth:Qe,minimapCanvasOuterHeight:Ye}}static computeLayout(ie,_e){const Ne=_e.outerWidth|0,ze=_e.outerHeight|0,$e=_e.lineHeight|0,Je=_e.lineNumbersDigitCount|0,K=_e.typicalHalfwidthCharacterWidth,se=_e.maxDigitWidth,he=_e.pixelRatio,J=_e.viewLineCount,ne=ie.get(118),ce=ne==="inherit"?ie.get(117):ne,ve=ce==="inherit"?ie.get(113):ce,ye=ie.get(116),je=ie.get(2),He=_e.isDominatedByLongLines,We=ie.get(46),Ge=ie.get(56).renderType!==0,nt=ie.get(57),dt=ie.get(91),it=ie.get(61),Ye=ie.get(89),mt=Ye.verticalScrollbarSize,wt=Ye.verticalHasArrows,Ee=Ye.arrowSize,fe=Ye.horizontalScrollbarSize,le=ie.get(54),Z=ie.get(35);let Fe;if(typeof le=="string"&&/^\d+(\.\d+)?ch$/.test(le)){const _t=parseFloat(le.substr(0,le.length-2));Fe=a.clampedInt(_t*K,0,0,1e3)}else Fe=a.clampedInt(le,0,0,1e3);Z&&(Fe+=16);let Te=0;if(Ge){const _t=Math.max(Je,nt);Te=Math.round(_t*se)}let Qe=0;We&&(Qe=$e);let Ze=0,ct=Ze+Qe,ht=ct+Te,Xe=ht+Fe;const ot=Ne-Qe-Te-Fe;let ft=!1,at=!1,St=-1;je!==2&&(ce==="inherit"&&He?(ft=!0,at=!0):ve==="on"||ve==="bounded"?at=!0:ve==="wordWrapColumn"&&(St=ye));const vt=$._computeMinimapLayout({outerWidth:Ne,outerHeight:ze,lineHeight:$e,typicalHalfwidthCharacterWidth:K,pixelRatio:he,scrollBeyondLastLine:dt,minimap:it,verticalScrollbarWidth:mt,viewLineCount:J,remainingWidth:ot,isViewportWrapping:at},_e.memory||new D);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Ze+=vt.minimapWidth,ct+=vt.minimapWidth,ht+=vt.minimapWidth,Xe+=vt.minimapWidth);const kt=ot-vt.minimapWidth,At=Math.max(1,Math.floor((kt-mt-2)/K)),Tt=wt?Ee:0;return at&&(St=Math.max(1,At),ve==="bounded"&&(St=Math.min(St,ye))),{width:Ne,height:ze,glyphMarginLeft:Ze,glyphMarginWidth:Qe,lineNumbersLeft:ct,lineNumbersWidth:Te,decorationsLeft:ht,decorationsWidth:Fe,contentLeft:Xe,contentWidth:kt,minimap:vt,viewportColumn:At,isWordWrapMinified:ft,isViewportWrapping:at,wrappingColumn:St,verticalScrollbarWidth:mt,horizontalScrollbarHeight:fe,overviewRuler:{top:Tt,width:mt,height:ze-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=$;class U extends k{constructor(){const ie={enabled:!0};super(53,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:_.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:f(ie.enabled,this.defaultValue.enabled)}}}class F extends k{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",ie,{"editor.inlineHints.enabled":{type:"boolean",default:ie.enabled,description:_.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:ie.fontSize,description:_.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:ie.fontFamily,description:_.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class M extends a{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:_.localize(43,null)})}compute(ie,_e,Ne){return ie.fontInfo.lineHeight}}class L extends k{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:_.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[_.localize(45,null),_.localize(46,null),_.localize(47,null)],default:ie.size,description:_.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:_.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:_.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:_.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:_.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:_.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),size:w(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(_e.side,this.defaultValue.side,["right","left"]),showSlider:w(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(_e.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(_e.scale,1,1,3),maxColumn:a.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(X){return X==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class B extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{top:a.clampedInt(_e.top,0,0,1e3),bottom:a.clampedInt(_e.bottom,0,0,1e3)}}}class j extends k{constructor(){const ie={enabled:!0,cycle:!1};super(72,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:_.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:_.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),cycle:f(_e.cycle,this.defaultValue.cycle)}}}class Q extends r{constructor(){super(124)}compute(ie,_e,Ne){return ie.pixelRatio}}class de extends k{constructor(){const ie={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:_.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:_.localize(59,null)},other:{type:"boolean",default:ie.other,description:_.localize(60,null)}}}],default:ie,description:_.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const _e=ie,Ne={other:f(_e.other,this.defaultValue.other),comments:f(_e.comments,this.defaultValue.comments),strings:f(_e.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var be;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ae extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[_.localize(62,null),_.localize(63,null),_.localize(64,null),_.localize(65,null)],default:"on",description:_.localize(66,null)})}validate(ie){let _e=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(_e=4,Ne=ie):ie==="interval"?_e=3:ie==="relative"?_e=2:ie==="on"?_e=1:_e=0),{renderType:_e,renderFn:Ne}}}function Ce(X){const ie=X.get(84);return ie==="editable"?X.get(77):ie!=="on"}e.filterValidationDecorations=Ce;class Le extends k{constructor(){const ie=[],_e={type:"number",description:_.localize(67,null)};super(88,"rulers",ie,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:_.localize(68,null),format:"color-hex"}}}]},default:ie,description:_.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let _e=[];for(let Ne of ie)if(typeof Ne=="number")_e.push({column:a.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const ze=Ne;_e.push({column:a.clampedInt(ze.column,0,0,1e4),color:ze.color})}return _e.sort((Ne,ze)=>Ne.column-ze.column),_e}return this.defaultValue}}function z(X,ie){if(typeof X!="string")return ie;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Y extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie,Ne=a.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=a.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(_e.vertical,this.defaultValue.vertical),horizontal:z(_e.horizontal,this.defaultValue.horizontal),useShadows:f(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:a.clampedInt(_e.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:a.clampedInt(_e.verticalSliderSize,ze,0,1e3),scrollByPage:f(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends k{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[_.localize(70,null),_.localize(71,null)],default:ie.insertMode,description:_.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:_.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:_.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:_.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:_.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:_.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:_.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:_.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:_.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:_.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:_.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:_.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:_.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:_.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:_.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:_.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:_.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:_.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:_.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:_.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:_.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:_.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:_.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:_.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:_.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:_.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:_.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:_.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:_.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:_.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:_.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:_.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:_.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:_.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:_.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:_.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:_.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:_.localize(109,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{insertMode:w(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:f(_e.showIcons,this.defaultValue.showIcons),showStatusBar:f(_e.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:f(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(_e.showMethods,this.defaultValue.showMethods),showFunctions:f(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:f(_e.showConstructors,this.defaultValue.showConstructors),showFields:f(_e.showFields,this.defaultValue.showFields),showVariables:f(_e.showVariables,this.defaultValue.showVariables),showClasses:f(_e.showClasses,this.defaultValue.showClasses),showStructs:f(_e.showStructs,this.defaultValue.showStructs),showInterfaces:f(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:f(_e.showModules,this.defaultValue.showModules),showProperties:f(_e.showProperties,this.defaultValue.showProperties),showEvents:f(_e.showEvents,this.defaultValue.showEvents),showOperators:f(_e.showOperators,this.defaultValue.showOperators),showUnits:f(_e.showUnits,this.defaultValue.showUnits),showValues:f(_e.showValues,this.defaultValue.showValues),showConstants:f(_e.showConstants,this.defaultValue.showConstants),showEnums:f(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:f(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(_e.showKeywords,this.defaultValue.showKeywords),showWords:f(_e.showWords,this.defaultValue.showWords),showColors:f(_e.showColors,this.defaultValue.showColors),showFiles:f(_e.showFiles,this.defaultValue.showFiles),showReferences:f(_e.showReferences,this.defaultValue.showReferences),showFolders:f(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:f(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(_e.showSnippets,this.defaultValue.showSnippets),showUsers:f(_e.showUsers,this.defaultValue.showUsers),showIssues:f(_e.showIssues,this.defaultValue.showIssues)}}}class ae extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:_.localize(110,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends r{constructor(){super(125,[77])}compute(ie,_e,Ne){return _e.get(77)?!0:ie.tabFocusMode}}var De;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Oe(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class we extends r{constructor(){super(127,[126])}compute(ie,_e,Ne){const ze=_e.get(126);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}const Pe="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Re:I.isLinux?Be:Pe,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Se(X){return e.editorOptionsRegistry[X.id]=X,X}var qe;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=39]="fontFamily",X[X.fontInfo=40]="fontInfo",X[X.fontLigatures=41]="fontLigatures",X[X.fontSize=42]="fontSize",X[X.fontWeight=43]="fontWeight",X[X.formatOnPaste=44]="formatOnPaste",X[X.formatOnType=45]="formatOnType",X[X.glyphMargin=46]="glyphMargin",X[X.gotoLocation=47]="gotoLocation",X[X.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",X[X.hover=50]="hover",X[X.inDiffEditor=51]="inDiffEditor",X[X.letterSpacing=52]="letterSpacing",X[X.lightbulb=53]="lightbulb",X[X.lineDecorationsWidth=54]="lineDecorationsWidth",X[X.lineHeight=55]="lineHeight",X[X.lineNumbers=56]="lineNumbers",X[X.lineNumbersMinChars=57]="lineNumbersMinChars",X[X.linkedEditing=58]="linkedEditing",X[X.links=59]="links",X[X.matchBrackets=60]="matchBrackets",X[X.minimap=61]="minimap",X[X.mouseStyle=62]="mouseStyle",X[X.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=64]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",X[X.multiCursorModifier=66]="multiCursorModifier",X[X.multiCursorPaste=67]="multiCursorPaste",X[X.occurrencesHighlight=68]="occurrencesHighlight",X[X.overviewRulerBorder=69]="overviewRulerBorder",X[X.overviewRulerLanes=70]="overviewRulerLanes",X[X.padding=71]="padding",X[X.parameterHints=72]="parameterHints",X[X.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",X[X.quickSuggestions=75]="quickSuggestions",X[X.quickSuggestionsDelay=76]="quickSuggestionsDelay",X[X.readOnly=77]="readOnly",X[X.renameOnType=78]="renameOnType",X[X.renderControlCharacters=79]="renderControlCharacters",X[X.renderIndentGuides=80]="renderIndentGuides",X[X.renderFinalNewline=81]="renderFinalNewline",X[X.renderLineHighlight=82]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=84]="renderValidationDecorations",X[X.renderWhitespace=85]="renderWhitespace",X[X.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",X[X.roundedSelection=87]="roundedSelection",X[X.rulers=88]="rulers",X[X.scrollbar=89]="scrollbar",X[X.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=91]="scrollBeyondLastLine",X[X.scrollPredominantAxis=92]="scrollPredominantAxis",X[X.selectionClipboard=93]="selectionClipboard",X[X.selectionHighlight=94]="selectionHighlight",X[X.selectOnLineNumbers=95]="selectOnLineNumbers",X[X.showFoldingControls=96]="showFoldingControls",X[X.showUnused=97]="showUnused",X[X.snippetSuggestions=98]="snippetSuggestions",X[X.smartSelect=99]="smartSelect",X[X.smoothScrolling=100]="smoothScrolling",X[X.stickyTabStops=101]="stickyTabStops",X[X.stopRenderingLineAfter=102]="stopRenderingLineAfter",X[X.suggest=103]="suggest",X[X.suggestFontSize=104]="suggestFontSize",X[X.suggestLineHeight=105]="suggestLineHeight",X[X.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",X[X.suggestSelection=107]="suggestSelection",X[X.tabCompletion=108]="tabCompletion",X[X.tabIndex=109]="tabIndex",X[X.unusualLineTerminators=110]="unusualLineTerminators",X[X.useTabStops=111]="useTabStops",X[X.wordSeparators=112]="wordSeparators",X[X.wordWrap=113]="wordWrap",X[X.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=116]="wordWrapColumn",X[X.wordWrapOverride1=117]="wordWrapOverride1",X[X.wordWrapOverride2=118]="wordWrapOverride2",X[X.wrappingIndent=119]="wrappingIndent",X[X.wrappingStrategy=120]="wrappingStrategy",X[X.showDeprecated=121]="showDeprecated",X[X.inlineHints=122]="inlineHints",X[X.editorClassName=123]="editorClassName",X[X.pixelRatio=124]="pixelRatio",X[X.tabFocusMode=125]="tabFocusMode",X[X.layoutInfo=126]="layoutInfo",X[X.wrappingInfo=127]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:_.localize(111,null)})),acceptSuggestionOnEnter:Se(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",_.localize(112,null),""],markdownDescription:_.localize(113,null)})),accessibilitySupport:Se(new m),accessibilityPageSize:Se(new a(3,"accessibilityPageSize",10,1,1073741824,{description:_.localize(114,null)})),ariaLabel:Se(new E(4,"ariaLabel",_.localize(115,null))),autoClosingBrackets:Se(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(116,null),_.localize(117,null),""],description:_.localize(118,null)})),autoClosingDelete:Se(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",_.localize(119,null),""],description:_.localize(120,null)})),autoClosingOvertype:Se(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",_.localize(121,null),""],description:_.localize(122,null)})),autoClosingQuotes:Se(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(123,null),_.localize(124,null),""],description:_.localize(125,null)})),autoIndent:Se(new h(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[_.localize(126,null),_.localize(127,null),_.localize(128,null),_.localize(129,null),_.localize(130,null)],description:_.localize(131,null)})),automaticLayout:Se(new p(10,"automaticLayout",!1)),autoSurround:Se(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[_.localize(132,null),_.localize(133,null),_.localize(134,null),""],description:_.localize(135,null)})),stickyTabStops:Se(new p(101,"stickyTabStops",!1,{description:_.localize(136,null)})),codeLens:Se(new p(12,"codeLens",!0,{description:_.localize(137,null)})),codeLensFontFamily:Se(new E(13,"codeLensFontFamily","",{description:_.localize(138,null)})),codeLensFontSize:Se(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:_.localize(139,null)})),colorDecorators:Se(new p(15,"colorDecorators",!0,{description:_.localize(140,null)})),columnSelection:Se(new p(16,"columnSelection",!1,{description:_.localize(141,null)})),comments:Se(new t),contextmenu:Se(new p(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new p(19,"copyWithSyntaxHighlighting",!0,{description:_.localize(142,null)})),cursorBlinking:Se(new h(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:_.localize(143,null)})),cursorSmoothCaretAnimation:Se(new p(21,"cursorSmoothCaretAnimation",!1,{description:_.localize(144,null)})),cursorStyle:Se(new h(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],l,{description:_.localize(145,null)})),cursorSurroundingLines:Se(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:_.localize(146,null)})),cursorSurroundingLinesStyle:Se(new S(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[_.localize(147,null),_.localize(148,null)],description:_.localize(149,null)})),cursorWidth:Se(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:_.localize(150,null)})),disableLayerHinting:Se(new p(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new p(27,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new p(28,"domReadOnly",!1)),dragAndDrop:Se(new p(29,"dragAndDrop",!0,{description:_.localize(151,null)})),emptySelectionClipboard:Se(new v),extraEditorClassName:Se(new E(31,"extraEditorClassName","")),fastScrollSensitivity:Se(new u(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:_.localize(152,null)})),find:Se(new d),fixedOverflowWidgets:Se(new p(34,"fixedOverflowWidgets",!1)),folding:Se(new p(35,"folding",!0,{description:_.localize(153,null)})),foldingStrategy:Se(new S(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[_.localize(154,null),_.localize(155,null)],description:_.localize(156,null)})),foldingHighlight:Se(new p(37,"foldingHighlight",!0,{description:_.localize(157,null)})),unfoldOnClickAfterEndOfLine:Se(new p(38,"unfoldOnClickAfterEndOfLine",!1,{description:_.localize(158,null)})),fontFamily:Se(new E(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:_.localize(159,null)})),fontInfo:Se(new R),fontLigatures2:Se(new b),fontSize:Se(new N),fontWeight:Se(new q),formatOnPaste:Se(new p(44,"formatOnPaste",!1,{description:_.localize(160,null)})),formatOnType:Se(new p(45,"formatOnType",!1,{description:_.localize(161,null)})),glyphMargin:Se(new p(46,"glyphMargin",!0,{description:_.localize(162,null)})),gotoLocation:Se(new re),hideCursorInOverviewRuler:Se(new p(48,"hideCursorInOverviewRuler",!1,{description:_.localize(163,null)})),highlightActiveIndentGuide:Se(new p(49,"highlightActiveIndentGuide",!0,{description:_.localize(164,null)})),hover:Se(new V),inDiffEditor:Se(new p(51,"inDiffEditor",!1)),letterSpacing:Se(new u(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>u.clamp(X,-5,20),{description:_.localize(165,null)})),lightbulb:Se(new U),lineDecorationsWidth:Se(new C(54,"lineDecorationsWidth",10)),lineHeight:Se(new M),lineNumbers:Se(new Ae),lineNumbersMinChars:Se(new a(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new p(58,"linkedEditing",!1,{description:_.localize(166,null)})),links:Se(new p(59,"links",!0,{description:_.localize(167,null)})),matchBrackets:Se(new S(60,"matchBrackets","always",["always","near","never"],{description:_.localize(168,null)})),minimap:Se(new L),mouseStyle:Se(new S(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new u(63,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:_.localize(169,null)})),mouseWheelZoom:Se(new p(64,"mouseWheelZoom",!1,{markdownDescription:_.localize(170,null)})),multiCursorMergeOverlapping:Se(new p(65,"multiCursorMergeOverlapping",!0,{description:_.localize(171,null)})),multiCursorModifier:Se(new h(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[_.localize(172,null),_.localize(173,null)],markdownDescription:_.localize(174,null)})),multiCursorPaste:Se(new S(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[_.localize(175,null),_.localize(176,null)],markdownDescription:_.localize(177,null)})),occurrencesHighlight:Se(new p(68,"occurrencesHighlight",!0,{description:_.localize(178,null)})),overviewRulerBorder:Se(new p(69,"overviewRulerBorder",!0,{description:_.localize(179,null)})),overviewRulerLanes:Se(new a(70,"overviewRulerLanes",3,0,3)),padding:Se(new B),parameterHints:Se(new j),peekWidgetDefaultFocus:Se(new S(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[_.localize(180,null),_.localize(181,null)],description:_.localize(182,null)})),definitionLinkOpensInPeek:Se(new p(74,"definitionLinkOpensInPeek",!1,{description:_.localize(183,null)})),quickSuggestions:Se(new de),quickSuggestionsDelay:Se(new a(76,"quickSuggestionsDelay",10,0,1073741824,{description:_.localize(184,null)})),readOnly:Se(new p(77,"readOnly",!1)),renameOnType:Se(new p(78,"renameOnType",!1,{description:_.localize(185,null),markdownDeprecationMessage:_.localize(186,null)})),renderControlCharacters:Se(new p(79,"renderControlCharacters",!1,{description:_.localize(187,null)})),renderIndentGuides:Se(new p(80,"renderIndentGuides",!0,{description:_.localize(188,null)})),renderFinalNewline:Se(new p(81,"renderFinalNewline",!0,{description:_.localize(189,null)})),renderLineHighlight:Se(new S(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",_.localize(190,null)],description:_.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Se(new p(83,"renderLineHighlightOnlyWhenFocus",!1,{description:_.localize(192,null)})),renderValidationDecorations:Se(new S(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new S(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",_.localize(193,null),_.localize(194,null),_.localize(195,null),""],description:_.localize(196,null)})),revealHorizontalRightPadding:Se(new a(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new p(87,"roundedSelection",!0,{description:_.localize(197,null)})),rulers:Se(new Le),scrollbar:Se(new Y),scrollBeyondLastColumn:Se(new a(90,"scrollBeyondLastColumn",5,0,1073741824,{description:_.localize(198,null)})),scrollBeyondLastLine:Se(new p(91,"scrollBeyondLastLine",!0,{description:_.localize(199,null)})),scrollPredominantAxis:Se(new p(92,"scrollPredominantAxis",!0,{description:_.localize(200,null)})),selectionClipboard:Se(new p(93,"selectionClipboard",!0,{description:_.localize(201,null),included:I.isLinux})),selectionHighlight:Se(new p(94,"selectionHighlight",!0,{description:_.localize(202,null)})),selectOnLineNumbers:Se(new p(95,"selectOnLineNumbers",!0)),showFoldingControls:Se(new S(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[_.localize(203,null),_.localize(204,null)],description:_.localize(205,null)})),showUnused:Se(new p(97,"showUnused",!0,{description:_.localize(206,null)})),showDeprecated:Se(new p(121,"showDeprecated",!0,{description:_.localize(207,null)})),inlineHints:Se(new F),snippetSuggestions:Se(new S(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[_.localize(208,null),_.localize(209,null),_.localize(210,null),_.localize(211,null)],description:_.localize(212,null)})),smartSelect:Se(new ae),smoothScrolling:Se(new p(100,"smoothScrolling",!1,{description:_.localize(213,null)})),stopRenderingLineAfter:Se(new a(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new ee),suggestFontSize:Se(new a(104,"suggestFontSize",0,0,1e3,{markdownDescription:_.localize(214,null)})),suggestLineHeight:Se(new a(105,"suggestLineHeight",0,0,1e3,{markdownDescription:_.localize(215,null)})),suggestOnTriggerCharacters:Se(new p(106,"suggestOnTriggerCharacters",!0,{description:_.localize(216,null)})),suggestSelection:Se(new S(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[_.localize(217,null),_.localize(218,null),_.localize(219,null)],description:_.localize(220,null)})),tabCompletion:Se(new S(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[_.localize(221,null),_.localize(222,null),_.localize(223,null)],description:_.localize(224,null)})),tabIndex:Se(new a(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new S(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[_.localize(225,null),_.localize(226,null),_.localize(227,null)],description:_.localize(228,null)})),useTabStops:Se(new p(111,"useTabStops",!0,{description:_.localize(229,null)})),wordSeparators:Se(new E(112,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:_.localize(230,null)})),wordWrap:Se(new S(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[_.localize(231,null),_.localize(232,null),_.localize(233,null),_.localize(234,null)],description:_.localize(235,null)})),wordWrapBreakAfterCharacters:Se(new E(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new E(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new a(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:_.localize(236,null)})),wordWrapOverride1:Se(new S(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new S(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new h(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[_.localize(237,null),_.localize(238,null),_.localize(239,null),_.localize(240,null)],description:_.localize(241,null)})),wrappingStrategy:Se(new S(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[_.localize(242,null),_.localize(243,null)],description:_.localize(244,null)})),editorClassName:Se(new g),pixelRatio:Se(new Q),tabFocusMode:Se(new me),layoutInfo:Se(new $),wrappingInfo:Se(new we)}}),define(ge[153],pe([18,19]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[154],pe([18,19]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[155],pe([18,19]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[156],pe([18,19]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ge[157],pe([18,19]),function(G,e){return G.create("vs/platform/markers/common/markers",e)}),define(ge[158],pe([18,19]),function(G,e){return G.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[159],pe([18,19]),function(G,e){return G.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[160],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ge[161],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[162],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[163],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[164],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[165],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[166],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[167],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[168],pe([18,19]),function(G,e){return G.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[169],pe([18,19]),function(G,e){return G.create("vs/workbench/common/views",e)}),define(ge[170],pe([18,19]),function(G,e){return G.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[171],pe([18,19]),function(G,e){return G.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[172],pe([18,19]),function(G,e){return G.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(ge[173],pe([18,19]),function(G,e){return G.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[174],pe([18,19]),function(G,e){return G.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[175],pe([18,19]),function(G,e){return G.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[176],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var _;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var I;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var A;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[177],pe([0,1,155]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(C){return C=C.trim(),C==="*"||I.test(C)}e.isValidVersionStr=A;function T(C){if(!A(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=C.match(I);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=T;function y(C){if(!C)return null;let f=C.majorBase,p=C.majorMustEqual,a=C.minorBase,u=C.minorMustEqual,E=C.patchBase,w=C.patchMustEqual;return C.hasCaret&&(f===0||(u=!1),w=!1),{majorBase:f,majorMustEqual:p,minorBase:a,minorMustEqual:u,patchBase:E,patchMustEqual:w,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=y;function P(C,f){let p;typeof C=="string"?p=y(T(C)):p=C;let a;if(typeof f=="string"?a=y(T(f)):a=f,!p||!a)return!1;let u=p.majorBase,E=p.minorBase,w=p.patchBase,S=a.majorBase,h=a.minorBase,c=a.patchBase,m=a.majorMustEqual,t=a.minorMustEqual,n=a.patchMustEqual;return a.isMinimum?u>S?!0:u<S?!1:E>h?!0:E<h?!1:w>=c:(u===1&&S===0&&(!m||!t||!n)&&(S=1,h=0,c=0,m=!0,t=!1,n=!1),u<S?!1:u>S?!m:E<h?!1:E>h?!t:w<c?!1:w>c?!n:!0)}e.isValidVersion=P;function D(C,f,p){return f.isBuiltin||typeof f.main=="undefined"?!0:r(C,f.engines.vscode,p)}e.isValidExtensionVersion=D;function k(C,f){return C==="*"||r(f,C)}e.isEngineValid=k;function r(C,f,p=[]){let a=y(T(f));if(!a)return p.push(_.localize(0,null,f)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return p.push(_.localize(1,null,f)),!1}else if(!a.majorMustEqual)return p.push(_.localize(2,null,f)),!1;return P(C,a)?!0:(p.push(_.localize(3,null,C,f)),!1)}e.isVersionValid=r}),define(ge[112],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class _{constructor(T,y=[],P=!1){this.ctor=T,this.staticArguments=y,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=_;const I=(A,...T)=>new _(A,T);e.createSyncDescriptor=I}),define(ge[79],pe([0,1,112]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function A(y,P,D){P instanceof _.SyncDescriptor||(P=new _.SyncDescriptor(P,[],D)),I.push([y,P])}e.registerSingleton=A;function T(){return I}e.getSingletonServiceDescriptors=T}),define(ge[178],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=_;class I{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let y of this._nodes.values())y.outgoing.size===0&&T.push(y);return T}insertEdge(T,y){const P=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(y);P.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(T),P)}removeNode(T){const y=this._hashFn(T);this._nodes.delete(y);for(let P of this._nodes.values())P.outgoing.delete(y),P.incoming.delete(y)}lookupOrInsertNode(T){const y=this._hashFn(T);let P=this._nodes.get(y);return P||(P=new _(T),this._nodes.set(y,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[y,P]of this._nodes)T.push(`${y}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,y]of this._nodes){const P=new Set([T]),D=this._findCycle(y,P);if(D)return D}}_findCycle(T,y){for(let[P,D]of T.outgoing){if(y.has(P))return[...y,P].join(" -> ");y.add(P);const k=this._findCycle(D,y);if(k)return k;y.delete(P)}}}e.Graph=I}),define(ge[4],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function D(k){return k[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=D})(_=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function I(P,D,k,r){D[_.DI_TARGET]===D?D[_.DI_DEPENDENCIES].push({id:P,index:k,optional:r}):(D[_.DI_DEPENDENCIES]=[{id:P,index:k,optional:r}],D[_.DI_TARGET]=D)}function A(P){if(_.serviceIds.has(P))return _.serviceIds.get(P);const D=function(k,r,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(D,k,C,!1)};return D.toString=()=>P,_.serviceIds.set(P,D),D}e.createDecorator=A;function T(P){return P}e.refineServiceDecorator=T;function y(P){return function(D,k,r){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(P,D,r,!0)}}e.optional=y}),define(ge[179],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,_.createDecorator)("modelService");function I(A){return!A.isTooLargeForSyncing()&&!A.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(ge[180],pe([0,1,3,74,6,24,73,77,179]),function(G,e,_,I,A,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(f){return typeof f=="string"?!1:Array.isArray(f)?f.every(k):!!f.exclusive}class r{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(p,a){let u={selector:p,provider:a,_score:-1,_time:this._clock++};return this._entries.push(u),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,A.toDisposable)(()=>{if(u){let E=this._entries.indexOf(u);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),u=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const a=[];for(let u of this._entries)u._score>0&&a.push(u.provider);return a}ordered(p){const a=[];return this._orderedForEach(p,u=>a.push(u.provider)),a}orderedGroups(p){const a=[];let u,E;return this._orderedForEach(p,w=>{u&&E===w._score?u.push(w.provider):(E=w._score,u=[w.provider],a.push(u))}),a}_orderedForEach(p,a){if(!!p){this._updateScores(p);for(const u of this._entries)u._score>0&&a(u)}}_updateScores(p){let a={uri:p.uri.toString(),language:p.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let u of this._entries)if(u._score=(0,P.score)(u.selector,p.uri,p.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(p)),k(u.selector)&&u._score>0){for(let E of this._entries)E._score=0;u._score=1e3;break}this._entries.sort(r._compareByScoreAndTime)}}static _compareByScoreAndTime(p,a){return p._score<a._score?1:p._score>a._score?-1:p._time<a._time?1:p._time>a._time?-1:0}}e.LanguageFeatureRegistry=r;class C{constructor(p,a,u=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=a,this.max=u,this._cache=new T.LRUCache(50,.7)}_key(p){return p.id+(0,I.hash)(this._registry.all(p))}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const a=this._key(p),u=this._cache.get(a);return this._clamp(u==null?void 0:u.value)}update(p,a){const u=this._key(p);let E=this._cache.get(u);return E||(E=new y.MovingAverage,this._cache.set(u,E)),E.update(a),this.get(p)}}e.LanguageFeatureRequestDelays=C}),define(ge[80],pe([0,1,2,45,180,144,43]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(d){d[d.Null=0]="Null",d[d.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class D{constructor(b,R){this.language=b,this.id=R}}e.LanguageIdentifier=D;var k;(function(d){d[d.NotSet=-1]="NotSet",d[d.None=0]="None",d[d.Italic=1]="Italic",d[d.Bold=2]="Bold",d[d.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var r;(function(d){d[d.None=0]="None",d[d.DefaultForeground=1]="DefaultForeground",d[d.DefaultBackground=2]="DefaultBackground"})(r=e.ColorId||(e.ColorId={}));var C;(function(d){d[d.Other=0]="Other",d[d.Comment=1]="Comment",d[d.String=2]="String",d[d.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var f;(function(d){d[d.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",d[d.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",d[d.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",d[d.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",d[d.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",d[d.ITALIC_MASK=2048]="ITALIC_MASK",d[d.BOLD_MASK=4096]="BOLD_MASK",d[d.UNDERLINE_MASK=8192]="UNDERLINE_MASK",d[d.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",d[d.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",d[d.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",d[d.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",d[d.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",d[d.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",d[d.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",d[d.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",d[d.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",d[d.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(f=e.MetadataConsts||(e.MetadataConsts={}));class p{static getLanguageId(b){return(b&255)>>>0}static getTokenType(b){return(b&1792)>>>8}static getFontStyle(b){return(b&14336)>>>11}static getForeground(b){return(b&8372224)>>>14}static getBackground(b){return(b&4286578688)>>>23}static getClassNameFromMetadata(b){let R=this.getForeground(b),N="mtk"+R,q=this.getFontStyle(b);return q&1&&(N+=" mtki"),q&2&&(N+=" mtkb"),q&4&&(N+=" mtku"),N}static getInlineStyleFromMetadata(b,R){const N=this.getForeground(b),q=this.getFontStyle(b);let re=`color: ${R[N]};`;return q&1&&(re+="font-style: italic;"),q&2&&(re+="font-weight: bold;"),q&4&&(re+="text-decoration: underline;"),re}}e.TokenMetadata=p;var a;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let d=Object.create(null);return d[0]="symbol-method",d[1]="symbol-function",d[2]="symbol-constructor",d[3]="symbol-field",d[4]="symbol-variable",d[5]="symbol-class",d[6]="symbol-struct",d[7]="symbol-interface",d[8]="symbol-module",d[9]="symbol-property",d[10]="symbol-event",d[11]="symbol-operator",d[12]="symbol-unit",d[13]="symbol-value",d[14]="symbol-constant",d[15]="symbol-enum",d[16]="symbol-enum-member",d[17]="symbol-keyword",d[27]="symbol-snippet",d[18]="symbol-text",d[19]="symbol-color",d[20]="symbol-file",d[21]="symbol-reference",d[22]="symbol-customcolor",d[23]="symbol-folder",d[24]="symbol-type-parameter",d[25]="account",d[26]="issues",function(b){const R=d[b];let N=R&&y.iconRegistry.get(R);return N||(console.info("No codicon found for CompletionItemKind "+b),N=y.Codicon.symbolProperty),N.classNames}}(),e.completionKindFromString=function(){let d=Object.create(null);return d.method=0,d.function=1,d.constructor=2,d.field=3,d.variable=4,d.class=5,d.struct=6,d.interface=7,d.module=8,d.property=9,d.event=10,d.operator=11,d.unit=12,d.value=13,d.constant=14,d.enum=15,d["enum-member"]=16,d.enumMember=16,d.keyword=17,d.snippet=27,d.text=18,d.color=19,d.file=20,d.reference=21,d.customcolor=22,d.folder=23,d["type-parameter"]=24,d.typeParameter=24,d.account=25,d.issue=26,function(b,R){let N=d[b];return typeof N=="undefined"&&!R&&(N=9),N}}();var u;(function(d){d[d.Deprecated=1]="Deprecated"})(u=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(S=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function m(d){return d&&_.URI.isUri(d.uri)&&I.Range.isIRange(d.range)&&(I.Range.isIRange(d.originSelectionRange)||I.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=m;var t;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(d){d[d.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var o;(function(d){const b=new Map;b.set("file",0),b.set("module",1),b.set("namespace",2),b.set("package",3),b.set("class",4),b.set("method",5),b.set("property",6),b.set("field",7),b.set("constructor",8),b.set("enum",9),b.set("interface",10),b.set("function",11),b.set("variable",12),b.set("constant",13),b.set("string",14),b.set("number",15),b.set("boolean",16),b.set("array",17),b.set("object",18),b.set("key",19),b.set("null",20),b.set("enum-member",21),b.set("struct",22),b.set("event",23),b.set("operator",24),b.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function N(V){return b.get(V)}d.fromString=N;function q(V){return R.get(V)}d.toString=q;function re(V,W){const $=R.get(V);let U=$&&y.iconRegistry.get("symbol-"+$);return U||(console.info("No codicon found for SymbolKind "+V),U=y.Codicon.symbolProperty),`${W?"inline":"block"} ${U.classNames}`}d.toCssClassName=re})(o=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(b){this.value=b}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var s;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var g;(function(d){d[d.Other=0]="Other",d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(g=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new A.LanguageFeatureRegistry,e.RenameProviderRegistry=new A.LanguageFeatureRegistry,e.CompletionProviderRegistry=new A.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new A.LanguageFeatureRegistry,e.HoverProviderRegistry=new A.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new A.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new A.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new A.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new A.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new A.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new A.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.LinkProviderRegistry=new A.LanguageFeatureRegistry,e.ColorProviderRegistry=new A.LanguageFeatureRegistry,e.SelectionRangeRegistry=new A.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var v;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(v=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[181],pe([0,1,6,11,4,3,56,54]),function(G,e,_,I,A,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,A.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,k){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:D,handler:k})}if(D.description){const a=[];for(let E of D.description.args)a.push(E.constraint);const u=D.handler;D.handler=function(E,...w){return(0,I.validateConstraints)(w,a),u(E,...w)}}const{id:r}=D;let C=this._commands.get(r);C||(C=new y.LinkedList,this._commands.set(r,C));let f=C.unshift(D),p=(0,_.toDisposable)(()=>{f();const a=this._commands.get(r);(a==null?void 0:a.isEmpty())&&this._commands.delete(r)});return this._onDidRegisterCommand.fire(r),p}registerCommandAlias(D,k){return e.CommandsRegistry.registerCommand(D,(r,...C)=>r.get(e.ICommandService).executeCommand(k,...C))}getCommand(D){const k=this._commands.get(D);if(!(!k||k.isEmpty()))return P.Iterable.first(k)}getCommands(){const D=new Map;for(const k of this._commands.keys()){const r=this.getCommand(k);r&&D.set(k,r)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>_.Disposable.None,onDidExecuteCommand:()=>_.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(ge[81],pe([0,1,9,4,10]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=A.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",A.isMacintosh),y.set("isLinux",A.isLinux),y.set("isWindows",A.isWindows),y.set("isWeb",A.isWeb),y.set("isMacNative",A.isMacintosh&&!A.isWeb),y.set("isEdge",T.indexOf("Edg/")>=0),y.set("isFirefox",T.indexOf("Firefox")>=0),y.set("isChrome",T.indexOf("Chrome")>=0),y.set("isSafari",T.indexOf("Safari")>=0),y.set("isIPad",T.indexOf("iPad")>=0);const P=Object.prototype.hasOwnProperty;var D;(function(d){d[d.False=0]="False",d[d.True=1]="True",d[d.Defined=2]="Defined",d[d.Not=3]="Not",d[d.Equals=4]="Equals",d[d.NotEquals=5]="NotEquals",d[d.And=6]="And",d[d.Regex=7]="Regex",d[d.NotRegex=8]="NotRegex",d[d.Or=9]="Or",d[d.In=10]="In",d[d.NotIn=11]="NotIn",d[d.Greater=12]="Greater",d[d.GreaterEquals=13]="GreaterEquals",d[d.Smaller=14]="Smaller",d[d.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return C.INSTANCE}static true(){return f.INSTANCE}static has(b){return p.create(b)}static equals(b,R){return a.create(b,R)}static notEquals(b,R){return w.create(b,R)}static regex(b,R){return n.create(b,R)}static in(b,R){return u.create(b,R)}static not(b){return S.create(b)}static and(...b){return i.create(b)}static or(...b){return s.create(b)}static greater(b,R){return h.create(b,R)}static less(b,R){return m.create(b,R)}static deserialize(b,R=!1){if(!!b)return this._deserializeOrExpression(b,R)}static _deserializeOrExpression(b,R){let N=b.split("||");return s.create(N.map(q=>this._deserializeAndExpression(q,R)))}static _deserializeAndExpression(b,R){let N=b.split("&&");return i.create(N.map(q=>this._deserializeOne(q,R)))}static _deserializeOne(b,R){if(b=b.trim(),b.indexOf("!=")>=0){let N=b.split("!=");return w.create(N[0].trim(),this._deserializeValue(N[1],R))}if(b.indexOf("==")>=0){let N=b.split("==");return a.create(N[0].trim(),this._deserializeValue(N[1],R))}if(b.indexOf("=~")>=0){let N=b.split("=~");return n.create(N[0].trim(),this._deserializeRegexValue(N[1],R))}if(b.indexOf(" in ")>=0){let N=b.split(" in ");return u.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(b)){const N=b.split(">=");return c.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(b)){const N=b.split(">");return h.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(b)){const N=b.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(b)){const N=b.split("<");return m.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(b)?S.create(b.substr(1).trim()):p.create(b)}static _deserializeValue(b,R){if(b=b.trim(),b==="true")return!0;if(b==="false")return!1;let N=/^'([^']*)'$/.exec(b);return N?N[1].trim():b}static _deserializeRegexValue(b,R){if((0,_.isFalsyOrWhitespace)(b)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=b.indexOf("/"),q=b.lastIndexOf("/");if(N===q||N<0){if(R)throw new Error(`bad regexp-value '${b}', missing /-enclosure`);return console.warn(`bad regexp-value '${b}', missing /-enclosure`),null}let re=b.slice(N+1,q),V=b[q+1]==="i"?"i":"";try{return new RegExp(re,V)}catch(W){if(R)throw new Error(`bad regexp-value '${b}', parse error: ${W}`);return console.warn(`bad regexp-value '${b}', parse error: ${W}`),null}}}e.ContextKeyExpr=k;function r(d,b){return d.cmp(b)}class C{constructor(){this.type=0}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class f{constructor(){this.type=1}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class p{constructor(b){this.key=b,this.type=2}static create(b){const R=y.get(b);return typeof R=="boolean"?R?f.INSTANCE:C.INSTANCE:new p(b)}cmp(b){return b.type!==this.type?this.type-b.type:g(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return S.create(this.key)}}e.ContextKeyDefinedExpr=p;class a{constructor(b,R){this.key=b,this.value=R,this.type=4}static create(b,R){if(typeof R=="boolean")return R?p.create(b):S.create(b);const N=y.get(b);return typeof N=="boolean"?R===(N?"true":"false")?f.INSTANCE:C.INSTANCE:new a(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:v(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(b){return b.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class u{constructor(b,R){this.key=b,this.valueKey=R,this.type=10}static create(b,R){return new u(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:v(this.key,this.valueKey,b.key,b.valueKey)}equals(b){return b.type===this.type?this.key===b.key&&this.valueKey===b.valueKey:!1}evaluate(b){const R=b.getValue(this.valueKey),N=b.getValue(this.key);return Array.isArray(R)?R.indexOf(N)>=0:typeof N=="string"&&typeof R=="object"&&R!==null?P.call(R,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(b){return b.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=u;class E{constructor(b){this._actual=b,this.type=11}static create(b){return new E(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new E(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class w{constructor(b,R){this.key=b,this.value=R,this.type=5}static create(b,R){if(typeof R=="boolean")return R?S.create(b):p.create(b);const N=y.get(b);return typeof N=="boolean"?R===(N?"true":"false")?C.INSTANCE:f.INSTANCE:new w(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:v(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(b){return b.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class S{constructor(b){this.key=b,this.type=3}static create(b){const R=y.get(b);return typeof R=="boolean"?R?C.INSTANCE:f.INSTANCE:new S(b)}cmp(b){return b.type!==this.type?this.type-b.type:g(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!b.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(b){return b.mapNot(this.key)}negate(){return p.create(this.key)}}e.ContextKeyNotExpr=S;class h{constructor(b,R){this.key=b,this.value=R,this.type=12}static create(b,R){return new h(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:v(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=h;class c{constructor(b,R){this.key=b,this.value=R,this.type=13}static create(b,R){return new c(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:v(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreaterEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class m{constructor(b,R){this.key=b,this.value=R,this.type=14}static create(b,R){return new m(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:v(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=m;class t{constructor(b,R){this.key=b,this.value=R,this.type=15}static create(b,R){return new t(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:v(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmallerEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(b,R){this.key=b,this.regexp=R,this.type=7}static create(b,R){return new n(b,R)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.key<b.key)return-1;if(this.key>b.key)return 1;const R=this.regexp?this.regexp.source:"",N=b.regexp?b.regexp.source:"";return R<N?-1:R>N?1:0}equals(b){if(b.type===this.type){const R=this.regexp?this.regexp.source:"",N=b.regexp?b.regexp.source:"";return this.key===b.key&&R===N}return!1}evaluate(b){let R=b.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const b=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${b}`}keys(){return[this.key]}map(b){return b.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=n;class o{constructor(b){this._actual=b,this.type=8}static create(b){return new o(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new o(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class i{constructor(b){this.expr=b,this.type=6}static create(b){return i._normalizeArr(b)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let R=0,N=this.expr.length;R<N;R++){const q=r(this.expr[R],b.expr[R]);if(q!==0)return q}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let R=0,N=this.expr.length;R<N;R++)if(!this.expr[R].equals(b.expr[R]))return!1;return!0}return!1}evaluate(b){for(let R=0,N=this.expr.length;R<N;R++)if(!this.expr[R].evaluate(b))return!1;return!0}static _normalizeArr(b){const R=[];let N=!1;for(const q of b)if(!!q){if(q.type===1){N=!0;continue}if(q.type===0)return C.INSTANCE;if(q.type===6){R.push(...q.expr);continue}R.push(q)}if(R.length===0&&N)return f.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(r);R.length>1;){const q=R[R.length-1];if(q.type!==9)break;R.pop();const re=R.pop(),V=s.create(q.expr.map(W=>i.create([W,re])));V&&(R.push(V),R.sort(r))}return R.length===1?R[0]:new i(R)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(let R of this.expr)b.push(...R.keys());return b}map(b){return new i(this.expr.map(R=>R.map(b)))}negate(){let b=[];for(let R of this.expr)b.push(R.negate());return s.create(b)}}e.ContextKeyAndExpr=i;class s{constructor(b){this.expr=b,this.type=9}static create(b){const R=s._normalizeArr(b);if(R.length!==0)return R.length===1?R[0]:new s(R)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let R=0,N=this.expr.length;R<N;R++){const q=r(this.expr[R],b.expr[R]);if(q!==0)return q}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let R=0,N=this.expr.length;R<N;R++)if(!this.expr[R].equals(b.expr[R]))return!1;return!0}return!1}evaluate(b){for(let R=0,N=this.expr.length;R<N;R++)if(this.expr[R].evaluate(b))return!0;return!1}static _normalizeArr(b){let R=[],N=!1;if(b){for(let q=0,re=b.length;q<re;q++){const V=b[q];if(!!V){if(V.type===0){N=!0;continue}if(V.type===1)return[f.INSTANCE];if(V.type===9){R=R.concat(V.expr);continue}R.push(V)}}if(R.length===0&&N)return[C.INSTANCE];R.sort(r)}return R}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(let R of this.expr)b.push(...R.keys());return b}map(b){return new s(this.expr.map(R=>R.map(b)))}negate(){let b=[];for(let N of this.expr)b.push(N.negate());const R=N=>N.type===9?N.expr:[N];for(;b.length>1;){const N=b.shift(),q=b.shift(),re=[];for(const V of R(N))for(const W of R(q))re.push(k.and(V,W));b.unshift(k.or(...re))}return b[0]}}e.ContextKeyOrExpr=s;class l extends p{constructor(b,R,N){super(b);this._defaultValue=R,typeof N=="object"?l._info.push(Object.assign(Object.assign({},N),{key:b})):N!==!0&&l._info.push({key:b,description:N,type:R!=null?typeof R:void 0})}static all(){return l._info.values()}bindTo(b){return b.createKey(this.key,this._defaultValue)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(b){return k.equals(this.key,b)}notEqualsTo(b){return k.notEquals(this.key,b)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(d,b){return d<b?-1:d>b?1:0}function v(d,b,R,N){return d<R?-1:d>R?1:b<N?-1:b>N?1:0}}),define(ge[182],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[183],pe([0,1,154,4,12]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function T(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=T;var y;(function(C){C[C.NoneOrRelevance=0]="NoneOrRelevance",C[C.LastUpdatedDate=1]="LastUpdatedDate",C[C.Title=2]="Title",C[C.PublisherName=3]="PublisherName",C[C.InstallCount=4]="InstallCount",C[C.PublishedDate=5]="PublishedDate",C[C.AverageRating=6]="AverageRating",C[C.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var P;(function(C){C[C.Default=0]="Default",C[C.Ascending=1]="Ascending",C[C.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var D;(function(C){C.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var k;(function(C){C[C.None=0]="None",C[C.Install=1]="Install",C[C.Update=2]="Update"})(k=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class r extends Error{constructor(f,p){super(f);this.code=p}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,_.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,_.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(ge[27],pe([0,1,9,4]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class y{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,C){if(typeof r=="undefined"||r===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof r=="string"||typeof C=="string"){let f=typeof r=="string"?r:r.value,p=typeof C=="string"?C:C.value;return _.equalsIgnoreCase(f,p)}return r._lower===C._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.ExtensionIdentifier=y;function P(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function D(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[184],pe([0,1,9,27]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(p,a){return p.uuid&&a.uuid?p.uuid===a.uuid:p.id===a.id?!0:(0,_.compareIgnoreCase)(p.id,a.id)===0}e.areSameExtensions=A;class T{constructor(a,u){this.version=u,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof T?A(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=T;function y(p,a){return`${p}.${a}`}e.getExtensionId=y;function P(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function D(p,a){return P(y(p,a))}e.getGalleryExtensionId=D;function k(p,a){const u=[],E=w=>{for(const S of u)if(S.some(h=>A(a(h),a(w))))return S;return null};for(const w of p){const S=E(w);S?S.push(w):u.push([w])}return u}e.groupByExtension=k;function r(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=r;function C(p){return Object.assign({id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0)},p.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function f(p){const a=new Set;for(const u of p)u.malicious&&a.add(u.id.id);return a}e.getMaliciousExtensionsSet=f}),define(ge[46],pe([0,1,156,8,2,4,9,11,24]),function(G,e,_,I,A,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function k(V){return V.create===!0}e.isFileOpenForWriteOptions=k;var r;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(r=e.FileType||(e.FileType={}));var C;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=f;function p(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=p;function a(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function u(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=u;var E;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(W,$){super(W);this.code=$}}e.FileSystemProviderError=w;function S(V,W){const $=new w(V.toString(),W);return c($,W),$}e.createFileSystemProviderError=S;function h(V){return V||S((0,_.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=h;function c(V,W){return V.name=W?`${W} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=c;function m(V){if(!V)return E.Unknown;if(V instanceof w)return V.code;const W=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!W)return E.Unknown;switch(W[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=m;function t(V){if(V instanceof g)return V.fileOperationResult;switch(m(V)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class o{constructor(W,$,U){this.resource=W,this.operation=$,this.target=U}isOperation(W){return this.operation===W}}e.FileOperationEvent=o;var i;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(i=e.FileChangeType||(e.FileChangeType={}));class s{constructor(W,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=W;for(const U of W)switch(U.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(U.resource,U);break}}contains(W,...$){return this.doContains(W,{includeChildren:!1},...$)}affects(W,...$){return this.doContains(W,{includeChildren:!0},...$)}doContains(W,$,...U){var F,M,L,O,B,j;if(!W)return!1;const Q=U.length>0;return!!((!Q||U.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(W))||$.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(W)))||(!Q||U.includes(0))&&(((L=this.updated)===null||L===void 0?void 0:L.get(W))||$.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(W)))||(!Q||U.includes(2))&&(((B=this.deleted)===null||B===void 0?void 0:B.findSubstr(W))||$.includeChildren&&((j=this.deleted)===null||j===void 0?void 0:j.findSuperstr(W))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(W){const $=[],U=W===1?this.added:W===0?this.updated:this.deleted;if(U)for(const[,F]of U)$.push(F);return $}filter(W){return new s(this.changes.filter($=>W($)),this.ignorePathCasing)}}e.FileChangesEvent=s;function l(V,W,$){return!V||!W||V===W||W.length>V.length?!1:(W.charAt(W.length-1)!==I.sep&&(W+=I.sep),$?(0,y.startsWithIgnoreCase)(V,W):V.indexOf(W)===0)}e.isParent=l;class g extends Error{constructor(W,$,U){super(W);this.fileOperationResult=$,this.options=U}static isFileOperationError(W){return W instanceof Error&&!(0,P.isUndefinedOrNull)(W.fileOperationResult)}}e.FileOperationError=g;var v;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(v=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var d;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(d=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function b(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=b;async function R(V,W){if(!W.canHandleResource(A.URI.from({scheme:V.scheme})))return new Promise($=>{const U=W.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===V.scheme&&F.added&&(U.dispose(),$())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(W){return(0,P.isNumber)(W)||(W=0),W<N.KB?(0,_.localize)(1,null,W.toFixed(0)):W<N.MB?(0,_.localize)(2,null,(W/N.KB).toFixed(2)):W<N.GB?(0,_.localize)(3,null,(W/N.MB).toFixed(2)):W<N.TB?(0,_.localize)(4,null,(W/N.GB).toFixed(2)):(0,_.localize)(5,null,(W/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var q;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function re(V){return{maxFileSize:V===0?300*N.MB:16*N.GB,maxHeapSize:V===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=re}),define(ge[82],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...A){this._entries=new Map;for(let[T,y]of A)this.set(T,y)}set(A,T){const y=this._entries.get(A);return this._entries.set(A,T),y}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=_}),define(ge[185],pe([0,1,16,178,112,4,82,13]),function(G,e,_,I,A,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class k extends Error{constructor(a){var u;super("cyclic dependency between services");this.message=(u=a.findCycleSlow())!==null&&u!==void 0?u:`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class r{constructor(a=new y.ServiceCollection,u=!1,E){this._activeInstantiations=new Set,this._services=a,this._strict=u,this._parent=E,this._services.set(T.IInstantiationService,this)}createChild(a){return new r(a,this._strict,this)}invokeFunction(a,...u){let E=f.traceInvocation(a),w=!1;try{return a({get:(h,c)=>{if(w)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(h,E);if(!m&&c!==T.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return m}},...u)}finally{w=!0,E.stop()}}createInstance(a,...u){let E,w;return a instanceof A.SyncDescriptor?(E=f.traceCreation(a.ctor),w=this._createInstance(a.ctor,a.staticArguments.concat(u),E)):(E=f.traceCreation(a),w=this._createInstance(a,u,E)),E.stop(),w}_createInstance(a,u=[],E){let w=T._util.getServiceDependencies(a).sort((c,m)=>c.index-m.index),S=[];for(const c of w){let m=this._getOrCreateServiceInstance(c.id,E);if(!m&&this._strict&&!c.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${c.id}.`);S.push(m)}let h=w.length>0?w[0].index:u.length;if(u.length!==h){console.warn(`[createInstance] First service dependency of ${a.name} at position ${h+1} conflicts with ${u.length} static arguments`);let c=h-u.length;c>0?u=u.concat(new Array(c)):u=u.slice(0,h)}return new a(...[...u,...S])}_setServiceInstance(a,u){if(this._services.get(a)instanceof A.SyncDescriptor)this._services.set(a,u);else if(this._parent)this._parent._setServiceInstance(a,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let u=this._services.get(a);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):u}_getOrCreateServiceInstance(a,u){let E=this._getServiceInstanceOrDescriptor(a);return E instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,E,u.branch(a,!0)):(u.branch(a,!1),E)}_safeCreateAndCacheServiceInstance(a,u,E){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,u,E)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,u,E){const w=new I.Graph(c=>c.id.toString());let S=0;const h=[{id:a,desc:u,_trace:E}];for(;h.length;){const c=h.pop();if(w.lookupOrInsertNode(c),S++>1e3)throw new k(w);for(let m of T._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(m.id);if(!t&&!m.optional&&console.warn(`[createInstance] ${a} depends on ${m.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const n={id:m.id,desc:t,_trace:c._trace.branch(m.id,!0)};w.insertEdge(c,n),h.push(n)}}}for(;;){const c=w.roots();if(c.length===0){if(!w.isEmpty())throw new k(w);break}for(const{data:m}of c){if(this._getServiceInstanceOrDescriptor(m.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,n)}w.removeNode(m)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,u,E=[],w,S){if(this._services.get(a)instanceof A.SyncDescriptor)return this._createServiceInstance(u,E,w,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,u,E,w,S);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(a,u=[],E,w){if(E){const S=new P.IdleValue(()=>this._createInstance(a,u,w));return new Proxy(Object.create(null),{get(h,c){if(c in h)return h[c];let m=S.value,t=m[c];return typeof t!="function"||(t=t.bind(m),h[c]=t),t},set(h,c,m){return S.value[c]=m,!0}})}else return this._createInstance(a,u,w)}}e.InstantiationService=r;var C;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(C||(C={}));class f{constructor(a,u){this.type=a,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new f(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(a){return D?new f(0,a.name):f._None}branch(a,u){let E=new f(2,a.toString());return this._dep.push([a,u,E]),E}stop(){let a=Date.now()-this._start;f._totals+=a;let u=!1;function E(S,h){let c=[],m=new Array(S+1).join("	");for(const[t,n,o]of h._dep)if(n&&o){u=!0,c.push(`${m}CREATES -> ${t}`);let i=E(S+1,o);i&&c.push(i)}else c.push(`${m}uses -> ${t}`);return c.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(a>2||u)&&console.log(w.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(ge[14],pe([0,1,4,6,10,3,59]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function P(){return new Date().toISOString()}var D;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class k extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class r extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(D.Error,this.format(o))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let o=0;o<t.length;o++){let i=t[o];if(typeof i=="object")try{i=JSON.stringify(i)}catch(s){}n+=(o>0?" ":"")+i}return n}}e.AbstractMessageLogger=r;class C extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...n):console.warn(`[main ${P()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class f extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=f;class p extends k{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class a extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const o of this.logServices)o.trace(t,...n)}debug(t,...n){for(const o of this.logServices)o.debug(t,...n)}info(t,...n){for(const o of this.logServices)o.info(t,...n)}warn(t,...n){for(const o of this.logServices)o.warn(t,...n)}error(t,...n){for(const o of this.logServices)o.error(t,...n)}critical(t,...n){for(const o of this.logServices)o.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class u extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=u;class E extends I.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(o))}))}createLogger(t,n){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),o),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class w{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=w;function S(m){if(m.verbose)return D.Trace;if(typeof m.logLevel=="string"){const t=h(m.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function h(m){switch(m){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=h;function c(m){switch(m){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=c}),define(ge[113],pe([0,1,14,46]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function A(D,k,r,C){try{const f=await new Promise((p,a)=>{G(["spdlog"],p,a)});return f.setAsyncMode(8192,500),f.createRotatingLoggerAsync(D,k,r,C)}catch(f){console.error(f)}return null}function T(D,k,r,C){return G.__$__nodeRequire("spdlog").createRotatingLogger(D,k,r,C)}e.createRotatingLogger=T;function y(D,k,r){switch(k){case _.LogLevel.Trace:D.trace(r);break;case _.LogLevel.Debug:D.debug(r);break;case _.LogLevel.Info:D.info(r);break;case _.LogLevel.Warning:D.warn(r);break;case _.LogLevel.Error:D.error(r);break;case _.LogLevel.Critical:D.critical(r);break;default:throw new Error("Invalid log level")}}class P extends _.AbstractMessageLogger{constructor(k,r,C,f){super();this.name=k,this.filepath=r,this.rotating=C,this.buffer=[],this.setLevel(f),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const k=this.rotating?6:1,r=30/k*I.ByteSize.MB;return A(this.name,this.filepath,r,k).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:f,message:p}of this.buffer)y(this._logger,f,p);this.buffer=[]}})}log(k,r){this._logger?y(this._logger,k,r):this.getLevel()<=k&&this.buffer.push({level:k,message:r})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(ge[114],pe([0,1,4,157,57]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function k(a,u){return u-a}D.compare=k;const r=Object.create(null);r[D.Error]=(0,I.localize)(0,null),r[D.Warning]=(0,I.localize)(1,null),r[D.Info]=(0,I.localize)(2,null);function C(a){return r[a]||""}D.toString=C;function f(a){switch(a){case A.default.Error:return D.Error;case A.default.Warning:return D.Warning;case A.default.Info:return D.Info;case A.default.Ignore:return D.Hint}}D.fromSeverity=f;function p(a){switch(a){case D.Error:return A.default.Error;case D.Warning:return A.default.Warning;case D.Info:return A.default.Info;case D.Hint:return A.default.Ignore}}D.toSeverity=p}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(D){const k="";function r(f){return C(f,!0)}D.makeKey=r;function C(f,p){let a=[k];return f.source?a.push(f.source.replace("\xA6","\\\xA6")):a.push(k),f.code?typeof f.code=="string"?a.push(f.code.replace("\xA6","\\\xA6")):a.push(f.code.value.replace("\xA6","\\\xA6")):a.push(k),f.severity!==void 0&&f.severity!==null?a.push(y.toString(f.severity)):a.push(k),f.message&&p?a.push(f.message.replace("\xA6","\\\xA6")):a.push(k),f.startLineNumber!==void 0&&f.startLineNumber!==null?a.push(f.startLineNumber.toString()):a.push(k),f.startColumn!==void 0&&f.startColumn!==null?a.push(f.startColumn.toString()):a.push(k),f.endLineNumber!==void 0&&f.endLineNumber!==null?a.push(f.endLineNumber.toString()):a.push(k),f.endColumn!==void 0&&f.endColumn!==null?a.push(f.endColumn.toString()):a.push(k),a.push(k),a.join("\xA6")}D.makeKeyOptionalMessage=C})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(ge[186],pe([0,1,57,4,3]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=(0,I.createDecorator)("notificationService");var T;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new D,this.onDidClose=A.Event.None,this.onDidChangeVisibility=A.Event.None}updateSeverity(r){}updateMessage(r){}updateActions(r){}close(){}}e.NoOpNotification=P;class D{infinite(){}done(){}total(r){}worked(r){}}e.NoOpProgress=D}),define(ge[187],pe([0,1,12,10,36,25]),function(G,e,_,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof I.globals.vscode!="undefined"){const P=I.globals.vscode.context.configuration();if(P)y=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const P=(0,T.dirname)(_.FileAccess.asFileUri("",G));y=G.__$__nodeRequire((0,T.joinPath)(P,"product.json").fsPath);const D=G.__$__nodeRequire((0,T.joinPath)(P,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else{y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.56.0-dev",nameShort:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});const P=document.getElementById("vscode-remote-product-configuration"),D=P&&P.getAttribute("data-settings");D&&Object.assign(y,JSON.parse(D))}e.default=y});var Ve=this&&this.__decorate||function(G,e,_,I){var A=arguments.length,T=A<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,_):I,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(G,e,_,I);else for(var P=G.length-1;P>=0;P--)(y=G[P])&&(T=(A<3?y(T):A>3?y(e,_,T):y(e,_))||T);return A>3&&T&&Object.defineProperty(e,_,T),T},xe=this&&this.__param||function(G,e){return function(_,I){e(_,I,G)}};define(ge[115],pe([0,1,4,21,6,13]),function(G,e,_,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var y;(function(r){r[r.Explorer=1]="Explorer",r[r.Scm=3]="Scm",r[r.Extensions=5]="Extensions",r[r.Window=10]="Window",r[r.Notification=15]="Notification",r[r.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let D=class extends A.Disposable{constructor(C,f){super();this.deferred=new T.DeferredPromise,f.withProgress(C,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,A.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};D=Ve([xe(1,e.IProgressService)],D),e.UnmanagedProgress=D;class k extends A.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new A.DisposableStore)}start(C){this.stop();const f=++this.currentOperationId,p=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{f===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,A.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,A.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,A.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:f,token:p.token,stop:()=>this.doStop(f),isCurrent:()=>this.currentOperationId===f}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(ge[40],pe([0,1,11,52]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(y,P){I.ok(_.isString(y)),I.ok(_.isObject(P)),I.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,P)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new A}),define(ge[116],pe([0,1,40,3]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,k){this.schemasById[A(D)]=k,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new T;_.Registry.add(e.Extensions.JSONContribution,y)}),define(ge[83],pe([0,1,153,3,40,11,116]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=A.Registry.as(y.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,S=!0){this.registerConfigurations([w],S)}registerConfigurations(w,S=!0){const h=[];w.forEach(c=>{h.push(...this.validateAndRegisterProperties(c,S,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterConfigurations(w){const S=[],h=c=>{if(c.properties)for(const m in c.properties)S.push(m),delete this.configurationProperties[m],this.removeFromSchema(m,c.properties[m]);c.allOf&&c.allOf.forEach(m=>h(m))};for(const c of w){h(c);const m=this.configurationContributors.indexOf(c);m!==-1&&this.configurationContributors.splice(m,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(w){const S=[],h=[];for(const c of w)for(const m in c)if(S.push(m),e.OVERRIDE_PROPERTY_PATTERN.test(m)){this.defaultValues[m]=Object.assign(Object.assign({},this.defaultValues[m]||{}),c[m]);const t={type:"object",default:this.defaultValues[m],description:_.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId};h.push(C(m)),this.configurationProperties[m]=t,this.defaultLanguageConfigurationOverridesNode.properties[m]=t}else{this.defaultValues[m]=c[m];const t=this.configurationProperties[m];t&&(this.updatePropertyDefaultValue(m,t),this.updateSchema(m,t))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(w){const S=[];for(const h of w)for(const c in h)if(S.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const m=this.configurationProperties[c];m&&(this.updatePropertyDefaultValue(c,m),this.updateSchema(c,m))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const S of w)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,S=!0,h,c=3){var m;c=T.isUndefinedOrNull(w.scope)?c:w.scope;let t=[],n=w.properties;if(n)for(let i in n){if(S&&a(i)){delete n[i];continue}const s=n[i];if(this.updatePropertyDefaultValue(i,s),e.OVERRIDE_PROPERTY_PATTERN.test(i)?s.scope=void 0:(s.scope=T.isUndefinedOrNull(s.scope)?c:s.scope,s.restricted=T.isUndefinedOrNull(s.restricted)?!!((m=h==null?void 0:h.restrictedConfigurations)===null||m===void 0?void 0:m.includes(i)):s.restricted),n[i].hasOwnProperty("included")&&!n[i].included){this.excludedConfigurationProperties[i]=n[i],delete n[i];continue}else this.configurationProperties[i]=n[i];!n[i].deprecationMessage&&n[i].markdownDeprecationMessage&&(n[i].deprecationMessage=n[i].markdownDeprecationMessage),t.push(i)}let o=w.allOf;if(o)for(let i of o)t.push(...this.validateAndRegisterProperties(i,S,h,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const S=h=>{let c=h.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let m=h.allOf;m&&m.forEach(S)};S(w)}updateSchema(w,S){switch(e.allSettings.properties[w]=S,S.scope){case 1:e.applicationSettings.properties[w]=S;break;case 2:e.machineSettings.properties[w]=S;break;case 6:e.machineOverridableSettings.properties[w]=S;break;case 3:e.windowSettings.properties[w]=S;break;case 4:e.resourceSettings.properties[w]=S;break;case 5:e.resourceSettings.properties[w]=S,this.resourceLanguageSettingsSchema.properties[w]=S;break}}removeFromSchema(w,S){switch(delete e.allSettings.properties[w],S.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const S=`[${w}]`,h={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,h),e.allSettings.properties[S]=h,e.applicationSettings.properties[S]=h,e.machineSettings.properties[S]=h,e.machineOverridableSettings.properties[S]=h,e.windowSettings.properties[S]=h,e.resourceSettings.properties[S]=h}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,S){let h=this.defaultValues[w];T.isUndefined(h)&&(h=S.default),T.isUndefined(h)&&(h=f(S.type)),S.default=h}}const r="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(r);function C(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=C;function f(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const p=new k;A.Registry.add(e.Extensions.Configuration,p);function a(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?_.localize(5,null,E):p.getConfigurationProperties()[E]!==void 0?_.localize(6,null,E):null:_.localize(4,null)}e.validateProperty=a;function u(){const E=[],w=p.getConfigurationProperties();for(const S of Object.keys(w))E.push([S,w[S].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=u}),define(ge[84],pe([0,1,23,11,2,40,4,83]),function(G,e,_,I,A,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationOverrides=D;var k;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function r(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=r;function C(n,o){const i=o?n?o.keys.filter(R=>n.keys.indexOf(R)===-1):[...o.keys]:[],s=n?o?n.keys.filter(R=>o.keys.indexOf(R)===-1):[...n.keys]:[],l=[];if(o&&n){for(const R of n.keys)if(o.keys.indexOf(R)!==-1){const N=w(n.contents,R),q=w(o.contents,R);_.equals(N,q)||l.push(R)}}const g=[],v=R=>{const N={};for(const q of R)for(const re of q.identifiers)N[m(re)]=q;return N},d=o?v(o.overrides):{},b=n?v(n.overrides):{};if(Object.keys(d).length)for(const R of i){const N=d[R];N&&g.push([(0,P.overrideIdentifierFromKey)(R),N.keys])}if(Object.keys(b).length)for(const R of s){const N=b[R];N&&g.push([(0,P.overrideIdentifierFromKey)(R),N.keys])}if(Object.keys(d).length&&Object.keys(b).length)for(const R of l){const N=b[R],q=d[R];if(N&&q){const re=C({contents:N.contents,keys:N.keys,overrides:[]},{contents:q.contents,keys:q.keys,overrides:[]});g.push([(0,P.overrideIdentifierFromKey)(R),[...re.added,...re.removed,...re.updated]])}}return{added:i,removed:s,updated:l,overrides:g}}e.compare=C;function f(n,o){const i=[];for(const s of Object.keys(n))if(P.OVERRIDE_PROPERTY_PATTERN.test(s)){const l={};for(const g in n[s])l[g]=n[s][g];i.push({identifiers:[(0,P.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(l),contents:p(l,o)})}return i}e.toOverrides=f;function p(n,o){const i=Object.create(null);for(let s in n)a(i,s,n[s],o);return i}e.toValuesTree=p;function a(n,o,i,s){const l=o.split("."),g=l.pop();let v=n;for(let d=0;d<l.length;d++){let b=l[d],R=v[b];switch(typeof R){case"undefined":R=v[b]=Object.create(null);break;case"object":break;default:s(`Ignoring ${o} as ${l.slice(0,d+1).join(".")} is ${JSON.stringify(R)}`);return}v=R}if(typeof v=="object"&&v!==null)try{v[g]=i}catch(d){s(`Ignoring ${o} as ${l.join(".")} is ${JSON.stringify(v)}`)}else s(`Ignoring ${o} as ${l.join(".")} is ${JSON.stringify(v)}`)}e.addToValueTree=a;function u(n,o){const i=o.split(".");E(n,i)}e.removeFromValueTree=u;function E(n,o){const i=o.shift();if(o.length===0){delete n[i];return}if(Object.keys(n).indexOf(i)!==-1){const s=n[i];typeof s=="object"&&!Array.isArray(s)&&(E(s,o),Object.keys(s).length===0&&delete n[i])}}function w(n,o,i){function s(v,d){let b=v;for(const R of d){if(typeof b!="object"||b===null)return;b=b[R]}return b}const l=o.split("."),g=s(n,l);return typeof g=="undefined"?i:g}e.getConfigurationValue=w;function S(n,o,i){Object.keys(o).forEach(s=>{s!=="__proto__"&&(s in n?I.isObject(n[s])&&I.isObject(o[s])?S(n[s],o[s],i):i&&(n[s]=o[s]):n[s]=o[s])})}e.merge=S;function h(){const n=T.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=h;function c(){const n=Object.create(null),o=T.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let i in o){let s=o[i].default;a(n,i,s,l=>console.error(`Conflict in default settings: ${l}`))}return n}e.getDefaultValues=c;function m(n){return`[${n}]`}e.keyFromOverrideIdentifier=m;function t(n,o,i){const s=n.inspect(o),l=n.inspect(i);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:s.defaultValue}e.getMigratedSettingValue=t}),define(ge[188],pe([0,1,55,24,17,11,23,2,83,84,40,6,3]),function(G,e,_,I,A,T,y,P,D,k,r,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},n=[],o=[]){this._contents=t,this._keys=n,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const o=this.getContentsForOverrideIdentifer(n);return o?t?(0,k.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const i of A.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[i],l=n[i];l&&(typeof s=="object"&&typeof l=="object"?(s=y.deepClone(s),this.mergeContents(s,l)):s=l),o[i]=s}return new p(o,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),o=y.deepClone(this.overrides),i=[...this.keys];for(const s of t){this.mergeContents(n,s.contents);for(const l of s.overrides){const[g]=o.filter(v=>A.equals(v.identifiers,l.identifiers));g?this.mergeContents(g.contents,l.contents):o.push(y.deepClone(l))}for(const l of s.keys)i.indexOf(l)===-1&&i.push(l)}return new p(n,i,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const o of Object.keys(n)){if(o in t&&T.isObject(t[o])&&T.isObject(n[o])){this.mergeContents(t[o],n[o]);continue}t[o]=y.deepClone(n[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,k.addToValueTree)(this.contents,t,n,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let o=0;o<n;o++)t.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=p;class a extends p{constructor(){const t=(0,k.getDefaultValues)(),n=(0,k.getConfigurationKeys)(),o=[];for(const i of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(i)&&o.push({identifiers:[(0,D.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,k.toValuesTree)(t[i],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,n,o)}}e.DefaultConfigurationModel=a;class u{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:o,keys:i,overrides:s,restricted:l}=this.doParseRaw(t,n);this._configurationModel=new p(o,i,s),this._restrictedConfigurations=l||[]}doParseContent(t){let n={},o=null,i=[],s=[],l=[];function g(d){Array.isArray(i)?i.push(d):o&&(i[o]=d)}let v={onObjectBegin:()=>{let d={};g(d),s.push(i),i=d,o=null},onObjectProperty:d=>{o=d},onObjectEnd:()=>{i=s.pop()},onArrayBegin:()=>{let d=[];g(d),s.push(i),i=d,o=null},onArrayEnd:()=>{i=s.pop()},onLiteralValue:g,onError:(d,b,R)=>{l.push({error:d,offset:b,length:R})}};if(t)try{_.visit(t,v),n=i[0]||{}}catch(d){console.error(`Error while parsing settings file ${this._name}: ${d}`),this._parseErrors=[d]}return n}doParseRaw(t,n){const o=r.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,o,!0,n);t=i.raw;const s=(0,k.toValuesTree)(t,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),l=Object.keys(t),g=(0,k.toOverrides)(t,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:s,keys:l,overrides:g,restricted:i.restricted}}filter(t,n,o,i){if(!(i==null?void 0:i.scopes)&&!(i==null?void 0:i.skipRestricted))return{raw:t,restricted:[]};const s={},l=[];for(let g in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(g)&&o){const v=this.filter(t[g],n,!1,i);s[g]=v.raw,l.push(...v.restricted)}else{const v=n[g],d=v?typeof v.scope!="undefined"?v.scope:3:void 0;(v==null?void 0:v.restricted)&&l.push(g),(d===void 0||i.scopes===void 0||i.scopes.includes(d))&&(i.skipRestricted&&(v==null?void 0:v.restricted)||(s[g]=t[g]))}return{raw:s,restricted:l}}}e.ConfigurationModelParser=u;class E extends C.Disposable{constructor(t,n,o,i){super();this.userSettingsResource=t,this.scopes=n,this.fileService=i,this._onDidChange=this._register(new f.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(f.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class w{constructor(t,n,o=new p,i=new p,s=new I.ResourceMap,l=new p,g=new I.ResourceMap,v=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=i,this._folderConfigurations=s,this._memoryConfiguration=l,this._memoryConfigurationByResource=g,this._freeze=v,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(t)}updateValue(t,n,o={}){let i;o.resource?(i=this._memoryConfigurationByResource.get(o.resource),i||(i=new p,this._memoryConfigurationByResource.set(o.resource,i))):i=this._memoryConfiguration,n===void 0?i.removeValue(t):i.setValue(t,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,o){const i=this.getConsolidateConfigurationModel(n,o),s=this.getFolderConfigurationModelForResource(n.resource,o),l=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,g=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),v=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),d=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),b=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,N=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,q=n.overrideIdentifier?l.override(n.overrideIdentifier).getValue(t):l.getValue(t),re=i.getValue(t),V=A.distinct(A.flatten(i.overrides.map(W=>W.identifiers))).filter(W=>i.getOverrideValue(t,W)!==void 0);return{defaultValue:g,userValue:v,userLocalValue:d,userRemoteValue:b,workspaceValue:R,workspaceFolderValue:N,memoryValue:q,value:re,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:v!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:d!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:b!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:s==null?void 0:s.freeze().getValue(t),override:n.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:q!==void 0?{value:l.getValue(t),override:n.overrideIdentifier?l.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const o=n.filter(i=>D.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const s=(0,D.overrideIdentifierFromKey)(i),l=this._defaultConfiguration.getKeysForOverrideIdentifier(s),g=t.getKeysForOverrideIdentifier(s),v=[...g.filter(d=>l.indexOf(d)===-1),...l.filter(d=>g.indexOf(d)===-1),...l.filter(d=>!y.equals(this._defaultConfiguration.override(s).getValue(d),t.override(s).getValue(d)))];return[s,v]});return this.updateDefaultConfiguration(t),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:o,removed:i,overrides:s}=(0,k.compare)(this.localUserConfiguration,t),l=[...n,...o,...i];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:o,removed:i,overrides:s}=(0,k.compare)(this.remoteUserConfiguration,t);let l=[...n,...o,...i];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:o,removed:i,overrides:s}=(0,k.compare)(this.workspaceConfiguration,t);let l=[...n,...o,...i];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:s}}compareAndUpdateFolderConfiguration(t,n){const o=this.folderConfigurations.get(t),{added:i,updated:s,removed:l,overrides:g}=(0,k.compare)(o,n);let v=[...i,...s,...l];return(v.length||!o)&&this.updateFolderConfiguration(t,n),{keys:v,overrides:g}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:i,removed:s,overrides:l}=(0,k.compare)(n,void 0);return{keys:[...o,...i,...s],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let o=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const i=n.getFolder(t);i&&(o=this.getFolderConsolidatedConfiguration(i.uri)||o);const s=this._memoryConfigurationByResource.get(t);s&&(o=o.merge(s))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(n=o.merge(i),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=o}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const o=n.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:o,overrides:i,keys:s}=this._folderConfigurations.get(n);return t.push([n,{contents:o,overrides:i,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((l,g)=>(l.set(P.URI.revive(g[0]),this.parseConfigurationModel(g[1])),l),new I.ResourceMap);return new w(n,o,new p,i,s,new p,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function S(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const t=new Set,n=new Map;for(const i of m)i.keys.forEach(s=>t.add(s)),i.overrides.forEach(([s,l])=>{const g=(0,I.getOrSet)(n,s,new Set);l.forEach(v=>g.add(v))});const o=[];return n.forEach((i,s)=>o.push([s,[...i.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=S;class h{constructor(t,n,o,i){this.change=t,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=i,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(g=>s.add(g)),t.overrides.forEach(([,g])=>g.forEach(v=>s.add(v))),this.affectedKeys=[...s.values()];const l=new p;this.affectedKeys.forEach(g=>l.setValue(g,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,s=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(i,s)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let o=(0,k.toValuesTree)({[n]:!0},()=>{}),i;for(;typeof o=="object"&&(i=Object.keys(o)[0]);){if(t=t[i],!t)return!1;o=o[i]}return!0}}e.ConfigurationChangeEvent=h;class c extends h{constructor(t,n,o,i){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=o,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=c}),define(ge[85],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var I;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(I=e.RemoteTrustOption||(e.RemoteTrustOption={}));var A;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(P,D=A.Unknown,k){super(P);this._message=P,this._code=D,this._detail=k,this.isHandled=D===A.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(P){return P instanceof T&&P._code===A.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof T&&P._code===A.NoResolverFound}static isHandled(P){return P instanceof T&&P.isHandled}}e.RemoteAuthorityResolverError=T}),define(ge[117],pe([0,1,12]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function I(D){return D.scheme===_.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=I;function A(D){if(!!D){const k=D.indexOf("+");return k<0?D:D.substr(0,k)}}e.getRemoteName=A;function T(D){return D.scheme!==_.Schemas.file&&D.scheme!==_.Schemas.vscodeRemote}function y(D){if(D.folders.length)return D.folders.every(k=>T(k.uri))?D.folders[0].uri:void 0;if(D.configuration&&T(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=y;function P(D){var k;return(k=y(D))===null||k===void 0?void 0:k.scheme}e.getVirtualWorkspaceScheme=P}),define(ge[189],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class _{vsda(){return new Promise((A,T)=>G(["vsda"],A,T))}async sign(A){try{const T=await this.vsda(),y=new T.signer;if(y)return y.sign(A)}catch(T){}return A}}e.SignService=_}),define(ge[190],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(A){this._callback=A,this._terminalBufferMap=new Map}dispose(){for(const A of this._terminalBufferMap.values())A.dispose()}startBuffering(A,T,y=5){let P;return P=T(D=>{const k=typeof D=="string"?D:D.data;let r=this._terminalBufferMap.get(A);if(r){r.data.push(k);return}const C=setTimeout(()=>this.flushBuffer(A),y);r={data:[k],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(A),P.dispose()}},this._terminalBufferMap.set(A,r)}),P}stopBuffering(A){const T=this._terminalBufferMap.get(A);T&&T.dispose()}flushBuffer(A){const T=this._terminalBufferMap.get(A);T&&(this._terminalBufferMap.delete(A),this._callback(A,T.data.join("")))}}e.TerminalDataBufferer=_}),define(ge[191],pe([0,1,44,8,36,26,11,23,10]),function(G,e,_,I,A,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function k(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(_.release());let f=0;return C&&C.length===4&&(f=parseInt(C[3])),f}e.getWindowsBuildNumber=k;async function r(C,f,p,a=A.env,u=T.exists){if(I.isAbsolute(C))return await u(C)?C:void 0;if(f===void 0&&(f=A.cwd()),I.dirname(C)!=="."){const h=I.join(f,C);return await u(h)?h:void 0}const w=(0,P.getCaseInsensitive)(a,"PATH");if(p===void 0&&(0,y.isString)(w)&&(p=w.split(I.delimiter)),p===void 0||p.length===0){const h=I.join(f,C);return await u(h)?h:void 0}for(let h of p){let c;if(I.isAbsolute(h)?c=I.join(h,C):c=I.join(f,h,C),await u(c))return c;if(D.isWindows){let m=c+".com";if(await u(m)||(m=c+".exe",await u(m)))return m}}const S=I.join(f,C);return await u(S)?S:void 0}e.findExecutable=r}),define(ge[192],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(ge[193],pe([0,1,4,6,40,3,192,43]),function(G,e,_,I,A,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var D;(function(E){function w(S){return S&&typeof S=="object"&&typeof S.id=="string"}E.isThemeColor=w})(D=e.ThemeColor||(e.ThemeColor={}));function k(E){return{id:E}}e.themeColorFromId=k;var r;(function(E){function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}E.isThemeIcon=w;const S=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function h(t){const n=S.exec(t);if(!!n){let[,o]=n;return{id:o}}}E.fromString=h;function c(t,n){let o=t.id;const i=o.lastIndexOf("~");return i!==-1&&(o=o.substring(0,i)),n&&(o=`${o}~${n}`),{id:o}}E.modify=c;function m(t,n){var o,i;return t.id===n.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((i=n.color)===null||i===void 0?void 0:i.id)}E.isEqual=m,E.asClassNameArray=P.CSSIcon.asClassNameArray,E.asClassName=P.CSSIcon.asClassName,E.asCSSSelector=P.CSSIcon.asCSSSelector})(r=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function C(E){switch(E){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,I.toDisposable)(()=>{const S=this.themingParticipants.indexOf(w);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new f;A.Registry.add(e.Extensions.ThemingContribution,p);function a(E){return p.onColorThemeChange(E)}e.registerThemingParticipant=a;class u extends I.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,S){let h=this.theme.getColor(w);return h&&S&&(h=S(h,this.theme)),h?h.toString():null}}e.Themable=u}),define(ge[194],pe([0,1,40,193,3,158,116,13,43]),function(G,e,_,I,A,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,S,h,c){const m=this.iconsById[w];if(m){if(h&&!m.description){m.description=h,this.iconSchema.properties[w].markdownDescription=`${h} $(${w})`;const o=this.iconReferenceSchema.enum.indexOf(w);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=h),this._onDidChange.fire()}return m}let t={id:w,description:h,defaults:S,deprecationMessage:c};this.iconsById[w]=t;let n={$ref:"#/definitions/icons"};return c&&(n.deprecationMessage=c),h&&(n.markdownDescription=`${h}: $(${w})`),this.iconSchema.properties[w]=n,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(h||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const S=this.iconReferenceSchema.enum.indexOf(w);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,S){const h=this.iconFontsById[w];if(h)return h;let c={id:w,definition:S};return this.iconFontsById[w]=c,this._onDidChange.fire(),c}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(m,t)=>m.id.localeCompare(t.id),S=m=>{for(;I.ThemeIcon.isThemeIcon(m.defaults);)m=this.iconsById[m.defaults.id];return`codicon codicon-${m?m.id:""}`};let h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(m=>this.iconsById[m]);for(const m of c.filter(t=>!!t.description).sort(w))h.push(`|<i class="${S(m)}"></i>|${m.id}|${I.ThemeIcon.isThemeIcon(m.defaults)?m.defaults.id:m.id}|${m.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const m of c.filter(t=>!I.ThemeIcon.isThemeIcon(t.defaults)).sort(w))h.push(`|<i class="${S(m)}"></i>|${m.id}|`);return h.join(`
`)}}const r=new k;_.Registry.add(e.Extensions.IconContribution,r);function C(E,w,S,h){return r.registerIcon(E,w,S,h)}e.registerIcon=C;function f(){return r}e.getIconRegistry=f;function p(){for(const E of D.iconRegistry.all)r.registerIcon(E.id,E.definition,E.description);D.iconRegistry.onDidRegister(E=>r.registerIcon(E.id,E.definition,E.description))}p(),e.iconsSchemaId="vscode://schemas/icons";let a=_.Registry.as(y.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,r.getIconSchema());const u=new P.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);r.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.widgetClose=C("widget-close",D.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",D.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",D.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=I.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(ge[60],pe([0,1,2,25,4,24]),function(G,e,_,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var y;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function P(f){const p=f;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=P;function D(f){const p=f;return!!(p&&typeof p=="object"&&_.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=D;class k{constructor(p,a,u,E){this._id=p,this._configuration=u,this._ignorePathCasing=E,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class r{constructor(p,a){this.raw=a,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,I.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=r;function C(f){return new r({uri:f,index:0,name:(0,I.basenameOrAuthority)(f)},{uri:f.toString()})}e.toWorkspaceFolder=C}),define(ge[118],pe([0,1,4,159,60,2,10,8,25,133,55,12,76,29,117]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const u=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E($){return(typeof $=="string"?(0,P.extname)($):(0,D.extname)($))===u}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,_.createDecorator)("workspacesService");function w($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function S($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=S;function h($){return $.hasOwnProperty("fileUri")}e.isRecentFile=h;function c($){const U=$;return typeof(U==null?void 0:U.id)=="string"&&T.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=c;function m($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=m;function t($){const U=$;return typeof(U==null?void 0:U.id)=="string"&&T.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=t;function n($){const U=$;if(U==null?void 0:U.uri)return{id:U.id,uri:T.URI.revive(U.uri)};const F=$;if(F==null?void 0:F.configPath)return{id:F.id,configPath:T.URI.revive(F.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=n;function o($,U){return D.extUriBiasedIgnorePathCase.isEqualOrParent($,U.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function i($){return s($)||l($)}e.isStoredWorkspaceFolder=i;function s($){const U=$;return typeof(U==null?void 0:U.path)=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=s;function l($){const U=$;return typeof(U==null?void 0:U.uri)=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=l;function g($,U,F,M,L=!y.isWindows,O){if($.scheme!==M.scheme)return{name:F,uri:$.toString(!0)};let B=U?void 0:O.relativePath(M,$);if(B!==void 0)B.length===0?B=".":y.isWindows&&$.scheme===C.Schemas.file&&!L&&(B=B.replace(/\//g,"\\"));else if($.scheme===C.Schemas.file)B=$.fsPath,y.isWindows&&(B=(0,f.normalizeDriveLetter)(B),L&&(B=(0,p.toSlashes)(B)));else{if(!O.isEqualAuthority($.authority,M.authority))return{name:F,uri:$.toString(!0)};B=$.path}return{name:F,path:B}}e.getStoredWorkspaceFolder=g;function v($,U,F){let M=[],L=new Set;const O=F.dirname(U);for(let B of $){let j=null;if(s(B))B.path&&(j=F.resolvePath(O,B.path));else if(l(B))try{j=T.URI.parse(B.uri),j.path[0]!=="/"&&(j=j.with({path:"/"+j.path}))}catch(Q){console.warn(Q)}if(j){let Q=F.getComparisonKey(j);if(!L.has(Q)){L.add(Q);const de=B.name||F.basenameOrAuthority(j);M.push(new A.WorkspaceFolder({uri:j,name:de,index:M.length},B))}}}return M}e.toWorkspaceFolders=v;function d($,U,F,M,L){let O=b(U,$);const B=L.dirname(U),j=L.dirname(M),Q=[],de=R(O.folders);for(const Le of O.folders){const z=s(Le)?L.resolvePath(B,Le.path):T.URI.parse(Le.uri);let Y;F?Y=!1:Y=!s(Le)||(0,P.isAbsolute)(Le.path),Q.push(g(z,Y,Le.name,j,de,L))}const be={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Ae=k.setProperty($,["folders"],Q,be);let Ce=k.applyEdits($,Ae);return O.remoteAuthority===(0,a.getRemoteAuthority)(M)&&(Ce=k.applyEdits(Ce,k.removeProperty(Ce,["remoteAuthority"],be))),Ce}e.rewriteWorkspaceFileForNewLocation=d;function b($,U){let F=r.parse(U);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(M=>i(M));else throw new Error(`${$} looks like an invalid workspace file.`);return F}function R($){return y.isWindows?$.some(U=>s(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function N($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function q($){return typeof $.folderUri=="string"}function re($){return typeof $.fileUri=="string"}function V($,U){const F={workspaces:[],files:[]};if($){const M=function(O,B){for(let j=0;j<O.length;j++)try{B(O[j],j)}catch(Q){U.warn(`Error restoring recent entry ${JSON.stringify(O[j])}: ${Q.toString()}. Skip entry.`)}},L=$;if(Array.isArray(L.entries))M(L.entries,O=>{const B=O.label,j=O.remoteAuthority;N(O)?F.workspaces.push({label:B,remoteAuthority:j,workspace:{id:O.workspace.id,configPath:T.URI.parse(O.workspace.configPath)}}):q(O)?F.workspaces.push({label:B,remoteAuthority:j,folderUri:T.URI.parse(O.folderUri)}):re(O)&&F.files.push({label:B,remoteAuthority:j,fileUri:T.URI.parse(O.fileUri)})});else{const O=$;Array.isArray(O.workspaces3)&&M(O.workspaces3,(B,j)=>{const Q=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[j]||void 0;typeof B=="object"&&typeof B.id=="string"&&typeof B.configURIPath=="string"?F.workspaces.push({label:Q,workspace:{id:B.id,configPath:T.URI.parse(B.configURIPath)}}):typeof B=="string"&&F.workspaces.push({label:Q,folderUri:T.URI.parse(B)})}),Array.isArray(O.files2)&&M(O.files2,(B,j)=>{const Q=Array.isArray(O.fileLabels)&&O.fileLabels[j]||void 0;typeof B=="string"&&F.files.push({label:Q,fileUri:T.URI.parse(B)})})}}return F}e.restoreRecentlyOpened=V;function W($){const U={entries:[]};for(const F of $.workspaces)S(F)?U.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):U.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of $.files)U.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return U}e.toStoreData=W}),define(ge[86],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{constructor(A){this.id=A,this._data=new Map,this._idPool=1}add(A){const T=this._idPool++;return this._data.set(T,A),this.logDebugInfo(),T}get(A,T){return this._data.has(A)?this._data.get(A)[T]:void 0}delete(A){this._data.delete(A),this.logDebugInfo()}logDebugInfo(){!_.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=_,_.enableDebugLogging=!1}),define(ge[195],pe([0,1,2,3]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class A{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(P=>({name:P.name,group:P.group,resource:_.URI.revive(P.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(ge[61],pe([0,1,12,4]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,P){P===null?this._providerInfo.delete(y):this._providerInfo.set(y,P)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(ge[28],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,_.createDecorator)("IExtHostInitDataService")}),define(ge[196],pe([0,1,13]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(y,P,D){this._deferredPromises=new Map,this._id=y,this._shared=P,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new _.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const r of k.values())r.complete()}catch(r){for(const C of k.values())C.error(r)}})()},0)}get whenReady(){return this._init}get(y,P){let D=this._value[y];return typeof D=="undefined"&&(D=P),D}update(y,P){this._value[y]=P;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const k=new _.DeferredPromise;return this._deferredPromises.set(y,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class A extends I{constructor(y,P){super(y.identifier.value,!0,P);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=A}),define(ge[15],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class I{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=I});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[197],pe([0,1,27,3]),function(G,e,_,I){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(P,D){A.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(P.identifier),tt(this,A,D,"f"),Ue(this,A,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(P){return Ue(this,A,"f").get(this._id,P)}store(P,D){return Ue(this,A,"f").store(this._id,P,D)}delete(P){return Ue(this,A,"f").delete(this._id,P)}}e.ExtensionSecrets=T,A=new WeakMap}),define(ge[119],pe([0,1,4,3]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class A{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=A,e.IExtHostTelemetry=(0,_.createDecorator)("IExtHostTelemetry")}),define(ge[87],pe([0,1,3]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var I;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(I=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const A=new WeakMap,T=y=>{let P=A.get(y);return P||(P={children:new Map,bus:new _.Emitter},A.set(y,P)),P};e.getPrivateApiFor=T}),define(ge[50],pe([0,1,4,3,15]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(P){function D(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public}}P.fromApiTunnel=D;function k(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.public}}P.fromServiceTunnel=k})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,_.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,k){return{dispose:()=>{}}}async $providePortAttributes(D,k,r,C,f){return[]}async $forwardPort(D,k){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=Ve([xe(0,A.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)},qt=this&&this.__rest||function(G,e){var _={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(_[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(G);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(G,I[A])&&(_[I[A]]=G[I[A]]);return _};define(ge[7],pe([0,1,17,16,98,24,9,11,2,30,46,85,87]),function(G,e,_,I,A,T,y,P,D,k,r,C,f){"use strict";var p,a,u,E,w,S,h,c,m,t,n,o,i,s,l,g;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function v(H){function x(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf(x,H),Object.setPrototypeOf(x.prototype,H.prototype),x}let d=u=class{constructor(x){p.set(this,void 0),tt(this,p,x,"f")}static from(...x){let oe=x;return new u(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}dispose(){typeof Ue(this,p,"f")=="function"&&(Ue(this,p,"f").call(this),tt(this,p,void 0,"f"))}};p=new WeakMap,d=u=Ve([v],d),e.Disposable=d;let b=E=class{constructor(x,oe){if(x<0)throw(0,I.illegalArgument)("line must be non-negative");if(oe<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=x,this._character=oe}static Min(...x){if(x.length===0)throw new TypeError;let oe=x[0];for(let ke=1;ke<x.length;ke++){const Ke=x[ke];Ke.isBefore(oe)&&(oe=Ke)}return oe}static Max(...x){if(x.length===0)throw new TypeError;let oe=x[0];for(let ke=1;ke<x.length;ke++){const Ke=x[ke];Ke.isAfter(oe)&&(oe=Ke)}return oe}static isPosition(x){if(!x)return!1;if(x instanceof E)return!0;let{line:oe,character:ke}=x;return typeof oe=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,oe=0){if(x===null||oe===null)throw(0,I.illegalArgument)();let ke;return typeof x=="undefined"?ke=0:typeof x=="number"?ke=x:(ke=typeof x.lineDelta=="number"?x.lineDelta:0,oe=typeof x.characterDelta=="number"?x.characterDelta:0),ke===0&&oe===0?this:new E(this.line+ke,this.character+oe)}with(x,oe=this.character){if(x===null||oe===null)throw(0,I.illegalArgument)();let ke;return typeof x=="undefined"?ke=this.line:typeof x=="number"?ke=x:(ke=typeof x.line=="number"?x.line:this.line,oe=typeof x.character=="number"?x.character:this.character),ke===this.line&&oe===this.character?this:new E(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};b=E=Ve([v],b),e.Position=b;let R=w=class{constructor(x,oe,ke,Ke){let et,st;if(typeof x=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"?(et=new b(x,oe),st=new b(ke,Ke)):x instanceof b&&oe instanceof b&&(et=x,st=oe),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(x){return x instanceof w?!0:x?b.isPosition(x.start)&&b.isPosition(x.end):!1}get start(){return this._start}get end(){return this._end}contains(x){return x instanceof w?this.contains(x._start)&&this.contains(x._end):x instanceof b?!(x.isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const oe=b.Max(x.start,this._start),ke=b.Min(x.end,this._end);if(!oe.isAfter(ke))return new w(oe,ke)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const oe=b.Min(x.start,this._start),ke=b.Max(x.end,this.end);return new w(oe,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,oe=this.end){if(x===null||oe===null)throw(0,I.illegalArgument)();let ke;return x?b.isPosition(x)?ke=x:(ke=x.start||this.start,oe=x.end||this.end):ke=this.start,ke.isEqual(this._start)&&oe.isEqual(this.end)?this:new w(ke,oe)}toJSON(){return[this.start,this.end]}};R=w=Ve([v],R),e.Range=R;let N=S=class extends R{constructor(x,oe,ke,Ke){let et,st;if(typeof x=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"?(et=new b(x,oe),st=new b(ke,Ke)):x instanceof b&&oe instanceof b&&(et=x,st=oe),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(x){return x instanceof S?!0:x?R.isRange(x)&&b.isPosition(x.anchor)&&b.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};N=S=Ve([v],N),e.Selection=N;class q{constructor(x,oe,ke){if(typeof x!="string"||x.length===0)throw(0,I.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,I.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,I.illegalArgument)("connectionToken");this.host=x,this.port=Math.round(oe),this.connectionToken=ke}}e.ResolvedAuthority=q;class re extends Error{constructor(x,oe=C.RemoteAuthorityResolverErrorCode.Unknown,ke){super(x);this._message=x,this._code=oe,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,re.prototype)}static NotAvailable(x,oe){return new re(x,C.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(x){return new re(x,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=re;var V;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var W;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let $=h=class{constructor(x,oe){this._range=x,this._newText=oe}static isTextEdit(x){return x instanceof h?!0:x?R.isRange(x)&&typeof x.newText=="string":!1}static replace(x,oe){return new h(x,oe)}static insert(x,oe){return h.replace(new R(x,x),oe)}static delete(x){return h.replace(x,"")}static setEndOfLine(x){const oe=new h(new R(new b(0,0),new b(0,0)),"");return oe.newEol=x,oe}get range(){return this._range}set range(x){if(x&&!R.isRange(x))throw(0,I.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,I.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,I.illegalArgument)("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};$=h=Ve([v],$),e.TextEdit=$;var U;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellOutput=4]="CellOutput",H[H.CellReplace=5]="CellReplace",H[H.CellOutputItem=6]="CellOutputItem"})(U=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,oe,ke,Ke){this._edits.push({_type:1,from:x,to:oe,options:ke,metadata:Ke})}createFile(x,oe,ke){this._edits.push({_type:1,from:void 0,to:x,options:oe,metadata:ke})}deleteFile(x,oe,ke){this._edits.push({_type:1,from:x,to:void 0,options:oe,metadata:ke})}replaceNotebookMetadata(x,oe,ke){this._edits.push({_type:3,metadata:ke,uri:x,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(x,oe,ke,Ke,et){let st,ut,yt=[],Ct;if(Wt.isNotebookRange(oe)&&Ft.isNotebookCellDataArray(ke)&&!Ft.isNotebookCellDataArray(Ke)?(st=oe.start,ut=oe.end,yt=ke,Ct=Ke):typeof oe=="number"&&typeof ke=="number"&&Ft.isNotebookCellDataArray(Ke)&&(st=oe,ut=ke,yt=Ke,Ct=et),st===void 0||ut===void 0)throw new Error("Invalid arguments");(st!==ut||yt.length>0)&&this._edits.push({_type:5,uri:x,index:st,count:ut-st,cells:yt,metadata:Ct})}replaceNotebookCellMetadata(x,oe,ke,Ke){this._edits.push({_type:3,metadata:Ke,uri:x,edit:{editType:8,index:oe,metadata:ke}})}replace(x,oe,ke,Ke){this._edits.push({_type:2,uri:x,edit:new $(oe,ke),metadata:Ke})}insert(x,oe,ke,Ke){this.replace(x,new R(oe,oe),ke,Ke)}delete(x,oe,ke){this.replace(x,oe,"",ke)}has(x){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===x.toString())}set(x,oe){if(oe)for(const ke of oe)ke&&this._edits.push({_type:2,uri:x,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ke=this._edits[ke];Ke._type===2&&Ke.uri.toString()===x.toString()&&(this._edits[ke]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(x){const oe=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===x.toString()&&oe.push(ke.edit);return oe}entries(){const x=new T.ResourceMap;for(let oe of this._edits)if(oe._type===2){let ke=x.get(oe.uri);ke||(ke=[oe.uri,[]],x.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=Ve([v],F),e.WorkspaceEdit=F;let M=c=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof c?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=c._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,oe=this._tabstop++){if(typeof x=="function"){const ke=new c;ke._tabstop=this._tabstop,x(ke),this._tabstop=ke._tabstop,x=ke.value}else x=c._escape(x);return this.value+="${",this.value+=oe,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,oe=this._tabstop++){const ke=x.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(x,oe){if(typeof oe=="function"){const ke=new c;ke._tabstop=this._tabstop,oe(ke),this._tabstop=ke._tabstop,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};M=c=Ve([v],M),e.SnippetString=M;var L;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(L=e.DiagnosticTag||(e.DiagnosticTag={}));var O;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let B=m=class{constructor(x,oe){if(this.uri=x,oe)if(oe instanceof R)this.range=oe;else if(oe instanceof b)this.range=new R(oe,oe);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof m?!0:x?R.isRange(x.range)&&D.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};B=m=Ve([v],B),e.Location=B;let j=class{constructor(x,oe){this.location=x,this.message=oe}static is(x){return x?typeof x.message=="string"&&x.location&&R.isRange(x.location.range)&&D.URI.isUri(x.location.uri):!1}static isEqual(x,oe){return x===oe?!0:!x||!oe?!1:x.message===oe.message&&x.location.range.isEqual(oe.location.range)&&x.location.uri.toString()===oe.location.uri.toString()}};j=Ve([v],j),e.DiagnosticRelatedInformation=j;let Q=class{constructor(x,oe,ke=O.Error){if(!R.isRange(x))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=x,this.message=oe,this.severity=ke}toJSON(){return{severity:O[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,oe){return x===oe?!0:!x||!oe?!1:x.message===oe.message&&x.severity===oe.severity&&x.code===oe.code&&x.severity===oe.severity&&x.source===oe.source&&x.range.isEqual(oe.range)&&(0,_.equals)(x.tags,oe.tags)&&(0,_.equals)(x.relatedInformation,oe.relatedInformation,j.isEqual)}};Q=Ve([v],Q),e.Diagnostic=Q;let de=class{constructor(x,oe){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:(0,A.isMarkdownString)(x)?this.contents=[x]:this.contents=[x],this.range=oe}};de=Ve([v],de),e.Hover=de;var be;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ae=class{constructor(x,oe=be.Text){this.range=x,this.kind=oe}toJSON(){return{range:this.range,kind:be[this.kind]}}};Ae=Ve([v],Ae),e.DocumentHighlight=Ae;var Ce;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(Ce=e.SymbolKind||(e.SymbolKind={}));var Le;(function(H){H[H.Deprecated=1]="Deprecated"})(Le=e.SymbolTag||(e.SymbolTag={}));let z=t=class{constructor(x,oe,ke,Ke,et){this.name=x,this.kind=oe,this.containerName=et,typeof ke=="string"&&(this.containerName=ke),Ke instanceof B?this.location=Ke:ke instanceof R&&(this.location=new B(Ke,ke)),t.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ce[this.kind],location:this.location,containerName:this.containerName}}};z=t=Ve([v],z),e.SymbolInformation=z;let Y=n=class{constructor(x,oe,ke,Ke,et){this.name=x,this.detail=oe,this.kind=ke,this.range=Ke,this.selectionRange=et,this.children=[],n.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(n.validate)}};Y=n=Ve([v],Y),e.DocumentSymbol=Y;var ee;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(x,oe){this.title=x,this.kind=oe}};ae=Ve([v],ae),e.CodeAction=ae;let me=o=class{constructor(x){this.value=x}append(x){return new o(this.value?this.value+o.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+o.sep)}};me.sep=".",me=o=Ve([v],me),e.CodeActionKind=me,me.Empty=new me(""),me.QuickFix=me.Empty.append("quickfix"),me.Refactor=me.Empty.append("refactor"),me.RefactorExtract=me.Refactor.append("extract"),me.RefactorInline=me.Refactor.append("inline"),me.RefactorRewrite=me.Refactor.append("rewrite"),me.Source=me.Empty.append("source"),me.SourceOrganizeImports=me.Source.append("organizeImports"),me.SourceFixAll=me.Source.append("fixAll");let De=class{constructor(x,oe){if(this.range=x,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};De=Ve([v],De),e.SelectionRange=De;class Oe{constructor(x,oe,ke,Ke,et,st){this.kind=x,this.name=oe,this.detail=ke,this.uri=Ke,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=Oe;class we{constructor(x,oe){this.fromRanges=oe,this.from=x}}e.CallHierarchyIncomingCall=we;class Pe{constructor(x,oe){this.fromRanges=oe,this.to=x}}e.CallHierarchyOutgoingCall=Pe;let Re=class{constructor(x,oe){this.range=x,this.command=oe}get isResolved(){return!!this.command}};Re=Ve([v],Re),e.CodeLens=Re;let Be=i=class{constructor(x,oe=!1){a.set(this,void 0),tt(this,a,new A.MarkdownString(x,{supportThemeIcons:oe}),"f")}static isMarkdownString(x){return x instanceof i?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return Ue(this,a,"f").value}set value(x){Ue(this,a,"f").value=x}get isTrusted(){return Ue(this,a,"f").isTrusted}set isTrusted(x){Ue(this,a,"f").isTrusted=x}get supportThemeIcons(){return Ue(this,a,"f").supportThemeIcons}appendText(x){return Ue(this,a,"f").appendText(x),this}appendMarkdown(x){return Ue(this,a,"f").appendMarkdown(x),this}appendCodeblock(x,oe){return Ue(this,a,"f").appendCodeblock(oe!=null?oe:"",x),this}};a=new WeakMap,Be=i=Ve([v],Be),e.MarkdownString=Be;let Se=class{constructor(x,oe){this.label=x,this.documentation=oe}};Se=Ve([v],Se),e.ParameterInformation=Se;let qe=class{constructor(x,oe){this.label=x,this.documentation=oe,this.parameters=[]}};qe=Ve([v],qe),e.SignatureInformation=qe;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=Ve([v],X),e.SignatureHelp=X;var ie;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(ie=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var _e;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(_e=e.InlineHintKind||(e.InlineHintKind={}));let Ne=class{constructor(x,oe,ke){this.text=x,this.range=oe,this.kind=ke}};Ne=Ve([v],Ne),e.InlineHint=Ne;var ze;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Je;(function(H){H[H.Deprecated=1]="Deprecated"})(Je=e.CompletionItemTag||(e.CompletionItemTag={}));let K=class{constructor(x,oe){this.label=x,this.kind=oe}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};K=Ve([v],K),e.CompletionItem=K;let se=class{constructor(x=[],oe=!1){this.items=x,this.isIncomplete=oe}};se=Ve([v],se),e.CompletionList=se;var he;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(he=e.ViewColumn||(e.ViewColumn={}));var J;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(J=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ne;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(ne=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ce;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(ce=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ye;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var je;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(je=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function x(oe){switch(oe){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=x}(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let He=class{constructor(x,oe){if(oe&&!D.URI.isUri(oe))throw(0,I.illegalArgument)("target");if(!R.isRange(x)||x.isEmpty)throw(0,I.illegalArgument)("range");this.range=x,this.target=oe}};He=Ve([v],He),e.DocumentLink=He;let We=class{constructor(x,oe,ke,Ke){this.red=x,this.green=oe,this.blue=ke,this.alpha=Ke}};We=Ve([v],We),e.Color=We;let Ge=class{constructor(x,oe){if(oe&&!(oe instanceof We))throw(0,I.illegalArgument)("color");if(!R.isRange(x)||x.isEmpty)throw(0,I.illegalArgument)("range");this.range=x,this.color=oe}};Ge=Ve([v],Ge),e.ColorInformation=Ge;let nt=class{constructor(x){if(!x||typeof x!="string")throw(0,I.illegalArgument)("label");this.label=x}};nt=Ve([v],nt),e.ColorPresentation=nt;var dt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var it;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ye;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Ye=e.TaskRevealKind||(e.TaskRevealKind={}));var mt;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(mt=e.TaskPanelKind||(e.TaskPanelKind={}));let wt=s=class{constructor(x,oe){if(typeof x!="string"||typeof oe!="string")throw(0,I.illegalArgument)("name");this._id=x}static from(x){switch(x){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};wt.Clean=new s("clean","Clean"),wt.Build=new s("build","Build"),wt.Rebuild=new s("rebuild","Rebuild"),wt.Test=new s("test","Test"),wt=s=Ve([v],wt),e.TaskGroup=wt;function Ee(H){let x="";for(let oe=0;oe<H.length;oe++)x+=H[oe].replace(/,/g,",,")+",";return x}let fe=class{constructor(x,oe,ke){if(typeof x!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=x,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=ke):this._options=oe)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,I.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)x.push(oe);return Ee(x)}};fe=Ve([v],fe),e.ProcessExecution=fe;let le=class{constructor(x,oe,ke){if(this._args=[],Array.isArray(oe)){if(!x)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,I.illegalArgument)("command");this._command=x,this._args=oe,this._options=ke}else{if(typeof x!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=x,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,I.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)x.push(typeof oe=="string"?oe:oe.value);return Ee(x)}};le=Ve([v],le),e.ShellExecution=le;var Z;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Z=e.ShellQuoting||(e.ShellQuoting={}));var Fe;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Fe=e.TaskScope||(e.TaskScope={}));class Te{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=Te;let Qe=l=class{constructor(x,oe,ke,Ke,et,st){this.__deprecated=!1,this._definition=this.definition=x;let ut;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=ke,this.execution=Ke,ut=et,this.__deprecated=!0):oe===Fe.Global||oe===Fe.Workspace?(this.target=oe,this._name=this.name=ke,this._source=this.source=Ke,this.execution=et,ut=st):(this.target=oe,this._name=this.name=ke,this._source=this.source=Ke,this.execution=et,ut=st),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof fe?this._definition={type:l.ProcessType,id:this._execution.computeId()}:this._execution instanceof le?this._definition={type:l.ShellType,id:this._execution.computeId()}:this._execution instanceof Te?this._definition={type:l.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:l.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const oe=this._definition.type;(l.EmptyType===oe||l.ProcessType===oe||l.ShellType===oe||l.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};Qe.ExtensionCallbackType="customExecution",Qe.ProcessType="process",Qe.ShellType="shell",Qe.EmptyType="$empty",Qe=l=Ve([v],Qe),e.Task=Qe;var Ze;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Ze=e.ProgressLocation||(e.ProgressLocation={}));let ct=class{constructor(x,oe=ht.None){this.collapsibleState=oe,D.URI.isUri(x)?this.resourceUri=x:this.label=x}};ct=Ve([v],ct),e.TreeItem=ct;var ht;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Xe=class{constructor(x,oe){this.id=x,this.color=oe}};Xe=Ve([v],Xe),e.ThemeIcon=Xe,Xe.File=new Xe("file"),Xe.Folder=new Xe("folder");let ot=class{constructor(x){this.id=x}};ot=Ve([v],ot),e.ThemeColor=ot;var ft;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let at=class{constructor(x,oe){if(typeof x!="string"&&(!x||!D.URI.isUri(x)&&!D.URI.isUri(x.uri)))throw(0,I.illegalArgument)("base");if(typeof oe!="string")throw(0,I.illegalArgument)("pattern");typeof x=="string"?(this.baseFolder=D.URI.file(x),this.base=x):D.URI.isUri(x)?(this.baseFolder=x,this.base=x.fsPath):(this.baseFolder=x.uri,this.base=x.uri.fsPath),this.pattern=oe}};at=Ve([v],at),e.RelativePattern=at;let St=class{constructor(x,oe,ke,Ke){this.enabled=typeof x=="boolean"?x:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};St=Ve([v],St),e.Breakpoint=St;let vt=class extends St{constructor(x,oe,ke,Ke,et){super(oe,ke,Ke,et);if(x===null)throw(0,I.illegalArgument)("location");this.location=x}};vt=Ve([v],vt),e.SourceBreakpoint=vt;let kt=class extends St{constructor(x,oe,ke,Ke,et){super(oe,ke,Ke,et);this.functionName=x}};kt=Ve([v],kt),e.FunctionBreakpoint=kt;let At=class extends St{constructor(x,oe,ke,Ke,et,st,ut){super(Ke,et,st,ut);if(!oe)throw(0,I.illegalArgument)("dataId");this.label=x,this.dataId=oe,this.canPersist=ke}};At=Ve([v],At),e.DataBreakpoint=At;let Tt=class{constructor(x,oe,ke){this.command=x,this.args=oe||[],this.options=ke}};Tt=Ve([v],Tt),e.DebugAdapterExecutable=Tt;let _t=class{constructor(x,oe){this.port=x,this.host=oe}};_t=Ve([v],_t),e.DebugAdapterServer=_t;let Jt=class{constructor(x){this.path=x}};Jt=Ve([v],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor(x){this.implementation=x}};Zt=Ve([v],Zt),e.DebugAdapterInlineImplementation=Zt;let gt=class{constructor(x,oe){this.range=x,this.expression=oe}};gt=Ve([v],gt),e.EvaluatableExpression=gt;let en=class{constructor(x,oe){this.range=x,this.text=oe}};en=Ve([v],en),e.InlineValueText=en;let Dt=class{constructor(x,oe,ke=!0){this.range=x,this.variableName=oe,this.caseSensitiveLookup=ke}};Dt=Ve([v],Dt),e.InlineValueVariableLookup=Dt;let Kt=class{constructor(x,oe){this.range=x,this.expression=oe}};Kt=Ve([v],Kt),e.InlineValueEvaluatableExpression=Kt;let tn=class{constructor(x,oe){this.frameId=x,this.stoppedLocation=oe}};tn=Ve([v],tn),e.InlineValueContext=tn;var Gt;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Gt=e.FileChangeType||(e.FileChangeType={}));let lt=g=class extends Error{constructor(x,oe=r.FileSystemProviderErrorCode.Unknown,ke){var Ke;super(D.URI.isUri(x)?x.toString(!0):x);this.code=(Ke=ke==null?void 0:ke.name)!==null&&Ke!==void 0?Ke:"Unknown",(0,r.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(x){return new g(x,r.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(x){return new g(x,r.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(x){return new g(x,r.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(x){return new g(x,r.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(x){return new g(x,r.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(x){return new g(x,r.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}};lt=g=Ve([v],lt),e.FileSystemError=lt;let nn=class{constructor(x,oe,ke){this.start=x,this.end=oe,this.kind=ke}};nn=Ve([v],nn),e.FoldingRange=nn;var Rt;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Bt;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Bt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var gn;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(gn=e.CommentMode||(e.CommentMode={}));class yn{constructor(x,oe=[]){this.tokenTypes=x,this.tokenModifiers=oe}}e.SemanticTokensLegend=yn;function pn(H){return typeof H=="undefined"||(0,P.isStringArray)(H)}class rn{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let oe=0,ke=x.tokenTypes.length;oe<ke;oe++)this._tokenTypeStrToInt.set(x.tokenTypes[oe],oe);for(let oe=0,ke=x.tokenModifiers.length;oe<ke;oe++)this._tokenModifierStrToInt.set(x.tokenModifiers[oe],oe)}}push(x,oe,ke,Ke,et){if(typeof x=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(x,oe,ke,Ke,et);if(R.isRange(x)&&typeof oe=="string"&&pn(ke))return this._push(x,oe,ke);throw(0,I.illegalArgument)()}_push(x,oe,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ke=x.start.line,et=x.start.character,st=x.end.character-x.start.character,ut=this._tokenTypeStrToInt.get(oe);let yt=0;if(ke)for(const Ct of ke){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const Pt=this._tokenModifierStrToInt.get(Ct);yt|=1<<Pt>>>0}this._pushEncoded(Ke,et,st,ut,yt)}_pushEncoded(x,oe,ke,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Ct=0,Pt=0;for(let It=0;It<yt;It++){let Mt=this._data[5*It],hn=this._data[5*It+1];Mt===0?(Mt=Ct,hn+=Pt):Mt+=Ct,this._data[5*It]=Mt,this._data[5*It+1]=hn,Ct=Mt,Pt=hn}}let st=x,ut=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=x,this._prevChar=oe}static _sortAndDeltaEncode(x){let oe=[];const ke=x.length/5|0;for(let ut=0;ut<ke;ut++)oe[ut]=ut;oe.sort((ut,yt)=>{const Ct=x[5*ut],Pt=x[5*yt];if(Ct===Pt){const It=x[5*ut+1],Mt=x[5*yt+1];return It-Mt}return Ct-Pt});const Ke=new Uint32Array(x.length);let et=0,st=0;for(let ut=0;ut<ke;ut++){const yt=5*oe[ut],Ct=x[yt+0],Pt=x[yt+1],It=x[yt+2],Mt=x[yt+3],hn=x[yt+4],Mn=Ct-et,Bn=Mn===0?Pt-st:Pt,fn=5*ut;Ke[fn+0]=Mn,Ke[fn+1]=Bn,Ke[fn+2]=It,Ke[fn+3]=Mt,Ke[fn+4]=hn,et=Ct,st=Pt}return Ke}build(x){return this._dataIsSortedAndDeltaEncoded?new Qt(new Uint32Array(this._data),x):new Qt(rn._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=rn;class Qt{constructor(x,oe){this.resultId=oe,this.data=x}}e.SemanticTokens=Qt;class Nt{constructor(x,oe,ke){this.start=x,this.deleteCount=oe,this.data=ke}}e.SemanticTokensEdit=Nt;class Dn{constructor(x,oe){this.resultId=oe,this.edits=x}}e.SemanticTokensEdits=Dn;var sn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(sn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var on;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(on=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new Xe("arrow-left")},Xt=Ve([v],Xt),e.QuickInputButtons=Xt;var Cn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Cn=e.ExtensionKind||(e.ExtensionKind={}));class Lt{constructor(x,oe,ke){this.badge=x,this.tooltip=oe,this.color=ke}static validate(x){if(x.badge&&x.badge.length!==1&&x.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Lt;let an=class{constructor(x){this.kind=x}};an=Ve([v],an),e.ColorTheme=an;var kn;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(kn=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{constructor(x,oe){if(x<0)throw(0,I.illegalArgument)("start must be positive");if(oe<0)throw(0,I.illegalArgument)("end must be positive");x<=oe?(this._start=x,this._end=oe):(this._start=oe,this._end=x)}static isNotebookRange(x){return x instanceof Wt?!0:x?typeof x.start=="number"&&typeof x.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let oe=this._start,ke=this._end;return x.start!==void 0&&(oe=x.start),x.end!==void 0&&(ke=x.end),oe===this._start&&ke===this._end?this:new Wt(oe,ke)}}e.NotebookRange=Wt;class ln{constructor(x,oe){typeof x=="object"?Object.assign(this,x):(this.inputCollapsed=x,this.outputCollapsed=oe)}with(x){let{inputCollapsed:oe,outputCollapsed:ke}=x,Ke=qt(x,["inputCollapsed","outputCollapsed"]);return oe===void 0?oe=this.inputCollapsed:oe===null&&(oe=void 0),ke===void 0?ke=this.outputCollapsed:ke===null&&(ke=void 0),oe===this.inputCollapsed&&ke===this.outputCollapsed&&Object.keys(Ke).length===0?this:new ln(Object.assign({inputCollapsed:oe,outputCollapsed:ke},Ke))}}e.NotebookCellMetadata=ln;class Ut{constructor(x=!0){var oe;typeof x=="object"?(Object.assign(this,x),this.trusted=(oe=x.trusted)!==null&&oe!==void 0?oe:!0):this.trusted=x}with(x){let{trusted:oe}=x,ke=qt(x,["trusted"]);return oe===void 0?oe=this.trusted:oe===null&&(oe=void 0),oe===this.trusted&&Object.keys(ke).length===0?this:new Ut(Object.assign({trusted:oe},ke))}}e.NotebookDocumentMetadata=Ut;class Ft{constructor(x,oe,ke,Ke,et,st){this.kind=x,this.source=oe,this.language=ke,this.outputs=Ke!=null?Ke:[],this.metadata=et,this.latestExecutionSummary=st}static isNotebookCellDataArray(x){return Array.isArray(x)&&x.every(oe=>Ft.isNotebookCellData(oe))}static isNotebookCellData(x){return!0}}e.NotebookCellData=Ft;class vn{constructor(x,oe){this.cells=x,this.metadata=oe!=null?oe:new Ut}}e.NotebookData=vn;class $t{constructor(x,oe,ke){if(this.mime=x,this.value=oe,this.metadata=ke,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(x){return x instanceof $t}}e.NotebookCellOutputItem=$t;class Me{constructor(x,oe,ke){this.outputs=x,typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,k.generateUuid)(),this.metadata=oe!=null?oe:ke)}}e.NotebookCellOutput=Me;var cn;(function(H){H[H.Markdown=1]="Markdown",H[H.Code=2]="Code"})(cn=e.NotebookCellKind||(e.NotebookCellKind={}));var un;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(un=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(pt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pn;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class In{constructor(x,oe,ke,Ke,et,st){this.text=x,this.alignment=oe,this.command=ke,this.tooltip=Ke,this.priority=et,this.accessibilityInformation=st}}e.NotebookCellStatusBarItem=In;var wn;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(wn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));let Yt=class{constructor(x,oe){this.label=x,this.timestamp=oe}};Yt=Ve([v],Yt),e.TimelineItem=Yt;var dn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(dn=e.ExtensionMode||(e.ExtensionMode={}));var An;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(An=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Tn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(Tn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor(x,oe){this.ranges=x,this.wordPattern=oe}}e.LinkedEditingRanges=Rn;var bn;(function(H){H[H.Unset=0]="Unset",H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(bn=e.TestResultState||(e.TestResultState={}));var _n;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information",H[H.Hint=3]="Hint"})(_n=e.TestMessageSeverity||(e.TestMessageSeverity={}));var En;(function(H){H[H.Pending=0]="Pending",H[H.Resolved=1]="Resolved"})(En=e.TestItemStatus||(e.TestItemStatus={}));const xt=(H,x,oe,ke)=>{let Ke=oe;return{enumerable:!0,configurable:!1,get(){return Ke},set(et){ke(Ke,et)||(Ke=et,H.bus.fire([3,x,et]))}}},Ht=(H,x)=>H===x,Ln=(H,x)=>H===x?!0:!H||!x?!1:H.isEqual(x);class te{constructor(x,oe,ke,Ke){this.label=oe,this.data=Ke;const et=(0,f.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:x,enumerable:!0,writable:!1},uri:{value:ke,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new T.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:xt(et,"range",void 0,Ln),description:xt(et,"description",void 0,Ht),runnable:xt(et,"runnable",!0,Ht),debuggable:xt(et,"debuggable",!0,Ht),status:xt(et,"status",En.Resolved,Ht),error:xt(et,"error",void 0,Ht)})}invalidate(){(0,f.getPrivateApiFor)(this).bus.fire([2])}dispose(){const x=(0,f.getPrivateApiFor)(this);x.parent&&(0,f.getPrivateApiFor)(x.parent).children.delete(this.id),x.bus.fire([1])}addChild(x){if(!(x instanceof te))throw new Error("Test child must be created through vscode.test.createTestItem()");const oe=(0,f.getPrivateApiFor)(this);if(oe.children.has(x.id))throw new Error(`Attempted to insert a duplicate test item ID ${x.id}`);oe.children.set(x.id,x),oe.bus.fire([0,x])}}e.TestItemImpl=te;class ue{constructor(x){this.message=x,this.severity=_n.Error}static diff(x,oe,ke){const Ke=new ue(x);return Ke.expectedOutput=oe,Ke.actualOutput=ke,Ke}}e.TestMessage=ue;var Ie;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Ie=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var rt;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(rt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var bt;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore"})(bt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[120],pe([0,1,52,12,9,145,109,7,17]),function(G,e,_,I,A,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function r(a,u){u?k.set(a,u):k.delete(a)}e.setWordDefinitionFor=r;function C(a){return k.get(a)}e.getWordDefinitionFor=C;class f extends T.MirrorTextModel{constructor(u,E,w,S,h,c,m,t){super(E,w,S,h);this._proxy=u,this._languageId=c,this._isDirty=m,this._notebook=t,this._isDisposed=!1}dispose(){(0,_.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,D.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===I.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(E){return E?u._getTextInRange(E):u.getText()},get eol(){return u._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(E){return u._lineAt(E)},offsetAt(E){return u._offsetAt(E)},positionAt(E){return u._positionAt(E)},validateRange(E){return u._validateRange(E)},validatePosition(E){return u._validatePosition(E)},getWordRangeAtPosition(E,w){return u._getWordRangeAtPosition(E,w)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,_.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,_.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const E=this._validateRange(u);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const w=this._eol,S=E.start.line,h=E.end.line,c=[];c.push(this._lines[S].substring(E.start.character));for(let m=S+1;m<h;m++)c.push(this._lines[m]);return c.push(this._lines[h].substring(0,E.end.character)),c.join(w)}_lineAt(u){let E;if(u instanceof P.Position?E=u.line:typeof u=="number"&&(E=u),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new p(E,this._lines[E],E===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(u),w=this._lines[E.index].length;return new P.Position(E.index,Math.min(E.remainder,w))}_validateRange(u){if(!(u instanceof P.Range))throw new Error("Invalid argument");const E=this._validatePosition(u.start),w=this._validatePosition(u.end);return E===u.start&&w===u.end?u:new P.Range(E.line,E.character,w.line,w.character)}_validatePosition(u){if(!(u instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:E,character:w}=u,S=!1;if(E<0)E=0,w=0,S=!0;else if(E>=this._lines.length)E=this._lines.length-1,w=this._lines[E].length,S=!0;else{const h=this._lines[E].length;w<0?(w=0,S=!0):w>h&&(w=h,S=!0)}return S?new P.Position(E,w):u}_getWordRangeAtPosition(u,E){const w=this._validatePosition(u);if(!E)E=C(this._languageId);else if((0,A.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const S=(0,y.getWordAtText)(w.character+1,(0,y.ensureValidWordDefinition)(E),this._lines[w.line],0);if(S)return new P.Range(w.line,S.startColumn-1,w.line,S.endColumn-1)}}e.ExtHostDocumentData=f;class p{constructor(u,E,w){this._line=u,this._text=E,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(ge[198],pe([0,1,7,3,111,6,77,24,2,30]),function(G,e,_,I,A,T,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class r{constructor(f,p,a,u){this._notebook=a,this._selector=u,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(w=>{const S=this._cellUris.get(w.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(f.onDidChangeNotebookCells(w=>E(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const f=[],p=[];for(const a of this._notebook.getCells())a.kind===_.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),f.push(a.document.getText().length+1),p.push(a.document.lineCount));this._cellLengths=new A.PrefixSumComputer(new Uint32Array(f)),this._cellLines=new A.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(f){var p,a;if(!f){let h="";for(const c of this._cells)h+=c.document.getText()+`
`;return h=h.slice(0,-1),h}if(f.isEmpty)return"";const u=this.locationAt(f.start),E=this.locationAt(f.end),w=this._cells[(p=this._cellUris.get(u.uri))!==null&&p!==void 0?p:-1],S=this._cells[(a=this._cellUris.get(E.uri))!==null&&a!==void 0?a:-1];if(!w||!S)return"";if(w===S)return w.document.getText(new _.Range(u.range.start,E.range.end));{const h=w.document.getText(new _.Range(u.range.start,new _.Position(w.document.lineCount,0))),c=S.document.getText(new _.Range(new _.Position(0,0),E.range.end));return h+`
`+c}}offsetAt(f){const p=this._cellLines.getIndexOf(f.line),a=this._cellLengths.getAccumulatedValue(p.index-1),u=this._cells[p.index].document.offsetAt(f.with(p.remainder));return a+u}positionAt(f){if(typeof f=="number"){const a=this._cellLengths.getIndexOf(f),u=this._cellLines.getAccumulatedValue(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(u)}const p=this._cellUris.get(f.uri);if(p!==void 0){const a=this._cellLines.getAccumulatedValue(p-1);return new _.Position(a+f.range.start.line,f.range.start.character)}return new _.Position(0,0)}locationAt(f){_.Range.isRange(f)||(f=new _.Range(f,f));const p=this._cellLines.getIndexOf(f.start.line);let a=p;f.isEmpty||(a=this._cellLines.getIndexOf(f.end.line));const u=new _.Position(p.remainder,f.start.character),E=new _.Position(a.remainder,f.end.character),w=new _.Range(u,E),S=this._cells[p.index];return new _.Location(S.document.uri,S.document.validateRange(w))}contains(f){return this._cellUris.has(f)}validateRange(f){const p=this.validatePosition(f.start),a=this.validatePosition(f.end);return f.with(p,a)}validatePosition(f){const p=this._cellLines.getIndexOf(f.line),a=new _.Position(p.remainder,f.character),u=this._cells[p.index].document.validatePosition(a),E=this._cellLines.getAccumulatedValue(p.index-1);return new _.Position(E+u.line,u.character)}}e.ExtHostNotebookConcatDocument=r}),define(ge[199],pe([0,1,7,15,3]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(P){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new A.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let D=P==="light"?_.ColorThemeKind.Light:P==="dark"?_.ColorThemeKind.Dark:_.ColorThemeKind.HighContrast;this._actual=new _.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Ve([xe(0,I.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(ge[62],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,_.createDecorator)("IURITransformerService");class I{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=I}),define(ge[200],pe([0,1,22]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(D){let k=this.buffers.indexOf(D);return k<0&&(k=this.buffers.length,this.buffers.push(D)),k}}function A(P,D){if(D){const k=new I,r=(p,a)=>{if(a instanceof ArrayBuffer){const u=k.add(a);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(a)){const u=T(a);if(u){const E=k.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:u,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},C=JSON.stringify(P,r),f=k.buffers.map(p=>{const a=new Uint8Array(p);return _.VSBuffer.wrap(a)});return{message:C,buffers:f}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=A;function T(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(P,D){const k=D.map(f=>{const p=new ArrayBuffer(f.byteLength);return new Uint8Array(p).set(f.buffer),p}),r=D.length?(f,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const a=p,{index:u}=a,E=k[u];if(a.view)switch(a.view.type){case 1:return new Int8Array(E,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return p}:void 0;return{message:JSON.parse(P,r),arrayBuffers:k}}e.deserializeWebviewMessage=y}),define(ge[88],pe([0,1,2]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(T,y,P){const D=T.webviewResourceRoot.replace("{{resource}}",P.scheme+A(P)).replace("{{uuid}}",y);return _.URI.parse(D)}e.asWebviewUri=I;function A(T){return T.toString().replace(/^\S+?:/,"")}}),define(ge[201],pe([0,1,3,6,88,30]),function(G,e,_,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,k,r){this._proxy=D,this._editors=k,this._initData=r,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(k.onDidChangeVisibleTextEditors(()=>{const C=k.getVisibleTextEditors();for(const f of this._insets.values())C.indexOf(f.editor)<0&&f.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,k,r,C,f){let p;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===D){p=c;break}if(!p)throw new Error("not a visible editor");const a=this,u=this._handlePool++,E=new _.Emitter,w=new _.Emitter,S=new class{constructor(){this._uuid=(0,T.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,A.asWebviewUri)(a._initData,this._uuid,c)}get cspSource(){return a._initData.webviewCspSource}set options(c){this._options=c,a._proxy.$setOptions(u,c)}get options(){return this._options}set html(c){this._html=c,a._proxy.$setHtml(u,c)}get html(){return this._html}get onDidReceiveMessage(){return E.event}postMessage(c){return a._proxy.$postMessage(u,c)}},h=new class{constructor(){this.editor=D,this.line=k,this.height=r,this.webview=S,this.onDidDispose=w.event}dispose(){a._insets.has(u)&&(a._insets.delete(u),a._proxy.$disposeEditorInset(u),w.fire(),w.dispose(),E.dispose())}};return this._proxy.$createEditorInset(u,p.id,p.value.document.uri,k+1,r,C||{},f.identifier,f.extensionLocation),this._insets.set(u,{editor:D,inset:h,onDidReceiveMessage:E}),h}$onDidDispose(D){const k=this._insets.get(D);k&&k.inset.dispose()}$onDidReceiveMessage(D,k){const r=this._insets.get(D);r&&r.onDidReceiveMessage.fire(k)}}e.ExtHostEditorInsets=y}),define(ge[202],pe([0,1,3,81,169,4,6,24,40,17,53,23,43,194]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,p.registerIcon)("default-view-icon",f.Codicon.window,(0,A.localize)(0,null));var a;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var u;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel"})(u=e.ViewContainerLocation||(e.ViewContainerLocation={}));function E(s){switch(s){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=E;function w(s){return`viewContainer.${s}.enabled`}e.getEnabledViewContainerContextKey=w;class S extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(l,g,v){var d;const b=this.get(l.id);if(b)return b;const R=l;return R.openCommandActionDescriptor=(v==null?void 0:v.donotRegisterOpenCommand)?void 0:(d=R.openCommandActionDescriptor)!==null&&d!==void 0?d:{id:R.id},(0,P.getOrSet)(this.viewContainers,g,[]).push(R),(v==null?void 0:v.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:g}),R}deregisterViewContainer(l){for(const g of this.viewContainers.keys()){const v=this.viewContainers.get(g),d=v==null?void 0:v.indexOf(l);if(d!==-1){v==null||v.splice(d,1),v.length===0&&this.viewContainers.delete(g),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:g});return}}}get(l){return this.all.filter(g=>g.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(g=>this.getViewContainers(g).filter(v=>(v==null?void 0:v.id)===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(g=>this.getViewContainerLocation(g)===l)}}D.Registry.add(a.ViewContainersRegistry,new S);var h;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(h=e.ViewContentGroups||(e.ViewContentGroups={}));function c(s,l){var g,v,d,b;const R=(g=s.group)!==null&&g!==void 0?g:h.More,N=(v=l.group)!==null&&v!==void 0?v:h.More;return R!==N?R.localeCompare(N):((d=s.order)!==null&&d!==void 0?d:5)-((b=l.order)!==null&&b!==void 0?b:5)}class m extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new r.SetMap}registerViews(l,g){this.registerViews2([{views:l,viewContainer:g}])}registerViews2(l){l.forEach(({views:g,viewContainer:v})=>this.addViews(g,v)),this._onViewsRegistered.fire(l)}deregisterViews(l,g){const v=this.removeViews(l,g);v.length&&this._onViewsDeregistered.fire({views:v,viewContainer:g})}moveViews(l,g){for(const v of this._views.keys())if(v!==g){const d=this.removeViews(l,v);d.length&&(this.addViews(d,g),this._onDidChangeContainer.fire({views:d,from:v,to:g}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const g of this._viewContainers){const v=(this._views.get(g)||[]).filter(d=>d.id===l)[0];if(v)return v}return null}getViewContainer(l){for(const g of this._viewContainers)if((this._views.get(g)||[]).filter(d=>d.id===l)[0])return g;return null}registerViewWelcomeContent(l,g){return this._viewWelcomeContents.add(l,g),this._onDidChangeViewWelcomeContent.fire(l),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(l,g),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,g){const v=new Map;for(const[d,b]of g)this._viewWelcomeContents.add(l,b),v.set(d,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(l,b),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),v}getViewWelcomeContent(l){const g=[];return this._viewWelcomeContents.forEach(l,v=>g.push(v)),g.sort(c)}addViews(l,g){let v=this._views.get(g);v||(v=[],this._views.set(g,v),this._viewContainers.push(g));for(const d of l){if(this.getView(d.id)!==null)throw new Error((0,A.localize)(1,null,d.id));v.push(d)}}removeViews(l,g){const v=this._views.get(g);if(!v)return[];const d=[],b=[];for(const R of v)l.includes(R)?d.push(R):b.push(R);return d.length&&(b.length?this._views.set(g,b):(this._views.delete(g),this._viewContainers.splice(this._viewContainers.indexOf(g),1))),d}}D.Registry.add(a.ViewsRegistry,new m),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,A.localize)(2,null));function t(s){return`view.${s}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(l,g){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,l),this._hasResolve=!!g,this.resolve=async v=>{var d,b;if(g&&!this.resolved){const R=await g(v);R&&(this.tooltip=(d=this.tooltip)!==null&&d!==void 0?d:R.tooltip,this.command=(b=this.command)!==null&&b!==void 0?b:R.command)}v.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i}),define(ge[203],pe([0,1,2,181,118,14,182,202]),function(G,e,_,I,A,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(u){return(E,...w)=>u(E.get(I.ICommandService),...w)}class k{static execute(E,w){const S={forceReuseWindow:w&&w.reuseWindow,remoteAuthority:w&&w.remoteAuthority};return E.executeCommand("_files.newWindow",S)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:k.ID,handler:D(k.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(u,E){return u.get(A.IWorkspacesService).removeRecentlyOpened([E])});class r{static execute(E,w){return typeof w=="string"?w=w.match(/^[^:/?#]+:\/\//)?_.URI.parse(w):_.URI.file(w):w=_.URI.revive(w),E.executeCommand("_workbench.removeFromRecentlyOpened",w)}}e.RemoveFromRecentlyOpenedAPICommand=r,r.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(r.ID,D(r.execute));class C{static execute(E,w){const S=typeof w=="string"?{extensionId:w}:w;return E.executeCommand("workbench.action.openIssueReporter",S)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(u,E){const w=u.get(A.IWorkspacesService);let S;const h=E.uri,c=E.label,m=E.remoteAuthority;return E.type==="workspace"?S={workspace:await w.getWorkspaceIdentifier(h),label:c,remoteAuthority:m}:E.type==="folder"?S={folderUri:h,label:c,remoteAuthority:m}:S={fileUri:h,label:c,remoteAuthority:m},w.addRecentlyOpened([S])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(u){return u.get(A.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(u,E){const w=u.get(T.ILogService),S=u.get(y.IEnvironmentService);S.isExtensionDevelopment&&!!S.extensionTestsLocationURI&&w.setLevel(E)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(u){return u.get(T.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(u,E){const w=u.get(P.IViewDescriptorService),S=w.getViewContainerById(E.destinationId);if(!!S){for(const h of E.viewIds){const c=w.getViewDescriptorById(h);(c==null?void 0:c.canMoveView)&&w.moveViewsToContainer([c],S,P.ViewVisibilityState.Default)}await u.get(P.IViewsService).openViewContainer(S.id,!0)}});class f{static execute(E,w){return!Array.isArray(w==null?void 0:w.viewIds)||typeof(w==null?void 0:w.destinationId)!="string"?Promise.reject("Invalid arguments"):E.executeCommand("_workbench.action.moveViews",w)}}e.MoveViewsAPICommand=f,f.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:f.ID,handler:D(f.execute),description:{description:"Move Views",args:[]}});class p{static execute(E,w){return E.executeCommand("_workbench.open",w)}}p.ID="vscode.open",I.CommandsRegistry.registerCommand(p.ID,D(p.execute));class a{static execute(E,w,S,h,c){return E.executeCommand("_workbench.diff",[w,S,h])}}a.ID="vscode.diff",I.CommandsRegistry.registerCommand(a.ID,D(a.execute))}),define(ge[121],pe([0,1,3,13,170]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,D,k,r){const C={command:P};if(D&&Object.keys(D).length>0&&(C.arguments=D),this.internalSend("request",C),typeof r=="number"){const f=setTimeout(()=>{clearTimeout(f);const p=this.pendingRequests.get(C.seq);if(p){this.pendingRequests.delete(C.seq);const a={type:"response",seq:0,request_seq:C.seq,success:!1,command:P,message:(0,A.localize)(0,null,r,P)};p(a)}},r)}return k&&this.pendingRequests.set(C.seq,k),C.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,D){return P.type!=="event"||D.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,I.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const D=P,k=this.pendingRequests.get(D.request_seq);k&&(this.pendingRequests.delete(D.request_seq),k(D));break}}}internalSend(P,D){D.type=P,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((D,k)=>P.set(k,D)),await(0,I.timeout)(500),P.forEach((D,k)=>{D({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(ge[204],pe([0,1,9,2,8,23,12]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function D(n,o,i){return n.replace(P,function(s,l){return o&&l.length>0&&l[0]!=="_"?s:i&&i.hasOwnProperty(l)?i[l]:s})}e.formatPII=D;function k(n){const o={};for(const i of Object.keys(n))i.startsWith("!")||(o[i]=n[i]);return o}e.filterExceptionsFromTelemetry=k;function r(n){return n.configuration.request==="attach"&&!C(n)}e.isSessionAttach=r;function C(n){let o=n.configuration.type;if(!!o)return o==="vslsShare"&&(o=n.configuration.adapterProxy.configuration.type),(0,_.equalsIgnoreCase)(o,"extensionhost")||(0,_.equalsIgnoreCase)(o,"pwa-extensionhost")?n:n.parentSession?C(n.parentSession):void 0}e.getExtensionHostDebugSession=C;function f(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=f;function p(n,o,i){let s,l=0,g=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,v=null;for(;v=g.exec(n);){let d=v.index+1,b=d+v[0].length;if(d<=o&&b>=i){s=v[0],l=d;break}}if(s){let d=/\w+/g,b=null;for(;(b=d.exec(s))&&!(b.index+1+l+b[0].length>=i););b&&(s=s.substring(0,d.lastIndex))}return s?{start:l,end:l+s.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(n){return!!(n&&n.match(a))}e.isUri=u;function E(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(u(n.path))return I.URI.parse(n.path);if((0,A.isAbsolute)(n.path))return I.URI.file(n.path)}return n.path}function w(n){if(typeof n.path=="object"){const o=I.URI.revive(n.path);if(o)return o.scheme===y.Schemas.file?o.fsPath:o.toString()}return n.path}function S(n,o){const i=o?E:w,s=(0,T.deepClone)(n);return c(s,(l,g)=>{l&&g&&(g.path=i(g))}),s}e.convertToDAPaths=S;function h(n,o){const i=o?E:w,s=(0,T.deepClone)(n);return c(s,(l,g)=>{!l&&g&&(g.path=i(g))}),s}e.convertToVSCPaths=h;function c(n,o){switch(n.type){case"event":const i=n;switch(i.event){case"output":o(!1,i.body.source);break;case"loadedSource":o(!1,i.body.source);break;case"breakpoint":o(!1,i.body.breakpoint.source);break;default:break}break;case"request":const s=n;switch(s.command){case"setBreakpoints":o(!0,s.arguments.source);break;case"breakpointLocations":o(!0,s.arguments.source);break;case"source":o(!0,s.arguments.source);break;case"gotoTargets":o(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(g=>o(!1,g));break;default:break}break;case"response":const l=n;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(g=>o(!1,g.source));break;case"loadedSources":l.body.sources.forEach(g=>o(!1,g));break;case"scopes":l.body.scopes.forEach(g=>o(!1,g.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(g=>o(!1,g.source));break;case"setBreakpoints":l.body.breakpoints.forEach(g=>o(!1,g.source));break;default:break}break}}function m(n){return n.filter(o=>{var i;return!((i=o.presentation)===null||i===void 0?void 0:i.hidden)}).sort((o,i)=>o.presentation?i.presentation?o.presentation.group?i.presentation.group?o.presentation.group!==i.presentation.group?o.presentation.group.localeCompare(i.presentation.group):t(o.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(o.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=m;function t(n,o){return typeof n!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:n-o}}),define(ge[205],pe([0,1,26,38,171,122,8,9,23,10,183,121]),function(G,e,_,I,A,T,y,P,D,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class f extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(S,h){this.outputStream=h,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,S.on("data",c=>this.handleData(c))}sendMessage(S){if(this.outputStream){const h=JSON.stringify(S);this.outputStream.write(`Content-Length: ${Buffer.byteLength(h,"utf8")}${f.TWO_CRLF}${h}`,"utf8")}}handleData(S){for(this.rawData=Buffer.concat([this.rawData,S]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const h=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,h.length>0)try{this.acceptMessage(JSON.parse(h))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+h))}continue}}else{const h=this.rawData.indexOf(f.TWO_CRLF);if(h!==-1){const m=this.rawData.toString("utf8",0,h).split(f.HEADER_LINESEPARATOR);for(const t of m){const n=t.split(f.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(h+f.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=f,f.TWO_CRLF=`\r
\r
`,f.HEADER_LINESEPARATOR=/\r?\n/,f.HEADER_FIELDSEPARATOR=/: */;class p extends f{startSession(){return new Promise((S,h)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),S(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):h(new Error("connection closed"))}),this.socket.on("error",m=>{c?this._onError.fire(m):h(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class a extends p{constructor(S){super();this.adapterServer=S}createConnection(S){return T.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",S)}}e.SocketDebugAdapter=a;class u extends p{constructor(S){super();this.adapterServer=S}createConnection(S){return T.createConnection(this.adapterServer.path,S)}}e.NamedPipeDebugAdapter=u;class E extends f{constructor(S,h,c){super();this.adapterExecutable=S,this.debugType=h,this.outputService=c}async startSession(){const S=this.adapterExecutable.command,h=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(S)if(y.isAbsolute(S)){if(!await(0,_.exists)(S))throw new Error(A.localize(0,null,S))}else S.indexOf("/")<0&&S.indexOf("\\")<0;else throw new Error(A.localize(1,null,this.debugType));let m=process.env;if(c.env&&Object.keys(c.env).length>0&&(m=D.mixin(D.deepClone(process.env),c.env)),S==="node")if(Array.isArray(h)&&h.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:m,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(o.cwd=c.cwd);const i=I.fork(h[0],h.slice(1),o);if(!i.pid)throw new Error(A.localize(2,null,h[0]));this.serverProcess=i}else throw new Error(A.localize(3,null));else{const n={env:m};c.cwd&&(n.cwd=c.cwd),this.serverProcess=I.spawn(S,h,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,o)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const i=t.getChannel(r.ExtensionsChannelId);i&&i.append(n(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),k.isWindows?new Promise((S,h)=>{const c=I.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,t,n){if(m)return h(m)});c.on("exit",S),c.on("error",h)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(S,h){if(!!S){const c=Object.create(null);S.runtime&&(S.runtime.indexOf("./")===0?c.runtime=y.join(h,S.runtime):c.runtime=S.runtime),S.runtimeArgs&&(c.runtimeArgs=S.runtimeArgs),S.program&&(y.isAbsolute(S.program)?c.program=S.program:c.program=y.join(h,S.program)),S.args&&(c.args=S.args);const m=S;return m.win&&(c.win=E.extract(m.win,h)),m.winx86&&(c.winx86=E.extract(m.winx86,h)),m.windows&&(c.windows=E.extract(m.windows,h)),m.osx&&(c.osx=E.extract(m.osx,h)),m.linux&&(c.linux=E.extract(m.linux,h)),c}}static platformAdapterExecutable(S,h){let c=Object.create(null);h=h.toLowerCase();for(const s of S)if(s.contributes){const l=s.contributes.debuggers;l&&l.length>0&&l.filter(g=>typeof g.type=="string"&&P.equalsIgnoreCase(g.type,h)).forEach(g=>{const v=E.extract(g,s.extensionLocation.fsPath);c=D.mixin(c,v,s.isBuiltin)})}let m;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=c.winx86||c.win||c.windows:k.isWindows?m=c.win||c.windows:k.isMacintosh?m=c.osx:k.isLinux&&(m=c.linux),m=m||c;let t=m.program||c.program;const n=m.args||c.args;let o=m.runtime||c.runtime;const i=m.runtimeArgs||c.runtimeArgs;if(o)return{type:"executable",command:o,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=E}),define(ge[206],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ge[207],pe([0,1,38,8,78,172,26,10,84,4,206,12]),function(G,e,_,I,A,T,y,P,D,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const f=T.localize(0,null);let p=class zt{constructor(h){this._configurationService=h}openTerminal(h){if(this._configurationService){const c=this._configurationService.getValue();this.spawnTerminal(_,c,A.getWindowsShell(),h)}}runInTerminal(h,c,m,t,n){const o=n.windowsExec||zt.getDefaultTerminalWindows();return new Promise((i,s)=>{const l=`"${c} - ${f}"`,g=`""${m.join('" "')}" & pause"`,v=["/c","start",l,"/wait",o,"/c",g],d=Object.assign({},process.env,t);Object.keys(d).filter(N=>d[N]===null).forEach(N=>delete d[N]);const b={cwd:c,env:d,windowsVerbatimArguments:!0};_.spawn(zt.CMD,v,b).on("error",N=>{s(E(N))}),i(void 0)})}spawnTerminal(h,c,m,t){const o=c.terminal.external.windowsExec||zt.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const i=I.basename(o).toLowerCase();if(i==="cmder"||i==="cmder.exe")return h.spawn(o,t?[t]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return o.indexOf(" ")>=0&&s.push('""'),s.push(o),(i==="wt"||i==="wt.exe")&&s.push("-d ."),new Promise((l,g)=>{const v=t?{cwd:t}:void 0,d=h.spawn(m,s,v);d.on("error",g),d.on("exit",()=>l())})}static getDefaultTerminalWindows(){if(!zt._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");zt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return zt._DEFAULT_TERMINAL_WINDOWS}};p.CMD="cmd.exe",p=Ve([xe(0,(0,k.optional)(D.IConfigurationService))],p),e.WindowsExternalTerminalService=p;let a=class On{constructor(h){this._configurationService=h}openTerminal(h){if(this._configurationService){const c=this._configurationService.getValue();this.spawnTerminal(_,c,h)}}runInTerminal(h,c,m,t,n){const o=n.osxExec||r.DEFAULT_TERMINAL_OSX;return new Promise((i,s)=>{if(o===r.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const l=o===r.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",v=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,G).fsPath,"-t",h||f,"-w",c];for(let R of m)v.push("-a"),v.push(R);if(t)for(let R in t){const N=t[R];N===null?(v.push("-u"),v.push(R)):(v.push("-e"),v.push(`${R}=${N}`))}let d="";const b=_.spawn(On.OSASCRIPT,v);b.on("error",R=>{s(E(R))}),b.stderr.on("data",R=>{d+=R.toString()}),b.on("exit",R=>{if(R===0)i(void 0);else if(d){const N=d.split(`
`,1);s(new Error(N[0]))}else s(new Error(T.localize(1,null,l,R)))})}else s(new Error(T.localize(2,null,o)))})}spawnTerminal(h,c,m){const n=c.terminal.external.osxExec||r.DEFAULT_TERMINAL_OSX;return new Promise((o,i)=>{const s=["-a",n];m&&s.push(m);const l=h.spawn("/usr/bin/open",s);l.on("error",i),l.on("exit",()=>o())})}};a.OSASCRIPT="/usr/bin/osascript",a=Ve([xe(0,(0,k.optional)(D.IConfigurationService))],a),e.MacExternalTerminalService=a;let u=class Vt{constructor(h){this._configurationService=h}openTerminal(h){if(this._configurationService){const c=this._configurationService.getValue();this.spawnTerminal(_,c,h)}}runInTerminal(h,c,m,t,n){const o=n.linuxExec?Promise.resolve(n.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{let l=[];o.then(g=>{g.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const v=`${w(m)}; echo; read -p "${Vt.WAIT_MESSAGE}" -n1;`;l.push(`''${v}''`);const d=Object.assign({},process.env,t);Object.keys(d).filter(q=>d[q]===null).forEach(q=>delete d[q]);const b={cwd:c,env:d};let R="";const N=_.spawn(g,l,b);N.on("error",q=>{s(E(q))}),N.stderr.on("data",q=>{R+=q.toString()}),N.on("exit",q=>{if(q===0)i(void 0);else if(R){const re=R.split(`
`,1);s(new Error(re[0]))}else s(new Error(T.localize(4,null,g,q)))})})})}spawnTerminal(h,c,m){const t=c.terminal.external,n=t.linuxExec?Promise.resolve(t.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((o,i)=>{n.then(s=>{const l=m?{cwd:m}:void 0,g=h.spawn(s,[],l);g.on("error",i),g.on("exit",()=>o())})})}static async getDefaultTerminalLinuxReady(){return Vt._DEFAULT_TERMINAL_LINUX_READY||(Vt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async h=>{P.isLinux?await y.exists("/etc/debian_version")?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm"):h("xterm")})),Vt._DEFAULT_TERMINAL_LINUX_READY}};u.WAIT_MESSAGE=T.localize(3,null),u=Ve([xe(0,(0,k.optional)(D.IConfigurationService))],u),e.LinuxExternalTerminalService=u;function E(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(T.localize(5,null,S.path)):S}function w(S){let h="";for(let c of S)c.indexOf(" ")>=0?h+='"'+c+'"':h+=c,h+=" ";return h}}),define(ge[208],pe([0,1,38,10,207,29]),function(G,e,_,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let y;function P(f,p){if(!y)if(I.isWindows)y=new A.WindowsExternalTerminalService(void 0);else if(I.isMacintosh)y=new A.MacExternalTerminalService(void 0);else if(I.isLinux)y=new A.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const a=p.getConfiguration("terminal");return y.runInTerminal(f.title,f.cwd,f.args,f.env||{},a.external||{})}e.runInExternalTerminal=P;function D(f,p){return new Promise((a,u)=>{let E="";const w=_.spawn(f,p);w.pid&&w.stdout.on("data",S=>{E+=S.toString()}),w.on("error",S=>{u(S)}),w.on("close",S=>{a(E)})})}function k(f){return f?I.isWindows?D("wmic",["process","get","ParentProcessId"]).then(p=>p.split(`\r
`).some(u=>parseInt(u)===f),p=>!0):D("/usr/bin/pgrep",["-lP",String(f)]).then(p=>{const a=p.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},p=>!0):Promise.resolve(!0)}e.hasChildProcesses=k;var r;(function(f){f[f.cmd=0]="cmd",f[f.powershell=1]="powershell",f[f.bash=2]="bash"})(r||(r={}));function C(f,p,a,u){f=f.trim().toLowerCase();let E;f.indexOf("powershell")>=0||f.indexOf("pwsh")>=0?E=1:f.indexOf("cmd.exe")>=0?E=0:f.indexOf("bash")>=0?E=2:I.isWindows?E=0:E=2;let w,S=" ";switch(E){case 1:if(w=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),a){const c=(0,T.getDriveLetter)(a);c&&(S+=`${c}:; `),S+=`cd ${w(a)}; `}if(u)for(let c in u){const m=u[c];m===null?S+=`Remove-Item env:${c}; `:S+=`\${env:${c}}='${m}'; `}if(p.length>0){const c=w(p.shift());S+=c[0]==="'"?`& ${c} `:`${c} `;for(let m of p)S+=`${w(m)} `}break;case 0:if(w=c=>(c=c.replace(/\"/g,'""'),c.indexOf(" ")>=0||c.indexOf('"')>=0||c.length===0?`"${c}"`:c),a){const c=(0,T.getDriveLetter)(a);c&&(S+=`${c}: && `),S+=`cd ${w(a)} && `}if(u){S+='cmd /C "';for(let c in u){let m=u[c];m===null?S+=`set "${c}=" && `:(m=m.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),S+=`set "${c}=${m}" && `)}}for(let c of p)S+=`${w(c)} `;u&&(S+='"');break;case 2:w=c=>(c=c.replace(/(["'\\\$])/g,"\\$1"),c.indexOf(" ")>=0||c.indexOf(";")>=0||c.length===0?`"${c}"`:c);const h=c=>/[^\w@%\/+=,.:^-]/.test(c)?`'${c.replace(/'/g,"'\\''")}'`:c;if(a&&(S+=`cd ${w(a)} ; `),u){S+="/usr/bin/env";for(let c in u){const m=u[c];m===null?S+=` -u ${h(c)}`:S+=` ${h(`${c}=${m}`)}`}S+=" "}for(let c of p)S+=`${w(c)} `;break}return S}e.prepareCommand=C}),define(ge[89],pe([0,1,33,12,8,10,81]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NOTEBOOK_WORKING_COPY_TYPE_PREFIX=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(v){v[v.Markdown=1]="Markdown",v[v.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(v){v[v.Running=1]="Running",v[v.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var k;(function(v){v[v.Idle=1]="Idle",v[v.Pending=2]="Pending",v[v.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var r;(function(v){v[v.WithHardKernelDependency=0]="WithHardKernelDependency",v[v.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",v[v.Pure=2]="Pure",v[v.Never=3]="Never"})(r=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(v){v[v.ModelChange=1]="ModelChange",v[v.Move=2]="Move",v[v.CellClearOutput=3]="CellClearOutput",v[v.CellsClearOutput=4]="CellsClearOutput",v[v.ChangeLanguage=5]="ChangeLanguage",v[v.Initialize=6]="Initialize",v[v.ChangeCellMetadata=7]="ChangeCellMetadata",v[v.Output=8]="Output",v[v.OutputItem=9]="OutputItem",v[v.ChangeCellContent=10]="ChangeCellContent",v[v.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",v[v.Unknown=12]="Unknown"})(C=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var f;(function(v){v[v.Handle=0]="Handle",v[v.Index=1]="Index"})(f=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(v){v[v.Replace=1]="Replace",v[v.Output=2]="Output",v[v.Metadata=3]="Metadata",v[v.CellLanguage=4]="CellLanguage",v[v.DocumentMetadata=5]="DocumentMetadata",v[v.Move=6]="Move",v[v.OutputItems=7]="OutputItems",v[v.PartialMetadata=8]="PartialMetadata"})(p=e.CellEditType||(e.CellEditType={}));function a(v){const d=u.parse(v);return d?d.notebook.toString():v.toString()}e.getCellUndoRedoComparisonKey=a;var u;(function(v){v.scheme=I.Schemas.vscodeNotebookCell;const d=/^ch(\d{7,})/;function b(re,V){return re.with({scheme:v.scheme,fragment:`ch${V.toString().padStart(7,"0")}${re.scheme!==I.Schemas.file?re.scheme:""}`})}v.generate=b;function R(re){if(re.scheme===v.scheme){const V=d.exec(re.fragment);if(!!V)return{handle:Number(V[1]),notebook:re.with({scheme:re.fragment.substr(V[0].length)||I.Schemas.file,fragment:null})}}}v.parse=R;function N(re,V){return re.with({scheme:I.Schemas.vscodeNotebookCellMetadata,fragment:`ch${V.toString().padStart(7,"0")}${re.scheme!==I.Schemas.file?re.scheme:""}`})}v.generateCellMetadataUri=N;function q(re){if(re.scheme===I.Schemas.vscodeNotebookCellMetadata){const V=d.exec(re.fragment);if(!!V)return{handle:Number(V[1]),notebook:re.with({scheme:re.fragment.substr(V[0].length)||I.Schemas.file,fragment:null})}}}v.parseCellMetadataUri=q})(u=e.CellUri||(e.CellUri={}));const E=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(v){var d,b;return(b=(d=E.get(v))===null||d===void 0?void 0:d.alwaysSecure)!==null&&b!==void 0?b:!1}e.mimeTypeIsAlwaysSecure=w;function S(v){var d,b;return(b=(d=E.get(v))===null||d===void 0?void 0:d.supportedByCore)!==null&&b!==void 0?b:!1}e.mimeTypeSupportedByCore=S;function h(v){var d,b;return(b=(d=E.get(v))===null||d===void 0?void 0:d.mergeable)!==null&&b!==void 0?b:!1}e.mimeTypeIsMergeable=h;function c(v,d){return T.isWindows&&(v=v.replace(/\//g,"\\"),d=d.replace(/\//g,"\\")),_.match(v,d)}function m(v,d,b){let R=0;for(let N=0;N<d.length;N++){if(c(d[N],v))return R;R++}for(let N=0;N<b.length;N++){if(c(b[N],v))return R;R++}return R}function t(v,d,b){return v.sort((R,N)=>m(R,d,b)-m(N,d,b))}e.sortMimeTypes=t;function n(v,d,b,R=(N,q)=>N===q){const N=[];function q(W,$,U){if(!($===0&&U.length===0)){const F=N[N.length-1];F&&F.start+F.deleteCount===W?(F.deleteCount+=$,F.toInsert.push(...U)):N.push({start:W,deleteCount:$,toInsert:U})}}let re=0,V=0;for(;;){if(re===v.length){q(re,0,d.slice(V));break}if(V===d.length){q(re,v.length-re,[]);break}const W=v[re],$=d[V];if(R(W,$)){re+=1,V+=1;continue}b($)?(q(re,1,[]),re+=1):(q(re,0,[$]),V+=1)}return N}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(v){v.default="default",v.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function i(v){const d=v;return!!((typeof d.include=="string"||_.isRelativePattern(d.include))&&(typeof d.exclude=="string"||_.isRelativePattern(d.exclude)))}e.isDocumentExcludePattern=i;function s(v,d,b){if(Array.isArray(v.viewType)&&v.viewType.indexOf(d)>=0||v.viewType===d)return!0;if(v.filenamePattern){let R=i(v.filenamePattern)?v.filenamePattern.include:v.filenamePattern,N=i(v.filenamePattern)?v.filenamePattern.exclude:void 0;if(_.match(R,(0,A.basename)(b.fsPath).toLowerCase()))return!(N&&_.match(N,(0,A.basename)(b.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s;class l{constructor(d){this.textModel=d}getElements(){const d=new Int32Array(this.textModel.cells.length);for(let b=0;b<this.textModel.cells.length;b++)d[b]=this.textModel.cells[b].getHashValue();return d}}e.CellSequence=l,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var g;(function(v){v[v.Left=1]="Left",v[v.Right=2]="Right"})(g=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={})),e.NOTEBOOK_WORKING_COPY_TYPE_PREFIX="notebook/"}),define(ge[209],pe([0,1,174,4,81]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new A.RawContextKey("customExecutionSupported",!0,_.localize(0,null)),e.ShellExecutionSupportedContext=new A.RawContextKey("shellExecutionSupported",!1,_.localize(1,null)),e.ProcessExecutionSupportedContext=new A.RawContextKey("processExecutionSupported",!1,_.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[210],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=_;function I(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=I}),define(ge[211],pe([0,1,8,135,10]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function T(m,t){if(!!t)if(A.isWindows)for(const n in t){let o=n;for(const s in m)if(n.toLowerCase()===s.toLowerCase()){o=s;break}const i=t[n];i!==void 0&&y(m,o,i)}else Object.keys(t).forEach(n=>{const o=t[n];o!==void 0&&y(m,n,o)})}e.mergeEnvironments=T;function y(m,t,n){typeof n=="string"?m[t]=n:delete m[t]}function P(m,t,n,o){m.TERM_PROGRAM="vscode",t&&(m.TERM_PROGRAM_VERSION=t),r(m,o)&&(m.LANG=C(n)),m.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=P;function D(m,t){if(!!t)for(const n of Object.keys(t)){const o=t[n];o&&(m[n]=o)}}function k(m,t){return Object.keys(t).forEach(n=>{const o=t[n];if(typeof o=="string")try{t[n]=m(o)}catch(i){t[n]=o}}),t}function r(m,t){if(t==="on")return!0;if(t==="auto"){const n=m.LANG;return!n||n.search(/\.UTF\-8$/)===-1&&n.search(/\.utf8$/)===-1&&n.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=r;function C(m){const t=m?m.split("-"):[],n=t.length;if(n===0)return"en_US.UTF-8";if(n===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in o&&t.push(o[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=C;function f(m,t,n,o,i,s){if(m.cwd){const g=typeof m.cwd=="object"?m.cwd.fsPath:m.cwd,v=p(g,n);return a(v||g)}let l;return!m.ignoreConfigurationCwd&&i&&(n&&(i=p(i,n,s)),i&&(_.isAbsolute(i)?l=i:o&&(l=_.join(o.fsPath,i)))),l||(l=o?o.fsPath:t||""),a(l)}e.getCwd=f;function p(m,t,n){if(t)try{return t(m)}catch(o){n==null||n.error("Could not resolve terminal cwd",o);return}return m}function a(m){return A.OS===1&&m&&m[1]===":"?m[0].toUpperCase()+m.substr(1):m}function u(m){let t=m;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const n=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(n,""),`'${t}'`}e.escapeNonWindowsPath=u;function E(m,t,n){if(!!n)return o=>n.resolveWithEnvironment(t,m,o)}e.createVariableResolver=E;function w(m,t,n,o,i,s,l,g=A.platform){let v;l&&(v=h(m,"automationShell",g)),v||(v=h(m,"shell",g));let d=v||t;if(g===3&&!n&&o){const b=_.join(o,"Sysnative").replace(/\//g,"\\").toLowerCase();d&&d.toLowerCase().indexOf(b)===0&&(d=_.join(o,"System32",d.substr(b.length+1)))}if(d&&g===3&&(d=d.replace(/\//g,"\\")),i)try{d=i(d)}catch(b){s.error("Could not resolve shell",b)}return d}e.getDefaultShell=w;function S(m,t,n,o,i=A.platform){if(t&&h(m,"automationShell",i))return[];const s=i===3?"windows":i===1?"osx":"linux";let l=m(`terminal.integrated.shellArgs.${s}`);if(!l)return[];if(typeof l=="string"&&i===3)return n?n(l):l;if(n){const g=[];for(const v of l)try{g.push(n(v))}catch(d){o.error(`Could not resolve terminal.integrated.shellArgs.${s}`,d),g.push(v)}l=g}return l}e.getDefaultShellArgs=S;function h(m,t,n=A.platform){return m(`terminal.integrated.${t}.${n===3?"windows":n===1?"osx":"linux"}`)}function c(m,t,n,o,i,s){let l={};if(m.strictEnv)D(l,m.env);else{D(l,s);const g=Object.assign({},t);n&&(g&&k(n,g),m.env&&k(n,m.env)),(0,I.sanitizeProcessEnvironment)(l,"VSCODE_IPC_HOOK_CLI"),T(l,g),T(l,m.env),P(l,o,A.locale,i)}return l}e.createTerminalEnvironment=c});var mn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],_;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),_={},I("next"),I("throw"),I("return"),_[Symbol.asyncIterator]=function(){return this},_);function I(T){_[T]=G[T]&&function(y){return new Promise(function(P,D){y=G[T](y),A(P,D,y.done,y.value)})}}function A(T,y,P,D){Promise.resolve(D).then(function(k){T({value:k,done:P})},y)}};define(ge[212],pe([0,1,37,8,104,191,38,26,43,10]),function(G,e,_,I,A,T,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let r;function C(c,m,t,n,o,i,s){return t=t||{existsFile:P.SymlinkSupport.existsFile,readFile:_.promises.readFile},k.isWindows?f(c,t,n,m("terminal.integrated.useWslProfiles")||!0,m("terminal.integrated.profiles.windows"),o,i):w(t,n,c,m(`terminal.integrated.profiles.${k.isMacintosh?"osx":"linux"}`),s,o,i)}e.detectAvailableProfiles=C;async function f(c,m,t,n,o,i,s){const l=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${process.env.windir}\\${l?"Sysnative":"System32"}`;let v=!1;(0,T.getWindowsBuildNumber)()>=16299&&(v=!0),await a();const d=new Map;c||(d.set("PowerShell",{source:"PowerShell",icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),d.set("Windows PowerShell",{path:`${g}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),d.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),d.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),d.set("Command Prompt",{path:`${g}\\cmd.exe`,icon:D.Codicon.terminalCmd.id,isAutoDetected:!0})),S(o,d);const b=await p(d.entries(),m,t,i,s);if(!c||c&&n)try{const R=await E(`${g}\\${v?"wsl.exe":"bash.exe"}`,n);R&&b.push(...R)}catch(R){t==null||t.info("WSL is not installed, so could not detect WSL profiles")}return b}async function p(c,m,t,n,o){const i=[];for(const[s,l]of c)if(l!==null){let g,v,d;if("source"in l){const N=r==null?void 0:r.get(l.source);if(!N)continue;g=N.paths,v=l.args||N.args,d=l.icon||N.icon}else g=Array.isArray(l.path)?l.path:[l.path],v=k.isWindows||Array.isArray(l.args)?l.args:void 0,d=l.icon;const b=g.slice();for(let N=0;N<b.length;N++)b[N]=await(n==null?void 0:n.resolveAsync(o,b[N]))||b[N];const R=await h(s,b,m,v,l.env,l.overrideName,l.isAutoDetected,t);R?(R.isAutoDetected=l.isAutoDetected,R.icon=d,i.push(R)):t==null||t.trace("profile not validated",s,g)}return i}async function a(){r||(r=new Map,r.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),r.set("PowerShell",{profileName:"PowerShell",paths:await u(),icon:"terminal-powershell"}))}async function u(){var c,m;const t=[];try{for(var n=mn((0,A.enumeratePowerShellInstallations)()),o;o=await n.next(),!o.done;){const i=o.value;t.push(i.exePath)}}catch(i){c={error:i}}finally{try{o&&!o.done&&(m=n.return)&&await m.call(n)}finally{if(c)throw c.error}}return t}async function E(c,m){const t=[];if(m){const n=await new Promise((o,i)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le"},(s,l)=>{if(s)return i("Problem occurred when getting wsl distros");o(l)})});if(n){const o=new RegExp(/[\r?\n]/),i=n.split(o).filter(s=>s.trim().length>0&&s!=="");for(let s of i)if(s!==""&&!s.startsWith("docker-desktop")){const l={profileName:`${s} (WSL)`,path:c,args:["-d",`${s}`]};s.includes("Ubuntu")?l.icon="terminal-ubuntu":s.includes("Debian")?l.icon="terminal-debian":l.icon="terminal-linux",t.push(l)}return t}}return[]}async function w(c,m,t,n,o,i,s){const l=new Map;if(!t){const g=await c.readFile("/etc/shells","utf8"),v=o||g.split(`
`).filter(b=>b.trim().indexOf("#")!==0&&b.trim().length>0),d=new Map;for(const b of v){let R=(0,I.basename)(b),N=d.get(R)||0;N++,N>1&&(R=`${R} (${N})`),d.set(R,N),l.set(R,{path:b,isAutoDetected:!0})}}return S(n,l),await p(l.entries(),c,m,i,s)}function S(c,m){if(!!c)for(const[t,n]of Object.entries(c))n===null||!("path"in n)&&!("source"in n)?m.delete(t):m.set(t,n)}async function h(c,m,t,n,o,i,s,l){if(m.length===0)return Promise.resolve(void 0);const g=m.shift();if(g==="")return h(c,m,t,n,o,i,s);const v={profileName:c,path:g,args:n,env:o,overrideName:i,isAutoDetected:s};if((0,I.basename)(g)===g){const b=process.env.PATH?process.env.PATH.split(I.delimiter):void 0;return await(0,T.findExecutable)(g,void 0,b,void 0,t.existsFile)?v:h(c,m,t,n)}return await t.existsFile((0,I.normalize)(g))?v:h(c,m,t,n,o,i,s)}}),define(ge[123],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var _;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(D,k)=>{k.expand!==void 0&&(D.expand=k.expand),k.item!==void 0&&(D.item=D.item?Object.assign(D.item,k.item):k.item)};e.applyTestItemUpdate=I;var A;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(A=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(D,k)=>`${D}:${k.toString()}`;e.getTestSubscriptionKey=T;class y{add(k){}update(k){}remove(k,r){}complete(){}}e.IncrementalChangeCollector=y;class P{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const r=this.createChangeCollector();for(const C of k)switch(C[0]){case 0:{const f=C[1];if(f.parent){if(this.items.has(f.parent)){const p=this.items.get(f.parent);p.children.add(f.item.extId);const a=this.createItem(f,p);this.items.set(f.item.extId,a),r.add(a)}}else{this.roots.add(f.item.extId);const p=this.createItem(f);this.items.set(f.item.extId,p),r.add(p)}f.expand===2&&this.busyControllerCount++;break}case 1:{const f=C[1],p=this.items.get(f.extId);if(!p)break;f.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,f.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,f),r.update(p);break}case 2:{const f=this.items.get(C[1]);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f.item.extId);const p=[[C[1]]];for(;p.length;)for(const a of p.pop()){const u=this.items.get(a);u&&(p.push(u.children),this.items.delete(a),r.remove(u,u!==f),u.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}r.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=P}),define(ge[213],pe([0,1,8,36,11,23,10,76,175]),function(G,e,_,I,A,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(C,f,p){this._contributedVariables=new Map,this._context=C,this._labelService=f,p&&(this._envVariablesPromise=p.then(a=>this.prepareEnv(a)))}prepareEnv(C){if(y.isWindows){const f=Object.create(null);return Object.keys(C).forEach(p=>{f[p.toLowerCase()]=C[p]}),f}return C}resolveWithEnvironment(C,f,p){return this.recursiveResolve(this.prepareEnv(C),f?f.uri:void 0,p)}async resolveAsync(C,f){return this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,f)}async resolveAnyBase(C,f,p,a){const u=T.deepClone(f);return y.isWindows&&u.windows?Object.keys(u.windows).forEach(E=>u[E]=u.windows[E]):y.isMacintosh&&u.osx?Object.keys(u.osx).forEach(E=>u[E]=u.osx[E]):y.isLinux&&u.linux&&Object.keys(u.linux).forEach(E=>u[E]=u.linux[E]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,u,p,a)}async resolveAnyAsync(C,f,p){return this.resolveAnyBase(C,f,p)}async resolveAnyMap(C,f,p){const a=new Map;return{newConfig:await this.resolveAnyBase(C,f,p,a),resolvedVariables:a}}resolveWithInteractionReplace(C,f,p,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,f,p,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,f){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,f)}recursiveResolve(C,f,p,a,u){if(A.isString(p))return this.resolveString(C,f,p,a,u);if(A.isArray(p))return p.map(E=>this.recursiveResolve(C,f,E,a,u));if(A.isObject(p)){let E=Object.create(null);return Object.keys(p).forEach(w=>{const S=this.resolveString(C,f,w,a,u);E[S]=this.recursiveResolve(C,f,p[w],a,u)}),E}return p}resolveString(C,f,p,a,u){return p.replace(k.VARIABLE_REGEXP,(w,S)=>{if(S.includes(k.VARIABLE_LHS))return w;let h=this.evaluateSingleVariable(C,w,S,f,a);return u&&u.set(S,h),h})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,f,p,a,u){let E;const w=p.split(":");w.length>1&&(p=w[0],E=w[1]);const S=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error((0,D.localize)(0,null,f))},h=()=>{const m=S();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,f,_.basename(m)))},c=()=>{if(E){const m=this._context.getFolderUri(E);if(m)return m;throw new Error((0,D.localize)(2,null,f,E))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,f)):new Error((0,D.localize)(4,null,f))};switch(p){case"env":if(E){if(C){const m=C[y.isWindows?E.toLowerCase():E];if(A.isString(m))return m}return""}throw new Error((0,D.localize)(5,null,f));case"config":if(E){const m=this._context.getConfigurationValue(a,E);if(A.isUndefinedOrNull(m))throw new Error((0,D.localize)(6,null,f,E));if(A.isObject(m))throw new Error((0,D.localize)(7,null,f,E));return m}throw new Error((0,D.localize)(8,null,f));case"command":return this.resolveFromMap(f,E,u,"command");case"input":return this.resolveFromMap(f,E,u,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return a||E?(0,P.normalizeDriveLetter)(this.fsPath(c())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(c()));case"lineNumber":const m=this._context.getLineNumber();if(m)return m;throw new Error((0,D.localize)(9,null,f));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,f));case"file":return S();case"fileWorkspaceFolder":return h();case"relativeFile":return a||E?_.relative(this.fsPath(c()),S()):S();case"relativeFileDirname":const n=_.dirname(S());if(a||E){const l=_.relative(this.fsPath(c()),n);return l.length===0?".":l}return n;case"fileDirname":return _.dirname(S());case"fileExtname":return _.extname(S());case"fileBasename":return _.basename(S());case"fileBasenameNoExtension":const o=_.basename(S());return o.slice(0,o.length-_.extname(o).length);case"fileDirnameBasename":return _.basename(_.dirname(S()));case"execPath":const i=this._context.getExecPath();return i||f;case"execInstallFolder":const s=this._context.getAppRoot();return s||f;case"pathSeparator":return _.sep;default:try{const l=E?`${p}:${E}`:p;return this.resolveFromMap(f,l,u,void 0)}catch(l){return f}}}}resolveFromMap(C,f,p,a){if(f&&p){const u=a===void 0?p[f]:p[a+":"+f];if(typeof u=="string")return u;throw new Error((0,D.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[214],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var I;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var A;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(f){f[f.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var P;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(P=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(f){f[f.GROUP_ACTIVE=0]="GROUP_ACTIVE",f[f.GROUP_INDEX=1]="GROUP_INDEX",f[f.EDITOR_OPEN=2]="EDITOR_OPEN",f[f.EDITOR_CLOSE=3]="EDITOR_CLOSE",f[f.EDITOR_MOVE=4]="EDITOR_MOVE",f[f.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",f[f.EDITOR_LABEL=6]="EDITOR_LABEL",f[f.EDITOR_PIN=7]="EDITOR_PIN",f[f.EDITOR_STICKY=8]="EDITOR_STICKY",f[f.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var r;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(r=e.OpenEditorContext||(e.OpenEditorContext={}));function C(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(ge[215],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[20],pe([0,1,17,98,289,58,23,11,2,45,80,176,114,89,215,7]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(Ee){function fe(Z){const{selectionStartLineNumber:Fe,selectionStartColumn:Te,positionLineNumber:Qe,positionColumn:Ze}=Z,ct=new u.Position(Fe-1,Te-1),ht=new u.Position(Qe-1,Ze-1);return new u.Selection(ct,ht)}Ee.to=fe;function le(Z){const{anchor:Fe,active:Te}=Z;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}Ee.from=le})(E=e.Selection||(e.Selection={}));var w;(function(Ee){function fe(Z){if(!!Z){const{start:Fe,end:Te}=Z;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}Ee.from=fe;function le(Z){if(!!Z){const{startLineNumber:Fe,startColumn:Te,endLineNumber:Qe,endColumn:Ze}=Z;return new u.Range(Fe-1,Te-1,Qe-1,Ze-1)}}Ee.to=le})(w=e.Range||(e.Range={}));var S;(function(Ee){function fe(le){switch(le){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 4:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}Ee.to=fe})(S=e.TokenType||(e.TokenType={}));var h;(function(Ee){function fe(Z){return new u.Position(Z.lineNumber-1,Z.column-1)}Ee.to=fe;function le(Z){return{lineNumber:Z.line+1,column:Z.character+1}}Ee.from=le})(h=e.Position||(e.Position={}));var c;(function(Ee){function fe(Z){switch(Z){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}Ee.from=fe;function le(Z){switch(Z){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}Ee.to=le})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var m;(function(Ee){function fe(Z){let Fe;return Z.code&&((0,P.isString)(Z.code)||(0,P.isNumber)(Z.code)?Fe=String(Z.code):Fe={value:String(Z.code.value),target:Z.code.target}),Object.assign(Object.assign({},w.from(Z.range)),{message:Z.message,source:Z.source,code:Fe,severity:n.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(t.from),tags:Array.isArray(Z.tags)?(0,_.coalesce)(Z.tags.map(c.from)):void 0})}Ee.from=fe;function le(Z){var Fe;const Te=new u.Diagnostic(w.to(Z),Z.message,n.to(Z.severity));return Te.source=Z.source,Te.code=(0,P.isString)(Z.code)?Z.code:(Fe=Z.code)===null||Fe===void 0?void 0:Fe.value,Te.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(t.to),Te.tags=Z.tags&&(0,_.coalesce)(Z.tags.map(c.to)),Te}Ee.to=le})(m=e.Diagnostic||(e.Diagnostic={}));var t;(function(Ee){function fe(Z){return Object.assign(Object.assign({},w.from(Z.location.range)),{message:Z.message,resource:Z.location.uri})}Ee.from=fe;function le(Z){return new u.DiagnosticRelatedInformation(new u.Location(Z.resource,w.to(Z)),Z.message)}Ee.to=le})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(Ee){function fe(Z){switch(Z){case u.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}Ee.from=fe;function le(Z){switch(Z){case f.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}Ee.to=le})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(Ee){function fe(Z){return typeof Z=="number"&&Z>=u.ViewColumn.One?Z-1:Z===u.ViewColumn.Beside?a.SIDE_GROUP:a.ACTIVE_GROUP}Ee.from=fe;function le(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=le})(o=e.ViewColumn||(e.ViewColumn={}));function i(Ee){return typeof Ee.range!="undefined"}function s(Ee){return Ee.length===0?!0:!!i(Ee[0])}e.isDecorationOptionsArr=s;var l;(function(Ee){function fe(Ze){return Ze.map(Ee.from)}Ee.fromMany=fe;function le(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function Z(Ze){let ct;if(le(Ze)){const{language:ft,value:at}=Ze;ct={value:"```"+ft+`
`+at+"\n```\n"}}else u.MarkdownString.isMarkdownString(Ze)?ct={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons}:typeof Ze=="string"?ct={value:Ze}:ct={value:""};const ht=Object.create(null);ct.uris=ht;const Xe=ft=>{try{let at=D.URI.parse(ft,!0);at=at.with({query:Fe(at.query,ht)}),ht[ft]=at}catch(at){}return""},ot=new A.Renderer;return ot.link=Xe,ot.image=ft=>Xe(I.parseHrefAndDimensions(ft).href),A(ct.value,{renderer:ot}),ct}Ee.from=Z;function Fe(Ze,ct){if(!Ze)return Ze;let ht;try{ht=(0,T.parse)(Ze)}catch(ot){}if(!ht)return Ze;let Xe=!1;return ht=(0,y.cloneAndChange)(ht,ot=>{if(D.URI.isUri(ot)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ft]=ot,Xe=!0,ft}else return}),Xe?JSON.stringify(ht):Ze}function Te(Ze){const ct=new u.MarkdownString(Ze.value,Ze.supportThemeIcons);return ct.isTrusted=Ze.isTrusted,ct}Ee.to=Te;function Qe(Ze){if(!!Ze)return typeof Ze=="string"?Ze:Ee.from(Ze)}Ee.fromStrict=Qe})(l=e.MarkdownString||(e.MarkdownString={}));function g(Ee){return s(Ee)?Ee.map(fe=>({range:w.from(fe.range),hoverMessage:Array.isArray(fe.hoverMessage)?l.fromMany(fe.hoverMessage):fe.hoverMessage?l.from(fe.hoverMessage):void 0,renderOptions:fe.renderOptions})):Ee.map(fe=>({range:w.from(fe)}))}e.fromRangeOrRangeWithMessage=g;function v(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?D.URI.file(Ee):Ee}e.pathOrURIToURI=v;var d;(function(Ee){function fe(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?v(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}Ee.from=fe})(d=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var b;(function(Ee){function fe(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?v(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?d.from(le.before):void 0,after:le.after?d.from(le.after):void 0}}Ee.from=fe})(b=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(Ee){function fe(le){if(typeof le=="undefined")return le;switch(le){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=fe})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var N;(function(Ee){function fe(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?R.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?b.from(le.light):void 0,dark:le.dark?b.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?v(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?d.from(le.before):void 0,after:le.after?d.from(le.after):void 0}}Ee.from=fe})(N=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var q;(function(Ee){function fe(Z){return{text:Z.newText,eol:Z.newEol&&ie.from(Z.newEol),range:w.from(Z.range)}}Ee.from=fe;function le(Z){const Fe=new u.TextEdit(w.to(Z.range),Z.text);return Fe.newEol=typeof Z.eol=="undefined"?void 0:ie.to(Z.eol),Fe}Ee.to=le})(q=e.TextEdit||(e.TextEdit={}));var re;(function(Ee){function fe(Z,Fe,Te){var Qe,Ze,ct;const ht={edits:[]};if(Z instanceof u.WorkspaceEdit)for(let Xe of Z._allEntries())if(Xe._type===1)ht.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const ot=Fe==null?void 0:Fe.getDocument(Xe.uri);ht.edits.push({_type:2,resource:Xe.uri,edit:q.from(Xe.edit),modelVersionId:ot==null?void 0:ot.version,metadata:Xe.metadata})}else Xe._type===3?ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:(Qe=Te==null?void 0:Te.lookupNotebookDocument(Xe.uri))===null||Qe===void 0?void 0:Qe.apiNotebook.version}):Xe._type===4?(Xe.newOutputs&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:2,index:Xe.index,append:Xe.append,outputs:Xe.newOutputs.map(je.from)}}),Xe.newMetadata&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:8,index:Xe.index,metadata:Xe.newMetadata}})):Xe._type===5?ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:(Ze=Te==null?void 0:Te.lookupNotebookDocument(Xe.uri))===null||Ze===void 0?void 0:Ze.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(ve.from)}}):Xe._type===6&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:7,outputId:Xe.outputId,items:((ct=Xe.newOutputItems)===null||ct===void 0?void 0:ct.map(ye.from))||[],append:Xe.append}});return ht}Ee.from=fe;function le(Z){const Fe=new u.WorkspaceEdit;for(const Te of Z.edits)Te.edit?Fe.replace(D.URI.revive(Te.resource),w.to(Te.edit.range),Te.edit.text):Fe.renameFile(D.URI.revive(Te.oldUri),D.URI.revive(Te.newUri),Te.options);return Fe}Ee.to=le})(re=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(Ee){const fe=Object.create(null);fe[u.SymbolKind.File]=0,fe[u.SymbolKind.Module]=1,fe[u.SymbolKind.Namespace]=2,fe[u.SymbolKind.Package]=3,fe[u.SymbolKind.Class]=4,fe[u.SymbolKind.Method]=5,fe[u.SymbolKind.Property]=6,fe[u.SymbolKind.Field]=7,fe[u.SymbolKind.Constructor]=8,fe[u.SymbolKind.Enum]=9,fe[u.SymbolKind.Interface]=10,fe[u.SymbolKind.Function]=11,fe[u.SymbolKind.Variable]=12,fe[u.SymbolKind.Constant]=13,fe[u.SymbolKind.String]=14,fe[u.SymbolKind.Number]=15,fe[u.SymbolKind.Boolean]=16,fe[u.SymbolKind.Array]=17,fe[u.SymbolKind.Object]=18,fe[u.SymbolKind.Key]=19,fe[u.SymbolKind.Null]=20,fe[u.SymbolKind.EnumMember]=21,fe[u.SymbolKind.Struct]=22,fe[u.SymbolKind.Event]=23,fe[u.SymbolKind.Operator]=24,fe[u.SymbolKind.TypeParameter]=25;function le(Fe){return typeof fe[Fe]=="number"?fe[Fe]:6}Ee.from=le;function Z(Fe){for(const Te in fe)if(fe[Te]===Fe)return Number(Te);return u.SymbolKind.Property}Ee.to=Z})(V=e.SymbolKind||(e.SymbolKind={}));var W;(function(Ee){function fe(Z){switch(Z){case u.SymbolTag.Deprecated:return 1}}Ee.from=fe;function le(Z){switch(Z){case 1:return u.SymbolTag.Deprecated}}Ee.to=le})(W=e.SymbolTag||(e.SymbolTag={}));var $;(function(Ee){function fe(Z){return{name:Z.name,kind:V.from(Z.kind),tags:Z.tags&&Z.tags.map(W.from),containerName:Z.containerName,location:O.from(Z.location)}}Ee.from=fe;function le(Z){const Fe=new u.SymbolInformation(Z.name,V.to(Z.kind),Z.containerName,O.to(Z.location));return Fe.tags=Z.tags&&Z.tags.map(W.to),Fe}Ee.to=le})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(Ee){function fe(Z){var Fe,Te;const Qe={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:w.from(Z.range),selectionRange:w.from(Z.selectionRange),kind:V.from(Z.kind),tags:(Te=(Fe=Z.tags)===null||Fe===void 0?void 0:Fe.map(W.from))!==null&&Te!==void 0?Te:[]};return Z.children&&(Qe.children=Z.children.map(fe)),Qe}Ee.from=fe;function le(Z){const Fe=new u.DocumentSymbol(Z.name,Z.detail,V.to(Z.kind),w.to(Z.range),w.to(Z.selectionRange));return(0,_.isNonEmptyArray)(Z.tags)&&(Fe.tags=Z.tags.map(W.to)),Z.children&&(Fe.children=Z.children.map(le)),Fe}Ee.to=le})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var F;(function(Ee){function fe(le){const Z=new u.CallHierarchyItem(V.to(le.kind),le.name,le.detail||"",D.URI.revive(le.uri),w.to(le.range),w.to(le.selectionRange));return Z._sessionId=le._sessionId,Z._itemId=le._itemId,Z}Ee.to=fe})(F=e.CallHierarchyItem||(e.CallHierarchyItem={}));var M;(function(Ee){function fe(le){return new u.CallHierarchyIncomingCall(F.to(le.from),le.fromRanges.map(Z=>w.to(Z)))}Ee.to=fe})(M=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var L;(function(Ee){function fe(le){return new u.CallHierarchyOutgoingCall(F.to(le.to),le.fromRanges.map(Z=>w.to(Z)))}Ee.to=fe})(L=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(Ee){function fe(Z){return{range:Z.range&&w.from(Z.range),uri:Z.uri}}Ee.from=fe;function le(Z){return new u.Location(D.URI.revive(Z.uri),w.to(Z.range))}Ee.to=le})(O=e.location||(e.location={}));var B;(function(Ee){function fe(Z){const Fe=Z,Te=Z;return{originSelectionRange:Fe.originSelectionRange?w.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Te.uri,range:w.from(Fe.targetRange?Fe.targetRange:Te.range),targetSelectionRange:Fe.targetSelectionRange?w.from(Fe.targetSelectionRange):void 0}}Ee.from=fe;function le(Z){return{targetUri:D.URI.revive(Z.uri),targetRange:w.to(Z.range),targetSelectionRange:Z.targetSelectionRange?w.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?w.to(Z.originSelectionRange):void 0}}Ee.to=le})(B=e.DefinitionLink||(e.DefinitionLink={}));var j;(function(Ee){function fe(Z){return{range:w.from(Z.range),contents:l.fromMany(Z.contents)}}Ee.from=fe;function le(Z){return new u.Hover(Z.contents.map(l.to),w.to(Z.range))}Ee.to=le})(j=e.Hover||(e.Hover={}));var Q;(function(Ee){function fe(Z){return{range:w.from(Z.range),expression:Z.expression}}Ee.from=fe;function le(Z){return new u.EvaluatableExpression(w.to(Z.range),Z.expression)}Ee.to=le})(Q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var de;(function(Ee){function fe(Z){if(Z instanceof u.InlineValueText)return{type:"text",range:w.from(Z.range),text:Z.text};if(Z instanceof u.InlineValueVariableLookup)return{type:"variable",range:w.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=fe;function le(Z){switch(Z.type){case"text":return{range:w.to(Z.range),text:Z.text};case"variable":return{range:w.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:w.to(Z.range),expression:Z.expression}}}Ee.to=le})(de=e.InlineValue||(e.InlineValue={}));var be;(function(Ee){function fe(Z){return{frameId:Z.frameId,stoppedLocation:w.from(Z.stoppedLocation)}}Ee.from=fe;function le(Z){return new u.InlineValueContext(Z.frameId,w.to(Z.stoppedLocation))}Ee.to=le})(be=e.InlineValueContext||(e.InlineValueContext={}));var Ae;(function(Ee){function fe(Z){return{range:w.from(Z.range),kind:Z.kind}}Ee.from=fe;function le(Z){return new u.DocumentHighlight(w.to(Z.range),Z.kind)}Ee.to=le})(Ae=e.DocumentHighlight||(e.DocumentHighlight={}));var Ce;(function(Ee){function fe(le){switch(le){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}Ee.to=fe})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(Ee){function fe(le){return{triggerKind:Ce.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}Ee.to=fe})(Le=e.CompletionContext||(e.CompletionContext={}));var z;(function(Ee){function fe(Z){switch(Z){case u.CompletionItemTag.Deprecated:return 1}}Ee.from=fe;function le(Z){switch(Z){case 1:return u.CompletionItemTag.Deprecated}}Ee.to=le})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(Ee){const fe=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function le(Te){var Qe;return(Qe=fe.get(Te))!==null&&Qe!==void 0?Qe:9}Ee.from=le;const Z=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Fe(Te){var Qe;return(Qe=Z.get(Te))!==null&&Qe!==void 0?Qe:u.CompletionItemKind.Property}Ee.to=Fe})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(Ee){function fe(le,Z){var Fe;const Te=new u.CompletionItem(typeof le.label=="string"?le.label:le.label.name);return typeof le.label!="string"&&(Te.label2=le.label),Te.insertText=le.insertText,Te.kind=Y.to(le.kind),Te.tags=(Fe=le.tags)===null||Fe===void 0?void 0:Fe.map(z.to),Te.detail=le.detail,Te.documentation=I.isMarkdownString(le.documentation)?l.to(le.documentation):le.documentation,Te.sortText=le.sortText,Te.filterText=le.filterText,Te.preselect=le.preselect,Te.commitCharacters=le.commitCharacters,k.Range.isIRange(le.range)?Te.range=w.to(le.range):typeof le.range=="object"&&(Te.range={inserting:w.to(le.range.insert),replacing:w.to(le.range.replace)}),Te.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?Te.insertText=new u.SnippetString(le.insertText):(Te.insertText=le.insertText,Te.textEdit=Te.range instanceof u.Range?new u.TextEdit(Te.range,Te.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Te.additionalTextEdits=le.additionalTextEdits.map(Qe=>q.to(Qe))),Te.command=Z&&le.command?Z.fromInternal(le.command):void 0,Te}Ee.to=fe})(ee=e.CompletionItem||(e.CompletionItem={}));var ae;(function(Ee){function fe(Z){return{label:Z.label,documentation:Z.documentation?l.fromStrict(Z.documentation):void 0}}Ee.from=fe;function le(Z){return{label:Z.label,documentation:I.isMarkdownString(Z.documentation)?l.to(Z.documentation):Z.documentation}}Ee.to=le})(ae=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(Ee){function fe(Z){return{label:Z.label,documentation:Z.documentation?l.fromStrict(Z.documentation):void 0,parameters:Array.isArray(Z.parameters)?Z.parameters.map(ae.from):[],activeParameter:Z.activeParameter}}Ee.from=fe;function le(Z){return{label:Z.label,documentation:I.isMarkdownString(Z.documentation)?l.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(ae.to):[],activeParameter:Z.activeParameter}}Ee.to=le})(me=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(Ee){function fe(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(me.from):[]}}Ee.from=fe;function le(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(me.to):[]}}Ee.to=le})(De=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(Ee){function fe(Z){var Fe;return{text:Z.text,range:w.from(Z.range),kind:we.from((Fe=Z.kind)!==null&&Fe!==void 0?Fe:u.InlineHintKind.Other),description:Z.description&&l.fromStrict(Z.description),whitespaceBefore:Z.whitespaceBefore,whitespaceAfter:Z.whitespaceAfter}}Ee.from=fe;function le(Z){const Fe=new u.InlineHint(Z.text,w.to(Z.range),we.to(Z.kind));return Fe.whitespaceAfter=Z.whitespaceAfter,Fe.whitespaceBefore=Z.whitespaceBefore,Fe.description=I.isMarkdownString(Z.description)?l.to(Z.description):Z.description,Fe}Ee.to=le})(Oe=e.InlineHint||(e.InlineHint={}));var we;(function(Ee){function fe(Z){return Z}Ee.from=fe;function le(Z){return Z}Ee.to=le})(we=e.InlineHintKind||(e.InlineHintKind={}));var Pe;(function(Ee){function fe(Z){return{range:w.from(Z.range),url:Z.target,tooltip:Z.tooltip}}Ee.from=fe;function le(Z){let Fe;if(Z.url)try{Fe=typeof Z.url=="string"?D.URI.parse(Z.url,!0):D.URI.revive(Z.url)}catch(Te){}return new u.DocumentLink(w.to(Z.range),Fe)}Ee.to=le})(Pe=e.DocumentLink||(e.DocumentLink={}));var Re;(function(Ee){function fe(Z){const Fe=new u.ColorPresentation(Z.label);return Z.textEdit&&(Fe.textEdit=q.to(Z.textEdit)),Z.additionalTextEdits&&(Fe.additionalTextEdits=Z.additionalTextEdits.map(Te=>q.to(Te))),Fe}Ee.to=fe;function le(Z){return{label:Z.label,textEdit:Z.textEdit?q.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Fe=>q.from(Fe)):void 0}}Ee.from=le})(Re=e.ColorPresentation||(e.ColorPresentation={}));var Be;(function(Ee){function fe(Z){return new u.Color(Z[0],Z[1],Z[2],Z[3])}Ee.to=fe;function le(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}Ee.from=le})(Be=e.Color||(e.Color={}));var Se;(function(Ee){function fe(Z){return{range:w.from(Z.range)}}Ee.from=fe;function le(Z){return new u.SelectionRange(w.to(Z.range))}Ee.to=le})(Se=e.SelectionRange||(e.SelectionRange={}));var qe;(function(Ee){function fe(le){switch(le){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}Ee.to=fe})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(Ee){function fe(Z){switch(Z){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=fe;function le(Z){switch(Z){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}Ee.to=le})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ie;(function(Ee){function fe(Z){if(Z===u.EndOfLine.CRLF)return 1;if(Z===u.EndOfLine.LF)return 0}Ee.from=fe;function le(Z){if(Z===1)return u.EndOfLine.CRLF;if(Z===0)return u.EndOfLine.LF}Ee.to=le})(ie=e.EndOfLine||(e.EndOfLine={}));var _e;(function(Ee){function fe(le){if(typeof le=="object")return le.viewId;switch(le){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=fe})(_e=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(Ee){function fe(le){const Z={start:le.start+1,end:le.end+1};return le.kind&&(Z.kind=ze.from(le.kind)),Z}Ee.from=fe})(Ne=e.FoldingRange||(e.FoldingRange={}));var ze;(function(Ee){function fe(le){if(le)switch(le){case u.FoldingRangeKind.Comment:return r.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return r.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return r.FoldingRangeKind.Region}}Ee.from=fe})(ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(Ee){function fe(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?w.from(le.selection):void 0,override:typeof le.override=="boolean"?C.EditorOverride.DISABLED:void 0}}Ee.from=fe})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Je;(function(Ee){function fe(Z){return Z instanceof u.RelativePattern||typeof Z=="string"?Z:le(Z)?new u.RelativePattern(Z.base,Z.pattern):Z}Ee.from=fe;function le(Z){const Fe=Z;return Fe&&typeof Fe.base=="string"&&typeof Fe.pattern=="string"}})(Je=e.GlobPattern||(e.GlobPattern={}));var K;(function(Ee){function fe(le){if(le){if(Array.isArray(le))return le.map(fe);if(typeof le=="string")return le;{const Z=le;return{language:Z.language,scheme:Z.scheme,pattern:typeof Z.pattern=="undefined"?void 0:Je.from(Z.pattern),exclusive:Z.exclusive}}}else return}Ee.from=fe})(K=e.LanguageSelector||(e.LanguageSelector={}));var se;(function(Ee){function fe(Z){return{start:Z.start,end:Z.end}}Ee.from=fe;function le(Z){return new u.NotebookRange(Z.start,Z.end)}Ee.to=le})(se=e.NotebookRange||(e.NotebookRange={}));var he;(function(Ee){function fe(le){return new u.NotebookCellMetadata().with(Object.assign(Object.assign({},le),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}Ee.to=fe})(he=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var J;(function(Ee){function fe(Z){return Z}Ee.from=fe;function le(Z){return new u.NotebookDocumentMetadata().with(Z)}Ee.to=le})(J=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ne;(function(Ee){function fe(Z){return{startTime:Z.runStartTime,endTime:Z.runEndTime,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}Ee.to=fe;function le(Z){return{lastRunSuccess:Z.success,runStartTime:Z.startTime,runEndTime:Z.endTime,executionOrder:Z.executionOrder}}Ee.from=le})(ne=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ce;(function(Ee){function fe(Z){switch(Z){case u.NotebookCellKind.Markdown:return p.CellKind.Markdown;case u.NotebookCellKind.Code:default:return p.CellKind.Code}}Ee.from=fe;function le(Z){switch(Z){case p.CellKind.Markdown:return u.NotebookCellKind.Markdown;case p.CellKind.Code:default:return u.NotebookCellKind.Code}}Ee.to=le})(ce=e.NotebookCellKind||(e.NotebookCellKind={}));var ve;(function(Ee){function fe(Z){var Fe;return{cellKind:ce.from(Z.kind),language:Z.language,source:Z.source,metadata:Object.assign(Object.assign({},Z.metadata),ne.from((Fe=Z.latestExecutionSummary)!==null&&Fe!==void 0?Fe:{})),outputs:Z.outputs?Z.outputs.map(je.from):[]}}Ee.from=fe;function le(Z){return new u.NotebookCellData(ce.to(Z.cellKind),Z.source,Z.language,Z.outputs?Z.outputs.map(je.to):void 0,Z.metadata?he.to(Z.metadata):void 0)}Ee.to=le})(ve=e.NotebookCellData||(e.NotebookCellData={}));var ye;(function(Ee){function fe(Z){return{mime:Z.mime,value:Z.value,metadata:Z.metadata}}Ee.from=fe;function le(Z){return new u.NotebookCellOutputItem(Z.mime,Z.value,Z.metadata)}Ee.to=le})(ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var je;(function(Ee){function fe(Z){return{outputId:Z.id,outputs:Z.outputs.map(ye.from),metadata:Z.metadata}}Ee.from=fe;function le(Z){const Fe=Z.outputs.map(ye.to);return new u.NotebookCellOutput(Fe,Z.outputId,Z.metadata)}Ee.to=le})(je=e.NotebookCellOutput||(e.NotebookCellOutput={}));var He;(function(Ee){function fe(Te){if(Te!=null){if(Te instanceof u.RelativePattern||typeof Te=="string")return Te;if(Fe(Te))return new u.RelativePattern(Te.base,Te.pattern);if(Z(Te))return{include:Je.from(Te.include)||void 0,exclude:Je.from(Te.exclude)||void 0}}}Ee.from=fe;function le(Te){return typeof Te=="string"?Te:Fe(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}Ee.to=le;function Z(Te){const Qe=Te,Ze=Je.from(Qe.include);if(!(Ze&&Ze instanceof u.RelativePattern||typeof Ze=="string"))return!1;const ct=Je.from(Qe.exclude);return!!(ct&&ct instanceof u.RelativePattern||typeof ct=="string")}function Fe(Te){const Qe=Te;return Qe&&typeof Qe.base=="string"&&typeof Qe.pattern=="string"}})(He=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var We;(function(Ee){function fe(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?d.from(le.top):void 0}}Ee.from=fe})(We=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ge;(function(Ee){function fe(le,Z,Fe){const Te=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:Z.toInternal(Te,Fe),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}Ee.from=fe})(Ge=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(Ee){function fe(le){var Z,Fe;return{transientOutputs:(Z=le==null?void 0:le.transientOutputs)!==null&&Z!==void 0?Z:!1,transientCellMetadata:Object.assign(Object.assign({},le==null?void 0:le.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Fe=le==null?void 0:le.transientDocumentMetadata)!==null&&Fe!==void 0?Fe:{}}}Ee.from=fe})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var dt;(function(Ee){function fe(Z){var Fe;return{uri:Z.uri,provides:typeof Z.provides=="string"?[Z.provides]:(Fe=Z.provides)!==null&&Fe!==void 0?Fe:[]}}Ee.from=fe;function le(Z){return{uri:D.URI.revive(Z.uri),provides:Z.provides}}Ee.to=le})(dt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var it;(function(Ee){function fe(Z){return{message:l.fromStrict(Z.message)||"",severity:Z.severity,expectedOutput:Z.expectedOutput,actualOutput:Z.actualOutput,location:Z.location?O.from(Z.location):void 0}}Ee.from=fe;function le(Z){const Fe=new u.TestMessage(typeof Z.message=="string"?Z.message:l.to(Z.message));return Fe.severity=Z.severity,Fe.actualOutput=Z.actualOutput,Fe.expectedOutput=Z.expectedOutput,Fe}Ee.to=le})(it=e.TestMessage||(e.TestMessage={}));var Ye;(function(Ee){function fe(Te){var Qe,Ze;return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range)||null,debuggable:(Qe=Te.debuggable)!==null&&Qe!==void 0?Qe:!1,description:Te.description||null,runnable:(Ze=Te.runnable)!==null&&Ze!==void 0?Ze:!0,error:Te.error&&l.fromStrict(Te.error)||null}}Ee.from=fe;function le(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range)||null,debuggable:!1,description:Te.description||null,error:null,runnable:!0}}Ee.fromResultSnapshot=le;function Z(Te){return{id:Te.extId,label:Te.label,uri:D.URI.revive(Te.uri),range:w.to(Te.range||void 0),addChild:()=>{},dispose:()=>{},status:u.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description||void 0,runnable:Te.runnable}}Ee.toPlain=Z;function Fe(Te){const Qe=new u.TestItemImpl(Te.extId,Te.label,D.URI.revive(Te.uri),void 0);return Qe.range=w.to(Te.range||void 0),Qe.debuggable=Te.debuggable,Qe.description=Te.description||void 0,Qe.runnable=Te.runnable,Qe}Ee.to=Fe})(Ye=e.TestItem||(e.TestItem={}));var mt;(function(Ee){const fe=(Z,Fe)=>Object.assign(Object.assign({},Ye.toPlain(Z.item)),{taskStates:Z.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(it.to)})),children:Z.children.map(Te=>Fe.get(Te)).filter(P.isDefined).map(Te=>fe(Te,Fe))});function le(Z){const Fe=[],Te=new Map;for(const Qe of Z.items)Te.set(Qe.item.extId,Qe),Qe.direct&&Fe.push(Qe);return{completedAt:Z.completedAt,results:Fe.map(Qe=>fe(Qe,Te))}}Ee.to=le})(mt=e.TestResults||(e.TestResults={}));var wt;(function(Ee){function fe(le){switch(le){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}Ee.to=fe})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[216],pe([0,1,2,16,7,20,56]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(k,r,C,f={timeout:1500,errors:3}){this._logService=k,this._documents=r,this._mainThreadBulkEdits=C,this._thresholds=f,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(r,C,f)=>{const a={dispose:this._callbacks.push([r,C,k])};return Array.isArray(f)&&f.push(a),a}}async $participateInSave(k,r){const C=_.URI.revive(k);let f=!1;const p=setTimeout(()=>f=!0,this._thresholds.timeout),a=[];try{for(let u of[...this._callbacks]){if(f)break;const E=this._documents.getDocument(C),w=await this._deliverEventAsyncAndBlameBadListeners(u,{document:E,reason:T.TextDocumentSaveReason.to(r)});a.push(w)}}finally{clearTimeout(p)}return a}_deliverEventAsyncAndBlameBadListeners([k,r,C],f){const p=this._badListeners.get(k);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,k,r,f).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const u=this._badListeners.get(k);this._badListeners.set(k,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,r,C,f){const p=[],a=Date.now(),{document:u,reason:E}=f,{version:w}=u,S=Object.freeze({document:u,reason:E,waitUntil(h){if(Object.isFrozen(p))throw(0,I.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(h))}});try{r.apply(C,[S])}catch(h){return Promise.reject(h)}return Object.freeze(p),new Promise((h,c)=>{const m=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(m),h(t)}).catch(t=>{clearTimeout(m),c(t)})}).then(h=>{const c={edits:[]};for(const m of h)if(Array.isArray(m)&&m.every(t=>t instanceof A.TextEdit))for(const{newText:t,newEol:n,range:o}of m)c.edits.push({_type:2,resource:u.uri,edit:{range:o&&T.Range.from(o),text:t,eol:n&&T.EndOfLine.from(n)}});if(c.edits.length!==0)return w===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ge[217],pe([0,1,3,13,33,2,20,7]),function(G,e,_,I,A,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(C,f,p,a,u){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter,this._config=0,p&&(this._config+=1),a&&(this._config+=2),u&&(this._config+=4);const E=(0,A.parse)(f),w=C(S=>{if(!p)for(let h of S.created){const c=T.URI.revive(h);E(c.fsPath)&&this._onDidCreate.fire(c)}if(!a)for(let h of S.changed){const c=T.URI.revive(h);E(c.fsPath)&&this._onDidChange.fire(c)}if(!u)for(let h of S.deleted){const c=T.URI.revive(h);E(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(C,f,p){this._logService=f,this._extHostDocumentsAndEditors=p,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,f,p,a){return new D(this._onFileSystemEvent.event,C,f,p,a)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,f){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:f.map(p=>({oldUri:T.URI.revive(p.source),newUri:T.URI.revive(p.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:f.map(p=>T.URI.revive(p.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:f.map(p=>T.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,f){return(p,a,u)=>{const E=function(S){p.call(a,S)};return E.extension=C,f.event(E,void 0,u)}}async $onWillRunFileOperation(C,f,p,a){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:f.map(u=>({oldUri:T.URI.revive(u.source),newUri:T.URI.revive(u.target)}))},p,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:f.map(u=>T.URI.revive(u.target))},p,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:f.map(u=>T.URI.revive(u.target))},p,a)}}async _fireWillEvent(C,f,p,a){const u=new Set,E=[];if(await C.fireAsync(f,a,async(S,h)=>{var c;const m=Date.now(),t=await Promise.resolve(S);t instanceof P.WorkspaceEdit&&(E.push(t),u.add((c=h.extension.displayName)!==null&&c!==void 0?c:h.extension.identifier.value)),Date.now()-m>p&&this._logService.warn("SLOW file-participant",h.extension.identifier)}),!a.isCancellationRequested&&E.length!==0){const w={edits:[]};for(let S of E){let{edits:h}=y.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(h)}return{edit:w,extensionNames:Array.from(u)}}}}e.ExtHostFileSystemEventService=k}),define(ge[218],pe([0,1,12,23,2,20,7,89]),function(G,e,_,I,A,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(f,p,a,u){this.start=f,this.deletedCount=p,this.deletedItems=a,this.items=u}static asApiEvents(f){return f.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(a=>a.apiCell)}))}}class k{constructor(f,p,a){var u;this._notebook=f,this._extHostDocument=p,this._cellData=a,this.handle=a.handle,this.uri=A.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(u=a.metadata)!==null&&u!==void 0?u:{},this._metadata=T.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=T.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(f,p){return{EOL:p.eol,lines:p.source,modeId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:f}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._cell){const f=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return f._notebook.getCellIndex(f)},notebook:f._notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get outputs(){return f._outputs.slice(0)},get metadata(){return f._metadata},get latestExecutionSummary(){return f._previousResult}})}return this._cell}setOutputs(f){this._outputs=f.map(T.NotebookCellOutput.to)}setOutputItems(f,p,a){const u=a.map(T.NotebookCellOutputItem.to),E=this._outputs.find(w=>w.id===f);E&&(p||(E.outputs.length=0),E.outputs.push(...u))}setMetadata(f){this._internalMetadata=f,this._metadata=T.NotebookCellMetadata.to(f),this._previousResult=T.NotebookCellPreviousExecutionResult.to(f)}}e.ExtHostCell=k;class r{constructor(f,p,a,u,E,w,S){this._proxy=f,this._textDocumentsAndEditors=p,this._textDocuments=a,this._emitter=u,this._viewType=E,this._metadata=w,this.uri=S,this.handle=r._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const f=this;this._notebook={get uri(){return f.uri},get version(){return f._versionId},get viewType(){return f._viewType},get isDirty(){return f._isDirty},get isUntitled(){return f.uri.scheme===_.Schemas.untitled},get isClosed(){return f._disposed},get metadata(){return f._metadata},get cellCount(){return f._cells.length},cellAt(p){return p=f._validateIndex(p),f._cells[p].apiCell},getCells(p){return(p?f._getCells(p):f._cells).map(u=>u.apiCell)},save(){return f._save()}}}return this._notebook}updateBackup(f){var p;(p=this._backup)===null||p===void 0||p.delete(),this._backup=f}disposeBackup(){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(f){f.metadata&&(this._metadata=this._metadata.with(f.metadata))}acceptModelChanged(f,p){this._versionId=f.versionId,this._isDirty=p;for(const a of f.rawEvents)a.kind===P.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(a.changes,!0),a.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===P.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===P.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(a.index,a.metadata)}_validateIndex(f){return f<0?0:f>=this._cells.length?this._cells.length-1:f}_validateRange(f){return f.start<0&&(f=f.with({start:0})),f.end>this._cells.length&&(f=f.with({end:this._cells.length})),f}_getCells(f){f=this._validateRange(f);const p=[];for(let a=f.start;a<f.end;a++)p.push(this._cells[a]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(f,p){if(!this._disposed){const a=[],u=[],E=[];f.reverse().forEach(w=>{const h=w[2].map(t=>{const n=new k(this,this._textDocumentsAndEditors,t);return p||u.push(k.asModelAddData(this.apiNotebook,t)),n}),c=new D(w[0],w[1],[],h),m=this._cells.splice(w[0],w[1],...h);for(let t of m)E.push(t.uri),c.deletedItems.push(t.apiCell);a.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:E}),p||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(a)}))}}_moveCell(f,p){const a=this._cells.splice(f,1);this._cells.splice(p,0,...a);const u=[new D(f,1,a.map(E=>E.apiCell),[]),new D(p,0,[],a)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(u)}))}_setCellOutputs(f,p){const a=this._cells[f];a.setOutputs(p),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(f,p,a,u){const E=this._cells[f];E.setOutputItems(p,a,u),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_changeCellLanguage(f,p){const a=this._cells[f];a.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelModeChanged(a.uri,p)}_changeCellMetadata(f,p){var a;const u=this._cells[f],E=u.internalMetadata,w=u.apiCell.metadata;u.setMetadata(p);const S=u.apiCell.metadata;if((0,I.equals)(w,S)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:u.apiCell})),E.runState!==p.runState){const h=(a=p.runState)!==null&&a!==void 0?a:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.apiNotebook,cell:u.apiCell,executionState:h}))}}getCellFromIndex(f){return this._cells[f]}getCell(f){return this._cells.find(p=>p.handle===f)}getCellIndex(f){return this._cells.indexOf(f)}}e.ExtHostNotebookDocument=r,r._handlePool=0}),define(ge[219],pe([0,1,7,20]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(P){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=P}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(P){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:P})}replaceCellMetadata(P,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:P,metadata:D})}replaceCells(P,D,k){this._throwIfFinalized(),!(P===D&&k.length===0)&&this._collectedEdits.push({editType:1,index:P,count:D-P,cells:k.map(I.NotebookCellData.from)})}}class T{constructor(P,D,k,r,C,f){this.id=P,this._proxy=D,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=C,this._visibleRanges=r,this._viewColumn=f}get apiEditor(){if(!this._editor){const P=this;this._editor={get document(){return P.notebookData.apiNotebook},get selections(){return P._selections},get visibleRanges(){return P._visibleRanges},revealRange(D,k){P._proxy.$tryRevealRange(P.id,I.NotebookRange.from(D),k!=null?k:_.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn},edit(D){const k=new A(this.document.version);return D(k),P._applyEdit(k.finalize())},setDecorations(D,k){return P.setDecorations(D,k)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_acceptViewColumn(P){this._viewColumn=P}_applyEdit(P){if(P.cellEdits.length===0)return Promise.resolve(!0);const D=[];let k=-1;for(let r=0;r<P.cellEdits.length;r++){if(k<0){D.push(P.cellEdits[r]),k++;continue}const f=D[k],p=P.cellEdits[r];if(f.editType===1&&p.editType===1&&f.index===p.index){f.cells.push(...P.cellEdits[r].cells),f.count+=P.cellEdits[r].count;continue}D.push(P.cellEdits[r]),k++}return this._proxy.$tryApplyEdits(this.id,P.documentVersionId,D)}setDecorations(P,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(P.key)))return D.isEmpty?this._hasDecorationsForKey.delete(P.key):this._hasDecorationsForKey.add(P.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(D),P.key)}}e.ExtHostNotebookEditor=T}),define(ge[220],pe([0,1,20,115,163,21,70]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,f,p){const a=this._handles++,{title:u,location:E,cancellable:w}=f,S={label:(0,A.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(a,{location:_.ProgressLocation.from(E),title:u,source:S,cancellable:w},C),this._withProgress(a,p,!!w)}_withProgress(C,f,p){let a;p&&(a=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,a));const u=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),a&&a.dispose()};let E;try{E=f(new k(this._proxy,C),p&&a?a.token:T.CancellationToken.None)}catch(w){throw u(C),w}return E.then(w=>u(C),w=>u(C)),E}$acceptProgressCanceled(C){const f=this._mapHandleToCancellationSource.get(C);f&&(f.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=P;function D(r,C){return r.message=C.message,typeof C.increment=="number"&&(typeof r.increment=="number"?r.increment+=C.increment:r.increment=C.increment),r}class k extends I.Progress{constructor(C,f){super(p=>this.throttledReport(p));this._proxy=C,this._handle=f}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}Ve([(0,y.throttle)(100,(r,C)=>D(r,C),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(ge[124],pe([0,1,52,16,72,20,7]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(f,p){const a=P._Keys.nextId();f.$registerTextEditorDecorationType(a,T.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:a,dispose(){f.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=P,P._Keys=new A.IdGenerator("TextEditorDecorationType");class D{constructor(f,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=f,this._documentVersionId=f.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(f,p){this._throwIfFinalized();let a=null;if(f instanceof y.Position)a=new y.Range(f,f);else if(f instanceof y.Range)a=f;else throw new Error("Unrecognized location");this._pushEdit(a,p,!1)}insert(f,p){this._throwIfFinalized(),this._pushEdit(new y.Range(f,f),p,!0)}delete(f){this._throwIfFinalized();let p=null;if(f instanceof y.Range)p=f;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(f,p,a){const u=this._document.validateRange(f);this._collectedEdits.push({range:u,text:p,forceMoveMarkers:a})}setEndOfLine(f){if(this._throwIfFinalized(),f!==y.EndOfLine.LF&&f!==y.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=f}}e.TextEditorEdit=D;class k{constructor(f,p,a,u){this._proxy=f,this._id=p,this._accept(a),this._logService=u;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(w){E._setTabSize(w)},get insertSpaces(){return E._insertSpaces},set insertSpaces(w){E._setInsertSpaces(w)},get cursorStyle(){return E._cursorStyle},set cursorStyle(w){E._setCursorStyle(w)},get lineNumbers(){return E._lineNumbers},set lineNumbers(w){E._setLineNumbers(w)}}}_accept(f){this._tabSize=f.tabSize,this._insertSpaces=f.insertSpaces,this._cursorStyle=f.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(f.lineNumbers)}_validateTabSize(f){if(f==="auto")return"auto";if(typeof f=="number"){const p=Math.floor(f);return p>0?p:null}if(typeof f=="string"){const p=parseInt(f,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(f){const p=this._validateTabSize(f);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}_setInsertSpaces(f){const p=this._validateInsertSpaces(f);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(f){this._cursorStyle!==f&&(this._cursorStyle=f,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:f})))}_setLineNumbers(f){this._lineNumbers!==f&&(this._lineNumbers=f,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(f)})))}assign(f){const p={};let a=!1;if(typeof f.tabSize!="undefined"){const u=this._validateTabSize(f.tabSize);u==="auto"?(a=!0,p.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,a=!0,p.tabSize=u)}if(typeof f.insertSpaces!="undefined"){const u=this._validateInsertSpaces(f.insertSpaces);u==="auto"?(a=!0,p.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,a=!0,p.insertSpaces=u)}typeof f.cursorStyle!="undefined"&&this._cursorStyle!==f.cursorStyle&&(this._cursorStyle=f.cursorStyle,a=!0,p.cursorStyle=f.cursorStyle),typeof f.lineNumbers!="undefined"&&this._lineNumbers!==f.lineNumbers&&(this._lineNumbers=f.lineNumbers,a=!0,p.lineNumbers=T.TextEditorLineNumbersStyle.from(f.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,p))}_warnOnError(f){f.catch(p=>this._logService.warn(p))}}e.ExtHostTextEditorOptions=k;class r{constructor(f,p,a,u,E,w,S,h){this.id=f,this._proxy=p,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new k(this._proxy,this.id,w,a),this._visibleRanges=S,this._viewColumn=h;const c=this;this.value=Object.freeze({get document(){return u.getValue()},set document(m){throw(0,I.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(m){if(!(m instanceof y.Selection))throw(0,I.illegalArgument)("selection");c._selections=[m],c._trySetSelection()},get selections(){return c._selections},set selections(m){if(!Array.isArray(m)||m.some(t=>!(t instanceof y.Selection)))throw(0,I.illegalArgument)("selections");c._selections=m,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(m){throw(0,I.readonly)("visibleRanges")},get options(){return c._options.value},set options(m){c._disposed||c._options.assign(m)},get viewColumn(){return c._viewColumn},set viewColumn(m){throw(0,I.readonly)("viewColumn")},edit(m,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(u.getValue(),t);return m(n),c._applyEdit(n)},insertSnippet(m,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=c._selections.map(i=>T.Range.from(i));else if(t instanceof y.Position){const{lineNumber:i,column:s}=T.Position.from(t);o=[{startLineNumber:i,startColumn:s,endLineNumber:i,endColumn:s}]}else if(t instanceof y.Range)o=[T.Range.from(t)];else{o=[];for(const i of t)if(i instanceof y.Range)o.push(T.Range.from(i));else{const{lineNumber:s,column:l}=T.Position.from(i);o.push({startLineNumber:s,startColumn:l,endLineNumber:s,endColumn:l})}}return p.$tryInsertSnippet(f,m.value,o,n)},setDecorations(m,t){const n=t.length===0;n&&!c._hasDecorationsForKey.has(m.key)||(n?c._hasDecorationsForKey.delete(m.key):c._hasDecorationsForKey.add(m.key),c._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return p.$trySetDecorations(f,m.key,T.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let i=0,s=t.length;i<s;i++){const l=t[i];o[4*i]=l.start.line+1,o[4*i+1]=l.start.character+1,o[4*i+2]=l.end.line+1,o[4*i+3]=l.end.character+1}return p.$trySetDecorationsFast(f,m.key,o)}}))},revealRange(m,t){c._runOnProxy(()=>p.$tryRevealRange(f,T.Range.from(m),t||y.TextEditorRevealType.Default))},show(m){p.$tryShowEditor(f,T.ViewColumn.from(m))},hide(){p.$tryHideEditor(f)}})}dispose(){(0,_.ok)(!this._disposed),this._disposed=!0}_acceptOptions(f){(0,_.ok)(!this._disposed),this._options._accept(f)}_acceptVisibleRanges(f){(0,_.ok)(!this._disposed),this._visibleRanges=f}_acceptViewColumn(f){(0,_.ok)(!this._disposed),this._viewColumn=f}_acceptSelections(f){(0,_.ok)(!this._disposed),this._selections=f}async _trySetSelection(){const f=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,f)),this.value}_applyEdit(f){const p=f.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const a=p.edits.map(E=>E.range);a.sort((E,w)=>E.end.line===w.end.line?E.end.character===w.end.character?E.start.line===w.start.line?E.start.character-w.start.character:E.start.line-w.start.line:E.end.character-w.end.character:E.end.line-w.end.line);for(let E=0,w=a.length-1;E<w;E++){const S=a[E].end;if(a[E+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=p.edits.map(E=>({range:T.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,u,{setEndOfLine:typeof p.setEndOfLine=="number"?T.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(f){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=r}),define(ge[221],pe([0,1,166,25,2,3,6,13,7,11,17,20,21]),function(G,e,_,I,A,T,y,P,D,k,r,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(E,w){if((0,k.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let S;return Array.isArray(E.highlights)&&(S=E.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),S=S.length?S:void 0),{label:E.label,highlights:S}}}class a{constructor(w,S,h){this._proxy=w,this.commands=S,this.logService=h,this.treeViews=new Map;function c(m){return m&&m.$treeViewId&&m.$treeItemHandle}S.registerArgumentProcessor({processArgument:m=>c(m)?this.convertArgument(m):Array.isArray(m)&&m.length>0?m.map(t=>c(t)?this.convertArgument(t):t):m})}registerTreeDataProvider(w,S,h){const c=this.createTreeView(w,{treeDataProvider:S},h);return{dispose:()=>c.dispose()}}createTreeView(w,S,h){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany}),m=this.createExtHostTreeView(w,S,h);return{get onDidCollapseElement(){return m.onDidCollapseElement},get onDidExpandElement(){return m.onDidExpandElement},get selection(){return m.selectedElements},get onDidChangeSelection(){return m.onDidChangeSelection},get visible(){return m.visible},get onDidChangeVisibility(){return m.onDidChangeVisibility},get message(){return m.message},set message(t){m.message=t},get title(){return m.title},set title(t){m.title=t},get description(){return m.description},set description(t){m.description=t},reveal:(t,n)=>m.reveal(t,n),dispose:async()=>{await c,this.treeViews.delete(w),m.dispose()}}}$getChildren(w,S){const h=this.treeViews.get(w);return h?h.getChildren(S):Promise.reject(new Error((0,_.localize)(0,null,w)))}async $hasResolve(w){const S=this.treeViews.get(w);if(!S)throw new Error((0,_.localize)(1,null,w));return S.hasResolve}$resolve(w,S,h){const c=this.treeViews.get(w);if(!c)throw new Error((0,_.localize)(2,null,w));return c.resolveTreeItem(S,h)}$setExpanded(w,S,h){const c=this.treeViews.get(w);if(!c)throw new Error((0,_.localize)(3,null,w));c.setExpanded(S,h)}$setSelection(w,S){const h=this.treeViews.get(w);if(!h)throw new Error((0,_.localize)(4,null,w));h.setSelection(S)}$setVisible(w,S){const h=this.treeViews.get(w);if(!h)throw new Error((0,_.localize)(5,null,w));h.setVisible(S)}createExtHostTreeView(w,S,h){const c=new u(w,S,this._proxy,this.commands.converter,this.logService,h);return this.treeViews.set(w,c),c}convertArgument(w){const S=this.treeViews.get(w.$treeViewId);return S?S.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=a;class u extends y.Disposable{constructor(w,S,h,c,m,t){super();if(this.viewId=w,this.proxy=h,this.commands=c,this.logService=m,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,t.contributes&&t.contributes.views)for(const i in t.contributes.views)for(const s of t.contributes.views[i])s.id===w&&(this._title=s.name);this.dataProvider=S.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(i=>this._onDidChangeData.fire({message:!1,element:i})));let n,o;this._register(T.Event.debounce(this._onDidChangeData.event,(i,s)=>(i||(i={message:!1,elements:[]}),s.element!==!1&&(n||(n=new Promise(l=>o=l),this.refreshPromise=this.refreshPromise.then(()=>n)),i.elements.push(s.element)),s.message&&(i.message=!0),i),200,!0)(({message:i,elements:s})=>{s.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const l=o;return n=null,this.refresh(s).then(()=>l())})),i&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,k.isUndefinedOrNull)(w))}getChildren(w){const S=w?this.getExtensionElement(w):void 0;if(w&&!S)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const h=this.getChildrenNodes(w);return(h?Promise.resolve(h):this.fetchChildrenNodes(S)).then(c=>c.map(m=>m.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,S){S=S||{select:!0,focus:!1};const h=(0,k.isUndefinedOrNull)(S.select)?!0:S.select,c=(0,k.isUndefinedOrNull)(S.focus)?!1:S.focus,m=(0,k.isUndefinedOrNull)(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(o=>o.item)},{select:h,focus:c,expand:m})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:h,focus:c,expand:m})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,S){const h=this.getExtensionElement(w);h&&(S?this._onDidExpandElement.fire(Object.freeze({element:h})):this._onDidCollapseElement.fire(Object.freeze({element:h})))}setSelection(w){(0,r.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,S){var h;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(w);if(c){const m=this.nodes.get(c);if(m){const t=(h=await this.dataProvider.resolveTreeItem(m.extensionItem,c,S))!==null&&h!==void 0?h:m.extensionItem;return m.item.tooltip=this.getTooltip(t.tooltip),m.item.command=this.getCommand(m.disposableStore,t.command),m.item}}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(S=>S?this.resolveUnknownParentChain(S).then(h=>this.resolveTreeNode(S,h[h.length-1]).then(c=>(h.push(c),h))):Promise.resolve([]))}resolveParent(w){const S=this.nodes.get(w);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,S){const h=this.nodes.get(w);return h?Promise.resolve(h):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(c=>this.createHandle(w,c,S,!0)).then(c=>this.getChildren(S?S.item.handle:void 0).then(()=>{const m=this.getExtensionElement(c);if(m){const t=this.nodes.get(m);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(w){if(w){let S;if(typeof w=="string"){const h=this.getExtensionElement(w);S=h?this.nodes.get(h):void 0}else S=w;return S&&S.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const S=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const h=w?this.nodes.get(w):void 0,c=await this.dataProvider.getChildren(w);if(S.token.isCancellationRequested)return[];const m=await Promise.all((0,r.coalesce)(c||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,h):null}));return S.token.isCancellationRequested?[]:(0,r.coalesce)(m)}finally{S.dispose()}}refresh(w){if(w.some(h=>!h))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const h=this.getHandlesToRefresh(w);if(h.length)return this.refreshHandles(h)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const S=new Set,h=w.map(m=>this.nodes.get(m));for(const m of h)if(m&&!S.has(m.item.handle)){let t=m;for(;t&&t.parent&&h.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&S.add(m.item.handle)}const c=[];return S.forEach(m=>{const t=this.elements.get(m);if(t){const n=this.nodes.get(t);n&&(!n.parent||!S.has(n.parent.item.handle))&&c.push(m)}}),c}refreshHandles(w){const S={};return Promise.all(w.map(h=>this.refreshNode(h).then(c=>{c&&(S[h]=c.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(w){const S=this.getExtensionElement(w);if(S){const h=this.nodes.get(S);if(h)return this.clearChildren(S),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(S)).then(c=>{if(c){const m=this.createTreeNode(S,c,h.parent);return this.updateNodeCache(S,m,h,h.parent),h.dispose(),m}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,S,h){const c=this.createTreeNode(w,S,h);if(S.id&&this.elements.has(c.item.handle))throw new Error((0,_.localize)(6,null,S.id));return this.addNodeToCache(w,c),this.addNodeToParentCache(c,h),c}getTooltip(w){return D.MarkdownString.isMarkdownString(w)?C.MarkdownString.from(w):w}getCommand(w,S){return S?this.commands.toInternal(S,w):void 0}createTreeNode(w,S,h){const c=new y.DisposableStore,m=this.createHandle(w,S,h),t=this.getLightIconPath(S);return{item:{handle:m,parentHandle:h?h.item.handle:void 0,label:p(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(c,S.command),contextValue:S.contextValue,icon:t,iconDark:this.getDarkIconPath(S)||t,themeIcon:this.getThemeIcon(S),collapsibleState:(0,k.isUndefinedOrNull)(S.collapsibleState)?D.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation},extensionItem:S,parent:h,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(w){return w.iconPath instanceof D.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:S,label:h,resourceUri:c},m,t){if(S)return`${u.ID_HANDLE_PREFIX}/${S}`;const n=p(h,this.extension),o=m?m.item.handle:u.LABEL_HANDLE_PREFIX;let i=n?n.label:c?(0,I.basename)(c):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const s=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,l=this.getChildrenNodes(m)||[];let g,v=0;do{if(g=`${o}/${v}:${i}`,t||!this.elements.has(g)||s===g)break;v++}while(v<=l.length);return g}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon))return typeof w.iconPath=="string"||A.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return A.URI.isUri(w)?w:A.URI.file(w)}addNodeToCache(w,S){this.elements.set(S.item.handle,w),this.nodes.set(w,S)}updateNodeCache(w,S,h,c){this.elements.delete(S.item.handle),this.nodes.delete(w),S.item.handle!==h.item.handle&&this.elements.delete(h.item.handle),this.addNodeToCache(w,S);const m=this.getChildrenNodes(c)||[],t=m.filter(n=>n.item.handle===h.item.handle)[0];t&&m.splice(m.indexOf(t),1,S)}addNodeToParentCache(w,S){S?(S.children||(S.children=[]),S.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const S=this.nodes.get(w);if(S){if(S.children)for(const h of S.children){const c=this.elements.get(h.item.handle);c&&this.clear(c)}S.children=void 0}}else this.clearAll()}clear(w){const S=this.nodes.get(w);if(S){if(S.children)for(const h of S.children){const c=this.elements.get(h.item.handle);c&&this.clear(c)}this.nodes.delete(w),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}u.LABEL_HANDLE_PREFIX="0",u.ID_HANDLE_PREFIX="1"}),define(ge[222],pe([0,1,17,13,21,11,87,20,7,123]),function(G,e,_,I,A,T,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class r{constructor(){this.testIdsToInternal=new Map}getTestById(E,w){if(w!==void 0){const S=this.testIdsToInternal.get(w),h=S==null?void 0:S.get(E);if(h)return[S,h]}return(0,_.mapFind)(this.testIdsToInternal.values(),S=>{const h=S.get(E);return h&&[S,h]})}createForHierarchy(E=()=>{}){return new a(this.createIdMap(f++),E)}createIdMap(E){const w=new p(E);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=r;var C;(function(u){u[u.Disconnected=0]="Disconnected",u[u.IsChild=1]="IsChild",u[u.IsParent=2]="IsParent",u[u.IsSame=3]="IsSame"})(C=e.TestPosition||(e.TestPosition={}));let f=0;class p{constructor(E){this.id=E,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(E){if(this.map.has(E.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${E.item.extId}`);this.map.set(E.item.extId,E),E.parent||this._roots.add(E)}has(E){return this.map.has(E)}delete(E){const w=this.map.get(E);return w?(this.map.delete(E),this._roots.delete(w),!0):!1}get(E){return this.map.get(E)}comparePositions(E,w){const S=typeof E=="string"?this.map.get(E):E,h=typeof w=="string"?this.map.get(w):w;if(!S||!h)return 0;if(S===h)return 3;for(let c=this.map.get(h.parent);c;c=this.map.get(c.parent))if(c===S)return 1;for(let c=this.map.get(S.parent);c;c=this.map.get(c.parent))if(c===h)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=p;class a{constructor(E,w){this.testIdToInternal=E,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(E,w){this.addItem(E,w,null)}getTestByReference(E){return this.testItemToInternal.get(E)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const w=this.diff[this.diff.length-1];if(w&&E[0]===1){if(w[0]===1&&w[1].extId===E[1].extId){(0,k.applyTestItemUpdate)(w[1],E[1]);return}if(w[0]===0&&w[1].item.extId===E[1].extId){(0,k.applyTestItemUpdate)(w[1],E[1]);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,w){var S;const h=this.testIdToInternal.object.get(E);if(!!h){if((h.expandLevels===void 0||w>h.expandLevels)&&(h.expandLevels=w),h.expand===1){const c=this.refreshChildren(h);return c.isSettled?this.expandChildren(h,w-1):c.p.then(()=>this.expandChildren(h,w-1))}else if(h.expand===3)return((S=h.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?h.initialExpand.p.then(()=>this.expandChildren(h,w-1)):this.expandChildren(h,w-1)}}dispose(){var E;for(const w of this.testItemToInternal.values())(E=w.discoverCts)===null||E===void 0||E.dispose(!0),(0,y.getPrivateApiFor)(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(E,w){const S=E==null?void 0:E.actual.id;switch(w[0]){case 2:this.pushDiff([4,S]);break;case 1:this.removeItem(E);break;case 0:this.addItem(w[1],E.src.controller,E);break;case 3:const[h,c,m]=w;switch(c){case"status":this.updateExpandability(E);break;case"range":this.pushDiff([1,{extId:S,item:{range:P.Range.from(m)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:P.MarkdownString.fromStrict(m)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[c]:m!=null?m:null}}]);break}break;default:(0,T.assertNever)(w[0])}}addItem(E,w,S){if(!(E instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${E.id} did not`);if(this.testItemToInternal.has(E))throw new Error(`Attempted to add a single TestItem ${E.id} multiple times to the tree`);if(this.testIdToInternal.object.has(E.id))throw new Error(`Attempted to insert a duplicate test item ID ${E.id}`);const h=S?S.item.extId:null,c=E.resolveHandler?1:0,m=S?S.expandLevels:1,t={controller:w,tree:this.testIdToInternal.object.id},n={actual:E,parent:h,item:P.TestItem.from(E),expandLevels:m?m-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(E,n),this.pushDiff([0,{parent:h,src:t,expand:c,item:n.item}]);const o=(0,y.getPrivateApiFor)(E);o.parent=S==null?void 0:S.actual,o.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const i of o.children.values())this.testItemToInternal.has(i)||this.addItem(i,w,n)}updateExpandability(E){var w;let S;E.actual.resolveHandler?E.actual.status===D.TestItemStatus.Pending?S=E.discoverCts?2:1:((w=E.initialExpand)===null||w===void 0||w.complete(),S=3):S=0,S!==E.expand&&(E.expand=S,this.pushDiff([1,{extId:E.actual.id,expand:S}]),S===1&&E.expandLevels!==void 0&&this.refreshChildren(E))}expandChildren(E,w){if(!(w<0)){const S=[...E.actual.children.values()].map(h=>this.expand(h.id,w)).filter(I.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(E){if(E.discoverCts&&E.discoverCts.dispose(!0),!E.actual.resolveHandler){const w=new I.DeferredPromise;return w.complete(),w}return E.expand=2,E.discoverCts=new A.CancellationTokenSource,this.pushExpandStateUpdate(E),E.initialExpand=new I.DeferredPromise,E.actual.resolveHandler(E.discoverCts.token),E.initialExpand}pushExpandStateUpdate(E){this.pushDiff([1,{extId:E.actual.id,expand:E.expand}])}removeItem(E){var w;this.pushDiff([2,E.actual.id]);const S=[E];for(;S.length;){const h=S.pop();if(!!h){(w=h.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(h.item.extId),this.testItemToInternal.delete(h.actual);for(const c of h.actual.children.values())S.push(this.testIdToInternal.object.get(c.id))}}}flushDiff(){const E=this.collectDiff();E.length&&this.publishDiff(E)}}e.SingleUseTestCollection=a}),define(ge[223],pe([0,1,27,3,8]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(r){this.removedDueToLooping=r}}e.DeltaExtensionsResult=T;class y{constructor(r){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=r,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const r of this._extensionDescriptions){if(this._extensionsMap.has(_.ExtensionIdentifier.toKey(r.identifier))){console.error("Extension `"+r.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(_.ExtensionIdentifier.toKey(r.identifier),r),this._extensionsArr.push(r),Array.isArray(r.activationEvents))for(let C of r.activationEvents)C==="onUri"&&(C=`onUri:${_.ExtensionIdentifier.toKey(r.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(r)}}keepOnly(r){const C=new Set;r.forEach(f=>C.add(_.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>C.has(_.ExtensionIdentifier.toKey(f.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(r,C){r.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(r));const f=y._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(f.map(p=>p.identifier)),C.length>0){const p=new Set;C.forEach(a=>p.add(_.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!p.has(_.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(f)}static _findLoopingExtensions(r){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,w){this.addNode(E),this.addNode(w),this._arcs.has(E)?this._arcs.get(E).push(w):this._arcs.set(E,[w])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,w){const S=C.getArcs(E);for(let h=0;h<S.length;h++)if(!w.has(S[h]))return!1;return!0}getNodes(){return this._nodesArr}};let f=new Map;for(let E of r){const w=_.ExtensionIdentifier.toKey(E.identifier);if(f.set(w,E),E.extensionDependencies)for(let S of E.extensionDependencies){const h=_.ExtensionIdentifier.toKey(S);C.addArc(w,h)}}let p=new Set;C.getNodes().filter(E=>C.getArcs(E).length===0).forEach(E=>p.add(E));let a=C.getNodes().filter(E=>!p.has(E)),u;do{u=!1;for(let E=0;E<a.length;E++){const w=a[E];C.hasOnlyGoodArcs(w,p)&&(a.splice(E,1),E--,p.add(w),u=!0)}}while(u);return a.map(E=>f.get(E))}containsActivationEvent(r){return this._activationMap.has(r)}containsExtension(r){return this._extensionsMap.has(_.ExtensionIdentifier.toKey(r))}getExtensionDescriptionsForActivationEvent(r){const C=this._activationMap.get(r);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(r){const C=this._extensionsMap.get(_.ExtensionIdentifier.toKey(r));return C||void 0}}e.ExtensionDescriptionRegistry=y;var P;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(P||(P={}));function D(k,r){const C=k.isBuiltin?0:k.isUnderDevelopment?2:1,f=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(C!==f)return C-f;const p=A.posix.basename(k.extensionLocation.path),a=A.posix.basename(r.extensionLocation.path);return p<a?-1:p>a?1:0}}),define(ge[224],pe([0,1,22]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function T(P){const D=_.VSBuffer.alloc(1);switch(P){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=T;function y(P,D){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(ge[41],pe([0,1,3,2,4,27,184]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class P{constructor(S){this.dependency=S}}e.MissingExtensionDependency=P;var D;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(S,h,c,m){this.codeLoadingTime=S,this.activateCallTime=h,this.activateResolvedTime=c,this.activationReason=m}}e.ActivationTimes=k;class r{constructor(S,h){this.description=S,this.value=h}}e.ExtensionPointContribution=r,e.ExtensionHostLogFileName="exthost";var C;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function f(w){w.enableProposedApi||p(w)}e.checkProposedApiEnabled=f;function p(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=p;function a(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=a;function u(w){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=u;class E{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,h){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,h,c,m,t){}_onDidActivateExtensionError(S,h){}_onExtensionRuntimeError(S,h){}_onExtensionHostExit(S){}}e.NullExtensionService=E}),define(ge[225],pe([0,1,27,41,14]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class y{constructor(a,u,E,w){this.startup=a,this.codeLoadingTime=u,this.activateCallTime=E,this.activateResolvedTime=w}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class P{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,u){return a===-1||u===-1?-1:u-a}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=P;class D{constructor(a,u,E,w,S,h){this.activationFailed=a,this.activationFailedError=u,this.activationTimes=E,this.module=w,this.exports=S,this.subscriptions=h}}e.ActivatedExtension=D;class k extends D{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class r extends D{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=r;class C extends D{constructor(a){super(!0,a,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=C;let f=class{constructor(a,u,E,w,S){this._logService=S,this._registry=a,this._resolvedExtensionsSet=new Set,u.forEach(h=>this._resolvedExtensionsSet.add(_.ExtensionIdentifier.toKey(h))),this._hostExtensionsMap=new Map,E.forEach(h=>this._hostExtensionsMap.set(_.ExtensionIdentifier.toKey(h),h)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const u=_.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(u)}getActivatedExtension(a){const u=_.ExtensionIdentifier.toKey(a),E=this._activatedExtensions.get(u);if(!E)throw new Error("Extension `"+a.value+"` is not known or not activated");return E}activateByEvent(a,u){if(this._alreadyActivatedEvents[a])return T;const E=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(E.map(w=>({id:w.identifier,reason:{startup:u,extensionId:w.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,u){const E=this._registry.getExtensionDescription(a);if(!E)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:E.identifier,reason:u}])}_handleActivateRequest(a,u,E){if(this._hostExtensionsMap.has(_.ExtensionIdentifier.toKey(a.id))){u[_.ExtensionIdentifier.toKey(a.id)]=a;return}const w=this._registry.getExtensionDescription(a.id);if(!w){const c=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,c,new I.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(_.ExtensionIdentifier.toKey(a.id),new C(c));return}const S=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let h=!0;for(let c=0,m=S.length;c<m;c++){const t=S[c];if(!this._resolvedExtensionsSet.has(_.ExtensionIdentifier.toKey(t))){const n=this._activatedExtensions.get(_.ExtensionIdentifier.toKey(t));if(!(n&&!n.activationFailed)){if(n&&n.activationFailed){const l=w.displayName||w.identifier.value,g=this._registry.getExtensionDescription(t),v=g&&g.displayName||t,d=new Error(`Cannot activate the '${l}' extension because its dependency '${v}' failed to activate`);d.detail=n.activationFailedError,this._host.onExtensionActivationError(w.identifier,d,null),this._activatedExtensions.set(_.ExtensionIdentifier.toKey(w.identifier),new C(d));return}if(this._hostExtensionsMap.has(_.ExtensionIdentifier.toKey(t))){h=!1,u[_.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(_.ExtensionIdentifier.toKey(t)),reason:a.reason};continue}const o=this._registry.getExtensionDescription(t);if(o){h=!1,u[_.ExtensionIdentifier.toKey(t)]={id:o.identifier,reason:a.reason};continue}const i=w.displayName||w.identifier.value,s=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,s,new I.MissingExtensionDependency(t)),this._activatedExtensions.set(_.ExtensionIdentifier.toKey(w.identifier),new C(s));return}}}h?u[_.ExtensionIdentifier.toKey(w.identifier)]=a:E.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(S=>!this._activatedExtensions.has(_.ExtensionIdentifier.toKey(S.id))),a.length===0))return Promise.resolve(void 0);const u=Object.create(null),E=[];for(let S=0,h=a.length;S<h;S++)this._handleActivateRequest(a[S],u,E);for(let S=0,h=E.length;S<h;S++){const c=_.ExtensionIdentifier.toKey(E[S].id);u[c]&&delete u[c]}const w=Object.keys(u).map(S=>u[S]);return E.length===0?Promise.all(w.map(S=>this._activateExtension(S.id,S.reason))).then(S=>{}):this._activateExtensions(w).then(S=>this._activateExtensions(E))}_activateExtension(a,u){const E=_.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(E))return Promise.resolve(void 0);const w=this._activatingExtensions.get(E);if(w)return w;const S=this._host.actualActivateExtension(a,u).then(void 0,h=>{const c=new Error;return h&&h.name&&(c.name=h.name),h&&h.message?c.message=`Activating extension '${a.value}' failed: ${h.message}.`:c.message=`Activating extension '${a.value}' failed: ${h}.`,h&&h.stack&&(c.stack=h.stack),this._host.onExtensionActivationError(a,c,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(h),new C(h)}).then(h=>{this._activatedExtensions.set(E,h),this._activatingExtensions.delete(E)});return this._activatingExtensions.set(E,S),S}};f=Ve([xe(4,A.ILogService)],f),e.ExtensionsActivator=f}),define(ge[226],pe([0,1,14,41,28,12,113]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends _.LogService{constructor(k){if(k.logFile.scheme!==T.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(I.ExtensionHostLogFileName,k.logFile.fsPath,!0,k.logLevel))}$setLevel(k){this.setLevel(k)}};P=Ve([xe(0,A.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(ge[227],pe([0,1,16]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,y)=>{this._actualOk=T,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,_.onUnexpectedError)(T))}then(T,y){return this._ensureActual().then(T,y)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=I}),define(ge[125],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(D,k){this.isMain=D,this.sid=k,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const I=[];function A(P){const D=new _(!0,P);return I[D.nid]=D,D}e.createMainContextProxyIdentifier=A;function T(P){const D=new _(!1,P);return I[D.nid]=D,D}e.createExtHostContextProxyIdentifier=T;function y(P){return I[P].sid}e.getStringIdentifierForProxy=y}),define(ge[5],pe([0,1,2,125,58]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(c){c[c.Markdown=1]="Markdown",c[c.Code=2]="Code"})(k=e.CellKind||(e.CellKind={}));var r;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(r=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var f;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(f=e.CandidatePortSource||(e.CandidatePortSource={}));var p;(function(c){c.name="$ident";function m(n,o){return Object.defineProperty(n,c.name,{value:o,enumerable:!0}),n}c.mixin=m;function t(n){return n[c.name]}c.of=t})(p=e.ObjectIdentifier||(e.ObjectIdentifier={}));class a{static mixin(m){return m._id=a._n++,m}}e.IdObject=a,a._n=0;var u;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function S(c){if(c&&c.edits)for(const m of c.edits)typeof m.resource=="object"?m.resource=_.URI.revive(m.resource):(m.newUri=_.URI.revive(m.newUri),m.oldUri=_.URI.revive(m.oldUri)),m.metadata&&m.metadata.iconPath&&(m.metadata=(0,A.revive)(m.metadata));return c}e.reviveWorkspaceEditDto=S;var h;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(h=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[90],pe([0,1,5,3,4]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(P){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,D){return this._proxy.$getPassword(P,D)}store(P,D,k){return this._proxy.$setPassword(P,D,k)}delete(P,D){return this._proxy.$deletePassword(P,D)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,A.createDecorator)("IExtHostSecretState")}),define(ge[63],pe([0,1,4,14,5,15]),function(G,e,_,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,_.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(A.MainContext.MainThreadTelemetry)}report(D,k,r){const C=this.getUsageKey(D,k);this._reportedUsages.has(C)||(this._reportedUsages.add(C),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${r}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:D}))}getUsageKey(D,k){return`${D}-${k.identifier.value}`}};y=Ve([xe(0,T.IExtHostRpcService),xe(1,I.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(P,D,k){}})}),define(ge[228],pe([0,1,3,5,7,27]),function(G,e,_,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new _.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,k,r,C={}){const f=T.ExtensionIdentifier.toKey(D.identifier),p=this._inFlightRequests.get(f)||[],a=r.sort().join(" ");let u=p.find(E=>E.scopes===a);if(u)return u.result;{const E=this._getSession(D,f,k,r,C);u={scopes:a,result:E},p.push(u),this._inFlightRequests.set(f,p);try{await E}finally{const w=p.findIndex(S=>S.scopes===a);w>-1&&(p.splice(w),this._inFlightRequests.set(f,p))}return E}}async _getSession(D,k,r,C,f={}){await this._proxy.$ensureProvider(r);const p=D.displayName||D.name;return this._proxy.$getSession(r,C,k,p,f)}async removeSession(D,k){const r=this._authenticationProviders.get(D);return r?r.provider.removeSession(k):this._proxy.$removeSession(D,k)}registerAuthenticationProvider(D,k,r,C){var f;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:k,provider:r,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(a=>a.id===D)||this._providers.push({id:D,label:k});const p=r.onDidChangeSessions(a=>{var u,E,w;this._proxy.$sendDidChangeSessions(D,{added:(u=a.added)!==null&&u!==void 0?u:[],changed:(E=a.changed)!==null&&E!==void 0?E:[],removed:(w=a.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(D,k,(f=C==null?void 0:C.supportsMultipleAccounts)!==null&&f!==void 0?f:!1),new A.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(D);const a=this._providers.findIndex(u=>u.id===D);a>-1&&this._providers.splice(a),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,k){const r=this._authenticationProviders.get(D);if(r)return Promise.resolve(r.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,k){const r=this._authenticationProviders.get(D);if(r)return Promise.resolve(r.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,k){const r=this._authenticationProviders.get(D);if(r)return Promise.resolve(r.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,k){return this._onDidChangeSessions.fire({provider:{id:D,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,k){return D.forEach(r=>{this._providers.some(C=>C.id===r.id)||this._providers.push(r)}),k.forEach(r=>{const C=this._providers.findIndex(f=>f.id===r.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ge[229],pe([0,1,5,15,20]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(P,D){this._extHostDocumentsAndEditors=D,this._proxy=P.getProxy(_.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const D=A.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};T=Ve([xe(0,I.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(ge[230],pe([0,1,5]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(T){const y=T.getProxy(_.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(P){return y.$writeText(P)}})}}e.ExtHostClipboard=I}),define(ge[51],pe([0,1,11,7,20,23,5,17,14,58,45,49,2,6,4,15]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new w(this,o=>{const i=this._apiCommands.get(o);return(i==null?void 0:i.result)===h.Void?i:void 0},n),this._argumentProcessors=[{processArgument(o){return(0,k.revive)(o)}},{processArgument(o){return(0,T.cloneAndChange)(o,function(i){if(r.Range.isIRange(i))return A.Range.to(i);if(C.Position.isIPosition(i))return A.Position.to(i);if(r.Range.isIRange(i.range)&&f.URI.isUri(i.uri))return A.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...o)=>{const i=t.args.map((l,g)=>{if(!l.validate(o[g]))throw new Error(`Invalid argument '${l.name}' when running '${t.id}', received: ${o[g]}`);return l.convert(o[g])}),s=await this.executeCommand(t.internalId,...i);return t.result.convert(s,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,o,i,s){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:o,thisArg:i,description:s}),t&&this._proxy.$registerCommand(n),new I.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,o){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const i=(0,T.cloneAndChange)(n,function(s){if(s instanceof I.Position)return A.Position.from(s);if(s instanceof I.Range)return A.Range.from(s);if(s instanceof I.Location)return A.location.from(s);if(!Array.isArray(s))return s});try{const s=await this._proxy.$executeCommand(t,i,o);return(0,k.revive)(s)}catch(s){if(s instanceof Error&&s.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw s}}}async _executeContributedCommand(t,n){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:i,thisArg:s,description:l}=o;if(l)for(let g=0;g<l.args.length;g++)try{(0,_.validateConstraint)(n[g],l.args[g].constraint)}catch(v){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${l.args[g].name}' - ${l.args[g].description}`)}try{return await i.apply(s,n)}catch(g){if(t===this.converter.delegatingCommandId){const v=this.converter.getActualCommand(...n);v&&(t=v.command)}throw this._logService.error(g,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(o=>this._argumentProcessors.reduce((i,s)=>s.processArgument(i),o)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(o=>o[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,o]of this._commands){let{description:i}=o;i&&(t[n]=i)}return Promise.resolve(t)}};E=Ve([xe(0,u.IExtHostRpcService),xe(1,D.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class w{constructor(t,n,o){this._commands=t,this._lookupApiCommand=n,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const i=this._lookupApiCommand(t.command);if(i)o.id=i.internalId,o.arguments=i.args.map((s,l)=>s.convert(t.arguments&&t.arguments[l]));else if((0,P.isNonEmptyArray)(t.arguments)){const s=++this._cachIdPool;this._cache.set(s,t),n.add((0,p.toDisposable)(()=>{this._cache.delete(s),this._logService.trace("CommandsConverter#DISPOSE",s)})),o.$ident=s,o.id=this.delegatingCommandId,o.arguments=[s],this._logService.trace("CommandsConverter#CREATE",t.command,s)}return o}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class S{constructor(t,n,o,i){this.name=t,this.description=n,this.validate=o,this.convert=i}optional(){return new S(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new S(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",m=>f.URI.isUri(m),m=>m),S.Position=new S("position","A position in a text document",m=>I.Position.isPosition(m),A.Position.from),S.Range=new S("range","A range in a text document",m=>I.Range.isRange(m),A.Range.from),S.Selection=new S("selection","A selection in a text document",m=>I.Selection.isSelection(m),A.Selection.from),S.Number=new S("number","",m=>typeof m=="number",m=>m),S.String=new S("string","",m=>typeof m=="string",m=>m),S.CallHierarchyItem=new S("item","A call hierarchy item",m=>m instanceof I.CallHierarchyItem,A.CallHierarchyItem.to);class h{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=h,h.Void=new h("no result",m=>m);class c{constructor(t,n,o,i,s){this.id=t,this.internalId=n,this.description=o,this.args=i,this.result=s}}e.ApiCommand=c}),define(ge[231],pe([0,1,6,20,7,80,51,203,17,110]),function(G,e,_,I,A,T,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const r=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",f(I.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,u)=>{if(!(0,D.isFalsyOrEmpty)(a)){class E extends A.SymbolInformation{static to(S){const h=new E(S.name,I.SymbolKind.to(S.kind),S.containerName||"",new A.Location(u[0],I.Range.to(S.range)));return h.detail=S.detail,h.range=h.location.range,h.selectionRange=I.Range.to(S.selectionRange),h.children=S.children?S.children.map(E.to):[],h}}return a.map(E.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",f(I.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",f(I.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(u=>A.Position.isPosition(u)),a=>a.map(I.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(u=>{let E;for(const w of u.reverse())E=new A.SelectionRange(I.Range.to(w),E);return E}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const u=[];if(Array.isArray(a))for(let E of a)u.push(...E[1].map(I.WorkspaceSymbol.to));return u})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return I.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(I.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new A.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const u=(0,k.decodeSemanticTokensDto)(a);if(u.type==="full")return new A.SemanticTokens(u.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new A.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const u=(0,k.decodeSemanticTokensDto)(a);if(u.type==="full")return new A.SemanticTokens(u.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,u,E)=>{if(!a)return new A.CompletionList([]);const w=a.suggestions.map(S=>I.CompletionItem.to(S,E));return new A.CompletionList(w,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return I.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,u,E)=>f(w=>new A.CodeLens(I.Range.to(w.range),w.command&&E.fromInternal(w.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>A.Range.isRange(a),a=>A.Selection.isSelection(a)?I.Selection.from(a):I.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,u,E)=>f(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return E.fromInternal(w.command)}else{const S=new A.CodeAction(w.title,w.kind?new A.CodeActionKind(w.kind):void 0);return w.edit&&(S.edit=I.WorkspaceEdit.to(w.edit)),w.command&&(S.command=E.fromInternal(w.command)),S.isPreferred=w.isPreferred,S}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(u=>new A.ColorInformation(I.Range.to(u.range),I.Color.to(u.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof A.Color,I.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:I.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(I.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineHint objects",a=>a.map(I.InlineHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",f(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(u=>I.NotebookExclusiveDocumentPattern.to(u))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(I.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void)];class C{constructor(u){this._disposables=new _.DisposableStore,this._commands=u}static register(u){return r.forEach(u.registerApiCommand,u),new C(u).registerCommands()}registerCommands(){const u=E=>(...w)=>E(this._commands,...w);this._register(P.RemoveFromRecentlyOpenedAPICommand.ID,u(P.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:E=>typeof E=="string"}]}),this._register(P.OpenIssueReporter.ID,u(P.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:E=>typeof E=="string"||typeof E=="object"&&typeof E.extensionId=="string"}]})}_register(u,E,w){const S=this._commands.registerCommand(!1,u,E,this,w);this._disposables.add(S)}}e.ExtHostApiCommands=C;function f(a){return u=>{if(Array.isArray(u))return u.map(a)}}function p(a){if(!!Array.isArray(a)){const u=[];for(const E of a)T.isLocationLink(E)?u.push(I.DefinitionLink.to(E)):u.push(I.location.to(E));return u}}}),define(ge[232],pe([0,1,13,70,3,6,2,80,27,20,7,5]),function(G,e,_,I,A,T,y,P,D,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class f{constructor(c,m,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(C.MainContext.MainThreadComments),m.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const o=this._commentControllers.get(n.handle);return o||n}else if(n&&n.$mid===7){const o=this._commentControllers.get(n.commentControlHandle);if(!o)return n;const i=o.getCommentThread(n.commentThreadHandle);return i||n}else if(n&&n.$mid===8){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const i=o.getCommentThread(n.thread.commentThreadHandle);return i?{thread:i,text:n.text}:n}else if(n&&n.$mid===9){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const i=o.getCommentThread(n.thread.commentThreadHandle);if(!i)return n;let s=n.commentUniqueId,l=i.getCommentByUniqueId(s);return l||n}else if(n&&n.$mid===10){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const i=o.getCommentThread(n.thread.commentThreadHandle);if(!i)return n;let s=n.text,l=n.commentUniqueId,g=i.getCommentByUniqueId(l);return g?(g.body=s,g):n}return n}})}createCommentController(c,m,t){const n=f.handlePool++,o=new a(c,n,this._proxy,m,t);this._commentControllers.set(o.handle,o);const i=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(c.identifier))||[];return i.push(o),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(c.identifier),i),o}$createCommentThreadTemplate(c,m,t){const n=this._commentControllers.get(c);!n||n.$createCommentThreadTemplate(m,t)}async $updateCommentThreadTemplate(c,m,t){const n=this._commentControllers.get(c);!n||n.$updateCommentThreadTemplate(m,t)}$deleteCommentThread(c,m){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(m)}$provideCommentingRanges(c,m,t){const n=this._commentControllers.get(c);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const o=this._documents.getDocument(y.URI.revive(m));return(0,_.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(o,t)).then(i=>i?i.map(s=>k.Range.from(s)):void 0)}$toggleReaction(c,m,t,n,o){const i=this._commentControllers.get(c);return!i||!i.reactionHandler?Promise.resolve(void 0):(0,_.asPromise)(()=>{const s=i.getCommentThread(m);if(s){const l=s.getCommentByUniqueId(n.uniqueIdInThread);if(i!==void 0&&l&&i.reactionHandler)return i.reactionHandler(l,w(o))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=f,f.handlePool=0;class p{constructor(c,m,t,n,o,i,s){this._proxy=c,this._commentController=m,this._id=t,this._uri=n,this._range=o,this._comments=i,this.handle=p._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new A.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${m.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),s),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=i}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),m={};c("range")&&(m.range=k.Range.from(this._range)),c("label")&&(m.label=this.label),c("contextValue")&&(m.contextValue=this.contextValue),c("comments")&&(m.comments=this._comments.map(t=>u(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(m.collapseState=S(this._collapseState)),c("canReply")&&(m.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,m)}}getCommentByUniqueId(c){for(let m of this._commentsMap){let t=m[0],n=m[1];if(c===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}p._handlePool=0,Ve([(0,I.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=p;class a{constructor(c,m,t,n,o){this._extension=c,this._handle=m,this._proxy=t,this._id=n,this._label=o,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,o)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,m,t,n){if(typeof c=="string"){const o=new p(this._proxy,this,c,m,t,n,this._extension.identifier);return this._threads.set(o.handle,o),o}else{const o=new p(this._proxy,this,void 0,c,m,t,this._extension.identifier);return this._threads.set(o.handle,o),o}}$createCommentThreadTemplate(c,m){const t=new p(this._proxy,this,void 0,y.URI.revive(c),k.Range.to(m),[],this._extension.identifier);return t.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,m){let t=this._threads.get(c);t&&(t.range=k.Range.to(m))}$deleteCommentThread(c){let m=this._threads.get(c);m&&m.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function u(h,c,m,t){let n=t.get(m);n||(n=++h.commentHandle,t.set(m,n));const o=m.author&&m.author.iconPath?m.author.iconPath.toString():void 0;return{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:n,body:k.MarkdownString.from(m.body),userName:m.author.name,userIconPath:o,label:m.label,commentReactions:m.reactions?m.reactions.map(i=>E(i)):void 0}}function E(h){return{label:h.label,iconPath:h.iconPath?k.pathOrURIToURI(h.iconPath):void 0,count:h.count,hasReacted:h.authorHasReacted}}function w(h){return{label:h.label||"",count:h.count||0,iconPath:h.iconPath?y.URI.revive(h.iconPath):"",authorHasReacted:h.hasReacted||!1}}function S(h){if(h!==void 0)switch(h){case r.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case r.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}}),define(ge[126],pe([0,1,2,5,7,4,15,14,17,9,8]),function(G,e,_,I,A,T,y,P,D,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class Sn{constructor(p,a){this._logService=a,this._provider=new Map,this._proxy=p.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,a){const u=Sn._handlePool++;this._provider.set(u,{provider:p,extensionId:a}),this._proxy.$registerDecorationProvider(u,a.value);const E=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(u,null);return}let S=(0,D.asArray)(w);if(S.length<=Sn._maxEventSize){this._proxy.$onDidChange(u,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,S.length);const h=S.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),c=(0,D.groupBy)(h,(t,n)=>t.rank-n.rank||(0,k.compare)(t.uri.path,n.uri.path));let m=[];e:for(let t of c){let n;for(let o of t){let i=(0,r.dirname)(o.uri.path);if(n!==i&&(n=i,m.push(o.uri)>=Sn._maxEventSize))break e}}this._proxy.$onDidChange(u,m)});return new A.Disposable(()=>{E==null||E.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(p,a,u){if(!this._provider.has(p))return Object.create(null);const E=Object.create(null),{provider:w,extensionId:S}=this._provider.get(p);return await Promise.all(a.map(async h=>{try{const{uri:c,id:m}=h,t=await Promise.resolve(w.provideFileDecoration(_.URI.revive(c),u));if(!t)return;try{A.FileDecoration.validate(t),E[m]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${S.value}': ${n}`)}}catch(c){this._logService.error(c)}})),E}};C._handlePool=0,C._maxEventSize=250,C=Ve([xe(0,y.IExtHostRpcService),xe(1,P.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(ge[233],pe([0,1,161,114,2,5,7,20,3,14,24]),function(G,e,_,I,A,T,y,P,D,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(a,u,E,w,S){this._name=a,this._owner=u,this._maxDiagnosticsPerFile=E,this._proxy=w,this._onDidChangeDiagnostics=S,this._isDisposed=!1,this._data=new r.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,u){if(!a){this.clear();return}this._checkDisposed();let E=[];if(A.URI.isUri(a)){if(!u){this.delete(a);return}this._data.set(a,u.slice()),E=[a]}else if(Array.isArray(a)){E=[];let S;a=[...a].sort(C._compareIndexedTuplesByUri);for(const h of a){const[c,m]=h;if((!S||c.toString()!==S.toString())&&(S&&this._data.get(S).length===0&&this._data.delete(S),S=c,E.push(c),this._data.set(c,[])),m){const t=this._data.get(c);t&&t.push(...m)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!!this._proxy){const w=[];for(let S of E){let h=[];const c=this._data.get(S);if(c)if(c.length>this._maxDiagnosticsPerFile){h=[];const m=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of c)if(n.severity===m[t]&&h.push(P.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;h.push({severity:I.MarkerSeverity.Info,message:(0,_.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:h[h.length-1].startLineNumber,startColumn:h[h.length-1].startColumn,endLineNumber:h[h.length-1].endLineNumber,endColumn:h[h.length-1].endColumn})}else h=c.map(m=>P.Diagnostic.from(m));w.push([S,h])}this._proxy.$changeMany(this._owner,w)}}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,u){this._checkDisposed();for(let E of this._data.keys())a.apply(u,[E,this.get(E),this])}get(a){this._checkDisposed();const u=this._data.get(a);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,u){return a[0].toString()<u[0].toString()?-1:a[0].toString()>u[0].toString()?1:0}}e.DiagnosticCollection=C;let f=class jt{constructor(a,u){this._logService=u,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,jt._debouncer,50),jt._mapper),this._proxy=a.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(a,u){return a?a.concat(u):u}static _mapper(a){const u=[],E=new Set;for(const w of a)typeof w=="string"?E.has(w)||(E.add(w),u.push(A.URI.parse(w))):E.has(w.toString())||(E.add(w.toString()),u.push(w));return Object.freeze(u),{uris:u}}createDiagnosticCollection(a,u){const{_collections:E,_proxy:w,_onDidChangeDiagnostics:S,_logService:h}=this,c=new class{$changeMany(n,o){w.$changeMany(n,o),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,n,o.length===0?"CLEARING":o)}$clear(n){w.$clear(n),h.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,n)}dispose(){w.dispose()}};let m;if(!u)u="_generated_diagnostic_collection_name_#"+jt._idPool++,m=u;else if(!E.has(u))m=u;else{this._logService.warn(`DiagnosticCollection with name '${u}' does already exist.`);do m=u+jt._idPool++;while(E.has(m))}return new class extends C{constructor(){super(u,m,jt._maxDiagnosticsPerFile,c,S);E.set(m,this)}dispose(){super.dispose(),E.delete(m)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const u=new Map,E=[];for(const w of this._collections.values())w.forEach((S,h)=>{let c=u.get(S.toString());typeof c=="undefined"&&(c=E.length,u.set(S.toString(),c),E.push([S,[]])),E[c][1]=E[c][1].concat(...h)});return E}}_getDiagnostics(a){let u=[];for(let E of this._collections.values())E.has(a)&&(u=u.concat(E.get(a)));return u}$acceptMarkersChange(a){if(!this._mirrorCollection){const u="_generated_mirror",E=new C(u,u,jt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(u,E),this._mirrorCollection=E}for(const[u,E]of a)this._mirrorCollection.set(A.URI.revive(u),E.map(P.Diagnostic.to))}};f._idPool=0,f._maxDiagnosticsPerFile=1e3,f=Ve([xe(1,k.ILogService)],f),e.ExtHostDiagnostics=f}),define(ge[234],pe([0,1,2,5]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(y){this._proxy=y.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(P=>P?P.map(D=>_.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(P=>P?_.URI.revive(P):void 0)}}e.ExtHostDialogs=A}),define(ge[235],pe([0,1,16,2,7,5,12,21,9]),function(G,e,_,I,A,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(C,f,p){this._documentsAndEditors=f,this._logService=p,this._documentContentProviders=new Map,this._proxy=C.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,f){if(Object.keys(y.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const p=k._handlePool++;this._documentContentProviders.set(p,f),this._proxy.$registerTextContentProvider(p,C);let a;return typeof f.onDidChange=="function"&&(a=f.onDidChange(u=>{if(u.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(p,u).then(E=>{if(!(!E&&typeof E!="string")){const w=this._documentsAndEditors.getDocument(u);if(!!w){const S=(0,D.splitLines)(E);if(!w.equalLines(S))return this._proxy.$onVirtualDocumentChange(u,E)}}},_.onUnexpectedError)})),new A.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(C,f){const p=this._documentContentProviders.get(C);return p?Promise.resolve(p.provideTextDocumentContent(I.URI.revive(f),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(ge[236],pe([0,1,3,6,2,5,120,20,11,23]),function(G,e,_,I,A,T,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class r{constructor(f,p){this._onDidAddDocument=new _.Emitter,this._onDidRemoveDocument=new _.Emitter,this._onDidChangeDocument=new _.Emitter,this._onDidSaveDocument=new _.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const u of a)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const u of a)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!!f){const p=this._documentsAndEditors.getDocument(f);if(p)return p}}getDocument(f){const p=this.getDocumentData(f);if(!(p==null?void 0:p.document))throw new Error(`Unable to retrieve document from URI '${f}'`);return p.document}ensureDocumentData(f){const p=this._documentsAndEditors.getDocument(f);if(p)return Promise.resolve(p);let a=this._documentLoader.get(f.toString());return a||(a=this._proxy.$tryOpenDocument(f).then(u=>{this._documentLoader.delete(f.toString());const E=A.URI.revive(u);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(E))},u=>(this._documentLoader.delete(f.toString()),Promise.reject(u))),this._documentLoader.set(f.toString(),a)),a}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(p=>A.URI.revive(p))}$acceptModelModeChanged(f,p){const a=A.URI.revive(f),u=this._documentsAndEditors.getDocument(a);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(p),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(f){const p=A.URI.revive(f),a=this._documentsAndEditors.getDocument(p);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(f,p){const a=A.URI.revive(f),u=this._documentsAndEditors.getDocument(a);if(!u)throw new Error("unknown document");u._acceptIsDirty(p),this._onDidChangeDocument.fire({document:u.document,contentChanges:[]})}$acceptModelChanged(f,p,a){const u=A.URI.revive(f),E=this._documentsAndEditors.getDocument(u);if(!E)throw new Error("unknown document");E._acceptIsDirty(a),E.onEvents(p),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:E.document,contentChanges:p.changes.map(w=>({range:P.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(f,p){(0,y.setWordDefinitionFor)(f,p)}}e.ExtHostDocuments=r}),define(ge[39],pe([0,1,52,3,6,2,4,5,120,15,124,20,14,24,12,54,134]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(c,m){this._extHostRpc=c,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const m=[],t=[],n=[];if(c.removedDocuments)for(const o of c.removedDocuments){const i=T.URI.revive(o),s=this._documents.get(i);(s==null?void 0:s.unref())&&(this._documents.delete(i),m.push(s.value))}if(c.addedDocuments)for(const o of c.addedDocuments){const i=T.URI.revive(o.uri);let s=this._documents.get(i);if(s&&i.scheme!==a.Schemas.vscodeNotebookCell)throw new Error(`document '${i} already exists!'`);s||(s=new w(new D.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),i,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(i,s),t.push(s.value)),s.ref()}if(c.removedEditors)for(const o of c.removedEditors){const i=this._editors.get(o);this._editors.delete(o),i&&n.push(i)}if(c.addedEditors)for(const o of c.addedEditors){const i=T.URI.revive(o.documentUri);_.ok(this._documents.has(i),`document '${i}' does not exist`),_.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const s=this._documents.get(i).value,l=new r.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>s.document),o.selections.map(C.Selection.to),o.options,o.visibleRanges.map(g=>C.Range.to(g)),typeof o.editorPosition=="number"?C.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,l)}c.newActiveEditor!==void 0&&(_.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,A.dispose)(m),(0,A.dispose)(n),c.removedDocuments&&this._onDidRemoveDocuments.fire(m),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var m;return(m=this._documents.get(c))===null||m===void 0?void 0:m.value}allDocuments(){return u.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const m=this._editors.get(this._activeEditorId);return c?m:m==null?void 0:m.value}}allEditors(){return[...this._editors.values()]}};S=Ve([xe(0,k.IExtHostRpcService),xe(1,f.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[237],pe([0,1,2,5,6,7,20,143,9,22]),function(G,e,_,I,A,T,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class r{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const a=this._schemes.indexOf(p);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),a=[];let u,E,w=14,S=14;for(const h of p){let c=u?(0,D.commonPrefixLength)(u,h):0;for(c===0?E=1:E=S;c<h.length;c++)c+1===h.length?(w=S,S=9):S+=1,a.push([E,h.toUpperCase().charCodeAt(c),S]),a.push([E,h.toLowerCase().charCodeAt(c),S]),E=S;u=h,S=w}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new P.StateMachine(a)}}provideDocumentLinks(p){this._initStateMachine();const a=[],u=P.LinkComputer.computeLinks({getLineContent(E){return p.lineAt(E-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const E of u){const w=y.DocumentLink.to(E);w.target&&a.push(w)}return a}}class C{constructor(p,a){this._extHostLanguageFeatures=a,this._linkProvider=new r,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var p;(p=this._linkProviderRegistration)===null||p===void 0||p.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(p,a,u,E={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(w,u);let S=2;E.isCaseSensitive&&(S+=1024),E.isReadonly&&(S+=2048),typeof u.copy=="function"&&(S+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&(S+=4),this._proxy.$registerFileSystemProvider(w,a,S).catch(c=>{console.error(`FAILED to register filesystem provider of ${p.value}-extension for the scheme ${a}`),console.error(c)});const h=u.onDidChangeFile(c=>{const m=[];for(const t of c){let{uri:n,type:o}=t;if(n.scheme===a){let i;switch(o){case T.FileChangeType.Changed:i=0;break;case T.FileChangeType.Created:i=1;break;case T.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}m.push({resource:n,type:i})}}this._proxy.$onFileSystemChange(w,m)});return(0,A.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(p){const{type:a,ctime:u,mtime:E,size:w}=p;return{type:a,ctime:u,mtime:E,size:w}}$stat(p,a){return Promise.resolve(this._getFsProvider(p).stat(_.URI.revive(a))).then(C._asIStat)}$readdir(p,a){return Promise.resolve(this._getFsProvider(p).readDirectory(_.URI.revive(a)))}$readFile(p,a){return Promise.resolve(this._getFsProvider(p).readFile(_.URI.revive(a))).then(u=>k.VSBuffer.wrap(u))}$writeFile(p,a,u,E){return Promise.resolve(this._getFsProvider(p).writeFile(_.URI.revive(a),u.buffer,E))}$delete(p,a,u){return Promise.resolve(this._getFsProvider(p).delete(_.URI.revive(a),u))}$rename(p,a,u,E){return Promise.resolve(this._getFsProvider(p).rename(_.URI.revive(a),_.URI.revive(u),E))}$copy(p,a,u,E){const w=this._getFsProvider(p);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(_.URI.revive(a),_.URI.revive(u),E))}$mkdir(p,a){return Promise.resolve(this._getFsProvider(p).createDirectory(_.URI.revive(a)))}$watch(p,a,u,E){const w=this._getFsProvider(p).watch(_.URI.revive(u),E);this._watches.set(a,w)}$unwatch(p,a){const u=this._watches.get(a);u&&(u.dispose(),this._watches.delete(a))}$open(p,a,u){const E=this._getFsProvider(p);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(_.URI.revive(a),u))}$close(p,a){const u=this._getFsProvider(p);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(a))}$read(p,a,u,E){const w=this._getFsProvider(p);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const S=k.VSBuffer.alloc(E);return Promise.resolve(w.read(a,u,S.buffer,0,E)).then(h=>S.slice(0,h))}$write(p,a,u,E){const w=this._getFsProvider(p);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(a,u,E.buffer,0,E.byteLength))}_getFsProvider(p){const a=this._fsProvider.get(p);if(!a){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return a}}e.ExtHostFileSystem=C}),define(ge[91],pe([0,1,5,46,7,22,4,15,61]),function(G,e,_,I,A,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Ot{constructor(C,f){const p=C.getProxy(_.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return p.$stat(a).catch(Ot._handleError)},readDirectory(a){return p.$readdir(a).catch(Ot._handleError)},createDirectory(a){return p.$mkdir(a).catch(Ot._handleError)},async readFile(a){return p.$readFile(a).then(u=>u.buffer).catch(Ot._handleError)},writeFile(a,u){return p.$writeFile(a,T.VSBuffer.wrap(u)).catch(Ot._handleError)},delete(a,u){return p.$delete(a,Object.assign({recursive:!1,useTrash:!1},u)).catch(Ot._handleError)},rename(a,u,E){return p.$rename(a,u,Object.assign({overwrite:!1},E)).catch(Ot._handleError)},copy(a,u,E){return p.$copy(a,u,Object.assign({overwrite:!1},E)).catch(Ot._handleError)},isWritableFileSystem(a){const u=f.getCapabilities(a);if(typeof u=="number")return!(u&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new A.FileSystemError(String(C));if(C.name==="ENOPRO")throw A.FileSystemError.Unavailable(C.message);switch(C.name){case I.FileSystemProviderErrorCode.FileExists:throw A.FileSystemError.FileExists(C.message);case I.FileSystemProviderErrorCode.FileNotFound:throw A.FileSystemError.FileNotFound(C.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw A.FileSystemError.FileNotADirectory(C.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw A.FileSystemError.FileIsADirectory(C.message);case I.FileSystemProviderErrorCode.NoPermissions:throw A.FileSystemError.NoPermissions(C.message);case I.FileSystemProviderErrorCode.Unavailable:throw A.FileSystemError.Unavailable(C.message);default:throw new A.FileSystemError(C.message,C.name)}}};k=Ve([xe(0,P.IExtHostRpcService),xe(1,D.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[238],pe([0,1,6,5]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class A{constructor(y){this._handlePool=0,this._proxy=y.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,y),(0,_.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=A}),define(ge[239],pe([0,1,2,23,20,7,13,5,9,45,17,11,140,6,110,72,86,48,16]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class h{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentSymbols(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ee,Y)).then(ae=>{if(!(0,r.isFalsyOrEmpty)(ae))return ae[0]instanceof T.DocumentSymbol?ae.map(A.DocumentSymbol.from):h._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(z){var Y;z=z.slice(0).sort((me,De)=>{let Oe=me.location.range.start.compareTo(De.location.range.start);return Oe===0&&(Oe=De.location.range.end.compareTo(me.location.range.end)),Oe});const ee=[],ae=[];for(const me of z){const De={name:me.name||"!!MISSING: name!!",kind:A.SymbolKind.from(me.kind),tags:((Y=me.tags)===null||Y===void 0?void 0:Y.map(A.SymbolTag.from))||[],detail:"",containerName:me.containerName,range:A.Range.from(me.location.range),selectionRange:A.Range.from(me.location.range),children:[]};for(;;){if(ae.length===0){ae.push(De),ee.push(De);break}const Oe=ae[ae.length-1];if(k.Range.containsRange(Oe.range,De.range)&&!k.Range.equalsRange(Oe.range,De.range)){Oe.children&&Oe.children.push(De),ae.push(De);break}ae.pop()}}return ee}}class c{constructor(z,Y,ee){this._documents=z,this._commands=Y,this._provider=ee,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,Y){const ee=this._documents.getDocument(z),ae=await this._provider.provideCodeLenses(ee,Y);if(!(!ae||Y.isCancellationRequested)){const me=this._cache.add(ae),De=new p.DisposableStore;this._disposables.set(me,De);const Oe={cacheId:me,lenses:[]};for(let we=0;we<ae.length;we++)Oe.lenses.push({cacheId:[me,we],range:A.Range.from(ae[we].range),command:this._commands.toInternal(ae[we].command,De)});return Oe}}async resolveCodeLens(z,Y){var ee;const ae=z.cacheId&&this._cache.get(...z.cacheId);if(!!ae){let me;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?me=ae:me=await this._provider.resolveCodeLens(ae,Y),me||(me=ae),!Y.isCancellationRequested){const De=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!De)return z.command=this._commands.toInternal((ee=me.command)!==null&&ee!==void 0?ee:c._badCmd,De),z}}}releaseCodeLenses(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function m(Le){return Array.isArray(Le)?Le.map(A.DefinitionLink.from):Le?[A.DefinitionLink.from(Le)]:[]}class t{constructor(z,Y){this._documents=z,this._provider=Y}provideDefinition(z,Y,ee){const ae=this._documents.getDocument(z),me=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDefinition(ae,me,ee)).then(m)}}class n{constructor(z,Y){this._documents=z,this._provider=Y}provideDeclaration(z,Y,ee){const ae=this._documents.getDocument(z),me=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDeclaration(ae,me,ee)).then(m)}}class o{constructor(z,Y){this._documents=z,this._provider=Y}provideImplementation(z,Y,ee){const ae=this._documents.getDocument(z),me=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideImplementation(ae,me,ee)).then(m)}}class i{constructor(z,Y){this._documents=z,this._provider=Y}provideTypeDefinition(z,Y,ee){const ae=this._documents.getDocument(z),me=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(ae,me,ee)).then(m)}}class s{constructor(z,Y){this._documents=z,this._provider=Y}provideHover(z,Y,ee){const ae=this._documents.getDocument(z),me=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideHover(ae,me,ee)).then(De=>{if(!(!De||(0,r.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=ae.getWordRangeAtPosition(me)),De.range||(De.range=new T.Range(me,me)),A.Hover.from(De)})}}class l{constructor(z,Y){this._documents=z,this._provider=Y}provideEvaluatableExpression(z,Y,ee){const ae=this._documents.getDocument(z),me=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,me,ee)).then(De=>{if(De)return A.EvaluatableExpression.from(De)})}}class g{constructor(z,Y){this._documents=z,this._provider=Y}provideInlineValues(z,Y,ee,ae){const me=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideInlineValues(me,A.Range.to(Y),A.InlineValueContext.to(ee),ae)).then(De=>{if(Array.isArray(De))return De.map(Oe=>A.InlineValue.from(Oe))})}}class v{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentHighlights(z,Y,ee){const ae=this._documents.getDocument(z),me=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(ae,me,ee)).then(De=>{if(Array.isArray(De))return De.map(A.DocumentHighlight.from)})}}class d{constructor(z,Y){this._documents=z,this._provider=Y}provideLinkedEditingRanges(z,Y,ee){const ae=this._documents.getDocument(z),me=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,me,ee)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,r.coalesce)(De.ranges.map(A.Range.from)),wordPattern:De.wordPattern}})}}class b{constructor(z,Y){this._documents=z,this._provider=Y}provideReferences(z,Y,ee,ae){const me=this._documents.getDocument(z),De=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideReferences(me,De,ee,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(A.location.from)})}}class R{constructor(z,Y,ee,ae,me,De,Oe){this._documents=z,this._commands=Y,this._diagnostics=ee,this._provider=ae,this._logService=me,this._extension=De,this._apiDeprecation=Oe,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(z,Y,ee,ae){const me=this._documents.getDocument(z),De=f.Selection.isISelection(Y)?A.Selection.to(Y):A.Range.to(Y),Oe=[];for(const Pe of this._diagnostics.getDiagnostics(z))if(De.intersection(Pe.range)&&Oe.push(Pe)>R._maxCodeActionsPerFile)break;const we={diagnostics:Oe,only:ee.only?new T.CodeActionKind(ee.only):void 0,triggerKind:A.CodeActionTriggerKind.to(ee.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(me,De,we,ae)).then(Pe=>{var Re;if(!(!(0,r.isNonEmptyArray)(Pe)||ae.isCancellationRequested)){const Be=this._cache.add(Pe),Se=new p.DisposableStore;this._disposables.set(Be,Se);const qe=[];for(let X=0;X<Pe.length;X++){const ie=Pe[X];!ie||(R._isCommand(ie)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:ie.title,command:this._commands.toInternal(ie,Se)})):(we.only&&(ie.kind?we.only.contains(ie.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action is of kind '${ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[Be,X],title:ie.title,command:ie.command&&this._commands.toInternal(ie.command,Se),diagnostics:ie.diagnostics&&ie.diagnostics.map(A.Diagnostic.from),edit:ie.edit&&A.WorkspaceEdit.from(ie.edit),kind:ie.kind&&ie.kind.value,isPreferred:ie.isPreferred,disabled:(Re=ie.disabled)===null||Re===void 0?void 0:Re.reason})))}return{cacheId:Be,actions:qe}}})}async resolveCodeAction(z,Y){var ee;const[ae,me]=z,De=this._cache.get(ae,me);if(!(!De||R._isCommand(De))&&!!this._provider.resolveCodeAction){const Oe=(ee=await this._provider.resolveCodeAction(De,Y))!==null&&ee!==void 0?ee:De;return(Oe==null?void 0:Oe.edit)?A.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}R._maxCodeActionsPerFile=1e3;class N{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentFormattingEdits(z,Y,ee){const ae=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,Y,ee)).then(me=>{if(Array.isArray(me))return me.map(A.TextEdit.from)})}}class q{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentRangeFormattingEdits(z,Y,ee,ae){const me=this._documents.getDocument(z),De=A.Range.to(Y);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(me,De,ee,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(A.TextEdit.from)})}}class re{constructor(z,Y){this._documents=z,this._provider=Y,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(z,Y,ee,ae,me){const De=this._documents.getDocument(z),Oe=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Oe,ee,ae,me)).then(we=>{if(Array.isArray(we))return we.map(A.TextEdit.from)})}}class V{constructor(z,Y){this._provider=z,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(z,Y){const ee=P.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(z,Y)).then(ae=>{if((0,r.isNonEmptyArray)(ae)){for(const me of ae)if(!!me){if(!me.name){this._logService.warn("INVALID SymbolInformation, lacks name",me);continue}const De=P.IdObject.mixin(A.WorkspaceSymbol.from(me));this._symbolCache.set(De._id,me),ee.symbols.push(De)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(z,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const ee=this._symbolCache.get(z._id);if(ee){const ae=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,Y));return ae&&(0,I.mixin)(z,A.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(z){const Y=this._resultCache.get(z);if(Y){for(let[ee,ae]=Y;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete(z)}}}class W{constructor(z,Y,ee){this._documents=z,this._provider=Y,this._logService=ee}static supportsResolving(z){return typeof z.prepareRename=="function"}provideRenameEdits(z,Y,ee,ae){const me=this._documents.getDocument(z),De=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(me,De,ee,ae)).then(Oe=>{if(!!Oe)return A.WorkspaceEdit.from(Oe)},Oe=>{const we=W._asMessage(Oe);return we?{rejectReason:we,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(z,Y,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(z),me=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.prepareRename(ae,me,ee)).then(De=>{let Oe,we;if(T.Range.isRange(De)?(Oe=De,we=ae.getText(De)):(0,C.isObject)(De)&&(Oe=De.range,we=De.placeholder),!!Oe){if(Oe.start.line>me.line||Oe.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(Oe),text:we}}},De=>{const Oe=W._asMessage(De);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ${constructor(z,Y){this.resultId=z,this.tokens=Y}}class U{constructor(z,Y){this._documents=z,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(z,Y,ee){const ae=this._documents.getDocument(z),me=Y!==0?this._previousResults.get(Y):null;return(0,y.asPromise)(()=>me&&typeof me.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,me.resultId,ee):this._provider.provideDocumentSemanticTokens(ae,ee)).then(De=>(me&&this._previousResults.delete(Y),De?(De=U._fixProvidedSemanticTokens(De),this._send(U._convertToEdits(me,De),De)):null))}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return U._isSemanticTokens(z)?U._isCorrectSemanticTokens(z)?z:new T.SemanticTokens(new Uint32Array(z.data),z.resultId):U._isSemanticTokensEdits(z)?U._isCorrectSemanticTokensEdits(z)?z:new T.SemanticTokensEdits(z.edits.map(Y=>new T.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const Y of z.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,Y){if(!U._isSemanticTokens(Y)||!z||!z.tokens)return Y;const ee=z.tokens,ae=ee.length,me=Y.data,De=me.length;let Oe=0;const we=Math.min(ae,De);for(;Oe<we&&ee[Oe]===me[Oe];)Oe++;if(Oe===ae&&Oe===De)return new T.SemanticTokensEdits([],Y.resultId);let Pe=0;const Re=we-Oe;for(;Pe<Re&&ee[ae-Pe-1]===me[De-Pe-1];)Pe++;return new T.SemanticTokensEdits([{start:Oe,deleteCount:ae-Oe-Pe,data:me.subarray(Oe,De-Pe)}],Y.resultId)}_send(z,Y){if(U._isSemanticTokens(z)){const ee=this._nextResultId++;return this._previousResults.set(ee,new $(z.resultId,z.data)),(0,a.encodeSemanticTokensDto)({id:ee,type:"full",data:z.data})}if(U._isSemanticTokensEdits(z)){const ee=this._nextResultId++;return U._isSemanticTokens(Y)?this._previousResults.set(ee,new $(Y.resultId,Y.data)):this._previousResults.set(ee,new $(z.resultId)),(0,a.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(z.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class F{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentRangeSemanticTokens(z,Y,ee){const ae=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,A.Range.to(Y),ee)).then(me=>me?this._send(me):null)}_send(z){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=F;class M{constructor(z,Y,ee,ae,me){this._documents=z,this._commands=Y,this._provider=ee,this._apiDeprecation=ae,this._extension=me,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,Y,ee,ae){const me=this._documents.getDocument(z),De=A.Position.to(Y),Oe=me.getWordRangeAtPosition(De)||new T.Range(De,De),we=Oe.with({end:De}),Pe=new w.StopWatch(!0),Re=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(me,De,ae,A.CompletionContext.to(ee)));if(!!Re&&!ae.isCancellationRequested){const Be=Array.isArray(Re)?new T.CompletionList(Re):Re,Se=M.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),qe=new p.DisposableStore;this._disposables.set(Se,qe);const X=[],ie={x:Se,b:X,a:{replace:A.Range.from(Oe),insert:A.Range.from(we)},c:Be.isIncomplete||void 0,d:Pe.elapsed()};for(let _e=0;_e<Be.items.length;_e++){const Ne=Be.items[_e],ze=this._convertCompletionItem(Ne,[Se,_e],we,Oe);X.push(ze)}return ie}}async resolveCompletionItem(z,Y){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...z);if(!!ee){const ae=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ee,Y));if(!!ae)return this._convertCompletionItem(ae,z)}}}releaseCompletionItems(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,Y,ee,ae){var me;const De=this._disposables.get(Y[0]);if(!De)throw Error("DisposableStore is missing...");const Oe={x:Y,a:(me=z.label)!==null&&me!==void 0?me:"",o:z.label2,b:z.kind!==void 0?A.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(A.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:A.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(A.TextEdit.from),m:this._commands.toInternal(z.command,De)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=z.textEdit.newText):typeof z.insertText=="string"?Oe.h=z.insertText:z.insertText instanceof T.SnippetString&&(Oe.h=z.insertText.value,Oe.i|=4);let we;return z.textEdit?we=z.textEdit.range:z.range&&(we=z.range),T.Range.isRange(we)?Oe.j=A.Range.from(we):we&&(!(ee==null?void 0:ee.isEqual(we.inserting))||!(ae==null?void 0:ae.isEqual(we.replacing)))&&(Oe.j={insert:A.Range.from(we.inserting),replace:A.Range.from(we.replacing)}),Oe}}class L{constructor(z,Y){this._documents=z,this._provider=Y,this._cache=new E.Cache("SignatureHelp")}provideSignatureHelp(z,Y,ee,ae){const me=this._documents.getDocument(z),De=A.Position.to(Y),Oe=this.reviveContext(ee);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(me,De,ae,Oe)).then(we=>{if(we){const Pe=this._cache.add([we]);return Object.assign(Object.assign({},A.SignatureHelp.from(we)),{id:Pe})}})}reviveContext(z){let Y;if(z.activeSignatureHelp){const ee=A.SignatureHelp.to(z.activeSignatureHelp),ae=this._cache.get(z.activeSignatureHelp.id,0);ae?(Y=ae,Y.activeSignature=ee.activeSignature,Y.activeParameter=ee.activeParameter):Y=ee}return Object.assign(Object.assign({},z),{activeSignatureHelp:Y})}releaseSignatureHelp(z){this._cache.delete(z)}}class O{constructor(z,Y){this._documents=z,this._provider=Y}provideInlineHints(z,Y,ee){const ae=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideInlineHints(ae,A.Range.to(Y),ee)).then(me=>me?{hints:me.map(A.InlineHint.from)}:void 0)}}class B{constructor(z,Y){this._documents=z,this._provider=Y,this._cache=new E.Cache("DocumentLink")}provideLinks(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ee,Y)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(A.DocumentLink.from)};{const me=this._cache.add(ae),De={links:[],id:me};for(let Oe=0;Oe<ae.length;Oe++){const we=A.DocumentLink.from(ae[Oe]);we.cacheId=[me,Oe],De.links.push(we)}return De}}})}resolveLink(z,Y){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...z);return ee?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ee,Y)).then(ae=>ae&&A.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(z){this._cache.delete(z)}}class j{constructor(z,Y){this._documents=z,this._provider=Y}provideColors(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ee,Y)).then(ae=>Array.isArray(ae)?ae.map(De=>({color:A.Color.from(De.color),range:A.Range.from(De.range)})):[])}provideColorPresentations(z,Y,ee){const ae=this._documents.getDocument(z),me=A.Range.to(Y.range),De=A.Color.to(Y.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(De,{document:ae,range:me},ee)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(A.ColorPresentation.from)})}}class Q{constructor(z,Y){this._documents=z,this._provider=Y}provideFoldingRanges(z,Y,ee){const ae=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(ae,Y,ee)).then(me=>{if(!!Array.isArray(me))return me.map(A.FoldingRange.from)})}}class de{constructor(z,Y,ee){this._documents=z,this._provider=Y,this._logService=ee}provideSelectionRanges(z,Y,ee){const ae=this._documents.getDocument(z),me=Y.map(A.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(ae,me,ee)).then(De=>{if(!(0,r.isNonEmptyArray)(De))return[];if(De.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let we=0;we<me.length;we++){const Pe=[];Oe.push(Pe);let Re=me[we],Be=De[we];for(;;){if(!Be.range.contains(Re))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(A.SelectionRange.from(Be)),!Be.parent)break;Re=Be.range,Be=Be.parent}}return Oe})}}class be{constructor(z,Y){this._documents=z,this._provider=Y,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(z,Y,ee){const ae=this._documents.getDocument(z),me=A.Position.to(Y),De=await this._provider.prepareCallHierarchy(ae,me,ee);if(!!De){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(De)?De.map(we=>this._cacheAndConvertItem(Oe,we)):[this._cacheAndConvertItem(Oe,De)]}}async provideCallsTo(z,Y,ee){const ae=this._itemFromCache(z,Y);if(!ae)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!me)return me.map(De=>({from:this._cacheAndConvertItem(z,De.from),fromRanges:De.fromRanges.map(Oe=>A.Range.from(Oe))}))}async provideCallsFrom(z,Y,ee){const ae=this._itemFromCache(z,Y);if(!ae)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!me)return me.map(De=>({to:this._cacheAndConvertItem(z,De.to),fromRanges:De.fromRanges.map(Oe=>A.Range.from(Oe))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,Y){var ee;const ae=this._cache.get(z),me={_sessionId:z,_itemId:ae.size.toString(36),name:Y.name,detail:Y.detail,kind:A.SymbolKind.from(Y.kind),uri:Y.uri,range:A.Range.from(Y.range),selectionRange:A.Range.from(Y.selectionRange),tags:(ee=Y.tags)===null||ee===void 0?void 0:ee.map(A.SymbolTag.from)};return ae.set(me._itemId,Y),me}_itemFromCache(z,Y){const ee=this._cache.get(z);return ee==null?void 0:ee.get(Y)}}class Ae{constructor(z,Y){this.adapter=z,this.extension=Y}}class Ce{constructor(z,Y,ee,ae,me,De,Oe){this._adapter=new Map,this._uriTransformer=Y,this._proxy=z.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=me,this._logService=De,this._apiDeprecation=Oe}_transformDocumentSelector(z){return(0,r.coalesce)((0,r.asArray)(z).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:A.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new T.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Ce._handlePool++}_withAdapter(z,Y,ee,ae,me=!1){const De=this._adapter.get(z);if(!De)return Promise.resolve(ae);if(De.adapter instanceof Y){let Oe;De.extension&&(Oe=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${Y.name}'`));const we=ee(De.adapter,De.extension),Pe=De.extension;return Pe&&Promise.resolve(we).then(()=>this._logService.trace(`[${Pe.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Re=>{me&&Re instanceof S.CancellationError||(this._logService.error(`[${Pe.identifier.value}] provider FAILED`),this._logService.error(Re))}),we}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,Y){const ee=this._nextHandle();return this._adapter.set(ee,new Ae(z,Y)),ee}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,Y,ee,ae){const me=this._addNewAdapter(new h(this._documents,ee),z),De=ae&&ae.label||Ce._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(Y),De),this._createDisposable(me)}$provideDocumentSymbols(z,Y,ee){return this._withAdapter(z,h,ae=>ae.provideDocumentSymbols(_.URI.revive(Y),ee),void 0)}registerCodeLensProvider(z,Y,ee){const ae=this._nextHandle(),me=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ae(new c(this._documents,this._commands.converter,ee),z)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Y),me);let De=this._createDisposable(ae);if(me!==void 0){const Oe=ee.onDidChangeCodeLenses(we=>this._proxy.$emitCodeLensEvent(me));De=T.Disposable.from(De,Oe)}return De}$provideCodeLenses(z,Y,ee){return this._withAdapter(z,c,ae=>ae.provideCodeLenses(_.URI.revive(Y),ee),void 0)}$resolveCodeLens(z,Y,ee){return this._withAdapter(z,c,ae=>ae.resolveCodeLens(Y,ee),void 0)}$releaseCodeLenses(z,Y){this._withAdapter(z,c,ee=>Promise.resolve(ee.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(z,Y,ee){const ae=this._addNewAdapter(new t(this._documents,ee),z);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDefinition(z,Y,ee,ae){return this._withAdapter(z,t,me=>me.provideDefinition(_.URI.revive(Y),ee,ae),[])}registerDeclarationProvider(z,Y,ee){const ae=this._addNewAdapter(new n(this._documents,ee),z);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDeclaration(z,Y,ee,ae){return this._withAdapter(z,n,me=>me.provideDeclaration(_.URI.revive(Y),ee,ae),[])}registerImplementationProvider(z,Y,ee){const ae=this._addNewAdapter(new o(this._documents,ee),z);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideImplementation(z,Y,ee,ae){return this._withAdapter(z,o,me=>me.provideImplementation(_.URI.revive(Y),ee,ae),[])}registerTypeDefinitionProvider(z,Y,ee){const ae=this._addNewAdapter(new i(this._documents,ee),z);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideTypeDefinition(z,Y,ee,ae){return this._withAdapter(z,i,me=>me.provideTypeDefinition(_.URI.revive(Y),ee,ae),[])}registerHoverProvider(z,Y,ee,ae){const me=this._addNewAdapter(new s(this._documents,ee),z);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(Y)),this._createDisposable(me)}$provideHover(z,Y,ee,ae){return this._withAdapter(z,s,me=>me.provideHover(_.URI.revive(Y),ee,ae),void 0)}registerEvaluatableExpressionProvider(z,Y,ee,ae){const me=this._addNewAdapter(new l(this._documents,ee),z);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(Y)),this._createDisposable(me)}$provideEvaluatableExpression(z,Y,ee,ae){return this._withAdapter(z,l,me=>me.provideEvaluatableExpression(_.URI.revive(Y),ee,ae),void 0)}registerInlineValuesProvider(z,Y,ee,ae){const me=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new g(this._documents,ee),z);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(Y),me);let Oe=this._createDisposable(De);if(me!==void 0){const we=ee.onDidChangeInlineValues(Pe=>this._proxy.$emitInlineValuesEvent(me));Oe=T.Disposable.from(Oe,we)}return Oe}$provideInlineValues(z,Y,ee,ae,me){return this._withAdapter(z,g,De=>De.provideInlineValues(_.URI.revive(Y),ee,ae,me),void 0)}registerDocumentHighlightProvider(z,Y,ee){const ae=this._addNewAdapter(new v(this._documents,ee),z);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentHighlights(z,Y,ee,ae){return this._withAdapter(z,v,me=>me.provideDocumentHighlights(_.URI.revive(Y),ee,ae),void 0)}registerLinkedEditingRangeProvider(z,Y,ee){const ae=this._addNewAdapter(new d(this._documents,ee),z);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideLinkedEditingRanges(z,Y,ee,ae){return this._withAdapter(z,d,async me=>{const De=await me.provideLinkedEditingRanges(_.URI.revive(Y),ee,ae);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Ce._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(z,Y,ee){const ae=this._addNewAdapter(new b(this._documents,ee),z);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideReferences(z,Y,ee,ae,me){return this._withAdapter(z,b,De=>De.provideReferences(_.URI.revive(Y),ee,ae,me),void 0)}registerCodeActionProvider(z,Y,ee,ae){var me,De;const Oe=new p.DisposableStore,we=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(Y),{providedKinds:(me=ae==null?void 0:ae.providedCodeActionKinds)===null||me===void 0?void 0:me.map(Pe=>Pe.value),documentation:(De=ae==null?void 0:ae.documentation)===null||De===void 0?void 0:De.map(Pe=>({kind:Pe.kind.value,command:this._commands.converter.toInternal(Pe.command,Oe)}))},Ce._extLabel(z),Boolean(ee.resolveCodeAction)),Oe.add(this._createDisposable(we)),Oe}$provideCodeActions(z,Y,ee,ae,me){return this._withAdapter(z,R,De=>De.provideCodeActions(_.URI.revive(Y),ee,ae,me),void 0)}$resolveCodeAction(z,Y,ee){return this._withAdapter(z,R,ae=>ae.resolveCodeAction(Y,ee),void 0)}$releaseCodeActions(z,Y){this._withAdapter(z,R,ee=>Promise.resolve(ee.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(z,Y,ee){const ae=this._addNewAdapter(new N(this._documents,ee),z);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Y),z.identifier,z.displayName||z.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(z,Y,ee,ae){return this._withAdapter(z,N,me=>me.provideDocumentFormattingEdits(_.URI.revive(Y),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider(z,Y,ee){const ae=this._addNewAdapter(new q(this._documents,ee),z);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Y),z.identifier,z.displayName||z.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(z,Y,ee,ae,me){return this._withAdapter(z,q,De=>De.provideDocumentRangeFormattingEdits(_.URI.revive(Y),ee,ae,me),void 0)}registerOnTypeFormattingEditProvider(z,Y,ee,ae){const me=this._addNewAdapter(new re(this._documents,ee),z);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(Y),ae,z.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(z,Y,ee,ae,me,De){return this._withAdapter(z,re,Oe=>Oe.provideOnTypeFormattingEdits(_.URI.revive(Y),ee,ae,me,De),void 0)}registerWorkspaceSymbolProvider(z,Y){const ee=this._addNewAdapter(new V(Y,this._logService),z);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(z,Y,ee){return this._withAdapter(z,V,ae=>ae.provideWorkspaceSymbols(Y,ee),{symbols:[]})}$resolveWorkspaceSymbol(z,Y,ee){return this._withAdapter(z,V,ae=>ae.resolveWorkspaceSymbol(Y,ee),void 0)}$releaseWorkspaceSymbols(z,Y){this._withAdapter(z,V,ee=>ee.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(z,Y,ee){const ae=this._addNewAdapter(new W(this._documents,ee,this._logService),z);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Y),W.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits(z,Y,ee,ae,me){return this._withAdapter(z,W,De=>De.provideRenameEdits(_.URI.revive(Y),ee,ae,me),void 0)}$resolveRenameLocation(z,Y,ee,ae){return this._withAdapter(z,W,me=>me.resolveRenameLocation(_.URI.revive(Y),ee,ae),void 0)}registerDocumentSemanticTokensProvider(z,Y,ee,ae){const me=this._nextHandle(),De=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(me,new Ae(new U(this._documents,ee),z)),this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(Y),ae,De);let Oe=this._createDisposable(me);if(De){const we=ee.onDidChangeSemanticTokens(Pe=>this._proxy.$emitDocumentSemanticTokensEvent(De));Oe=T.Disposable.from(Oe,we)}return Oe}$provideDocumentSemanticTokens(z,Y,ee,ae){return this._withAdapter(z,U,me=>me.provideDocumentSemanticTokens(_.URI.revive(Y),ee,ae),null,!0)}$releaseDocumentSemanticTokens(z,Y){this._withAdapter(z,U,ee=>ee.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(z,Y,ee,ae){const me=this._addNewAdapter(new F(this._documents,ee),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(Y),ae),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(z,Y,ee,ae){return this._withAdapter(z,F,me=>me.provideDocumentRangeSemanticTokens(_.URI.revive(Y),ee,ae),null,!0)}registerCompletionItemProvider(z,Y,ee,ae){const me=this._addNewAdapter(new M(this._documents,this._commands.converter,ee,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(me,this._transformDocumentSelector(Y),ae,M.supportsResolving(ee),`${z.identifier.value}(${ae.join("")})`),this._createDisposable(me)}$provideCompletionItems(z,Y,ee,ae,me){return this._withAdapter(z,M,De=>De.provideCompletionItems(_.URI.revive(Y),ee,ae,me),void 0)}$resolveCompletionItem(z,Y,ee){return this._withAdapter(z,M,ae=>ae.resolveCompletionItem(Y,ee),void 0)}$releaseCompletionItems(z,Y){this._withAdapter(z,M,ee=>ee.releaseCompletionItems(Y),void 0)}registerSignatureHelpProvider(z,Y,ee,ae){const me=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,De=this._addNewAdapter(new L(this._documents,ee),z);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(Y),me),this._createDisposable(De)}$provideSignatureHelp(z,Y,ee,ae,me){return this._withAdapter(z,L,De=>De.provideSignatureHelp(_.URI.revive(Y),ee,ae,me),void 0)}$releaseSignatureHelp(z,Y){this._withAdapter(z,L,ee=>ee.releaseSignatureHelp(Y),void 0)}registerInlineHintsProvider(z,Y,ee){const ae=typeof ee.onDidChangeInlineHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new O(this._documents,ee),z);this._proxy.$registerInlineHintsProvider(me,this._transformDocumentSelector(Y),ae);let De=this._createDisposable(me);if(ae!==void 0){const Oe=ee.onDidChangeInlineHints(we=>this._proxy.$emitInlineHintsEvent(ae));De=T.Disposable.from(De,Oe)}return De}$provideInlineHints(z,Y,ee,ae){return this._withAdapter(z,O,me=>me.provideInlineHints(_.URI.revive(Y),ee,ae),void 0)}registerDocumentLinkProvider(z,Y,ee){const ae=this._addNewAdapter(new B(this._documents,ee),z);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Y),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(z,Y,ee){return this._withAdapter(z,B,ae=>ae.provideLinks(_.URI.revive(Y),ee),void 0)}$resolveDocumentLink(z,Y,ee){return this._withAdapter(z,B,ae=>ae.resolveLink(Y,ee),void 0)}$releaseDocumentLinks(z,Y){this._withAdapter(z,B,ee=>ee.releaseLinks(Y),void 0)}registerColorProvider(z,Y,ee){const ae=this._addNewAdapter(new j(this._documents,ee),z);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentColors(z,Y,ee){return this._withAdapter(z,j,ae=>ae.provideColors(_.URI.revive(Y),ee),[])}$provideColorPresentations(z,Y,ee,ae){return this._withAdapter(z,j,me=>me.provideColorPresentations(_.URI.revive(Y),ee,ae),void 0)}registerFoldingRangeProvider(z,Y,ee){const ae=this._nextHandle(),me=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ae(new Q(this._documents,ee),z)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Y),me);let De=this._createDisposable(ae);if(me!==void 0){const Oe=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));De=T.Disposable.from(De,Oe)}return De}$provideFoldingRanges(z,Y,ee,ae){return this._withAdapter(z,Q,me=>me.provideFoldingRanges(_.URI.revive(Y),ee,ae),void 0)}registerSelectionRangeProvider(z,Y,ee){const ae=this._addNewAdapter(new de(this._documents,ee,this._logService),z);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideSelectionRanges(z,Y,ee,ae){return this._withAdapter(z,de,me=>me.provideSelectionRanges(_.URI.revive(Y),ee,ae),[])}registerCallHierarchyProvider(z,Y,ee){const ae=this._addNewAdapter(new be(this._documents,ee),z);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$prepareCallHierarchy(z,Y,ee,ae){return this._withAdapter(z,be,me=>Promise.resolve(me.prepareSession(_.URI.revive(Y),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls(z,Y,ee,ae){return this._withAdapter(z,be,me=>me.provideCallsTo(Y,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls(z,Y,ee,ae){return this._withAdapter(z,be,me=>me.provideCallsFrom(Y,ee,ae),void 0)}$releaseCallHierarchy(z,Y){this._withAdapter(z,be,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,D.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Ce._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Ce._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ce._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ce._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Ce._serializeRegExp(z.beforeText),afterText:z.afterText?Ce._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Ce._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Ce._serializeOnEnterRule)}setLanguageConfiguration(z,Y,ee){let{wordPattern:ae}=ee;if(ae&&(0,D.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Y,ae):this._documents.setWordDefinitionFor(Y,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const me=this._nextHandle(),De={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Ce._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Ce._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Ce._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,Y,De),this._createDisposable(me)}$setWordDefinitions(z){for(const Y of z)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=Ce,Ce._handlePool=0}),define(ge[240],pe([0,1,5,20,7]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(P,D){this._proxy=P.getProxy(_.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,D){await this._proxy.$changeLanguage(P,D);const k=this._documents.getDocumentData(P);if(!k)throw new Error(`document '${P.toString}' NOT found`);return k.document}async tokenAtPosition(P,D){var k;const r=P.version,C=I.Position.from(D),f=await this._proxy.$tokensAtPosition(P.uri,C),p={type:A.StandardTokenType.Other,range:(k=P.getWordRangeAtPosition(D))!==null&&k!==void 0?k:new A.Range(D.line,D.character,D.line,D.character)};if(!f)return p;const a={range:I.Range.to(f.range),type:I.TokenType.to(f.type)};return!a.range.contains(D)||r!==P.version?p:a}}e.ExtHostLanguages=T}),define(ge[241],pe([0,1,5,14,41]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(P){return P&&P.title}let y=class{constructor(D,k){this._logService=k,this._proxy=D.getProxy(_.MainContext.MainThreadMessageService)}showMessage(D,k,r,C,f){const p={extension:D};let a;typeof C=="string"||T(C)?a=[C,...f]:(p.modal=C&&C.modal,p.useCustom=C&&C.useCustom,a=f),p.useCustom&&(0,A.checkProposedApiEnabled)(D);const u=[];for(let E=0;E<a.length;E++){const w=a[E];if(typeof w=="string")u.push({title:w,handle:E,isCloseAffordance:!1});else if(typeof w=="object"){let{title:S,isCloseAffordance:h}=w;u.push({title:S,isCloseAffordance:!!h,handle:E})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(k,r,p,u).then(E=>{if(typeof E=="number")return a[E]})}};y=Ve([xe(1,I.ILogService)],y),e.ExtHostMessageService=y}),define(ge[242],pe([0,1,13,22,21,3,74,72,6,24,9,11,2,86,5,20,7,89,218,219]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E,w,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class c{constructor(s,l){const g=c._Keys.nextId();s.$registerNotebookEditorDecorationType(g,u.NotebookDecorationRenderOptions.from(l)),this.value={key:g,dispose(){s.$removeNotebookEditorDecorationType(g)}}}}e.NotebookEditorDecorationType=c,c._Keys=new P.IdGenerator("NotebookEditorDecorationType");class m{constructor(s,l,g,v,d,b){this._textDocumentsAndEditors=g,this._textDocuments=v,this.logService=d,this._extensionStoragePaths=b,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new T.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new T.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new T.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new T.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new k.ResourceMap,this._statusBarCache=new p.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(a.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(a.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(a.MainContext.MainThreadNotebookEditors),this._commandsConverter=l.converter,l.registerArgumentProcessor({processArgument:R=>{var N;if(R&&R.$mid===12){const q=(N=R.notebookEditor)===null||N===void 0?void 0:N.notebookUri,re=R.cell.handle,V=this._documents.get(q),W=V==null?void 0:V.getCell(re);if(W)return W.apiCell}return R}})}get activeNotebookEditor(){var s;return(s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){return this._editors.get(s)}getIdByEditor(s){for(const[l,g]of this._editors)if(g.apiEditor===s)return l}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(s){return this._documents.get(s)}_getNotebookDocument(s){const l=this._documents.get(s);if(!l)throw new Error(`NO notebook document for '${s}'`);return l}_getProviderData(s){const l=this._notebookContentProviders.get(s);if(!l)throw new Error(`NO provider for '${s}'`);return l}registerNotebookContentProvider(s,l,g,v){var d,b,R;if((0,r.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(l))throw new Error(`Notebook provider for '${l}' already registered`);this._notebookContentProviders.set(l,{extension:s,provider:g});let N;g.onDidChangeNotebookContentOptions&&(N=g.onDidChangeNotebookContentOptions(()=>{const V=u.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(l,V)}));const q=(d=v==null?void 0:v.viewOptions)===null||d===void 0?void 0:d.filenamePattern.map(V=>u.NotebookExclusiveDocumentPattern.from(V)).filter(V=>V!==void 0);((b=v==null?void 0:v.viewOptions)===null||b===void 0?void 0:b.filenamePattern)&&!q&&console.warn(`Notebook content provider view options file name pattern is invalid ${(R=v==null?void 0:v.viewOptions)===null||R===void 0?void 0:R.filenamePattern}`);const re=u.NotebookDocumentContentOptions.from(v);return this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation,description:s.description},l,{transientOutputs:re.transientOutputs,transientCellMetadata:re.transientCellMetadata,transientDocumentMetadata:re.transientDocumentMetadata,viewOptions:(v==null?void 0:v.viewOptions)&&q?{displayName:v.viewOptions.displayName,filenamePattern:q,exclusive:v.viewOptions.exclusive||!1}:void 0}),new E.Disposable(()=>{N==null||N.dispose(),this._notebookContentProviders.delete(l),this._notebookProxy.$unregisterNotebookProvider(l)})}registerNotebookCellStatusBarItemProvider(s,l,g){const v=m._notebookStatusBarItemProviderHandlePool++,d=typeof g.onDidChangeCellStatusBarItems=="function"?m._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(v,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(v,d,l);let b;return d!==void 0&&(b=g.onDidChangeCellStatusBarItems(R=>this._notebookProxy.$emitCellStatusBarEvent(d))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(v),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(v,d),b&&b.dispose()})}createNotebookEditorDecorationType(s){return new c(this._notebookEditorsProxy,s).value}async openNotebookDocument(s){const l=this._documents.get(s);if(l)return l.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenDocument(s),v=this._documents.get(f.URI.revive(g));return(0,C.assertIsDefined)(v==null?void 0:v.apiNotebook)}async showNotebookDocument(s,l){var g;f.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let v;typeof l=="object"?v={position:u.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(u.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:v={preserveFocus:!1};const d=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.viewType,v),b=d&&((g=this._editors.get(d))===null||g===void 0?void 0:g.apiEditor);if(b)return b;throw d?new Error(`Could NOT open editor for "${s.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.toString()}".`)}async $provideNotebookCellStatusBarItems(s,l,g,v){var d;const b=this._notebookStatusBarItemProviders.get(s),R=f.URI.revive(l),N=this._documents.get(R);if(!(!N||!b)){const q=N.getCellFromIndex(g);if(!!q){const re=await b.provideCellStatusBarItems(q.apiCell,v);if(!!re){const V=new D.DisposableStore,W=this._statusBarCache.add([V]),$=(d=re&&re.map(U=>u.NotebookStatusBarItem.from(U,this._commandsConverter,V)))!==null&&d!==void 0?d:void 0;return{cacheId:W,items:$}}}}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,l,g,v){if((0,r.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");const d=this._handlePool++;this._notebookSerializer.set(d,g);const b=u.NotebookDocumentContentOptions.from(v);return this._notebookProxy.$registerNotebookSerializer(d,{id:s.identifier,location:s.extensionLocation,description:s.description},l,b),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(d)})}async $dataToNotebook(s,l,g){const v=this._notebookSerializer.get(s);if(!v)throw new Error("NO serializer found");const d=await v.deserializeNotebook(l.buffer,g);return{metadata:u.NotebookDocumentMetadata.from(d.metadata),cells:d.cells.map(u.NotebookCellData.from)}}async $notebookToData(s,l,g){const v=this._notebookSerializer.get(s);if(!v)throw new Error("NO serializer found");const d=await v.serializeNotebook({metadata:u.NotebookDocumentMetadata.to(l.metadata),cells:l.cells.map(u.NotebookCellData.to)},g);return I.VSBuffer.wrap(d)}cancelOneNotebookCellExecution(s){const l=this._activeExecutions.get(s.uri);l==null||l.cancel()}async $openNotebook(s,l,g,v,d){const{provider:b}=this._getProviderData(s),R=await b.openNotebook(f.URI.revive(l),{backupId:g,untitledDocumentData:v==null?void 0:v.buffer},d);return{metadata:u.NotebookDocumentMetadata.from(R.metadata),cells:R.cells.map(u.NotebookCellData.from)}}async $saveNotebook(s,l,g){const v=this._getNotebookDocument(f.URI.revive(l)),{provider:d}=this._getProviderData(s);return await d.saveNotebook(v.apiNotebook,g),!0}async $saveNotebookAs(s,l,g,v){const d=this._getNotebookDocument(f.URI.revive(l)),{provider:b}=this._getProviderData(s);return await b.saveNotebookAs(f.URI.revive(g),d.apiNotebook,v),!0}async $backupNotebook(s,l,g){var v;const d=this._getNotebookDocument(f.URI.revive(l)),b=this._getProviderData(s),R=(v=this._extensionStoragePaths.workspaceValue(b.extension))!==null&&v!==void 0?v:this._extensionStoragePaths.globalValue(b.extension),N=String((0,y.hash)([d.uri.toString(),this._backupIdPool++])),q=f.URI.joinPath(R,N),re=await b.provider.backupNotebook(d.apiNotebook,{destination:q},g);return d.updateBackup(re),re.id}$acceptModelChanged(s,l,g){this._getNotebookDocument(f.URI.revive(s)).acceptModelChanged(l,g)}$acceptDirtyStateChanged(s,l){const g=this._getNotebookDocument(f.URI.revive(s));g.acceptModelChanged({rawEvents:[],versionId:g.apiNotebook.version},l)}$acceptModelSaved(s){const l=this._getNotebookDocument(f.URI.revive(s));this._onDidSaveNotebookDocument.fire(l.apiNotebook)}$acceptEditorPropertiesChanged(s,l){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",s,l);const g=this._editors.get(s);if(!g)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);l.visibleRanges&&g._acceptVisibleRanges(l.visibleRanges.ranges.map(u.NotebookRange.to)),l.selections&&g._acceptSelections(l.selections.selections.map(u.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:g.apiEditor,visibleRanges:g.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:g.apiEditor,selections:g.apiEditor.selections}))}$acceptEditorViewColumns(s){for(const l in s){const g=this._editors.get(l);if(!g)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);g._acceptViewColumn(u.ViewColumn.to(s[l]))}}$acceptDocumentPropertiesChanged(s,l){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",s.path,l);const g=this._getNotebookDocument(f.URI.revive(s));g.acceptDocumentPropertiesChanged(l),l.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:g.apiNotebook})}_createExtHostEditor(s,l,g){if(this._editors.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const v=new h.ExtHostNotebookEditor(l,this._notebookEditorsProxy,s,g.visibleRanges.map(u.NotebookRange.to),g.selections.map(u.NotebookRange.to),typeof g.viewColumn=="number"?u.ViewColumn.to(g.viewColumn):void 0);this._editors.set(l,v)}$acceptDocumentAndEditorsDelta(s){var l,g,v;if(s.removedDocuments)for(const b of s.removedDocuments){const R=f.URI.revive(b),N=this._documents.get(R);N&&(N.dispose(),this._documents.delete(R),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:N.apiNotebook.getCells().map(q=>q.document.uri)}),this._onDidCloseNotebookDocument.fire(N.apiNotebook));for(const q of this._editors.values())q.notebookData.uri.toString()===R.toString()&&this._editors.delete(q.id)}if(s.addedDocuments){const b=[];for(const R of s.addedDocuments){const N=f.URI.revive(R.uri),q=R.viewType;if(this._documents.has(N))throw new Error(`adding EXISTING notebook ${N} `);const re=this,V=new S.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(W){re._onDidChangeNotebookCells.fire(W)},emitCellOutputsChange(W){re._onDidChangeCellOutputs.fire(W)},emitCellMetadataChange(W){re._onDidChangeCellMetadata.fire(W)},emitCellExecutionStateChange(W){re._onDidChangeCellExecutionState.fire(W)}},q,R.metadata?u.NotebookDocumentMetadata.to(R.metadata):new E.NotebookDocumentMetadata,N);V.acceptModelChanged({versionId:R.versionId,rawEvents:[{kind:w.NotebookCellsChangeType.Initialize,changes:[[0,0,R.cells]]}]},!1),b.push(...R.cells.map(W=>S.ExtHostCell.asModelAddData(V.apiNotebook,W))),(l=this._documents.get(N))===null||l===void 0||l.dispose(),this._documents.set(N,V),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this._onDidOpenNotebookDocument.fire(V.apiNotebook)}}if(s.addedEditors)for(const b of s.addedEditors){if(this._editors.has(b.id))return;const R=f.URI.revive(b.documentUri),N=this._documents.get(R);N&&this._createExtHostEditor(N,b.id,b)}const d=[];if(s.removedEditors)for(const b of s.removedEditors){const R=this._editors.get(b);R&&(this._editors.delete(b),((g=this._activeNotebookEditor)===null||g===void 0?void 0:g.id)===R.id&&(this._activeNotebookEditor=void 0),d.push(R))}if(s.visibleEditors){this._visibleNotebookEditors=s.visibleEditors.map(R=>this._editors.get(R)).filter(R=>!!R);const b=new Set;this._visibleNotebookEditors.forEach(R=>b.add(R.id));for(const R of this._editors.values()){const N=b.has(R.id);R._acceptVisibility(N)}this._visibleNotebookEditors=[...this._editors.values()].map(R=>R).filter(R=>R.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.newActiveEditor===null?this._activeNotebookEditor=void 0:s.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.newActiveEditor)),s.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((v=this._activeNotebookEditor)===null||v===void 0?void 0:v.apiEditor)}createNotebookCellExecution(s,l,g){const v=this.lookupNotebookDocument(s);if(!v)throw new Error(`Invalid uri: ${s} `);const d=v.getCellFromIndex(l);if(!d)throw new Error(`Invalid cell index: ${s}, ${l} `);if(this._activeExecutions.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const b=new n(s,v,d,this._notebookDocumentsProxy);this._activeExecutions.set(d.uri,b);const R=b.onDidChangeState(()=>{b.state===t.Resolved&&(b.dispose(),R.dispose(),this._activeExecutions.delete(d.uri))});return b.asApiObject()}}e.ExtHostNotebookController=m,m._notebookStatusBarItemProviderHandlePool=0;var t;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(t||(t={}));class n extends D.Disposable{constructor(s,l,g,v){super();this._uri=s,this._document=l,this._cell=g,this._proxy=v,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new A.CancellationTokenSource),this._collector=new o(10,d=>this.applyEdits(d)),this._executionOrder=g.internalMetadata.executionOrder,this.mixinMetadata({runState:E.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(s){await this._collector.addItem(s)}async applyEdits(s){return this._proxy.$applyEdits(this._uri,s,!1)}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(s){const l={editType:8,handle:this._cell.handle,metadata:s};this.applyEdits([l])}cellIndexToHandle(s){const l=typeof s=="number"?this._document.getCellFromIndex(s):this._cell;if(!!l)return l.handle}asApiObject(){const s=this;return Object.freeze({get document(){return s._document.apiNotebook},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(l){s._executionOrder=l,s.mixinMetadata({executionOrder:l})},start(l){var g;if(s._state===t.Resolved||s._state===t.Started)throw new Error("Cannot call start again");s._state=t.Started,s._onDidChangeState.fire(),s.mixinMetadata({runState:E.NotebookCellExecutionState.Executing,runStartTime:(g=l==null?void 0:l.startTime)!==null&&g!==void 0?g:null})},end(l){var g,v;if(s._state===t.Resolved)throw new Error("Cannot call resolve twice");s._state=t.Resolved,s._onDidChangeState.fire(),s.mixinMetadata({runState:E.NotebookCellExecutionState.Idle,lastRunSuccess:(g=l==null?void 0:l.success)!==null&&g!==void 0?g:null,runEndTime:(v=l==null?void 0:l.endTime)!==null&&v!==void 0?v:null})},clearOutput(l){return s.verifyStateForOutput(),this.replaceOutput([],l)},async appendOutput(l,g){s.verifyStateForOutput();const v=s.cellIndexToHandle(g);if(typeof v=="number")return l=Array.isArray(l)?l:[l],s.applyEditSoon({editType:2,handle:v,append:!0,outputs:l.map(u.NotebookCellOutput.from)})},async replaceOutput(l,g){s.verifyStateForOutput();const v=s.cellIndexToHandle(g);if(typeof v=="number")return l=Array.isArray(l)?l:[l],s.applyEditSoon({editType:2,handle:v,outputs:l.map(u.NotebookCellOutput.from)})},async appendOutputItems(l,g){return s.verifyStateForOutput(),l=Array.isArray(l)?l:[l],s.applyEditSoon({editType:7,append:!0,items:l.map(u.NotebookCellOutputItem.from),outputId:g})},async replaceOutputItems(l,g){return s.verifyStateForOutput(),l=Array.isArray(l)?l:[l],s.applyEditSoon({editType:7,items:l.map(u.NotebookCellOutputItem.from),outputId:g})},token:s._tokenSource.token})}}class o{constructor(s,l){this.delay=s,this.callback=l,this.batch=[]}addItem(s){return this.batch.push(s),this.waitPromise||(this.waitPromise=(0,_.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const l=this.batch;return this.batch=[],this.callback(l)})),this.waitPromise}}}),define(ge[243],pe([0,1,3,6,5,27,2,20,88]),function(G,e,_,I,A,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class k{constructor(C,f,p){this._initData=f,this._extHostNotebook=p,this._kernelData=new Map,this._handlePool=0,this._proxy=C.getProxy(A.MainContext.MainThreadNotebookKernels)}createNotebookController(C,f,p,a,u,E){for(let d of this._kernelData.values())if(d.controller.id===f&&T.ExtensionIdentifier.equals(C.identifier,d.extensionId))throw new Error(`notebook controller with id '${f}' ALREADY exist`);const w=this._handlePool++,S=this,h=()=>console.warn(`NO execute handler from notebook controller '${o.id}' of extension: '${C.identifier}'`);let c=!1;const m=new I.DisposableStore,t=new _.Emitter,n=new _.Emitter,o={id:`${C.identifier.value}/${f}`,viewType:p,extensionId:C.identifier,extensionLocation:C.extensionLocation,label:a||C.identifier.value,preloads:E?E.map(P.NotebookKernelPreload.from):[]};let i=u!=null?u:h,s;this._proxy.$addKernel(w,o).catch(d=>{console.log(d),c=!0});let l=0;const g=()=>{if(!c){const d=++l;Promise.resolve().then(()=>{d===l&&this._proxy.$updateKernel(w,o)})}},v={get id(){return f},get viewType(){return o.viewType},onDidChangeNotebookAssociation:t.event,get label(){return o.label},set label(d){var b;o.label=(b=d!=null?d:C.displayName)!==null&&b!==void 0?b:C.name,g()},get detail(){var d;return(d=o.detail)!==null&&d!==void 0?d:""},set detail(d){o.detail=d,g()},get description(){var d;return(d=o.description)!==null&&d!==void 0?d:""},set description(d){o.description=d,g()},get supportedLanguages(){return o.supportedLanguages},set supportedLanguages(d){o.supportedLanguages=d,g()},get hasExecutionOrder(){var d;return(d=o.hasExecutionOrder)!==null&&d!==void 0?d:!1},set hasExecutionOrder(d){o.hasExecutionOrder=d,g()},get preloads(){return o.preloads?o.preloads.map(P.NotebookKernelPreload.to):[]},get executeHandler(){return i},set executeHandler(d){i=d!=null?d:h},get interruptHandler(){return s},set interruptHandler(d){s=d,o.supportsInterrupt=Boolean(d),g()},createNotebookCellExecutionTask(d){if(c)throw new Error("notebook controller is DISPOSED");return S._extHostNotebook.createNotebookCellExecution(d.notebook.uri,d.index,o.id)},dispose:()=>{c||(c=!0,this._kernelData.delete(w),m.dispose(),t.dispose(),n.dispose(),this._proxy.$removeKernel(w))},onDidReceiveMessage:n.event,postMessage(d,b){return S._proxy.$postMessage(w,b&&S._extHostNotebook.getIdByEditor(b),d)},asWebviewUri(d){return(0,D.asWebviewUri)(S._initData.environment,String(w),d)},updateNotebookAffinity(d,b){S._proxy.$updateNotebookPriority(w,d.uri,b)}};return this._kernelData.set(w,{extensionId:C.identifier,controller:v,onDidChangeSelection:t,onDidReceiveMessage:n}),v}$acceptSelection(C,f,p){const a=this._kernelData.get(C);a&&a.onDidChangeSelection.fire({selected:p,notebook:this._extHostNotebook.lookupNotebookDocument(y.URI.revive(f)).apiNotebook})}async $executeCells(C,f,p){const a=this._kernelData.get(C);if(!!a){const u=this._extHostNotebook.lookupNotebookDocument(y.URI.revive(f));if(!u)throw new Error("MISSING notebook");const E=[];for(let w of p){const S=u.getCell(w);S&&E.push(S.apiCell)}try{await a.controller.executeHandler.call(a.controller,E,u.apiNotebook,a.controller)}catch(w){console.error(w)}}}async $cancelCells(C,f,p){const a=this._kernelData.get(C);if(!!a){const u=this._extHostNotebook.lookupNotebookDocument(y.URI.revive(f));if(!u)throw new Error("MISSING notebook");a.controller.interruptHandler&&await a.controller.interruptHandler.call(a.controller,u.apiNotebook);for(let E of p){const w=u.getCell(E);w&&this._extHostNotebook.cancelOneNotebookCellExecution(w)}}}$acceptRendererMessage(C,f,p){const a=this._kernelData.get(C);if(!!a){const u=this._extHostNotebook.getEditorById(f);if(!u)throw new Error(`send message for UNKNOWN editor: ${f}`);a.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:p}))}}}e.ExtHostNotebookKernels=k}),define(ge[64],pe([0,1,5,3,6,22,4,15]),function(G,e,_,I,A,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends A.Disposable{constructor(a,u,E,w){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=w,this._id=w.$register(this.name,u,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?T.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(u=>this._proxy.$clear(u,a))}show(a,u){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof a=="boolean"?a:u)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class k extends D{constructor(a,u){super(a,!1,void 0,u)}append(a){super.append(a),this._id.then(u=>this._proxy.$append(u,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class r extends D{constructor(a,u,E){super(a,!0,u,E)}append(a){throw new Error("Not supported")}}class C{constructor(a,u){this.name=a,this._channel=u}append(a){this._channel.then(u=>u.append(a))}appendLine(a){this._channel.then(u=>u.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,u){this._channel.then(E=>E.show(a,u))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=C;let f=class{constructor(a){this._proxy=a.getProxy(_.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new k(a,this._proxy)}createOutputChannelFromLogFile(a,u){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!u)throw new Error("illegal argument `file`. must not be falsy");return new r(a,u,this._proxy)}};f=Ve([xe(0,P.IExtHostRpcService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(ge[244],pe([0,1,13,21,3,6,5,2,7,16,17,57]),function(G,e,_,I,A,T,y,P,D,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(p,a,u){const E=p.getProxy(y.MainContext.MainThreadQuickOpen);class w{constructor(i,s){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=s}showQuickPick(i,s,l,g=I.CancellationToken.None){this._onDidSelectItem=void 0;const v=Promise.resolve(i),d=++this._instances,b=E.$show(d,{title:l==null?void 0:l.title,placeHolder:l==null?void 0:l.placeHolder,matchOnDescription:l==null?void 0:l.matchOnDescription,matchOnDetail:l==null?void 0:l.matchOnDetail,ignoreFocusLost:l==null?void 0:l.ignoreFocusOut,canPickMany:l==null?void 0:l.canPickMany},g),R={},N=b.then(()=>R);return Promise.race([N,v]).then(q=>{if(q!==R)return v.then(re=>{const V=[];for(let W=0;W<re.length;W++){const $=re[W];let U,F,M,L,O;typeof $=="string"?U=$:(U=$.label,F=$.description,M=$.detail,L=$.picked,O=$.alwaysShow),V.push({label:U,description:F,handle:W,detail:M,picked:L,alwaysShow:O})}return l&&typeof l.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{l.onDidSelectItem(re[W])}),E.$setItems(d,V),b.then(W=>{if(typeof W=="number")return re[W];if(Array.isArray(W))return W.map($=>re[$])})})}).then(void 0,q=>{if(!(0,k.isPromiseCanceledError)(q))return E.$setError(d,q),Promise.reject(q)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,s=I.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,E.$input(i,typeof this._validateInput=="function",s).then(void 0,l=>{if(!(0,k.isPromiseCanceledError)(l))return Promise.reject(l)})}$validateInput(i){return this._validateInput?(0,_.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,s=I.CancellationToken.None){const l=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!!l){const g=await this._workspace.getWorkspaceFolders2();if(!!g)return g.find(v=>v.uri.toString()===l.uri.toString())}}createQuickPick(i,s){const l=new t(i,s,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}createInputBox(i){const s=new n(i,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}$onDidChangeValue(i,s){const l=this._sessions.get(i);l&&l._fireDidChangeValue(s)}$onDidAccept(i){const s=this._sessions.get(i);s&&s._fireDidAccept()}$onDidChangeActive(i,s){const l=this._sessions.get(i);l instanceof t&&l._fireDidChangeActive(s)}$onDidChangeSelection(i,s){const l=this._sessions.get(i);l instanceof t&&l._fireDidChangeSelection(s)}$onDidTriggerButton(i,s){const l=this._sessions.get(i);l&&l._fireDidTriggerButton(s)}$onDidHide(i){const s=this._sessions.get(i);s&&s._fireDidHide()}}class S{constructor(i,s){this._extensionId=i,this._onDidDispose=s,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((s,l)=>{const g=s===D.QuickInputButtons.Back?-1:l;this._handlesToButtons.set(g,s)}),this.update({buttons:i.map((s,l)=>({iconPath:h(s.iconPath),tooltip:s.tooltip,handle:s===D.QuickInputButtons.Back?-1:l}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const s=this._handlesToButtons.get(i);s&&this._onDidTriggerButtonEmitter.fire(s)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(i){if(!this._disposed){for(const s of Object.keys(i)){const l=i[s];this._pendingUpdate[s]=l===void 0?null:l}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function h(o){if(o instanceof D.ThemeIcon)return{id:o.id};const i=m(o),s=c(o);return{dark:typeof i=="string"?P.URI.file(i):i,light:typeof s=="string"?P.URI.file(s):s}}function c(o){return typeof o=="object"&&"light"in o?o.light:o}function m(o){return typeof o=="object"&&"dark"in o?o.dark:o}class t extends S{constructor(i,s,l){super(i,l);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((s,l)=>{this._handlesToItems.set(l,s),this._itemsToHandles.set(s,l)}),this.update({items:i.map((s,l)=>({label:s.label,description:s.description,handle:l,detail:s.detail,picked:s.picked,alwaysShow:s.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(s=>this._itemsToHandles.has(s)),this.update({activeItems:this._activeItems.map(s=>this._itemsToHandles.get(s))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(s=>this._itemsToHandles.has(s)),this.update({selectedItems:this._selectedItems.map(s=>this._itemsToHandles.get(s))})}_fireDidChangeActive(i){const s=(0,r.coalesce)(i.map(l=>this._handlesToItems.get(l)));this._activeItems=s,this._onDidChangeActiveEmitter.fire(s)}_fireDidChangeSelection(i){const s=(0,r.coalesce)(i.map(l=>this._handlesToItems.get(l)));this._selectedItems=s,this._onDidChangeSelectionEmitter.fire(s)}}class n extends S{constructor(i,s){super(i,s);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?C.default.Error:C.default.Ignore})}}return new w(a,u)}e.createExtHostQuickOpen=f}),define(ge[245],pe([0,1,2,3,70,6,13,5,17,99,14,27,41]),function(G,e,_,I,A,T,y,P,D,k,r,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(i){if(i)return typeof i.iconPath=="string"?_.URI.file(i.iconPath):i.iconPath}function a(i,s){if(!i.iconPath&&!s.iconPath)return 0;if(i.iconPath){if(!s.iconPath)return 1}else return-1;const l=typeof i.iconPath=="string"?i.iconPath:i.iconPath.fsPath,g=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath;return(0,k.comparePaths)(l,g)}function u(i,s){let l=0;if(i.strikeThrough!==s.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==s.faded)return i.faded?1:-1;if(i.tooltip!==s.tooltip)return(i.tooltip||"").localeCompare(s.tooltip||"");if(l=a(i,s),l!==0)return l;if(i.light&&s.light)l=a(i.light,s.light);else{if(i.light)return 1;if(s.light)return-1}if(l!==0)return l;if(i.dark&&s.dark)l=a(i.dark,s.dark);else{if(i.dark)return 1;if(s.dark)return-1}return l}function E(i,s){if(i.command!==s.command)return i.command<s.command?-1:1;if(i.title!==s.title)return i.title<s.title?-1:1;if(i.tooltip!==s.tooltip){if(i.tooltip!==void 0&&s.tooltip!==void 0)return i.tooltip<s.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(i.arguments===s.arguments)return 0;if(i.arguments)if(s.arguments){if(i.arguments.length!==s.arguments.length)return i.arguments.length-s.arguments.length}else return 1;else return-1;for(let l=0;l<i.arguments.length;l++){const g=i.arguments[l],v=s.arguments[l];if(g!==v)return g<v?-1:1}return 0}function w(i,s){let l=(0,k.comparePaths)(i.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(l!==0)return l;if(i.command&&s.command)l=E(i.command,s.command);else{if(i.command)return 1;if(s.command)return-1}if(l!==0)return l;if(i.decorations&&s.decorations)l=u(i.decorations,s.decorations);else{if(i.decorations)return 1;if(s.decorations)return-1}return l}function S(i,s){for(let l=0;l<i.length;l++)if(i[l]!==s[l])return!1;return!0}function h(i,s){return i.command===s.command&&i.title===s.title&&i.tooltip===s.tooltip&&(i.arguments&&s.arguments?S(i.arguments,s.arguments):i.arguments===s.arguments)}function c(i,s){return(0,D.equals)(i,s,h)}class m{constructor(s,l,g){this._extension=s,this._proxy=l,this._sourceControlHandle=g,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(s){if((0,f.checkProposedApiEnabled)(this._extension),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}focus(){(0,f.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(s,l){(0,f.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,s,l)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=m;class t{constructor(s,l,g,v,d){this._proxy=s,this._commands=l,this._sourceControlHandle=g,this._id=v,this._label=d,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,l){const g=this._resourceStatesCommandsMap.get(s);return g?(0,y.asPromise)(()=>this._commands.executeCommand(g.command,...g.arguments||[],l)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var s;const l=[...this._resourceStates].sort(w),v=(0,D.sortedDiff)(this._resourceSnapshot,l,w).map(R=>{const N=R.toInsert.map(q=>{const re=this._resourceHandlePool++;this._resourceStatesMap.set(re,q);const V=q.resourceUri,W=p(q.decorations),$=q.decorations&&p(q.decorations.light)||W,U=q.decorations&&p(q.decorations.dark)||W,F=[];let M;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"){const de=new T.DisposableStore;M=this._commands.converter.toInternal(q.command,de),this._resourceStatesDisposablesMap.set(re,de)}else this._resourceStatesCommandsMap.set(re,q.command);$&&F.push($),U&&U.toString()!==($==null?void 0:$.toString())&&F.push(U);const L=q.decorations&&q.decorations.tooltip||"",O=q.decorations&&!!q.decorations.strikeThrough,B=q.decorations&&!!q.decorations.faded,j=q.contextValue||"";return{rawResource:[re,V,F,L,O,B,j,M],handle:re}});return{start:R.start,deleteCount:R.deleteCount,toInsert:N}}),d=v.map(({start:R,deleteCount:N,toInsert:q})=>[R,N,q.map(re=>re.rawResource)]),b=v.reverse();for(const{start:R,deleteCount:N,toInsert:q}of b){const re=q.map(W=>W.handle),V=this._handlesSnapshot.splice(R,N,...re);for(const W of V)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),(s=this._resourceStatesDisposablesMap.get(W))===null||s===void 0||s.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=l,d}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(s,l,g,v,d,b){this._proxy=l,this._commands=g,this._id=v,this._label=d,this._rootUri=b,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new m(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,v,d,b)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=s;const l=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:l})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(!(this._statusBarCommands&&s&&c(this._statusBarCommands,s))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=s;const l=(s||[]).map(g=>this._commands.converter.toInternal(g,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:l})}}get selected(){return this._selected}createResourceGroup(s,l){const g=new t(this._proxy,this._commands,this.handle,s,l),v=I.Event.once(g.onDidDispose)(()=>this.createdResourceGroups.delete(g));return this.createdResourceGroups.set(g,v),this.eventuallyAddResourceGroups(),g}eventuallyAddResourceGroups(){const s=[],l=[];for(const[g,v]of this.createdResourceGroups){v.dispose();const d=g.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(g),this.eventuallyUpdateResourceStates()});I.Event.once(g.onDidDispose)(()=>{this.updatedResourceGroups.delete(g),d.dispose(),this._groups.delete(g.handle),this._proxy.$unregisterGroup(this.handle,g.handle)}),s.push([g.handle,g.id,g.label,g.features]);const b=g._takeResourceStateSnapshot();b.length>0&&l.push([g.handle,b]),this._groups.set(g.handle,g)}this._proxy.$registerGroups(this.handle,s,l),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(l=>{const g=l._takeResourceStateSnapshot();g.length!==0&&s.push([l.handle,g])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([(0,A.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([(0,A.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let o=class Nn{constructor(s,l,g){this._commands=l,this.logService=g,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=s.getProxy(P.MainContext.MainThreadSCM),this._telemetry=s.getProxy(P.MainContext.MainThreadTelemetry),l.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===3){const d=this._sourceControls.get(v.sourceControlHandle);if(!d)return v;const b=d.getResourceGroup(v.groupHandle);return b?b.getResourceState(v.handle):v}else if(v&&v.$mid===4){const d=this._sourceControls.get(v.sourceControlHandle);return d?d.getResourceGroup(v.groupHandle):v}else if(v&&v.$mid===5){const d=this._sourceControls.get(v.handle);return d||v}return v}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,l,g,v){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,l,g,v),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const d=Nn._handlePool++,b=new n(s,this._proxy,this._commands,l,g,v);this._sourceControls.set(d,b);const R=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(s.identifier))||[];return R.push(b),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(s.identifier),R),b}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const l=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(s.identifier)),g=l&&l[l.length-1];return g&&g.inputBox}$provideOriginalResource(s,l,g){const v=_.URI.revive(l);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,v.toString());const d=this._sourceControls.get(s);return!d||!d.quickDiffProvider||!d.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>d.quickDiffProvider.provideOriginalResource(v,g)).then(b=>b||null)}$onInputBoxValueChange(s,l){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const g=this._sourceControls.get(s);return g&&g.inputBox.$onInputBoxValueChange(l),Promise.resolve(void 0)}$executeResourceCommand(s,l,g,v){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,l,g);const d=this._sourceControls.get(s);if(!d)return Promise.resolve(void 0);const b=d.getResourceGroup(l);return b?b.$executeResourceCommand(g,v):Promise.resolve(void 0)}$validateInput(s,l,g){this.logService.trace("ExtHostSCM#$validateInput",s);const v=this._sourceControls.get(s);return!v||!v.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>v.inputBox.validateInput(l,g)).then(d=>d?Promise.resolve([d.message,d.type]):Promise.resolve(void 0))}$setSelectedSourceControl(s){var l,g;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&((l=this._sourceControls.get(s))===null||l===void 0||l.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((g=this._sourceControls.get(this._selectedSourceControlHandle))===null||g===void 0||g.setSelectionState(!1)),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};o._handlePool=0,o=Ve([xe(2,r.ILogService)],o),e.ExtHostSCM=o});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[246],pe([0,1,7,5,164,6]),function(G,e,_,I,A,T){"use strict";var y,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(f,p,a,u,E=_.StatusBarAlignment.Left,w,S){y.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,tt(this,y,f,"f"),tt(this,P,p,"f"),this._id=D.ID_GEN++,this._statusId=a,this._statusName=u,this._alignment=E,this._priority=w,this._accessibilityInformation=S}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var f;return(f=this._command)===null||f===void 0?void 0:f.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!D.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){var p;((p=this._command)===null||p===void 0?void 0:p.fromApi)!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Ue(this,P,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Ue(this,P,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var f;this._timeoutHandle=void 0;let p=this._color;this._backgroundColor&&(p=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(f=this._command)===null||f===void 0?void 0:f.internal,p,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,P=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(f){this._messages=[],this._item=f.createStatusBarEntry("status.extensionMessage",(0,A.localize)(0,null),_.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const p={message:f};return this._messages.unshift(p),this._update(),new _.Disposable(()=>{const a=this._messages.indexOf(p);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class r{constructor(f,p){this._proxy=f.getProxy(I.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new k(this)}createStatusBarEntry(f,p,a,u,E){return new D(this._proxy,this._commands,f,p,a,u,E)}setStatusBarMessage(f,p){const a=this._statusMessage.setMessage(f);let u;return typeof p=="number"?u=setTimeout(()=>a.dispose(),p):typeof p!="undefined"&&p.then(()=>a.dispose(),()=>a.dispose()),new _.Disposable(()=>{a.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=r}),define(ge[92],pe([0,1,5,3,4]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(P){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,D){this._proxy.$registerExtensionStorageKeysToSync(P,D)}getValue(P,D,k){return this._proxy.$getValue(P,D).then(r=>r||k)}setValue(P,D,k){return this._proxy.$setValue(P,D,k)}$acceptValue(P,D,k){this._onDidChangeStorage.fire({shared:P,key:D,value:k})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,A.createDecorator)("IExtHostStorage")}),define(ge[93],pe([0,1,4,28,14,91,2]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,_.createDecorator)("IExtensionStoragePaths");let P=class{constructor(k,r,C){var f;this._logService=r,this._extHostFileSystem=C,this._workspace=(f=k.workspace)!==null&&f!==void 0?f:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const r=this._workspace.id,C=y.URI.joinPath(this._environment.workspaceStorageHome,r);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(f){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=y.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),C}catch(f){this._logService.error("[ExtHostStorage]",f);return}}workspaceValue(k){if(this._value)return y.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return y.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};P=Ve([xe(0,I.IExtHostInitDataService),xe(1,A.ILogService),xe(2,T.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ge[34],pe([0,1,3,5,4,2,15,6,7,165,16,210,21,30,190]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,A.createDecorator)("IExtHostTerminalService");class u{constructor(t,n,o,i){this._proxy=t,this._id=n,this._creationOptions=o,this._name=i,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(l=>this._pidPromiseComplete=l);const s=this;this.value={get name(){return s._name||""},get processId(){return s._pidPromise},get creationOptions(){return s._creationOptions},get exitStatus(){return s._exitStatus},sendText(l,g=!0){s._checkDisposed(),s._proxy.$sendText(s._id,l,g)},show(l){s._checkDisposed(),s._proxy.$show(s._id,l)},hide(){s._checkDisposed(),s._proxy.$hide(s._id)},dispose(){s._disposed||(s._disposed=!0,s._proxy.$dispose(s._id))},get dimensions(){if(!(s._cols===void 0||s._rows===void 0))return{columns:s._cols,rows:s._rows}}}}async create(t,n,o,i,s,l,g,v,d,b,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:o,env:i,icon:s,initialText:l,waitOnExit:g,strictEnv:v,hideFromUser:d,isFeatureTerminal:b,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=u;class E{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new _.Emitter,this._onProcessTitleChanged=new _.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new _.Emitter,this._onProcessShellTypeChanged=new _.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let w=1,S=class extends P.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this._onDidOpenTerminal=new _.Emitter,this._onDidChangeActiveTerminal=new _.Emitter,this._onDidChangeTerminalDimensions=new _.Emitter,this._proxy=n.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[o,i]of this._terminalProcesses)i.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new u(this._proxy,(0,p.generateUuid)(),t,t.name),o=new E(t.pty);return n.createExtensionTerminal().then(i=>{const s=this._setupExtHostProcessListeners(i,o);this._terminalProcessDisposables[i]=s}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const i=new E(n),s=this._setupExtHostProcessListeners(t,i);this._terminalProcessDisposables[t]=s}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(t);o&&(this._activeTerminal=o,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const o=this._getTerminalById(t);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:n})}async $acceptTerminalDimensions(t,n,o){const i=this._getTerminalById(t);i&&i.setDimensions(n,o)&&this._onDidChangeTerminalDimensions.fire({terminal:i.value,dimensions:i.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,o){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.resize(n,o)}async $acceptTerminalTitleChange(t,n){const o=this._getTerminalById(t);o&&(o.name=n)}async $acceptTerminalClosed(t,n){const o=this._getTerminalObjectIndexById(this._terminals,t);if(o!==null){const i=this._terminals.splice(o,1)[0];i.setExitCode(n),this._onDidCloseTerminal.fire(i.value)}}$acceptTerminalOpened(t,n,o,i){if(n){const g=this._getTerminalObjectIndexById(this._terminals,n);if(g!==null){this._terminals[g]._id=t,this._onDidOpenTerminal.fire(this.terminals[g]),this._terminals[g].isOpen=!0;return}}const s={name:i.name,shellPath:i.executable,shellArgs:i.args,cwd:typeof i.cwd=="string"?i.cwd:T.URI.revive(i.cwd),env:i.env,hideFromUser:i.hideFromUser},l=new u(this._proxy,t,s,o);this._terminals.push(l),this._onDidOpenTerminal.fire(l.value),l.isOpen=!0}async $acceptTerminalProcessId(t,n){const o=this._getTerminalById(t);o&&o._setProcessId(n)}async $startExtensionTerminal(t,n){const o=this._getTerminalById(t);if(!o)return{message:(0,k.localize)(0,null,t)};o.isOpen||await new Promise(s=>{const l=this.onDidOpenTerminal(async g=>{g===o.value&&(l.dispose(),s())})});const i=this._terminalProcesses.get(t);i?i.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const o=new P.DisposableStore;o.add(n.onProcessReady(s=>this._proxy.$sendProcessReady(t,s.pid,s.cwd))),o.add(n.onProcessTitleChanged(s=>this._proxy.$sendProcessTitle(t,s))),this._bufferer.startBuffering(t,n.onProcessData),o.add(n.onProcessExit(s=>this._onProcessExit(t,s))),n.onProcessOverrideDimensions&&o.add(n.onProcessOverrideDimensions(s=>this._proxy.$sendOverrideDimensions(t,s))),this._terminalProcesses.set(t,n);const i=this._extensionTerminalAwaitingStart[t];return i&&n instanceof E&&(n.startSendingEvents(i.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),o}$acceptProcessAckDataEvent(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.input(n)}$acceptProcessResize(t,n,o){var i;try{(i=this._terminalProcesses.get(t))===null||i===void 0||i.resize(n,o)}catch(s){if(s.code!=="EPIPE"&&s.code!=="ERR_IPC_CHANNEL_CLOSED")throw s}}$acceptProcessShutdown(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(t,o))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(o=>this._proxy.$sendProcessCwd(t,o))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const o=this._getTerminalById(t);if(!o)return[];this._terminalLinkCache.delete(t);const i=this._terminalLinkCancellationSource.get(t);i&&i.dispose(!0);const s=new f.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,s);const l=[],g={terminal:o.value,line:n},v=[];for(const R of this._linkProviders)v.push(new Promise(async N=>{s.token.onCancellationRequested(()=>N({provider:R,links:[]}));const q=await R.provideTerminalLinks(g,s.token)||[];s.token.isCancellationRequested||N({provider:R,links:q})}));const d=await Promise.all(v);if(s.token.isCancellationRequested)return[];const b=new Map;for(const R of d)R&&R.links.length>0&&l.push(...R.links.map(N=>{const q={id:w++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return b.set(q.id,{provider:R.provider,link:N}),q}));return this._terminalLinkCache.set(t,b),l}$activateLink(t,n){var o;const i=(o=this._terminalLinkCache.get(t))===null||o===void 0?void 0:o.get(n);!i||i.provider.handleTerminalLink(i.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const o=this._terminalProcessDisposables[t];o&&(o.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const o=this._getTerminalObjectIndexById(t,n);return o!==null?t[o]:null}_getTerminalObjectIndexById(t,n){let o=null;return t.some((i,s)=>i._id===n?(o=s,!0):!1),o}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new h,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const o=(0,C.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const o=n[0],i=new h(n[1]);this._setEnvironmentVariableCollection(o,i)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};S=Ve([xe(1,y.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class h{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const o=this.map.get(t);(!o||o.value!==n.value||o.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((o,i)=>t.call(n,i,o,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=h;let c=class extends S{constructor(t){super(!1,t)}createTerminal(t,n,o){throw new r.NotSupportedError}createTerminalFromOptions(t){throw new r.NotSupportedError}getDefaultShell(t,n){throw new r.NotSupportedError}getDefaultShellArgs(t,n){throw new r.NotSupportedError}$getAvailableProfiles(t){throw new r.NotSupportedError}async $getDefaultShellAndArgs(t){throw new r.NotSupportedError}};c=Ve([xe(0,y.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(ge[247],pe([0,1,3,17,5,124,20,7]),function(G,e,_,I,A,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(r,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new _.Emitter,this._onDidChangeTextEditorOptions=new _.Emitter,this._onDidChangeTextEditorVisibleRanges=new _.Emitter,this._onDidChangeTextEditorViewColumn=new _.Emitter,this._onDidChangeActiveTextEditor=new _.Emitter,this._onDidChangeVisibleTextEditors=new _.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=r.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(f=>this._onDidChangeVisibleTextEditors.fire(f)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(f=>this._onDidChangeActiveTextEditor.fire(f))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(r){const C=this._extHostDocumentsAndEditors.allEditors();return r?C:C.map(f=>f.value)}async showTextDocument(r,C,f){let p;typeof C=="number"?p={position:y.ViewColumn.from(C),preserveFocus:f}:typeof C=="object"?p={position:y.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?y.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:p={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(r.uri,p),u=a&&this._extHostDocumentsAndEditors.getEditor(a);if(u)return u.value;throw a?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}createTextEditorDecorationType(r){return new T.TextEditorDecorationType(this._proxy,r).value}$acceptEditorPropertiesChanged(r,C){const f=this._extHostDocumentsAndEditors.getEditor(r);if(!f)throw new Error("unknown text editor");if(C.options&&f._acceptOptions(C.options),C.selections){const p=C.selections.selections.map(y.Selection.to);f._acceptSelections(p)}if(C.visibleRanges){const p=I.coalesce(C.visibleRanges.map(y.Range.to));f._acceptVisibleRanges(p)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:f.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const p=P.TextEditorSelectionChangeKind.fromValue(C.selections.source),a=C.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:f.value,selections:a,kind:p})}if(C.visibleRanges){const p=I.coalesce(C.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:f.value,visibleRanges:p})}}$acceptEditorPositionData(r){for(const C in r){const f=this._extHostDocumentsAndEditors.getEditor(C);if(!f)throw new Error("Unknown text editor");const p=y.ViewColumn.to(r[C]);f.value.viewColumn!==p&&(f._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:f.value,viewColumn:p}))}}getDiffInformation(r){return Promise.resolve(this._proxy.$getDiffInformation(r))}}e.ExtHostEditors=D});var qt=this&&this.__rest||function(G,e){var _={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(_[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(G);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(G,I[A])&&(_[I[A]]=G[I[A]]);return _};define(ge[248],pe([0,1,2,4,5,6,7]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class P{constructor(r,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=r.getProxy(A.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:f=>{var p,a;if(f&&f.$mid===11){const u=f.uri===void 0?void 0:_.URI.revive(f.uri);return(a=(p=this._itemsBySourceAndUriMap.get(f.source))===null||p===void 0?void 0:p.get(D(u)))===null||a===void 0?void 0:a.get(f.handle)}return f}})}async $getTimeline(r,C,f,p,a){const u=this._providers.get(r);return u==null?void 0:u.provideTimeline(_.URI.revive(C),f,p,a)}registerTimelineProvider(r,C,f,p){const a=new T.DisposableStore,u=this.convertTimelineItem(C.id,p,a).bind(this);let E;C.onDidChange&&(E=C.onDidChange(S=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},S),{id:C.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:r,onDidChange:void 0,async provideTimeline(S,h,c,m){var t;(m==null?void 0:m.resetCache)&&(a.clear(),(t=w.get(C.id))===null||t===void 0||t.clear());const n=await C.provideTimeline(S,h,c);if(n!=null){const o=u(S,m);return Object.assign(Object.assign({},n),{source:C.id,items:n.items.map(o)})}},dispose(){var S;for(const h of w.values())(S=h.get(C.id))===null||S===void 0||S.clear();E==null||E.dispose(),a.dispose()}}))}convertTimelineItem(r,C,f){return(p,a)=>{let u;if(a==null?void 0:a.cacheResults){let E=this._itemsBySourceAndUriMap.get(r);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(r,E));const w=D(p);u=E.get(w),u===void 0&&(u=new Map,E.set(w,u))}return E=>{var w,S;const{iconPath:h}=E,c=qt(E,["iconPath"]),m=`${r}|${(w=E.id)!==null&&w!==void 0?w:E.timestamp}`;u==null||u.set(m,E);let t,n,o;return E.iconPath&&(h instanceof y.ThemeIcon?o={id:h.id}:_.URI.isUri(h)?(t=h,n=h):{light:t,dark:n}=h),Object.assign(Object.assign({},c),{id:(S=c.id)!==null&&S!==void 0?S:void 0,handle:m,source:r,command:E.command?C.toInternal(E.command,f):void 0,icon:t,iconDark:n,themeIcon:o,accessibilityInformation:E.accessibilityInformation})}}}registerTimelineProviderCore(r){if(this._providers.get(r.id))throw new Error(`Timeline Provider ${r.id} already exists.`);return this._proxy.$registerTimelineProvider({id:r.id,label:r.label,scheme:r.scheme}),this._providers.set(r.id,r),(0,T.toDisposable)(()=>{var f;for(const p of this._itemsBySourceAndUriMap.values())(f=p.get(r.id))===null||f===void 0||f.clear();this._providers.delete(r.id),this._proxy.$unregisterTimelineProvider(r.id),r.dispose()})}}e.ExtHostTimeline=P;function D(k){return k==null?void 0:k.toString()}}),define(ge[249],pe([0,1,6,12,2,5]),function(G,e,_,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,k,r,C){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const f=C.schemes.find(p=>!y.supportedSchemes.has(p));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,r),this._proxy.$registerUriOpener(k,C.schemes,D,C.label),(0,_.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(D,k,r){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener with id: ${D}`);const f=A.URI.revive(k);return C.canOpenExternalUri(f,r)}async $openUri(D,k,r){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener id: '${D}'`);return C.openExternalUri(A.URI.revive(k.resolvedUri),{sourceUri:A.URI.revive(k.sourceUri)},r)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(ge[250],pe([0,1,5,2,6,16,27]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(k,r){if(this.handles.has(y.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const C=P.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(k)),this.handlers.set(C,r),this._proxy.$registerUriHandler(C,k),(0,A.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(k)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(k,r){const C=this.handlers.get(k);if(!C)return Promise.resolve(void 0);try{C.handleUri(I.URI.revive(r))}catch(f){(0,T.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(k){return I.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=P,P.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[65],pe([0,1,22,3,2,177,200,88,5]),function(G,e,_,I,A,T,y,P,D){"use strict";var k,r,C,f,p,a,u,E,w,S,h,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(d,b,R,N,q,re,V){k.set(this,void 0),r.set(this,void 0),C.set(this,void 0),f.set(this,void 0),p.set(this,void 0),a.set(this,void 0),u.set(this,""),E.set(this,void 0),w.set(this,!1),S.set(this,!1),h.set(this,!1),this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new I.Emitter),this._onDidDispose=Ue(this,c,"f").event,tt(this,k,d,"f"),tt(this,r,b,"f"),tt(this,E,R,"f"),tt(this,f,N,"f"),tt(this,p,q,"f"),tt(this,a,re,"f"),tt(this,h,t(re),"f"),tt(this,C,V,"f")}dispose(){tt(this,w,!0,"f"),Ue(this,c,"f").fire(),Ue(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return tt(this,S,!0,"f"),(0,P.asWebviewUri)(Ue(this,f,"f"),Ue(this,k,"f"),d)}get cspSource(){return Ue(this,f,"f").webviewCspSource.replace("{{uuid}}",Ue(this,k,"f"))}get html(){return this.assertNotDisposed(),Ue(this,u,"f")}set html(d){this.assertNotDisposed(),Ue(this,u,"f")!==d&&(tt(this,u,d,"f"),!Ue(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(tt(this,S,!0,"f"),Ue(this,C,"f").report("Webview vscode-resource: uris",Ue(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,r,"f").$setHtml(Ue(this,k,"f"),d))}get options(){return this.assertNotDisposed(),Ue(this,E,"f")}set options(d){this.assertNotDisposed(),Ue(this,r,"f").$setOptions(Ue(this,k,"f"),s(Ue(this,a,"f"),Ue(this,p,"f"),d)),tt(this,E,d,"f")}async postMessage(d){if(Ue(this,w,"f"))return!1;const b=n(d,{serializeBuffersForPostMessage:Ue(this,h,"f")});return Ue(this,r,"f").$postMessage(Ue(this,k,"f"),b.message,...b.buffers)}assertNotDisposed(){if(Ue(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,k=new WeakMap,r=new WeakMap,C=new WeakMap,f=new WeakMap,p=new WeakMap,a=new WeakMap,u=new WeakMap,E=new WeakMap,w=new WeakMap,S=new WeakMap,h=new WeakMap,c=new WeakMap;function t(v){if(!v.enableProposedApi)return!1;try{const d=(0,T.normalizeVersion)((0,T.parseVersion)(v.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=56}catch(d){return!1}}e.shouldSerializeBuffersForPostMessage=t;function n(v,d){if(d.serializeBuffersForPostMessage){const b=[],R=(q,re)=>{if(re&&re instanceof ArrayBuffer){let V=b.findIndex(W=>W.original===re);if(V===-1){const W=new Uint8Array(re),$=_.VSBuffer.wrap(W);V=b.length,b.push({original:re,vsBuffer:$})}return{$$vscode_array_buffer_reference$$:!0,index:V}}return re};return{message:JSON.stringify(v,R),buffers:b.map(q=>q.vsBuffer)}}else return{message:JSON.stringify(v),buffers:[]}}e.serializeMessage=n;class o{constructor(d,b,R,N,q){this.initData=b,this.workspace=R,this._logService=N,this._deprecationService=q,this._webviews=new Map,this._webviewProxy=d.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(d,b,...R){const N=this.getWebview(d);if(N){const{message:q}=(0,y.deserializeWebviewMessage)(b,R);N._onMessageEmitter.fire(q)}}$onMissingCsp(d,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,b,R){const N=new m(d,this._webviewProxy,l(b),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(d,N),N._onDidDispose(()=>{this._webviews.delete(d)}),N}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=o;function i(v){return{id:v.identifier,location:v.extensionLocation}}e.toExtensionData=i;function s(v,d,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||g(v,d)}}e.serializeWebviewOptions=s;function l(v){var d;return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,portMapping:v.portMapping,localResourceRoots:(d=v.localResourceRoots)===null||d===void 0?void 0:d.map(b=>A.URI.from(b))}}e.reviveOptions=l;function g(v,d){return[...((d==null?void 0:d.getWorkspaceFolders())||[]).map(b=>b.uri),v.extensionLocation]}}),define(ge[251],pe([0,1,21,74,6,12,25,2,20,65,86,5,7]),function(G,e,_,I,A,T,y,P,D,k,r,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new r.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class a{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,o){const i=this.key(t,n.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const s=new p(n,o);return this._documents.set(i,s),s}delete(t,n){const o=this.key(t,n.uri);this._documents.delete(o)}key(t,n){return`${t}@@@${n}`}}var u;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(u||(u={}));class E{constructor(){this._providers=new Map}addTextProvider(t,n,o){return this.add(0,t,n,o)}addCustomProvider(t,n,o){return this.add(1,t,n,o)}get(t){return this._providers.get(t)}add(t,n,o,i){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:o,provider:i}),new f.Disposable(()=>this._providers.delete(n))}}class w{constructor(t,n,o,i,s){this._extHostDocuments=n,this._extensionStoragePaths=o,this._extHostWebview=i,this._extHostWebviewPanels=s,this._editorProviders=new E,this._documents=new a,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,o,i){const s=new A.DisposableStore;return S(o)?(s.add(this._editorProviders.addTextProvider(n,t,o)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),n,i.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(s.add(this._editorProviders.addCustomProvider(n,t,o)),this.supportEditing(o)&&s.add(o.onDidChangeCustomDocument(l=>{const g=this.getCustomDocumentEntry(n,l.document.uri);if(h(l)){const v=g.addEdit(l);this._proxy.$onDidEdit(l.document.uri,n,v,l.label)}else this._proxy.$onContentChange(l.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),n,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),f.Disposable.from(s,new f.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,o,i,s){var l;const g=this._editorProviders.get(n);if(!g)throw new Error(`No provider found for '${n}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${n}'`);const v=P.URI.revive(t),d=await g.provider.openCustomDocument(v,{backupId:o,untitledDocumentData:i==null?void 0:i.buffer},s);let b;return this.supportEditing(g.provider)&&this._extensionStoragePaths&&(b=(l=this._extensionStoragePaths.workspaceValue(g.extension))!==null&&l!==void 0?l:this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(n,d,b),{editable:this.supportEditing(g.provider)}}async $disposeCustomDocument(t,n){const o=this._editorProviders.get(n);if(!o)throw new Error(`No provider found for '${n}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${n}'`);const i=P.URI.revive(t),{document:s}=this.getCustomDocumentEntry(n,i);this._documents.delete(n,s),s.dispose()}async $resolveWebviewEditor(t,n,o,i,s,l){const g=this._editorProviders.get(o);if(!g)throw new Error(`No provider found for '${o}'`);const v=D.ViewColumn.to(s),d=this._extHostWebview.createNewWebview(n,i.webviewOptions,g.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(n,o,i.title,v,i.panelOptions,d),R=P.URI.revive(t);switch(g.type){case 1:{const{document:N}=this.getCustomDocumentEntry(o,R);return g.provider.resolveCustomEditor(N,b,l)}case 0:{const N=this._extHostDocuments.getDocument(R);return g.provider.resolveCustomTextEditor(N,b,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,o){this.getCustomDocumentEntry(n,t).disposeEdits(o)}async $onMoveCustomEditor(t,n,o){const i=this._editorProviders.get(o);if(!i)throw new Error(`No provider found for '${o}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const l=P.URI.revive(n),g=this._extHostDocuments.getDocument(l);await i.provider.moveCustomTextEditor(g,s,_.CancellationToken.None)}async $undo(t,n,o,i){return this.getCustomDocumentEntry(n,t).undo(o,i)}async $redo(t,n,o,i){return this.getCustomDocumentEntry(n,t).redo(o,i)}async $revert(t,n,o){const i=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(i.document,o),i.disposeBackup()}async $onSave(t,n,o){const i=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(i.document,o),i.disposeBackup()}async $onSaveAs(t,n,o,i){const s=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(s.document,P.URI.revive(o),i)}async $backup(t,n,o){const i=this.getCustomDocumentEntry(n,t),l=await this.getCustomEditorProvider(n).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},o);return i.updateBackup(l),l.id}getCustomDocumentEntry(t,n){const o=this._documents.get(t,P.URI.revive(n));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const n=this._editorProviders.get(t),o=n==null?void 0:n.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function S(m){return typeof m.resolveCustomTextEditor=="function"}function h(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function c(m){const t=m.scheme===T.Schemas.file||m.scheme===T.Schemas.untitled?m.fsPath:m.toString();return(0,I.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[252],pe([0,1,3,6,2,30,20,65,5,7]),function(G,e,_,I,A,T,y,P,D,k){"use strict";var r,C,f,p,a,u,E,w,S,h,c,m,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends I.Disposable{constructor(l,g,v,d,b,R,N){super();r.set(this,void 0),C.set(this,void 0),f.set(this,void 0),p.set(this,void 0),a.set(this,void 0),u.set(this,void 0),E.set(this,void 0),w.set(this,void 0),S.set(this,!0),h.set(this,!0),c.set(this,!1),m.set(this,this._register(new _.Emitter)),this.onDidDispose=Ue(this,m,"f").event,t.set(this,this._register(new _.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,tt(this,r,l,"f"),tt(this,C,g,"f"),tt(this,f,v,"f"),tt(this,a,R,"f"),tt(this,w,b,"f"),tt(this,u,d,"f"),tt(this,p,N,"f")}dispose(){Ue(this,c,"f")||(tt(this,c,!0,"f"),Ue(this,m,"f").fire(),Ue(this,C,"f").$disposeWebview(Ue(this,r,"f")),Ue(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,p,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,f,"f")}get title(){return this.assertNotDisposed(),Ue(this,u,"f")}set title(l){this.assertNotDisposed(),Ue(this,u,"f")!==l&&(tt(this,u,l,"f"),Ue(this,C,"f").$setTitle(Ue(this,r,"f"),l))}get iconPath(){return this.assertNotDisposed(),Ue(this,E,"f")}set iconPath(l){this.assertNotDisposed(),Ue(this,E,"f")!==l&&(tt(this,E,l,"f"),Ue(this,C,"f").$setIconPath(Ue(this,r,"f"),A.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Ue(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,w,"f")=="number"&&Ue(this,w,"f")<0))return Ue(this,w,"f")}get active(){return this.assertNotDisposed(),Ue(this,h,"f")}get visible(){return this.assertNotDisposed(),Ue(this,S,"f")}_updateViewState(l){Ue(this,c,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(tt(this,h,l.active,"f"),tt(this,S,l.visible,"f"),tt(this,w,l.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(l,g){this.assertNotDisposed(),Ue(this,C,"f").$reveal(Ue(this,r,"f"),{viewColumn:l?y.ViewColumn.from(l):void 0,preserveFocus:!!g})}assertNotDisposed(){if(Ue(this,c,"f"))throw new Error("Webview is disposed")}}r=new WeakMap,C=new WeakMap,f=new WeakMap,p=new WeakMap,a=new WeakMap,u=new WeakMap,E=new WeakMap,w=new WeakMap,S=new WeakMap,h=new WeakMap,c=new WeakMap,m=new WeakMap,t=new WeakMap;class o{constructor(l,g,v){this.webviews=g,this.workspace=v,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(l,g,v,d,b={}){const R=typeof d=="object"?d.viewColumn:d,N={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof d=="object"&&!!d.preserveFocus},q=(0,P.shouldSerializeBuffersForPostMessage)(l),re=o.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(l),re,g,{title:v,panelOptions:i(b),webviewOptions:(0,P.serializeWebviewOptions)(l,this.workspace,b),serializeBuffersForPostMessage:q},N);const V=this.webviews.createNewWebview(re,b,l);return this.createNewWebviewPanel(re,g,v,R,b,V)}$onDidChangeWebviewPanelViewStates(l){const g=Object.keys(l);g.sort((v,d)=>{const b=l[v],R=l[d];return b.active?1:R.active?-1:+b.visible-+R.visible});for(const v of g){const d=this.getWebviewPanel(v);if(!!d){const b=l[v];d._updateViewState({active:b.active,visible:b.visible,viewColumn:y.ViewColumn.to(b.position)})}}}async $onDidDisposeWebviewPanel(l){const g=this.getWebviewPanel(l);g==null||g.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,g,v){if(this._serializers.has(g))throw new Error(`Serializer for '${g}' already registered`);return this._serializers.set(g,{serializer:v,extension:l}),this._proxy.$registerSerializer(g,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(l)}),new k.Disposable(()=>{this._serializers.delete(g),this._proxy.$unregisterSerializer(g)})}async $deserializeWebviewPanel(l,g,v,d){const b=this._serializers.get(g);if(!b)throw new Error(`No serializer found for '${g}'`);const{serializer:R,extension:N}=b,q=this.webviews.createNewWebview(l,v.webviewOptions,N),re=this.createNewWebviewPanel(l,g,v.title,d,v.panelOptions,q);await R.deserializeWebviewPanel(re,v.state)}createNewWebviewPanel(l,g,v,d,b,R){const N=new n(l,this._proxy,g,v,d,b,R);return this._webviewPanels.set(l,N),N}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=o;function i(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[253],pe([0,1,3,6,65,5,7]),function(G,e,_,I,A,T,y){"use strict";var P,D,k,r,C,f,p,a,u,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends I.Disposable{constructor(c,m,t,n,o,i){super();P.set(this,void 0),D.set(this,void 0),k.set(this,void 0),r.set(this,void 0),C.set(this,!1),f.set(this,void 0),p.set(this,void 0),a.set(this,void 0),u.set(this,this._register(new _.Emitter)),this.onDidChangeVisibility=Ue(this,u,"f").event,E.set(this,this._register(new _.Emitter)),this.onDidDispose=Ue(this,E,"f").event,tt(this,k,t,"f"),tt(this,p,n,"f"),tt(this,P,c,"f"),tt(this,D,m,"f"),tt(this,r,o,"f"),tt(this,f,i,"f")}dispose(){Ue(this,C,"f")||(tt(this,C,!0,"f"),Ue(this,E,"f").fire(),Ue(this,r,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,p,"f")}set title(c){this.assertNotDisposed(),Ue(this,p,"f")!==c&&(tt(this,p,c,"f"),Ue(this,D,"f").$setWebviewViewTitle(Ue(this,P,"f"),c))}get description(){return this.assertNotDisposed(),Ue(this,a,"f")}set description(c){this.assertNotDisposed(),Ue(this,a,"f")!==c&&(tt(this,a,c,"f"),Ue(this,D,"f").$setWebviewViewDescription(Ue(this,P,"f"),c))}get visible(){return Ue(this,f,"f")}get webview(){return Ue(this,r,"f")}get viewType(){return Ue(this,k,"f")}_setVisible(c){c===Ue(this,f,"f")||Ue(this,C,"f")||(tt(this,f,c,"f"),Ue(this,u,"f").fire())}show(c){this.assertNotDisposed(),Ue(this,D,"f").$show(Ue(this,P,"f"),!!c)}assertNotDisposed(){if(Ue(this,C,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,D=new WeakMap,k=new WeakMap,r=new WeakMap,C=new WeakMap,f=new WeakMap,p=new WeakMap,a=new WeakMap,u=new WeakMap,E=new WeakMap;class S{constructor(c,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,m,t,n){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,A.toExtensionData)(c),m,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(c,m,t,n,o){const i=this._viewProviders.get(m);if(!i)throw new Error(`No view provider found for '${m}'`);const{provider:s,extension:l}=i,g=this._extHostWebview.createNewWebview(c,{},l),v=new w(c,this._proxy,m,t,g,!0);this._webviewViews.set(c,v),await s.resolveWebviewView(v,{state:n},o)}async $onDidChangeWebviewViewVisibility(c,m){this.getWebviewView(c)._setVisible(m)}async $disposeWebviewView(c){const m=this.getWebviewView(c);this._webviewViews.delete(c),m.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const m=this._webviewViews.get(c);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=S}),define(ge[127],pe([0,1,3,5,2,12,9,4,15]),function(G,e,_,I,A,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Un{constructor(C){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Un.InitialState,this._proxy=C.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,f){let p;if(typeof C=="string"){p=C;try{C=A.URI.parse(C)}catch(a){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,y.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,p,f)}async asExternalUri(C,f){if((0,y.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const p=await this._proxy.$asExternalUri(C,f);return A.URI.from(p)}};k.InitialState={focused:!0},k=Ve([xe(0,D.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ge[254],pe([0,1,8,44,30,51,6,5,2,15]),function(G,e,_,I,A,T,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let r=class extends y.Disposable{constructor(f,p){super();const a=f.getProxy(P.MainContext.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async u=>{const E=D.URI.file((0,_.join)((0,I.tmpdir)(),(0,A.generateUuid)()));return await a.$download(u,E),E})}};r=Ve([xe(0,k.IExtHostRpcService),xe(1,T.IExtHostCommands)],r),e.ExtHostDownloadService=r}),define(ge[255],pe([0,1,2,8,147,26,37,64,28,15,6,14,113,46]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class a{constructor(S,h){this.file=h,this.appender=(0,f.createRotatingLogger)(S,h,30*p.ByteSize.MB,1),this.appender.clearFormatters()}append(S){this.appender.critical(S)}flush(){this.appender.flush()}}class u extends P.AbstractExtHostOutputChannel{constructor(S,h,c){super(S,!1,_.URI.file(h.file),c);this._appender=h}append(S){super.append(S),this._appender.append(S),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(S,h){this._appender.flush(),super.show(S,h)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=u;let E=class extends P.ExtHostOutputService{constructor(S,h,c){super(S);this.logService=h,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new r.MutableDisposable,this._logsLocation=c.logsLocation}$setVisibleChannel(S){if(S){const h=this._channels.get(S);h&&(this._visibleChannelDisposable.value=h.onDidAppend(()=>h.update()))}}createOutputChannel(S){if(S=S.trim(),!S)throw new Error("illegal argument `name`. must not be falsy");const h=this._doCreateOutChannel(S);return h.then(c=>c._id.then(m=>this._channels.set(m,c))),new P.LazyOutputChannel(S,h)}async _doCreateOutChannel(S){try{const h=(0,I.join)(this._logsLocation.fsPath,`output_logging_${(0,A.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await T.SymlinkSupport.existsDirectory(h)||await y.promises.mkdir(h,{recursive:!0});const m=`${this._namePool++}-${S.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=_.URI.file((0,I.join)(h,`${m}.log`)),n=new a(m,t.fsPath);return new u(S,n,this._proxy)}catch(h){return this.logService.error(h),new P.ExtHostPushOutputChannel(S,this._proxy)}}};E=Ve([xe(0,k.IExtHostRpcService),xe(1,C.ILogService),xe(2,D.IExtHostInitDataService)],E),e.ExtHostOutputService2=E}),define(ge[256],pe([0,1,5,15,6,28,2,38,25,37,26,7,10,50,3,73,14]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(g,v,d){this.remoteAddress=g,this.localAddress=v,this._dispose=d,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function S(l){const g=l.trim().split(`
`),v=[];return g.forEach(b=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(b);R&&R.length>=3&&v.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),v.reduce((b,R)=>(b[R.socket]=R,b),{})}e.getSockets=S;function h(...l){const g=[].concat(...l.map(m));return[...new Map(g.filter(v=>v.st==="0A").map(v=>{const d=v.local_address.split(":");return{socket:parseInt(v.inode,10),ip:c(d[0]),port:parseInt(d[1],16)}}).map(v=>[v.ip+":"+v.port,v])).values()]}e.loadListeningPorts=h;function c(l){let g="";if(l.length===8)for(let v=l.length-2;v>=0;v-=2)g+=parseInt(l.substr(v,2),16),v!==0&&(g+=".");else for(let v=l.length-4;v>=0;v-=4)g+=parseInt(l.substr(v,4),16).toString(16),v!==0&&(g+=":");return g}e.parseIpAddress=c;function m(l){const g=l.trim().split(`
`),v=g.shift().trim().split(/\s+/).filter(b=>b!=="rx_queue"&&b!=="tm->when");return g.map(b=>b.trim().split(/\s+/).reduce((R,N,q)=>(R[v[q]||q]=N,R),{}))}e.loadConnectionTable=m;function t(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/vs/server/main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function n(l){const g=l.trim().split(`
`),v=[];return g.forEach(d=>{const b=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(d);b&&b.length>=4&&v.push({pid:parseInt(b[1],10),ppid:parseInt(b[2]),cmd:b[3]})}),v}e.getRootProcesses=n;async function o(l,g,v){const d=v.reduce((R,N)=>(R[N.pid]=N,R),{}),b=[];return l.forEach(({socket:R,ip:N,port:q})=>{var re;const V=g[R]?g[R].pid:void 0,W=V?(re=d[V])===null||re===void 0?void 0:re.cmd:void 0;V&&W&&!t(W)&&b.push({host:N,port:q,detail:W,pid:V})}),b}e.findPorts=o;function i(l,g,v){const d=new Map,b=n(g);for(const R of l){const N=v.get(R.port);if(N){d.set(R.port,N);continue}const q=b.find(re=>re.cmd.includes(`${R.port}`));if(q){let re=q,V;do V=b.find(W=>W.ppid===re.pid),V&&(re=V);while(V);d.set(R.port,{host:R.ip,port:R.port,pid:re.pid,detail:re.cmd,ppid:re.ppid})}else d.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return d}e.tryFindRootPorts=i;let s=class extends A.Disposable{constructor(g,v,d){super();this.logService=d,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new a.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=g.getProxy(_.MainContext.MainThreadTunnelService),f.isLinux&&v.remote.isRemote&&v.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(g,v){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${g.identifier.value} called openTunnel API for ${v.remoteAddress.host}:${v.remoteAddress.port}.`);const d=await this._proxy.$openTunnel(v,g.displayName);if(d){const b=new w(d.remoteAddress,d.localAddress,()=>this._proxy.$closeTunnel(d.remoteAddress));return this._register(b),b}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(g){return Math.max(g*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(g,v){const d=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(d,{selector:g,provider:v}),this._proxy.$registerPortsAttributesProvider(g,d),new C.Disposable(()=>{this._portAttributesProviders.delete(d),this._proxy.$unregisterPortsAttributesProvider(d)})}async $providePortAttributes(g,v,d,b,R){const N=[];for(const re of g){const V=this._portAttributesProviders.get(re);if(!V)return[];N.push(...await Promise.all(v.map(async W=>V.provider.providePortAttributes(W,d,b,R))))}const q=N.filter(re=>!!re);return q.length>0?q.map(re=>({autoForwardAction:re.autoForwardAction,port:re.port})):[]}async $registerCandidateFinder(g){if(!(g&&this._candidateFindingEnabled)){this._candidateFindingEnabled=g;let v=new u.MovingAverage,d;for(;this._candidateFindingEnabled;){const b=new Date().getTime(),R=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(q=>q.port).join(", ")}`);const N=new Date().getTime()-b;v.update(N),(!d||JSON.stringify(d)!==JSON.stringify(R))&&(d=R,await this._proxy.$onFoundNewCandidates(d)),await new Promise(q=>setTimeout(()=>q(),this.calculateDelay(v.value)))}}}async setTunnelExtensionFunctions(g){var v;return g?(g.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(g.candidatePortSource),g.showCandidatePort&&(this._showCandidatePort=g.showCandidatePort,this._proxy.$setCandidateFilter()),g.tunnelFactory&&(this._forwardPortProvider=g.tunnelFactory,this._proxy.$setTunnelProvider((v=g.tunnelFeatures)!==null&&v!==void 0?v:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(g,v){if(this._extensionTunnels.has(g.host)){const d=this._extensionTunnels.get(g.host);d.has(g.port)&&(v&&d.get(g.port).disposeListener.dispose(),await d.get(g.port).tunnel.dispose(),d.delete(g.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(g,v){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const d=this._forwardPortProvider(g,v);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),d!==void 0){const b=await d;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(g.remoteAddress.host)||this._extensionTunnels.set(g.remoteAddress.host,new Map);const R=this._register(b.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(b.remoteAddress))));return this._extensionTunnels.get(g.remoteAddress.host).set(g.remoteAddress.port,{tunnel:b,disposeListener:R}),p.TunnelDto.fromApiTunnel(b)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(d){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(g){const v=await Promise.all(g.map(b=>{var R;return this._showCandidatePort(b.host,b.port,(R=b.detail)!==null&&R!==void 0?R:"")})),d=g.filter((b,R)=>v[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${g.map(b=>b.port).join(", ")} to ${d.map(b=>b.port).join(", ")}`),d}async findCandidatePorts(){let g="",v="";try{g=await k.promises.readFile("/proc/net/tcp","utf8"),v=await k.promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const d=h(g,v),b=await new Promise(U=>{(0,P.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,M,L)=>{U(M)})}),R=S(b),N=await r.readdir("/proc"),q=[];for(let U of N)try{const F=Number(U),M=D.joinPath(y.URI.file("/proc"),U);if((await k.promises.stat(M.fsPath)).isDirectory()&&!isNaN(F)){const O=await k.promises.readlink(D.joinPath(M,"cwd").fsPath),B=await k.promises.readFile(D.joinPath(M,"cmdline").fsPath,"utf8");q.push({pid:F,cwd:O,cmd:B})}}catch(F){}const re=[],V=d.filter(U=>{const F=R[U.socket];return F||re.push(U),F}),W=o(V,R,q);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${re.length}`),re.length>0){const U=await new Promise(F=>{(0,P.exec)("ps -F -A -l | grep root",(M,L,O)=>{F(L)})});this._foundRootPorts=i(re,U,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return W.then(U=>$?U.concat($):U)}};s=Ve([xe(0,I.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,E.ILogService)],s),e.ExtHostTunnelService=s}),define(ge[257],pe([0,1,13,21,16,3,6,101,227,125,22]),function(G,e,_,I,A,T,y,P,D,k,r){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function f(i,s){try{return JSON.stringify(i,s)}catch(l){return"null"}}function p(i,s){return JSON.stringify(i,s)}function a(i){return i?(s,l)=>l&&l.$mid===1?i.transformOutgoing(l):l:null}var u;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},S=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class c extends y.Disposable{constructor(s,l=null,g=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=s,this._logger=l,this._uriTransformer=g,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let v=0,d=k.ProxyIdentifier.count;v<d;v++)this._locals[v]=null,this._proxies[v]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(v=>this._receiveOneMessage(v))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(s=>{this._pendingRPCReplies[s].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(s){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(s){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(s){this._responsiveState!==s&&(this._responsiveState=s,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(s){return this._uriTransformer?(0,P.transformIncomingURIs)(s,this._uriTransformer):s}getProxy(s){const{nid:l,sid:g}=s;return this._proxies[l]||(this._proxies[l]=this._createProxy(l,g)),this._proxies[l]}_createProxy(s,l){let g={get:(v,d)=>(typeof d=="string"&&!v[d]&&d.charCodeAt(0)===36&&(v[d]=(...b)=>this._remoteCall(s,d,b)),d===h?l:v[d])};return new Proxy(Object.create(null),g)}set(s,l){return this._locals[s.nid]=l,l}assertRegistered(s){for(let l=0,g=s.length;l<g;l++){const v=s[l];if(!this._locals[v.nid])throw new Error(`Missing actor ${v.sid} (isMain: ${v.isMain})`)}}_receiveOneMessage(s){if(!this._isDisposed){const l=s.byteLength,g=m.read(s,0),v=g.readUInt8(),d=g.readUInt32();switch(v){case 1:case 2:{let{rpcId:b,method:R,args:N}=t.deserializeRequestJSONArgs(g);this._uriTransformer&&(N=(0,P.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(l,d,b,R,N,v===2);break}case 3:case 4:{let{rpcId:b,method:R,args:N}=t.deserializeRequestMixedArgs(g);this._uriTransformer&&(N=(0,P.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(l,d,b,R,N,v===4);break}case 5:{this._logger&&this._logger.logIncoming(l,d,0,"ack"),this._onDidReceiveAcknowledge(d);break}case 6:{this._receiveCancel(l,d);break}case 7:{this._receiveReply(l,d,void 0);break}case 9:{let b=t.deserializeReplyOKJSON(g);this._uriTransformer&&(b=(0,P.transformIncomingURIs)(b,this._uriTransformer)),this._receiveReply(l,d,b);break}case 8:{let b=t.deserializeReplyOKVSBuffer(g);this._receiveReply(l,d,b);break}case 10:{let b=t.deserializeReplyErrError(g);this._uriTransformer&&(b=(0,P.transformIncomingURIs)(b,this._uriTransformer)),this._receiveReplyErr(l,d,b);break}case 11:{this._receiveReplyErr(l,d,void 0);break}default:console.error("received unexpected message"),console.error(s)}}}_receiveRequest(s,l,g,v,d,b){this._logger&&this._logger.logIncoming(s,l,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(g)}.${v}(`,d);const R=String(l);let N,q;if(b){const V=new I.CancellationTokenSource;d.push(V.token),N=this._invokeHandler(g,v,d),q=()=>V.cancel()}else N=this._invokeHandler(g,v,d),q=w;this._cancelInvokedHandlers[R]=q;const re=t.serializeAcknowledged(l);this._logger&&this._logger.logOutgoing(re.byteLength,l,1,"ack"),this._protocol.send(re),N.then(V=>{delete this._cancelInvokedHandlers[R];const W=t.serializeReplyOK(l,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(W.byteLength,l,1,"reply:",V),this._protocol.send(W)},V=>{delete this._cancelInvokedHandlers[R];const W=t.serializeReplyErr(l,V);this._logger&&this._logger.logOutgoing(W.byteLength,l,1,"replyErr:",V),this._protocol.send(W)})}_receiveCancel(s,l){this._logger&&this._logger.logIncoming(s,l,1,"receiveCancel");const g=String(l);this._cancelInvokedHandlers[g]&&this._cancelInvokedHandlers[g]()}_receiveReply(s,l,g){this._logger&&this._logger.logIncoming(s,l,0,"receiveReply:",g);const v=String(l);if(!!this._pendingRPCReplies.hasOwnProperty(v)){const d=this._pendingRPCReplies[v];delete this._pendingRPCReplies[v],d.resolveOk(g)}}_receiveReplyErr(s,l,g){this._logger&&this._logger.logIncoming(s,l,0,"receiveReplyErr:",g);const v=String(l);if(!!this._pendingRPCReplies.hasOwnProperty(v)){const d=this._pendingRPCReplies[v];delete this._pendingRPCReplies[v];let b;g&&(g.$isError?(b=new Error,b.name=g.name,b.message=g.message,b.stack=g.stack):b=g),d.resolveErr(b)}}_invokeHandler(s,l,g){try{return Promise.resolve(this._doInvokeHandler(s,l,g))}catch(v){return Promise.reject(v)}}_doInvokeHandler(s,l,g){const v=this._locals[s];if(!v)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(s));let d=v[l];if(typeof d!="function")throw new Error("Unknown method "+l+" on actor "+(0,k.getStringIdentifierForProxy)(s));return d.apply(v,g)}_remoteCall(s,l,g){if(this._isDisposed)return Promise.reject(A.canceled());let v=null;if(g.length>0&&I.CancellationToken.isCancellationToken(g[g.length-1])&&(v=g.pop()),v&&v.isCancellationRequested)return Promise.reject(A.canceled());const d=t.serializeRequestArguments(g,this._uriReplacer),b=++this._lastMessageId,R=String(b),N=new D.LazyPromise;v&&v.onCancellationRequested(()=>{const re=t.serializeCancel(b);this._logger&&this._logger.logOutgoing(re.byteLength,b,0,"cancel"),this._protocol.send(t.serializeCancel(b))}),this._pendingRPCReplies[R]=N,this._onWillSendRequest(b);const q=t.serializeRequest(b,s,l,d,!!v);return this._logger&&this._logger.logOutgoing(q.byteLength,b,0,`request: ${(0,k.getStringIdentifierForProxy)(s)}.${l}(`,g),this._protocol.send(q),N}}e.RPCProtocol=c,C=S,c.UNRESPONSIVE_TIME=3*1e3;class m{constructor(s,l){this._buff=s,this._offset=l}static alloc(s,l,g){let v=new m(r.VSBuffer.alloc(g+1+4),0);return v.writeUInt8(s),v.writeUInt32(l),v}static read(s,l){return new m(s,l)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(s){this._buff.writeUInt8(s,this._offset),this._offset+=1}readUInt8(){const s=this._buff.readUInt8(this._offset);return this._offset+=1,s}writeUInt32(s){this._buff.writeUInt32BE(s,this._offset),this._offset+=4}readUInt32(){const s=this._buff.readUInt32BE(this._offset);return this._offset+=4,s}static sizeShortString(s){return 1+s.byteLength}writeShortString(s){this._buff.writeUInt8(s.byteLength,this._offset),this._offset+=1,this._buff.set(s,this._offset),this._offset+=s.byteLength}readShortString(){const s=this._buff.readUInt8(this._offset);this._offset+=1;const g=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,g}static sizeLongString(s){return 4+s.byteLength}writeLongString(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readLongString(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const g=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,g}writeBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}static sizeVSBuffer(s){return 4+s.byteLength}writeVSBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readVSBuffer(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const l=this._buff.slice(this._offset,this._offset+s);return this._offset+=s,l}static sizeMixedArray(s,l){let g=0;g+=1;for(let v=0,d=s.length;v<d;v++){const b=s[v],R=l[v];switch(g+=1,R){case 1:g+=this.sizeLongString(b);break;case 2:g+=this.sizeVSBuffer(b);break;case 3:break}}return g}writeMixedArray(s,l){this._buff.writeUInt8(s.length,this._offset),this._offset+=1;for(let g=0,v=s.length;g<v;g++){const d=s[g];switch(l[g]){case 1:this.writeUInt8(1),this.writeLongString(d);break;case 2:this.writeUInt8(2),this.writeVSBuffer(d);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const s=this._buff.readUInt8(this._offset);this._offset+=1;let l=new Array(s);for(let g=0;g<s;g++)switch(this.readUInt8()){case 1:l[g]=this.readLongString();break;case 2:l[g]=this.readVSBuffer();break;case 3:l[g]=void 0;break}return l}}class t{static _arrayContainsBufferOrUndefined(s){for(let l=0,g=s.length;l<g;l++)if(s[l]instanceof r.VSBuffer||typeof s[l]=="undefined")return!0;return!1}static serializeRequestArguments(s,l){if(this._arrayContainsBufferOrUndefined(s)){let g=[],v=[];for(let d=0,b=s.length;d<b;d++){const R=s[d];R instanceof r.VSBuffer?(g[d]=R,v[d]=2):typeof R=="undefined"?(g[d]=r.VSBuffer.alloc(0),v[d]=3):(g[d]=r.VSBuffer.fromString(p(R,l)),v[d]=1)}return{type:"mixed",args:g,argsType:v}}return{type:"simple",args:p(s,l)}}static serializeRequest(s,l,g,v,d){return v.type==="mixed"?this._requestMixedArgs(s,l,g,v.args,v.argsType,d):this._requestJSONArgs(s,l,g,v.args,d)}static _requestJSONArgs(s,l,g,v,d){const b=r.VSBuffer.fromString(g),R=r.VSBuffer.fromString(v);let N=0;N+=m.sizeUInt8(),N+=m.sizeShortString(b),N+=m.sizeLongString(R);let q=m.alloc(d?2:1,s,N);return q.writeUInt8(l),q.writeShortString(b),q.writeLongString(R),q.buffer}static deserializeRequestJSONArgs(s){const l=s.readUInt8(),g=s.readShortString(),v=s.readLongString();return{rpcId:l,method:g,args:JSON.parse(v)}}static _requestMixedArgs(s,l,g,v,d,b){const R=r.VSBuffer.fromString(g);let N=0;N+=m.sizeUInt8(),N+=m.sizeShortString(R),N+=m.sizeMixedArray(v,d);let q=m.alloc(b?4:3,s,N);return q.writeUInt8(l),q.writeShortString(R),q.writeMixedArray(v,d),q.buffer}static deserializeRequestMixedArgs(s){const l=s.readUInt8(),g=s.readShortString(),v=s.readMixedArray(),d=new Array(v.length);for(let b=0,R=v.length;b<R;b++){const N=v[b];typeof N=="string"?d[b]=JSON.parse(N):d[b]=N}return{rpcId:l,method:g,args:d}}static serializeAcknowledged(s){return m.alloc(5,s,0).buffer}static serializeCancel(s){return m.alloc(6,s,0).buffer}static serializeReplyOK(s,l,g){return typeof l=="undefined"?this._serializeReplyOKEmpty(s):l instanceof r.VSBuffer?this._serializeReplyOKVSBuffer(s,l):this._serializeReplyOKJSON(s,f(l,g))}static _serializeReplyOKEmpty(s){return m.alloc(7,s,0).buffer}static _serializeReplyOKVSBuffer(s,l){let g=0;g+=m.sizeVSBuffer(l);let v=m.alloc(8,s,g);return v.writeVSBuffer(l),v.buffer}static deserializeReplyOKVSBuffer(s){return s.readVSBuffer()}static _serializeReplyOKJSON(s,l){const g=r.VSBuffer.fromString(l);let v=0;v+=m.sizeLongString(g);let d=m.alloc(9,s,v);return d.writeLongString(g),d.buffer}static deserializeReplyOKJSON(s){const l=s.readLongString();return JSON.parse(l)}static serializeReplyErr(s,l){return l?this._serializeReplyErrEror(s,l):this._serializeReplyErrEmpty(s)}static _serializeReplyErrEror(s,l){const g=r.VSBuffer.fromString(f(A.transformErrorForSerialization(l),null));let v=0;v+=m.sizeLongString(g);let d=m.alloc(10,s,v);return d.writeLongString(g),d.buffer}static deserializeReplyErrError(s){const l=s.readLongString();return JSON.parse(l)}static _serializeReplyErrEmpty(s){return m.alloc(11,s,0).buffer}}var n;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var o;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(o||(o={}))}),define(ge[258],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(ge[259],pe([0,1,12,8,10,2,4,258]),function(G,e,_,I,A,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(r,C){this.localUserHome=r,this.remoteAgentService=C,this.resolveOS=(async()=>{const f=await this.remoteAgentService.getEnvironment();return(f==null?void 0:f.os)||A.OS})(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(f==null?void 0:f.userHome)||r})()}async userHome(r){return(r==null?void 0:r.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(r=>r===1?I.win32:I.posix)}async fileURI(r){let C="";if(await this.resolveOS===1&&(r=r.replace(/\\/g,"/")),r[0]==="/"&&r[1]==="/"){const p=r.indexOf("/",2);p===-1?(C=r.substring(2),r="/"):(C=r.substring(2,p),r=r.substring(p)||"/")}return T.URI.from({scheme:_.Schemas.file,authority:C,path:r,query:"",fragment:""})}};D=Ve([xe(1,P.IRemoteAgentService)],D),e.AbstractPathService=D}),define(ge[66],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class _{constructor(y,P){this.line=y,this.character=P}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,P){return new _(0,0)}with(y){return new _(0,0)}}e.Position=_;class I{constructor(y,P,D,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new _(y,P),this.end=new _(D,k)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new I(0,0,0,0)}with(y){return new I(0,0,0,0)}}e.Range=I;var A;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(A=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ge[31],pe([0,1,17,33,23,29,9,4,8,16,66]),function(G,e,_,I,A,T,y,P,D,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return r.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const C="\u27EA ",f=" characters skipped \u27EB",p=(C.length+f.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var a;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function E(F){return!!F.preview}e.resultIsMatch=E;function w(F){return!!F.resource}e.isFileMatch=w;function S(F){return!!F.message}e.isProgressMessage=S;var h;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(h=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class c{constructor(M){this.resource=M,this.results=[]}}e.FileMatch=c;class m{constructor(M,L,O){this.ranges=L;const B=Array.isArray(L)?L:[L];if(O&&O.matchLines===1&&t(B)){M=(0,y.getNLines)(M,O.matchLines);let j="",Q=0,de=0;const be=Math.floor(O.charsPerLine/5),Ae=[];for(const Ce of B){const Le=Math.max(Ce.startColumn-be,0),z=Ce.startColumn+O.charsPerLine;if(Le>de+be+p){const Y=C+(Le-de)+f;j+=Y+M.slice(Le,z),Q+=Le-(de+Y.length)}else j+=M.slice(de,z);Ae.push(new o(0,Ce.startColumn-Q,Ce.endColumn-Q)),de=z}this.preview={text:j,matches:Array.isArray(this.ranges)?Ae:Ae[0]}}else{const j=Array.isArray(L)?L[0].startLineNumber:L.startLineNumber;this.preview={text:M,matches:(0,_.mapArrayOrNot)(L,Q=>new n(Q.startLineNumber-j,Q.startColumn,Q.endLineNumber-j,Q.endColumn))}}}}e.TextSearchMatch=m;function t(F){const M=F[0].startLineNumber;for(const L of F)if(L.startLineNumber!==M||L.endLineNumber!==M)return!1;return!0}class n{constructor(M,L,O,B){this.startLineNumber=M,this.startColumn=L,this.endLineNumber=O,this.endColumn=B}}e.SearchRange=n;class o extends n{constructor(M,L,O){super(M,L,M,O)}}e.OneLineRange=o;var i;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function s(F,M=!0){const L=F&&F.files&&F.files.exclude,O=M&&F&&F.search&&F.search.exclude;if(!(!L&&!O)){if(!L||!O)return L||O;let B=Object.create(null);return B=A.mixin(B,A.deepClone(L)),B=A.mixin(B,A.deepClone(O),!0),B}}e.getExcludes=s;function l(F,M){return F.excludePattern&&I.match(F.excludePattern,M)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&I.match(F.includePattern,M)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(L=>{const O=L.folder.fsPath;if(T.isEqualOrParent(M,O)){const B=D.relative(O,M);return!L.includePattern||!!I.match(L.includePattern,B)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var g;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class v extends Error{constructor(M,L){super(M);this.code=L}}e.SearchError=v;function d(F){const M=F.message;if((0,k.isPromiseCanceledError)(F))return new v(M,g.canceled);try{const L=JSON.parse(M);return new v(L.message,L.code)}catch(L){return new v(M,g.other)}}e.deserializeSearchError=d;function b(F){const M={message:F.message,code:F.code};return new Error(JSON.stringify(M))}e.serializeSearchError=b;function R(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=R;function N(F){return F.type==="success"}e.isSerializedSearchSuccess=N;function q(F){return!!F.path}e.isSerializedFileMatch=q;function re(F,M){const L=F.searchPath?F.searchPath:F.relativePath;return(0,y.fuzzyContains)(L,M)}e.isFilePatternMatch=re;class V{constructor(M){this.path=M,this.results=[]}addMatch(M){this.results.push(M)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=V;function W(F,M){const L=Object.assign(Object.assign({},F||{}),M||{});return Object.keys(L).filter(O=>{const B=L[O];return typeof B=="boolean"&&B})}e.resolvePatternsForProvider=W;class ${constructor(M,L){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},M.excludePattern||{}),L.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let O=M.includePattern;L.includePattern&&(O?O=Object.assign(Object.assign({},O),L.includePattern):O=L.includePattern),O&&(this._parsedIncludeExpression=I.parse(O))}includedInQuerySync(M,L,O){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(M,L,O)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(M,L,O))}includedInQuery(M,L,O){return Promise.resolve(this._parsedExcludeExpression(M,L,O)).then(j=>!!j).then(j=>j?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(M,L,O)).then(Q=>!!Q):Promise.resolve(!0)).then(j=>j)}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=$;function U(F){for(const M in F)if(typeof F[M]!="boolean")return!0;return!1}}),define(ge[32],pe([0,1,17,13,21,3,24,12,73,25,9,11,2,167,4,14,186,60,61,28,15,7,31,5]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E,w,S,h,c,m,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(R,N,q){return new k.ExtUri(re=>g(re,q)).isEqual(R,N)}function i(R,N,q){return o(R.uri,N.uri,q)?0:(0,r.compare)(R.uri.toString(),N.uri.toString())}function s(R,N,q){return R.index!==N.index?R.index<N.index?-1:1:o(R.uri,N.uri,q)?(0,r.compare)(R.name,N.name):(0,r.compare)(R.uri.toString(),N.uri.toString())}function l(R,N,q,re){const V=R.slice(0).sort(($,U)=>q($,U,re)),W=N.slice(0).sort(($,U)=>q($,U,re));return(0,_.delta)(V,W,($,U)=>q($,U,re))}function g(R,N){const q=N.getCapabilities(R.scheme);return!(q&&q&1024)}class v extends w.Workspace{constructor(N,q,re,V,W,$){super(N,re.map(U=>new w.WorkspaceFolder(U)),V,$);this._name=q,this._isUntitled=W,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris($),re.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(N,q,re,V){if(!N)return{workspace:null,added:[],removed:[]};const{id:W,name:$,folders:U,configuration:F,isUntitled:M}=N,L=[],O=q;q?U.forEach((de,be)=>{const Ae=f.URI.revive(de.uri),Ce=v._findFolder(re||q,Ae,V);Ce?(Ce.name=de.name,Ce.index=de.index,L.push(Ce)):L.push({uri:Ae,name:de.name,index:be})}):L.push(...U.map(({uri:de,name:be,index:Ae})=>({uri:f.URI.revive(de),name:be,index:Ae}))),L.sort((de,be)=>de.index<be.index?-1:1);const B=new v(W,$,L,F?f.URI.revive(F):null,!!M,de=>g(de,V)),{added:j,removed:Q}=l(O?O.workspaceFolders:[],B.workspaceFolders,i,V);return{workspace:B,added:j,removed:Q}}static _findFolder(N,q,re){for(let V=0;V<N.folders.length;V++){const W=N.workspaceFolders[V];if(o(W.uri,q,re))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,q){return q&&this._structure.get(N)&&(N=(0,k.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let d=class{constructor(N,q,re,V){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=V,this._extHostFileSystemInfo=re,this._requestIdProvider=new D.Counter,this._barrier=new I.Barrier,this._proxy=N.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(n.MainContext.MainThreadMessageService);const W=q.workspace;this._confirmedWorkspace=W?new v(W.id,W.name,[],W.configuration?f.URI.revive(W.configuration):null,!!W.isUntitled,$=>g($,re)):void 0}$initializeWorkspace(N,q){this._trusted=q,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?f.URI.from({scheme:P.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,q,re,...V){const W=[];if(Array.isArray(V)&&V.forEach(L=>{f.URI.isUri(L.uri)&&!W.some(O=>o(O.uri,L.uri,this._extHostFileSystemInfo))&&W.push({uri:L.uri,name:L.name||(0,k.basenameOrAuthority)(L.uri)})}),this._unconfirmedWorkspace||[q,re].some(L=>typeof L!="number"||L<0)||re===0&&W.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(q+re>$.length)return!1;const U=$.slice(0);U.splice(q,re,...W.map(L=>({uri:L.uri,name:L.name||(0,k.basenameOrAuthority)(L.uri),index:void 0})));for(let L=0;L<U.length;L++){const O=U[L];if(U.some((B,j)=>j!==L&&o(O.uri,B.uri,this._extHostFileSystemInfo)))return!1}U.forEach((L,O)=>L.index=O);const{added:F,removed:M}=l($,U,s,this._extHostFileSystemInfo);if(F.length===0&&M.length===0)return!1;if(this._proxy){const L=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(L,q,re,W).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,p.localize)(0,null,L,O.toString()),{extension:N},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(N,q){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,q)}async getWorkspaceFolder2(N,q){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,q)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!!this._actualWorkspace){const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}}getRelativePath(N,q){let re,V="";if(typeof N=="string"?(re=f.URI.file(N),V=N):typeof N!="undefined"&&(re=N,V=N.fsPath),!re)return V;const W=this.getWorkspaceFolder(re,!0);if(!W)return V;typeof q=="undefined"&&this._actualWorkspace&&(q=this._actualWorkspace.folders.length>1);let $=(0,k.relativePath)(W.uri,re);return q&&W.name&&($=`${W.name}/${$}`),$}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=v.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:q,added:re,removed:V}=v.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=q||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:re,removed:V}))}findFiles(N,q,re,V,W=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let $;if(q===null?$=!1:q&&(typeof q=="string"?$=q:$=q.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:F}=b(N);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(U),(0,C.withUndefinedAsNull)(F),(0,C.withUndefinedAsNull)($),(0,C.withUndefinedAsNull)(re),W).then(M=>Array.isArray(M)?M.map(L=>f.URI.revive(L)):[])}async findTextInFiles(N,q,re,V,W=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),U=typeof q.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:F,folder:M}=b(q.include),L=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,O={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:U,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:F,excludePattern:L},B=!1;if(this._activeSearchCallbacks[$]=j=>{if(!B){const Q=f.URI.revive(j.resource);j.results.forEach(de=>{(0,t.resultIsMatch)(de)?re({uri:Q,preview:{text:de.preview.text,matches:(0,_.mapArrayOrNot)(de.preview.matches,be=>new m.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,_.mapArrayOrNot)(de.ranges,be=>new m.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):re({uri:Q,text:de.text,lineNumber:de.lineNumber})})}},W.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(N,(0,C.withUndefinedAsNull)(M),O,$,W);return delete this._activeSearchCallbacks[$],j||{}}catch(j){throw delete this._activeSearchCallbacks[$],j}}$handleTextSearchResult(N,q){this._activeSearchCallbacks[q]&&this._activeSearchCallbacks[q](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){const q=this._proxy.$requestWorkspaceTrust(N);return(N==null?void 0:N.modal)?q:Promise.resolve(this._trusted)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};d=Ve([xe(0,c.IExtHostRpcService),xe(1,h.IExtHostInitDataService),xe(2,S.IExtHostFileSystemInfo),xe(3,u.ILogService)],d),e.ExtHostWorkspace=d,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function b(R){let N,q;return R&&(typeof R=="string"?N=R:(N=R.pattern,q=R.baseFolder||f.URI.file(R.base))),{includePattern:N,folder:q}}}),define(ge[35],pe([0,1,23,3,32,5,7,188,83,11,13,4,15,14,2]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(n,o){if(o){const i=o.split(".");let s=n;for(let l=0;s&&l<i.length;l++)s=s[i[l]];return s}}function E(n){return n instanceof a.URI}function w(n){return n&&n.uri instanceof a.URI&&n.languageId&&typeof n.languageId=="string"}function S(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function h(n){return n&&n.uri instanceof a.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function c(n){if(E(n))return{resource:n};if(w(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(S(n))return{overrideIdentifier:n.languageId};if(h(n))return{resource:n.uri};if(n===null)return{resource:null}}let m=class{constructor(o,i,s){this._proxy=o.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=s,this._barrier=new r.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,i){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(o,i))}};m=Ve([xe(0,f.IExtHostRpcService),xe(1,A.IExtHostWorkspace),xe(2,p.ILogService)],m),e.ExtHostConfiguration=m;class t{constructor(o,i,s,l){this._onDidChangeConfiguration=new I.Emitter,this._proxy=o,this._logService=l,this._extHostWorkspace=i,this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,i){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,s))}getConfiguration(o,i,s){const l=c(i)||{},g=this._toReadonlyValue(o?u(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,l,s==null?void 0:s.identifier);function v(b){if(b==null)return null;if(typeof b=="boolean")return b?1:4;switch(b){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(b){return typeof u(g,b)!="undefined"},get:(b,R)=>{this._validateConfigurationAccess(o?`${o}.${b}`:b,l,s==null?void 0:s.identifier);let N=u(g,b);if(typeof N=="undefined")N=R;else{let q;const re=(V,W)=>{let $;const U=()=>{q=q||(0,_.deepClone)(g),$=$||u(q,W)};return(0,k.isObject)(V)?new Proxy(V,{get:(F,M)=>{if(typeof M=="string"&&M.toLowerCase()==="tojson")return U(),()=>$;if(q)return $=$||u(q,W),$[M];const L=F[M];return typeof M=="string"?re(L,`${W}.${M}`):L},set:(F,M,L)=>(U(),$&&($[M]=L),!0),deleteProperty:(F,M)=>(U(),$&&delete $[M],!0),defineProperty:(F,M,L)=>(U(),$&&Object.defineProperty($,M,L),!0)}):V};N=re(N,b)}return N},update:(b,R,N,q)=>{b=o?`${o}.${b}`:b;const re=v(N);return R!==void 0?this._proxy.$updateConfigurationOption(re,b,R,l,q):this._proxy.$removeConfigurationOption(re,b,l,q)},inspect:b=>{var R,N,q,re,V,W,$,U;b=o?`${o}.${b}`:b;const F=(0,_.deepClone)(this._configuration.inspect(b,l,this._extHostWorkspace.workspace));if(F)return{key:b,defaultValue:(R=F.default)===null||R===void 0?void 0:R.value,globalValue:(N=F.user)===null||N===void 0?void 0:N.value,workspaceValue:(q=F.workspace)===null||q===void 0?void 0:q.value,workspaceFolderValue:(re=F.workspaceFolder)===null||re===void 0?void 0:re.value,defaultLanguageValue:(V=F.default)===null||V===void 0?void 0:V.override,globalLanguageValue:(W=F.user)===null||W===void 0?void 0:W.override,workspaceLanguageValue:($=F.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(U=F.workspaceFolder)===null||U===void 0?void 0:U.override,languageIds:F.overrideIdentifiers}}};return typeof g=="object"&&(0,_.mixin)(d,g,!1),Object.freeze(d)}_toReadonlyValue(o){const i=s=>(0,k.isObject)(s)?new Proxy(s,{get:(l,g)=>i(l[g]),set:(l,g,v)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(l,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(l,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return i(o)}_validateConfigurationAccess(o,i,s){const l=D.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),g=s?`[${s.value}] `:"";if(l===4){typeof(i==null?void 0:i.resource)=="undefined"&&this._logService.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){(i==null?void 0:i.resource)&&this._logService.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,i){const s=new P.ConfigurationChangeEvent(o,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,g)=>s.affectsConfiguration(l,c(g))})}_toMap(o){return o.reduce((i,s)=>(i.set(s[0],s[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[67],pe([0,1,2,13,3,5,7,32,39,35,21,34,15,28,4,12,10,14,63,209,16]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E,w,S,h,c){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(V){function W(U){if(U!=null)return U}V.from=W;function $(U){if(U!=null)return U}V.to=$})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(V){function W(U){if(U!=null)return U}V.from=W;function $(U){if(U!=null)return U}V.to=$})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(V){function W(U){if(U!=null)return U}V.from=W;function $(U){if(U!=null)return U}V.to=$})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(V){function W(F){if(F){const M=F;return M&&!!M.process}else return!1}V.is=W;function $(F){if(F!=null){const M={process:F.process,args:F.args};return F.options&&(M.options=o.from(F.options)),M}}V.from=$;function U(F){if(F!=null)return new y.ProcessExecution(F.process,F.args,F.options)}V.to=U})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(V){function W(U){if(U!=null)return U}V.from=W;function $(U){if(U!=null)return U}V.to=$})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function(V){function W(F){if(F){const M=F;return M&&(!!M.commandLine||!!M.command)}else return!1}V.is=W;function $(F){if(F!=null){const M={};return F.commandLine!==void 0?M.commandLine=F.commandLine:(M.command=F.command,M.args=F.args),F.options&&(M.options=s.from(F.options)),M}}V.from=$;function U(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new y.ShellExecution(F.commandLine,F.options):new y.ShellExecution(F.command,F.args?F.args:[],F.options)}V.to=U})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var g;(function(V){function W(F){if(F){let M=F;return M&&M.customExecution==="customExecution"}else return!1}V.is=W;function $(F){return{customExecution:"customExecution"}}V.from=$;function U(F,M){return M.get(F)}V.to=U})(g=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var v;(function(V){function W($,U){let F;return $.scope!==void 0&&typeof $.scope!="number"?F=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===y.TaskScope.Workspace&&U&&U.workspaceFile?F=U.workspaceFile:F=h.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:F}}V.from=W})(v=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(V){function W(F,M){if(F==null)return[];const L=[];for(let O of F){const B=$(O,M);B&&L.push(B)}return L}V.fromMany=W;function $(F,M){if(F!=null){let L;F.execution instanceof y.ProcessExecution?L=i.from(F.execution):F.execution instanceof y.ShellExecution?L=l.from(F.execution):F.execution&&F.execution instanceof y.CustomExecution&&(L=g.from(F.execution));const O=t.from(F.definition);let B;if(F.scope?typeof F.scope=="number"?B=F.scope:B=F.scope.uri:B=y.TaskScope.Workspace,!(!O||!B)){const j=F.group?F.group.id:void 0;return{_id:F._id,definition:O,name:F.name,source:{extensionId:M.identifier.value,label:F.source,scope:B},execution:L,isBackground:F.isBackground,group:j,presentationOptions:n.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}}}V.from=$;async function U(F,M,L){if(F!=null){let O;i.is(F.execution)?O=i.to(F.execution):l.is(F.execution)?O=l.to(F.execution):g.is(F.execution)&&(O=g.to(F._id,L));const B=t.to(F.definition);let j;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?j=F.source.scope:j=await M.resolveWorkspaceFolder(_.URI.revive(F.source.scope)):j=y.TaskScope.Workspace),!(!B||!j)){const Q=new y.Task(B,j,F.name,F.source.label,O,F.problemMatchers);return F.isBackground!==void 0&&(Q.isBackground=F.isBackground),F.group!==void 0&&(Q.group=y.TaskGroup.from(F.group)),F.presentationOptions&&(Q.presentationOptions=n.to(F.presentationOptions)),F._id&&(Q._id=F._id),F.detail&&(Q.detail=F.detail),Q}}}V.to=U})(d=e.TaskDTO||(e.TaskDTO={}));var b;(function(V){function W(U){return U}V.from=W;function $(U){if(!!U)return Object.assign(Object.create(null),U)}V.to=$})(b=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(W,$,U){this._id=$,this._task=U,m.set(this,void 0),tt(this,m,W,"f")}get task(){return this._task}terminate(){Ue(this,m,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}m=new WeakMap;var N;(function(V){function W($){return{id:$._id,task:void 0}}V.from=W})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let q=class{constructor(W,$,U,F,M,L,O,B){this._onDidExecuteTask=new A.Emitter,this._onDidTerminateTask=new A.Emitter,this._onDidTaskProcessStarted=new A.Emitter,this._onDidTaskProcessEnded=new A.Emitter,this._proxy=W.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=F,this._configurationService=M,this._terminalService=L,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=B,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,$,U){if(!U)return new y.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:$,provider:U,extension:W}),this._proxy.$registerTaskProvider(F,$),new y.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(W,$){this._proxy.$registerTaskSystem(W,$)}fetchTasks(W){return this._proxy.$fetchTasks(b.from(W)).then(async $=>{const U=[];for(let F of $){const M=await d.to(F,this._workspaceProvider,this._providedCustomExecutions2);M&&U.push(M)}return U})}get taskExecutions(){const W=[];return this._taskExecutions.forEach($=>W.push($)),W}terminateTask(W){if(!(W instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,$,U){const F=this._providedCustomExecutions2.get(W.id);if(F){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,F),this._terminalService.attachPtyToTerminal($,await F.callback(U))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const $=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const $=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:$,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const $=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:W.exitCode})}$provideTasks(W,$){const U=this._handlers.get(W);if(!U)return Promise.reject(new Error("no handler found"));const F=[],M=(0,I.asPromise)(()=>U.provider.provideTasks(r.CancellationToken.None)).then(L=>this.provideTasksInternal($,F,U,L));return new Promise(L=>{M.then(O=>{Promise.all(F).then(()=>{L(O)})})})}async $resolveTask(W,$){const U=this._handlers.get(W);if(!U)return Promise.reject(new Error("no handler found"));if($.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${U.type}].`);const F=await d.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const M=await U.provider.resolveTask(F,r.CancellationToken.None);if(!!M){this.checkDeprecation(M,U);const L=d.from(M,U.extension);if(!L)throw new Error("Unexpected: Task cannot be resolved.");if(M.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(L.execution)&&await this.addCustomExecution(L,M,!0),await this.resolveTaskInternal(L)}}nextHandle(){return this._handleCounter++}async addCustomExecution(W,$,U){const F=await this._proxy.$createTaskId(W);!U&&!this._providedCustomExecutions2.has(F)&&this._notProvidedCustomExecutions.add(F),this._providedCustomExecutions2.set(F,$.execution)}async getTaskExecution(W,$){if(typeof W=="string"){const M=this._taskExecutionPromises.get(W);if(!M)throw new Error("Unexpected: The specified task is missing an execution");return M}let U=this._taskExecutionPromises.get(W.id);if(U)return U;const F=new Promise(async(M,L)=>{const O=$||await d.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);O?M(new R(this,W.id,O)):L("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,F),F.then(M=>(this._taskExecutions.set(W.id,M),M),M=>Promise.reject(M))}checkDeprecation(W,$){W._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let U=this._notProvidedCustomExecutions.values(),F=U.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=U.next()}};q=Ve([xe(0,f.IExtHostRpcService),xe(1,p.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,D.IExtHostDocumentsAndEditors),xe(4,k.IExtHostConfiguration),xe(5,C.IExtHostTerminalService),xe(6,w.ILogService),xe(7,S.IExtHostApiDeprecationService)],q),e.ExtHostTaskBase=q;let re=class extends q{constructor(W,$,U,F,M,L,O,B){super(W,$,U,F,M,L,O,B);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(W,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const U=d.from($,W);if(U===void 0)throw new Error("Task is not valid");if(g.is(U.execution))await this.addCustomExecution(U,$,!1);else throw new c.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),$);return this._proxy.$executeTask(U).catch(M=>{throw new Error(M)}),F}provideTasksInternal(W,$,U,F){const M=[];if(F)for(let L of F){this.checkDeprecation(L,U),(!L.definition||!W[L.definition.type])&&this._logService.warn(`The task [${L.source}, ${L.name}] uses an undefined task type. The task will be ignored in the future.`);const O=d.from(L,U.extension);O&&g.is(O.execution)?(M.push(O),$.push(this.addCustomExecution(O,L,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:M,extension:U.extension}}async resolveTaskInternal(W){if(g.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,$){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(W,$,U){}};re=Ve([xe(0,f.IExtHostRpcService),xe(1,p.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,D.IExtHostDocumentsAndEditors),xe(4,k.IExtHostConfiguration),xe(5,C.IExtHostTerminalService),xe(6,w.ILogService),xe(7,S.IExtHostApiDeprecationService)],re),e.WorkerExtHostTask=re,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)},qt=this&&this.__rest||function(G,e){var _={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(_[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(G);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(G,I[A])&&(_[I[A]]=G[I[A]]);return _};define(ge[260],pe([0,1,17,13,22,21,3,71,54,6,23,11,2,30,5,39,15,87,20,7,32,222,123]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E,w,S,h,c,m,t){"use strict";var n,o,i,s;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const l=(U,F)=>`${U}:${F.toString()}`;let g=class{constructor(F,M,L){this.documents=M,this.workspace=L,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new m.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(a.MainContext.MainThreadTesting),this.runQueue=new v(this.proxy),this.workspaceObservers=new W(this.proxy),this.textDocumentObservers=new $(this.proxy,M)}registerTestController(F,M){const L=(0,p.generateUuid)();this.controllers.set(L,{instance:M,extensionId:F}),this.proxy.$registerTestController(L);const O=[...this.testControllers.keys()];return setTimeout(()=>{var B;for(const j of O)(B=this.testControllers.get(j))===null||B===void 0||B.subscribeFn(L,M)},0),new h.Disposable(()=>{this.controllers.delete(L),this.proxy.$unregisterTestController(L)})}createTextDocumentTestObserver(F){return this.textDocumentObservers.checkout(F.uri)}createWorkspaceTestObserver(F){return this.workspaceObservers.checkout(F.uri)}async runTests(F,M=T.CancellationToken.None){const L=O=>O.map(this.getInternalTestForReference,this).filter(C.isDefined).map(B=>({src:B.src,testId:B.item.extId}));await this.proxy.$runTests({exclude:F.exclude?L(F.exclude).map(O=>O.testId):void 0,tests:L(F.tests),debug:F.debug},M)}createTestRun(F,M,L,O=!0){return this.runQueue.createTestRun(F,M,L,O)}$publishTestResults(F){this.results=Object.freeze(F.map(M=>(0,r.deepFreeze)(S.TestResults.to(M))).concat(this.results).sort((M,L)=>L.completedAt-M.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(F,M){const L=f.URI.revive(M),O=l(F,L);if(!this.testControllers.has(O)){const B=new T.CancellationTokenSource;let j;if(F===1){let Ce=this.documents.getDocument(L);if(!Ce){const Le=new k.DisposableStore;Ce=await new Promise(z=>{Le.add((0,I.disposableTimeout)(()=>z(void 0),5e3)),Le.add(this.documents.onDidAddDocuments(Y=>{const ee=Y.find(ae=>ae.document.uri.toString()===L.toString());ee&&z(ee)}))}).finally(()=>Le.dispose())}if(Ce){const Le=await this.workspace.getWorkspaceFolder2(L,!1);j=z=>z.createDocumentTestRoot?z.createDocumentTestRoot(Ce.document,B.token):(0,e.createDefaultDocumentTestRoot)(z,Ce.document,Le,B.token)}}else{const Ce=await this.workspace.getWorkspaceFolder2(L,!1);Ce&&(j=Le=>Le.createWorkspaceTestRoot(Ce,B.token))}if(!!j){const Q=async(Ce,Le)=>{try{const z=await j(Le);z&&be.addRoot(z,Ce)}catch(z){console.error(z)}},de=new k.DisposableStore,be=de.add(this.ownedTests.createForHierarchy(Ce=>this.proxy.$publishDiff(F,M,Ce)));de.add((0,k.toDisposable)(()=>B.dispose(!0)));const Ae=[];for(const[Ce,Le]of this.controllers)Ae.push(Q(Ce,Le.instance));Promise.all(Ae).then(()=>be.pushDiff([3,-1])),this.testControllers.set(O,{store:de,collection:be,subscribeFn:Q})}}}async $expandTest(F,M){const L=(0,_.mapFind)(this.testControllers.values(),O=>O.collection.treeId===F.src.tree?O:void 0);await(L==null?void 0:L.collection.expand(F.testId,M<0?Infinity:M)),this.flushCollectionDiffs()}$unsubscribeFromTests(F,M){var L;const O=f.URI.revive(M),B=l(F,O);(L=this.testControllers.get(B))===null||L===void 0||L.store.dispose(),this.testControllers.delete(B)}$acceptDiff(F,M,L){F===1?this.textDocumentObservers.acceptDiff(f.URI.revive(M),L):this.workspaceObservers.acceptDiff(f.URI.revive(M),L)}async $runTestsForProvider(F,M){const L=this.controllers.get(F.tests[0].src.controller);if(!!L){const O=F.tests.map(({testId:Q,src:de})=>this.ownedTests.getTestById(Q,de==null?void 0:de.tree)).filter(C.isDefined).map(([Q,de])=>de),B=F.excludeExtIds.map(Q=>this.ownedTests.getTestById(Q)).filter(C.isDefined).filter(([Q,de])=>O.some(be=>Q.comparePositions(be,de)===1));if(!!O.length){const j={tests:O.map(Q=>N.unwrap(Q.actual)),exclude:B.map(([,Q])=>N.unwrap(Q.actual)),debug:F.debug};await this.runQueue.enqueueRun({dto:d.fromInternal(F),token:M,extensionId:L.extensionId,req:j,doRun:()=>L.instance.runTests(j,M)})}}}$lookupTest(F){const M=this.ownedTests.getTestById(F.testId);if(!M)return Promise.resolve(void 0);const L=M[1],{actual:O,discoverCts:B,expandLevels:j}=L,Q=qt(L,["actual","discoverCts","expandLevels"]);return Promise.resolve(Q)}flushCollectionDiffs(){for(const{collection:F}of this.testControllers.values())F.flushDiff()}getInternalTestForReference(F){var M,L;return(L=(M=this.workspaceObservers.getMirroredTestDataByReference(F))!==null&&M!==void 0?M:(0,_.mapFind)(this.testControllers.values(),O=>O.collection.getTestByReference(F)))!==null&&L!==void 0?L:this.textDocumentObservers.getMirroredTestDataByReference(F)}};g=Ve([xe(0,E.IExtHostRpcService),xe(1,u.IExtHostDocumentsAndEditors),xe(2,c.IExtHostWorkspace)],g),e.ExtHostTesting=g;class v{constructor(F){this.proxy=F,this.state=new Map}enqueueRun(F){let M=this.state.get(F.extensionId);M||(M={queue:[],current:void 0},this.state.set(F.extensionId,M));const L=new I.DeferredPromise,O=()=>{const B=[],j=new Set;M.current={publicReq:F.req,factory:Q=>{const de=new b(Q,F.dto,j,this.proxy);return B.push(de),F.token.onCancellationRequested(()=>de.end()),de}},this.invokeRunner(F.extensionId,F.dto.id,F.doRun,B).finally(()=>L.complete())};return M.queue.push(O),M.queue.length===1&&O(),L.p}createTestRun(F,M,L,O){var B,j;const Q=this.state.get(F);if((Q==null?void 0:Q.current.publicReq)===M)return Q.current.factory(L);const de=d.fromPublic(M),be=new b(L,de,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:M.debug,exclude:(j=(B=M.exclude)===null||B===void 0?void 0:B.map(Ae=>Ae.id))!==null&&j!==void 0?j:[],id:de.id,tests:M.tests.map(Ae=>Ae.id),persist:O}),be.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(de.id)),be}invokeRunner(F,M,L,O){try{const B=L();return(0,I.isThenable)(B)?B.then(()=>this.handleInvokeResult(F,M,O,void 0)).catch(j=>this.handleInvokeResult(F,M,O,j)):this.handleInvokeResult(F,M,O,void 0)}catch(B){return this.handleInvokeResult(F,M,O,B)}}async handleInvokeResult(F,M,L,O){const B=this.state.get(F);!B||(B.queue.shift(),B.queue.length>0?B.queue[0]():this.state.delete(F),await Promise.all(L.map(j=>j.onEnd.wait())))}}class d{constructor(F,M,L){this.id=F,this.include=M,this.exclude=L}static fromPublic(F){var M,L;return new d((0,p.generateUuid)(),new Set(F.tests.map(O=>O.id)),new Set((L=(M=F.exclude)===null||M===void 0?void 0:M.map(O=>O.id))!==null&&L!==void 0?L:D.Iterable.empty()))}static fromInternal(F){return new d(F.runId,new Set(F.tests.map(M=>M.testId)),new Set(F.excludeExtIds))}isIncluded(F){for(let M=F;M;M=M.parent){if(this.include.has(M.id))return!0;if(this.exclude.has(M.id))return!1}return!0}}class b{constructor(F,M,L,O){this.name=F,n.set(this,void 0),o.set(this,void 0),i.set(this,(0,p.generateUuid)()),s.set(this,void 0),this.onEnd=new I.Barrier,tt(this,n,O,"f"),tt(this,o,M,"f"),tt(this,s,L,"f"),O.$startedTestRunTask(M.id,{id:Ue(this,i,"f"),name:F,running:!0})}setState(F,M,L){Ue(this,o,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Ue(this,n,"f").$updateTestStateInRun(Ue(this,o,"f").id,Ue(this,i,"f"),F.id,M,L))}appendMessage(F,M){Ue(this,o,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Ue(this,n,"f").$appendTestMessageInRun(Ue(this,o,"f").id,Ue(this,i,"f"),F.id,S.TestMessage.from(M)))}appendOutput(F){Ue(this,n,"f").$appendOutputToRun(Ue(this,o,"f").id,Ue(this,i,"f"),A.VSBuffer.fromString(F))}end(){Ue(this,n,"f").$finishedTestRunTask(Ue(this,o,"f").id,Ue(this,i,"f")),this.onEnd.open()}ensureTestIsKnown(F){const M=Ue(this,s,"f");if(!M.has(F.id)){const L=[];for(;L.unshift(S.TestItem.from(F)),!(M.has(F.id)||(M.add(F.id),!F.parent));)F=F.parent;Ue(this,n,"f").$addTestsToRun(Ue(this,o,"f").id,L)}}}n=new WeakMap,o=new WeakMap,i=new WeakMap,s=new WeakMap;const R=async(U,F,M,L)=>{if(!!M){const O=await U.createWorkspaceTestRoot(M,L);if(!!O){L.onCancellationRequested(()=>{N.removeFilter(F)});const B=N.getWrapperForTestItem(O,F);return B.refreshMatch(),B}}};e.createDefaultDocumentTestRoot=R;class N extends h.TestItemImpl{constructor(F,M,L){super(F.id,F.label,F.uri,void 0);if(this.actual=F,this.filterDocument=M,this.actualParent=L,!(F instanceof h.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${F.id} did not`);this.debuggable=F.debuggable,this.runnable=F.runnable,this.description=F.description,this.error=F.error,this.status=F.status,this.range=F.range,this.resolveHandler=F.resolveHandler;const O=(0,w.getPrivateApiFor)(this);(0,w.getPrivateApiFor)(F).bus.event(j=>{switch(j[0]){case 3:this[j[1]]=j[2];break;case 0:const Q=N.getWrapperForTestItem(j[1],this.filterDocument,this);(0,w.getPrivateApiFor)(Q).parent=F,Q.refreshMatch();break;default:O.bus.fire(j)}})}static removeFilter(F){this.wrapperMap.delete(F)}static getWrapperForTestItem(F,M,L){let O=this.wrapperMap.get(M);if(O==null?void 0:O.has(F))return O.get(F);O||(O=new WeakMap,this.wrapperMap.set(M,O));const B=new N(F,M,L);return O.set(F,B),B}static unwrap(F){return F instanceof N?F.actual:F}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var F;const M=this._cachedMatchesFilter;for(const O of this.actual.children.values()){const B=N.getWrapperForTestItem(O,this.filterDocument,this);B.hasNodeMatchingFilter?this.children.has(B.id)||this.addChild(B):B.dispose()}const L=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=L,L!==M&&((F=this.actualParent)===null||F===void 0||F.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,w.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,w.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=N,N.wrapperMap=new WeakMap;class q extends t.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,S.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:M,removed:L}=this;return{get added(){return[...F].map(O=>O.revived)},get updated(){return[...M].map(O=>O.revived)},get removed(){return[...L].map(O=>O.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class re extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(F){let M=[];for(const L of F){const O=this.items.get(L);O&&M.push(O.revived)}return M}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,M){return Object.assign(Object.assign({},F),{revived:S.TestItem.toPlain(F.item),depth:M?M.depth+1:0,children:new Set})}createChangeCollector(){return new q(this.changeEmitter)}}e.MirroredTestCollection=re;class V{constructor(){this.resources=new Map}checkout(F){var M,L;const O=F.toString(),B=(M=this.resources.get(O))!==null&&M!==void 0?M:this.createObserverData(F);return(L=B.pendingDeletion)===null||L===void 0||L.dispose(),B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return B.tests.rootTestItems},dispose:(0,P.once)(()=>{--B.observers||(B.pendingDeletion=this.eventuallyDispose(F))})}}getMirroredTestDataByReference(F){for(const{tests:M}of this.resources.values()){const L=M.getMirroredTestDataByReference(F);if(L)return L}}eventuallyDispose(F){return(0,I.disposableTimeout)(()=>this.unlisten(F),10*1e3)}createObserverData(F){const M=new re,L=this.listen(F,B=>M.apply(B)),O={observers:0,tests:M,listener:L};return this.resources.set(F.toString(),O),O}unlisten(F){var M;const L=F.toString(),O=this.resources.get(L);O&&(O.observers=-1,(M=O.pendingDeletion)===null||M===void 0||M.dispose(),O.listener.dispose(),this.resources.delete(L))}}class W extends V{constructor(F){super();this.proxy=F,this.diffListeners=new Map}acceptDiff(F,M){var L;(L=this.diffListeners.get(F.toString()))===null||L===void 0||L(M)}listen(F,M){this.proxy.$subscribeToDiffs(0,F);const L=F.toString();return this.diffListeners.set(L,M),new h.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,F),this.diffListeners.delete(L)})}}class $ extends V{constructor(F,M){super();this.proxy=F,this.documents=M,this.diffListeners=new Map}acceptDiff(F,M){var L;(L=this.diffListeners.get(F.toString()))===null||L===void 0||L(M)}listen(F,M){if(!this.documents.getDocument(F))return new h.Disposable(()=>{});const O=F.toString();return this.diffListeners.set(O,M),this.proxy.$subscribeToDiffs(1,F),new h.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,F),this.diffListeners.delete(O)})}}}),define(ge[261],pe([0,1,17,53,33,76,24,12,8,25,9,11,2,141,173,84,60,214,259,31]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E,w,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(v,d,b,R){this.configurationService=v,this.workspaceContextService=d,this.editorGroupsService=b,this.pathService=R}text(v,d,b={}){v=this.getContentPattern(v,b);const R=this.configurationService.getValue(),N=d&&d.some(re=>!this.configurationService.getValue({resource:re}).search.useRipgrep),q=this.commonQuery(d==null?void 0:d.map(E.toWorkspaceFolder),b);return Object.assign(Object.assign({},q),{type:2,contentPattern:v,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:R.search.usePCRE2||N||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles})}getContentPattern(v,d){const b=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},v),{wordSeparators:b.editor.wordSeparators});return this.isCaseSensitive(v,d)&&(R.isCaseSensitive=!0),this.isMultiline(v)&&(R.isMultiline=!0),R}file(v,d={}){const b=this.commonQuery(v,d);return Object.assign(Object.assign({},b),{type:1,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey})}handleIncludeExclude(v,d){return v?(v=Array.isArray(v)?v.map(i):i(v),d?this.parseSearchPaths(v):{pattern:t(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],d={}){const b=this.handleIncludeExclude(d.includePattern,d.expandPatterns),R=this.handleIncludeExclude(d.excludePattern,d.expandPatterns),N=v.length>1,q=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,d,R)):v.map(W=>this.getFolderQueryForRoot(W,d,R,N))).filter(W=>!!W),re={_reason:d._reason,folderQueries:q,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:R.pattern,includePattern:b.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const $=_.coalesce(_.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(M=>M.resource)))).filter(F=>(0,h.pathIncludedInQuery)(re,F.fsPath)),U=this.commonQueryFromFileList($);return Object.assign(Object.assign({},re),U)}const V=d.extraFileResources&&d.extraFileResources.filter(W=>(0,h.pathIncludedInQuery)(re,W.fsPath));return re.extraFileResources=V&&V.length?V:void 0,re}commonQueryFromFileList(v){const d=[],b=new y.ResourceMap,R={};let N=!1;return v.forEach(q=>{var re,V;if(q.scheme!==P.Schemas.walkThrough)if((0,k.isAbsolutePath)(q)){const $=(V=(re=this.workspaceContextService.getWorkspaceFolder(q))===null||re===void 0?void 0:re.uri)!==null&&V!==void 0?V:q.with({path:D.dirname(q.fsPath)});let U=b.get($);U||(N=!0,U={folder:$,includePattern:{}},d.push(U),b.set($,U));const F=D.relative($.fsPath,q.fsPath);(0,C.assertIsDefined)(U.includePattern)[F.replace(/\\/g,"/")]=!0}else q.fsPath&&(N=!0,R[q.fsPath]=!0)}),{folderQueries:d,includePattern:R,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(v,d){if(d.isSmartCase){if(v.isRegExp){if(r.containsUppercaseCharacter(v.pattern,!0))return!0}else if(r.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,p.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const d=U=>D.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),R=(Array.isArray(v)?v:n(v)).map(U=>{const F=this.pathService.resolvedUserHome;return F?(0,T.untildify)(U,F.scheme===P.Schemas.file?F.fsPath:F.path):U}),N=I.groupBy(R,U=>d(U)?"searchPaths":"exprSegments"),q=(N.exprSegments||[]).map(U=>r.rtrim(U,"/")).map(U=>r.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),o(U))),re={},V=this.expandSearchPathPatterns(N.searchPaths||[]);V&&V.length&&(re.searchPaths=V);const W=_.flatten(q),$=t(...W);return $&&(re.pattern=$),re}getExcludesForFolder(v,d){return d.disregardExcludeSettings?void 0:(0,h.getExcludes)(v,!d.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const d=_.flatten(v.map(R=>{let{pathPortion:N,globPortion:q}=m(R);q&&(q=s(q));const re=this.expandOneSearchPath(N);return _.flatten(re.map(V=>this.resolveOneSearchPathPattern(V,q)))})),b=new Map;return d.forEach(R=>{const N=R.searchPath.toString(),q=b.get(N);q?R.pattern&&(q.pattern=q.pattern||{},q.pattern[R.pattern]=!0):b.set(N,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(b.values())}expandOneSearchPath(v){if(D.isAbsolute(v)){const d=this.workspaceContextService.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==P.Schemas.file?[{searchPath:d[0].uri.with({path:v})}]:[{searchPath:f.URI.file(D.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const d=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=i(v),v.startsWith("../")||v===".."){const R=D.posix.resolve(d.path,v);return[{searchPath:d.with({path:R})}]}const b=s(v);return[{searchPath:d,pattern:b}]}else{if(v==="./"||v===".\\")return[];{const d=v.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(d){const b=d[1],R=this.workspaceContextService.getWorkspace().folders.filter(N=>N.name===b);if(R.length)return R.map(N=>{const q=d[2];return{searchPath:N.uri,pattern:q&&s(q)}});{const N=a.localize(0,null,b);throw new Error(N)}}}}return[]}resolveOneSearchPathPattern(v,d){const b=v.pattern&&d?`${v.pattern}/${d}`:v.pattern||d,R=[{searchPath:v.searchPath,pattern:b}];return b&&!b.endsWith("**")&&R.push({searchPath:v.searchPath,pattern:b+"/**"}),R}getFolderQueryForSearchPath(v,d,b){const R=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(v.searchPath),d,b,!1);return R?Object.assign(Object.assign({},R),{includePattern:v.pattern}):null}getFolderQueryForRoot(v,d,b,R){let N;const q=f.URI.isUri(v)?v:v.uri;if(b.searchPaths){const U=b.searchPaths.filter(F=>(0,k.isEqual)(F.searchPath,q))[0];if(U&&!U.pattern)return null;U&&(N=U.pattern)}const re=this.configurationService.getValue({resource:q}),V=this.getExcludesForFolder(re,d),W=Object.assign(Object.assign({},V||{}),N||{}),$=f.URI.isUri(v)?(0,k.basename)(v):v.name;return{folder:q,folderName:R?$:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:re.files&&re.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!re.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!re.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!re.search.followSymlinks}}};c=Ve([xe(0,u.IConfigurationService),xe(1,E.IWorkspaceContextService),xe(2,w.IEditorGroupsService),xe(3,S.IPathService)],c),e.QueryBuilder=c;function m(g){const v=g.match(/[\*\{\}\(\)\[\]\?]/);if(v){const d=v.index,b=g.substr(0,d).match(/[/|\\][^/\\]*$/);if(b){let R=g.substr(0,b.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:g.substr((b.index||0)+1)}}}return{pathPortion:g}}function t(...g){return g.length?g.reduce((v,d)=>(v[d]=!0,v),Object.create(null)):void 0}function n(g){return A.splitGlobAware(g,",").map(v=>v.trim()).filter(v=>!!v.length)}function o(g){return[`**/${g}/**`,`**/${g}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function i(g){return g.replace(/\\/g,"/")}function s(g){return i(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(g,v){g=_.distinct(g,R=>R.toString());const d=[],b=v.getWorkspace();return g&&g.forEach(R=>{let N;if(v.getWorkbenchState()===2)N=(0,k.relativePath)(b.folders[0].uri,R),N&&N!=="."&&(N="./"+N);else{const q=v.getWorkspaceFolder(R);if(q){const re=q.name;if(b.folders.filter(W=>W.name===re).length===1){const W=(0,k.relativePath)(q.uri,R);W===""?N=`./${q.name}`:N=`./${q.name}/${W}`}else N=R.fsPath}}N&&d.push(N)}),d}e.resolveResourcesForSearchIncludes=l}),define(ge[262],pe([0,1,25,2,21,16,4,261,31,60]),function(G,e,_,I,A,T,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const r=7e3;function C(u,E){const w=E.activationEvents;if(!w)return Promise.resolve(void 0);const S=[],h=[];for(const i of w)if(/^workspaceContains:/.test(i)){const s=i.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||u.forceUsingSearch?h.push(s):S.push(s)}if(S.length===0&&h.length===0)return Promise.resolve(void 0);let c;const m=new Promise((i,s)=>{c=i}),t=i=>c({activationEvent:i}),n=Promise.all(S.map(i=>f(u,i,t))).then(()=>{}),o=p(u,E.identifier,h,t);return Promise.all([n,o]).then(()=>{c(void 0)}),m}e.checkActivateWorkspaceContainsExtension=C;async function f(u,E,w){for(const S of u.folders)if(await u.exists(_.joinPath(I.URI.revive(S),E))){w(`workspaceContains:${E}`);return}}async function p(u,E,w,S){if(w.length===0)return Promise.resolve(void 0);const h=new A.CancellationTokenSource,c=u.checkExists(u.folders,w,h.token),m=setTimeout(async()=>{h.cancel(),S(`workspaceContainsTimeout:${w.join(",")}`)},r);let t=!1;try{t=await c}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}h.dispose(),clearTimeout(m),t&&S(`workspaceContains:${w.join(",")}`)}function a(u,E,w,S){const h=u.get(y.IInstantiationService),c=u.get(D.ISearchService),t=h.createInstance(P.QueryBuilder).file(E.map(n=>(0,k.toWorkspaceFolder)(I.URI.revive(n))),{_reason:"checkExists",includePattern:w,exists:!0});return c.fileSearch(t,S).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=a});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[42],pe([0,1,162,8,68,25,13,6,24,2,14,5,35,225,92,32,41,223,16,27,22,196,7,85,4,28,93,15,82,50,34,3,262,90,197]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E,w,S,h,c,m,t,n,o,i,s,l,g,v,d,b,R,N,q){"use strict";var re,V,W;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let $=class xn extends P.Disposable{constructor(L,O,B,j,Q,de,be,Ae,Ce,Le){super();this._onDidChangeRemoteConnectionData=this._register(new b.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=O,this._extHostContext=B,this._initData=be,this._extHostWorkspace=j,this._extHostConfiguration=Q,this._logService=de,this._extHostTunnelService=Ce,this._extHostTerminalService=Le,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=Ae,this._instaService=L.createChild(new g.ServiceCollection([a.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));const z=new Set;this._initData.hostExtensions.forEach(Y=>z.add(h.ExtensionIdentifier.toKey(Y))),this._activator=new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Y,ee,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Y,S.transformErrorForSerialization(ee),ae)},actualActivateExtension:async(Y,ee)=>{if(z.has(h.ExtensionIdentifier.toKey(Y)))return await this._mainThreadExtensionsProxy.$activateExtension(Y,ee),new p.HostExtension;const ae=this._registry.getExtensionDescription(Y);return this._activateExtension(ae,ee)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),A.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(L){S.onUnexpectedError(L)}}async deactivateAll(){let L=[];try{L=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(O){}await Promise.all(L)}isActivated(L){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(L):!1}_activateByEvent(L,O){return this._activator.activateByEvent(L,O)}_activateById(L,O){return this._activator.activateById(L,O)}activateByIdWithErrors(L,O){return this._activateById(L,O).then(()=>{const B=this._activator.getActivatedExtension(L);if(B.activationFailed)return Promise.reject(B.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(L=>this._registry)}getExtensionExports(L){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(L).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const L=D.TernarySearchTree.forPaths(),O=this._registry.getAllExtensionDescriptions().map(B=>{if(!!this._getEntryPoint(B))return this._hostUtils.realpath(B.extensionLocation.fsPath).then(j=>L.set(k.URI.file(j).fsPath,B))});this._extensionPathIndex=Promise.all(O).then(()=>L)}return this._extensionPathIndex}_deactivate(L){let O=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(L))return O;const B=this._activator.getActivatedExtension(L);if(!B)return O;try{typeof B.module.deactivate=="function"&&(O=Promise.resolve(B.module.deactivate()).then(void 0,j=>Promise.resolve(void 0)))}catch(j){}try{(0,P.dispose)(B.subscriptions)}catch(j){}return O}async _activateExtension(L,O){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(L.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(L.identifier),this._doActivateExtension(L,O).then(B=>{const j=B.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(L.identifier,j.codeLoadingTime,j.activateCallTime,j.activateResolvedTime,O),this._logExtensionActivationTimes(L,O,"success",j),B},B=>{throw this._logExtensionActivationTimes(L,O,"failure"),B})}_logExtensionActivationTimes(L,O,B,j){const Q=U(L,O);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},Q),j||{}),{outcome:B}))}_doActivateExtension(L,O){const B=U(L,O);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",B);const j=this._getEntryPoint(L);if(!j)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${L.identifier.value} ${JSON.stringify(O)}`),this._logService.flush();const Q=new p.ExtensionActivationTimesBuilder(O.startup);return Promise.all([this._loadCommonJSModule(L.identifier,(0,T.joinPath)(L.extensionLocation,j),Q),this._loadExtensionContext(L)]).then(de=>(A.mark(`code/extHost/willActivateExtension/${L.identifier.value}`),xn._callActivate(this._logService,L.identifier,de[0],de[1],Q))).then(de=>(A.mark(`code/extHost/didActivateExtension/${L.identifier.value}`),de))}_loadExtensionContext(L){const O=new m.ExtensionGlobalMemento(L,this._storage),B=new m.ExtensionMemento(L.identifier.value,!1,this._storage),j=new q.ExtensionSecrets(L,this._secretState),Q=L.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${L.identifier.value}`),Promise.all([O.whenReady,B.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let Ae;return Object.freeze({globalState:O,workspaceState:B,secrets:j,subscriptions:[],get extensionUri(){return L.extensionLocation},get extensionPath(){return L.extensionLocation.fsPath},asAbsolutePath(Ce){return I.join(L.extensionLocation.fsPath,Ce)},get storagePath(){var Ce;return(Ce=be._storagePath.workspaceValue(L))===null||Ce===void 0?void 0:Ce.fsPath},get globalStoragePath(){return be._storagePath.globalValue(L).fsPath},get logPath(){return I.join(be._initData.logsLocation.fsPath,L.identifier.value)},get logUri(){return k.URI.joinPath(be._initData.logsLocation,L.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(L)},get globalStorageUri(){return be._storagePath.globalValue(L)},get extensionMode(){return Q},get extension(){return Ae===void 0&&(Ae=new F(be,L.identifier,L,de)),Ae},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(L),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(L)}})})}static _callActivate(L,O,B,j,Q){return B=B||{activate:void 0,deactivate:void 0},this._callActivateOptional(L,O,B,j,Q).then(de=>new p.ActivatedExtension(!1,null,Q.build(),B,de,j.subscriptions))}static _callActivateOptional(L,O,B,j,Q){if(typeof B.activate=="function")try{Q.activateCallStart(),L.trace(`ExtensionService#_callActivateOptional ${O.value}`);const de=typeof global=="object"?global:self,be=B.activate.apply(de,[j]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(be).then(Ae=>(Q.activateResolveStop(),Ae))}catch(de){return Promise.reject(de)}else return Promise.resolve(B)}_activateOneStartupFinished(L,O){this._activateById(L.identifier,{startup:!1,extensionId:L.identifier,activationEvent:O}).then(void 0,B=>{this._logService.error(B)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(A.getMarks());for(const L of this._registry.getAllExtensionDescriptions())if(L.activationEvents)for(const O of L.activationEvents)O==="onStartupFinished"&&this._activateOneStartupFinished(L,O)}_handleEagerExtensions(){const L=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const O=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],B=this._handleWorkspaceContainsEagerExtensions(O),j=Promise.all([L,B]).then(()=>{});return Promise.race([j,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),j}_handleWorkspaceContainsEagerExtensions(L){return L.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(O=>this._handleWorkspaceContainsEagerExtension(L,O))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(L,O){if(!this.isActivated(O.identifier)){const B=!this._initData.remote.isRemote&&!!this._initData.remote.authority,j={folders:L.map(de=>de.uri),forceUsingSearch:B,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,be,Ae)=>this._mainThreadWorkspaceProxy.$checkExists(de,be,Ae)},Q=await(0,R.checkActivateWorkspaceContainsExtension)(j,O);if(!!Q)return this._activateById(O.identifier,{startup:!0,extensionId:O.identifier,activationEvent:Q.activationEvent}).then(void 0,de=>this._logService.error(de))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(L){throw console.error(L),L}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:L,extensionTestsLocationURI:O}=this._initData.environment;if(!L||!O)throw new Error(_.localize(0,null));const B=await this._loadCommonJSModule(null,O,new p.ExtensionActivationTimesBuilder(!1));if(!B||typeof B.run!="function")throw new Error(_.localize(1,null,O.toString()));return new Promise((j,Q)=>{const de=(Ce,Le)=>{Ce?Q(Ce):j(typeof Le=="number"&&Le>0?1:0)},be=(0,T.originalFSPath)(O),Ae=B.run(be,de);Ae&&Ae.then&&Ae.then(()=>{j(0)}).catch(Ce=>{Q(Ce.toString())})})}async $extensionTestsExit(L){this._logService.info(`extension host terminating: test runner requested exit with code ${L}`),this._logService.info(`exiting with code ${L}`),this._logService.flush(),this._hostUtils.exit(L)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(L,O){return this._resolvers[L]=O,(0,P.toDisposable)(()=>{delete this._resolvers[L]})}async $resolveAuthority(L,O){const B=L.indexOf("+");if(B===-1)throw new Error("Not an authority that can be resolved!");const j=L.substr(0,B);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${j}`,!1);const Q=this._resolvers[j];if(!Q)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${j}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(Q)),A.mark(`code/extHost/willResolveAuthority/${j}`);const de=await Q.resolve(L,{resolveAttempt:O});A.mark(`code/extHost/didResolveAuthorityOK/${j}`);const be={authority:L,host:de.host,port:de.port,connectionToken:de.connectionToken},Ae={extensionHostEnv:de.extensionHostEnv,trust:de.trust};return{type:"ok",value:{authority:be,options:Ae,tunnelInformation:{environmentTunnels:de.environmentTunnels}}}}catch(de){if(A.mark(`code/extHost/didResolveAuthorityError/${j}`),de instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:de._code,message:de._message,detail:de._detail}};throw de}}$startExtensionHost(L){return this._registry.keepOnly(L),this._startExtensionHost()}$activateByEvent(L,O){return O===1?this._activateByEvent(L,!1):this._readyToRunExtensions.wait().then(B=>this._activateByEvent(L,!1))}async $activate(L,O){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(L)?(await this._activateById(L,O),!0):!1}async $deltaExtensions(L,O){L.forEach(j=>j.extensionLocation=k.URI.revive(j.extensionLocation));const B=await this.getExtensionPathIndex();return await Promise.all(O.map(async j=>{const Q=this._registry.getExtensionDescription(j);if(!!Q){const de=await this._hostUtils.realpath(Q.extensionLocation.fsPath);B.delete(k.URI.file(de).fsPath)}})),await Promise.all(L.map(async j=>{const Q=await this._hostUtils.realpath(j.extensionLocation.fsPath);B.set(k.URI.file(Q).fsPath,j)})),this._registry.deltaExtensions(L,O),Promise.resolve(void 0)}async $test_latency(L){return L}async $test_up(L){return L.byteLength}async $test_down(L){let O=c.VSBuffer.alloc(L),B=Math.random()%256;for(let j=0;j<L;j++)O.writeUInt8(B,j);return O}async $updateRemoteConnectionData(L){this._remoteConnectionData=L,this._onDidChangeRemoteConnectionData.fire()}};$=Ve([xe(0,o.IInstantiationService),xe(1,e.IHostUtils),xe(2,l.IExtHostRpcService),xe(3,u.IExtHostWorkspace),xe(4,f.IExtHostConfiguration),xe(5,r.ILogService),xe(6,i.IExtHostInitDataService),xe(7,s.IExtensionStoragePaths),xe(8,v.IExtHostTunnelService),xe(9,d.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function U(M,L){return{id:M.identifier.value,name:M.name,extensionVersion:M.version,publisherDisplayName:M.publisher,activationEvents:M.activationEvents?M.activationEvents.join(","):null,isBuiltin:M.isBuiltin,reason:L.activationEvent,reasonId:L.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class F{constructor(L,O,B,j){re.set(this,void 0),V.set(this,void 0),W.set(this,void 0),tt(this,re,L,"f"),tt(this,V,O,"f"),tt(this,W,B.identifier,"f"),this.id=B.identifier.value,this.extensionUri=B.extensionLocation,this.extensionPath=I.normalize((0,T.originalFSPath)(B.extensionLocation)),this.packageJSON=B,this.extensionKind=j}get isActive(){return Ue(this,re,"f").isActivated(Ue(this,W,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,re,"f").getExtensionExports(Ue(this,W,"f"))}activate(){return Ue(this,re,"f").activateByIdWithErrors(Ue(this,W,"f"),{startup:!1,extensionId:Ue(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,re=new WeakMap,V=new WeakMap,W=new WeakMap}),define(ge[47],pe([0,1,8,2,3,13,5,7,121,32,42,39,213,35,204,15,4,11,36]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let h=class{constructor(l,g,v,d,b){this._workspaceService=g,this._extensionService=v,this._editorsService=d,this._configurationService=b,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=l.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new m(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(N=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(l,g){const v=l;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let d=`debug:${encodeURIComponent(v.path||"")}`,b="?";return g&&(d+=`${b}session=${encodeURIComponent(g.id)}`,b="&"),d+=`${b}ref=${v.sourceReference}`,I.URI.parse(d)}else{if(v.path)return I.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const g=[];for(const v of l.getAllExtensionDescriptions())if(v.contributes){const d=v.contributes.debuggers;if(d&&d.length>0)for(const b of d)(0,a.isDebuggerMainContribution)(b)&&g.push(b.type)}this._debugServiceProxy.$registerDebugTypes(g)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(g=>l.push(g)),l}addBreakpoints(l){this.startBreakpoints();const g=l.filter(b=>{const R=b.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,b),!0)});this.fireBreakpointChanges(g,[],[]);const v=[],d=new Map;for(const b of g)if(b instanceof P.SourceBreakpoint){let R=d.get(b.location.uri.toString());R||(R={type:"sourceMulti",uri:b.location.uri,lines:[]},d.set(b.location.uri.toString(),R),v.push(R)),R.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character})}else b instanceof P.FunctionBreakpoint&&v.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName});return this._debugServiceProxy.$registerBreakpoints(v)}removeBreakpoints(l){this.startBreakpoints();const g=l.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],g,[]);const v=g.filter(R=>R instanceof P.SourceBreakpoint).map(R=>R.id),d=g.filter(R=>R instanceof P.FunctionBreakpoint).map(R=>R.id),b=g.filter(R=>R instanceof P.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(v,d,b)}startDebugging(l,g,v){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,g,{parentSessionID:v.parentSession?v.parentSession.id:void 0,repl:v.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,g,v){if(!g)return new P.Disposable(()=>{});const d=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:d,provider:g}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,v,!!g.provideDebugConfigurations,!!g.resolveDebugConfiguration,!!g.resolveDebugConfigurationWithSubstitutedVariables,d),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(b=>b.provider!==g),this._debugServiceProxy.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(l,g,v){if(!v)return new P.Disposable(()=>{});if(!this.definesDebugType(l,g))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${g}' debugger.`);if(this.getAdapterDescriptorFactoryByType(g))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:g,handle:d,factory:v}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(g,d),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(b=>b.factory!==v),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(l,g){if(!g)return new P.Disposable(()=>{});const v=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:v,factory:g}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(d=>d.factory!==g)})}async $runInTerminal(l,g){return Promise.resolve(void 0)}async $substituteVariables(l,g){if(!this._variableResolver){const[b,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(b||[],this._editorsService,R)}let v;const d=await this.getFolder(l);return d&&(v={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(v,g)}createDebugAdapter(l,g){if(l.type==="implementation")return new o(l.implementation)}createSignService(){}async $startDASession(l,g){const v=this,d=await this.getSession(g);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(d.type),d).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const R=this.convertToDto(b),N=this.createDebugAdapter(R,d);if(!N)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const q=N;return this._debugAdapters.set(l,q),this.getDebugAdapterTrackers(d).then(re=>(re&&this._debugAdaptersTrackers.set(l,re),q.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const W=V,$={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(W.arguments.value);$.body={signature:U},q.sendResponse($)}else throw new Error("no signer")}catch(U){$.success=!1,$.message=U.message,q.sendResponse($)}}else re&&re.onDidSendMessage&&re.onDidSendMessage(V),V=(0,a.convertToVSCPaths)(V,!0),v._debugServiceProxy.$acceptDAMessage(l,V)}),q.onError(V=>{re&&re.onError&&re.onError(V),this._debugServiceProxy.$acceptDAError(l,V.name,V.message,V.stack)}),q.onExit(V=>{re&&re.onExit&&re.onExit((0,w.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,w.withNullAsUndefined)(V),void 0)}),re&&re.onWillStartSession&&re.onWillStartSession(),q.startSession()))})}$sendDAMessage(l,g){g=(0,a.convertToDAPaths)(g,!1);const v=this._debugAdaptersTrackers.get(l);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(g);const d=this._debugAdapters.get(l);d&&d.sendMessage(g)}$stopDASession(l){const g=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),g&&g.onWillStopSession&&g.onWillStopSession();const v=this._debugAdapters.get(l);return this._debugAdapters.delete(l),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const g=[],v=[],d=[];if(l.added)for(const b of l.added){const R=b.id;if(R&&!this._breakpoints.has(R)){let N;if(b.type==="function")N=new P.FunctionBreakpoint(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage);else if(b.type==="data")N=new P.DataBreakpoint(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage);else{const q=I.URI.revive(b.uri);N=new P.SourceBreakpoint(new P.Location(q,new P.Position(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage)}N._id=R,this._breakpoints.set(R,N),g.push(N)}}if(l.removed)for(const b of l.removed){const R=this._breakpoints.get(b);R&&(this._breakpoints.delete(b),v.push(R))}if(l.changed){for(const b of l.changed)if(b.id){const R=this._breakpoints.get(b.id);if(R){if(R instanceof P.FunctionBreakpoint&&b.type==="function"){const N=R;N.enabled=b.enabled,N.condition=b.condition,N.hitCondition=b.hitCondition,N.logMessage=b.logMessage,N.functionName=b.functionName}else if(R instanceof P.SourceBreakpoint&&b.type==="source"){const N=R;N.enabled=b.enabled,N.condition=b.condition,N.hitCondition=b.hitCondition,N.logMessage=b.logMessage,N.location=new P.Location(I.URI.revive(b.uri),new P.Position(b.line,b.character))}d.push(R)}}}this.fireBreakpointChanges(g,v,d)}$provideDebugConfigurations(l,g,v){return(0,T.asPromise)(async()=>{const d=this.getConfigProviderByHandle(l);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.getFolder(g);return d.provideDebugConfigurations(b,v)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(l,g,v,d){return(0,T.asPromise)(async()=>{const b=this.getConfigProviderByHandle(l);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(g);return b.resolveDebugConfiguration(R,v,d)})}$resolveDebugConfigurationWithSubstitutedVariables(l,g,v,d){return(0,T.asPromise)(async()=>{const b=this.getConfigProviderByHandle(l);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(g);return b.resolveDebugConfigurationWithSubstitutedVariables(R,v,d)})}async $provideDebugAdapter(l,g){const v=this.getAdapterDescriptorFactoryByHandle(l);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.getSession(g);return this.getAdapterDescriptor(v,d).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.convertToDto(b)})}async $acceptDebugSessionStarted(l){const g=await this.getSession(l);this._onDidStartDebugSession.fire(g)}async $acceptDebugSessionTerminated(l){const g=await this.getSession(l);g&&(this._onDidTerminateDebugSession.fire(g),this._debugSessions.delete(g.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,g){const v=await this.getSession(l);v&&v._acceptNameChanged(g)}async $acceptDebugSessionCustomEvent(l,g){const d={session:await this.getSession(l),event:g.event,body:g.body};this._onDidReceiveDebugSessionCustomEvent.fire(d)}convertToDto(l){if(l instanceof P.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof P.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const g=this._adapterFactories.filter(v=>v.type===l);if(g.length>0)return g[0].factory}getAdapterDescriptorFactoryByHandle(l){const g=this._adapterFactories.filter(v=>v.handle===l);if(g.length>0)return g[0].factory}getConfigProviderByHandle(l){const g=this._configProviders.filter(v=>v.handle===l);if(g.length>0)return g[0].provider}definesDebugType(l,g){if(l.contributes){const v=l.contributes.debuggers;if(v&&v.length>0){for(const d of v)if(d.label&&d.type&&d.type===g)return!0}}return!1}getDebugAdapterTrackers(l){const v=l.configuration.type,d=this._trackerFactories.filter(b=>b.type===v||b.type==="*").map(b=>(0,T.asPromise)(()=>b.factory.createDebugAdapterTracker(l)).then(R=>R,R=>null));return Promise.race([Promise.all(d).then(b=>{const R=b.filter(N=>!!N);if(R.length>0)return new n(R)}),new Promise((b,R)=>{const N=setTimeout(()=>{clearTimeout(N),R(new Error("timeout"))},1e3)})]).catch(b=>{})}async getAdapterDescriptor(l,g){const v=g.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new P.DebugAdapterServer(v));if(l){const b=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>l.createDebugAdapterDescriptor(g,this.daExecutableFromPackage(g,b))).then(R=>{if(R)return R})}const d=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(g,d))}daExecutableFromPackage(l,g){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,g,v){(l.length>0||g.length>0||v.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:g,changed:v}))}async getSession(l){if(l)if(typeof l=="string"){const g=this._debugSessions.get(l);if(g)return g}else{let g=this._debugSessions.get(l.id);if(!g){const v=await this.getFolder(l.folderUri);g=new c(this._debugServiceProxy,l.id,l.type,l.name,v,l.configuration),this._debugSessions.set(g.id,g),this._debugServiceProxy.$sessionCached(g.id)}return g}throw new Error("cannot find session")}getFolder(l){if(l){const g=I.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(g)}return Promise.resolve(void 0)}};h=Ve([xe(0,u.IExtHostRpcService),xe(1,k.IExtHostWorkspace),xe(2,r.IExtHostExtensionService),xe(3,C.IExtHostDocumentsAndEditors),xe(4,p.IExtHostConfiguration)],h),e.ExtHostDebugServiceBase=h;class c{constructor(l,g,v,d,b,R){this._debugServiceProxy=l,this._id=g,this._type=v,this._name=d,this._workspaceFolder=b,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,g){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,g)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=c;class m{constructor(l){this.value=Object.freeze({append(g){l.$appendDebugConsole(g)},appendLine(g){this.append(g+`
`)}})}}e.ExtHostDebugConsole=m;class t extends f.AbstractVariableResolverService{constructor(l,g,v,d){super({getFolderUri:b=>{const R=l.filter(N=>N.name===b);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(b,R)=>v.getConfiguration(void 0,b).get(R),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(g){const b=g.activeEditor();if(b)return _.normalize(b.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(g&&d){const b=g.activeEditor();if(b){const R=d.getWorkspaceFolder(b.document.uri);if(R)return _.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(g){const b=g.activeEditor();if(b&&!b.selection.isEmpty)return b.document.getText(b.selection)}},getLineNumber:()=>{if(g){const b=g.activeEditor();if(b)return String(b.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=t;class n{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(g=>g.onWillReceiveMessage?g.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(g=>g.onDidSendMessage?g.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(g=>g.onError?g.onError(l):void 0)}onExit(l,g){this.trackers.forEach(v=>v.onExit?v.onExit(l,g):void 0)}}class o extends D.AbstractDebugAdapter{constructor(l){super();this.implementation=l,l.onDidSendMessage(g=>{this.acceptMessage(g)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends h{constructor(l,g,v,d,b){super(l,g,v,d,b)}createVariableResolver(l,g,v){return new t(l,g,v)}};i=Ve([xe(0,u.IExtHostRpcService),xe(1,k.IExtHostWorkspace),xe(2,r.IExtHostExtensionService),xe(3,C.IExtHostDocumentsAndEditors),xe(4,p.IExtHostConfiguration)],i),e.WorkerExtHostDebugService=i}),define(ge[263],pe([0,1,68,2,5,35,41,27,15,28,4,42,36,14]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(h,c,m,t,n,o,i){this._apiFactory=h,this._extensionRegistry=c,this._instaService=m,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=o,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const h=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,c,this._extensionRegistry,h,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,c,this._initData.environment.appUriScheme))}register(h){if(Array.isArray(h.nodeModuleName))for(let c of h.nodeModuleName)this._factories.set(c,h);else this._factories.set(h.nodeModuleName,h);typeof h.alternativeModuleName=="function"&&this._alternatives.push(c=>h.alternativeModuleName(c))}};a=Ve([xe(2,r.IInstantiationService),xe(3,T.IExtHostConfiguration),xe(4,C.IExtHostExtensionService),xe(5,k.IExtHostInitDataService),xe(6,p.ILogService)],a),e.RequireInterceptor=a;class u{constructor(h,c,m,t,n){this._apiFactory=h,this._extensionPaths=c,this._extensionRegistry=m,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(h,c){const m=this._extensionPaths.findSubstr(c.fsPath);if(m){let t=this._extApiImpl.get(P.ExtensionIdentifier.toKey(m.identifier));return t||(t=this._apiFactory(m,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(m.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,o)=>t+=`	${o} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(h,c){this.nodeModuleName="keytar";const{environment:m}=c,t=h.getProxy(A.MainContext.MainThreadKeytar);if(m.appRoot){let n=m.appRoot.fsPath;f.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,o)=>t.$getPassword(n,o),setPassword:(n,o,i)=>t.$setPassword(n,o,i),deletePassword:(n,o)=>t.$deletePassword(n,o),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(h,c){return this._impl}alternativeModuleName(h){const c=h.length;if(!(c<=7||!this.alternativeNames)){const m=c-7;if((h.charAt(m)==="/"||h.charAt(m)==="\\")&&h.endsWith("keytar")&&(h=h.replace(/\\/g,"/"),this.alternativeNames.has(h)))return"keytar"}}};E=Ve([xe(0,D.IExtHostRpcService),xe(1,k.IExtHostInitDataService)],E);let w=class{constructor(h,c,m){this._extensionPaths=h,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=m.getProxy(A.MainContext.MainThreadTelemetry);const t=m.getProxy(A.MainContext.MainThreadWindow);this._impl=(n,o)=>{const i=I.URI.parse(n);return o?this.callOriginal(n,o):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,n,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,n,{}):this.callOriginal(n,o)}}load(h,c,m){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=m(h),this._impl}callOriginal(h,c){return this.sendNoForwardTelemetry(),this._original(h,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=Ve([xe(2,D.IExtHostRpcService)],w)}),define(ge[264],pe([0,1,168,10,7,205,32,42,39,35,34,15,47,189,208,13]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let E=class extends f.ExtHostDebugServiceBase{constructor(h,c,m,t,n,o){super(h,c,m,t,n);this._terminalService=o,this._integratedTerminalInstances=new w}createDebugAdapter(h,c){switch(h.type){case"server":return new T.SocketDebugAdapter(h);case"pipeServer":return new T.NamedPipeDebugAdapter(h);case"executable":return new T.ExecutableDebugAdapter(h,c.type)}return super.createDebugAdapter(h,c)}daExecutableFromPackage(h,c){const m=T.ExecutableDebugAdapter.platformAdapterExecutable(c.getAllExtensionDescriptions(),h.type);if(m)return new A.DebugAdapterExecutable(m.command,m.args,m.options)}createSignService(){return new p.SignService}async $runInTerminal(h,c){if(h.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(b=>{this._integratedTerminalInstances.onTerminalClosed(b)}));const m=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,m),n=this._terminalService.getDefaultShellArgs(!0,m),o=JSON.stringify({shell:t,shellArgs:n});let i=await this._integratedTerminalInstances.checkout(o),s,l=!1;if(i)s=h.cwd;else{const b={shellPath:t,shellArgs:n,cwd:h.cwd,name:h.title||_.localize(0,null)};l=!0,i=this._terminalService.createTerminalFromOptions(b,!0),this._integratedTerminalInstances.insert(i,o)}i.show(!0);const g=await i.processId;l?await new Promise(b=>setTimeout(b,1e3)):m.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?i.sendText("cls"):t.indexOf("bash")>=0?i.sendText("clear"):I.isWindows?i.sendText("cls"):i.sendText("clear"));const v=(0,a.prepareCommand)(t,h.args,s,h.env);i.sendText(v);const d=this.onDidTerminateDebugSession(b=>{b.id===c&&(this._integratedTerminalInstances.free(i),d.dispose())});return g}else if(h.kind==="external")return(0,a.runInExternalTerminal)(h,await this._configurationService.getConfigProvider());return super.$runInTerminal(h,c)}createVariableResolver(h,c,m){return new f.ExtHostVariableResolverService(h,c,m,this._workspaceService)}};E=Ve([xe(0,C.IExtHostRpcService),xe(1,y.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,D.IExtHostDocumentsAndEditors),xe(4,k.IExtHostConfiguration),xe(5,r.IExtHostTerminalService)],E),e.ExtHostDebugService=E;class w{constructor(){this._terminalInstances=new Map}async checkout(h){const m=[...this._terminalInstances.entries()].map(([t,n])=>(0,u.createCancelablePromise)(async o=>{if(n.lastUsedAt!==-1&&await(0,a.hasChildProcesses)(await t.processId))return null;const i=Date.now();return n.lastUsedAt+w.minUseDelay>i||o.isCancellationRequested||n.config!==h?null:(n.lastUsedAt=i,t)}));return await(0,u.firstParallel)(m,t=>!!t)}insert(h,c){this._terminalInstances.set(h,{lastUsedAt:Date.now(),config:c})}free(h){const c=this._terminalInstances.get(h);c&&(c.lastUsedAt=-1)}onTerminalClosed(h){this._terminalInstances.delete(h)}}w.minUseDelay=1e3}),define(ge[265],pe([0,1,8,2,78,32,47,39,35,34,15,28,67,12,14,63]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let E=class extends f.ExtHostTaskBase{constructor(S,h,c,m,t,n,o,i){super(S,h,c,m,t,n,o,i);this.workspaceService=c,h.remote.isRemote&&h.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:h.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(S,h){const c=h;if(!h.execution&&c._id===void 0)throw new Error("Tasks to execute must include an execution");if(c._id!==void 0){const m=f.TaskHandleDTO.from(c,this.workspaceService),t=await this._proxy.$getTaskExecution(m);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(t,h);return this._proxy.$executeTask(m).catch(()=>{}),n}else{const m=f.TaskDTO.from(h,S);if(m===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(m.execution)&&await this.addCustomExecution(m,h,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(m),h);return this._proxy.$executeTask(m).catch(()=>{}),t}}provideTasksInternal(S,h,c,m){const t=[];if(m)for(let n of m){this.checkDeprecation(n,c),(!n.definition||!S[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const o=f.TaskDTO.from(n,c.extension);o&&(t.push(o),f.CustomExecutionDTO.is(o.execution)&&h.push(this.addCustomExecution(o,n,!0)))}return{tasks:t,extension:c.extension}}async resolveTaskInternal(S){return S}async getVariableResolver(S){if(this._variableResolver===void 0){const h=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(S,this._editorService,h,this.workspaceService)}return this._variableResolver}async $resolveVariables(S,h){const c=I.URI.revive(S),m={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(c),n=await this._workspaceProvider.getWorkspaceFolders2();if(!n||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const o=await this.getVariableResolver(n),i={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let s of h.variables)m.variables[s]=await o.resolveAsync(i,s);if(h.process!==void 0){let s;if(h.process.path!==void 0){s=h.process.path.split(_.delimiter);for(let l=0;l<s.length;l++)s[l]=await o.resolveAsync(i,s[l])}m.process=await A.win32.findExecutable(await o.resolveAsync(i,h.process.name),h.process.cwd!==void 0?await o.resolveAsync(i,h.process.cwd):void 0,s)}return m}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(S,h,c){return A.win32.findExecutable(S,h,c)}};E=Ve([xe(0,r.IExtHostRpcService),xe(1,C.IExtHostInitDataService),xe(2,T.IExtHostWorkspace),xe(3,P.IExtHostDocumentsAndEditors),xe(4,D.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,a.ILogService),xe(7,u.IExtHostApiDeprecationService)],E),e.ExtHostTask=E}),define(ge[266],pe([0,1,10,11,30,150,14,35,47,39,15,34,32,211,212]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let u=class extends C.BaseExtHostTerminalService{constructor(w,S,h,c,m){super(!0,w);this._extHostConfiguration=S,this._extHostWorkspace=h,this._extHostDocumentsAndEditors=c,this._logService=m,(0,T.getSystemShell)(_.OS,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(w,S,h){const c=new C.ExtHostTerminal(this._proxy,(0,A.generateUuid)(),{name:w,shellPath:S,shellArgs:h},w);return this._terminals.push(c),c.create(S,h),c.value}createTerminalFromOptions(w,S){const h=new C.ExtHostTerminal(this._proxy,(0,A.generateUuid)(),w,w.name);return this._terminals.push(h),h.create((0,I.withNullAsUndefined)(w.shellPath),(0,I.withNullAsUndefined)(w.shellArgs),(0,I.withNullAsUndefined)(w.cwd),(0,I.withNullAsUndefined)(w.env),(0,I.withNullAsUndefined)(w.icon),(0,I.withNullAsUndefined)(w.message),void 0,(0,I.withNullAsUndefined)(w.strictEnv),(0,I.withNullAsUndefined)(w.hideFromUser),(0,I.withNullAsUndefined)(S),!0),h.value}getDefaultShell(w,S){var h;return p.getDefaultShell(this._buildSafeConfigProvider(S),(h=this._defaultShell)!==null&&h!==void 0?h:(0,T.getSystemShellSync)(_.OS,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,p.createVariableResolver(this._lastActiveWorkspace,process.env,this._variableResolver),this._logService,w)}getDefaultShellArgs(w,S){return p.getDefaultShellArgs(this._buildSafeConfigProvider(S),w,p.createVariableResolver(this._lastActiveWorkspace,process.env,this._variableResolver),this._logService)}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const w=this._extHostDocumentsAndEditors.activeEditor();w&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(w.document.uri))}async _updateVariableResolver(){const w=await this._extHostConfiguration.getConfigProvider(),S=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new D.ExtHostVariableResolverService(S||[],this._extHostDocumentsAndEditors,w),this._variableResolver}async $getAvailableProfiles(w){const S=this._buildSafeConfigProvider(await this._extHostConfiguration.getConfigProvider());return(0,a.detectAvailableProfiles)(w,S,void 0,this._logService,await this._variableResolverPromise,this._lastActiveWorkspace)}async $getDefaultShellAndArgs(w){const S=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(w,S),args:this.getDefaultShellArgs(w,S)}}_buildSafeConfigProvider(w){const S=w.getConfiguration();return h=>{if(S.get("terminal.integrated.allowWorkspaceConfiguration"))return S.get(h);const m=S.inspect(h);return(m==null?void 0:m.globalValue)||(m==null?void 0:m.defaultValue)}}};u=Ve([xe(0,r.IExtHostRpcService),xe(1,P.IExtHostConfiguration),xe(2,f.IExtHostWorkspace),xe(3,k.IExtHostDocumentsAndEditors),xe(4,y.ILogService)],u),e.ExtHostTerminalService=u}),define(ge[267],pe([0,1,13,16,68,6,2,5,257,14,79,82,28,185,15,62,42,34]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(c,m,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const o=new D.RPCProtocol(c,null,n);m=S._transform(m,o);const i=new C.ServiceCollection(...(0,r.getSingletonServiceDescriptors)());i.set(f.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},m)),i.set(a.IExtHostRpcService,new a.ExtHostRpcService(o)),i.set(u.IURITransformerService,new u.URITransformerService(n)),i.set(E.IHostUtils,t);const s=new p.InstantiationService(i,!0),l=s.invokeFunction(b=>b.get(w.IExtHostTerminalService));this._disposables.add(l),this._logService=s.invokeFunction(b=>b.get(k.ILogService)),A.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",m),this._extensionService=s.invokeFunction(b=>b.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(R,N)=>{let q="",re,V;for(const W of N)q+=`
	at ${W.toString()}`,V=W.getFileName(),!re&&V&&(re=b.findSubstr(V));return g.set(R,re),`${R.name||"Error"}: ${R.message||""}${q}`}});const v=o.getProxy(P.MainContext.MainThreadExtensionService),d=o.getProxy(P.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(b=>{const R=I.transformErrorForSerialization(b),N=g.get(b);N?v.$onExtensionRuntimeError(N.identifier,R):d.$onUnexpectedError(R)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(t=>{});const m=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,_.timeout)(4e3),m]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,m){c.extensions.forEach(n=>n.extensionLocation=y.URI.revive(m.transformIncomingURIs(n.extensionLocation))),c.environment.appRoot=y.URI.revive(m.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(m.transformIncomingURIs(n)))),c.environment.extensionTestsLocationURI=y.URI.revive(m.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=y.URI.revive(m.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=y.URI.revive(m.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=y.URI.revive(m.transformIncomingURIs(c.logsLocation)),c.logFile=y.URI.revive(m.transformIncomingURIs(c.logFile)),c.workspace=m.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=S}),define(ge[268],pe([0,1,8,21,59,33,25,48,31]),function(G,e,_,I,A,T,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(f,p,a){this.config=f,this.provider=p,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&T.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&T.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const p=this.config.folderQueries||[];return new Promise((a,u)=>{const E=w=>{this.resultCount++,f(w)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const S=w.toString(),h=_.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,h)||this.matchFile(E,{base:w,basename:h})}),Promise.all(p.map(w=>this.searchInFolder(w,E))).then(w=>{a({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{u(new Error((0,A.toErrorMessage)(w)))})})}async searchInFolder(f,p){const a=new I.CancellationTokenSource,u=this.getSearchOptionsForFolder(f),E=this.initDirectoryTree(),w=new D.QueryGlobTester(this.config,f),S=!w.hasSiblingExcludeClauses();let h;try{this.activeCancellationTokens.add(a),h=P.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,a.token),m=h.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(n=>{const o=_.posix.relative(f.folder.path,n.path);if(S){const i=_.basename(n.path);this.matchFile(p,{base:f.folder,relativePath:o,basename:i});return}this.addDirectoryEntries(E,f.folder,o,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,w,p),{providerTime:m,postProcessTime:t.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(f){const p=(0,D.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:a,includes:p,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},p,a,u){if(a===this.filePattern){const w=_.basename(this.filePattern);this.matchFile(u,{base:p,relativePath:this.filePattern,basename:w})}function E(w){const S=_.basename(w),h=_.dirname(w);let c=f[h];c||(c=f[h]=[],E(h)),c.push({base:p,relativePath:w,basename:S})}E(a)}matchDirectoryTree({rootEntries:f,pathToEntries:p},a,u){const E=this,w=this.filePattern;function S(h){const c=T.hasSiblingFn(()=>h.map(m=>m.basename));for(let m=0,t=h.length;m<t;m++){const n=h[m],{relativePath:o,basename:i}=n;if(!!a.includedInQuerySync(o,i,w!==i?c:void 0)){const s=p[o];if(s)S(s);else{if(o===w)continue;E.matchFile(u,n)}if(E.isLimitHit)break}}}S(f)}matchFile(f,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(p))}}class r{constructor(){this.sessions=new Map}fileSearch(f,p,a,u){const E=this.getSessionTokenSource(f.cacheKey),w=new k(f,p,E&&E.token);let S=0;const h=c=>{S+=c.length,a(c.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(w,r.BATCH_SIZE,h,u).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:c.stats}}))}clearCache(f){const p=this.getSessionTokenSource(f);p&&p.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new I.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:y.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,p,a,u){u.onCancellationRequested(()=>{f.cancel()});const E=S=>{S&&(w.push(S),p>0&&w.length>=p&&(a(w),w=[]))};let w=[];return f.search(E).then(S=>(w.length&&a(w),S),S=>(w.length&&a(w),Promise.reject(S)))}}e.FileSearchManager=r,r.BATCH_SIZE=512}),define(ge[128],pe([0,1,8,17,21,59,25,33,2,31,12,11]),function(G,e,_,I,A,T,y,P,D,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class f{constructor(h,c,m){this.query=h,this.provider=c,this.fileUtils=m,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(h,c){const m=this.query.folderQueries||[],t=new A.CancellationTokenSource;return c.onCancellationRequested(()=>t.cancel()),new Promise((n,o)=>{this.collector=new a(h);let i=!1;const s=(l,g)=>{if(!i&&!this.isLimitHit){const v=this.resultSize(l);E(l)&&typeof this.query.maxResults=="number"&&this.resultCount+v>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const d=this.resultSize(l);this.resultCount+=d,(d>0||!E(l))&&this.collector.add(l,g)}};Promise.all(m.map((l,g)=>this.searchInFolder(l,v=>s(v,g),t.token))).then(l=>{t.dispose(),this.collector.flush();const g=l.some(v=>!!v&&!!v.limitHit);n({limitHit:this.isLimitHit||g,messages:(0,I.flatten)(l.map(v=>(v==null?void 0:v.message)?(0,C.isArray)(v.message)?v.message:[v.message]:[])),stats:{type:"textSearchProvider"}})},l=>{t.dispose();const g=(0,T.toErrorMessage)(l);o(new Error(g))})})}resultSize(h){return E(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}trimResultToSize(h,c){const m=Array.isArray(h.ranges)?h.ranges:[h.ranges],t=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:m.slice(0,c),preview:{matches:t.slice(0,c),text:h.preview.text},uri:h.uri}}async searchInFolder(h,c,m){const t=new k.QueryGlobTester(this.query,h),n=[],o={report:l=>{if(!!this.validateProviderResult(l)){const g=h.folder.scheme===r.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(l.uri))):void 0,v=y.relativePath(h.folder,l.uri);v&&n.push(t.includedInQuery(v,_.basename(v),g).then(d=>{d&&c(l)}))}}},i=this.getSearchOptionsForFolder(h),s=await this.provider.provideTextSearchResults(p(this.query.contentPattern),i,o,m);return await Promise.all(n),s}validateProviderResult(h){if(E(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(h){const c=(0,k.resolvePatternsForProvider)(this.query.includePattern,h.includePattern),m=(0,k.resolvePatternsForProvider)(this.query.excludePattern,h.excludePattern),t={folder:D.URI.from(h.folder),excludes:m,includes:c,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.fileUtils.toCanonicalName(h.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=f;function p(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class a{constructor(h){this._onResult=h,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,c=>this.sendItems(c))}add(h,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!y.isEqual(this._currentUri,h.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:h.uri,results:[]}),this._currentFileMatch.results.push(u(h))}pushToCollector(){const h=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,h)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(h){this._onResult(h)}}e.TextSearchResultsCollector=a;function u(S){return E(S)?{preview:{matches:(0,I.mapArrayOrNot)(S.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:S.preview.text},ranges:(0,I.mapArrayOrNot)(S.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function E(S){return!!S.preview}e.extensionResultIsMatch=E;class w{constructor(h,c){this.maxBatchSize=h,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(h,c){!h||this.addItemToBatch(h,c)}addItems(h,c){!h||this.addItemsToBatch(h,c)}addItemToBatch(h,c){this.batch.push(h),this.batchSize+=c,this.onUpdate()}addItemsToBatch(h,c){this.batch=this.batch.concat(h),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(ge[69],pe([0,1,6,5,4,268,15,62,14,2,128]),function(G,e,_,I,A,T,y,P,D,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,A.createDecorator)("IExtHostSearch");let C=class{constructor(u,E,w){this.extHostRpc=u,this._uriTransformer=E,this._logService=w,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,E){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const w=this._handlePool++;return this._textSearchProvider.set(w,E),this._proxy.$registerTextSearchProvider(w,this._transformScheme(u)),(0,_.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(u,E){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const w=this._handlePool++;return this._fileSearchProvider.set(w,E),this._proxy.$registerFileSearchProvider(w,this._transformScheme(u)),(0,_.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(u,E,w,S){const h=f(w),c=this._fileSearchProvider.get(u);if(c)return this._fileSearchManager.fileSearch(h,c,m=>{this._proxy.$handleFileMatch(u,E,m.map(t=>t.resource))},S);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,E,w,S){const h=this._textSearchProvider.get(u);if(!h||!h.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const c=f(w);return this.createTextSearchManager(c,h).search(t=>this._proxy.$handleTextMatch(u,E,t),S)}createTextSearchManager(u,E){return new r.TextSearchManager(u,E,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};C=Ve([xe(0,y.IExtHostRpcService),xe(1,P.IURITransformerService),xe(2,D.ILogService)],C),e.ExtHostSearch=C;function f(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(p),extraFileResources:a.extraFileResources&&a.extraFileResources.map(u=>k.URI.revive(u))})}e.reviveQuery=f;function p(a){return Object.assign(Object.assign({},a),{folder:k.URI.revive(a.folder)})}}),define(ge[269],pe([0,1,160,21,16,3,57,2,152,108,142,77,46,5,231,230,51,232,35,233,234,235,216,236,39,42,237,217,239,240,241,64,220,244,245,246,92,34,247,221,20,7,250,65,127,32,41,53,201,238,117,126,67,47,69,14,62,15,28,242,199,50,63,228,248,198,93,91,253,251,252,229,61,260,249,90,195,119,243,85,66]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E,w,S,h,c,m,t,n,o,i,s,l,g,v,d,b,R,N,q,re,V,W,$,U,F,M,L,O,B,j,Q,de,be,Ae,Ce,Le,z,Y,ee,ae,me,De,Oe,we,Pe,Re,Be,Se,qe,X,ie,_e,Ne,ze,$e,Je,K,se,he,J,ne,ce,ve,ye,je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function He(We){const Ge=We.get(Oe.IExtHostInitDataService),nt=We.get(K.IExtHostFileSystemInfo),dt=We.get(_e.IExtHostConsumerFileSystem),it=We.get(i.IExtHostExtensionService),Ye=We.get(j.IExtHostWorkspace),mt=We.get(ce.IExtHostTelemetry),wt=We.get(S.IExtHostConfiguration),Ee=We.get(me.IURITransformerService),fe=We.get(De.IExtHostRpcService),le=We.get(V.IExtHostStorage),Z=We.get(ie.IExtensionStoragePaths),Fe=We.get(ae.ILogService),Te=We.get(Re.IExtHostTunnelService),Qe=We.get(Be.IExtHostApiDeprecationService),Ze=We.get(B.IExtHostWindow),ct=We.get(J.IExtHostSecretState);fe.set(p.ExtHostContext.ExtHostFileSystemInfo,nt),fe.set(p.ExtHostContext.ExtHostLogService,Fe),fe.set(p.ExtHostContext.ExtHostWorkspace,Ye),fe.set(p.ExtHostContext.ExtHostConfiguration,wt),fe.set(p.ExtHostContext.ExtHostExtensionService,it),fe.set(p.ExtHostContext.ExtHostStorage,le),fe.set(p.ExtHostContext.ExtHostTunnelService,Te),fe.set(p.ExtHostContext.ExtHostWindow,Ze),fe.set(p.ExtHostContext.ExtHostSecretState,ct),fe.set(p.ExtHostContext.ExtHostTelemetry,mt);const ht=fe.set(p.ExtHostContext.ExtHostDecorations,We.get(Le.IExtHostDecorations)),Xe=fe.set(p.ExtHostContext.ExtHostDocumentsAndEditors,We.get(o.IExtHostDocumentsAndEditors)),ot=fe.set(p.ExtHostContext.ExtHostCommands,We.get(E.IExtHostCommands)),ft=fe.set(p.ExtHostContext.ExtHostTerminalService,We.get(W.IExtHostTerminalService)),at=fe.set(p.ExtHostContext.ExtHostDebugService,We.get(Y.IExtHostDebugService)),St=fe.set(p.ExtHostContext.ExtHostSearch,We.get(ee.IExtHostSearch)),vt=fe.set(p.ExtHostContext.ExtHostTask,We.get(z.IExtHostTask)),kt=fe.set(p.ExtHostContext.ExtHostOutputService,We.get(b.IExtHostOutputService)),At=fe.set(p.ExtHostContext.ExtHostEditorTabs,new ne.ExtHostEditorTabs),Tt=fe.set(p.ExtHostContext.ExtHostUrls,new L.ExtHostUrls(fe)),_t=fe.set(p.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(fe,Xe)),Jt=fe.set(p.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(fe,Xe,Fe)),Zt=fe.set(p.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Fe,_t,fe.getProxy(p.MainContext.MainThreadBulkEdits))),gt=fe.set(p.ExtHostContext.ExtHostNotebook,new we.ExtHostNotebookController(fe,ot,Xe,_t,Fe,Z)),en=fe.set(p.ExtHostContext.ExtHostNotebookKernels,new ve.ExtHostNotebookKernels(fe,Ge,gt)),Dt=fe.set(p.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(fe,Xe)),Kt=fe.set(p.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(fe.getProxy(p.MainContext.MainThreadTreeViews),ot,Fe)),tn=fe.set(p.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(fe.getProxy(p.MainContext.MainThreadEditorInsets),Dt,Ge.environment)),Gt=fe.set(p.ExtHostContext.ExtHostDiagnostics,new h.ExtHostDiagnostics(fe,Fe)),lt=fe.set(p.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(fe,Ee,_t,ot,Gt,Fe,Qe)),nn=fe.set(p.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(fe,lt)),Rt=fe.set(p.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(fe,Fe,Xe)),Bt=fe.set(p.ExtHostContext.ExtHostQuickOpen,(0,N.createExtHostQuickOpen)(fe,Ye,ot)),gn=fe.set(p.ExtHostContext.ExtHostSCM,new q.ExtHostSCM(fe,ot,Fe)),yn=fe.set(p.ExtHostContext.ExtHostComments,new w.ExtHostComments(fe,ot,_t)),pn=fe.set(p.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(fe.getProxy(p.MainContext.MainThreadProgress))),rn=fe.set(p.ExtHostContext.ExtHosLabelService,new Ae.ExtHostLabelService(fe)),Qt=fe.set(p.ExtHostContext.ExtHostTheming,new Pe.ExtHostTheming(fe)),Nt=fe.set(p.ExtHostContext.ExtHostAuthentication,new Se.ExtHostAuthentication(fe)),Dn=fe.set(p.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(fe,ot)),sn=fe.set(p.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(fe,Ge.environment,Ye,Fe,Qe)),on=fe.set(p.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(fe,sn,Ye)),Xt=fe.set(p.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(fe,_t,Z,sn,on)),Cn=fe.set(p.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(fe,sn)),Lt=fe.set(p.ExtHostContext.ExtHostTesting,new se.ExtHostTesting(fe,Xe,Ye)),an=fe.set(p.ExtHostContext.ExtHostUriOpeners,new he.ExtHostUriOpeners(fe)),kn=(0,de.values)(p.ExtHostContext);fe.assertRegistered(kn);const Wt=new Je.ExtHostBulkEdits(fe,Xe),ln=new u.ExtHostClipboard(fe),Ut=new d.ExtHostMessageService(fe,Fe),Ft=new c.ExtHostDialogs(fe),vn=new re.ExtHostStatusBar(fe,ot.converter),$t=new v.ExtHostLanguages(fe,_t);return a.ExtHostApiCommands.register(ot),function(Me,cn,un){const pt=function(){let te=!Me.isUnderDevelopment;function ue(Ie){te||(Fe.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ie(rt){if(Array.isArray(rt))rt.forEach(Ie);else if(typeof rt=="string")ue(rt);else{const bt=rt;typeof bt.scheme=="undefined"&&ue(rt),!Me.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,Q.throwProposedApiError)(Me)}return rt}}(),Pn={getSession(te,ue,Ie){return Nt.getSession(Me,te,ue,Ie)},get onDidChangeSessions(){return Nt.onDidChangeSessions},registerAuthenticationProvider(te,ue,Ie,rt){return Nt.registerAuthenticationProvider(te,ue,Ie,rt)},get onDidChangeAuthenticationProviders(){return(0,Q.checkProposedApiEnabled)(Me),Nt.onDidChangeAuthenticationProviders},get providers(){return(0,Q.checkProposedApiEnabled)(Me),Nt.providers},logout(te,ue){return(0,Q.checkProposedApiEnabled)(Me),Nt.removeSession(te,ue)}},In={registerCommand(te,ue,Ie){return ot.registerCommand(!0,te,ue,Ie)},registerTextEditorCommand(te,ue,Ie){return ot.registerCommand(!0,te,(...rt)=>{const bt=Dt.getActiveTextEditor();if(!bt){Fe.warn("Cannot execute "+te+" because there is no active text editor.");return}return bt.edit(H=>{ue.apply(Ie,[bt,H,...rt])}).then(H=>{H||Fe.warn("Edits from command "+te+" were not applied.")},H=>{Fe.warn("An error occurred while running command "+te,H)})})},registerDiffInformationCommand:(te,ue,Ie)=>((0,Q.checkProposedApiEnabled)(Me),ot.registerCommand(!0,te,async(...rt)=>{const bt=Xe.activeEditor(!0);if(!bt){Fe.warn("Cannot execute "+te+" because there is no active text editor.");return}const H=await Dt.getDiffInformation(bt.id);ue.apply(Ie,[H,...rt])})),executeCommand(te,...ue){return ot.executeCommand(te,...ue)},getCommands(te=!1){return ot.getCommands(te)}},wn={get machineId(){return Ge.telemetryInfo.machineId},get sessionId(){return Ge.telemetryInfo.sessionId},get language(){return Ge.environment.appLanguage},get appName(){return Ge.environment.appName},get appRoot(){var te,ue;return(ue=(te=Ge.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&ue!==void 0?ue:""},get uriScheme(){return Ge.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return ft.getDefaultShell(!1,un)},get isTelemetryEnabled(){return mt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return mt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(Ge.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,ue){return Ze.openUri(te,{allowTunneling:!!Ge.remote.authority,allowContributedOpeners:ue==null?void 0:ue.allowContributedOpeners})},asExternalUri(te){return te.scheme===Ge.environment.appUriScheme?Tt.createAppUri(te):Ze.asExternalUri(te,{allowTunneling:!!Ge.remote.authority})},get remoteName(){return(0,Ce.getRemoteName)(Ge.remote.authority)},get uiKind(){return Ge.uiKind}};Ge.environment.extensionTestsLocationURI||Object.freeze(wn);const Yt=Ge.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,dn={registerTestController(te){return(0,Q.checkProposedApiEnabled)(Me),Lt.registerTestController(Me.identifier.value,te)},createDocumentTestObserver(te){return(0,Q.checkProposedApiEnabled)(Me),Lt.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return(0,Q.checkProposedApiEnabled)(Me),Lt.createWorkspaceTestObserver(te)},runTests(te){return(0,Q.checkProposedApiEnabled)(Me),Lt.runTests(te)},createTestItem(te,ue){return new M.TestItemImpl(te.id,te.label,te.uri,ue)},createTestRun(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),Lt.createTestRun(Me.identifier.value,te,ue,Ie)},get onDidChangeTestResults(){return(0,Q.checkProposedApiEnabled)(Me),Lt.onResultsChanged},get testResults(){return(0,Q.checkProposedApiEnabled)(Me),Lt.results}};dn.createTestRunTask=dn.createTestRun;const An={getExtension(te){const ue=cn.getExtensionDescription(te);if(ue)return new i.Extension(it,Me.identifier,ue,Yt)},get all(){return cn.getAllExtensionDescriptions().map(te=>new i.Extension(it,Me.identifier,te,Yt))},get onDidChange(){return cn.onDidChange}},Tn={createDiagnosticCollection(te){return Gt.createDiagnosticCollection(Me.identifier,te)},get onDidChangeDiagnostics(){return Gt.onDidChangeDiagnostics},getDiagnostics:te=>Gt.getDiagnostics(te),getLanguages(){return $t.getLanguages()},setTextDocumentLanguage(te,ue){return $t.changeLanguage(te.uri,ue)},match(te,ue){return(0,C.score)(F.LanguageSelector.from(te),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(te,ue,Ie){return lt.registerCodeActionProvider(Me,pt(te),ue,Ie)},registerCodeLensProvider(te,ue){return lt.registerCodeLensProvider(Me,pt(te),ue)},registerDefinitionProvider(te,ue){return lt.registerDefinitionProvider(Me,pt(te),ue)},registerDeclarationProvider(te,ue){return lt.registerDeclarationProvider(Me,pt(te),ue)},registerImplementationProvider(te,ue){return lt.registerImplementationProvider(Me,pt(te),ue)},registerTypeDefinitionProvider(te,ue){return lt.registerTypeDefinitionProvider(Me,pt(te),ue)},registerHoverProvider(te,ue){return lt.registerHoverProvider(Me,pt(te),ue,Me.identifier)},registerEvaluatableExpressionProvider(te,ue){return lt.registerEvaluatableExpressionProvider(Me,pt(te),ue,Me.identifier)},registerInlineValuesProvider(te,ue){return lt.registerInlineValuesProvider(Me,pt(te),ue,Me.identifier)},registerDocumentHighlightProvider(te,ue){return lt.registerDocumentHighlightProvider(Me,pt(te),ue)},registerLinkedEditingRangeProvider(te,ue){return lt.registerLinkedEditingRangeProvider(Me,pt(te),ue)},registerReferenceProvider(te,ue){return lt.registerReferenceProvider(Me,pt(te),ue)},registerRenameProvider(te,ue){return lt.registerRenameProvider(Me,pt(te),ue)},registerDocumentSymbolProvider(te,ue,Ie){return lt.registerDocumentSymbolProvider(Me,pt(te),ue,Ie)},registerWorkspaceSymbolProvider(te){return lt.registerWorkspaceSymbolProvider(Me,te)},registerDocumentFormattingEditProvider(te,ue){return lt.registerDocumentFormattingEditProvider(Me,pt(te),ue)},registerDocumentRangeFormattingEditProvider(te,ue){return lt.registerDocumentRangeFormattingEditProvider(Me,pt(te),ue)},registerOnTypeFormattingEditProvider(te,ue,Ie,...rt){return lt.registerOnTypeFormattingEditProvider(Me,pt(te),ue,[Ie].concat(rt))},registerDocumentSemanticTokensProvider(te,ue,Ie){return lt.registerDocumentSemanticTokensProvider(Me,pt(te),ue,Ie)},registerDocumentRangeSemanticTokensProvider(te,ue,Ie){return lt.registerDocumentRangeSemanticTokensProvider(Me,pt(te),ue,Ie)},registerSignatureHelpProvider(te,ue,Ie,...rt){return typeof Ie=="object"?lt.registerSignatureHelpProvider(Me,pt(te),ue,Ie):lt.registerSignatureHelpProvider(Me,pt(te),ue,typeof Ie=="undefined"?[]:[Ie,...rt])},registerCompletionItemProvider(te,ue,...Ie){return lt.registerCompletionItemProvider(Me,pt(te),ue,Ie)},registerDocumentLinkProvider(te,ue){return lt.registerDocumentLinkProvider(Me,pt(te),ue)},registerColorProvider(te,ue){return lt.registerColorProvider(Me,pt(te),ue)},registerFoldingRangeProvider(te,ue){return lt.registerFoldingRangeProvider(Me,pt(te),ue)},registerSelectionRangeProvider(te,ue){return lt.registerSelectionRangeProvider(Me,te,ue)},registerCallHierarchyProvider(te,ue){return lt.registerCallHierarchyProvider(Me,te,ue)},setLanguageConfiguration:(te,ue)=>lt.setLanguageConfiguration(Me,te,ue),getTokenInformationAtPosition(te,ue){return(0,Q.checkProposedApiEnabled)(Me),$t.tokenAtPosition(te,ue)},registerInlineHintsProvider(te,ue){return(0,Q.checkProposedApiEnabled)(Me),lt.registerInlineHintsProvider(Me,te,ue)}},Rn={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(te,ue,Ie){const rt=await(P.URI.isUri(te)?Promise.resolve(bn.openTextDocument(te)):Promise.resolve(te));return Dt.showTextDocument(rt,ue,Ie)},createTextEditorDecorationType(te){return Dt.createTextEditorDecorationType(te)},onDidChangeActiveTextEditor(te,ue,Ie){return Dt.onDidChangeActiveTextEditor(te,ue,Ie)},onDidChangeVisibleTextEditors(te,ue,Ie){return Dt.onDidChangeVisibleTextEditors(te,ue,Ie)},onDidChangeTextEditorSelection(te,ue,Ie){return Dt.onDidChangeTextEditorSelection(te,ue,Ie)},onDidChangeTextEditorOptions(te,ue,Ie){return Dt.onDidChangeTextEditorOptions(te,ue,Ie)},onDidChangeTextEditorVisibleRanges(te,ue,Ie){return Dt.onDidChangeTextEditorVisibleRanges(te,ue,Ie)},onDidChangeTextEditorViewColumn(te,ue,Ie){return Dt.onDidChangeTextEditorViewColumn(te,ue,Ie)},onDidCloseTerminal(te,ue,Ie){return ft.onDidCloseTerminal(te,ue,Ie)},onDidOpenTerminal(te,ue,Ie){return ft.onDidOpenTerminal(te,ue,Ie)},onDidChangeActiveTerminal(te,ue,Ie){return ft.onDidChangeActiveTerminal(te,ue,Ie)},onDidChangeTerminalDimensions(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),ft.onDidChangeTerminalDimensions(te,ue,Ie)},onDidWriteTerminalData(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),ft.onDidWriteTerminalData(te,ue,Ie)},get state(){return Ze.state},onDidChangeWindowState(te,ue,Ie){return Ze.onDidChangeWindowState(te,ue,Ie)},showInformationMessage(te,...ue){return Ut.showMessage(Me,y.default.Info,te,ue[0],ue.slice(1))},showWarningMessage(te,...ue){return Ut.showMessage(Me,y.default.Warning,te,ue[0],ue.slice(1))},showErrorMessage(te,...ue){return Ut.showMessage(Me,y.default.Error,te,ue[0],ue.slice(1))},showQuickPick(te,ue,Ie){return Bt.showQuickPick(te,!!Me.enableProposedApi,ue,Ie)},showWorkspaceFolderPick(te){return Bt.showWorkspaceFolderPick(te)},showInputBox(te,ue){return Bt.showInput(te,ue)},showOpenDialog(te){return Ft.showOpenDialog(te)},showSaveDialog(te){return Ft.showSaveDialog(te)},createStatusBarItem(te,ue){let Ie,rt,bt,H;return te&&typeof te!="number"?(Ie=te.id,rt=te.name,bt=te.alignment,ue=te.priority,H=te.accessibilityInformation):(Ie=Me.identifier.value,rt=_.localize(0,null,Me.displayName||Me.name),bt=te),vn.createStatusBarEntry(Ie,rt,bt,ue,H)},setStatusBarMessage(te,ue){return vn.setStatusBarMessage(te,ue)},withScmProgress(te){return Qe.report("window.withScmProgress",Me,"Use 'withProgress' instead."),pn.withProgress(Me,{location:M.ProgressLocation.SourceControl},(ue,Ie)=>te({report(rt){}}))},withProgress(te,ue){return pn.withProgress(Me,te,ue)},createOutputChannel(te){return kt.createOutputChannel(te)},createWebviewPanel(te,ue,Ie,rt){return on.createWebviewPanel(Me,te,ue,Ie,rt)},createWebviewTextEditorInset(te,ue,Ie,rt){return(0,Q.checkProposedApiEnabled)(Me),tn.createWebviewEditorInset(te,ue,Ie,rt,Me)},createTerminal(te,ue,Ie){return typeof te=="object"?"pty"in te?ft.createExtensionTerminal(te):(te.message&&(0,Q.checkProposedApiEnabled)(Me),te.icon&&(0,Q.checkProposedApiEnabled)(Me),ft.createTerminalFromOptions(te)):ft.createTerminal(te,ue,Ie)},registerTerminalLinkProvider(te){return ft.registerLinkProvider(te)},registerTreeDataProvider(te,ue){return Kt.registerTreeDataProvider(te,ue,Me)},createTreeView(te,ue){return Kt.createTreeView(te,ue,Me)},registerWebviewPanelSerializer:(te,ue)=>on.registerWebviewPanelSerializer(Me,te,ue),registerCustomEditorProvider:(te,ue,Ie={})=>Xt.registerCustomEditorProvider(Me,te,ue,Ie),registerFileDecorationProvider(te){return ht.registerFileDecorationProvider(te,Me.identifier)},registerUriHandler(te){return Tt.registerUriHandler(Me.identifier,te)},createQuickPick(){return Bt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Bt.createInputBox(Me.identifier)},get activeColorTheme(){return Qt.activeColorTheme},onDidChangeActiveColorTheme(te,ue,Ie){return Qt.onDidChangeActiveColorTheme(te,ue,Ie)},registerWebviewViewProvider(te,ue,Ie){return Cn.registerWebviewViewProvider(Me,te,ue,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return(0,Q.checkProposedApiEnabled)(Me),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeActiveNotebookEditor(te,ue,Ie)},get visibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Me),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookEditorSelection(te,ue,Ie)},onDidChangeNotebookEditorVisibleRanges(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookEditorVisibleRanges(te,ue,Ie)},showNotebookDocument(te,ue){return(0,Q.checkProposedApiEnabled)(Me),gt.showNotebookDocument(te,ue)},registerExternalUriOpener(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),an.registerExternalUriOpener(Me.identifier,te,ue,Ie)},get openEditors(){return(0,Q.checkProposedApiEnabled)(Me),At.tabs},get onDidChangeOpenEditors(){return(0,Q.checkProposedApiEnabled)(Me),At.onDidChangeTabs}},bn={get rootPath(){return Qe.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ye.getPath()},set rootPath(te){throw A.readonly()},getWorkspaceFolder(te){return Ye.getWorkspaceFolder(te)},get workspaceFolders(){return Ye.getWorkspaceFolders()},get name(){return Ye.name},set name(te){throw A.readonly()},get workspaceFile(){return Ye.workspaceFile},set workspaceFile(te){throw A.readonly()},updateWorkspaceFolders:(te,ue,...Ie)=>Ye.updateWorkspaceFolders(Me,te,ue||0,...Ie),onDidChangeWorkspaceFolders:function(te,ue,Ie){return Ye.onDidChangeWorkspace(te,ue,Ie)},asRelativePath:(te,ue)=>Ye.getRelativePath(te,ue),findFiles:(te,ue,Ie,rt)=>Ye.findFiles(F.GlobPattern.from(te),F.GlobPattern.from(ue),Ie,Me.identifier,rt),findTextInFiles:(te,ue,Ie,rt)=>{let bt,H;return typeof ue=="object"?(bt=ue,H=Ie):(bt={},H=ue,rt=Ie),Ye.findTextInFiles(te,bt||{},H,Me.identifier,rt)},saveAll:te=>Ye.saveAll(te),applyEdit(te){return Wt.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,ue,Ie,rt)=>Rt.createFileSystemWatcher(F.GlobPattern.from(te),ue,Ie,rt),get textDocuments(){return _t.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw A.readonly()},openTextDocument(te){let ue;const Ie=te;if(typeof te=="string")ue=Promise.resolve(P.URI.file(te));else if(P.URI.isUri(te))ue=Promise.resolve(te);else if(!Ie||typeof Ie=="object")ue=_t.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(rt=>_t.ensureDocumentData(rt).then(bt=>bt.document))},onDidOpenTextDocument:(te,ue,Ie)=>_t.onDidAddDocument(te,ue,Ie),onDidCloseTextDocument:(te,ue,Ie)=>_t.onDidRemoveDocument(te,ue,Ie),onDidChangeTextDocument:(te,ue,Ie)=>_t.onDidChangeDocument(te,ue,Ie),onDidSaveTextDocument:(te,ue,Ie)=>_t.onDidSaveDocument(te,ue,Ie),onWillSaveTextDocument:(te,ue,Ie)=>Zt.getOnWillSaveTextDocumentEvent(Me)(te,ue,Ie),onDidChangeConfiguration:(te,ue,Ie)=>un.onDidChangeConfiguration(te,ue,Ie),getConfiguration(te,ue){return ue=arguments.length===1?void 0:ue,un.getConfiguration(te,ue,Me)},registerTextDocumentContentProvider(te,ue){return Jt.registerTextDocumentContentProvider(te,ue)},registerTaskProvider:(te,ue)=>(Qe.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Me,te,ue)),registerFileSystemProvider(te,ue,Ie){return nn.registerFileSystemProvider(Me.identifier,te,ue,Ie)},get fs(){return dt.value},registerFileSearchProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),St.registerFileSearchProvider(te,ue)),registerTextSearchProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),St.registerTextSearchProvider(te,ue)),registerRemoteAuthorityResolver:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),it.registerRemoteAuthorityResolver(te,ue)),registerResourceLabelFormatter:te=>((0,Q.checkProposedApiEnabled)(Me),rn.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,ue,Ie)=>Rt.onDidCreateFile(te,ue,Ie),onDidDeleteFiles:(te,ue,Ie)=>Rt.onDidDeleteFile(te,ue,Ie),onDidRenameFiles:(te,ue,Ie)=>Rt.onDidRenameFile(te,ue,Ie),onWillCreateFiles:(te,ue,Ie)=>Rt.getOnWillCreateFileEvent(Me)(te,ue,Ie),onWillDeleteFiles:(te,ue,Ie)=>Rt.getOnWillDeleteFileEvent(Me)(te,ue,Ie),onWillRenameFiles:(te,ue,Ie)=>Rt.getOnWillRenameFileEvent(Me)(te,ue,Ie),openTunnel:te=>((0,Q.checkProposedApiEnabled)(Me),Te.openTunnel(Me,te).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Q.checkProposedApiEnabled)(Me),Te.getTunnels()},onDidChangeTunnels:(te,ue,Ie)=>((0,Q.checkProposedApiEnabled)(Me),Te.onDidChangeTunnels(te,ue,Ie)),registerPortAttributesProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),Te.registerPortsAttributesProvider(te,ue)),registerTimelineProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),Dn.registerTimelineProvider(te,ue,Me.identifier,ot.converter)),get isTrusted(){return Ye.trusted},requestWorkspaceTrust:te=>((0,Q.checkProposedApiEnabled)(Me),Ye.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ue,Ie)=>Ye.onDidGrantWorkspaceTrust(te,ue,Ie)},_n={get inputBox(){return Qe.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),gn.getLastInputBox(Me)},createSourceControl(te,ue,Ie){return gn.createSourceControl(Me,te,ue,Ie)}},En={createCommentController(te,ue){return yn.createCommentController(Me,te,ue)}},xt={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(te,ue,Ie){return at.onDidStartDebugSession(te,ue,Ie)},onDidTerminateDebugSession(te,ue,Ie){return at.onDidTerminateDebugSession(te,ue,Ie)},onDidChangeActiveDebugSession(te,ue,Ie){return at.onDidChangeActiveDebugSession(te,ue,Ie)},onDidReceiveDebugSessionCustomEvent(te,ue,Ie){return at.onDidReceiveDebugSessionCustomEvent(te,ue,Ie)},onDidChangeBreakpoints(te,ue,Ie){return at.onDidChangeBreakpoints(te,ue,Ie)},registerDebugConfigurationProvider(te,ue,Ie){return at.registerDebugConfigurationProvider(te,ue,Ie||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ue){return at.registerDebugAdapterDescriptorFactory(Me,te,ue)},registerDebugAdapterTrackerFactory(te,ue){return at.registerDebugAdapterTrackerFactory(te,ue)},startDebugging(te,ue,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?at.startDebugging(te,ue,{parentSession:Ie}):at.startDebugging(te,ue,Ie||{})},stopDebugging(te){return at.stopDebugging(te)},addBreakpoints(te){return at.addBreakpoints(te)},removeBreakpoints(te){return at.removeBreakpoints(te)},asDebugSourceUri(te,ue){return at.asDebugSourceUri(te,ue)}},Ht={registerTaskProvider:(te,ue)=>vt.registerTaskProvider(Me,te,ue),fetchTasks:te=>vt.fetchTasks(te),executeTask:te=>vt.executeTask(Me,te),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(te,ue,Ie)=>vt.onDidStartTask(te,ue,Ie),onDidEndTask:(te,ue,Ie)=>vt.onDidEndTask(te,ue,Ie),onDidStartTaskProcess:(te,ue,Ie)=>vt.onDidStartTaskProcess(te,ue,Ie),onDidEndTaskProcess:(te,ue,Ie)=>vt.onDidEndTaskProcess(te,ue,Ie)},Ln={openNotebookDocument:te=>((0,Q.checkProposedApiEnabled)(Me),gt.openNotebookDocument(te)),get onDidOpenNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,Q.checkProposedApiEnabled)(Me),gt.notebookDocuments.map(te=>te.apiNotebook)},registerNotebookSerializer(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.registerNotebookSerializer(Me,te,ue,Ie)},registerNotebookContentProvider:(te,ue,Ie)=>((0,Q.checkProposedApiEnabled)(Me),gt.registerNotebookContentProvider(Me,te,ue,Ie)),registerNotebookCellStatusBarItemProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),gt.registerNotebookCellStatusBarItemProvider(Me,te,ue)),createNotebookEditorDecorationType(te){return(0,Q.checkProposedApiEnabled)(Me),gt.createNotebookEditorDecorationType(te)},onDidChangeNotebookDocumentMetadata(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookDocumentMetadata(te,ue,Ie)},onDidChangeNotebookCells(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookCells(te,ue,Ie)},onDidChangeCellExecutionState(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookCellExecutionState(te,ue,Ie)},onDidChangeCellOutputs(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeCellOutputs(te,ue,Ie)},onDidChangeCellMetadata(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeCellMetadata(te,ue,Ie)},createConcatTextDocument(te,ue){return(0,Q.checkProposedApiEnabled)(Me),new X.ExtHostNotebookConcatDocument(gt,_t,te,ue)},createNotebookCellExecutionTask(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.createNotebookCellExecution(te,ue,Ie)},createNotebookController(te,ue,Ie,rt,bt){return(0,Q.checkProposedApiEnabled)(Me),en.createNotebookController(Me,te,ue,Ie,rt,bt)}};return{version:Ge.version,authentication:Pn,commands:In,comments:En,debug:xt,env:wn,extensions:An,languages:Tn,notebook:Ln,scm:_n,tasks:Ht,test:dn,window:Rn,workspace:bn,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:p.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,EventEmitter:T.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:f.FileType,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,Hover:M.Hover,IndentAction:r.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:p.UIKind,Uri:P.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlineHint:M.InlineHint,InlineHintKind:M.InlineHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,RemoteTrustOption:ye.RemoteTrustOption,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookDocumentMetadata:M.NotebookDocumentMetadata,NotebookCellMetadata:M.NotebookCellMetadata,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,LinkedEditingRanges:M.LinkedEditingRanges,TestItemStatus:M.TestItemStatus,TestResultState:M.TestResultState,TestMessage:M.TestMessage,TextSearchCompleteMessageType:je.TextSearchCompleteMessageType,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=He}),define(ge[270],pe([0,1,79,64,32,126,35,51,39,34,67,47,69,93,92,50,63,127,91,61,90,119]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E,w,S,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(p.IExtensionStoragePaths,p.ExtensionStoragePaths),(0,_.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService),(0,_.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,_.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,_.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,_.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,_.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,_.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,_.registerSingleton)(h.IExtHostFileSystemInfo,h.ExtHostFileSystemInfo),(0,_.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,_.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch),(0,_.registerSingleton)(a.IExtHostStorage,a.ExtHostStorage),(0,_.registerSingleton)(r.IExtHostTask,r.WorkerExtHostTask),(0,_.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,_.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,_.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,_.registerSingleton)(A.IExtHostWorkspace,A.ExtHostWorkspace),(0,_.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,_.registerSingleton)(m.IExtHostTelemetry,m.ExtHostTelemetry)}),define(ge[94],pe([0,1,17,14,31,66]),function(G,e,_,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=y;function P(C,f,p,a){const u=(0,_.mapArrayOrNot)(p,D),E=new A.TextSearchMatch(f,u,a),w=E.preview.matches;return{ranges:(0,_.mapArrayOrNot)(u,k),uri:C,preview:{text:E.preview.text,matches:(0,_.mapArrayOrNot)(w,k)}}}e.createTextSearchResult=P;function D(C){return new A.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function k(C){return new T.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let r=class{constructor(f,p){this.prefix=f,this.logService=p}appendLine(f){this.logService.debug(`${this.prefix}#search`,f)}};r=Ve([xe(1,I.ILogService)],r),e.OutputChannel=r}),define(ge[271],pe([0,1,95,22]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function A(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=A,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const T=512,y=512,P=512*8,D=512*128;class k{constructor(n){this.iconvLiteDecoder=n}static async create(n){let o;if(n!==e.UTF8)o=(await new Promise((s,l)=>{G(["iconv-lite-umd"],s,l)})).getDecoder(p(n));else{const i=new TextDecoder;o={write(s){return i.decode(s,{stream:!0})},end(){return i.decode()}}}return new k(o)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function r(t,n){var o;const i=((o=n.minBytesRequiredForDetection)!==null&&o!==void 0?o:n.guessEncoding)?P:y;return new Promise((s,l)=>{const g=(0,_.newWriteableStream)(N=>N.join("")),v=[];let d=0,b;const R=async()=>{try{const N=await m({buffer:I.VSBuffer.concat(v),bytesRead:d},n.guessEncoding);N.encoding=await n.overwriteEncoding(N.encoding),b=await k.create(N.encoding);const q=b.write(I.VSBuffer.concat(v).buffer);g.write(q),v.length=0,d=0,s({stream:g,detected:N})}catch(N){l(N)}};(0,_.listenStream)(t,{onData:async N=>{b?g.write(b.write(N.buffer)):(v.push(N),d+=N.byteLength,d>=i&&(t.pause(),await R(),setTimeout(()=>t.resume())))},onError:N=>g.error(N),onEnd:async()=>{b||await R(),g.end(b==null?void 0:b.end())}})})}e.toDecodeStream=r;async function C(t,n,o){const s=(await new Promise((v,d)=>{G(["iconv-lite-umd"],v,d)})).getEncoder(p(n),o);let l=!1,g=!1;return{read(){if(g)return null;const v=t.read();if(typeof v!="string"){if(g=!0,!l&&(o==null?void 0:o.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return I.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const d=s.end();return d&&d.length>0?(l=!0,I.VSBuffer.wrap(d)):null}return l=!0,I.VSBuffer.wrap(s.write(v))}}}e.toEncodeReadable=C;async function f(t){return(await new Promise((o,i)=>{G(["iconv-lite-umd"],o,i)})).encodingExists(p(t))}e.encodingExists=f;function p(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=p;function a(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),i=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const s=t.readUInt8(2);return o===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&s===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const u=["ascii","utf-16","utf-32"];async function E(t){const n=await new Promise((g,v)=>{G(["jschardet"],g,v)}),o=t.slice(0,D),i=h(o.buffer),s=n.detect(i);if(!s||!s.encoding)return null;const l=s.encoding.toLowerCase();return 0<=u.indexOf(l)?null:S(s.encoding)}const w={ibm866:"cp866",big5:"cp950"};function S(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[n]||n}function h(t){let n="";for(let o=0;o<t.length;o++)n+=String.fromCharCode(t[o]);return n}function c(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=c;function m({buffer:t,bytesRead:n},o){let i=a(t,n),s=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let l=!0,g=!0,v=!1;for(let d=0;d<n&&d<T;d++){const b=d%2==1,R=t.readUInt8(d)===0;if(R&&(v=!0),l&&(b&&!R||!b&&R)&&(l=!1),g&&(b&&R||!b&&!R)&&(g=!1),R&&!l&&!g)break}v&&(l?i=e.UTF16le:g?i=e.UTF16be:s=!0)}return o&&!s&&!i&&t?E(t.slice(0,n)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:s,encoding:i}}e.detectEncodingFromBuffer=m,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[129],pe([0,1,271,26,128]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class T extends A.TextSearchManager{constructor(P,D,k=I){super(P,D,{readdir:r=>k.readdir(r.fsPath),toCanonicalName:r=>(0,_.toCanonicalName)(r)})}}e.NativeTextSearchManager=T}),define(ge[272],pe([0,1,273,290,291,2,292]),function(G,e,_,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(C,f,p,a,u,E){const w=E.environment.useHostProxy,S=typeof w=="boolean"?w:!E.remote.isRemote,h=(0,y.createProxyResolver)({resolveProxy:m=>C.resolveProxy(m),getHttpProxySetting:()=>f.getConfiguration("http").get("proxy"),log:(m,t,...n)=>{switch(m){case y.LogLevel.Trace:a.trace(t,...n);break;case y.LogLevel.Debug:a.debug(t,...n);break;case y.LogLevel.Info:a.info(t,...n);break;case y.LogLevel.Warning:a.warn(t,...n);break;case y.LogLevel.Error:a.error(t,...n);break;case y.LogLevel.Critical:a.critical(t,...n);break;case y.LogLevel.Off:break;default:o(m,t,n);break}function o(i,s,...l){a.error("Unknown log level",i),a.error(s,...l)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:m=>{u.$publicLog2("resolveProxy",m)},useHostProxy:S,env:process.env}),c=D(f,h);return r(p,c)}e.connectProxyResolver=P;function D(C,f){const p={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(u=>{p.config=C.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(u=>{a.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},_,(0,y.createHttpPatch)(_,f,{config:"off"},a,!0)),on:Object.assign({},_,(0,y.createHttpPatch)(_,f,{config:"on"},a,!0)),override:Object.assign({},_,(0,y.createHttpPatch)(_,f,{config:"override"},a,!0)),onRequest:Object.assign({},_,(0,y.createHttpPatch)(_,f,p,a,!0)),default:Object.assign(_,(0,y.createHttpPatch)(_,f,p,a,!1))},https:{off:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"off"},a,!0)),on:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"on"},a,!0)),override:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"override"},a,!0)),onRequest:Object.assign({},I,(0,y.createHttpPatch)(I,f,p,a,!0)),default:Object.assign(I,(0,y.createHttpPatch)(I,f,p,a,!1))},tls:Object.assign(A,(0,y.createTlsPatch)(A))}}const k=new Map;function r(C,f){return C.getExtensionPathIndex().then(p=>{const a=G.__$__nodeRequire("module"),u=a._load;a._load=function(w,S,h){if(w==="tls")return f.tls;if(w!=="http"&&w!=="https")return u.apply(this,arguments);const c=f[w],m=p.findSubstr(T.URI.file(S.filename).fsPath);let t=k.get(m);if(t||k.set(m,t={}),!t[w]){let n=c.default;m&&m.enableProposedApi&&(n=c[m.proxySupport]||c.onRequest),t[w]=Object.assign({},n)}return t[w]}})}}),define(ge[274],pe([0,1,38,8,75,29,10,9,94,275]),function(G,e,_,I,A,T,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const r=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(h,c,m,t){const n=f(h,c,m,t),o=c.folder.fsPath;return{cmd:_.spawn(r,n.args,{cwd:o}),rgDiskPath:r,siblingClauses:n.siblingClauses,rgArgs:n,cwd:o}}e.spawnRipgrepCmd=C;function f(h,c,m,t){const n=["--files","--hidden","--case-sensitive"];a([c],m,!1).forEach(i=>{const s=(0,D.anchorGlob)(i);if(n.push("-g",s),y.isMacintosh){const l=(0,A.normalizeNFD)(s);l!==s&&n.push("-g",l)}});const o=p([c],t,void 0,!1);return o.globArgs.forEach(i=>{const s=`!${(0,D.anchorGlob)(i)}`;if(n.push("-g",s),y.isMacintosh){const l=(0,A.normalizeNFD)(s);l!==s&&n.push("-g",l)}}),c.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),c.ignoreSymlinks||n.push("--follow"),h.exists&&n.push("--quiet"),n.push("--no-config"),c.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:o.siblingClauses}}function p(h,c,m,t=!0){const n=[];let o={};return h.forEach(i=>{const s=Object.assign({},i.excludePattern||{},c||{}),l=u(s,t?i.folder.fsPath:void 0,m);n.push(...l.globArgs),l.siblingClauses&&(o=Object.assign(o,l.siblingClauses))}),{globArgs:n,siblingClauses:o}}e.foldersToRgExcludeGlobs=p;function a(h,c,m=!0){const t=[];return h.forEach(n=>{const o=Object.assign({},c||{},n.includePattern||{}),i=u(o,m?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=a;function u(h,c,m){const t=[],n={};return Object.keys(h).forEach(o=>{if(!(m&&m.has(o))&&!!o){const i=h[o];o=w(c?E(c,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof i=="boolean"&&i?(o.startsWith("\\\\")&&(o+="**"),t.push(S(o))):i&&i.when&&(n[o]=i)}}),{globArgs:t,siblingClauses:n}}function E(h,c){return I.isAbsolute(c)?c:I.join(h,c)}e.getAbsoluteGlob=E;function w(h){return h=P.rtrim(h,"\\"),P.rtrim(h,"/")}function S(h){return T.getRoot(h).toLowerCase()==="c:/"?h.replace(/^c:[/\\]/i,"/"):h}e.fixDriveC=S}),define(ge[276],pe([0,1,38,37,8,102,17,59,33,75,29,10,48,9,11,26,31,274,100]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const h=new Set;process.on("exit",()=>{h.forEach(o=>o())});class c{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&D.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,S.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&D.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(s=>{const l=Object.assign({},s.excludePattern||{},this.config.excludePattern||{}),g=s.folder.fsPath;i.folderQueries.map(v=>v.folder.fsPath).filter(v=>v!==g).forEach(v=>{(0,r.isEqualOrParent)(v,g)&&(l[A.relative(g,v)]=!0)}),this.folderExcludePatterns.set(g,new t(l,g))})}cancel(){this.isCanceled=!0}walk(i,s,l,g,v){if(this.fileWalkSW=f.StopWatch.create(!1),this.isCanceled)return v(null,this.isLimitHit);s.forEach(d=>{const b=A.basename(d.fsPath);this.globalExcludePattern&&this.globalExcludePattern(d.fsPath,b)||this.matchFile(l,{relativePath:d.fsPath,searchPath:void 0})}),this.cmdSW=f.StopWatch.create(!1),this.parallel(i,(d,b)=>{this.call(this.cmdTraversal,this,d,l,g,R=>{if(R){const N=(0,P.toErrorMessage)(R);console.error(N),this.errors.push(N),b(R,void 0)}else b(null,void 0)})},(d,b)=>{this.fileWalkSW.stop();const R=d?y.coalesce(d)[0]:null;v(R,this.isLimitHit)})}parallel(i,s,l){const g=new Array(i.length),v=new Array(i.length);let d=!1,b=0;if(i.length===0)return l(null,[]);i.forEach((R,N)=>{s(R,(q,re)=>{if(q?(d=!0,g[N]=null,v[N]=q):(g[N]=re,v[N]=null),++b===i.length)return l(d?v:null,g)})})}call(i,s,...l){try{i.apply(s,l)}catch(g){l[l.length-1](g)}}cmdTraversal(i,s,l,g){const v=i.folder.fsPath,d=C.isMacintosh;let b;const R=()=>b&&b.kill();h.add(R);let N=F=>{h.delete(R),N=()=>{},g(F)},q="";const re=this.initDirectoryTree();let V;const W=(0,w.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);b=W.cmd,V=!Object.keys(W.siblingClauses).length;const $=W.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let U=`${W.rgDiskPath} ${$}
 - cwd: ${W.cwd}`;W.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(W.rgArgs.siblingClauses)}`),l({message:U}),this.cmdResultCount=0,this.collectStdout(b,"utf8",l,(F,M,L)=>{if(F){N(F);return}if(this.isLimitHit){N();return}const B=(q+(d?k.normalizeNFC(M||""):M)).split(`
`);if(L){const j=B.length;B[j-1]=B[j-1].trim(),B[j-1]||B.pop()}else q=B.pop()||"";if(B.length&&B[0].indexOf(`
`)!==-1){N(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=B.length,V){for(const j of B)if(this.matchFile(s,{base:v,relativePath:j,searchPath:this.getSearchPath(i,j)}),this.isLimitHit){R();break}(L||this.isLimitHit)&&N();return}this.addDirectoryEntries(i,re,v,B,s),L&&(this.matchDirectoryTree(re,v,s),N())})}spawnFindCmd(i){const s=this.folderExcludePatterns.get(i.folder.fsPath),l=s.getBasenameTerms(),g=s.getPathTerms(),v=["-L","."];if(l.length||g.length){v.push("-not","(","(");for(const d of l)v.push("-name",d),v.push("-o");for(const d of g)v.push("-path",d),v.push("-o");v.pop(),v.push(")","-prune",")")}return v.push("-type","f"),_.spawn("find",v,{cwd:i.folder.fsPath})}readStdout(i,s,l){let g="";this.collectStdout(i,s,()=>{},(v,d,b)=>{if(v){l(v);return}g+=d,b&&l(null,g)})}collectStdout(i,s,l,g){let v=(R,N,q)=>{(R||q)&&(v=()=>{},this.cmdSW&&this.cmdSW.stop()),g(R,N,q)},d=!1;i.stdout?(this.forwardData(i.stdout,s,v),i.stdout.once("data",()=>d=!0)):l({message:"stdout is null"});let b;i.stderr?b=this.collectData(i.stderr):l({message:"stderr is null"}),i.on("error",R=>{v(R)}),i.on("close",R=>{let N;!d&&(N=this.decodeData(b,s))&&n(N)?v(new Error(`command failed with error code ${R}: ${this.decodeData(b,s)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),v(null,"",!0))})}forwardData(i,s,l){const g=new T.StringDecoder(s);return i.on("data",v=>{l(null,g.write(v))}),g}collectData(i){const s=[];return i.on("data",l=>{s.push(l)}),s}decodeData(i,s){const l=new T.StringDecoder(s);return i.map(g=>l.write(g)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:s},l,g,v){g.indexOf(this.filePattern)!==-1&&this.matchFile(v,{base:l,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const d=b=>{const R=A.basename(b),N=A.dirname(b);let q=s[N];q||(q=s[N]=[],d(N)),q.push({base:l,relativePath:b,basename:R,searchPath:this.getSearchPath(i,b)})};g.forEach(d)}matchDirectoryTree({rootEntries:i,pathToEntries:s},l,g){const v=this,d=this.folderExcludePatterns.get(l),b=this.filePattern;function R(N){v.directoriesWalked++;const q=D.hasSiblingFn(()=>N.map(re=>re.basename));for(let re=0,V=N.length;re<V;re++){const W=N[re],{relativePath:$,basename:U}=W;if(!d.test($,U,b!==U?q:void 0)){const F=s[$];if(F)R(F);else{if(v.filesWalked++,$===b)continue;v.matchFile(g,W)}if(v.isLimitHit)break}}}R(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,s,l,g,v){const d=i.folder,b=D.hasSiblingFn(()=>l);this.parallel(l,(R,N)=>{if(this.isCanceled||this.isLimitHit)return N(null);const q=s?[s,R].join(A.sep):R;if(this.folderExcludePatterns.get(i.folder.fsPath).test(q,R,this.config.filePattern!==R?b:void 0))return N(null);const re=[d.fsPath,q].join(A.sep);I.lstat(re,(V,W)=>{if(V||this.isCanceled||this.isLimitHit)return N(null);this.statLinkIfNeeded(re,W,($,U)=>$||this.isCanceled||this.isLimitHit?N(null):U.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(re,W,(F,M)=>F||this.isCanceled||this.isLimitHit||(M=M||"",this.walkedPaths[M])?N(null):(this.walkedPaths[M]=!0,(0,u.readdir)(re).then(L=>{if(this.isCanceled||this.isLimitHit)return N(null);this.doWalk(i,q,L,g,O=>N(O||null))},L=>{N(null)})))):(this.filesWalked++,q===this.filePattern||this.maxFilesize&&a.isNumber(U.size)&&U.size>this.maxFilesize||this.matchFile(g,{base:d.fsPath,relativePath:q,searchPath:this.getSearchPath(i,q)}),N(null,void 0)))})},R=>{const N=R&&y.coalesce(R);return v(N&&N.length>0?N[0]:void 0)})}matchFile(i,s){this.isFileMatch(s)&&(!this.includePattern||this.includePattern(s.relativePath,A.basename(s.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(s))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,s,l){return s.isSymbolicLink()?I.stat(i,l):l(null,s)}realPathIfNeeded(i,s,l){return s.isSymbolicLink()?I.realpath(i,(g,v)=>g?l(g):l(null,v)):l(null,i)}getSearchPath(i,s){return i.folderName?A.join(i.folderName,s):s}}e.FileWalker=c;class m{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new c(i)}search(i,s,l){this.walker.walk(this.folderQueries,this.extraFiles,i,s,(g,v)=>{l(g,{limitHit:v,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class t{constructor(i,s){this.expression=i,this.root=s,this.init(i)}init(i){let s,l;Object.keys(i).filter(g=>i[g]).forEach(g=>{A.isAbsolute(g)?(s=s||D.getEmptyExpression(),s[g]=i[g]):(l=l||D.getEmptyExpression(),l[g]=i[g])}),this.absoluteParsedExpr=s&&D.parse(s,{trimForExclusions:!0}),this.relativeParsedExpr=l&&D.parse(l,{trimForExclusions:!0})}test(i,s,l){return this.relativeParsedExpr&&this.relativeParsedExpr(i,s,l)||this.absoluteParsedExpr&&this.absoluteParsedExpr(A.join(this.root,i),s,l)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getPathTerms(this.relativeParsedExpr)),i}}function n(o){const i=o.trim().split(`
`),s=i[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return p.uppercaseFirstLetter(i[i.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}e.rgErrorMsgForDisplay=n}),define(ge[130],pe([0,1,38,293,102,17,53,33,8,9,2,31,66,294,275,94]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(d){this.outputChannel=d}provideTextSearchResults(d,b,R,N){return this.outputChannel.appendLine(`provideTextSearchResults ${d.pattern}, ${JSON.stringify(Object.assign(Object.assign({},b),{folder:b.folder.toString()}))}`),new Promise((q,re)=>{N.onCancellationRequested(()=>O());const V=n(d,b),W=b.folder.fsPath,$=V.map(be=>be.match(/^-/)?be:`'${be}'`).join(" ");this.outputChannel.appendLine(`${E} ${$}
 - cwd: ${W}`);let U=_.spawn(E,V,{cwd:W});U.on("error",be=>{console.error(be),this.outputChannel.appendLine("Error: "+(be&&be.message)),re((0,C.serializeSearchError)(new C.SearchError(be&&be.message,C.SearchErrorCode.rgProcessError)))});let F=!1;const M=new c(b.maxResults,W,b.previewOptions);M.on("result",be=>{F=!0,j="",R.report(be)});let L=!1;const O=()=>{L=!0,U&&U.kill(),M&&M.cancel()};let B=!1;M.on("hitLimit",()=>{B=!0,O()});let j="";U.stdout.on("data",be=>{M.handleData(be),F||(j+=be)});let Q=!1;U.stdout.once("data",()=>Q=!0);let de="";U.stderr.on("data",be=>{const Ae=be.toString();this.outputChannel.appendLine(Ae),de+=Ae}),U.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(F?"Got result from parser":"No result from parser"),j&&this.outputChannel.appendLine(`Got data without result: ${j}`),this.outputChannel.appendLine(""),L)q({limitHit:B});else{M.flush(),U=null;let be;de&&!Q&&(be=S(de))?re((0,C.serializeSearchError)(new C.SearchError(be.message,be.code))):q({limitHit:B})}})})}}e.RipgrepTextSearchEngine=w;function S(v){const d=v.split(`
`),b=d[0].trim();if(d.some(N=>N.startsWith("regex parse error")))return new C.SearchError(h(d),C.SearchErrorCode.regexParseError);const R=b.match(/grep config error: unknown encoding: (.*)/);if(R)return new C.SearchError(`Unknown encoding: ${R[1]}`,C.SearchErrorCode.unknownEncoding);if(b.startsWith("error parsing glob"))return new C.SearchError(b.charAt(0).toUpperCase()+b.substr(1),C.SearchErrorCode.globParseError);if(b.startsWith("the literal"))return new C.SearchError(b.charAt(0).toUpperCase()+b.substr(1),C.SearchErrorCode.invalidLiteral);if(b.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(b,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=S;function h(v){const d=["Regex parse error"],b=v.filter(R=>R.startsWith("PCRE2:"));if(b.length>=1){const R=b[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const N=R.split(":")[1];d.push(":"+N)}}return d.join("")}e.buildRegexParseError=h;class c extends I.EventEmitter{constructor(d,b,R){super();this.maxResults=d,this.rootFolder=b,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new A.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(d,b){return super.on(d,b),this}handleData(d){if(!this.isDone){const b=typeof d=="string"?d:this.stringDecoder.write(d);this.handleDecodedData(b)}}handleDecodedData(d){let b=d.indexOf(`
`);const R=this.remainder+d;if(b>=0)b+=this.remainder.length;else{this.remainder=R;return}let N=0;for(;b>=0;)this.handleLine(R.substring(N,b).trim()),N=b+1,b=R.indexOf(`
`,N);this.remainder=R.substring(N)}handleLine(d){if(!(this.isDone||!d)){let b;try{b=JSON.parse(d)}catch(R){throw new Error(`malformed line from rg: ${d}`)}if(b.type==="match"){const R=m(b.data.path),N=r.URI.file(D.join(this.rootFolder,R)),q=this.createTextSearchMatch(b.data,N);this.onResult(q),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(b.type==="context"){const R=m(b.data.path),N=r.URI.file(D.join(this.rootFolder,R));this.createTextSearchContext(b.data,N).forEach(re=>this.onResult(re))}}}createTextSearchMatch(d,b){const R=d.line_number-1;let N=!1,q=m(d.lines);R===0&&(0,k.startsWithUTF8BOM)(q)&&(N=!0,q=(0,k.stripUTF8BOM)(q));const re=Buffer.from(q);let V=0,W=0,$=R;d.submatches.length===0&&d.submatches.push(q.length?{start:0,end:1,match:{text:q[0]}}:{start:0,end:0,match:{text:""}});const U=(0,T.coalesce)(d.submatches.map((F,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let L=m(F.match);R===0&&M===0&&N&&(L=(0,k.stripUTF8BOM)(L),F.start=F.start<=3?0:F.start-3,F.end=F.end<=3?0:F.end-3);const O=re.slice(V,F.start).toString().length,B=W+O,j=t(L),Q=$,de=j.numLines+Q,be=j.numLines>0?j.lastLineLength:j.lastLineLength+B;return V=F.end,W=be,$=de,new f.Range(Q,B,de,be)}));return(0,u.createTextSearchResult)(b,q,U,this.previewOptions)}createTextSearchContext(d,b){const R=m(d.lines),N=d.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((q,re)=>({text:q,uri:b,lineNumber:N+re}))}onResult(d){this.emit("result",d)}}e.RipgrepParser=c;function m(v){return v.bytes?Buffer.from(v.bytes,"base64").toString():v.text}function t(v){const d=/\n/g;let b=0,R=-1,N;for(;N=d.exec(v);)b++,R=N.index;const q=R>=0?v.length-R-1:v.length;return{numLines:b,lastLineLength:q}}function n(v,d){const b=["--hidden"];b.push(v.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:N}=(0,y.groupBy)(d.includes,re=>re.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const re=new Set;N.forEach(V=>{re.add(V)}),b.push("-g","!*"),re.forEach(V=>{o(V).map(u.anchorGlob).forEach(W=>{b.push("-g",W)})})}R&&R.length&&R.forEach(re=>{b.push("-g",re)}),d.excludes.map(u.anchorGlob).forEach(re=>b.push("-g",`!${re}`)),d.maxFileSize&&b.push("--max-filesize",d.maxFileSize+""),d.useIgnoreFiles?b.push("--no-ignore-parent"):b.push("--no-ignore"),d.followSymlinks&&b.push("--follow"),d.encoding&&d.encoding!=="utf8"&&b.push("--encoding",d.encoding),v.pattern==="--"&&(v.isRegExp=!0,v.pattern="\\-\\-"),v.isMultiline&&!v.isRegExp&&(v.pattern=(0,k.escapeRegExpCharacters)(v.pattern),v.isRegExp=!0),d.usePCRE2&&b.push("--pcre2"),b.push("--crlf"),v.isRegExp&&(v.pattern=i(v.pattern),b.push("--auto-hybrid-regex"));let q;if(v.isWordMatch){const V=(0,k.createRegExp)(v.pattern,!!v.isRegExp,{wholeWord:v.isWordMatch}).source.replace(/\\\//g,"/");b.push("--regexp",V)}else if(v.isRegExp){let re=l(v.pattern);re=g(re),b.push("--regexp",re)}else q=v.pattern,b.push("--fixed-strings");return b.push("--no-config"),d.useGlobalIgnoreFiles||b.push("--no-ignore-global"),b.push("--json"),v.isMultiline&&b.push("--multiline"),d.beforeContext&&b.push("--before-context",d.beforeContext+""),d.afterContext&&b.push("--after-context",d.afterContext+""),b.push("--"),q&&b.push(q),b.push("."),b}function o(v){const d=(0,P.splitGlobAware)(v,"/");return d.map((b,R)=>d.slice(0,R+1).join("/"))}e.spreadGlobComponents=o;function i(v){const d=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;v.match(d);)v=v.replace(d,"$1\\x{$2}");const b=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;v.match(b);)v=v.replace(b,"$1\\x{$2}");return v}e.unicodeEscapesToPCRE2=i;const s=v=>v.type==="Assertion"&&v.kind==="lookbehind";function l(v){let d;try{d=new p.RegExpParser().parsePattern(v)}catch(V){return v}let b="",R=0;const N=(V,W,$)=>{b+=v.slice(R,V)+$,R=W},q=[];return new p.RegExpVisitor({onCharacterEnter(V){if(V.raw==="\\n"){const W=q[0];if(!W)N(V.start,V.end,"\\r?\\n");else if(!q.some(s))if(W.type==="CharacterClass"){const $=v.slice(W.start+1,V.start)+v.slice(V.end,W.end-1);N(W.start,W.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else W.type==="Quantifier"&&N(V.start,V.end,"(?:\\r?\\n)")}},onQuantifierEnter(V){q.unshift(V)},onQuantifierLeave(){q.shift()},onCharacterClassRangeEnter(V){q.unshift(V)},onCharacterClassRangeLeave(){q.shift()},onCharacterClassEnter(V){q.unshift(V)},onCharacterClassLeave(){q.shift()},onAssertionEnter(V){s(V)&&q.push(V)},onAssertionLeave(V){q[0]===V&&q.shift()}}).visit(d),b+=v.slice(R),b}e.fixRegexNewline=l;function g(v){return v.replace(/\n/g,"\\r?\\n")}e.fixNewline=g}),define(ge[277],pe([0,1,21,130,115,12]),function(G,e,_,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,r,C,f){const p=new I.RipgrepTextSearchEngine(this.outputChannel);if(r.folder.scheme===T.Schemas.userData){const a=Object.assign(Object.assign({},r),{folder:r.folder.with({scheme:T.Schemas.file})}),u=new A.Progress(E=>C.report(Object.assign(Object.assign({},E),{uri:E.uri.with({scheme:r.folder.scheme})})));return this.withToken(f,E=>p.provideTextSearchResults(k,a,u,E))}else return this.withToken(f,a=>p.provideTextSearchResults(k,r,C,a))}async withToken(k,r){const C=P(k);this.inProgress.add(C);const f=await r(C.token);return this.inProgress.delete(C),f}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=y;function P(D){const k=new _.CancellationTokenSource;return D.onCancellationRequested(()=>k.cancel()),k}}),define(ge[278],pe([0,1,26,130,129]),function(G,e,_,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class T{constructor(D){this.query=D}search(D,k,r){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(p){r({message:p})}},f=new A.NativeTextSearchManager(this.query,new I.RipgrepTextSearchEngine(C),_);return new Promise((p,a)=>f.search(u=>{k(u.map(y))},D).then(u=>p({limitHit:u.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=T;function y(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((D,k)=>{if(k.ranges){const r=k;return D+(Array.isArray(r.ranges)?r.ranges.length:1)}else return D+1},0)}}}),define(ge[279],pe([0,1,37,295,17,13,16,3,100,8,48,2,46,31,276,278]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,I.gracefulify(_);class E{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const o=h(t),i=new P.Emitter({onFirstListenerDidAdd:()=>{n=(0,T.createCancelablePromise)(s=>this.doFileSearchWithEngine(a.Engine,o,l=>i.fire(l),s)),n.then(s=>i.fire(s),s=>i.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return i.event}textSearch(t){let n;const o=h(t),i=new P.Emitter({onFirstListenerDidAdd:()=>{n=(0,T.createCancelablePromise)(s=>this.ripgrepTextSearch(o,l=>i.fire(l),s)),n.then(s=>i.fire(s),s=>i.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return i.event}ripgrepTextSearch(t,n,o){return t.maxFileSize=(0,f.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new u.TextSearchEngineAdapter(t).search(o,n,n)}doFileSearch(t,n,o){return this.doFileSearchWithEngine(a.Engine,t,n,o)}doFileSearchWithEngine(t,n,o,i,s=E.BATCH_SIZE){let l=0;const g=d=>{Array.isArray(d)?(l+=d.length,o(d.map(b=>this.rawMatchToSearchItem(b)))):d.relativePath?(l++,o(this.rawMatchToSearchItem(d))):o(d)};if(n.sortByScore){let d=this.trySortedSearchFromCache(n,g,i);if(!d){const b=n.maxResults?Object.assign({},n,{maxResults:null}):n,R=new t(b);d=this.doSortedSearch(R,n,o,g,i)}return new Promise((b,R)=>{d.then(([N,q])=>{const re=q.map(V=>this.rawMatchToSearchItem(V));this.sendProgress(re,o,s),b(N)},R)})}const v=new t(n);return this.doSearch(v,g,s,i).then(d=>({limitHit:d.limitHit,type:"success",stats:{detailStats:d.stats,type:"searchProcess",fromCache:!1,resultCount:l,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,k.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,o,i,s){const l=new P.Emitter;let g=(0,T.createCancelablePromise)(d=>{let b=[];const R=N=>{Array.isArray(N)?b=N:(i(N),l.fire(N))};return this.doSearch(t,R,-1,d).then(N=>[N,b])}),v;if(n.cacheKey){v=this.getOrCreateCache(n.cacheKey);const d={promise:g,event:l.event,resolved:!1};v.resultsToSearchCache[n.filePattern||""]=d,g.then(()=>{d.resolved=!0},b=>{delete v.resultsToSearchCache[n.filePattern||""]}),g=this.preventCancellation(g)}return g.then(([d,b])=>{const R=v?v.scorerCache:Object.create(null),N=(typeof n.maxResults!="number"||n.maxResults>0)&&r.StopWatch.create(!1);return this.sortResults(n,b,R,s).then(q=>{const re=N?N.elapsed():-1;return[{type:"success",stats:{detailStats:d.stats,sortingTime:re,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:q.length},messages:d.messages,limitHit:d.limitHit||typeof n.maxResults=="number"&&b.length>n.maxResults},q]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new w)}trySortedSearchFromCache(t,n,o){const i=t.cacheKey&&this.caches[t.cacheKey];if(!!i){const s=this.getResultsFromCache(i,t.filePattern||"",n,o);if(s)return s.then(([l,g,v])=>{const d=r.StopWatch.create(!1);return this.sortResults(t,g,i.scorerCache,o).then(b=>{const R=d.elapsed(),N={fromCache:!0,detailStats:v,type:"searchProcess",resultCount:g.length,sortingTime:R};return[{type:"success",limitHit:l.limitHit||typeof t.maxResults=="number"&&g.length>t.maxResults,stats:N},b]})})}}sortResults(t,n,o,i){const s=(0,D.prepareQuery)(t.filePattern||""),l=(v,d)=>(0,D.compareItemsByFuzzyScore)(v,d,s,!0,S,o),g=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return A.topAsync(n,l,g,1e4,i)}sendProgress(t,n,o){if(o&&o>0)for(let i=0;i<t.length;i+=o)n(t.slice(i,i+o));else n(t)}getResultsFromCache(t,n,o,i){const s=r.StopWatch.create(!1),l=n.indexOf(k.sep)>=0;let g;for(const R in t.resultsToSearchCache)if(n.startsWith(R)){if(l&&R.indexOf(k.sep)<0&&R!=="")continue;const N=t.resultsToSearchCache[R];g={promise:this.preventCancellation(N.promise),event:N.event,resolved:N.resolved};break}if(!g)return null;const v=s.elapsed(),d=r.StopWatch.create(!1),b=g.event(o);return i&&i.onCancellationRequested(()=>{b.dispose()}),g.promise.then(([R,N])=>{if(i&&i.isCancellationRequested)throw(0,y.canceled)();const q=[],re=(0,D.prepareQuery)(n).normalizedLowercase;for(const V of N)!(0,p.isFilePatternMatch)(V,re)||q.push(V);return[R,q,{cacheWasResolved:g.resolved,cacheLookupTime:v,cacheFilterTime:d.elapsed(),cacheEntryCount:N.length}]})}doSearch(t,n,o,i){return new Promise((s,l)=>{let g=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(v=>{v&&(o?(g.push(v),o>0&&g.length>=o&&(n(g),g=[])):n(v))},v=>{n(v)},(v,d)=>{g.length&&n(g),v?l(v):s(d)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,o){return t.then(n,o)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=E,E.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const S=new class{getItemLabel(m){return(0,k.basename)(m.relativePath)}getItemDescription(m){return(0,k.dirname)(m.relativePath)}getItemPath(m){return m.relativePath}};function h(m){return Object.assign(Object.assign({},m),{folderQueries:m.folderQueries&&m.folderQueries.map(c),extraFileResources:m.extraFileResources&&m.extraFileResources.map(t=>C.URI.revive(t))})}function c(m){return Object.assign(Object.assign({},m),{folder:C.URI.revive(m.folder)})}}),define(ge[280],pe([0,1,6,2,26,14,31,279,277,94,15,62,28,69,12,129]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends p.ExtHostSearch{constructor(S,h,c,m){super(S,c,m);this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new k.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new D.RipgrepSearchProvider(t)),h.remote.isRemote&&h.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const S=new k.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new D.RipgrepSearchProvider(S)),this.registerInternalFileSearchProvider(a.Schemas.file,new P.SearchService)}registerInternalFileSearchProvider(S,h){const c=this._handlePool++;return this._internalFileSearchProvider=h,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(S)),(0,_.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(S,h,c,m){const t=(0,p.reviveQuery)(c);return S===this._internalFileSearchHandle?this.doInternalFileSearch(S,h,t,m):super.$provideFileSearchResults(S,h,c,m)}doInternalFileSearch(S,h,c,m){const t=n=>{if((0,y.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(S,h,n.map(o=>I.URI.file(o.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,t,m)}$clearCache(S){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(S),super.$clearCache(S)}createTextSearchManager(S,h){return new u.NativeTextSearchManager(S,h)}};E=Ve([xe(0,r.IExtHostRpcService),xe(1,f.IExtHostInitDataService),xe(2,C.IURITransformerService),xe(3,T.ILogService)],E),e.NativeExtHostSearch=E}),define(ge[131],pe([0,1,296,122,297,3,105,8,44,30,6,22,106,16,10]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class u{constructor(g){this.socket=g,this._errorListener=v=>{if(v){if(v.code==="EPIPE")return;(0,p.onUnexpectedError)(v)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(g){const v=d=>g(C.VSBuffer.wrap(d));return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(g){return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(g){return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(g){if(!this.socket.destroyed)try{this.socket.write(g.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,p.onUnexpectedError)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,p.onUnexpectedError)(v)}}end(){this.socket.end()}drain(){return new Promise((g,v)=>{if(this.socket.bufferSize===0){g();return}const d=()=>{this.socket.off("close",d),this.socket.off("end",d),this.socket.off("error",d),this.socket.off("timeout",d),this.socket.off("drain",d),g()};this.socket.on("close",d),this.socket.on("end",d),this.socket.on("error",d),this.socket.on("timeout",d),this.socket.on("drain",d)})}}e.NodeSocket=u;var E;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var w;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(w||(w={}));class S extends r.Disposable{constructor(g,v,d,b){super();this._onDidZlibFlush=this._register(new T.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new T.Emitter),this._onClose=this._register(new T.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=g,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=v,this._recordInflateBytes=b,v?(this._zlibInflate=A.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",R=>{console.error(R),(0,p.onUnexpectedError)(R),this._onClose.fire()}),this._zlibInflate.on("data",R=>{this._pendingInflateData.push(R)}),d&&(this._zlibInflate.write(d.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=A.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{console.error(R),(0,p.onUnexpectedError)(R),this._onClose.fire()}),this._zlibDeflate.on("data",R=>{this._pendingDeflateData.push(R)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new f.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this._onData.event(g)}onClose(g){return this._onClose.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){this._totalOutgoingDataBytes+=g.byteLength,this._zlibDeflate?(this._zlibDeflate.write(g.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let v=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,v=v.slice(0,v.length-4),this._isEnded||this._write(C.VSBuffer.wrap(v),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(g,!1)}_write(g,v){let d=2;g.byteLength<126?d+=0:g.byteLength<2**16?d+=2:d+=8;const b=C.VSBuffer.alloc(d);if(v?b.writeUInt8(194,0):b.writeUInt8(130,0),g.byteLength<126)b.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){b.writeUInt8(126,1);let R=1;b.writeUInt8(g.byteLength>>>8&255,++R),b.writeUInt8(g.byteLength>>>0&255,++R)}else{b.writeUInt8(127,1);let R=1;b.writeUInt8(0,++R),b.writeUInt8(0,++R),b.writeUInt8(0,++R),b.writeUInt8(0,++R),b.writeUInt8(g.byteLength>>>24&255,++R),b.writeUInt8(g.byteLength>>>16&255,++R),b.writeUInt8(g.byteLength>>>8&255,++R),b.writeUInt8(g.byteLength>>>0&255,++R)}this._totalOutgoingWireBytes+=b.byteLength+g.byteLength,this.socket.write(C.VSBuffer.concat([b,g]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(g){if(g.byteLength!==0){for(this._totalIncomingWireBytes+=g.byteLength,this._incomingData.acceptChunk(g);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const v=this._incomingData.peek(this._state.readLen),b=(v.readUInt8(0)&128)>>>7,R=v.readUInt8(1),N=(R&128)>>>7,q=R&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(q===126?2:0)+(q===127?8:0),this._state.fin=b,this._state.mask=0}else if(this._state.state===2){const v=this._incomingData.read(this._state.readLen),d=v.readUInt8(1),b=(d&128)>>>7;let R=d&127,N=1;R===126?R=v.readUInt8(++N)*2**8+v.readUInt8(++N):R===127&&(R=v.readUInt8(++N)*0+v.readUInt8(++N)*0+v.readUInt8(++N)*0+v.readUInt8(++N)*0+v.readUInt8(++N)*2**24+v.readUInt8(++N)*2**16+v.readUInt8(++N)*2**8+v.readUInt8(++N));let q=0;b&&(q=v.readUInt8(++N)*2**24+v.readUInt8(++N)*2**16+v.readUInt8(++N)*2**8+v.readUInt8(++N)),this._state.state=3,this._state.readLen=R,this._state.mask=q}else if(this._state.state===3){const v=this._incomingData.read(this._state.readLen);h(v,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(v.buffer)),this._zlibInflate.write(v.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const d=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=d.length,this._onData.fire(C.VSBuffer.wrap(d))})):(this._totalIncomingDataBytes+=v.byteLength,this._onData.fire(v))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await T.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=S;function h(l,g){if(g!==0){let v=l.byteLength>>>2;for(let re=0;re<v;re++){const V=l.readUInt32BE(re*4);l.writeUInt32BE(V^g,re*4)}let d=v*4,b=l.byteLength-d;const R=g>>>24&255,N=g>>>16&255,q=g>>>8&255;b>=1&&l.writeUInt8(l.readUInt8(d)^R,d),b>=2&&l.writeUInt8(l.readUInt8(d+1)^N,d+1),b>=3&&l.writeUInt8(l.readUInt8(d+2)^q,d+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function m(){const l=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let g;return e.XDG_RUNTIME_DIR?g=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):g=(0,P.join)((0,D.tmpdir)(),`vscode-ipc-${l}.sock`),n(g),g}e.createRandomIPCHandle=m;function t(l,g,v){const d=(0,_.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${d}-${v}-${g}-sock`;let b;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?b=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${d.substr(0,8)}-${v}-${g}.sock`):b=(0,P.join)(l,`${v}-${g}.sock`),n(b),b}e.createStaticIPCHandle=t;function n(l){const g=c[a.platform];typeof g=="number"&&l.length>=g&&console.warn(`WARNING: IPC handle "${l}" is longer than ${g} chars, try a shorter --user-data-dir`)}class o extends y.IPCServer{constructor(g){super(o.toClientConnectionEvent(g));this.server=g}static toClientConnectionEvent(g){const v=T.Event.fromNodeEventEmitter(g,"connection");return T.Event.map(v,d=>({protocol:new f.Protocol(new u(d)),onDidClientDisconnect:T.Event.once(T.Event.fromNodeEventEmitter(d,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function i(l){return new Promise((g,v)=>{const d=(0,I.createServer)();d.on("error",v),d.listen(l,()=>{d.removeListener("error",v),g(new o(d))})})}e.serve=i;function s(l,g){return new Promise((v,d)=>{const b=(0,I.createConnection)(l,()=>{b.removeListener("error",d),v(f.Client.fromSocket(new u(b),g))});b.once("error",d)})}e.connect=s}),define(ge[281],pe([0,1,131,273,37,51,2,118,14,8,44]),function(G,e,_,I,A,T,y,P,D,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(a,u,E){this._commands=a,this.logService=u,this._ipcHandlePath=E,this._server=I.createServer((w,S)=>this.onRequest(w,S)),this.setup().catch(w=>(u.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){A.promises.writeFile((0,k.join)((0,r.tmpdir)(),"vscode-ipc"),this._ipcHandlePath).catch(a=>{this.logService.error(a)});try{this._server.listen(this.ipcHandlePath),this._server.on("error",a=>this.logService.error(a))}catch(a){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(a,u){const E=[];a.setEncoding("utf8"),a.on("data",w=>E.push(w)),a.on("end",()=>{const w=JSON.parse(E.join(""));switch(w.type){case"open":this.open(w,u);break;case"openExternal":this.openExternal(w,u);break;case"status":this.getStatus(w,u);break;case"extensionManagement":this.manageExtensions(w,u).catch(this.logService.error);break;default:u.writeHead(404),u.write(`Unknown message type: ${w.type}`,S=>{S&&this.logService.error(S)}),u.end();break}})}open(a,u){let{fileURIs:E,folderURIs:w,forceNewWindow:S,diffMode:h,addMode:c,forceReuseWindow:m,gotoLineMode:t,waitMarkerFilePath:n}=a;const o=[];if(Array.isArray(w))for(const i of w)try{o.push({folderUri:y.URI.parse(i)})}catch(s){}if(Array.isArray(E))for(const i of E)try{(0,P.hasWorkspaceFileExtension)(i)?o.push({workspaceUri:y.URI.parse(i)}):o.push({fileUri:y.URI.parse(i)})}catch(s){}if(o.length){const i=n?y.URI.file(n):void 0,l={forceNewWindow:S,diffMode:h,addMode:c,gotoLineMode:t,forceReuseWindow:m,preferNewWindow:!m&&!i&&!c,waitMarkerFileURI:i};this._commands.executeCommand("_remoteCLI.windowOpen",o,l)}u.writeHead(200),u.end()}async openExternal(a,u){for(const E of a.uris){const w=y.URI.parse(E),S=w.scheme==="file"?w:E;await this._commands.executeCommand("_remoteCLI.openExternal",S)}u.writeHead(200),u.end()}async manageExtensions(a,u){try{const E=h=>h==null?void 0:h.map(c=>/\.vsix$/i.test(c)?y.URI.parse(c):c),w={list:a.list,install:E(a.install),uninstall:E(a.uninstall),force:a.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",w);u.writeHead(200),u.write(S)}catch(E){u.writeHead(500),u.write(String(E),w=>{w&&this.logService.error(w)})}u.end()}async getStatus(a,u){try{const E=await this._commands.executeCommand("_remoteCLI.getSystemStatus");u.writeHead(200),u.write(E),u.end()}catch(E){u.writeHead(500),u.write(String(E),w=>{w&&this.logService.error(w)}),u.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&A.existsSync(this._ipcHandlePath)&&A.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=C;let f=class extends C{constructor(a,u){super(a,u,(0,_.createRandomIPCHandle)())}};f=Ve([xe(0,T.IExtHostCommands),xe(1,D.ILogService)],f),e.CLIServer=f}),define(ge[282],pe([0,1,68,269,263,5,272,42,254,2,12,7,281,103]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends A.RequireInterceptor{_installInterceptor(){const w=this,S=G.__$__nodeRequire("module"),h=S._load;S._load=function(m,t,n){for(let o of w._alternatives){let i=o(m);if(i){m=i;break}}return w._factories.has(m)?w._factories.get(m).load(m,k.URI.file((0,p.realpathSync)(t.filename)),o=>h.apply(this,[o,t,n])):h.apply(this,arguments)}}}class u extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(I.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(f.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(a,w,this._registry).install(),_.mark("code/extHost/didInitAPI");const h=await this._extHostConfiguration.getConfigProvider();await(0,y.connectProxyResolver)(this._extHostWorkspace,h,this,this._logService,this._mainThreadTelemetryProxy,this._initData),_.mark("code/extHost/didInitProxyResolver");const c=process.send,m=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?c.apply(process,t):(m.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,S,h){if(S.scheme!==r.Schemas.file)throw new Error(`Cannot load URI: '${S}', must be of file-scheme`);let c=null;h.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${S.toString(!0)}`),this._logService.flush();try{w&&_.mark(`code/extHost/willLoadExtensionCode/${w.value}`),c=G.__$__nodeRequire(S.fsPath)}catch(m){return Promise.reject(m)}finally{w&&_.mark(`code/extHost/didLoadExtensionCode/${w.value}`),h.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const S in w){const h=w[S];h===null?delete process.env[S]:process.env[S]=h}}}e.ExtHostExtensionService=u}),define(ge[283],pe([0,1,79,255,266,265,264,280,282,226,256,47,42,64,69,67,34,50,14]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(f.IExtHostExtensionService,D.ExtHostExtensionService),(0,_.registerSingleton)(S.ILogService,k.ExtHostLogService),(0,_.registerSingleton)(C.IExtHostDebugService,y.ExtHostDebugService),(0,_.registerSingleton)(p.IExtHostOutputService,I.ExtHostOutputService2),(0,_.registerSingleton)(a.IExtHostSearch,P.NativeExtHostSearch),(0,_.registerSingleton)(u.IExtHostTask,T.ExtHostTask),(0,_.registerSingleton)(E.IExtHostTerminalService,A.ExtHostTerminalService),(0,_.registerSingleton)(w.IExtHostTunnelService,r.ExtHostTunnelService)}),define(ge[284],pe([0,1,122,298,68,16,106,131,187,224,267,22,101,26,103,13,138,270,283]),function(G,e,_,I,A,T,y,P,D,k,r,C,f,p,a,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let s=0;s<process.execArgv.length;s++)process.execArgv[s]==="--inspect-port=0"&&(process.execArgv.splice(s,1),s--)}();const w=I(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const i=G.__$__nodeRequire("module"),s=i._load;i._load=function(l){if(l==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return s.apply(this,arguments)}})();const S=process.exit.bind(process);function h(i){process.exit=function(s){if(i)S(s);else{const l=new Error("An extension called process.exit() and this was prevented.");console.warn(l.stack)}},process.crash=function(){const s=new Error("An extension called process.crash() and this was prevented.");console.warn(s.stack)}}let c=function(i){S()};function m(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,s)=>{let l=null,g=setTimeout(()=>{c("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const v=108e5,d=3e5,b=new u.RunOnceScheduler(()=>c("renderer disconnected for too long (1)"),v),R=new u.RunOnceScheduler(()=>c("renderer disconnected for too long (2)"),d);process.on("message",(q,re)=>{if(q&&q.type==="VSCODE_EXTHOST_IPC_SOCKET"){const V=C.VSBuffer.wrap(Buffer.from(q.initialDataChunk,"base64"));let W;if(q.skipWebSocketFrames)W=new P.NodeSocket(re);else{const $=C.VSBuffer.wrap(Buffer.from(q.inflateBytes,"base64"));W=new P.WebSocketNodeSocket(new P.NodeSocket(re),q.permessageDeflate,$,!1)}l?(b.cancel(),R.cancel(),l.beginAcceptReconnection(W,V),l.endAcceptReconnection()):(clearTimeout(g),l=new y.PersistentProtocol(W,V),l.onDidDispose(()=>c("renderer disconnected")),i(l),l.onSocketClose(()=>{process.send({type:"VSCODE_EXTHOST_DISCONNECTED"})}))}if(q&&q.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(R.isScheduled())return;b.isScheduled()&&R.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(N)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((s,l)=>{const g=_.createConnection(i,()=>{g.removeListener("error",l),s(new y.PersistentProtocol(new P.NodeSocket(g)))});g.once("error",l)})}}async function t(){const i=await m();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(s=>{(0,k.isMessageOfType)(s,2)?(this._terminating=!0,c("received terminate message from renderer")):this._onMessage.fire(s)})}send(s){this._terminating||i.send(s)}drain(){return i.drain()}}}function n(i){return new Promise(s=>{const l=i.onMessage(g=>{l.dispose();const v=JSON.parse(g.toString()),d=v.commit,b=D.default.commit;d&&b&&d!==b&&S(55);const R=[];process.on("unhandledRejection",(re,V)=>{R.push(V),setTimeout(()=>{const W=R.indexOf(V);W>=0&&V.catch($=>{R.splice(W,1),console.warn(`rejected promise not handled within 1 second: ${$}`),$&&$.stack&&console.warn(`stack trace: ${$.stack}`),(0,T.onUnexpectedError)(re)})},1e3)}),process.on("rejectionHandled",re=>{const V=R.indexOf(re);V>=0&&R.splice(V,1)}),process.on("uncaughtException",function(re){(0,T.onUnexpectedError)(re)});let N=0;setInterval(function(){try{process.kill(v.parentPid,0),N=0}catch(re){re&&re.code==="EPERM"?(N++,N>=3&&c(`parent process ${v.parentPid} does not exist anymore (3 x EPERM): ${re.message} (code: ${re.code}) (errno: ${re.errno})`)):c(`parent process ${v.parentPid} does not exist anymore: ${re.message} (code: ${re.code}) (errno: ${re.errno})`)}},1e3);let q;try{q=G.__$__nodeRequire("native-watchdog"),q.start(v.parentPid)}catch(re){(0,T.onUnexpectedError)(re)}i.send((0,k.createMessageOfType)(0)),s({protocol:i,initData:v})});i.send((0,k.createMessageOfType)(1))})}async function o(){E.monkeyPatch(!0),A.mark("code/extHost/willConnectToRenderer");const i=await t();A.mark("code/extHost/didConnectToRenderer");const s=await n(i);A.mark("code/extHost/didWaitForInitData");const{initData:l}=s;h(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=w.useHostProxy!==void 0?w.useHostProxy!=="false":void 0;const g=new class{exit(R){S(R)}exists(R){return(0,p.exists)(R)}realpath(R){return(0,a.realpath)(R)}};let v=null;if(l.remote.authority)try{v=new f.URITransformer(l.remote.authority)}catch(b){console.error(b)}const d=new r.ExtensionHostMain(s.protocol,l,g,v);c=b=>d.terminate(b)}e.startExtensionHostProcess=o}),define(ge[299],pe([0,1,284]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.startExtensionHostProcess)().catch(I=>console.log(I))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
